# This file is part of PyFd, a Python interface to the Fd library
#
# Copyright (C) 2020-2021  European Gravitational Observatory
#
# Author list: Franco Carbognani: franco.carbognani@ego-gw.it
#                   Rhys Poulton: poulton@ego-gw.it
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

r"""Wrapper for CfgCommon.h

Generated with:
/users/poulton/.local/bin/ctypesgen -a -l libPyFd.so --compile-libdir /users/poulton/packages/PyFd/v4r2/Linux-x86_64-CL7/ -I /virgoApp/Cm/v9r0/src/ -I /virgoApp/Cfg/v9r0/src/ -I /virgoApp/Fr/v8r40p5/src/ -I /virgoApp/Frv/v4r35p2/src/ -I /users/poulton/packages/Fd/v9r0/src/ /virgoApp/Cfg/v9r0/src/CfgCommon.h /virgoApp/Cfg/v9r0/src/CfgFnmatch.h /virgoApp/Cfg/v9r0/src/CfgGlob.h /virgoApp/Cfg/v9r0/src/CfgHeader.h /virgoApp/Cfg/v9r0/src/CfgLib.h /virgoApp/Cfg/v9r0/src/CfgList.h /virgoApp/Cfg/v9r0/src/CfgMsg.h /virgoApp/Cfg/v9r0/src/CfgOut.h /virgoApp/Cfg/v9r0/src/CfgParse.h /virgoApp/Cfg/v9r0/src/CfgQueue.h /virgoApp/Cfg/v9r0/src/CfgSnprintf.h /virgoApp/Cfg/v9r0/src/CfgVirgo.h /virgoApp/Fr/v8r40p5/src/FrameL.h /virgoApp/Fr/v8r40p5/src/FrFilter.h /virgoApp/Fr/v8r40p5/src/FrIO.h /virgoApp/Fr/v8r40p5/src/FrVect.h /virgoApp/Frv/v4r35p2/src/FrvBuf.h /virgoApp/Frv/v4r35p2/src/FrvCh.h /virgoApp/Frv/v4r35p2/src/FrvCopy.h /virgoApp/Frv/v4r35p2/src/FrvCorr.h /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h /virgoApp/Frv/v4r35p2/src/FrvFFT.h /virgoApp/Frv/v4r35p2/src/FrvFilter.h /virgoApp/Frv/v4r35p2/src/Frv.h /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h /virgoApp/Frv/v4r35p2/src/FrvLinkDef.h /virgoApp/Frv/v4r35p2/src/FrvMath.h /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h /virgoApp/Frv/v4r35p2/src/FrvTF.h /users/poulton/packages/Fd/v9r0/src/FdChList.h /users/poulton/packages/Fd/v9r0/src/FdCm.h /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h /users/poulton/packages/Fd/v9r0/src/Fd.h /users/poulton/packages/Fd/v9r0/src/FdIDir.h /users/poulton/packages/Fd/v9r0/src/FdIO.h /users/poulton/packages/Fd/v9r0/src/FdTools.h /users/poulton/packages/Fd/v9r0/src/FdUtil.h -R ../../.. -R ../Linux-x86_64-CL7/lib/ -R ../Linux-x86_64-CL7-cmake/lib -o PyFd.py

Do not modify this file.
"""

__docformat__ = "restructuredtext"

# Begin preamble for Python v(3, 6)

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, "c_int64"):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types

class c_void(Structure):
    # c_void_p is a buggy return type, converting to int, so
    # POINTER(None) == c_void_p is actually written as
    # POINTER(c_void), so it can be treated as a real pointer.
    _fields_ = [("dummy", c_int)]


def POINTER(obj):
    p = ctypes.POINTER(obj)

    # Convert None to a real NULL pointer to work around bugs
    # in how ctypes handles None on 64-bit platforms
    if not isinstance(p.from_param, classmethod):

        def from_param(cls, x):
            if x is None:
                return cls()
            else:
                return x

        p.from_param = classmethod(from_param)

    return p

class UserString:
    def __init__(self, seq):
        if isinstance(seq, bytes):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq).encode()

    def __bytes__(self):
        return self.data

    def __str__(self):
        return self.data.decode()

    def __repr__(self):
        return repr(self.data)

    def __int__(self):
        return int(self.data.decode())

    def __long__(self):
        return int(self.data.decode())

    def __float__(self):
        return float(self.data.decode())

    def __complex__(self):
        return complex(self.data.decode())

    def __hash__(self):
        return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)

    def __le__(self, string):
        if isinstance(string, UserString):
            return self.data <= string.data
        else:
            return self.data <= string

    def __lt__(self, string):
        if isinstance(string, UserString):
            return self.data < string.data
        else:
            return self.data < string

    def __ge__(self, string):
        if isinstance(string, UserString):
            return self.data >= string.data
        else:
            return self.data >= string

    def __gt__(self, string):
        if isinstance(string, UserString):
            return self.data > string.data
        else:
            return self.data > string

    def __eq__(self, string):
        if isinstance(string, UserString):
            return self.data == string.data
        else:
            return self.data == string

    def __ne__(self, string):
        if isinstance(string, UserString):
            return self.data != string.data
        else:
            return self.data != string

    def __contains__(self, char):
        return char in self.data

    def __len__(self):
        return len(self.data)

    def __getitem__(self, index):
        return self.__class__(self.data[index])

    def __getslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, bytes):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other).encode())

    def __radd__(self, other):
        if isinstance(other, bytes):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other).encode() + self.data)

    def __mul__(self, n):
        return self.__class__(self.data * n)

    __rmul__ = __mul__

    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self):
        return self.__class__(self.data.capitalize())

    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))

    def count(self, sub, start=0, end=sys.maxsize):
        return self.data.count(sub, start, end)

    def decode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())

    def encode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())

    def endswith(self, suffix, start=0, end=sys.maxsize):
        return self.data.endswith(suffix, start, end)

    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))

    def find(self, sub, start=0, end=sys.maxsize):
        return self.data.find(sub, start, end)

    def index(self, sub, start=0, end=sys.maxsize):
        return self.data.index(sub, start, end)

    def isalpha(self):
        return self.data.isalpha()

    def isalnum(self):
        return self.data.isalnum()

    def isdecimal(self):
        return self.data.isdecimal()

    def isdigit(self):
        return self.data.isdigit()

    def islower(self):
        return self.data.islower()

    def isnumeric(self):
        return self.data.isnumeric()

    def isspace(self):
        return self.data.isspace()

    def istitle(self):
        return self.data.istitle()

    def isupper(self):
        return self.data.isupper()

    def join(self, seq):
        return self.data.join(seq)

    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))

    def lower(self):
        return self.__class__(self.data.lower())

    def lstrip(self, chars=None):
        return self.__class__(self.data.lstrip(chars))

    def partition(self, sep):
        return self.data.partition(sep)

    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))

    def rfind(self, sub, start=0, end=sys.maxsize):
        return self.data.rfind(sub, start, end)

    def rindex(self, sub, start=0, end=sys.maxsize):
        return self.data.rindex(sub, start, end)

    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))

    def rpartition(self, sep):
        return self.data.rpartition(sep)

    def rstrip(self, chars=None):
        return self.__class__(self.data.rstrip(chars))

    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)

    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)

    def splitlines(self, keepends=0):
        return self.data.splitlines(keepends)

    def startswith(self, prefix, start=0, end=sys.maxsize):
        return self.data.startswith(prefix, start, end)

    def strip(self, chars=None):
        return self.__class__(self.data.strip(chars))

    def swapcase(self):
        return self.__class__(self.data.swapcase())

    def title(self):
        return self.__class__(self.data.title())

    def translate(self, *args):
        return self.__class__(self.data.translate(*args))

    def upper(self):
        return self.__class__(self.data.upper())

    def zfill(self, width):
        return self.__class__(self.data.zfill(width))


class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""

    def __init__(self, string=""):
        self.data = string

    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")

    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + sub + self.data[index + 1 :]

    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + self.data[index + 1 :]

    def __setslice__(self, start, end, sub):
        start = max(start, 0)
        end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start] + sub.data + self.data[end:]
        elif isinstance(sub, bytes):
            self.data = self.data[:start] + sub + self.data[end:]
        else:
            self.data = self.data[:start] + str(sub).encode() + self.data[end:]

    def __delslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]

    def immutable(self):
        return UserString(self.data)

    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, bytes):
            self.data += other
        else:
            self.data += str(other).encode()
        return self

    def __imul__(self, n):
        self.data *= n
        return self


class String(MutableString, Union):

    _fields_ = [("raw", POINTER(c_char)), ("data", c_char_p)]

    def __init__(self, obj=b""):
        if isinstance(obj, (bytes, UserString)):
            self.data = bytes(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from bytes
        elif isinstance(obj, bytes):
            return cls(obj)

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj.encode())

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from c_char array
        elif isinstance(obj, c_char * len(obj)):
            return obj

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)

    from_param = classmethod(from_param)


def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)


# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if hasattr(type, "_type_") and isinstance(type._type_, str) and type._type_ != "P":
        return type
    else:
        return c_void_p


# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self, func, restype, argtypes, errcheck):
        self.func = func
        self.func.restype = restype
        self.argtypes = argtypes
        if errcheck:
            self.func.errcheck = errcheck

    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func

    def __call__(self, *args):
        fixed_args = []
        i = 0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i += 1
        return self.func(*fixed_args + list(args[i:]))


def ord_if_char(value):
    """
    Simple helper used for casts to simple builtin types:  if the argument is a
    string type, it will be converted to it's ordinal value.

    This function will raise an exception if the argument is string with more
    than one characters.
    """
    return ord(value) if (isinstance(value, bytes) or isinstance(value, str)) else value

# End preamble

_libs = {}
_libdirs = ['/users/poulton/packages/PyFd/v4r2/Linux-x86_64-CL7/', '../../..', '../Linux-x86_64-CL7/lib/', '../Linux-x86_64-CL7-cmake/lib']

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util


def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []


class LibraryLoader(object):
    # library names formatted specifically for platforms
    name_formats = ["%s"]

    class Lookup(object):
        mode = ctypes.DEFAULT_MODE

        def __init__(self, path):
            super(LibraryLoader.Lookup, self).__init__()
            self.access = dict(cdecl=ctypes.CDLL(path, self.mode))

        def get(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                raise LookupError(
                    "Unknown calling convention '{}' for function '{}'".format(
                        calling_convention, name
                    )
                )
            return getattr(self.access[calling_convention], name)

        def has(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                return False
            return hasattr(self.access[calling_convention], name)

        def __getattr__(self, name):
            return getattr(self.access["cdecl"], name)

    def __init__(self):
        self.other_dirs = []

    def __call__(self, libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            try:
                return self.Lookup(path)
            except:
                pass

        raise ImportError("Could not load %s." % libname)

    def getpaths(self, libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # search through a prioritized series of locations for the library

            # we first search any specific directories identified by user
            for dir_i in self.other_dirs:
                for fmt in self.name_formats:
                    # dir_i should be absolute already
                    yield os.path.join(dir_i, fmt % libname)

            # then we search the directory where the generated python interface is stored
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.dirname(__file__), fmt % libname))

            # now, use the ctypes tools to try to find the library
            for fmt in self.name_formats:
                path = ctypes.util.find_library(fmt % libname)
                if path:
                    yield path

            # then we search all paths identified as platform-specific lib paths
            for path in self.getplatformpaths(libname):
                yield path

            # Finally, we'll try the users current working directory
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.curdir, fmt % libname))

    def getplatformpaths(self, libname):
        return []


# Darwin (Mac OS X)


class DarwinLibraryLoader(LibraryLoader):
    name_formats = [
        "lib%s.dylib",
        "lib%s.so",
        "lib%s.bundle",
        "%s.dylib",
        "%s.so",
        "%s.bundle",
        "%s",
    ]

    class Lookup(LibraryLoader.Lookup):
        # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
        # of the default RTLD_LOCAL.  Without this, you end up with
        # libraries not being loadable, resulting in "Symbol not found"
        # errors
        mode = ctypes.RTLD_GLOBAL

    def getplatformpaths(self, libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir, name)

    def getdirs(self, libname):
        """Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        """

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser("~/lib"), "/usr/local/lib", "/usr/lib"]

        dirs = []

        if "/" in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        if hasattr(sys, "frozen") and sys.frozen == "macosx_app":
            dirs.append(os.path.join(os.environ["RESOURCEPATH"], "..", "Frameworks"))

        dirs.extend(dyld_fallback_library_path)

        return dirs


# Posix


class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    _include = re.compile(r"^\s*include\s+(?P<pattern>.*)")

    class _Directories(dict):
        def __init__(self):
            self.order = 0

        def add(self, directory):
            if len(directory) > 1:
                directory = directory.rstrip(os.path.sep)
            # only adds and updates order if exists and not already in set
            if not os.path.exists(directory):
                return
            o = self.setdefault(directory, self.order)
            if o == self.order:
                self.order += 1

        def extend(self, directories):
            for d in directories:
                self.add(d)

        def ordered(self):
            return (i[0] for i in sorted(self.items(), key=lambda D: D[1]))

    def _get_ld_so_conf_dirs(self, conf, dirs):
        """
        Recursive funtion to help parse all ld.so.conf files, including proper
        handling of the `include` directive.
        """

        try:
            with open(conf) as f:
                for D in f:
                    D = D.strip()
                    if not D:
                        continue

                    m = self._include.match(D)
                    if not m:
                        dirs.add(D)
                    else:
                        for D2 in glob.glob(m.group("pattern")):
                            self._get_ld_so_conf_dirs(D2, dirs)
        except IOError:
            pass

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = self._Directories()
        for name in (
            "LD_LIBRARY_PATH",
            "SHLIB_PATH",  # HPUX
            "LIBPATH",  # OS/2, AIX
            "LIBRARY_PATH",  # BE/OS
        ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))

        self._get_ld_so_conf_dirs("/etc/ld.so.conf", directories)

        bitage = platform.architecture()[0]

        unix_lib_dirs_list = []
        if bitage.startswith("64"):
            # prefer 64 bit if that is our arch
            unix_lib_dirs_list += ["/lib64", "/usr/lib64"]

        # must include standard libs, since those paths are also used by 64 bit
        # installs
        unix_lib_dirs_list += ["/lib", "/usr/lib"]
        if sys.platform.startswith("linux"):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            if bitage.startswith("32"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/i386-linux-gnu", "/usr/lib/i386-linux-gnu"]
            elif bitage.startswith("64"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/x86_64-linux-gnu", "/usr/lib/x86_64-linux-gnu"]
            else:
                # guess...
                unix_lib_dirs_list += glob.glob("/lib/*linux-gnu")
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r"lib(.*)\.s[ol]")
        ext_re = re.compile(r"\.s[ol]$")
        for dir in directories.ordered():
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    cache_i = cache.setdefault(file, set())
                    cache_i.add(path)

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        cache_i = cache.setdefault(library, set())
                        cache_i.add(path)
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname, set())
        for i in result:
            # we iterate through all found paths for library, since we may have
            # actually found multiple architectures or other library types that
            # may not load
            yield i


# Windows


class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll", "%s"]

    class Lookup(LibraryLoader.Lookup):
        def __init__(self, path):
            super(WindowsLibraryLoader.Lookup, self).__init__(path)
            self.access["stdcall"] = ctypes.windll.LoadLibrary(path)


# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin": DarwinLibraryLoader,
    "cygwin": WindowsLibraryLoader,
    "win32": WindowsLibraryLoader,
    "msys": WindowsLibraryLoader,
}

load_library = loaderclass.get(sys.platform, PosixLibraryLoader)()


def add_library_search_dirs(other_dirs):
    """
    Add libraries to search paths.
    If library paths are relative, convert them to absolute with respect to this
    file's directory
    """
    for F in other_dirs:
        if not os.path.isabs(F):
            F = os.path.abspath(F)
        load_library.other_dirs.append(F)


del loaderclass

# End loader
filedir = os.path.dirname(os.path.abspath(__file__))
add_library_search_dirs([filedir + '/../../..', filedir + '/../Linux-x86_64-CL7/lib/', filedir + '../Linux-x86_64-CL7-cmake/lib'])
# Begin libraries
_libs["libPyFd.so"] = load_library("libPyFd.so")

# 1 libraries
# End libraries

# No modules

__u_char = c_ubyte# /usr/include/bits/types.h: 30

__u_short = c_uint# /usr/include/bits/types.h: 31

__u_int = c_uint# /usr/include/bits/types.h: 32

__u_long = c_ulong# /usr/include/bits/types.h: 33

__int8_t = c_char# /usr/include/bits/types.h: 36

__uint8_t = c_ubyte# /usr/include/bits/types.h: 37

__int16_t = c_int# /usr/include/bits/types.h: 38

__uint16_t = c_uint# /usr/include/bits/types.h: 39

__int32_t = c_int# /usr/include/bits/types.h: 40

__uint32_t = c_uint# /usr/include/bits/types.h: 41

__int64_t = c_long# /usr/include/bits/types.h: 43

__uint64_t = c_ulong# /usr/include/bits/types.h: 44

__quad_t = c_long# /usr/include/bits/types.h: 52

__u_quad_t = c_ulong# /usr/include/bits/types.h: 53

__dev_t = c_ulong# /usr/include/bits/types.h: 133

__uid_t = c_uint# /usr/include/bits/types.h: 134

__gid_t = c_uint# /usr/include/bits/types.h: 135

__ino_t = c_ulong# /usr/include/bits/types.h: 136

__ino64_t = c_ulong# /usr/include/bits/types.h: 137

__mode_t = c_uint# /usr/include/bits/types.h: 138

__nlink_t = c_ulong# /usr/include/bits/types.h: 139

__off_t = c_long# /usr/include/bits/types.h: 140

__off64_t = c_long# /usr/include/bits/types.h: 141

__pid_t = c_int# /usr/include/bits/types.h: 142

# /usr/include/bits/types.h: 143
class struct_anon_1(Structure):
    pass

struct_anon_1.__slots__ = [
    '__val',
]
struct_anon_1._fields_ = [
    ('__val', c_int * int(2)),
]

__fsid_t = struct_anon_1# /usr/include/bits/types.h: 143

__clock_t = c_long# /usr/include/bits/types.h: 144

__rlim_t = c_ulong# /usr/include/bits/types.h: 145

__rlim64_t = c_ulong# /usr/include/bits/types.h: 146

__id_t = c_uint# /usr/include/bits/types.h: 147

__time_t = c_long# /usr/include/bits/types.h: 148

__useconds_t = c_uint# /usr/include/bits/types.h: 149

__suseconds_t = c_long# /usr/include/bits/types.h: 150

__daddr_t = c_int# /usr/include/bits/types.h: 152

__key_t = c_int# /usr/include/bits/types.h: 153

__clockid_t = c_int# /usr/include/bits/types.h: 156

__timer_t = POINTER(None)# /usr/include/bits/types.h: 159

__blksize_t = c_long# /usr/include/bits/types.h: 162

__blkcnt_t = c_long# /usr/include/bits/types.h: 167

__blkcnt64_t = c_long# /usr/include/bits/types.h: 168

__fsblkcnt_t = c_ulong# /usr/include/bits/types.h: 171

__fsblkcnt64_t = c_ulong# /usr/include/bits/types.h: 172

__fsfilcnt_t = c_ulong# /usr/include/bits/types.h: 175

__fsfilcnt64_t = c_ulong# /usr/include/bits/types.h: 176

__fsword_t = c_long# /usr/include/bits/types.h: 179

__ssize_t = c_long# /usr/include/bits/types.h: 181

__syscall_slong_t = c_long# /usr/include/bits/types.h: 184

__syscall_ulong_t = c_ulong# /usr/include/bits/types.h: 186

__loff_t = __off64_t# /usr/include/bits/types.h: 190

__qaddr_t = POINTER(__quad_t)# /usr/include/bits/types.h: 191

__caddr_t = String# /usr/include/bits/types.h: 192

__intptr_t = c_long# /usr/include/bits/types.h: 195

__socklen_t = c_uint# /usr/include/bits/types.h: 198

u_char = __u_char# /usr/include/sys/types.h: 33

u_short = __u_short# /usr/include/sys/types.h: 34

u_int = __u_int# /usr/include/sys/types.h: 35

u_long = __u_long# /usr/include/sys/types.h: 36

quad_t = __quad_t# /usr/include/sys/types.h: 37

u_quad_t = __u_quad_t# /usr/include/sys/types.h: 38

fsid_t = __fsid_t# /usr/include/sys/types.h: 39

loff_t = __loff_t# /usr/include/sys/types.h: 44

ino_t = __ino_t# /usr/include/sys/types.h: 48

dev_t = __dev_t# /usr/include/sys/types.h: 60

gid_t = __gid_t# /usr/include/sys/types.h: 65

mode_t = __mode_t# /usr/include/sys/types.h: 70

nlink_t = __nlink_t# /usr/include/sys/types.h: 75

uid_t = __uid_t# /usr/include/sys/types.h: 80

off_t = __off_t# /usr/include/sys/types.h: 86

pid_t = __pid_t# /usr/include/sys/types.h: 98

id_t = __id_t# /usr/include/sys/types.h: 104

ssize_t = __ssize_t# /usr/include/sys/types.h: 109

daddr_t = __daddr_t# /usr/include/sys/types.h: 115

caddr_t = __caddr_t# /usr/include/sys/types.h: 116

key_t = __key_t# /usr/include/sys/types.h: 122

clock_t = __clock_t# /usr/include/time.h: 59

time_t = __time_t# /usr/include/time.h: 75

clockid_t = __clockid_t# /usr/include/time.h: 91

timer_t = __timer_t# /usr/include/time.h: 103

size_t = c_ulong# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/stddef.h: 212

ulong = c_ulong# /usr/include/sys/types.h: 150

ushort = c_uint# /usr/include/sys/types.h: 151

uint = c_uint# /usr/include/sys/types.h: 152

int8_t = c_char# /usr/include/sys/types.h: 162

int16_t = c_int# /usr/include/sys/types.h: 163

int32_t = c_int# /usr/include/sys/types.h: 164

int64_t = c_long# /usr/include/sys/types.h: 166

u_int8_t = c_ubyte# /usr/include/sys/types.h: 173

u_int16_t = c_uint# /usr/include/sys/types.h: 174

u_int32_t = c_uint# /usr/include/sys/types.h: 175

u_int64_t = c_ulong# /usr/include/sys/types.h: 177

register_t = c_int# /usr/include/sys/types.h: 182

__sig_atomic_t = c_int# /usr/include/bits/sigset.h: 23

# /usr/include/bits/sigset.h: 31
class struct_anon_2(Structure):
    pass

struct_anon_2.__slots__ = [
    '__val',
]
struct_anon_2._fields_ = [
    ('__val', c_ulong * int((1024 / (8 * sizeof(c_ulong))))),
]

__sigset_t = struct_anon_2# /usr/include/bits/sigset.h: 31

sigset_t = __sigset_t# /usr/include/sys/select.h: 37

# /usr/include/time.h: 120
class struct_timespec(Structure):
    pass

struct_timespec.__slots__ = [
    'tv_sec',
    'tv_nsec',
]
struct_timespec._fields_ = [
    ('tv_sec', __time_t),
    ('tv_nsec', __syscall_slong_t),
]

# /usr/include/bits/time.h: 30
class struct_timeval(Structure):
    pass

struct_timeval.__slots__ = [
    'tv_sec',
    'tv_usec',
]
struct_timeval._fields_ = [
    ('tv_sec', __time_t),
    ('tv_usec', __suseconds_t),
]

suseconds_t = __suseconds_t# /usr/include/sys/select.h: 48

__fd_mask = c_long# /usr/include/sys/select.h: 54

# /usr/include/sys/select.h: 75
class struct_anon_3(Structure):
    pass

struct_anon_3.__slots__ = [
    '__fds_bits',
]
struct_anon_3._fields_ = [
    ('__fds_bits', __fd_mask * int((1024 / (8 * (c_int (ord_if_char(sizeof(__fd_mask)))).value)))),
]

fd_set = struct_anon_3# /usr/include/sys/select.h: 75

fd_mask = __fd_mask# /usr/include/sys/select.h: 82

# /usr/include/sys/select.h: 106
if _libs["libPyFd.so"].has("select", "cdecl"):
    select = _libs["libPyFd.so"].get("select", "cdecl")
    select.argtypes = [c_int, POINTER(fd_set), POINTER(fd_set), POINTER(fd_set), POINTER(struct_timeval)]
    select.restype = c_int

# /usr/include/sys/select.h: 118
if _libs["libPyFd.so"].has("pselect", "cdecl"):
    pselect = _libs["libPyFd.so"].get("pselect", "cdecl")
    pselect.argtypes = [c_int, POINTER(fd_set), POINTER(fd_set), POINTER(fd_set), POINTER(struct_timespec), POINTER(__sigset_t)]
    pselect.restype = c_int

blksize_t = __blksize_t# /usr/include/sys/types.h: 228

blkcnt_t = __blkcnt_t# /usr/include/sys/types.h: 235

fsblkcnt_t = __fsblkcnt_t# /usr/include/sys/types.h: 239

fsfilcnt_t = __fsfilcnt_t# /usr/include/sys/types.h: 243

pthread_t = c_ulong# /usr/include/bits/pthreadtypes.h: 60

# /usr/include/bits/pthreadtypes.h: 63
class union_pthread_attr_t(Union):
    pass

union_pthread_attr_t.__slots__ = [
    '__size',
    '__align',
]
union_pthread_attr_t._fields_ = [
    ('__size', c_char * int(56)),
    ('__align', c_long),
]

pthread_attr_t = union_pthread_attr_t# /usr/include/bits/pthreadtypes.h: 69

# /usr/include/bits/pthreadtypes.h: 75
class struct___pthread_internal_list(Structure):
    pass

struct___pthread_internal_list.__slots__ = [
    '__prev',
    '__next',
]
struct___pthread_internal_list._fields_ = [
    ('__prev', POINTER(struct___pthread_internal_list)),
    ('__next', POINTER(struct___pthread_internal_list)),
]

__pthread_list_t = struct___pthread_internal_list# /usr/include/bits/pthreadtypes.h: 79

# /usr/include/bits/pthreadtypes.h: 92
class struct___pthread_mutex_s(Structure):
    pass

struct___pthread_mutex_s.__slots__ = [
    '__lock',
    '__count',
    '__owner',
    '__nusers',
    '__kind',
    '__spins',
    '__elision',
    '__list',
]
struct___pthread_mutex_s._fields_ = [
    ('__lock', c_int),
    ('__count', c_uint),
    ('__owner', c_int),
    ('__nusers', c_uint),
    ('__kind', c_int),
    ('__spins', c_short),
    ('__elision', c_short),
    ('__list', __pthread_list_t),
]

# /usr/include/bits/pthreadtypes.h: 128
class union_anon_4(Union):
    pass

union_anon_4.__slots__ = [
    '__data',
    '__size',
    '__align',
]
union_anon_4._fields_ = [
    ('__data', struct___pthread_mutex_s),
    ('__size', c_char * int(40)),
    ('__align', c_long),
]

pthread_mutex_t = union_anon_4# /usr/include/bits/pthreadtypes.h: 128

# /usr/include/bits/pthreadtypes.h: 134
class union_anon_5(Union):
    pass

union_anon_5.__slots__ = [
    '__size',
    '__align',
]
union_anon_5._fields_ = [
    ('__size', c_char * int(4)),
    ('__align', c_int),
]

pthread_mutexattr_t = union_anon_5# /usr/include/bits/pthreadtypes.h: 134

# /usr/include/bits/pthreadtypes.h: 141
class struct_anon_6(Structure):
    pass

struct_anon_6.__slots__ = [
    '__lock',
    '__futex',
    '__total_seq',
    '__wakeup_seq',
    '__woken_seq',
    '__mutex',
    '__nwaiters',
    '__broadcast_seq',
]
struct_anon_6._fields_ = [
    ('__lock', c_int),
    ('__futex', c_uint),
    ('__total_seq', c_ulonglong),
    ('__wakeup_seq', c_ulonglong),
    ('__woken_seq', c_ulonglong),
    ('__mutex', POINTER(None)),
    ('__nwaiters', c_uint),
    ('__broadcast_seq', c_uint),
]

# /usr/include/bits/pthreadtypes.h: 154
class union_anon_7(Union):
    pass

union_anon_7.__slots__ = [
    '__data',
    '__size',
    '__align',
]
union_anon_7._fields_ = [
    ('__data', struct_anon_6),
    ('__size', c_char * int(48)),
    ('__align', c_longlong),
]

pthread_cond_t = union_anon_7# /usr/include/bits/pthreadtypes.h: 154

# /usr/include/bits/pthreadtypes.h: 160
class union_anon_8(Union):
    pass

union_anon_8.__slots__ = [
    '__size',
    '__align',
]
union_anon_8._fields_ = [
    ('__size', c_char * int(4)),
    ('__align', c_int),
]

pthread_condattr_t = union_anon_8# /usr/include/bits/pthreadtypes.h: 160

pthread_key_t = c_uint# /usr/include/bits/pthreadtypes.h: 164

pthread_once_t = c_int# /usr/include/bits/pthreadtypes.h: 168

# /usr/include/bits/pthreadtypes.h: 177
class struct_anon_9(Structure):
    pass

struct_anon_9.__slots__ = [
    '__lock',
    '__nr_readers',
    '__readers_wakeup',
    '__writer_wakeup',
    '__nr_readers_queued',
    '__nr_writers_queued',
    '__writer',
    '__shared',
    '__pad1',
    '__pad2',
    '__flags',
]
struct_anon_9._fields_ = [
    ('__lock', c_int),
    ('__nr_readers', c_uint),
    ('__readers_wakeup', c_uint),
    ('__writer_wakeup', c_uint),
    ('__nr_readers_queued', c_uint),
    ('__nr_writers_queued', c_uint),
    ('__writer', c_int),
    ('__shared', c_int),
    ('__pad1', c_ulong),
    ('__pad2', c_ulong),
    ('__flags', c_uint),
]

# /usr/include/bits/pthreadtypes.h: 214
class union_anon_10(Union):
    pass

union_anon_10.__slots__ = [
    '__data',
    '__size',
    '__align',
]
union_anon_10._fields_ = [
    ('__data', struct_anon_9),
    ('__size', c_char * int(56)),
    ('__align', c_long),
]

pthread_rwlock_t = union_anon_10# /usr/include/bits/pthreadtypes.h: 214

# /usr/include/bits/pthreadtypes.h: 220
class union_anon_11(Union):
    pass

union_anon_11.__slots__ = [
    '__size',
    '__align',
]
union_anon_11._fields_ = [
    ('__size', c_char * int(8)),
    ('__align', c_long),
]

pthread_rwlockattr_t = union_anon_11# /usr/include/bits/pthreadtypes.h: 220

pthread_spinlock_t = c_int# /usr/include/bits/pthreadtypes.h: 226

# /usr/include/bits/pthreadtypes.h: 235
class union_anon_12(Union):
    pass

union_anon_12.__slots__ = [
    '__size',
    '__align',
]
union_anon_12._fields_ = [
    ('__size', c_char * int(32)),
    ('__align', c_long),
]

pthread_barrier_t = union_anon_12# /usr/include/bits/pthreadtypes.h: 235

# /usr/include/bits/pthreadtypes.h: 241
class union_anon_13(Union):
    pass

union_anon_13.__slots__ = [
    '__size',
    '__align',
]
union_anon_13._fields_ = [
    ('__size', c_char * int(4)),
    ('__align', c_int),
]

pthread_barrierattr_t = union_anon_13# /usr/include/bits/pthreadtypes.h: 241

# /usr/include/bits/sched.h: 73
class struct_sched_param(Structure):
    pass

struct_sched_param.__slots__ = [
    '__sched_priority',
]
struct_sched_param._fields_ = [
    ('__sched_priority', c_int),
]

# /usr/include/bits/sched.h: 104
class struct___sched_param(Structure):
    pass

struct___sched_param.__slots__ = [
    '__sched_priority',
]
struct___sched_param._fields_ = [
    ('__sched_priority', c_int),
]

__cpu_mask = c_ulong# /usr/include/bits/sched.h: 119

# /usr/include/bits/sched.h: 129
class struct_anon_14(Structure):
    pass

struct_anon_14.__slots__ = [
    '__bits',
]
struct_anon_14._fields_ = [
    ('__bits', __cpu_mask * int((1024 / (8 * sizeof(__cpu_mask))))),
]

cpu_set_t = struct_anon_14# /usr/include/bits/sched.h: 129

# /usr/include/bits/sched.h: 204
if _libs["libPyFd.so"].has("__sched_cpucount", "cdecl"):
    __sched_cpucount = _libs["libPyFd.so"].get("__sched_cpucount", "cdecl")
    __sched_cpucount.argtypes = [c_size_t, POINTER(cpu_set_t)]
    __sched_cpucount.restype = c_int

# /usr/include/bits/sched.h: 206
if _libs["libPyFd.so"].has("__sched_cpualloc", "cdecl"):
    __sched_cpualloc = _libs["libPyFd.so"].get("__sched_cpualloc", "cdecl")
    __sched_cpualloc.argtypes = [c_size_t]
    __sched_cpualloc.restype = POINTER(cpu_set_t)

# /usr/include/bits/sched.h: 207
if _libs["libPyFd.so"].has("__sched_cpufree", "cdecl"):
    __sched_cpufree = _libs["libPyFd.so"].get("__sched_cpufree", "cdecl")
    __sched_cpufree.argtypes = [POINTER(cpu_set_t)]
    __sched_cpufree.restype = None

# /usr/include/sched.h: 50
if _libs["libPyFd.so"].has("sched_setparam", "cdecl"):
    sched_setparam = _libs["libPyFd.so"].get("sched_setparam", "cdecl")
    sched_setparam.argtypes = [__pid_t, POINTER(struct_sched_param)]
    sched_setparam.restype = c_int

# /usr/include/sched.h: 54
if _libs["libPyFd.so"].has("sched_getparam", "cdecl"):
    sched_getparam = _libs["libPyFd.so"].get("sched_getparam", "cdecl")
    sched_getparam.argtypes = [__pid_t, POINTER(struct_sched_param)]
    sched_getparam.restype = c_int

# /usr/include/sched.h: 57
if _libs["libPyFd.so"].has("sched_setscheduler", "cdecl"):
    sched_setscheduler = _libs["libPyFd.so"].get("sched_setscheduler", "cdecl")
    sched_setscheduler.argtypes = [__pid_t, c_int, POINTER(struct_sched_param)]
    sched_setscheduler.restype = c_int

# /usr/include/sched.h: 61
if _libs["libPyFd.so"].has("sched_getscheduler", "cdecl"):
    sched_getscheduler = _libs["libPyFd.so"].get("sched_getscheduler", "cdecl")
    sched_getscheduler.argtypes = [__pid_t]
    sched_getscheduler.restype = c_int

# /usr/include/sched.h: 64
if _libs["libPyFd.so"].has("sched_yield", "cdecl"):
    sched_yield = _libs["libPyFd.so"].get("sched_yield", "cdecl")
    sched_yield.argtypes = []
    sched_yield.restype = c_int

# /usr/include/sched.h: 67
if _libs["libPyFd.so"].has("sched_get_priority_max", "cdecl"):
    sched_get_priority_max = _libs["libPyFd.so"].get("sched_get_priority_max", "cdecl")
    sched_get_priority_max.argtypes = [c_int]
    sched_get_priority_max.restype = c_int

# /usr/include/sched.h: 70
if _libs["libPyFd.so"].has("sched_get_priority_min", "cdecl"):
    sched_get_priority_min = _libs["libPyFd.so"].get("sched_get_priority_min", "cdecl")
    sched_get_priority_min.argtypes = [c_int]
    sched_get_priority_min.restype = c_int

# /usr/include/sched.h: 73
if _libs["libPyFd.so"].has("sched_rr_get_interval", "cdecl"):
    sched_rr_get_interval = _libs["libPyFd.so"].get("sched_rr_get_interval", "cdecl")
    sched_rr_get_interval.argtypes = [__pid_t, POINTER(struct_timespec)]
    sched_rr_get_interval.restype = c_int

# /usr/include/time.h: 133
class struct_tm(Structure):
    pass

struct_tm.__slots__ = [
    'tm_sec',
    'tm_min',
    'tm_hour',
    'tm_mday',
    'tm_mon',
    'tm_year',
    'tm_wday',
    'tm_yday',
    'tm_isdst',
    'tm_gmtoff',
    'tm_zone',
]
struct_tm._fields_ = [
    ('tm_sec', c_int),
    ('tm_min', c_int),
    ('tm_hour', c_int),
    ('tm_mday', c_int),
    ('tm_mon', c_int),
    ('tm_year', c_int),
    ('tm_wday', c_int),
    ('tm_yday', c_int),
    ('tm_isdst', c_int),
    ('tm_gmtoff', c_long),
    ('tm_zone', String),
]

# /usr/include/time.h: 161
class struct_itimerspec(Structure):
    pass

struct_itimerspec.__slots__ = [
    'it_interval',
    'it_value',
]
struct_itimerspec._fields_ = [
    ('it_interval', struct_timespec),
    ('it_value', struct_timespec),
]

# /usr/include/bits/siginfo.h: 301
class struct_sigevent(Structure):
    pass

# /usr/include/time.h: 189
if _libs["libPyFd.so"].has("clock", "cdecl"):
    clock = _libs["libPyFd.so"].get("clock", "cdecl")
    clock.argtypes = []
    clock.restype = clock_t

# /usr/include/time.h: 192
if _libs["libPyFd.so"].has("time", "cdecl"):
    time = _libs["libPyFd.so"].get("time", "cdecl")
    time.argtypes = [POINTER(time_t)]
    time.restype = time_t

# /usr/include/time.h: 195
if _libs["libPyFd.so"].has("difftime", "cdecl"):
    difftime = _libs["libPyFd.so"].get("difftime", "cdecl")
    difftime.argtypes = [time_t, time_t]
    difftime.restype = c_double

# /usr/include/time.h: 199
if _libs["libPyFd.so"].has("mktime", "cdecl"):
    mktime = _libs["libPyFd.so"].get("mktime", "cdecl")
    mktime.argtypes = [POINTER(struct_tm)]
    mktime.restype = time_t

# /usr/include/time.h: 205
if _libs["libPyFd.so"].has("strftime", "cdecl"):
    strftime = _libs["libPyFd.so"].get("strftime", "cdecl")
    strftime.argtypes = [String, c_size_t, String, POINTER(struct_tm)]
    strftime.restype = c_size_t

# /usr/include/xlocale.h: 30
class struct___locale_data(Structure):
    pass

# /usr/include/xlocale.h: 27
class struct___locale_struct(Structure):
    pass

struct___locale_struct.__slots__ = [
    '__locales',
    '__ctype_b',
    '__ctype_tolower',
    '__ctype_toupper',
    '__names',
]
struct___locale_struct._fields_ = [
    ('__locales', POINTER(struct___locale_data) * int(13)),
    ('__ctype_b', POINTER(c_uint)),
    ('__ctype_tolower', POINTER(c_int)),
    ('__ctype_toupper', POINTER(c_int)),
    ('__names', POINTER(c_char) * int(13)),
]

__locale_t = POINTER(struct___locale_struct)# /usr/include/xlocale.h: 39

locale_t = __locale_t# /usr/include/xlocale.h: 42

# /usr/include/time.h: 223
if _libs["libPyFd.so"].has("strftime_l", "cdecl"):
    strftime_l = _libs["libPyFd.so"].get("strftime_l", "cdecl")
    strftime_l.argtypes = [String, c_size_t, String, POINTER(struct_tm), __locale_t]
    strftime_l.restype = c_size_t

# /usr/include/time.h: 239
if _libs["libPyFd.so"].has("gmtime", "cdecl"):
    gmtime = _libs["libPyFd.so"].get("gmtime", "cdecl")
    gmtime.argtypes = [POINTER(time_t)]
    gmtime.restype = POINTER(struct_tm)

# /usr/include/time.h: 243
if _libs["libPyFd.so"].has("localtime", "cdecl"):
    localtime = _libs["libPyFd.so"].get("localtime", "cdecl")
    localtime.argtypes = [POINTER(time_t)]
    localtime.restype = POINTER(struct_tm)

# /usr/include/time.h: 249
if _libs["libPyFd.so"].has("gmtime_r", "cdecl"):
    gmtime_r = _libs["libPyFd.so"].get("gmtime_r", "cdecl")
    gmtime_r.argtypes = [POINTER(time_t), POINTER(struct_tm)]
    gmtime_r.restype = POINTER(struct_tm)

# /usr/include/time.h: 254
if _libs["libPyFd.so"].has("localtime_r", "cdecl"):
    localtime_r = _libs["libPyFd.so"].get("localtime_r", "cdecl")
    localtime_r.argtypes = [POINTER(time_t), POINTER(struct_tm)]
    localtime_r.restype = POINTER(struct_tm)

# /usr/include/time.h: 261
if _libs["libPyFd.so"].has("asctime", "cdecl"):
    asctime = _libs["libPyFd.so"].get("asctime", "cdecl")
    asctime.argtypes = [POINTER(struct_tm)]
    if sizeof(c_int) == sizeof(c_void_p):
        asctime.restype = ReturnString
    else:
        asctime.restype = String
        asctime.errcheck = ReturnString

# /usr/include/time.h: 264
if _libs["libPyFd.so"].has("ctime", "cdecl"):
    ctime = _libs["libPyFd.so"].get("ctime", "cdecl")
    ctime.argtypes = [POINTER(time_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        ctime.restype = ReturnString
    else:
        ctime.restype = String
        ctime.errcheck = ReturnString

# /usr/include/time.h: 272
if _libs["libPyFd.so"].has("asctime_r", "cdecl"):
    asctime_r = _libs["libPyFd.so"].get("asctime_r", "cdecl")
    asctime_r.argtypes = [POINTER(struct_tm), String]
    if sizeof(c_int) == sizeof(c_void_p):
        asctime_r.restype = ReturnString
    else:
        asctime_r.restype = String
        asctime_r.errcheck = ReturnString

# /usr/include/time.h: 276
if _libs["libPyFd.so"].has("ctime_r", "cdecl"):
    ctime_r = _libs["libPyFd.so"].get("ctime_r", "cdecl")
    ctime_r.argtypes = [POINTER(time_t), String]
    if sizeof(c_int) == sizeof(c_void_p):
        ctime_r.restype = ReturnString
    else:
        ctime_r.restype = String
        ctime_r.errcheck = ReturnString

# /usr/include/time.h: 282
try:
    __tzname = (POINTER(c_char) * int(2)).in_dll(_libs["libPyFd.so"], "__tzname")
except:
    pass

# /usr/include/time.h: 283
try:
    __daylight = (c_int).in_dll(_libs["libPyFd.so"], "__daylight")
except:
    pass

# /usr/include/time.h: 284
try:
    __timezone = (c_long).in_dll(_libs["libPyFd.so"], "__timezone")
except:
    pass

# /usr/include/time.h: 289
try:
    tzname = (POINTER(c_char) * int(2)).in_dll(_libs["libPyFd.so"], "tzname")
except:
    pass

# /usr/include/time.h: 293
if _libs["libPyFd.so"].has("tzset", "cdecl"):
    tzset = _libs["libPyFd.so"].get("tzset", "cdecl")
    tzset.argtypes = []
    tzset.restype = None

# /usr/include/time.h: 297
try:
    daylight = (c_int).in_dll(_libs["libPyFd.so"], "daylight")
except:
    pass

# /usr/include/time.h: 298
try:
    timezone = (c_long).in_dll(_libs["libPyFd.so"], "timezone")
except:
    pass

# /usr/include/time.h: 304
if _libs["libPyFd.so"].has("stime", "cdecl"):
    stime = _libs["libPyFd.so"].get("stime", "cdecl")
    stime.argtypes = [POINTER(time_t)]
    stime.restype = c_int

# /usr/include/time.h: 319
if _libs["libPyFd.so"].has("timegm", "cdecl"):
    timegm = _libs["libPyFd.so"].get("timegm", "cdecl")
    timegm.argtypes = [POINTER(struct_tm)]
    timegm.restype = time_t

# /usr/include/time.h: 322
if _libs["libPyFd.so"].has("timelocal", "cdecl"):
    timelocal = _libs["libPyFd.so"].get("timelocal", "cdecl")
    timelocal.argtypes = [POINTER(struct_tm)]
    timelocal.restype = time_t

# /usr/include/time.h: 325
if _libs["libPyFd.so"].has("dysize", "cdecl"):
    dysize = _libs["libPyFd.so"].get("dysize", "cdecl")
    dysize.argtypes = [c_int]
    dysize.restype = c_int

# /usr/include/time.h: 334
if _libs["libPyFd.so"].has("nanosleep", "cdecl"):
    nanosleep = _libs["libPyFd.so"].get("nanosleep", "cdecl")
    nanosleep.argtypes = [POINTER(struct_timespec), POINTER(struct_timespec)]
    nanosleep.restype = c_int

# /usr/include/time.h: 339
if _libs["libPyFd.so"].has("clock_getres", "cdecl"):
    clock_getres = _libs["libPyFd.so"].get("clock_getres", "cdecl")
    clock_getres.argtypes = [clockid_t, POINTER(struct_timespec)]
    clock_getres.restype = c_int

# /usr/include/time.h: 342
if _libs["libPyFd.so"].has("clock_gettime", "cdecl"):
    clock_gettime = _libs["libPyFd.so"].get("clock_gettime", "cdecl")
    clock_gettime.argtypes = [clockid_t, POINTER(struct_timespec)]
    clock_gettime.restype = c_int

# /usr/include/time.h: 345
if _libs["libPyFd.so"].has("clock_settime", "cdecl"):
    clock_settime = _libs["libPyFd.so"].get("clock_settime", "cdecl")
    clock_settime.argtypes = [clockid_t, POINTER(struct_timespec)]
    clock_settime.restype = c_int

# /usr/include/time.h: 353
if _libs["libPyFd.so"].has("clock_nanosleep", "cdecl"):
    clock_nanosleep = _libs["libPyFd.so"].get("clock_nanosleep", "cdecl")
    clock_nanosleep.argtypes = [clockid_t, c_int, POINTER(struct_timespec), POINTER(struct_timespec)]
    clock_nanosleep.restype = c_int

# /usr/include/time.h: 358
if _libs["libPyFd.so"].has("clock_getcpuclockid", "cdecl"):
    clock_getcpuclockid = _libs["libPyFd.so"].get("clock_getcpuclockid", "cdecl")
    clock_getcpuclockid.argtypes = [pid_t, POINTER(clockid_t)]
    clock_getcpuclockid.restype = c_int

# /usr/include/time.h: 363
for _lib in _libs.values():
    if not _lib.has("timer_create", "cdecl"):
        continue
    timer_create = _lib.get("timer_create", "cdecl")
    timer_create.argtypes = [clockid_t, POINTER(struct_sigevent), POINTER(timer_t)]
    timer_create.restype = c_int
    break

# /usr/include/time.h: 368
for _lib in _libs.values():
    if not _lib.has("timer_delete", "cdecl"):
        continue
    timer_delete = _lib.get("timer_delete", "cdecl")
    timer_delete.argtypes = [timer_t]
    timer_delete.restype = c_int
    break

# /usr/include/time.h: 371
for _lib in _libs.values():
    if not _lib.has("timer_settime", "cdecl"):
        continue
    timer_settime = _lib.get("timer_settime", "cdecl")
    timer_settime.argtypes = [timer_t, c_int, POINTER(struct_itimerspec), POINTER(struct_itimerspec)]
    timer_settime.restype = c_int
    break

# /usr/include/time.h: 376
for _lib in _libs.values():
    if not _lib.has("timer_gettime", "cdecl"):
        continue
    timer_gettime = _lib.get("timer_gettime", "cdecl")
    timer_gettime.argtypes = [timer_t, POINTER(struct_itimerspec)]
    timer_gettime.restype = c_int
    break

# /usr/include/time.h: 380
for _lib in _libs.values():
    if not _lib.has("timer_getoverrun", "cdecl"):
        continue
    timer_getoverrun = _lib.get("timer_getoverrun", "cdecl")
    timer_getoverrun.argtypes = [timer_t]
    timer_getoverrun.restype = c_int
    break

__jmp_buf = c_long * int(8)# /usr/include/bits/setjmp.h: 31

enum_anon_15 = c_int# /usr/include/pthread.h: 32

PTHREAD_CREATE_JOINABLE = 0# /usr/include/pthread.h: 32

PTHREAD_CREATE_DETACHED = (PTHREAD_CREATE_JOINABLE + 1)# /usr/include/pthread.h: 32

enum_anon_16 = c_int# /usr/include/pthread.h: 42

PTHREAD_MUTEX_TIMED_NP = 0# /usr/include/pthread.h: 42

PTHREAD_MUTEX_RECURSIVE_NP = (PTHREAD_MUTEX_TIMED_NP + 1)# /usr/include/pthread.h: 42

PTHREAD_MUTEX_ERRORCHECK_NP = (PTHREAD_MUTEX_RECURSIVE_NP + 1)# /usr/include/pthread.h: 42

PTHREAD_MUTEX_ADAPTIVE_NP = (PTHREAD_MUTEX_ERRORCHECK_NP + 1)# /usr/include/pthread.h: 42

PTHREAD_MUTEX_NORMAL = PTHREAD_MUTEX_TIMED_NP# /usr/include/pthread.h: 42

PTHREAD_MUTEX_RECURSIVE = PTHREAD_MUTEX_RECURSIVE_NP# /usr/include/pthread.h: 42

PTHREAD_MUTEX_ERRORCHECK = PTHREAD_MUTEX_ERRORCHECK_NP# /usr/include/pthread.h: 42

PTHREAD_MUTEX_DEFAULT = PTHREAD_MUTEX_NORMAL# /usr/include/pthread.h: 42

enum_anon_17 = c_int# /usr/include/pthread.h: 64

PTHREAD_MUTEX_STALLED = 0# /usr/include/pthread.h: 64

PTHREAD_MUTEX_STALLED_NP = PTHREAD_MUTEX_STALLED# /usr/include/pthread.h: 64

PTHREAD_MUTEX_ROBUST = (PTHREAD_MUTEX_STALLED_NP + 1)# /usr/include/pthread.h: 64

PTHREAD_MUTEX_ROBUST_NP = PTHREAD_MUTEX_ROBUST# /usr/include/pthread.h: 64

enum_anon_18 = c_int# /usr/include/pthread.h: 76

PTHREAD_PRIO_NONE = 0# /usr/include/pthread.h: 76

PTHREAD_PRIO_INHERIT = (PTHREAD_PRIO_NONE + 1)# /usr/include/pthread.h: 76

PTHREAD_PRIO_PROTECT = (PTHREAD_PRIO_INHERIT + 1)# /usr/include/pthread.h: 76

enum_anon_19 = c_int# /usr/include/pthread.h: 116

PTHREAD_RWLOCK_PREFER_READER_NP = 0# /usr/include/pthread.h: 116

PTHREAD_RWLOCK_PREFER_WRITER_NP = (PTHREAD_RWLOCK_PREFER_READER_NP + 1)# /usr/include/pthread.h: 116

PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP = (PTHREAD_RWLOCK_PREFER_WRITER_NP + 1)# /usr/include/pthread.h: 116

PTHREAD_RWLOCK_DEFAULT_NP = PTHREAD_RWLOCK_PREFER_READER_NP# /usr/include/pthread.h: 116

enum_anon_20 = c_int# /usr/include/pthread.h: 157

PTHREAD_INHERIT_SCHED = 0# /usr/include/pthread.h: 157

PTHREAD_EXPLICIT_SCHED = (PTHREAD_INHERIT_SCHED + 1)# /usr/include/pthread.h: 157

enum_anon_21 = c_int# /usr/include/pthread.h: 167

PTHREAD_SCOPE_SYSTEM = 0# /usr/include/pthread.h: 167

PTHREAD_SCOPE_PROCESS = (PTHREAD_SCOPE_SYSTEM + 1)# /usr/include/pthread.h: 167

enum_anon_22 = c_int# /usr/include/pthread.h: 177

PTHREAD_PROCESS_PRIVATE = 0# /usr/include/pthread.h: 177

PTHREAD_PROCESS_SHARED = (PTHREAD_PROCESS_PRIVATE + 1)# /usr/include/pthread.h: 177

# /usr/include/pthread.h: 192
class struct__pthread_cleanup_buffer(Structure):
    pass

struct__pthread_cleanup_buffer.__slots__ = [
    '__routine',
    '__arg',
    '__canceltype',
    '__prev',
]
struct__pthread_cleanup_buffer._fields_ = [
    ('__routine', CFUNCTYPE(UNCHECKED(None), POINTER(None))),
    ('__arg', POINTER(None)),
    ('__canceltype', c_int),
    ('__prev', POINTER(struct__pthread_cleanup_buffer)),
]

enum_anon_23 = c_int# /usr/include/pthread.h: 201

PTHREAD_CANCEL_ENABLE = 0# /usr/include/pthread.h: 201

PTHREAD_CANCEL_DISABLE = (PTHREAD_CANCEL_ENABLE + 1)# /usr/include/pthread.h: 201

enum_anon_24 = c_int# /usr/include/pthread.h: 208

PTHREAD_CANCEL_DEFERRED = 0# /usr/include/pthread.h: 208

PTHREAD_CANCEL_ASYNCHRONOUS = (PTHREAD_CANCEL_DEFERRED + 1)# /usr/include/pthread.h: 208

# /usr/include/pthread.h: 235
if _libs["libPyFd.so"].has("pthread_create", "cdecl"):
    pthread_create = _libs["libPyFd.so"].get("pthread_create", "cdecl")
    pthread_create.argtypes = [POINTER(pthread_t), POINTER(pthread_attr_t), CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), POINTER(None)), POINTER(None)]
    pthread_create.restype = c_int

# /usr/include/pthread.h: 244
if _libs["libPyFd.so"].has("pthread_exit", "cdecl"):
    pthread_exit = _libs["libPyFd.so"].get("pthread_exit", "cdecl")
    pthread_exit.argtypes = [POINTER(None)]
    pthread_exit.restype = None

# /usr/include/pthread.h: 252
if _libs["libPyFd.so"].has("pthread_join", "cdecl"):
    pthread_join = _libs["libPyFd.so"].get("pthread_join", "cdecl")
    pthread_join.argtypes = [pthread_t, POINTER(POINTER(None))]
    pthread_join.restype = c_int

# /usr/include/pthread.h: 273
if _libs["libPyFd.so"].has("pthread_detach", "cdecl"):
    pthread_detach = _libs["libPyFd.so"].get("pthread_detach", "cdecl")
    pthread_detach.argtypes = [pthread_t]
    pthread_detach.restype = c_int

# /usr/include/pthread.h: 277
if _libs["libPyFd.so"].has("pthread_self", "cdecl"):
    pthread_self = _libs["libPyFd.so"].get("pthread_self", "cdecl")
    pthread_self.argtypes = []
    pthread_self.restype = pthread_t

# /usr/include/pthread.h: 280
if _libs["libPyFd.so"].has("pthread_equal", "cdecl"):
    pthread_equal = _libs["libPyFd.so"].get("pthread_equal", "cdecl")
    pthread_equal.argtypes = [pthread_t, pthread_t]
    pthread_equal.restype = c_int

# /usr/include/pthread.h: 289
if _libs["libPyFd.so"].has("pthread_attr_init", "cdecl"):
    pthread_attr_init = _libs["libPyFd.so"].get("pthread_attr_init", "cdecl")
    pthread_attr_init.argtypes = [POINTER(pthread_attr_t)]
    pthread_attr_init.restype = c_int

# /usr/include/pthread.h: 292
if _libs["libPyFd.so"].has("pthread_attr_destroy", "cdecl"):
    pthread_attr_destroy = _libs["libPyFd.so"].get("pthread_attr_destroy", "cdecl")
    pthread_attr_destroy.argtypes = [POINTER(pthread_attr_t)]
    pthread_attr_destroy.restype = c_int

# /usr/include/pthread.h: 296
if _libs["libPyFd.so"].has("pthread_attr_getdetachstate", "cdecl"):
    pthread_attr_getdetachstate = _libs["libPyFd.so"].get("pthread_attr_getdetachstate", "cdecl")
    pthread_attr_getdetachstate.argtypes = [POINTER(pthread_attr_t), POINTER(c_int)]
    pthread_attr_getdetachstate.restype = c_int

# /usr/include/pthread.h: 301
if _libs["libPyFd.so"].has("pthread_attr_setdetachstate", "cdecl"):
    pthread_attr_setdetachstate = _libs["libPyFd.so"].get("pthread_attr_setdetachstate", "cdecl")
    pthread_attr_setdetachstate.argtypes = [POINTER(pthread_attr_t), c_int]
    pthread_attr_setdetachstate.restype = c_int

# /usr/include/pthread.h: 307
if _libs["libPyFd.so"].has("pthread_attr_getguardsize", "cdecl"):
    pthread_attr_getguardsize = _libs["libPyFd.so"].get("pthread_attr_getguardsize", "cdecl")
    pthread_attr_getguardsize.argtypes = [POINTER(pthread_attr_t), POINTER(c_size_t)]
    pthread_attr_getguardsize.restype = c_int

# /usr/include/pthread.h: 312
if _libs["libPyFd.so"].has("pthread_attr_setguardsize", "cdecl"):
    pthread_attr_setguardsize = _libs["libPyFd.so"].get("pthread_attr_setguardsize", "cdecl")
    pthread_attr_setguardsize.argtypes = [POINTER(pthread_attr_t), c_size_t]
    pthread_attr_setguardsize.restype = c_int

# /usr/include/pthread.h: 318
if _libs["libPyFd.so"].has("pthread_attr_getschedparam", "cdecl"):
    pthread_attr_getschedparam = _libs["libPyFd.so"].get("pthread_attr_getschedparam", "cdecl")
    pthread_attr_getschedparam.argtypes = [POINTER(pthread_attr_t), POINTER(struct_sched_param)]
    pthread_attr_getschedparam.restype = c_int

# /usr/include/pthread.h: 323
if _libs["libPyFd.so"].has("pthread_attr_setschedparam", "cdecl"):
    pthread_attr_setschedparam = _libs["libPyFd.so"].get("pthread_attr_setschedparam", "cdecl")
    pthread_attr_setschedparam.argtypes = [POINTER(pthread_attr_t), POINTER(struct_sched_param)]
    pthread_attr_setschedparam.restype = c_int

# /usr/include/pthread.h: 328
if _libs["libPyFd.so"].has("pthread_attr_getschedpolicy", "cdecl"):
    pthread_attr_getschedpolicy = _libs["libPyFd.so"].get("pthread_attr_getschedpolicy", "cdecl")
    pthread_attr_getschedpolicy.argtypes = [POINTER(pthread_attr_t), POINTER(c_int)]
    pthread_attr_getschedpolicy.restype = c_int

# /usr/include/pthread.h: 333
if _libs["libPyFd.so"].has("pthread_attr_setschedpolicy", "cdecl"):
    pthread_attr_setschedpolicy = _libs["libPyFd.so"].get("pthread_attr_setschedpolicy", "cdecl")
    pthread_attr_setschedpolicy.argtypes = [POINTER(pthread_attr_t), c_int]
    pthread_attr_setschedpolicy.restype = c_int

# /usr/include/pthread.h: 337
if _libs["libPyFd.so"].has("pthread_attr_getinheritsched", "cdecl"):
    pthread_attr_getinheritsched = _libs["libPyFd.so"].get("pthread_attr_getinheritsched", "cdecl")
    pthread_attr_getinheritsched.argtypes = [POINTER(pthread_attr_t), POINTER(c_int)]
    pthread_attr_getinheritsched.restype = c_int

# /usr/include/pthread.h: 342
if _libs["libPyFd.so"].has("pthread_attr_setinheritsched", "cdecl"):
    pthread_attr_setinheritsched = _libs["libPyFd.so"].get("pthread_attr_setinheritsched", "cdecl")
    pthread_attr_setinheritsched.argtypes = [POINTER(pthread_attr_t), c_int]
    pthread_attr_setinheritsched.restype = c_int

# /usr/include/pthread.h: 348
if _libs["libPyFd.so"].has("pthread_attr_getscope", "cdecl"):
    pthread_attr_getscope = _libs["libPyFd.so"].get("pthread_attr_getscope", "cdecl")
    pthread_attr_getscope.argtypes = [POINTER(pthread_attr_t), POINTER(c_int)]
    pthread_attr_getscope.restype = c_int

# /usr/include/pthread.h: 353
if _libs["libPyFd.so"].has("pthread_attr_setscope", "cdecl"):
    pthread_attr_setscope = _libs["libPyFd.so"].get("pthread_attr_setscope", "cdecl")
    pthread_attr_setscope.argtypes = [POINTER(pthread_attr_t), c_int]
    pthread_attr_setscope.restype = c_int

# /usr/include/pthread.h: 357
if _libs["libPyFd.so"].has("pthread_attr_getstackaddr", "cdecl"):
    pthread_attr_getstackaddr = _libs["libPyFd.so"].get("pthread_attr_getstackaddr", "cdecl")
    pthread_attr_getstackaddr.argtypes = [POINTER(pthread_attr_t), POINTER(POINTER(None))]
    pthread_attr_getstackaddr.restype = c_int

# /usr/include/pthread.h: 365
if _libs["libPyFd.so"].has("pthread_attr_setstackaddr", "cdecl"):
    pthread_attr_setstackaddr = _libs["libPyFd.so"].get("pthread_attr_setstackaddr", "cdecl")
    pthread_attr_setstackaddr.argtypes = [POINTER(pthread_attr_t), POINTER(None)]
    pthread_attr_setstackaddr.restype = c_int

# /usr/include/pthread.h: 370
if _libs["libPyFd.so"].has("pthread_attr_getstacksize", "cdecl"):
    pthread_attr_getstacksize = _libs["libPyFd.so"].get("pthread_attr_getstacksize", "cdecl")
    pthread_attr_getstacksize.argtypes = [POINTER(pthread_attr_t), POINTER(c_size_t)]
    pthread_attr_getstacksize.restype = c_int

# /usr/include/pthread.h: 377
if _libs["libPyFd.so"].has("pthread_attr_setstacksize", "cdecl"):
    pthread_attr_setstacksize = _libs["libPyFd.so"].get("pthread_attr_setstacksize", "cdecl")
    pthread_attr_setstacksize.argtypes = [POINTER(pthread_attr_t), c_size_t]
    pthread_attr_setstacksize.restype = c_int

# /usr/include/pthread.h: 383
if _libs["libPyFd.so"].has("pthread_attr_getstack", "cdecl"):
    pthread_attr_getstack = _libs["libPyFd.so"].get("pthread_attr_getstack", "cdecl")
    pthread_attr_getstack.argtypes = [POINTER(pthread_attr_t), POINTER(POINTER(None)), POINTER(c_size_t)]
    pthread_attr_getstack.restype = c_int

# /usr/include/pthread.h: 391
if _libs["libPyFd.so"].has("pthread_attr_setstack", "cdecl"):
    pthread_attr_setstack = _libs["libPyFd.so"].get("pthread_attr_setstack", "cdecl")
    pthread_attr_setstack.argtypes = [POINTER(pthread_attr_t), POINTER(None), c_size_t]
    pthread_attr_setstack.restype = c_int

# /usr/include/pthread.h: 423
if _libs["libPyFd.so"].has("pthread_setschedparam", "cdecl"):
    pthread_setschedparam = _libs["libPyFd.so"].get("pthread_setschedparam", "cdecl")
    pthread_setschedparam.argtypes = [pthread_t, c_int, POINTER(struct_sched_param)]
    pthread_setschedparam.restype = c_int

# /usr/include/pthread.h: 428
if _libs["libPyFd.so"].has("pthread_getschedparam", "cdecl"):
    pthread_getschedparam = _libs["libPyFd.so"].get("pthread_getschedparam", "cdecl")
    pthread_getschedparam.argtypes = [pthread_t, POINTER(c_int), POINTER(struct_sched_param)]
    pthread_getschedparam.restype = c_int

# /usr/include/pthread.h: 434
if _libs["libPyFd.so"].has("pthread_setschedprio", "cdecl"):
    pthread_setschedprio = _libs["libPyFd.so"].get("pthread_setschedprio", "cdecl")
    pthread_setschedprio.argtypes = [pthread_t, c_int]
    pthread_setschedprio.restype = c_int

# /usr/include/pthread.h: 488
if _libs["libPyFd.so"].has("pthread_once", "cdecl"):
    pthread_once = _libs["libPyFd.so"].get("pthread_once", "cdecl")
    pthread_once.argtypes = [POINTER(pthread_once_t), CFUNCTYPE(UNCHECKED(None), )]
    pthread_once.restype = c_int

# /usr/include/pthread.h: 500
if _libs["libPyFd.so"].has("pthread_setcancelstate", "cdecl"):
    pthread_setcancelstate = _libs["libPyFd.so"].get("pthread_setcancelstate", "cdecl")
    pthread_setcancelstate.argtypes = [c_int, POINTER(c_int)]
    pthread_setcancelstate.restype = c_int

# /usr/include/pthread.h: 504
if _libs["libPyFd.so"].has("pthread_setcanceltype", "cdecl"):
    pthread_setcanceltype = _libs["libPyFd.so"].get("pthread_setcanceltype", "cdecl")
    pthread_setcanceltype.argtypes = [c_int, POINTER(c_int)]
    pthread_setcanceltype.restype = c_int

# /usr/include/pthread.h: 507
if _libs["libPyFd.so"].has("pthread_cancel", "cdecl"):
    pthread_cancel = _libs["libPyFd.so"].get("pthread_cancel", "cdecl")
    pthread_cancel.argtypes = [pthread_t]
    pthread_cancel.restype = c_int

# /usr/include/pthread.h: 512
if _libs["libPyFd.so"].has("pthread_testcancel", "cdecl"):
    pthread_testcancel = _libs["libPyFd.so"].get("pthread_testcancel", "cdecl")
    pthread_testcancel.argtypes = []
    pthread_testcancel.restype = None

# /usr/include/pthread.h: 519
class struct_anon_25(Structure):
    pass

struct_anon_25.__slots__ = [
    '__cancel_jmp_buf',
    '__mask_was_saved',
]
struct_anon_25._fields_ = [
    ('__cancel_jmp_buf', __jmp_buf),
    ('__mask_was_saved', c_int),
]

# /usr/include/pthread.h: 525
class struct_anon_26(Structure):
    pass

struct_anon_26.__slots__ = [
    '__cancel_jmp_buf',
    '__pad',
]
struct_anon_26._fields_ = [
    ('__cancel_jmp_buf', struct_anon_25 * int(1)),
    ('__pad', POINTER(None) * int(4)),
]

__pthread_unwind_buf_t = struct_anon_26# /usr/include/pthread.h: 525

# /usr/include/pthread.h: 534
class struct___pthread_cleanup_frame(Structure):
    pass

struct___pthread_cleanup_frame.__slots__ = [
    '__cancel_routine',
    '__cancel_arg',
    '__do_it',
    '__cancel_type',
]
struct___pthread_cleanup_frame._fields_ = [
    ('__cancel_routine', CFUNCTYPE(UNCHECKED(None), POINTER(None))),
    ('__cancel_arg', POINTER(None)),
    ('__do_it', c_int),
    ('__cancel_type', c_int),
]

# /usr/include/pthread.h: 674
if _libs["libPyFd.so"].has("__pthread_register_cancel", "cdecl"):
    __pthread_register_cancel = _libs["libPyFd.so"].get("__pthread_register_cancel", "cdecl")
    __pthread_register_cancel.argtypes = [POINTER(__pthread_unwind_buf_t)]
    __pthread_register_cancel.restype = None

# /usr/include/pthread.h: 686
if _libs["libPyFd.so"].has("__pthread_unregister_cancel", "cdecl"):
    __pthread_unregister_cancel = _libs["libPyFd.so"].get("__pthread_unregister_cancel", "cdecl")
    __pthread_unregister_cancel.argtypes = [POINTER(__pthread_unwind_buf_t)]
    __pthread_unregister_cancel.restype = None

# /usr/include/pthread.h: 727
if _libs["libPyFd.so"].has("__pthread_unwind_next", "cdecl"):
    __pthread_unwind_next = _libs["libPyFd.so"].get("__pthread_unwind_next", "cdecl")
    __pthread_unwind_next.argtypes = [POINTER(__pthread_unwind_buf_t)]
    __pthread_unwind_next.restype = None

# /usr/include/pthread.h: 736
class struct___jmp_buf_tag(Structure):
    pass

# /usr/include/pthread.h: 737
if _libs["libPyFd.so"].has("__sigsetjmp", "cdecl"):
    __sigsetjmp = _libs["libPyFd.so"].get("__sigsetjmp", "cdecl")
    __sigsetjmp.argtypes = [POINTER(struct___jmp_buf_tag), c_int]
    __sigsetjmp.restype = c_int

# /usr/include/pthread.h: 743
if _libs["libPyFd.so"].has("pthread_mutex_init", "cdecl"):
    pthread_mutex_init = _libs["libPyFd.so"].get("pthread_mutex_init", "cdecl")
    pthread_mutex_init.argtypes = [POINTER(pthread_mutex_t), POINTER(pthread_mutexattr_t)]
    pthread_mutex_init.restype = c_int

# /usr/include/pthread.h: 748
if _libs["libPyFd.so"].has("pthread_mutex_destroy", "cdecl"):
    pthread_mutex_destroy = _libs["libPyFd.so"].get("pthread_mutex_destroy", "cdecl")
    pthread_mutex_destroy.argtypes = [POINTER(pthread_mutex_t)]
    pthread_mutex_destroy.restype = c_int

# /usr/include/pthread.h: 752
if _libs["libPyFd.so"].has("pthread_mutex_trylock", "cdecl"):
    pthread_mutex_trylock = _libs["libPyFd.so"].get("pthread_mutex_trylock", "cdecl")
    pthread_mutex_trylock.argtypes = [POINTER(pthread_mutex_t)]
    pthread_mutex_trylock.restype = c_int

# /usr/include/pthread.h: 756
if _libs["libPyFd.so"].has("pthread_mutex_lock", "cdecl"):
    pthread_mutex_lock = _libs["libPyFd.so"].get("pthread_mutex_lock", "cdecl")
    pthread_mutex_lock.argtypes = [POINTER(pthread_mutex_t)]
    pthread_mutex_lock.restype = c_int

# /usr/include/pthread.h: 761
if _libs["libPyFd.so"].has("pthread_mutex_timedlock", "cdecl"):
    pthread_mutex_timedlock = _libs["libPyFd.so"].get("pthread_mutex_timedlock", "cdecl")
    pthread_mutex_timedlock.argtypes = [POINTER(pthread_mutex_t), POINTER(struct_timespec)]
    pthread_mutex_timedlock.restype = c_int

# /usr/include/pthread.h: 767
if _libs["libPyFd.so"].has("pthread_mutex_unlock", "cdecl"):
    pthread_mutex_unlock = _libs["libPyFd.so"].get("pthread_mutex_unlock", "cdecl")
    pthread_mutex_unlock.argtypes = [POINTER(pthread_mutex_t)]
    pthread_mutex_unlock.restype = c_int

# /usr/include/pthread.h: 772
if _libs["libPyFd.so"].has("pthread_mutex_getprioceiling", "cdecl"):
    pthread_mutex_getprioceiling = _libs["libPyFd.so"].get("pthread_mutex_getprioceiling", "cdecl")
    pthread_mutex_getprioceiling.argtypes = [POINTER(pthread_mutex_t), POINTER(c_int)]
    pthread_mutex_getprioceiling.restype = c_int

# /usr/include/pthread.h: 779
if _libs["libPyFd.so"].has("pthread_mutex_setprioceiling", "cdecl"):
    pthread_mutex_setprioceiling = _libs["libPyFd.so"].get("pthread_mutex_setprioceiling", "cdecl")
    pthread_mutex_setprioceiling.argtypes = [POINTER(pthread_mutex_t), c_int, POINTER(c_int)]
    pthread_mutex_setprioceiling.restype = c_int

# /usr/include/pthread.h: 787
if _libs["libPyFd.so"].has("pthread_mutex_consistent", "cdecl"):
    pthread_mutex_consistent = _libs["libPyFd.so"].get("pthread_mutex_consistent", "cdecl")
    pthread_mutex_consistent.argtypes = [POINTER(pthread_mutex_t)]
    pthread_mutex_consistent.restype = c_int

# /usr/include/pthread.h: 800
if _libs["libPyFd.so"].has("pthread_mutexattr_init", "cdecl"):
    pthread_mutexattr_init = _libs["libPyFd.so"].get("pthread_mutexattr_init", "cdecl")
    pthread_mutexattr_init.argtypes = [POINTER(pthread_mutexattr_t)]
    pthread_mutexattr_init.restype = c_int

# /usr/include/pthread.h: 804
if _libs["libPyFd.so"].has("pthread_mutexattr_destroy", "cdecl"):
    pthread_mutexattr_destroy = _libs["libPyFd.so"].get("pthread_mutexattr_destroy", "cdecl")
    pthread_mutexattr_destroy.argtypes = [POINTER(pthread_mutexattr_t)]
    pthread_mutexattr_destroy.restype = c_int

# /usr/include/pthread.h: 808
if _libs["libPyFd.so"].has("pthread_mutexattr_getpshared", "cdecl"):
    pthread_mutexattr_getpshared = _libs["libPyFd.so"].get("pthread_mutexattr_getpshared", "cdecl")
    pthread_mutexattr_getpshared.argtypes = [POINTER(pthread_mutexattr_t), POINTER(c_int)]
    pthread_mutexattr_getpshared.restype = c_int

# /usr/include/pthread.h: 814
if _libs["libPyFd.so"].has("pthread_mutexattr_setpshared", "cdecl"):
    pthread_mutexattr_setpshared = _libs["libPyFd.so"].get("pthread_mutexattr_setpshared", "cdecl")
    pthread_mutexattr_setpshared.argtypes = [POINTER(pthread_mutexattr_t), c_int]
    pthread_mutexattr_setpshared.restype = c_int

# /usr/include/pthread.h: 820
if _libs["libPyFd.so"].has("pthread_mutexattr_gettype", "cdecl"):
    pthread_mutexattr_gettype = _libs["libPyFd.so"].get("pthread_mutexattr_gettype", "cdecl")
    pthread_mutexattr_gettype.argtypes = [POINTER(pthread_mutexattr_t), POINTER(c_int)]
    pthread_mutexattr_gettype.restype = c_int

# /usr/include/pthread.h: 827
if _libs["libPyFd.so"].has("pthread_mutexattr_settype", "cdecl"):
    pthread_mutexattr_settype = _libs["libPyFd.so"].get("pthread_mutexattr_settype", "cdecl")
    pthread_mutexattr_settype.argtypes = [POINTER(pthread_mutexattr_t), c_int]
    pthread_mutexattr_settype.restype = c_int

# /usr/include/pthread.h: 832
if _libs["libPyFd.so"].has("pthread_mutexattr_getprotocol", "cdecl"):
    pthread_mutexattr_getprotocol = _libs["libPyFd.so"].get("pthread_mutexattr_getprotocol", "cdecl")
    pthread_mutexattr_getprotocol.argtypes = [POINTER(pthread_mutexattr_t), POINTER(c_int)]
    pthread_mutexattr_getprotocol.restype = c_int

# /usr/include/pthread.h: 839
if _libs["libPyFd.so"].has("pthread_mutexattr_setprotocol", "cdecl"):
    pthread_mutexattr_setprotocol = _libs["libPyFd.so"].get("pthread_mutexattr_setprotocol", "cdecl")
    pthread_mutexattr_setprotocol.argtypes = [POINTER(pthread_mutexattr_t), c_int]
    pthread_mutexattr_setprotocol.restype = c_int

# /usr/include/pthread.h: 844
if _libs["libPyFd.so"].has("pthread_mutexattr_getprioceiling", "cdecl"):
    pthread_mutexattr_getprioceiling = _libs["libPyFd.so"].get("pthread_mutexattr_getprioceiling", "cdecl")
    pthread_mutexattr_getprioceiling.argtypes = [POINTER(pthread_mutexattr_t), POINTER(c_int)]
    pthread_mutexattr_getprioceiling.restype = c_int

# /usr/include/pthread.h: 850
if _libs["libPyFd.so"].has("pthread_mutexattr_setprioceiling", "cdecl"):
    pthread_mutexattr_setprioceiling = _libs["libPyFd.so"].get("pthread_mutexattr_setprioceiling", "cdecl")
    pthread_mutexattr_setprioceiling.argtypes = [POINTER(pthread_mutexattr_t), c_int]
    pthread_mutexattr_setprioceiling.restype = c_int

# /usr/include/pthread.h: 856
if _libs["libPyFd.so"].has("pthread_mutexattr_getrobust", "cdecl"):
    pthread_mutexattr_getrobust = _libs["libPyFd.so"].get("pthread_mutexattr_getrobust", "cdecl")
    pthread_mutexattr_getrobust.argtypes = [POINTER(pthread_mutexattr_t), POINTER(c_int)]
    pthread_mutexattr_getrobust.restype = c_int

# /usr/include/pthread.h: 866
if _libs["libPyFd.so"].has("pthread_mutexattr_setrobust", "cdecl"):
    pthread_mutexattr_setrobust = _libs["libPyFd.so"].get("pthread_mutexattr_setrobust", "cdecl")
    pthread_mutexattr_setrobust.argtypes = [POINTER(pthread_mutexattr_t), c_int]
    pthread_mutexattr_setrobust.restype = c_int

# /usr/include/pthread.h: 882
if _libs["libPyFd.so"].has("pthread_rwlock_init", "cdecl"):
    pthread_rwlock_init = _libs["libPyFd.so"].get("pthread_rwlock_init", "cdecl")
    pthread_rwlock_init.argtypes = [POINTER(pthread_rwlock_t), POINTER(pthread_rwlockattr_t)]
    pthread_rwlock_init.restype = c_int

# /usr/include/pthread.h: 887
if _libs["libPyFd.so"].has("pthread_rwlock_destroy", "cdecl"):
    pthread_rwlock_destroy = _libs["libPyFd.so"].get("pthread_rwlock_destroy", "cdecl")
    pthread_rwlock_destroy.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_destroy.restype = c_int

# /usr/include/pthread.h: 891
if _libs["libPyFd.so"].has("pthread_rwlock_rdlock", "cdecl"):
    pthread_rwlock_rdlock = _libs["libPyFd.so"].get("pthread_rwlock_rdlock", "cdecl")
    pthread_rwlock_rdlock.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_rdlock.restype = c_int

# /usr/include/pthread.h: 895
if _libs["libPyFd.so"].has("pthread_rwlock_tryrdlock", "cdecl"):
    pthread_rwlock_tryrdlock = _libs["libPyFd.so"].get("pthread_rwlock_tryrdlock", "cdecl")
    pthread_rwlock_tryrdlock.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_tryrdlock.restype = c_int

# /usr/include/pthread.h: 900
if _libs["libPyFd.so"].has("pthread_rwlock_timedrdlock", "cdecl"):
    pthread_rwlock_timedrdlock = _libs["libPyFd.so"].get("pthread_rwlock_timedrdlock", "cdecl")
    pthread_rwlock_timedrdlock.argtypes = [POINTER(pthread_rwlock_t), POINTER(struct_timespec)]
    pthread_rwlock_timedrdlock.restype = c_int

# /usr/include/pthread.h: 906
if _libs["libPyFd.so"].has("pthread_rwlock_wrlock", "cdecl"):
    pthread_rwlock_wrlock = _libs["libPyFd.so"].get("pthread_rwlock_wrlock", "cdecl")
    pthread_rwlock_wrlock.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_wrlock.restype = c_int

# /usr/include/pthread.h: 910
if _libs["libPyFd.so"].has("pthread_rwlock_trywrlock", "cdecl"):
    pthread_rwlock_trywrlock = _libs["libPyFd.so"].get("pthread_rwlock_trywrlock", "cdecl")
    pthread_rwlock_trywrlock.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_trywrlock.restype = c_int

# /usr/include/pthread.h: 915
if _libs["libPyFd.so"].has("pthread_rwlock_timedwrlock", "cdecl"):
    pthread_rwlock_timedwrlock = _libs["libPyFd.so"].get("pthread_rwlock_timedwrlock", "cdecl")
    pthread_rwlock_timedwrlock.argtypes = [POINTER(pthread_rwlock_t), POINTER(struct_timespec)]
    pthread_rwlock_timedwrlock.restype = c_int

# /usr/include/pthread.h: 921
if _libs["libPyFd.so"].has("pthread_rwlock_unlock", "cdecl"):
    pthread_rwlock_unlock = _libs["libPyFd.so"].get("pthread_rwlock_unlock", "cdecl")
    pthread_rwlock_unlock.argtypes = [POINTER(pthread_rwlock_t)]
    pthread_rwlock_unlock.restype = c_int

# /usr/include/pthread.h: 928
if _libs["libPyFd.so"].has("pthread_rwlockattr_init", "cdecl"):
    pthread_rwlockattr_init = _libs["libPyFd.so"].get("pthread_rwlockattr_init", "cdecl")
    pthread_rwlockattr_init.argtypes = [POINTER(pthread_rwlockattr_t)]
    pthread_rwlockattr_init.restype = c_int

# /usr/include/pthread.h: 932
if _libs["libPyFd.so"].has("pthread_rwlockattr_destroy", "cdecl"):
    pthread_rwlockattr_destroy = _libs["libPyFd.so"].get("pthread_rwlockattr_destroy", "cdecl")
    pthread_rwlockattr_destroy.argtypes = [POINTER(pthread_rwlockattr_t)]
    pthread_rwlockattr_destroy.restype = c_int

# /usr/include/pthread.h: 936
if _libs["libPyFd.so"].has("pthread_rwlockattr_getpshared", "cdecl"):
    pthread_rwlockattr_getpshared = _libs["libPyFd.so"].get("pthread_rwlockattr_getpshared", "cdecl")
    pthread_rwlockattr_getpshared.argtypes = [POINTER(pthread_rwlockattr_t), POINTER(c_int)]
    pthread_rwlockattr_getpshared.restype = c_int

# /usr/include/pthread.h: 942
if _libs["libPyFd.so"].has("pthread_rwlockattr_setpshared", "cdecl"):
    pthread_rwlockattr_setpshared = _libs["libPyFd.so"].get("pthread_rwlockattr_setpshared", "cdecl")
    pthread_rwlockattr_setpshared.argtypes = [POINTER(pthread_rwlockattr_t), c_int]
    pthread_rwlockattr_setpshared.restype = c_int

# /usr/include/pthread.h: 947
if _libs["libPyFd.so"].has("pthread_rwlockattr_getkind_np", "cdecl"):
    pthread_rwlockattr_getkind_np = _libs["libPyFd.so"].get("pthread_rwlockattr_getkind_np", "cdecl")
    pthread_rwlockattr_getkind_np.argtypes = [POINTER(pthread_rwlockattr_t), POINTER(c_int)]
    pthread_rwlockattr_getkind_np.restype = c_int

# /usr/include/pthread.h: 953
if _libs["libPyFd.so"].has("pthread_rwlockattr_setkind_np", "cdecl"):
    pthread_rwlockattr_setkind_np = _libs["libPyFd.so"].get("pthread_rwlockattr_setkind_np", "cdecl")
    pthread_rwlockattr_setkind_np.argtypes = [POINTER(pthread_rwlockattr_t), c_int]
    pthread_rwlockattr_setkind_np.restype = c_int

# /usr/include/pthread.h: 962
if _libs["libPyFd.so"].has("pthread_cond_init", "cdecl"):
    pthread_cond_init = _libs["libPyFd.so"].get("pthread_cond_init", "cdecl")
    pthread_cond_init.argtypes = [POINTER(pthread_cond_t), POINTER(pthread_condattr_t)]
    pthread_cond_init.restype = c_int

# /usr/include/pthread.h: 967
if _libs["libPyFd.so"].has("pthread_cond_destroy", "cdecl"):
    pthread_cond_destroy = _libs["libPyFd.so"].get("pthread_cond_destroy", "cdecl")
    pthread_cond_destroy.argtypes = [POINTER(pthread_cond_t)]
    pthread_cond_destroy.restype = c_int

# /usr/include/pthread.h: 971
if _libs["libPyFd.so"].has("pthread_cond_signal", "cdecl"):
    pthread_cond_signal = _libs["libPyFd.so"].get("pthread_cond_signal", "cdecl")
    pthread_cond_signal.argtypes = [POINTER(pthread_cond_t)]
    pthread_cond_signal.restype = c_int

# /usr/include/pthread.h: 975
if _libs["libPyFd.so"].has("pthread_cond_broadcast", "cdecl"):
    pthread_cond_broadcast = _libs["libPyFd.so"].get("pthread_cond_broadcast", "cdecl")
    pthread_cond_broadcast.argtypes = [POINTER(pthread_cond_t)]
    pthread_cond_broadcast.restype = c_int

# /usr/include/pthread.h: 983
if _libs["libPyFd.so"].has("pthread_cond_wait", "cdecl"):
    pthread_cond_wait = _libs["libPyFd.so"].get("pthread_cond_wait", "cdecl")
    pthread_cond_wait.argtypes = [POINTER(pthread_cond_t), POINTER(pthread_mutex_t)]
    pthread_cond_wait.restype = c_int

# /usr/include/pthread.h: 994
if _libs["libPyFd.so"].has("pthread_cond_timedwait", "cdecl"):
    pthread_cond_timedwait = _libs["libPyFd.so"].get("pthread_cond_timedwait", "cdecl")
    pthread_cond_timedwait.argtypes = [POINTER(pthread_cond_t), POINTER(pthread_mutex_t), POINTER(struct_timespec)]
    pthread_cond_timedwait.restype = c_int

# /usr/include/pthread.h: 1002
if _libs["libPyFd.so"].has("pthread_condattr_init", "cdecl"):
    pthread_condattr_init = _libs["libPyFd.so"].get("pthread_condattr_init", "cdecl")
    pthread_condattr_init.argtypes = [POINTER(pthread_condattr_t)]
    pthread_condattr_init.restype = c_int

# /usr/include/pthread.h: 1006
if _libs["libPyFd.so"].has("pthread_condattr_destroy", "cdecl"):
    pthread_condattr_destroy = _libs["libPyFd.so"].get("pthread_condattr_destroy", "cdecl")
    pthread_condattr_destroy.argtypes = [POINTER(pthread_condattr_t)]
    pthread_condattr_destroy.restype = c_int

# /usr/include/pthread.h: 1010
if _libs["libPyFd.so"].has("pthread_condattr_getpshared", "cdecl"):
    pthread_condattr_getpshared = _libs["libPyFd.so"].get("pthread_condattr_getpshared", "cdecl")
    pthread_condattr_getpshared.argtypes = [POINTER(pthread_condattr_t), POINTER(c_int)]
    pthread_condattr_getpshared.restype = c_int

# /usr/include/pthread.h: 1016
if _libs["libPyFd.so"].has("pthread_condattr_setpshared", "cdecl"):
    pthread_condattr_setpshared = _libs["libPyFd.so"].get("pthread_condattr_setpshared", "cdecl")
    pthread_condattr_setpshared.argtypes = [POINTER(pthread_condattr_t), c_int]
    pthread_condattr_setpshared.restype = c_int

# /usr/include/pthread.h: 1021
if _libs["libPyFd.so"].has("pthread_condattr_getclock", "cdecl"):
    pthread_condattr_getclock = _libs["libPyFd.so"].get("pthread_condattr_getclock", "cdecl")
    pthread_condattr_getclock.argtypes = [POINTER(pthread_condattr_t), POINTER(__clockid_t)]
    pthread_condattr_getclock.restype = c_int

# /usr/include/pthread.h: 1027
if _libs["libPyFd.so"].has("pthread_condattr_setclock", "cdecl"):
    pthread_condattr_setclock = _libs["libPyFd.so"].get("pthread_condattr_setclock", "cdecl")
    pthread_condattr_setclock.argtypes = [POINTER(pthread_condattr_t), __clockid_t]
    pthread_condattr_setclock.restype = c_int

# /usr/include/pthread.h: 1038
if _libs["libPyFd.so"].has("pthread_spin_init", "cdecl"):
    pthread_spin_init = _libs["libPyFd.so"].get("pthread_spin_init", "cdecl")
    pthread_spin_init.argtypes = [POINTER(pthread_spinlock_t), c_int]
    pthread_spin_init.restype = c_int

# /usr/include/pthread.h: 1042
if _libs["libPyFd.so"].has("pthread_spin_destroy", "cdecl"):
    pthread_spin_destroy = _libs["libPyFd.so"].get("pthread_spin_destroy", "cdecl")
    pthread_spin_destroy.argtypes = [POINTER(pthread_spinlock_t)]
    pthread_spin_destroy.restype = c_int

# /usr/include/pthread.h: 1046
if _libs["libPyFd.so"].has("pthread_spin_lock", "cdecl"):
    pthread_spin_lock = _libs["libPyFd.so"].get("pthread_spin_lock", "cdecl")
    pthread_spin_lock.argtypes = [POINTER(pthread_spinlock_t)]
    pthread_spin_lock.restype = c_int

# /usr/include/pthread.h: 1050
if _libs["libPyFd.so"].has("pthread_spin_trylock", "cdecl"):
    pthread_spin_trylock = _libs["libPyFd.so"].get("pthread_spin_trylock", "cdecl")
    pthread_spin_trylock.argtypes = [POINTER(pthread_spinlock_t)]
    pthread_spin_trylock.restype = c_int

# /usr/include/pthread.h: 1054
if _libs["libPyFd.so"].has("pthread_spin_unlock", "cdecl"):
    pthread_spin_unlock = _libs["libPyFd.so"].get("pthread_spin_unlock", "cdecl")
    pthread_spin_unlock.argtypes = [POINTER(pthread_spinlock_t)]
    pthread_spin_unlock.restype = c_int

# /usr/include/pthread.h: 1062
if _libs["libPyFd.so"].has("pthread_barrier_init", "cdecl"):
    pthread_barrier_init = _libs["libPyFd.so"].get("pthread_barrier_init", "cdecl")
    pthread_barrier_init.argtypes = [POINTER(pthread_barrier_t), POINTER(pthread_barrierattr_t), c_uint]
    pthread_barrier_init.restype = c_int

# /usr/include/pthread.h: 1068
if _libs["libPyFd.so"].has("pthread_barrier_destroy", "cdecl"):
    pthread_barrier_destroy = _libs["libPyFd.so"].get("pthread_barrier_destroy", "cdecl")
    pthread_barrier_destroy.argtypes = [POINTER(pthread_barrier_t)]
    pthread_barrier_destroy.restype = c_int

# /usr/include/pthread.h: 1072
if _libs["libPyFd.so"].has("pthread_barrier_wait", "cdecl"):
    pthread_barrier_wait = _libs["libPyFd.so"].get("pthread_barrier_wait", "cdecl")
    pthread_barrier_wait.argtypes = [POINTER(pthread_barrier_t)]
    pthread_barrier_wait.restype = c_int

# /usr/include/pthread.h: 1077
if _libs["libPyFd.so"].has("pthread_barrierattr_init", "cdecl"):
    pthread_barrierattr_init = _libs["libPyFd.so"].get("pthread_barrierattr_init", "cdecl")
    pthread_barrierattr_init.argtypes = [POINTER(pthread_barrierattr_t)]
    pthread_barrierattr_init.restype = c_int

# /usr/include/pthread.h: 1081
if _libs["libPyFd.so"].has("pthread_barrierattr_destroy", "cdecl"):
    pthread_barrierattr_destroy = _libs["libPyFd.so"].get("pthread_barrierattr_destroy", "cdecl")
    pthread_barrierattr_destroy.argtypes = [POINTER(pthread_barrierattr_t)]
    pthread_barrierattr_destroy.restype = c_int

# /usr/include/pthread.h: 1085
if _libs["libPyFd.so"].has("pthread_barrierattr_getpshared", "cdecl"):
    pthread_barrierattr_getpshared = _libs["libPyFd.so"].get("pthread_barrierattr_getpshared", "cdecl")
    pthread_barrierattr_getpshared.argtypes = [POINTER(pthread_barrierattr_t), POINTER(c_int)]
    pthread_barrierattr_getpshared.restype = c_int

# /usr/include/pthread.h: 1091
if _libs["libPyFd.so"].has("pthread_barrierattr_setpshared", "cdecl"):
    pthread_barrierattr_setpshared = _libs["libPyFd.so"].get("pthread_barrierattr_setpshared", "cdecl")
    pthread_barrierattr_setpshared.argtypes = [POINTER(pthread_barrierattr_t), c_int]
    pthread_barrierattr_setpshared.restype = c_int

# /usr/include/pthread.h: 1105
if _libs["libPyFd.so"].has("pthread_key_create", "cdecl"):
    pthread_key_create = _libs["libPyFd.so"].get("pthread_key_create", "cdecl")
    pthread_key_create.argtypes = [POINTER(pthread_key_t), CFUNCTYPE(UNCHECKED(None), POINTER(None))]
    pthread_key_create.restype = c_int

# /usr/include/pthread.h: 1110
if _libs["libPyFd.so"].has("pthread_key_delete", "cdecl"):
    pthread_key_delete = _libs["libPyFd.so"].get("pthread_key_delete", "cdecl")
    pthread_key_delete.argtypes = [pthread_key_t]
    pthread_key_delete.restype = c_int

# /usr/include/pthread.h: 1113
if _libs["libPyFd.so"].has("pthread_getspecific", "cdecl"):
    pthread_getspecific = _libs["libPyFd.so"].get("pthread_getspecific", "cdecl")
    pthread_getspecific.argtypes = [pthread_key_t]
    pthread_getspecific.restype = POINTER(c_ubyte)
    pthread_getspecific.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/pthread.h: 1116
if _libs["libPyFd.so"].has("pthread_setspecific", "cdecl"):
    pthread_setspecific = _libs["libPyFd.so"].get("pthread_setspecific", "cdecl")
    pthread_setspecific.argtypes = [pthread_key_t, POINTER(None)]
    pthread_setspecific.restype = c_int

# /usr/include/pthread.h: 1122
if _libs["libPyFd.so"].has("pthread_getcpuclockid", "cdecl"):
    pthread_getcpuclockid = _libs["libPyFd.so"].get("pthread_getcpuclockid", "cdecl")
    pthread_getcpuclockid.argtypes = [pthread_t, POINTER(__clockid_t)]
    pthread_getcpuclockid.restype = c_int

# /usr/include/pthread.h: 1139
for _lib in _libs.values():
    if not _lib.has("pthread_atfork", "cdecl"):
        continue
    pthread_atfork = _lib.get("pthread_atfork", "cdecl")
    pthread_atfork.argtypes = [CFUNCTYPE(UNCHECKED(None), ), CFUNCTYPE(UNCHECKED(None), ), CFUNCTYPE(UNCHECKED(None), )]
    pthread_atfork.restype = c_int
    break

CbfHPrinter_t = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cfg/v9r0/src/CbfHash.h: 41

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 43
class struct_CbfHEntry(Structure):
    pass

struct_CbfHEntry.__slots__ = [
    'key',
    'data',
    'next',
]
struct_CbfHEntry._fields_ = [
    ('key', String),
    ('data', String),
    ('next', POINTER(struct_CbfHEntry)),
]

CbfHEntry_t = struct_CbfHEntry# /virgoApp/Cfg/v9r0/src/CbfHash.h: 47

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 53
class struct_CbfH(Structure):
    pass

struct_CbfH.__slots__ = [
    'entry',
    'nElem',
    'mutex',
]
struct_CbfH._fields_ = [
    ('entry', POINTER(POINTER(CbfHEntry_t))),
    ('nElem', c_int),
    ('mutex', pthread_mutex_t),
]

CbfH_t = struct_CbfH# /virgoApp/Cfg/v9r0/src/CbfHash.h: 53

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 55
if _libs["libPyFd.so"].has("CbfHEnter", "cdecl"):
    CbfHEnter = _libs["libPyFd.so"].get("CbfHEnter", "cdecl")
    CbfHEnter.argtypes = [POINTER(CbfH_t), String, POINTER(None)]
    CbfHEnter.restype = POINTER(CbfHEntry_t)

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 57
if _libs["libPyFd.so"].has("CbfHEntryRemove", "cdecl"):
    CbfHEntryRemove = _libs["libPyFd.so"].get("CbfHEntryRemove", "cdecl")
    CbfHEntryRemove.argtypes = [POINTER(CbfHEntry_t)]
    CbfHEntryRemove.restype = None

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 58
if _libs["libPyFd.so"].has("CbfHFind", "cdecl"):
    CbfHFind = _libs["libPyFd.so"].get("CbfHFind", "cdecl")
    CbfHFind.argtypes = [POINTER(CbfH_t), String]
    CbfHFind.restype = POINTER(CbfHEntry_t)

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 60
if _libs["libPyFd.so"].has("CbfHFree", "cdecl"):
    CbfHFree = _libs["libPyFd.so"].get("CbfHFree", "cdecl")
    CbfHFree.argtypes = [POINTER(CbfH_t)]
    CbfHFree.restype = POINTER(CbfH_t)

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 61
if _libs["libPyFd.so"].has("CbfHInstallPrinter", "cdecl"):
    CbfHInstallPrinter = _libs["libPyFd.so"].get("CbfHInstallPrinter", "cdecl")
    CbfHInstallPrinter.argtypes = [CbfHPrinter_t]
    CbfHInstallPrinter.restype = CbfHPrinter_t

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 62
if _libs["libPyFd.so"].has("CbfHNew", "cdecl"):
    CbfHNew = _libs["libPyFd.so"].get("CbfHNew", "cdecl")
    CbfHNew.argtypes = [c_int]
    CbfHNew.restype = POINTER(CbfH_t)

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 63
if _libs["libPyFd.so"].has("_CbfHPrint", "cdecl"):
    _CbfHPrint = _libs["libPyFd.so"].get("_CbfHPrint", "cdecl")
    _CbfHPrint.argtypes = [POINTER(CbfH_t), String]
    _CbfHPrint.restype = None

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 64
if _libs["libPyFd.so"].has("CbfHPrint", "cdecl"):
    CbfHPrint = _libs["libPyFd.so"].get("CbfHPrint", "cdecl")
    CbfHPrint.argtypes = [POINTER(CbfH_t)]
    CbfHPrint.restype = None

CbfCleanFnt_t = CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), POINTER(None))# /virgoApp/Cfg/v9r0/src/CbfClean.h: 38

CbfCleanExitFnt_t = CFUNCTYPE(UNCHECKED(None), )# /virgoApp/Cfg/v9r0/src/CbfClean.h: 39

CbfCleanPrinter_t = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cfg/v9r0/src/CbfClean.h: 40

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 51
class struct_CbfClean(Structure):
    pass

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 42
class struct_CbfCleanChain(Structure):
    pass

struct_CbfCleanChain.__slots__ = [
    'name',
    'function',
    'arg',
    'loop',
    'cleanRef',
    'next',
]
struct_CbfCleanChain._fields_ = [
    ('name', c_char * int(128)),
    ('function', CbfCleanFnt_t),
    ('arg', POINTER(None)),
    ('loop', c_int),
    ('cleanRef', POINTER(struct_CbfClean)),
    ('next', POINTER(struct_CbfCleanChain)),
]

CbfCleanChain_t = struct_CbfCleanChain# /virgoApp/Cfg/v9r0/src/CbfClean.h: 49

struct_CbfClean.__slots__ = [
    'chain',
    'name',
    'mutex',
]
struct_CbfClean._fields_ = [
    ('chain', POINTER(CbfCleanChain_t)),
    ('name', c_char * int(128)),
    ('mutex', pthread_mutex_t),
]

CbfClean_t = struct_CbfClean# /virgoApp/Cfg/v9r0/src/CbfClean.h: 55

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 58
if _libs["libPyFd.so"].has("CbfCleanAdd", "cdecl"):
    CbfCleanAdd = _libs["libPyFd.so"].get("CbfCleanAdd", "cdecl")
    CbfCleanAdd.argtypes = [POINTER(CbfClean_t), String, CbfCleanFnt_t, POINTER(None)]
    CbfCleanAdd.restype = POINTER(CbfCleanChain_t)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 62
if _libs["libPyFd.so"].has("CbfCleanDone", "cdecl"):
    CbfCleanDone = _libs["libPyFd.so"].get("CbfCleanDone", "cdecl")
    CbfCleanDone.argtypes = [String, POINTER(None)]
    CbfCleanDone.restype = c_int

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 63
if _libs["libPyFd.so"].has("CbfCleanFind", "cdecl"):
    CbfCleanFind = _libs["libPyFd.so"].get("CbfCleanFind", "cdecl")
    CbfCleanFind.argtypes = [String, POINTER(None)]
    CbfCleanFind.restype = POINTER(CbfCleanChain_t)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 64
if _libs["libPyFd.so"].has("CbfCleanFree", "cdecl"):
    CbfCleanFree = _libs["libPyFd.so"].get("CbfCleanFree", "cdecl")
    CbfCleanFree.argtypes = [POINTER(CbfClean_t)]
    CbfCleanFree.restype = POINTER(CbfClean_t)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 65
if _libs["libPyFd.so"].has("CbfCleanFreeTag", "cdecl"):
    CbfCleanFreeTag = _libs["libPyFd.so"].get("CbfCleanFreeTag", "cdecl")
    CbfCleanFreeTag.argtypes = [String, POINTER(None)]
    CbfCleanFreeTag.restype = POINTER(CbfClean_t)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 66
if _libs["libPyFd.so"].has("CbfCleanInstallPrinter", "cdecl"):
    CbfCleanInstallPrinter = _libs["libPyFd.so"].get("CbfCleanInstallPrinter", "cdecl")
    CbfCleanInstallPrinter.argtypes = [CbfCleanPrinter_t]
    CbfCleanInstallPrinter.restype = CbfCleanPrinter_t

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 67
if _libs["libPyFd.so"].has("CbfCleanNew", "cdecl"):
    CbfCleanNew = _libs["libPyFd.so"].get("CbfCleanNew", "cdecl")
    CbfCleanNew.argtypes = [String]
    CbfCleanNew.restype = POINTER(CbfClean_t)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 68
if _libs["libPyFd.so"].has("CbfCleanPrint", "cdecl"):
    _func = _libs["libPyFd.so"].get("CbfCleanPrint", "cdecl")
    _restype = None
    _errcheck = None
    _argtypes = [POINTER(CbfClean_t), String]
    CbfCleanPrint = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 69
if _libs["libPyFd.so"].has("CbfCleanSetDebug", "cdecl"):
    CbfCleanSetDebug = _libs["libPyFd.so"].get("CbfCleanSetDebug", "cdecl")
    CbfCleanSetDebug.argtypes = [c_int, String]
    CbfCleanSetDebug.restype = None

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 70
if _libs["libPyFd.so"].has("CbfCleanSetExitFnt", "cdecl"):
    CbfCleanSetExitFnt = _libs["libPyFd.so"].get("CbfCleanSetExitFnt", "cdecl")
    CbfCleanSetExitFnt.argtypes = [CbfCleanExitFnt_t]
    CbfCleanSetExitFnt.restype = CbfCleanExitFnt_t

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 71
if _libs["libPyFd.so"].has("CbfCleanFinished", "cdecl"):
    CbfCleanFinished = _libs["libPyFd.so"].get("CbfCleanFinished", "cdecl")
    CbfCleanFinished.argtypes = []
    CbfCleanFinished.restype = c_int

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 72
if _libs["libPyFd.so"].has("CbfTerminate", "cdecl"):
    CbfTerminate = _libs["libPyFd.so"].get("CbfTerminate", "cdecl")
    CbfTerminate.argtypes = []
    CbfTerminate.restype = None

Ulong = c_ulong# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 48

enum_CfgBool = c_int# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 54

CfgFalse = 0# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 54

CfgTrue = (CfgFalse + 1)# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 54

CfgUnknown = (CfgTrue + 1)# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 54

CfgBool_t = enum_CfgBool# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 54

CfgNameSortFnc_t = CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(None))# /virgoApp/Cfg/v9r0/src/CfgList.h: 43

CfgNameFreeFnc_t = CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), POINTER(None))# /virgoApp/Cfg/v9r0/src/CfgList.h: 44

enum_CfgNameSort = c_int# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_SORT_FIRST = (-3)# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_DSORT_DDATA = (-3)# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_DSORT_IDATA = (-2)# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_DSORT_NAME = (-1)# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_NO_SORT = 0# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_ASORT_NAME = 1# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_ASORT_IDATA = 2# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_ASORT_DDATA = 3# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CFG_NAME_SORT_LAST = 3# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

CfgNameSort_t = enum_CfgNameSort# /virgoApp/Cfg/v9r0/src/CfgList.h: 56

# /virgoApp/Cfg/v9r0/src/CfgList.h: 70
class struct_CfgName(Structure):
    pass

struct_CfgName.__slots__ = [
    'name',
    'overwrites',
    'vData',
    'iData',
    'dData',
]
struct_CfgName._fields_ = [
    ('name', String),
    ('overwrites', c_int),
    ('vData', POINTER(None)),
    ('iData', c_long),
    ('dData', c_double),
]

CfgName_t = struct_CfgName# /virgoApp/Cfg/v9r0/src/CfgList.h: 70

# /virgoApp/Cfg/v9r0/src/CfgList.h: 77
class struct_CfgNameList(Structure):
    pass

struct_CfgNameList.__slots__ = [
    'size',
    'list',
    'sort',
    'freeFnc',
]
struct_CfgNameList._fields_ = [
    ('size', c_int),
    ('list', POINTER(CfgName_t)),
    ('sort', CfgNameSort_t),
    ('freeFnc', CfgNameFreeFnc_t),
]

CfgNameList_t = struct_CfgNameList# /virgoApp/Cfg/v9r0/src/CfgList.h: 77

# /virgoApp/Cfg/v9r0/src/CfgList.h: 96
if _libs["libPyFd.so"].has("CfgNameListNew", "cdecl"):
    CfgNameListNew = _libs["libPyFd.so"].get("CfgNameListNew", "cdecl")
    CfgNameListNew.argtypes = []
    CfgNameListNew.restype = POINTER(CfgNameList_t)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 97
if _libs["libPyFd.so"].has("CfgNameListInit", "cdecl"):
    CfgNameListInit = _libs["libPyFd.so"].get("CfgNameListInit", "cdecl")
    CfgNameListInit.argtypes = [POINTER(CfgNameList_t)]
    CfgNameListInit.restype = POINTER(CfgNameList_t)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 98
if _libs["libPyFd.so"].has("CfgNameListDone", "cdecl"):
    CfgNameListDone = _libs["libPyFd.so"].get("CfgNameListDone", "cdecl")
    CfgNameListDone.argtypes = [POINTER(CfgNameList_t)]
    CfgNameListDone.restype = POINTER(CfgNameList_t)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 99
if _libs["libPyFd.so"].has("CfgNameListFree", "cdecl"):
    CfgNameListFree = _libs["libPyFd.so"].get("CfgNameListFree", "cdecl")
    CfgNameListFree.argtypes = [POINTER(CfgNameList_t)]
    CfgNameListFree.restype = POINTER(CfgNameList_t)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 100
if _libs["libPyFd.so"].has("CfgNameListSetFreeFnc", "cdecl"):
    CfgNameListSetFreeFnc = _libs["libPyFd.so"].get("CfgNameListSetFreeFnc", "cdecl")
    CfgNameListSetFreeFnc.argtypes = [POINTER(CfgNameList_t), CfgNameFreeFnc_t]
    CfgNameListSetFreeFnc.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 101
if _libs["libPyFd.so"].has("CfgNameListSetSortOption", "cdecl"):
    CfgNameListSetSortOption = _libs["libPyFd.so"].get("CfgNameListSetSortOption", "cdecl")
    CfgNameListSetSortOption.argtypes = [POINTER(CfgNameList_t), c_int]
    CfgNameListSetSortOption.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 103
if _libs["libPyFd.so"].has("CfgNameListAdd", "cdecl"):
    CfgNameListAdd = _libs["libPyFd.so"].get("CfgNameListAdd", "cdecl")
    CfgNameListAdd.argtypes = [POINTER(CfgNameList_t), String]
    CfgNameListAdd.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 104
if _libs["libPyFd.so"].has("CfgNameListAddInt", "cdecl"):
    CfgNameListAddInt = _libs["libPyFd.so"].get("CfgNameListAddInt", "cdecl")
    CfgNameListAddInt.argtypes = [POINTER(CfgNameList_t), String, c_int]
    CfgNameListAddInt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 105
if _libs["libPyFd.so"].has("CfgNameListAddDouble", "cdecl"):
    CfgNameListAddDouble = _libs["libPyFd.so"].get("CfgNameListAddDouble", "cdecl")
    CfgNameListAddDouble.argtypes = [POINTER(CfgNameList_t), String, c_double]
    CfgNameListAddDouble.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 106
if _libs["libPyFd.so"].has("CfgNameListSetName", "cdecl"):
    CfgNameListSetName = _libs["libPyFd.so"].get("CfgNameListSetName", "cdecl")
    CfgNameListSetName.argtypes = [POINTER(CfgNameList_t), c_int, String]
    CfgNameListSetName.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 107
if _libs["libPyFd.so"].has("CfgNameListSetData", "cdecl"):
    CfgNameListSetData = _libs["libPyFd.so"].get("CfgNameListSetData", "cdecl")
    CfgNameListSetData.argtypes = [POINTER(CfgNameList_t), c_int, POINTER(None)]
    CfgNameListSetData.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 108
if _libs["libPyFd.so"].has("CfgNameListSetInt", "cdecl"):
    CfgNameListSetInt = _libs["libPyFd.so"].get("CfgNameListSetInt", "cdecl")
    CfgNameListSetInt.argtypes = [POINTER(CfgNameList_t), c_int, c_int]
    CfgNameListSetInt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 109
if _libs["libPyFd.so"].has("CfgNameListSetDouble", "cdecl"):
    CfgNameListSetDouble = _libs["libPyFd.so"].get("CfgNameListSetDouble", "cdecl")
    CfgNameListSetDouble.argtypes = [POINTER(CfgNameList_t), c_int, c_double]
    CfgNameListSetDouble.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 111
if _libs["libPyFd.so"].has("CfgNameListNRemove", "cdecl"):
    CfgNameListNRemove = _libs["libPyFd.so"].get("CfgNameListNRemove", "cdecl")
    CfgNameListNRemove.argtypes = [POINTER(CfgNameList_t), c_int]
    CfgNameListNRemove.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 112
if _libs["libPyFd.so"].has("CfgNameListRemoveName", "cdecl"):
    CfgNameListRemoveName = _libs["libPyFd.so"].get("CfgNameListRemoveName", "cdecl")
    CfgNameListRemoveName.argtypes = [POINTER(CfgNameList_t), String]
    CfgNameListRemoveName.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 113
if _libs["libPyFd.so"].has("CfgNameListRemoveData", "cdecl"):
    CfgNameListRemoveData = _libs["libPyFd.so"].get("CfgNameListRemoveData", "cdecl")
    CfgNameListRemoveData.argtypes = [POINTER(CfgNameList_t), POINTER(None)]
    CfgNameListRemoveData.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 114
if _libs["libPyFd.so"].has("CfgNameListRemoveInt", "cdecl"):
    CfgNameListRemoveInt = _libs["libPyFd.so"].get("CfgNameListRemoveInt", "cdecl")
    CfgNameListRemoveInt.argtypes = [POINTER(CfgNameList_t), c_int]
    CfgNameListRemoveInt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 115
if _libs["libPyFd.so"].has("CfgNameListRemoveDouble", "cdecl"):
    CfgNameListRemoveDouble = _libs["libPyFd.so"].get("CfgNameListRemoveDouble", "cdecl")
    CfgNameListRemoveDouble.argtypes = [POINTER(CfgNameList_t), c_double]
    CfgNameListRemoveDouble.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 120
if _libs["libPyFd.so"].has("CfgNameListSort", "cdecl"):
    CfgNameListSort = _libs["libPyFd.so"].get("CfgNameListSort", "cdecl")
    CfgNameListSort.argtypes = [POINTER(CfgNameList_t), c_int]
    CfgNameListSort.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 121
if _libs["libPyFd.so"].has("CfgNameListSearchName", "cdecl"):
    CfgNameListSearchName = _libs["libPyFd.so"].get("CfgNameListSearchName", "cdecl")
    CfgNameListSearchName.argtypes = [POINTER(CfgNameList_t), String]
    CfgNameListSearchName.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 122
if _libs["libPyFd.so"].has("CfgNameListSearchData", "cdecl"):
    CfgNameListSearchData = _libs["libPyFd.so"].get("CfgNameListSearchData", "cdecl")
    CfgNameListSearchData.argtypes = [POINTER(CfgNameList_t), POINTER(None)]
    CfgNameListSearchData.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 123
if _libs["libPyFd.so"].has("CfgNameListSearchInt", "cdecl"):
    CfgNameListSearchInt = _libs["libPyFd.so"].get("CfgNameListSearchInt", "cdecl")
    CfgNameListSearchInt.argtypes = [POINTER(CfgNameList_t), c_int]
    CfgNameListSearchInt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgList.h: 124
if _libs["libPyFd.so"].has("CfgNameListSearchDouble", "cdecl"):
    CfgNameListSearchDouble = _libs["libPyFd.so"].get("CfgNameListSearchDouble", "cdecl")
    CfgNameListSearchDouble.argtypes = [POINTER(CfgNameList_t), c_double]
    CfgNameListSearchDouble.restype = c_int

enum_anon_27 = c_int# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_INFO = 0# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_WARNING = 1# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_ERROR = 2# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_FATAL = 3# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_USER_INFO = 4# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CFG_MSGLVL_MAX = (CFG_USER_INFO + 1)# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CfgMsgLvl_t = enum_anon_27# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 47

CfgMsgPrinter_t = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 50

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 51
if _libs["libPyFd.so"].has("CfgMsgInstallPrinter", "cdecl"):
    CfgMsgInstallPrinter = _libs["libPyFd.so"].get("CfgMsgInstallPrinter", "cdecl")
    CfgMsgInstallPrinter.argtypes = [CfgMsgPrinter_t]
    CfgMsgInstallPrinter.restype = CfgMsgPrinter_t

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 54
class struct_CfgMsg(Structure):
    pass

CfgMsg_t = struct_CfgMsg# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 54

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 55
if _libs["libPyFd.so"].has("CfgMsgGetCount", "cdecl"):
    CfgMsgGetCount = _libs["libPyFd.so"].get("CfgMsgGetCount", "cdecl")
    CfgMsgGetCount.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgGetCount.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 56
if _libs["libPyFd.so"].has("CfgMsgGetLevel", "cdecl"):
    CfgMsgGetLevel = _libs["libPyFd.so"].get("CfgMsgGetLevel", "cdecl")
    CfgMsgGetLevel.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgGetLevel.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 57
if _libs["libPyFd.so"].has("CfgMsgGetLevelStr", "cdecl"):
    CfgMsgGetLevelStr = _libs["libPyFd.so"].get("CfgMsgGetLevelStr", "cdecl")
    CfgMsgGetLevelStr.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgGetLevelStr.restype = c_char_p

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 58
if _libs["libPyFd.so"].has("CfgMsgGetTimeStamp", "cdecl"):
    CfgMsgGetTimeStamp = _libs["libPyFd.so"].get("CfgMsgGetTimeStamp", "cdecl")
    CfgMsgGetTimeStamp.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgGetTimeStamp.restype = time_t

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 59
if _libs["libPyFd.so"].has("CfgMsgGetTimeStampTm", "cdecl"):
    CfgMsgGetTimeStampTm = _libs["libPyFd.so"].get("CfgMsgGetTimeStampTm", "cdecl")
    CfgMsgGetTimeStampTm.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgGetTimeStampTm.restype = POINTER(struct_tm)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 60
if _libs["libPyFd.so"].has("CfgMsgGetTxt", "cdecl"):
    CfgMsgGetTxt = _libs["libPyFd.so"].get("CfgMsgGetTxt", "cdecl")
    CfgMsgGetTxt.argtypes = [POINTER(CfgMsg_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgMsgGetTxt.restype = ReturnString
    else:
        CfgMsgGetTxt.restype = String
        CfgMsgGetTxt.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 61
if _libs["libPyFd.so"].has("CfgMsgFree", "cdecl"):
    CfgMsgFree = _libs["libPyFd.so"].get("CfgMsgFree", "cdecl")
    CfgMsgFree.argtypes = [POINTER(CfgMsg_t)]
    CfgMsgFree.restype = POINTER(CfgMsg_t)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 62
if _libs["libPyFd.so"].has("CfgMsgNew", "cdecl"):
    CfgMsgNew = _libs["libPyFd.so"].get("CfgMsgNew", "cdecl")
    CfgMsgNew.argtypes = [c_int, String]
    CfgMsgNew.restype = POINTER(CfgMsg_t)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 63
if _libs["libPyFd.so"].has("CfgMsgNewArgs", "cdecl"):
    CfgMsgNewArgs = _libs["libPyFd.so"].get("CfgMsgNewArgs", "cdecl")
    CfgMsgNewArgs.argtypes = [c_int, String, c_void_p]
    CfgMsgNewArgs.restype = POINTER(CfgMsg_t)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 64
if _libs["libPyFd.so"].has("CfgMsgNewFmt", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgNewFmt", "cdecl")
    _restype = POINTER(CfgMsg_t)
    _errcheck = None
    _argtypes = [c_int, String]
    CfgMsgNewFmt = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 66
if _libs["libPyFd.so"].has("CfgMsgPrintv", "cdecl"):
    CfgMsgPrintv = _libs["libPyFd.so"].get("CfgMsgPrintv", "cdecl")
    CfgMsgPrintv.argtypes = [c_int, String, c_void_p]
    CfgMsgPrintv.restype = None

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 68
class struct_CfgMsgR(Structure):
    pass

CfgMsgR_t = struct_CfgMsgR# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 68

CfgMsgSendFnt_t = CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(CfgMsg_t))# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 69

CfgMsgFnt_t = CFUNCTYPE(UNCHECKED(c_int), POINTER(None))# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 70

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 72
if _libs["libPyFd.so"].has("CfgMsgRAddFnt", "cdecl"):
    CfgMsgRAddFnt = _libs["libPyFd.so"].get("CfgMsgRAddFnt", "cdecl")
    CfgMsgRAddFnt.argtypes = [POINTER(CfgMsgR_t), POINTER(CfgMsgSendFnt_t), POINTER(None), POINTER(CfgMsgFnt_t), POINTER(CfgMsgFnt_t)]
    CfgMsgRAddFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 74
if _libs["libPyFd.so"].has("CfgMsgRAddMsg", "cdecl"):
    CfgMsgRAddMsg = _libs["libPyFd.so"].get("CfgMsgRAddMsg", "cdecl")
    CfgMsgRAddMsg.argtypes = [POINTER(CfgMsgR_t), POINTER(CfgMsg_t)]
    CfgMsgRAddMsg.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 75
if _libs["libPyFd.so"].has("CfgMsgRAddMsgTag", "cdecl"):
    CfgMsgRAddMsgTag = _libs["libPyFd.so"].get("CfgMsgRAddMsgTag", "cdecl")
    CfgMsgRAddMsgTag.argtypes = [POINTER(CfgMsgR_t), POINTER(CfgMsg_t), String]
    CfgMsgRAddMsgTag.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 76
if _libs["libPyFd.so"].has("CfgMsgRFree", "cdecl"):
    CfgMsgRFree = _libs["libPyFd.so"].get("CfgMsgRFree", "cdecl")
    CfgMsgRFree.argtypes = [POINTER(CfgMsgR_t)]
    CfgMsgRFree.restype = POINTER(CfgMsgR_t)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 77
if _libs["libPyFd.so"].has("CfgMsgRNew", "cdecl"):
    CfgMsgRNew = _libs["libPyFd.so"].get("CfgMsgRNew", "cdecl")
    CfgMsgRNew.argtypes = [c_int]
    CfgMsgRNew.restype = POINTER(CfgMsgR_t)

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 78
if _libs["libPyFd.so"].has("CfgMsgRRmFnt", "cdecl"):
    CfgMsgRRmFnt = _libs["libPyFd.so"].get("CfgMsgRRmFnt", "cdecl")
    CfgMsgRRmFnt.argtypes = [POINTER(CfgMsgR_t), POINTER(CfgMsgSendFnt_t), POINTER(None), POINTER(CfgMsgFnt_t), POINTER(CfgMsgFnt_t)]
    CfgMsgRRmFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 80
if _libs["libPyFd.so"].has("CfgMsgRSend", "cdecl"):
    CfgMsgRSend = _libs["libPyFd.so"].get("CfgMsgRSend", "cdecl")
    CfgMsgRSend.argtypes = [POINTER(CfgMsgR_t), POINTER(CfgMsg_t)]
    CfgMsgRSend.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 38
class struct__CmMessageRec(Structure):
    pass

CmMessage = POINTER(struct__CmMessageRec)# /virgoApp/Cm/v9r0/src/CmMessage.h: 38

# /virgoApp/Cm/v9r0/src/CmMessage.h: 39
class struct__CmMessageIteratorRec(Structure):
    pass

CmMessageIterator = POINTER(struct__CmMessageIteratorRec)# /virgoApp/Cm/v9r0/src/CmMessage.h: 39

enum_anon_28 = c_int# /virgoApp/Cm/v9r0/src/CmMessage.h: 45

CmMessageOk = 0# /virgoApp/Cm/v9r0/src/CmMessage.h: 45

CmMessageBreak = (CmMessageOk + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 45

CmMessageStatus = enum_anon_28# /virgoApp/Cm/v9r0/src/CmMessage.h: 45

enum_anon_29 = c_int# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsDead = 0# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsNotReady = (CmMessageIsDead + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsNew = (CmMessageIsNotReady + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsNotEmpty = (CmMessageIsNew + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsClosed = (CmMessageIsNotEmpty + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageIsSending = (CmMessageIsClosed + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

CmMessageState = enum_anon_29# /virgoApp/Cm/v9r0/src/CmMessage.h: 55

enum_anon_30 = c_int# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageChar = 0# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageShort = (CmMessageChar + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageInt = (CmMessageShort + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageFloat = (CmMessageInt + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageDouble = (CmMessageFloat + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

CmMessageArrayType = enum_anon_30# /virgoApp/Cm/v9r0/src/CmMessage.h: 64

enum_anon_31 = c_int# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemChar = 0# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemShort = (CmMessageItemChar + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemInt = (CmMessageItemShort + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemLong = (CmMessageItemInt + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemFloat = (CmMessageItemLong + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemDouble = (CmMessageItemFloat + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemArray = (CmMessageItemDouble + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemText = (CmMessageItemArray + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemBytes = (CmMessageItemText + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemTail = (CmMessageItemBytes + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemUnknown = (CmMessageItemTail + 1)# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageItemType = enum_anon_31# /virgoApp/Cm/v9r0/src/CmMessage.h: 79

CmMessageHandler = CFUNCTYPE(UNCHECKED(CmMessageStatus), CmMessage, String, String)# /virgoApp/Cm/v9r0/src/CmMessage.h: 81

CmMessageItem = c_char# /virgoApp/Cm/v9r0/src/CmMessage.h: 85

# /virgoApp/Cm/v9r0/src/GC.h: 36
class struct__GCReferenceRec(Structure):
    pass

GCReference = POINTER(struct__GCReferenceRec)# /virgoApp/Cm/v9r0/src/GC.h: 36

# /virgoApp/Cm/v9r0/src/GC.h: 37
class struct__GCClassRec(Structure):
    pass

GCClass = POINTER(struct__GCClassRec)# /virgoApp/Cm/v9r0/src/GC.h: 37

# /virgoApp/Cm/v9r0/src/GC.h: 38
class struct__GCObjectRec(Structure):
    pass

GCObject = POINTER(struct__GCObjectRec)# /virgoApp/Cm/v9r0/src/GC.h: 38

GCDeleteMethod = CFUNCTYPE(UNCHECKED(None), POINTER(None))# /virgoApp/Cm/v9r0/src/GC.h: 40

# /virgoApp/Cm/v9r0/src/GC.h: 42
if _libs["libPyFd.so"].has("GCStartup", "cdecl"):
    GCStartup = _libs["libPyFd.so"].get("GCStartup", "cdecl")
    GCStartup.argtypes = []
    GCStartup.restype = None

# /virgoApp/Cm/v9r0/src/GC.h: 43
if _libs["libPyFd.so"].has("GCReferenceCleanup", "cdecl"):
    GCReferenceCleanup = _libs["libPyFd.so"].get("GCReferenceCleanup", "cdecl")
    GCReferenceCleanup.argtypes = []
    GCReferenceCleanup.restype = None

# /virgoApp/Cm/v9r0/src/GC.h: 44
if _libs["libPyFd.so"].has("GCClassNew", "cdecl"):
    GCClassNew = _libs["libPyFd.so"].get("GCClassNew", "cdecl")
    GCClassNew.argtypes = [String, GCDeleteMethod]
    GCClassNew.restype = GCClass

# /virgoApp/Cm/v9r0/src/GC.h: 45
if _libs["libPyFd.so"].has("GCClassDelete", "cdecl"):
    GCClassDelete = _libs["libPyFd.so"].get("GCClassDelete", "cdecl")
    GCClassDelete.argtypes = [GCClass]
    GCClassDelete.restype = None

# /virgoApp/Cm/v9r0/src/GC.h: 46
if _libs["libPyFd.so"].has("GCObjectNew", "cdecl"):
    GCObjectNew = _libs["libPyFd.so"].get("GCObjectNew", "cdecl")
    GCObjectNew.argtypes = [POINTER(None), GCClass]
    GCObjectNew.restype = GCObject

# /virgoApp/Cm/v9r0/src/GC.h: 47
if _libs["libPyFd.so"].has("GCReferenceSet", "cdecl"):
    GCReferenceSet = _libs["libPyFd.so"].get("GCReferenceSet", "cdecl")
    GCReferenceSet.argtypes = [POINTER(POINTER(None)), POINTER(None), POINTER(None)]
    GCReferenceSet.restype = GCReference

# /virgoApp/Cm/v9r0/src/GC.h: 48
if _libs["libPyFd.so"].has("GCReferenceMove", "cdecl"):
    GCReferenceMove = _libs["libPyFd.so"].get("GCReferenceMove", "cdecl")
    GCReferenceMove.argtypes = [POINTER(POINTER(None)), POINTER(POINTER(None))]
    GCReferenceMove.restype = None

# /virgoApp/Cm/v9r0/src/GC.h: 49
if _libs["libPyFd.so"].has("GCDumpBase", "cdecl"):
    GCDumpBase = _libs["libPyFd.so"].get("GCDumpBase", "cdecl")
    GCDumpBase.argtypes = []
    GCDumpBase.restype = None

# /virgoApp/Cm/v9r0/src/GC.h: 50
if _libs["libPyFd.so"].has("GCCleanup", "cdecl"):
    GCCleanup = _libs["libPyFd.so"].get("GCCleanup", "cdecl")
    GCCleanup.argtypes = []
    GCCleanup.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 38
class struct__CArrayRec(Structure):
    pass

CArray = POINTER(struct__CArrayRec)# /virgoApp/Cm/v9r0/src/CSet.h: 38

# /virgoApp/Cm/v9r0/src/CSet.h: 39
class struct__CStackRec(Structure):
    pass

CStack = POINTER(struct__CStackRec)# /virgoApp/Cm/v9r0/src/CSet.h: 39

# /virgoApp/Cm/v9r0/src/CSet.h: 40
class struct__CQueueRec(Structure):
    pass

CQueue = POINTER(struct__CQueueRec)# /virgoApp/Cm/v9r0/src/CSet.h: 40

# /virgoApp/Cm/v9r0/src/CSet.h: 41
class struct__CLListRec(Structure):
    pass

CLList = POINTER(struct__CLListRec)# /virgoApp/Cm/v9r0/src/CSet.h: 41

# /virgoApp/Cm/v9r0/src/CSet.h: 42
class struct__CHasherRec(Structure):
    pass

CHasher = POINTER(struct__CHasherRec)# /virgoApp/Cm/v9r0/src/CSet.h: 42

# /virgoApp/Cm/v9r0/src/CSet.h: 43
class struct__CIteratorRec(Structure):
    pass

CIterator = POINTER(struct__CIteratorRec)# /virgoApp/Cm/v9r0/src/CSet.h: 43

CMethod = CFUNCTYPE(UNCHECKED(None), POINTER(None))# /virgoApp/Cm/v9r0/src/CSet.h: 45

CValuator = CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), POINTER(None))# /virgoApp/Cm/v9r0/src/CSet.h: 46

CCoder = CFUNCTYPE(UNCHECKED(c_int), POINTER(None))# /virgoApp/Cm/v9r0/src/CSet.h: 47

CTester = CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(None))# /virgoApp/Cm/v9r0/src/CSet.h: 48

# /virgoApp/Cm/v9r0/src/CSet.h: 50
if _libs["libPyFd.so"].has("CArrayStartup", "cdecl"):
    CArrayStartup = _libs["libPyFd.so"].get("CArrayStartup", "cdecl")
    CArrayStartup.argtypes = []
    CArrayStartup.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 51
if _libs["libPyFd.so"].has("CArrayCleanup", "cdecl"):
    CArrayCleanup = _libs["libPyFd.so"].get("CArrayCleanup", "cdecl")
    CArrayCleanup.argtypes = []
    CArrayCleanup.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 52
if _libs["libPyFd.so"].has("CArrayCheck", "cdecl"):
    CArrayCheck = _libs["libPyFd.so"].get("CArrayCheck", "cdecl")
    CArrayCheck.argtypes = []
    CArrayCheck.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 53
if _libs["libPyFd.so"].has("CArrayNew", "cdecl"):
    CArrayNew = _libs["libPyFd.so"].get("CArrayNew", "cdecl")
    CArrayNew.argtypes = []
    CArrayNew.restype = CArray

# /virgoApp/Cm/v9r0/src/CSet.h: 54
if _libs["libPyFd.so"].has("CArrayErase", "cdecl"):
    CArrayErase = _libs["libPyFd.so"].get("CArrayErase", "cdecl")
    CArrayErase.argtypes = [CArray]
    CArrayErase.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 55
if _libs["libPyFd.so"].has("CArrayCount", "cdecl"):
    CArrayCount = _libs["libPyFd.so"].get("CArrayCount", "cdecl")
    CArrayCount.argtypes = [CArray]
    CArrayCount.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 56
if _libs["libPyFd.so"].has("CArrayAdd", "cdecl"):
    CArrayAdd = _libs["libPyFd.so"].get("CArrayAdd", "cdecl")
    CArrayAdd.argtypes = [CArray, POINTER(None)]
    CArrayAdd.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 57
if _libs["libPyFd.so"].has("CArrayRemove", "cdecl"):
    CArrayRemove = _libs["libPyFd.so"].get("CArrayRemove", "cdecl")
    CArrayRemove.argtypes = [CArray, POINTER(None)]
    CArrayRemove.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 58
if _libs["libPyFd.so"].has("CArrayItem", "cdecl"):
    CArrayItem = _libs["libPyFd.so"].get("CArrayItem", "cdecl")
    CArrayItem.argtypes = [CArray, CIterator]
    CArrayItem.restype = POINTER(c_ubyte)
    CArrayItem.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 59
if _libs["libPyFd.so"].has("CArrayRemoveAt", "cdecl"):
    CArrayRemoveAt = _libs["libPyFd.so"].get("CArrayRemoveAt", "cdecl")
    CArrayRemoveAt.argtypes = [CArray, c_int]
    CArrayRemoveAt.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 60
if _libs["libPyFd.so"].has("CArrayItemAt", "cdecl"):
    CArrayItemAt = _libs["libPyFd.so"].get("CArrayItemAt", "cdecl")
    CArrayItemAt.argtypes = [CArray, c_int]
    CArrayItemAt.restype = POINTER(c_ubyte)
    CArrayItemAt.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 61
if _libs["libPyFd.so"].has("CArrayFind", "cdecl"):
    CArrayFind = _libs["libPyFd.so"].get("CArrayFind", "cdecl")
    CArrayFind.argtypes = [CArray, POINTER(None)]
    CArrayFind.restype = POINTER(c_ubyte)
    CArrayFind.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 62
if _libs["libPyFd.so"].has("CArrayGiveIterator", "cdecl"):
    CArrayGiveIterator = _libs["libPyFd.so"].get("CArrayGiveIterator", "cdecl")
    CArrayGiveIterator.argtypes = [CArray]
    CArrayGiveIterator.restype = CIterator

# /virgoApp/Cm/v9r0/src/CSet.h: 63
if _libs["libPyFd.so"].has("CArrayGiveBackwardIterator", "cdecl"):
    CArrayGiveBackwardIterator = _libs["libPyFd.so"].get("CArrayGiveBackwardIterator", "cdecl")
    CArrayGiveBackwardIterator.argtypes = [CArray]
    CArrayGiveBackwardIterator.restype = CIterator

# /virgoApp/Cm/v9r0/src/CSet.h: 64
if _libs["libPyFd.so"].has("CStackNew", "cdecl"):
    CStackNew = _libs["libPyFd.so"].get("CStackNew", "cdecl")
    CStackNew.argtypes = []
    CStackNew.restype = CStack

# /virgoApp/Cm/v9r0/src/CSet.h: 65
if _libs["libPyFd.so"].has("CStackErase", "cdecl"):
    CStackErase = _libs["libPyFd.so"].get("CStackErase", "cdecl")
    CStackErase.argtypes = [CStack]
    CStackErase.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 66
if _libs["libPyFd.so"].has("CStackCount", "cdecl"):
    CStackCount = _libs["libPyFd.so"].get("CStackCount", "cdecl")
    CStackCount.argtypes = [CStack]
    CStackCount.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 67
if _libs["libPyFd.so"].has("CStackPush", "cdecl"):
    CStackPush = _libs["libPyFd.so"].get("CStackPush", "cdecl")
    CStackPush.argtypes = [CStack, POINTER(None)]
    CStackPush.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 68
if _libs["libPyFd.so"].has("CStackTop", "cdecl"):
    CStackTop = _libs["libPyFd.so"].get("CStackTop", "cdecl")
    CStackTop.argtypes = [CStack]
    CStackTop.restype = POINTER(c_ubyte)
    CStackTop.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 69
if _libs["libPyFd.so"].has("CStackPop", "cdecl"):
    CStackPop = _libs["libPyFd.so"].get("CStackPop", "cdecl")
    CStackPop.argtypes = [CStack]
    CStackPop.restype = POINTER(c_ubyte)
    CStackPop.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 70
if _libs["libPyFd.so"].has("CQueueNew", "cdecl"):
    CQueueNew = _libs["libPyFd.so"].get("CQueueNew", "cdecl")
    CQueueNew.argtypes = []
    CQueueNew.restype = CQueue

# /virgoApp/Cm/v9r0/src/CSet.h: 71
if _libs["libPyFd.so"].has("CQueueErase", "cdecl"):
    CQueueErase = _libs["libPyFd.so"].get("CQueueErase", "cdecl")
    CQueueErase.argtypes = [CQueue]
    CQueueErase.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 72
if _libs["libPyFd.so"].has("CQueueCount", "cdecl"):
    CQueueCount = _libs["libPyFd.so"].get("CQueueCount", "cdecl")
    CQueueCount.argtypes = [CQueue]
    CQueueCount.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 73
if _libs["libPyFd.so"].has("CQueuePush", "cdecl"):
    CQueuePush = _libs["libPyFd.so"].get("CQueuePush", "cdecl")
    CQueuePush.argtypes = [CQueue, POINTER(None)]
    CQueuePush.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 74
if _libs["libPyFd.so"].has("CQueueTop", "cdecl"):
    CQueueTop = _libs["libPyFd.so"].get("CQueueTop", "cdecl")
    CQueueTop.argtypes = [CQueue]
    CQueueTop.restype = POINTER(c_ubyte)
    CQueueTop.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 75
if _libs["libPyFd.so"].has("CQueuePop", "cdecl"):
    CQueuePop = _libs["libPyFd.so"].get("CQueuePop", "cdecl")
    CQueuePop.argtypes = [CQueue]
    CQueuePop.restype = POINTER(c_ubyte)
    CQueuePop.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 76
if _libs["libPyFd.so"].has("CLListNew", "cdecl"):
    CLListNew = _libs["libPyFd.so"].get("CLListNew", "cdecl")
    CLListNew.argtypes = []
    CLListNew.restype = CLList

# /virgoApp/Cm/v9r0/src/CSet.h: 77
if _libs["libPyFd.so"].has("CLListErase", "cdecl"):
    CLListErase = _libs["libPyFd.so"].get("CLListErase", "cdecl")
    CLListErase.argtypes = [CLList]
    CLListErase.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 78
if _libs["libPyFd.so"].has("CLListCount", "cdecl"):
    CLListCount = _libs["libPyFd.so"].get("CLListCount", "cdecl")
    CLListCount.argtypes = [CLList]
    CLListCount.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 79
if _libs["libPyFd.so"].has("CLListAdd", "cdecl"):
    CLListAdd = _libs["libPyFd.so"].get("CLListAdd", "cdecl")
    CLListAdd.argtypes = [CLList, POINTER(None)]
    CLListAdd.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 80
if _libs["libPyFd.so"].has("CLListPrepend", "cdecl"):
    CLListPrepend = _libs["libPyFd.so"].get("CLListPrepend", "cdecl")
    CLListPrepend.argtypes = [CLList, POINTER(None)]
    CLListPrepend.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 81
if _libs["libPyFd.so"].has("CLListFirst", "cdecl"):
    CLListFirst = _libs["libPyFd.so"].get("CLListFirst", "cdecl")
    CLListFirst.argtypes = [CLList]
    CLListFirst.restype = POINTER(c_ubyte)
    CLListFirst.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 82
if _libs["libPyFd.so"].has("CLListLast", "cdecl"):
    CLListLast = _libs["libPyFd.so"].get("CLListLast", "cdecl")
    CLListLast.argtypes = [CLList]
    CLListLast.restype = POINTER(c_ubyte)
    CLListLast.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 83
if _libs["libPyFd.so"].has("CLListRemove", "cdecl"):
    CLListRemove = _libs["libPyFd.so"].get("CLListRemove", "cdecl")
    CLListRemove.argtypes = [CLList, POINTER(None)]
    CLListRemove.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 84
if _libs["libPyFd.so"].has("CLListFind", "cdecl"):
    CLListFind = _libs["libPyFd.so"].get("CLListFind", "cdecl")
    CLListFind.argtypes = [CLList, POINTER(None)]
    CLListFind.restype = POINTER(c_ubyte)
    CLListFind.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 85
if _libs["libPyFd.so"].has("CLListGiveIterator", "cdecl"):
    CLListGiveIterator = _libs["libPyFd.so"].get("CLListGiveIterator", "cdecl")
    CLListGiveIterator.argtypes = [CLList]
    CLListGiveIterator.restype = CIterator

# /virgoApp/Cm/v9r0/src/CSet.h: 86
if _libs["libPyFd.so"].has("CLListGiveBackwardIterator", "cdecl"):
    CLListGiveBackwardIterator = _libs["libPyFd.so"].get("CLListGiveBackwardIterator", "cdecl")
    CLListGiveBackwardIterator.argtypes = [CLList]
    CLListGiveBackwardIterator.restype = CIterator

# /virgoApp/Cm/v9r0/src/CSet.h: 87
if _libs["libPyFd.so"].has("CPtrHasherNew", "cdecl"):
    CPtrHasherNew = _libs["libPyFd.so"].get("CPtrHasherNew", "cdecl")
    CPtrHasherNew.argtypes = [c_int, CValuator]
    CPtrHasherNew.restype = CHasher

# /virgoApp/Cm/v9r0/src/CSet.h: 88
if _libs["libPyFd.so"].has("CStrHasherNew", "cdecl"):
    CStrHasherNew = _libs["libPyFd.so"].get("CStrHasherNew", "cdecl")
    CStrHasherNew.argtypes = [c_int, CValuator]
    CStrHasherNew.restype = CHasher

# /virgoApp/Cm/v9r0/src/CSet.h: 89
if _libs["libPyFd.so"].has("CLStrHasherNew", "cdecl"):
    CLStrHasherNew = _libs["libPyFd.so"].get("CLStrHasherNew", "cdecl")
    CLStrHasherNew.argtypes = [c_int, CValuator]
    CLStrHasherNew.restype = CHasher

# /virgoApp/Cm/v9r0/src/CSet.h: 90
if _libs["libPyFd.so"].has("CHasherNew", "cdecl"):
    CHasherNew = _libs["libPyFd.so"].get("CHasherNew", "cdecl")
    CHasherNew.argtypes = [c_int, CValuator, CCoder, CTester]
    CHasherNew.restype = CHasher

# /virgoApp/Cm/v9r0/src/CSet.h: 91
if _libs["libPyFd.so"].has("CHasherErase", "cdecl"):
    CHasherErase = _libs["libPyFd.so"].get("CHasherErase", "cdecl")
    CHasherErase.argtypes = [CHasher]
    CHasherErase.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 92
if _libs["libPyFd.so"].has("CHasherAdd", "cdecl"):
    CHasherAdd = _libs["libPyFd.so"].get("CHasherAdd", "cdecl")
    CHasherAdd.argtypes = [CHasher, POINTER(None)]
    CHasherAdd.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 93
if _libs["libPyFd.so"].has("CHasherFind", "cdecl"):
    CHasherFind = _libs["libPyFd.so"].get("CHasherFind", "cdecl")
    CHasherFind.argtypes = [CHasher, POINTER(None)]
    CHasherFind.restype = POINTER(c_ubyte)
    CHasherFind.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 94
if _libs["libPyFd.so"].has("CHasherFindPosition", "cdecl"):
    CHasherFindPosition = _libs["libPyFd.so"].get("CHasherFindPosition", "cdecl")
    CHasherFindPosition.argtypes = [CHasher, POINTER(None), POINTER(c_int), POINTER(c_int)]
    CHasherFindPosition.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 95
if _libs["libPyFd.so"].has("CHasherRemove", "cdecl"):
    CHasherRemove = _libs["libPyFd.so"].get("CHasherRemove", "cdecl")
    CHasherRemove.argtypes = [CHasher, POINTER(None)]
    CHasherRemove.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 96
if _libs["libPyFd.so"].has("CHasherGiveIterator", "cdecl"):
    CHasherGiveIterator = _libs["libPyFd.so"].get("CHasherGiveIterator", "cdecl")
    CHasherGiveIterator.argtypes = [CHasher]
    CHasherGiveIterator.restype = CIterator

# /virgoApp/Cm/v9r0/src/CSet.h: 97
if _libs["libPyFd.so"].has("CIteratorFinished", "cdecl"):
    CIteratorFinished = _libs["libPyFd.so"].get("CIteratorFinished", "cdecl")
    CIteratorFinished.argtypes = [CIterator]
    CIteratorFinished.restype = c_int

# /virgoApp/Cm/v9r0/src/CSet.h: 98
if _libs["libPyFd.so"].has("CIteratorFirst", "cdecl"):
    CIteratorFirst = _libs["libPyFd.so"].get("CIteratorFirst", "cdecl")
    CIteratorFirst.argtypes = [CIterator]
    CIteratorFirst.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 99
if _libs["libPyFd.so"].has("CIteratorForth", "cdecl"):
    CIteratorForth = _libs["libPyFd.so"].get("CIteratorForth", "cdecl")
    CIteratorForth.argtypes = [CIterator]
    CIteratorForth.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 100
if _libs["libPyFd.so"].has("CIteratorDelete", "cdecl"):
    CIteratorDelete = _libs["libPyFd.so"].get("CIteratorDelete", "cdecl")
    CIteratorDelete.argtypes = [CIterator]
    CIteratorDelete.restype = None

# /virgoApp/Cm/v9r0/src/CSet.h: 101
if _libs["libPyFd.so"].has("CIteratorItem", "cdecl"):
    CIteratorItem = _libs["libPyFd.so"].get("CIteratorItem", "cdecl")
    CIteratorItem.argtypes = [CIterator]
    CIteratorItem.restype = POINTER(c_ubyte)
    CIteratorItem.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CSet.h: 102
if _libs["libPyFd.so"].has("CIteratorStop", "cdecl"):
    CIteratorStop = _libs["libPyFd.so"].get("CIteratorStop", "cdecl")
    CIteratorStop.argtypes = [CIterator]
    CIteratorStop.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 40
class struct__CmConnectRec(Structure):
    pass

CmConnect = POINTER(struct__CmConnectRec)# /virgoApp/Cm/v9r0/src/CmConnect.h: 40

# /virgoApp/Cm/v9r0/src/CmConnect.h: 41
class struct__CmConnectIteratorRec(Structure):
    pass

CmConnectIterator = POINTER(struct__CmConnectIteratorRec)# /virgoApp/Cm/v9r0/src/CmConnect.h: 41

enum_anon_32 = c_int# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

CmConnectStatusNoData = 0# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

CmConnectStatusData = (CmConnectStatusNoData + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

CmConnectStatusDelayed = (CmConnectStatusData + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

CmConnectStatusAbort = (CmConnectStatusDelayed + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

CmConnectStatus = enum_anon_32# /virgoApp/Cm/v9r0/src/CmConnect.h: 49

enum_anon_33 = c_int# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectNormalCompletion = 0# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectNoHandler = (CmConnectNormalCompletion + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectTimeoutDetection = (CmConnectNoHandler + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectBreakDetection = (CmConnectTimeoutDetection + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectErrorCondition = (CmConnectBreakDetection + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

CmConnectCondition = enum_anon_33# /virgoApp/Cm/v9r0/src/CmConnect.h: 58

enum_anon_34 = c_int# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadPort = 1# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadName = (CmErrorBadPort + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadHost = (CmErrorBadName + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorNoNameServer = (CmErrorBadHost + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadSocket = (CmErrorNoNameServer + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadEnvironment = (CmErrorBadSocket + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorBadMemory = (CmErrorBadEnvironment + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorRecovered = (CmErrorBadMemory + 1)# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

CmErrorCode = enum_anon_34# /virgoApp/Cm/v9r0/src/CmConnect.h: 70

# /virgoApp/Cm/v9r0/src/CmConnect.h: 73
class struct__CmNameServerInfosRec(Structure):
    pass

CmNameServerInfos = POINTER(struct__CmNameServerInfosRec)# /virgoApp/Cm/v9r0/src/CmConnect.h: 72

struct__CmNameServerInfosRec.__slots__ = [
    'name',
    'host',
    'port',
    'firstPort',
    'ports',
    'repository',
]
struct__CmNameServerInfosRec._fields_ = [
    ('name', String),
    ('host', String),
    ('port', c_int),
    ('firstPort', c_int),
    ('ports', c_int),
    ('repository', String),
]

CmNameServerInfosRec = struct__CmNameServerInfosRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 81

# /virgoApp/Cm/v9r0/src/CmConnect.h: 84
class struct__CmConnectStatisticsRec(Structure):
    pass

CmConnectStatistics = POINTER(struct__CmConnectStatisticsRec)# /virgoApp/Cm/v9r0/src/CmConnect.h: 83

struct__CmConnectStatisticsRec.__slots__ = [
    'sent',
    'received',
    'bytes_sent',
    'bytes_received',
]
struct__CmConnectStatisticsRec._fields_ = [
    ('sent', c_int),
    ('received', c_int),
    ('bytes_sent', c_int),
    ('bytes_received', c_int),
]

CmConnectStatisticsRec = struct__CmConnectStatisticsRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 90

CmConnectPrinter = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cm/v9r0/src/CmConnect.h: 92

CmConnectFunction = CFUNCTYPE(UNCHECKED(None), )# /virgoApp/Cm/v9r0/src/CmConnect.h: 94

CmConnectConnectionHandler = CFUNCTYPE(UNCHECKED(None), CmConnect)# /virgoApp/Cm/v9r0/src/CmConnect.h: 95

CmConnectReceiveHandler = CFUNCTYPE(UNCHECKED(CmConnectStatus), CmConnect)# /virgoApp/Cm/v9r0/src/CmConnect.h: 96

CmConnectRearmHandler = CFUNCTYPE(UNCHECKED(CmConnectStatus), CmConnect)# /virgoApp/Cm/v9r0/src/CmConnect.h: 97

CmConnectBuildPortHandler = CFUNCTYPE(UNCHECKED(c_int), )# /virgoApp/Cm/v9r0/src/CmConnect.h: 98

CvtSwap = c_char * int(((((2 * sizeof(c_short)) + 1) + (2 * sizeof(c_int))) + 1))# /virgoApp/Cm/v9r0/src/Cvt.h: 36

# /virgoApp/Cm/v9r0/src/Cvt.h: 38
class struct__CvtRec(Structure):
    pass

Cvt = POINTER(struct__CvtRec)# /virgoApp/Cm/v9r0/src/Cvt.h: 38

# /virgoApp/Cm/v9r0/src/Cvt.h: 40
if _libs["libPyFd.so"].has("CvtForceStartup", "cdecl"):
    CvtForceStartup = _libs["libPyFd.so"].get("CvtForceStartup", "cdecl")
    CvtForceStartup.argtypes = []
    CvtForceStartup.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 41
if _libs["libPyFd.so"].has("CvtStartup", "cdecl"):
    CvtStartup = _libs["libPyFd.so"].get("CvtStartup", "cdecl")
    CvtStartup.argtypes = []
    CvtStartup.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 42
if _libs["libPyFd.so"].has("CvtCleanup", "cdecl"):
    CvtCleanup = _libs["libPyFd.so"].get("CvtCleanup", "cdecl")
    CvtCleanup.argtypes = []
    CvtCleanup.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 43
if _libs["libPyFd.so"].has("CvtCheckBalance", "cdecl"):
    CvtCheckBalance = _libs["libPyFd.so"].get("CvtCheckBalance", "cdecl")
    CvtCheckBalance.argtypes = []
    CvtCheckBalance.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 44
if _libs["libPyFd.so"].has("CvtNew", "cdecl"):
    CvtNew = _libs["libPyFd.so"].get("CvtNew", "cdecl")
    CvtNew.argtypes = [String]
    CvtNew.restype = Cvt

# /virgoApp/Cm/v9r0/src/Cvt.h: 45
if _libs["libPyFd.so"].has("CvtDelete", "cdecl"):
    CvtDelete = _libs["libPyFd.so"].get("CvtDelete", "cdecl")
    CvtDelete.argtypes = [Cvt]
    CvtDelete.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 46
if _libs["libPyFd.so"].has("CvtGetShort", "cdecl"):
    CvtGetShort = _libs["libPyFd.so"].get("CvtGetShort", "cdecl")
    CvtGetShort.argtypes = [Cvt, POINTER(c_ubyte)]
    CvtGetShort.restype = c_short

# /virgoApp/Cm/v9r0/src/Cvt.h: 47
if _libs["libPyFd.so"].has("CvtPutShort", "cdecl"):
    CvtPutShort = _libs["libPyFd.so"].get("CvtPutShort", "cdecl")
    CvtPutShort.argtypes = [c_short, POINTER(c_ubyte)]
    CvtPutShort.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 48
if _libs["libPyFd.so"].has("CvtGetInt", "cdecl"):
    CvtGetInt = _libs["libPyFd.so"].get("CvtGetInt", "cdecl")
    CvtGetInt.argtypes = [Cvt, POINTER(c_ubyte)]
    CvtGetInt.restype = c_int

# /virgoApp/Cm/v9r0/src/Cvt.h: 49
if _libs["libPyFd.so"].has("CvtPutInt", "cdecl"):
    CvtPutInt = _libs["libPyFd.so"].get("CvtPutInt", "cdecl")
    CvtPutInt.argtypes = [c_int, POINTER(c_ubyte)]
    CvtPutInt.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 50
if _libs["libPyFd.so"].has("CvtPutFloat", "cdecl"):
    CvtPutFloat = _libs["libPyFd.so"].get("CvtPutFloat", "cdecl")
    CvtPutFloat.argtypes = [c_float, POINTER(c_ubyte)]
    CvtPutFloat.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 51
if _libs["libPyFd.so"].has("CvtGetFloat", "cdecl"):
    CvtGetFloat = _libs["libPyFd.so"].get("CvtGetFloat", "cdecl")
    CvtGetFloat.argtypes = [POINTER(c_ubyte)]
    CvtGetFloat.restype = c_float

# /virgoApp/Cm/v9r0/src/Cvt.h: 52
if _libs["libPyFd.so"].has("CvtPutFloats", "cdecl"):
    CvtPutFloats = _libs["libPyFd.so"].get("CvtPutFloats", "cdecl")
    CvtPutFloats.argtypes = [POINTER(c_ubyte), c_int]
    CvtPutFloats.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 53
if _libs["libPyFd.so"].has("CvtGetFloats", "cdecl"):
    CvtGetFloats = _libs["libPyFd.so"].get("CvtGetFloats", "cdecl")
    CvtGetFloats.argtypes = [POINTER(c_ubyte), c_int]
    CvtGetFloats.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 54
if _libs["libPyFd.so"].has("CvtPutDouble", "cdecl"):
    CvtPutDouble = _libs["libPyFd.so"].get("CvtPutDouble", "cdecl")
    CvtPutDouble.argtypes = [c_double, POINTER(c_ubyte)]
    CvtPutDouble.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 55
if _libs["libPyFd.so"].has("CvtGetDouble", "cdecl"):
    CvtGetDouble = _libs["libPyFd.so"].get("CvtGetDouble", "cdecl")
    CvtGetDouble.argtypes = [POINTER(c_ubyte)]
    CvtGetDouble.restype = c_double

# /virgoApp/Cm/v9r0/src/Cvt.h: 56
if _libs["libPyFd.so"].has("CvtPutDoubles", "cdecl"):
    CvtPutDoubles = _libs["libPyFd.so"].get("CvtPutDoubles", "cdecl")
    CvtPutDoubles.argtypes = [POINTER(c_ubyte), c_int]
    CvtPutDoubles.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 57
if _libs["libPyFd.so"].has("CvtGetDoubles", "cdecl"):
    CvtGetDoubles = _libs["libPyFd.so"].get("CvtGetDoubles", "cdecl")
    CvtGetDoubles.argtypes = [POINTER(c_ubyte), c_int]
    CvtGetDoubles.restype = None

# /virgoApp/Cm/v9r0/src/Cvt.h: 58
if _libs["libPyFd.so"].has("CvtToText", "cdecl"):
    CvtToText = _libs["libPyFd.so"].get("CvtToText", "cdecl")
    CvtToText.argtypes = [Cvt]
    if sizeof(c_int) == sizeof(c_void_p):
        CvtToText.restype = ReturnString
    else:
        CvtToText.restype = String
        CvtToText.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/Cvt.h: 59
if _libs["libPyFd.so"].has("CvtGetSwap", "cdecl"):
    CvtGetSwap = _libs["libPyFd.so"].get("CvtGetSwap", "cdecl")
    CvtGetSwap.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CvtGetSwap.restype = ReturnString
    else:
        CvtGetSwap.restype = String
        CvtGetSwap.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 107
if _libs["libPyFd.so"].has("CmConnectForceStartup", "cdecl"):
    CmConnectForceStartup = _libs["libPyFd.so"].get("CmConnectForceStartup", "cdecl")
    CmConnectForceStartup.argtypes = []
    CmConnectForceStartup.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 108
if _libs["libPyFd.so"].has("CmConnectInitialize", "cdecl"):
    CmConnectInitialize = _libs["libPyFd.so"].get("CmConnectInitialize", "cdecl")
    CmConnectInitialize.argtypes = []
    CmConnectInitialize.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 109
if _libs["libPyFd.so"].has("CmConnectCleanup", "cdecl"):
    CmConnectCleanup = _libs["libPyFd.so"].get("CmConnectCleanup", "cdecl")
    CmConnectCleanup.argtypes = []
    CmConnectCleanup.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 110
if _libs["libPyFd.so"].has("CmConnectCheckBalance", "cdecl"):
    CmConnectCheckBalance = _libs["libPyFd.so"].get("CmConnectCheckBalance", "cdecl")
    CmConnectCheckBalance.argtypes = []
    CmConnectCheckBalance.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 111
if _libs["libPyFd.so"].has("CmConnectInstallPrinter", "cdecl"):
    CmConnectInstallPrinter = _libs["libPyFd.so"].get("CmConnectInstallPrinter", "cdecl")
    CmConnectInstallPrinter.argtypes = [CmConnectPrinter]
    CmConnectInstallPrinter.restype = CmConnectPrinter

# /virgoApp/Cm/v9r0/src/CmConnect.h: 112
if _libs["libPyFd.so"].has("CmConnectGetDomain", "cdecl"):
    CmConnectGetDomain = _libs["libPyFd.so"].get("CmConnectGetDomain", "cdecl")
    CmConnectGetDomain.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectGetDomain.restype = ReturnString
    else:
        CmConnectGetDomain.restype = String
        CmConnectGetDomain.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 113
if _libs["libPyFd.so"].has("CmConnectSetDomain", "cdecl"):
    CmConnectSetDomain = _libs["libPyFd.so"].get("CmConnectSetDomain", "cdecl")
    CmConnectSetDomain.argtypes = [String]
    CmConnectSetDomain.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 114
if _libs["libPyFd.so"].has("CmConnectExit", "cdecl"):
    CmConnectExit = _libs["libPyFd.so"].get("CmConnectExit", "cdecl")
    CmConnectExit.argtypes = [CmErrorCode]
    CmConnectExit.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 115
if _libs["libPyFd.so"].has("CmConnectInstallCHandler", "cdecl"):
    CmConnectInstallCHandler = _libs["libPyFd.so"].get("CmConnectInstallCHandler", "cdecl")
    CmConnectInstallCHandler.argtypes = [CmConnectConnectionHandler]
    CmConnectInstallCHandler.restype = CmConnectConnectionHandler

# /virgoApp/Cm/v9r0/src/CmConnect.h: 116
if _libs["libPyFd.so"].has("CmConnectInstallDHandler", "cdecl"):
    CmConnectInstallDHandler = _libs["libPyFd.so"].get("CmConnectInstallDHandler", "cdecl")
    CmConnectInstallDHandler.argtypes = [CmConnectConnectionHandler]
    CmConnectInstallDHandler.restype = CmConnectConnectionHandler

# /virgoApp/Cm/v9r0/src/CmConnect.h: 117
if _libs["libPyFd.so"].has("CmConnectDebugOn", "cdecl"):
    CmConnectDebugOn = _libs["libPyFd.so"].get("CmConnectDebugOn", "cdecl")
    CmConnectDebugOn.argtypes = []
    CmConnectDebugOn.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 118
if _libs["libPyFd.so"].has("CmConnectDebugOff", "cdecl"):
    CmConnectDebugOff = _libs["libPyFd.so"].get("CmConnectDebugOff", "cdecl")
    CmConnectDebugOff.argtypes = []
    CmConnectDebugOff.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 119
if _libs["libPyFd.so"].has("CmConnectTime", "cdecl"):
    CmConnectTime = _libs["libPyFd.so"].get("CmConnectTime", "cdecl")
    CmConnectTime.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectTime.restype = ReturnString
    else:
        CmConnectTime.restype = String
        CmConnectTime.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 120
if _libs["libPyFd.so"].has("CmConnectStartupAsServer", "cdecl"):
    CmConnectStartupAsServer = _libs["libPyFd.so"].get("CmConnectStartupAsServer", "cdecl")
    CmConnectStartupAsServer.argtypes = [String]
    CmConnectStartupAsServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 121
if _libs["libPyFd.so"].has("CmConnectStartupAsMS", "cdecl"):
    CmConnectStartupAsMS = _libs["libPyFd.so"].get("CmConnectStartupAsMS", "cdecl")
    CmConnectStartupAsMS.argtypes = [String]
    CmConnectStartupAsMS.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 122
if _libs["libPyFd.so"].has("CmConnectOpenServer", "cdecl"):
    CmConnectOpenServer = _libs["libPyFd.so"].get("CmConnectOpenServer", "cdecl")
    CmConnectOpenServer.argtypes = [String]
    CmConnectOpenServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 123
if _libs["libPyFd.so"].has("CmConnectOpenMultipleServer", "cdecl"):
    CmConnectOpenMultipleServer = _libs["libPyFd.so"].get("CmConnectOpenMultipleServer", "cdecl")
    CmConnectOpenMultipleServer.argtypes = [String]
    CmConnectOpenMultipleServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 124
if _libs["libPyFd.so"].has("CmConnectCloseServer", "cdecl"):
    CmConnectCloseServer = _libs["libPyFd.so"].get("CmConnectCloseServer", "cdecl")
    CmConnectCloseServer.argtypes = [String]
    CmConnectCloseServer.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 125
if _libs["libPyFd.so"].has("CmConnectSelectServer", "cdecl"):
    CmConnectSelectServer = _libs["libPyFd.so"].get("CmConnectSelectServer", "cdecl")
    CmConnectSelectServer.argtypes = [String]
    CmConnectSelectServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 126
if _libs["libPyFd.so"].has("CmServerSetComment", "cdecl"):
    CmServerSetComment = _libs["libPyFd.so"].get("CmServerSetComment", "cdecl")
    CmServerSetComment.argtypes = [String]
    CmServerSetComment.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 127
if _libs["libPyFd.so"].has("CmServerGetComment", "cdecl"):
    CmServerGetComment = _libs["libPyFd.so"].get("CmServerGetComment", "cdecl")
    CmServerGetComment.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CmServerGetComment.restype = ReturnString
    else:
        CmServerGetComment.restype = String
        CmServerGetComment.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 128
if _libs["libPyFd.so"].has("CmConnectWhoAmI", "cdecl"):
    CmConnectWhoAmI = _libs["libPyFd.so"].get("CmConnectWhoAmI", "cdecl")
    CmConnectWhoAmI.argtypes = []
    CmConnectWhoAmI.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 129
if _libs["libPyFd.so"].has("CmConnectNew", "cdecl"):
    CmConnectNew = _libs["libPyFd.so"].get("CmConnectNew", "cdecl")
    CmConnectNew.argtypes = [String]
    CmConnectNew.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 130
if _libs["libPyFd.so"].has("CmConnectNewWithAddress", "cdecl"):
    CmConnectNewWithAddress = _libs["libPyFd.so"].get("CmConnectNewWithAddress", "cdecl")
    CmConnectNewWithAddress.argtypes = [CmConnect, String, c_int, String]
    CmConnectNewWithAddress.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 131
if _libs["libPyFd.so"].has("CmConnectNewWithSocket", "cdecl"):
    CmConnectNewWithSocket = _libs["libPyFd.so"].get("CmConnectNewWithSocket", "cdecl")
    CmConnectNewWithSocket.argtypes = [String, c_int]
    CmConnectNewWithSocket.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 132
if _libs["libPyFd.so"].has("CmConnectGetSocketId", "cdecl"):
    CmConnectGetSocketId = _libs["libPyFd.so"].get("CmConnectGetSocketId", "cdecl")
    CmConnectGetSocketId.argtypes = [CmConnect]
    CmConnectGetSocketId.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 133
if _libs["libPyFd.so"].has("CmConnectGetMessage", "cdecl"):
    CmConnectGetMessage = _libs["libPyFd.so"].get("CmConnectGetMessage", "cdecl")
    CmConnectGetMessage.argtypes = [CmConnect]
    CmConnectGetMessage.restype = CmMessage

# /virgoApp/Cm/v9r0/src/CmConnect.h: 134
if _libs["libPyFd.so"].has("CmConnectPushMessage", "cdecl"):
    CmConnectPushMessage = _libs["libPyFd.so"].get("CmConnectPushMessage", "cdecl")
    CmConnectPushMessage.argtypes = [CmConnect]
    CmConnectPushMessage.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 135
if _libs["libPyFd.so"].has("CmConnectTopMessage", "cdecl"):
    CmConnectTopMessage = _libs["libPyFd.so"].get("CmConnectTopMessage", "cdecl")
    CmConnectTopMessage.argtypes = [CmConnect]
    CmConnectTopMessage.restype = CmMessage

# /virgoApp/Cm/v9r0/src/CmConnect.h: 136
if _libs["libPyFd.so"].has("CmConnectPopMessage", "cdecl"):
    CmConnectPopMessage = _libs["libPyFd.so"].get("CmConnectPopMessage", "cdecl")
    CmConnectPopMessage.argtypes = [CmConnect]
    CmConnectPopMessage.restype = CmMessage

# /virgoApp/Cm/v9r0/src/CmConnect.h: 137
if _libs["libPyFd.so"].has("CmConnectIsNameServer", "cdecl"):
    CmConnectIsNameServer = _libs["libPyFd.so"].get("CmConnectIsNameServer", "cdecl")
    CmConnectIsNameServer.argtypes = [CmConnect]
    CmConnectIsNameServer.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 138
if _libs["libPyFd.so"].has("CmConnectReceive", "cdecl"):
    CmConnectReceive = _libs["libPyFd.so"].get("CmConnectReceive", "cdecl")
    CmConnectReceive.argtypes = [CmConnect, String, c_int]
    CmConnectReceive.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 139
if _libs["libPyFd.so"].has("CmConnectSend", "cdecl"):
    CmConnectSend = _libs["libPyFd.so"].get("CmConnectSend", "cdecl")
    CmConnectSend.argtypes = [CmConnect, String, c_int]
    CmConnectSend.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 140
if _libs["libPyFd.so"].has("CmConnectGetReference", "cdecl"):
    CmConnectGetReference = _libs["libPyFd.so"].get("CmConnectGetReference", "cdecl")
    CmConnectGetReference.argtypes = [String]
    CmConnectGetReference.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 141
if _libs["libPyFd.so"].has("CmConnectGetNthReference", "cdecl"):
    CmConnectGetNthReference = _libs["libPyFd.so"].get("CmConnectGetNthReference", "cdecl")
    CmConnectGetNthReference.argtypes = [String, c_int]
    CmConnectGetNthReference.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 142
if _libs["libPyFd.so"].has("CmConnectGetName", "cdecl"):
    CmConnectGetName = _libs["libPyFd.so"].get("CmConnectGetName", "cdecl")
    CmConnectGetName.argtypes = [CmConnect]
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectGetName.restype = ReturnString
    else:
        CmConnectGetName.restype = String
        CmConnectGetName.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 143
if _libs["libPyFd.so"].has("CmConnectGetServer", "cdecl"):
    CmConnectGetServer = _libs["libPyFd.so"].get("CmConnectGetServer", "cdecl")
    CmConnectGetServer.argtypes = [CmConnect]
    CmConnectGetServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 144
if _libs["libPyFd.so"].has("CmConnectGetNameServer", "cdecl"):
    CmConnectGetNameServer = _libs["libPyFd.so"].get("CmConnectGetNameServer", "cdecl")
    CmConnectGetNameServer.argtypes = []
    CmConnectGetNameServer.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 145
if _libs["libPyFd.so"].has("CmConnectSetName", "cdecl"):
    CmConnectSetName = _libs["libPyFd.so"].get("CmConnectSetName", "cdecl")
    CmConnectSetName.argtypes = [CmConnect, String]
    CmConnectSetName.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 146
if _libs["libPyFd.so"].has("CmConnectIsLocal", "cdecl"):
    CmConnectIsLocal = _libs["libPyFd.so"].get("CmConnectIsLocal", "cdecl")
    CmConnectIsLocal.argtypes = [CmConnect]
    CmConnectIsLocal.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 147
if _libs["libPyFd.so"].has("CmConnectIsMultiple", "cdecl"):
    CmConnectIsMultiple = _libs["libPyFd.so"].get("CmConnectIsMultiple", "cdecl")
    CmConnectIsMultiple.argtypes = [CmConnect]
    CmConnectIsMultiple.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 148
if _libs["libPyFd.so"].has("CmConnectSetMultiple", "cdecl"):
    CmConnectSetMultiple = _libs["libPyFd.so"].get("CmConnectSetMultiple", "cdecl")
    CmConnectSetMultiple.argtypes = [CmConnect]
    CmConnectSetMultiple.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 149
if _libs["libPyFd.so"].has("CmConnectSetPort", "cdecl"):
    CmConnectSetPort = _libs["libPyFd.so"].get("CmConnectSetPort", "cdecl")
    CmConnectSetPort.argtypes = [CmConnect, c_int]
    CmConnectSetPort.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 150
if _libs["libPyFd.so"].has("CmConnectSnprint", "cdecl"):
    CmConnectSnprint = _libs["libPyFd.so"].get("CmConnectSnprint", "cdecl")
    CmConnectSnprint.argtypes = [CmConnect, String, c_int]
    CmConnectSnprint.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 151
if _libs["libPyFd.so"].has("CmConnectSetSocketSize", "cdecl"):
    CmConnectSetSocketSize = _libs["libPyFd.so"].get("CmConnectSetSocketSize", "cdecl")
    CmConnectSetSocketSize.argtypes = [c_int, c_int, String]
    CmConnectSetSocketSize.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 152
if _libs["libPyFd.so"].has("CmConnectGetPort", "cdecl"):
    CmConnectGetPort = _libs["libPyFd.so"].get("CmConnectGetPort", "cdecl")
    CmConnectGetPort.argtypes = [CmConnect]
    CmConnectGetPort.restype = c_int

# /virgoApp/Cm/v9r0/src/CmConnect.h: 153
if _libs["libPyFd.so"].has("CmConnectGetHost", "cdecl"):
    CmConnectGetHost = _libs["libPyFd.so"].get("CmConnectGetHost", "cdecl")
    CmConnectGetHost.argtypes = [CmConnect]
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectGetHost.restype = ReturnString
    else:
        CmConnectGetHost.restype = String
        CmConnectGetHost.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 154
if _libs["libPyFd.so"].has("CmConnectSetHost", "cdecl"):
    CmConnectSetHost = _libs["libPyFd.so"].get("CmConnectSetHost", "cdecl")
    CmConnectSetHost.argtypes = [CmConnect, String]
    CmConnectSetHost.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 155
if _libs["libPyFd.so"].has("CmConnectGetOwner", "cdecl"):
    CmConnectGetOwner = _libs["libPyFd.so"].get("CmConnectGetOwner", "cdecl")
    CmConnectGetOwner.argtypes = [CmConnect]
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectGetOwner.restype = ReturnString
    else:
        CmConnectGetOwner.restype = String
        CmConnectGetOwner.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 156
if _libs["libPyFd.so"].has("CmConnectSetOwner", "cdecl"):
    CmConnectSetOwner = _libs["libPyFd.so"].get("CmConnectSetOwner", "cdecl")
    CmConnectSetOwner.argtypes = [CmConnect, String]
    CmConnectSetOwner.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 157
if _libs["libPyFd.so"].has("CmConnectGetIterator", "cdecl"):
    CmConnectGetIterator = _libs["libPyFd.so"].get("CmConnectGetIterator", "cdecl")
    CmConnectGetIterator.argtypes = []
    CmConnectGetIterator.restype = CmConnectIterator

# /virgoApp/Cm/v9r0/src/CmConnect.h: 158
if _libs["libPyFd.so"].has("CmConnectIteratorDelete", "cdecl"):
    CmConnectIteratorDelete = _libs["libPyFd.so"].get("CmConnectIteratorDelete", "cdecl")
    CmConnectIteratorDelete.argtypes = [CmConnectIterator]
    CmConnectIteratorDelete.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 159
if _libs["libPyFd.so"].has("CmConnectGetNextAlive", "cdecl"):
    CmConnectGetNextAlive = _libs["libPyFd.so"].get("CmConnectGetNextAlive", "cdecl")
    CmConnectGetNextAlive.argtypes = [CmConnectIterator]
    CmConnectGetNextAlive.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 160
if _libs["libPyFd.so"].has("CmConnectGetNext", "cdecl"):
    CmConnectGetNext = _libs["libPyFd.so"].get("CmConnectGetNext", "cdecl")
    CmConnectGetNext.argtypes = [CmConnectIterator]
    CmConnectGetNext.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 161
if _libs["libPyFd.so"].has("CmConnectScan", "cdecl"):
    CmConnectScan = _libs["libPyFd.so"].get("CmConnectScan", "cdecl")
    CmConnectScan.argtypes = [CmConnectIterator]
    CmConnectScan.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmConnect.h: 162
if _libs["libPyFd.so"].has("CmConnectInstallReceiveHandler", "cdecl"):
    CmConnectInstallReceiveHandler = _libs["libPyFd.so"].get("CmConnectInstallReceiveHandler", "cdecl")
    CmConnectInstallReceiveHandler.argtypes = [CmConnect, CmConnectReceiveHandler]
    CmConnectInstallReceiveHandler.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 163
if _libs["libPyFd.so"].has("CmConnectInstallRearmHandler", "cdecl"):
    CmConnectInstallRearmHandler = _libs["libPyFd.so"].get("CmConnectInstallRearmHandler", "cdecl")
    CmConnectInstallRearmHandler.argtypes = [CmConnect, CmConnectRearmHandler]
    CmConnectInstallRearmHandler.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 164
if _libs["libPyFd.so"].has("CmConnectInitData", "cdecl"):
    CmConnectInitData = _libs["libPyFd.so"].get("CmConnectInitData", "cdecl")
    CmConnectInitData.argtypes = [CmConnect, CmConnectReceiveHandler, CmConnectRearmHandler]
    CmConnectInitData.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 165
if _libs["libPyFd.so"].has("CmConnectInitHandlers", "cdecl"):
    CmConnectInitHandlers = _libs["libPyFd.so"].get("CmConnectInitHandlers", "cdecl")
    CmConnectInitHandlers.argtypes = [CmConnect, CmConnectReceiveHandler, CmConnectRearmHandler]
    CmConnectInitHandlers.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 166
if _libs["libPyFd.so"].has("CmConnectInstallMessage", "cdecl"):
    CmConnectInstallMessage = _libs["libPyFd.so"].get("CmConnectInstallMessage", "cdecl")
    CmConnectInstallMessage.argtypes = [CmConnect, CmMessage]
    CmConnectInstallMessage.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 167
if _libs["libPyFd.so"].has("CmConnectInstallMessageIterator", "cdecl"):
    CmConnectInstallMessageIterator = _libs["libPyFd.so"].get("CmConnectInstallMessageIterator", "cdecl")
    CmConnectInstallMessageIterator.argtypes = [CmConnect, CmMessageIterator]
    CmConnectInstallMessageIterator.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 168
if _libs["libPyFd.so"].has("CmConnectInstallNoTimeOut", "cdecl"):
    CmConnectInstallNoTimeOut = _libs["libPyFd.so"].get("CmConnectInstallNoTimeOut", "cdecl")
    CmConnectInstallNoTimeOut.argtypes = [CmConnect]
    CmConnectInstallNoTimeOut.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 169
if _libs["libPyFd.so"].has("CmConnectInstallTimeOut", "cdecl"):
    CmConnectInstallTimeOut = _libs["libPyFd.so"].get("CmConnectInstallTimeOut", "cdecl")
    CmConnectInstallTimeOut.argtypes = [CmConnect, c_int, c_int]
    CmConnectInstallTimeOut.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 170
if _libs["libPyFd.so"].has("CmConnectKill", "cdecl"):
    CmConnectKill = _libs["libPyFd.so"].get("CmConnectKill", "cdecl")
    CmConnectKill.argtypes = [CmConnect]
    CmConnectKill.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 171
if _libs["libPyFd.so"].has("CmConnectGetComment", "cdecl"):
    CmConnectGetComment = _libs["libPyFd.so"].get("CmConnectGetComment", "cdecl")
    CmConnectGetComment.argtypes = [CmConnect]
    if sizeof(c_int) == sizeof(c_void_p):
        CmConnectGetComment.restype = ReturnString
    else:
        CmConnectGetComment.restype = String
        CmConnectGetComment.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmConnect.h: 172
if _libs["libPyFd.so"].has("CmConnectGetStatistics", "cdecl"):
    CmConnectGetStatistics = _libs["libPyFd.so"].get("CmConnectGetStatistics", "cdecl")
    CmConnectGetStatistics.argtypes = [CmConnect, POINTER(CmConnectStatisticsRec)]
    CmConnectGetStatistics.restype = None

# /virgoApp/Cm/v9r0/src/CmConnect.h: 173
if _libs["libPyFd.so"].has("CmConnectCheck", "cdecl"):
    CmConnectCheck = _libs["libPyFd.so"].get("CmConnectCheck", "cdecl")
    CmConnectCheck.argtypes = []
    CmConnectCheck.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmConnect.h: 174
if _libs["libPyFd.so"].has("CmConnectWait", "cdecl"):
    CmConnectWait = _libs["libPyFd.so"].get("CmConnectWait", "cdecl")
    CmConnectWait.argtypes = []
    CmConnectWait.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmConnect.h: 175
if _libs["libPyFd.so"].has("CmConnectWaitOnIterator", "cdecl"):
    CmConnectWaitOnIterator = _libs["libPyFd.so"].get("CmConnectWaitOnIterator", "cdecl")
    CmConnectWaitOnIterator.argtypes = [CmMessageIterator]
    CmConnectWaitOnIterator.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmConnect.h: 176
if _libs["libPyFd.so"].has("CmConnectWaitWithTimeout", "cdecl"):
    CmConnectWaitWithTimeout = _libs["libPyFd.so"].get("CmConnectWaitWithTimeout", "cdecl")
    CmConnectWaitWithTimeout.argtypes = [c_double]
    CmConnectWaitWithTimeout.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmConnect.h: 177
if _libs["libPyFd.so"].has("CmConnectCheckInputData", "cdecl"):
    CmConnectCheckInputData = _libs["libPyFd.so"].get("CmConnectCheckInputData", "cdecl")
    CmConnectCheckInputData.argtypes = [CmConnect]
    CmConnectCheckInputData.restype = CmConnectStatus

# /virgoApp/Cm/v9r0/src/CmConnect.h: 178
if _libs["libPyFd.so"].has("CmNameServerGetInfos", "cdecl"):
    CmNameServerGetInfos = _libs["libPyFd.so"].get("CmNameServerGetInfos", "cdecl")
    CmNameServerGetInfos.argtypes = []
    CmNameServerGetInfos.restype = CmNameServerInfos

# /virgoApp/Cm/v9r0/src/CmConnect.h: 179
if _libs["libPyFd.so"].has("CmConnectTestPort", "cdecl"):
    CmConnectTestPort = _libs["libPyFd.so"].get("CmConnectTestPort", "cdecl")
    CmConnectTestPort.argtypes = [c_int]
    CmConnectTestPort.restype = c_int

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 4
class struct__CmTransactionRec(Structure):
    pass

CmTransaction = POINTER(struct__CmTransactionRec)# /virgoApp/Cm/v9r0/src/CmTransaction.h: 4

enum_anon_35 = c_int# /virgoApp/Cm/v9r0/src/CmTransaction.h: 11

CmTransactionClosed = 0# /virgoApp/Cm/v9r0/src/CmTransaction.h: 11

CmTransactionPending = (CmTransactionClosed + 1)# /virgoApp/Cm/v9r0/src/CmTransaction.h: 11

CmTransactionTerminated = (CmTransactionPending + 1)# /virgoApp/Cm/v9r0/src/CmTransaction.h: 11

CmTransactionState = enum_anon_35# /virgoApp/Cm/v9r0/src/CmTransaction.h: 11

enum_anon_36 = c_int# /virgoApp/Cm/v9r0/src/CmTransaction.h: 18

CmTransactionOk = 0# /virgoApp/Cm/v9r0/src/CmTransaction.h: 18

CmTransactionNotFound = (CmTransactionOk + 1)# /virgoApp/Cm/v9r0/src/CmTransaction.h: 18

CmTransactionAlreadyClosed = (CmTransactionNotFound + 1)# /virgoApp/Cm/v9r0/src/CmTransaction.h: 18

CmTransactionStatus = enum_anon_36# /virgoApp/Cm/v9r0/src/CmTransaction.h: 18

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 20
if _libs["libPyFd.so"].has("CmOpenTransaction", "cdecl"):
    CmOpenTransaction = _libs["libPyFd.so"].get("CmOpenTransaction", "cdecl")
    CmOpenTransaction.argtypes = [String, POINTER(None)]
    CmOpenTransaction.restype = c_int

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 21
if _libs["libPyFd.so"].has("CmCloseTransaction", "cdecl"):
    CmCloseTransaction = _libs["libPyFd.so"].get("CmCloseTransaction", "cdecl")
    CmCloseTransaction.argtypes = [c_int]
    CmCloseTransaction.restype = CmTransactionStatus

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 22
if _libs["libPyFd.so"].has("CmTerminateTransaction", "cdecl"):
    CmTerminateTransaction = _libs["libPyFd.so"].get("CmTerminateTransaction", "cdecl")
    CmTerminateTransaction.argtypes = [c_int]
    CmTerminateTransaction.restype = CmTransactionStatus

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 23
if _libs["libPyFd.so"].has("CmRestartTransaction", "cdecl"):
    CmRestartTransaction = _libs["libPyFd.so"].get("CmRestartTransaction", "cdecl")
    CmRestartTransaction.argtypes = [c_int]
    CmRestartTransaction.restype = CmTransactionStatus

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 24
if _libs["libPyFd.so"].has("CmGetTransactionState", "cdecl"):
    CmGetTransactionState = _libs["libPyFd.so"].get("CmGetTransactionState", "cdecl")
    CmGetTransactionState.argtypes = [c_int]
    CmGetTransactionState.restype = CmTransactionState

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 25
if _libs["libPyFd.so"].has("CmGetTransactionInfo", "cdecl"):
    CmGetTransactionInfo = _libs["libPyFd.so"].get("CmGetTransactionInfo", "cdecl")
    CmGetTransactionInfo.argtypes = [c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        CmGetTransactionInfo.restype = ReturnString
    else:
        CmGetTransactionInfo.restype = String
        CmGetTransactionInfo.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 26
if _libs["libPyFd.so"].has("CmGetTransactionObject", "cdecl"):
    CmGetTransactionObject = _libs["libPyFd.so"].get("CmGetTransactionObject", "cdecl")
    CmGetTransactionObject.argtypes = [c_int]
    CmGetTransactionObject.restype = POINTER(c_ubyte)
    CmGetTransactionObject.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 27
if _libs["libPyFd.so"].has("CmIsTransactionTerminated", "cdecl"):
    CmIsTransactionTerminated = _libs["libPyFd.so"].get("CmIsTransactionTerminated", "cdecl")
    CmIsTransactionTerminated.argtypes = [c_int]
    CmIsTransactionTerminated.restype = c_int

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 28
if _libs["libPyFd.so"].has("CmTerminatedTransactionCount", "cdecl"):
    CmTerminatedTransactionCount = _libs["libPyFd.so"].get("CmTerminatedTransactionCount", "cdecl")
    CmTerminatedTransactionCount.argtypes = []
    CmTerminatedTransactionCount.restype = c_int

# /virgoApp/Cm/v9r0/src/CmTransaction.h: 29
if _libs["libPyFd.so"].has("CmDumpTransactions", "cdecl"):
    CmDumpTransactions = _libs["libPyFd.so"].get("CmDumpTransactions", "cdecl")
    CmDumpTransactions.argtypes = []
    CmDumpTransactions.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 90
if _libs["libPyFd.so"].has("CmMessageForceStartup", "cdecl"):
    CmMessageForceStartup = _libs["libPyFd.so"].get("CmMessageForceStartup", "cdecl")
    CmMessageForceStartup.argtypes = [String]
    CmMessageForceStartup.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 91
if _libs["libPyFd.so"].has("CmMessageInitialize", "cdecl"):
    CmMessageInitialize = _libs["libPyFd.so"].get("CmMessageInitialize", "cdecl")
    CmMessageInitialize.argtypes = []
    CmMessageInitialize.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 92
if _libs["libPyFd.so"].has("CmMessageStartup", "cdecl"):
    CmMessageStartup = _libs["libPyFd.so"].get("CmMessageStartup", "cdecl")
    CmMessageStartup.argtypes = [String]
    CmMessageStartup.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 93
if _libs["libPyFd.so"].has("CmMessageStartupMultiple", "cdecl"):
    CmMessageStartupMultiple = _libs["libPyFd.so"].get("CmMessageStartupMultiple", "cdecl")
    CmMessageStartupMultiple.argtypes = [String]
    CmMessageStartupMultiple.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 94
if _libs["libPyFd.so"].has("CmMessageOpenServer", "cdecl"):
    CmMessageOpenServer = _libs["libPyFd.so"].get("CmMessageOpenServer", "cdecl")
    CmMessageOpenServer.argtypes = [String]
    CmMessageOpenServer.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 95
if _libs["libPyFd.so"].has("CmMessageOpenMultipleServer", "cdecl"):
    CmMessageOpenMultipleServer = _libs["libPyFd.so"].get("CmMessageOpenMultipleServer", "cdecl")
    CmMessageOpenMultipleServer.argtypes = [String]
    CmMessageOpenMultipleServer.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 96
if _libs["libPyFd.so"].has("CmMessageCloseServer", "cdecl"):
    CmMessageCloseServer = _libs["libPyFd.so"].get("CmMessageCloseServer", "cdecl")
    CmMessageCloseServer.argtypes = [String]
    CmMessageCloseServer.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 97
if _libs["libPyFd.so"].has("CmMessageCleanup", "cdecl"):
    CmMessageCleanup = _libs["libPyFd.so"].get("CmMessageCleanup", "cdecl")
    CmMessageCleanup.argtypes = []
    CmMessageCleanup.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 98
if _libs["libPyFd.so"].has("CmMessageCheckBalance", "cdecl"):
    CmMessageCheckBalance = _libs["libPyFd.so"].get("CmMessageCheckBalance", "cdecl")
    CmMessageCheckBalance.argtypes = []
    CmMessageCheckBalance.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 99
if _libs["libPyFd.so"].has("CmMessageInstallPrinter", "cdecl"):
    CmMessageInstallPrinter = _libs["libPyFd.so"].get("CmMessageInstallPrinter", "cdecl")
    CmMessageInstallPrinter.argtypes = [CmConnectPrinter]
    CmMessageInstallPrinter.restype = CmConnectPrinter

# /virgoApp/Cm/v9r0/src/CmMessage.h: 100
if _libs["libPyFd.so"].has("CmMessageNew", "cdecl"):
    CmMessageNew = _libs["libPyFd.so"].get("CmMessageNew", "cdecl")
    CmMessageNew.argtypes = []
    CmMessageNew.restype = CmMessage

# /virgoApp/Cm/v9r0/src/CmMessage.h: 101
if _libs["libPyFd.so"].has("CmMessageDelete", "cdecl"):
    CmMessageDelete = _libs["libPyFd.so"].get("CmMessageDelete", "cdecl")
    CmMessageDelete.argtypes = [CmMessage]
    CmMessageDelete.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 102
if _libs["libPyFd.so"].has("CmMessageReset", "cdecl"):
    CmMessageReset = _libs["libPyFd.so"].get("CmMessageReset", "cdecl")
    CmMessageReset.argtypes = [CmMessage]
    CmMessageReset.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 103
if _libs["libPyFd.so"].has("CmMessageSetType", "cdecl"):
    CmMessageSetType = _libs["libPyFd.so"].get("CmMessageSetType", "cdecl")
    CmMessageSetType.argtypes = [CmMessage, String]
    CmMessageSetType.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 104
if _libs["libPyFd.so"].has("CmMessageGetType", "cdecl"):
    CmMessageGetType = _libs["libPyFd.so"].get("CmMessageGetType", "cdecl")
    CmMessageGetType.argtypes = [CmMessage]
    if sizeof(c_int) == sizeof(c_void_p):
        CmMessageGetType.restype = ReturnString
    else:
        CmMessageGetType.restype = String
        CmMessageGetType.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmMessage.h: 105
if _libs["libPyFd.so"].has("CmMessageGetState", "cdecl"):
    CmMessageGetState = _libs["libPyFd.so"].get("CmMessageGetState", "cdecl")
    CmMessageGetState.argtypes = [CmMessage]
    CmMessageGetState.restype = CmMessageState

# /virgoApp/Cm/v9r0/src/CmMessage.h: 106
if _libs["libPyFd.so"].has("CmMessageGetConnect", "cdecl"):
    CmMessageGetConnect = _libs["libPyFd.so"].get("CmMessageGetConnect", "cdecl")
    CmMessageGetConnect.argtypes = [CmMessage]
    CmMessageGetConnect.restype = CmConnect

# /virgoApp/Cm/v9r0/src/CmMessage.h: 107
if _libs["libPyFd.so"].has("CmMessageGetMessageLength", "cdecl"):
    CmMessageGetMessageLength = _libs["libPyFd.so"].get("CmMessageGetMessageLength", "cdecl")
    CmMessageGetMessageLength.argtypes = [CmMessage]
    CmMessageGetMessageLength.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 108
if _libs["libPyFd.so"].has("CmMessageSend", "cdecl"):
    CmMessageSend = _libs["libPyFd.so"].get("CmMessageSend", "cdecl")
    CmMessageSend.argtypes = [CmMessage, String]
    CmMessageSend.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 109
if _libs["libPyFd.so"].has("CmMessagePost", "cdecl"):
    CmMessagePost = _libs["libPyFd.so"].get("CmMessagePost", "cdecl")
    CmMessagePost.argtypes = [CmMessage, String, POINTER(CmMessageHandler)]
    CmMessagePost.restype = CmMessageIterator

# /virgoApp/Cm/v9r0/src/CmMessage.h: 110
if _libs["libPyFd.so"].has("CmMessagePrepareHandler", "cdecl"):
    CmMessagePrepareHandler = _libs["libPyFd.so"].get("CmMessagePrepareHandler", "cdecl")
    CmMessagePrepareHandler.argtypes = [CmConnect]
    CmMessagePrepareHandler.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 111
if _libs["libPyFd.so"].has("CmMessageInstallDefaultHandler", "cdecl"):
    CmMessageInstallDefaultHandler = _libs["libPyFd.so"].get("CmMessageInstallDefaultHandler", "cdecl")
    CmMessageInstallDefaultHandler.argtypes = [POINTER(CmMessageHandler)]
    CmMessageInstallDefaultHandler.restype = CmMessageHandler

# /virgoApp/Cm/v9r0/src/CmMessage.h: 112
if _libs["libPyFd.so"].has("CmMessageInstallHandler", "cdecl"):
    CmMessageInstallHandler = _libs["libPyFd.so"].get("CmMessageInstallHandler", "cdecl")
    CmMessageInstallHandler.argtypes = [POINTER(CmMessageHandler), String]
    CmMessageInstallHandler.restype = CmMessageHandler

# /virgoApp/Cm/v9r0/src/CmMessage.h: 113
if _libs["libPyFd.so"].has("CmMessageUninstallHandler", "cdecl"):
    CmMessageUninstallHandler = _libs["libPyFd.so"].get("CmMessageUninstallHandler", "cdecl")
    CmMessageUninstallHandler.argtypes = [String]
    CmMessageUninstallHandler.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 114
if _libs["libPyFd.so"].has("CmMessageAreYouThere", "cdecl"):
    CmMessageAreYouThere = _libs["libPyFd.so"].get("CmMessageAreYouThere", "cdecl")
    CmMessageAreYouThere.argtypes = [String]
    CmMessageAreYouThere.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 115
if _libs["libPyFd.so"].has("CmMessageCheck", "cdecl"):
    CmMessageCheck = _libs["libPyFd.so"].get("CmMessageCheck", "cdecl")
    CmMessageCheck.argtypes = []
    CmMessageCheck.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 116
if _libs["libPyFd.so"].has("CmMessageWait", "cdecl"):
    CmMessageWait = _libs["libPyFd.so"].get("CmMessageWait", "cdecl")
    CmMessageWait.argtypes = []
    CmMessageWait.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 117
if _libs["libPyFd.so"].has("CmMessageWaitWithTimeout", "cdecl"):
    CmMessageWaitWithTimeout = _libs["libPyFd.so"].get("CmMessageWaitWithTimeout", "cdecl")
    CmMessageWaitWithTimeout.argtypes = [c_double]
    CmMessageWaitWithTimeout.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 118
if _libs["libPyFd.so"].has("CmMessageServerCheck", "cdecl"):
    CmMessageServerCheck = _libs["libPyFd.so"].get("CmMessageServerCheck", "cdecl")
    CmMessageServerCheck.argtypes = [String]
    CmMessageServerCheck.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 119
if _libs["libPyFd.so"].has("CmMessageServerWait", "cdecl"):
    CmMessageServerWait = _libs["libPyFd.so"].get("CmMessageServerWait", "cdecl")
    CmMessageServerWait.argtypes = [String]
    CmMessageServerWait.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 120
if _libs["libPyFd.so"].has("CmMessageServerWaitWithTimeout", "cdecl"):
    CmMessageServerWaitWithTimeout = _libs["libPyFd.so"].get("CmMessageServerWaitWithTimeout", "cdecl")
    CmMessageServerWaitWithTimeout.argtypes = [String, c_double]
    CmMessageServerWaitWithTimeout.restype = CmConnectCondition

# /virgoApp/Cm/v9r0/src/CmMessage.h: 121
if _libs["libPyFd.so"].has("CmMessageTraceOn", "cdecl"):
    CmMessageTraceOn = _libs["libPyFd.so"].get("CmMessageTraceOn", "cdecl")
    CmMessageTraceOn.argtypes = [c_int]
    CmMessageTraceOn.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 122
if _libs["libPyFd.so"].has("CmMessageTraceOff", "cdecl"):
    CmMessageTraceOff = _libs["libPyFd.so"].get("CmMessageTraceOff", "cdecl")
    CmMessageTraceOff.argtypes = []
    CmMessageTraceOff.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 123
if _libs["libPyFd.so"].has("CmMessageGetItemType", "cdecl"):
    CmMessageGetItemType = _libs["libPyFd.so"].get("CmMessageGetItemType", "cdecl")
    CmMessageGetItemType.argtypes = [CmMessage]
    CmMessageGetItemType.restype = CmMessageItemType

# /virgoApp/Cm/v9r0/src/CmMessage.h: 124
if _libs["libPyFd.so"].has("CmMessagePutChar", "cdecl"):
    CmMessagePutChar = _libs["libPyFd.so"].get("CmMessagePutChar", "cdecl")
    CmMessagePutChar.argtypes = [CmMessage, c_char]
    CmMessagePutChar.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 125
if _libs["libPyFd.so"].has("CmMessageGetChar", "cdecl"):
    CmMessageGetChar = _libs["libPyFd.so"].get("CmMessageGetChar", "cdecl")
    CmMessageGetChar.argtypes = [CmMessage]
    CmMessageGetChar.restype = c_char

# /virgoApp/Cm/v9r0/src/CmMessage.h: 126
if _libs["libPyFd.so"].has("CmMessagePutShort", "cdecl"):
    CmMessagePutShort = _libs["libPyFd.so"].get("CmMessagePutShort", "cdecl")
    CmMessagePutShort.argtypes = [CmMessage, c_short]
    CmMessagePutShort.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 127
if _libs["libPyFd.so"].has("CmMessageGetShort", "cdecl"):
    CmMessageGetShort = _libs["libPyFd.so"].get("CmMessageGetShort", "cdecl")
    CmMessageGetShort.argtypes = [CmMessage]
    CmMessageGetShort.restype = c_short

# /virgoApp/Cm/v9r0/src/CmMessage.h: 128
if _libs["libPyFd.so"].has("CmMessagePutInt", "cdecl"):
    CmMessagePutInt = _libs["libPyFd.so"].get("CmMessagePutInt", "cdecl")
    CmMessagePutInt.argtypes = [CmMessage, c_int]
    CmMessagePutInt.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 129
if _libs["libPyFd.so"].has("CmMessageGetInt", "cdecl"):
    CmMessageGetInt = _libs["libPyFd.so"].get("CmMessageGetInt", "cdecl")
    CmMessageGetInt.argtypes = [CmMessage]
    CmMessageGetInt.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 130
if _libs["libPyFd.so"].has("CmMessagePutLong", "cdecl"):
    CmMessagePutLong = _libs["libPyFd.so"].get("CmMessagePutLong", "cdecl")
    CmMessagePutLong.argtypes = [CmMessage, c_long]
    CmMessagePutLong.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 131
if _libs["libPyFd.so"].has("CmMessageGetLong", "cdecl"):
    CmMessageGetLong = _libs["libPyFd.so"].get("CmMessageGetLong", "cdecl")
    CmMessageGetLong.argtypes = [CmMessage]
    CmMessageGetLong.restype = c_long

# /virgoApp/Cm/v9r0/src/CmMessage.h: 132
if _libs["libPyFd.so"].has("CmMessagePutFloat", "cdecl"):
    CmMessagePutFloat = _libs["libPyFd.so"].get("CmMessagePutFloat", "cdecl")
    CmMessagePutFloat.argtypes = [CmMessage, c_float]
    CmMessagePutFloat.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 133
if _libs["libPyFd.so"].has("CmMessageGetFloat", "cdecl"):
    CmMessageGetFloat = _libs["libPyFd.so"].get("CmMessageGetFloat", "cdecl")
    CmMessageGetFloat.argtypes = [CmMessage]
    CmMessageGetFloat.restype = c_float

# /virgoApp/Cm/v9r0/src/CmMessage.h: 134
if _libs["libPyFd.so"].has("CmMessagePutDouble", "cdecl"):
    CmMessagePutDouble = _libs["libPyFd.so"].get("CmMessagePutDouble", "cdecl")
    CmMessagePutDouble.argtypes = [CmMessage, c_double]
    CmMessagePutDouble.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 135
if _libs["libPyFd.so"].has("CmMessageGetDouble", "cdecl"):
    CmMessageGetDouble = _libs["libPyFd.so"].get("CmMessageGetDouble", "cdecl")
    CmMessageGetDouble.argtypes = [CmMessage]
    CmMessageGetDouble.restype = c_double

# /virgoApp/Cm/v9r0/src/CmMessage.h: 136
if _libs["libPyFd.so"].has("CmMessagePutArray", "cdecl"):
    CmMessagePutArray = _libs["libPyFd.so"].get("CmMessagePutArray", "cdecl")
    CmMessagePutArray.argtypes = [CmMessage, CmMessageArrayType, c_int, POINTER(None)]
    CmMessagePutArray.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 137
if _libs["libPyFd.so"].has("CmMessagePutExtArray", "cdecl"):
    CmMessagePutExtArray = _libs["libPyFd.so"].get("CmMessagePutExtArray", "cdecl")
    CmMessagePutExtArray.argtypes = [CmMessage, CmMessageArrayType, c_int, POINTER(None)]
    CmMessagePutExtArray.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 138
if _libs["libPyFd.so"].has("CmMessageGetArray", "cdecl"):
    CmMessageGetArray = _libs["libPyFd.so"].get("CmMessageGetArray", "cdecl")
    CmMessageGetArray.argtypes = [CmMessage, POINTER(CmMessageArrayType), POINTER(c_int)]
    CmMessageGetArray.restype = POINTER(c_ubyte)
    CmMessageGetArray.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cm/v9r0/src/CmMessage.h: 139
if _libs["libPyFd.so"].has("CmMessagePutText", "cdecl"):
    CmMessagePutText = _libs["libPyFd.so"].get("CmMessagePutText", "cdecl")
    CmMessagePutText.argtypes = [CmMessage, String]
    CmMessagePutText.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 140
if _libs["libPyFd.so"].has("CmMessageGetText", "cdecl"):
    CmMessageGetText = _libs["libPyFd.so"].get("CmMessageGetText", "cdecl")
    CmMessageGetText.argtypes = [CmMessage]
    if sizeof(c_int) == sizeof(c_void_p):
        CmMessageGetText.restype = ReturnString
    else:
        CmMessageGetText.restype = String
        CmMessageGetText.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmMessage.h: 141
if _libs["libPyFd.so"].has("CmMessagePutBytes", "cdecl"):
    CmMessagePutBytes = _libs["libPyFd.so"].get("CmMessagePutBytes", "cdecl")
    CmMessagePutBytes.argtypes = [CmMessage, String, c_int]
    CmMessagePutBytes.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 142
if _libs["libPyFd.so"].has("CmMessageGetBytes", "cdecl"):
    CmMessageGetBytes = _libs["libPyFd.so"].get("CmMessageGetBytes", "cdecl")
    CmMessageGetBytes.argtypes = [CmMessage, POINTER(c_int)]
    if sizeof(c_int) == sizeof(c_void_p):
        CmMessageGetBytes.restype = ReturnString
    else:
        CmMessageGetBytes.restype = String
        CmMessageGetBytes.errcheck = ReturnString

# /virgoApp/Cm/v9r0/src/CmMessage.h: 143
if _libs["libPyFd.so"].has("CmMessageIteratorDelete", "cdecl"):
    CmMessageIteratorDelete = _libs["libPyFd.so"].get("CmMessageIteratorDelete", "cdecl")
    CmMessageIteratorDelete.argtypes = [CmMessageIterator]
    CmMessageIteratorDelete.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 144
if _libs["libPyFd.so"].has("CmMessageIteratorStop", "cdecl"):
    CmMessageIteratorStop = _libs["libPyFd.so"].get("CmMessageIteratorStop", "cdecl")
    CmMessageIteratorStop.argtypes = [CmMessageIterator]
    CmMessageIteratorStop.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 145
if _libs["libPyFd.so"].has("CmMessageIteratorCallHandler", "cdecl"):
    CmMessageIteratorCallHandler = _libs["libPyFd.so"].get("CmMessageIteratorCallHandler", "cdecl")
    CmMessageIteratorCallHandler.argtypes = [CmMessageIterator]
    CmMessageIteratorCallHandler.restype = CmMessageStatus

# /virgoApp/Cm/v9r0/src/CmMessage.h: 146
if _libs["libPyFd.so"].has("CmMessageIteratorFinished", "cdecl"):
    CmMessageIteratorFinished = _libs["libPyFd.so"].get("CmMessageIteratorFinished", "cdecl")
    CmMessageIteratorFinished.argtypes = [CmMessageIterator]
    CmMessageIteratorFinished.restype = c_int

# /virgoApp/Cm/v9r0/src/CmMessage.h: 147
if _libs["libPyFd.so"].has("CmMessageIteratorForth", "cdecl"):
    CmMessageIteratorForth = _libs["libPyFd.so"].get("CmMessageIteratorForth", "cdecl")
    CmMessageIteratorForth.argtypes = [CmMessageIterator]
    CmMessageIteratorForth.restype = None

# /virgoApp/Cm/v9r0/src/CmMessage.h: 148
if _libs["libPyFd.so"].has("CmMessageCallHandler", "cdecl"):
    CmMessageCallHandler = _libs["libPyFd.so"].get("CmMessageCallHandler", "cdecl")
    CmMessageCallHandler.argtypes = [CmMessage]
    CmMessageCallHandler.restype = CmConnectStatus

enum_CfgType = c_int# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgNone = 0# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgFlag = (CfgNone + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgConstString = (CfgFlag + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgString = (CfgConstString + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgBoolean = (CfgString + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgReal = (CfgBoolean + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgHex = (CfgReal + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgDec = (CfgHex + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgFunction = (CfgDec + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgEnum = (CfgFunction + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgProcessing = (CfgEnum + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgGetFunction = (CfgProcessing + 1)# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

CfgType_t = enum_CfgType# /virgoApp/Cfg/v9r0/src/CfgParse.h: 64

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 69
class union_CfgDouble(Union):
    pass

union_CfgDouble.__slots__ = [
    'i',
    'd',
]
union_CfgDouble._fields_ = [
    ('i', Ulong * int(2)),
    ('d', c_double),
]

CfgDouble_t = union_CfgDouble# /virgoApp/Cfg/v9r0/src/CfgParse.h: 69

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 71
class struct_CfgParse(Structure):
    pass

CfgParse_t = struct_CfgParse# /virgoApp/Cfg/v9r0/src/CfgParse.h: 71

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 72
class struct_CfgDataType(Structure):
    pass

CfgDataType_t = struct_CfgDataType# /virgoApp/Cfg/v9r0/src/CfgParse.h: 72

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 74
if _libs["libPyFd.so"].has("CfgBufToFile", "cdecl"):
    CfgBufToFile = _libs["libPyFd.so"].get("CfgBufToFile", "cdecl")
    CfgBufToFile.argtypes = [String, String]
    CfgBufToFile.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 75
if _libs["libPyFd.so"].has("CfgDbGet", "cdecl"):
    CfgDbGet = _libs["libPyFd.so"].get("CfgDbGet", "cdecl")
    CfgDbGet.argtypes = [c_int, POINTER(None), CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), ), CFUNCTYPE(UNCHECKED(String), )]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDbGet.restype = ReturnString
    else:
        CfgDbGet.restype = String
        CfgDbGet.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 76
if _libs["libPyFd.so"].has("CfgDbPut", "cdecl"):
    CfgDbPut = _libs["libPyFd.so"].get("CfgDbPut", "cdecl")
    CfgDbPut.argtypes = [String, String, CFUNCTYPE(UNCHECKED(None), )]
    CfgDbPut.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 77
if _libs["libPyFd.so"].has("CfgFileToBuf", "cdecl"):
    CfgFileToBuf = _libs["libPyFd.so"].get("CfgFileToBuf", "cdecl")
    CfgFileToBuf.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgFileToBuf.restype = ReturnString
    else:
        CfgFileToBuf.restype = String
        CfgFileToBuf.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 78
if _libs["libPyFd.so"].has("CfgMapFile", "cdecl"):
    CfgMapFile = _libs["libPyFd.so"].get("CfgMapFile", "cdecl")
    CfgMapFile.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgMapFile.restype = ReturnString
    else:
        CfgMapFile.restype = String
        CfgMapFile.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 79
if _libs["libPyFd.so"].has("CfgParseAdd", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgParseAdd", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(CfgParse_t), String, c_int]
    CfgParseAdd = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 80
if _libs["libPyFd.so"].has("CfgParseArg", "cdecl"):
    CfgParseArg = _libs["libPyFd.so"].get("CfgParseArg", "cdecl")
    CfgParseArg.argtypes = [POINTER(CfgParse_t), c_int, POINTER(POINTER(c_char))]
    CfgParseArg.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 81
if _libs["libPyFd.so"].has("CfgParseBuffer", "cdecl"):
    CfgParseBuffer = _libs["libPyFd.so"].get("CfgParseBuffer", "cdecl")
    CfgParseBuffer.argtypes = [POINTER(CfgParse_t), String]
    CfgParseBuffer.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 82
if _libs["libPyFd.so"].has("CfgParseExtract", "cdecl"):
    CfgParseExtract = _libs["libPyFd.so"].get("CfgParseExtract", "cdecl")
    CfgParseExtract.argtypes = [POINTER(CfgParse_t), String, CfgBool_t]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgParseExtract.restype = ReturnString
    else:
        CfgParseExtract.restype = String
        CfgParseExtract.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 83
if _libs["libPyFd.so"].has("CfgParseFile", "cdecl"):
    CfgParseFile = _libs["libPyFd.so"].get("CfgParseFile", "cdecl")
    CfgParseFile.argtypes = [POINTER(CfgParse_t), String]
    CfgParseFile.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 84
if _libs["libPyFd.so"].has("CfgParseFree", "cdecl"):
    CfgParseFree = _libs["libPyFd.so"].get("CfgParseFree", "cdecl")
    CfgParseFree.argtypes = [POINTER(CfgParse_t)]
    CfgParseFree.restype = POINTER(CfgParse_t)

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 85
if _libs["libPyFd.so"].has("CfgParseFunctionAdd", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgParseFunctionAdd", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(CfgParse_t), String, CFUNCTYPE(UNCHECKED(c_int), ), POINTER(None), c_int]
    CfgParseFunctionAdd = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 87
if _libs["libPyFd.so"].has("CfgParseGetFunctionAdd", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgParseGetFunctionAdd", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(CfgParse_t), String, CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(CfgDataType_t)), POINTER(None), c_int]
    CfgParseGetFunctionAdd = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 92
if _libs["libPyFd.so"].has("CfgParseGetNextReal", "cdecl"):
    CfgParseGetNextReal = _libs["libPyFd.so"].get("CfgParseGetNextReal", "cdecl")
    CfgParseGetNextReal.argtypes = [POINTER(CfgDataType_t)]
    CfgParseGetNextReal.restype = c_double

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 93
if _libs["libPyFd.so"].has("CfgParseGetNextHex", "cdecl"):
    CfgParseGetNextHex = _libs["libPyFd.so"].get("CfgParseGetNextHex", "cdecl")
    CfgParseGetNextHex.argtypes = [POINTER(CfgDataType_t)]
    CfgParseGetNextHex.restype = c_long

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 94
if _libs["libPyFd.so"].has("CfgParseGetNextDec", "cdecl"):
    CfgParseGetNextDec = _libs["libPyFd.so"].get("CfgParseGetNextDec", "cdecl")
    CfgParseGetNextDec.argtypes = [POINTER(CfgDataType_t)]
    CfgParseGetNextDec.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 95
if _libs["libPyFd.so"].has("CfgParseGetNextString", "cdecl"):
    CfgParseGetNextString = _libs["libPyFd.so"].get("CfgParseGetNextString", "cdecl")
    CfgParseGetNextString.argtypes = [POINTER(CfgDataType_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgParseGetNextString.restype = ReturnString
    else:
        CfgParseGetNextString.restype = String
        CfgParseGetNextString.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 96
if _libs["libPyFd.so"].has("CfgParseGetNextConstString", "cdecl"):
    CfgParseGetNextConstString = _libs["libPyFd.so"].get("CfgParseGetNextConstString", "cdecl")
    CfgParseGetNextConstString.argtypes = [POINTER(CfgDataType_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgParseGetNextConstString.restype = ReturnString
    else:
        CfgParseGetNextConstString.restype = String
        CfgParseGetNextConstString.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 97
if _libs["libPyFd.so"].has("CfgParseGetNextEnum", "cdecl"):
    CfgParseGetNextEnum = _libs["libPyFd.so"].get("CfgParseGetNextEnum", "cdecl")
    CfgParseGetNextEnum.argtypes = [POINTER(CfgDataType_t)]
    CfgParseGetNextEnum.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 99
if _libs["libPyFd.so"].has("CfgParseGetResult", "cdecl"):
    CfgParseGetResult = _libs["libPyFd.so"].get("CfgParseGetResult", "cdecl")
    CfgParseGetResult.argtypes = [POINTER(CfgDataType_t)]
    CfgParseGetResult.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 101
if _libs["libPyFd.so"].has("CfgParseNew", "cdecl"):
    CfgParseNew = _libs["libPyFd.so"].get("CfgParseNew", "cdecl")
    CfgParseNew.argtypes = []
    CfgParseNew.restype = POINTER(CfgParse_t)

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 102
if _libs["libPyFd.so"].has("CfgParseSetEnumAttr", "cdecl"):
    CfgParseSetEnumAttr = _libs["libPyFd.so"].get("CfgParseSetEnumAttr", "cdecl")
    CfgParseSetEnumAttr.argtypes = [POINTER(CfgParse_t), String, c_long]
    CfgParseSetEnumAttr.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 103
if _libs["libPyFd.so"].has("CfgPrintError", "cdecl"):
    CfgPrintError = _libs["libPyFd.so"].get("CfgPrintError", "cdecl")
    CfgPrintError.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CfgPrintError.restype = ReturnString
    else:
        CfgPrintError.restype = String
        CfgPrintError.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 104
if _libs["libPyFd.so"].has("CfgSetErrorMsg", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgSetErrorMsg", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgSetErrorMsg = _variadic_function(_func,_restype,_argtypes,_errcheck)

enum_CfgOutStatus = c_int# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutNone = 0# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutUnknownByNS = (CfgOutNone + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutConnectInProgress = (CfgOutUnknownByNS + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutHostUnreachable = (CfgOutConnectInProgress + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutHostAlive = (CfgOutHostUnreachable + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutMsgSending = (CfgOutHostAlive + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutMsgNew = (CfgOutMsgSending + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

CfgOutStatus_t = enum_CfgOutStatus# /virgoApp/Cfg/v9r0/src/CfgOut.h: 47

enum_CfgOutRequest = c_int# /virgoApp/Cfg/v9r0/src/CfgOut.h: 53

CfgOutStatic = 0# /virgoApp/Cfg/v9r0/src/CfgOut.h: 53

CfgOutDynamic = (CfgOutStatic + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 53

CfgOutOnRequest = (CfgOutDynamic + 1)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 53

CfgOutRequest_t = enum_CfgOutRequest# /virgoApp/Cfg/v9r0/src/CfgOut.h: 53

CfgOutPrinter_t = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 62

CfgOutBuildMsg_t = CFUNCTYPE(UNCHECKED(c_int), CmMessage, POINTER(None), String, String)# /virgoApp/Cfg/v9r0/src/CfgOut.h: 63

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 66
if _libs["libPyFd.so"].has("CfgOutCmEnd", "cdecl"):
    CfgOutCmEnd = _libs["libPyFd.so"].get("CfgOutCmEnd", "cdecl")
    CfgOutCmEnd.argtypes = []
    CfgOutCmEnd.restype = None

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 67
if _libs["libPyFd.so"].has("CfgOutCmInit", "cdecl"):
    CfgOutCmInit = _libs["libPyFd.so"].get("CfgOutCmInit", "cdecl")
    CfgOutCmInit.argtypes = []
    CfgOutCmInit.restype = None

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 68
if _libs["libPyFd.so"].has("CfgOutDomainGroupAdd", "cdecl"):
    CfgOutDomainGroupAdd = _libs["libPyFd.so"].get("CfgOutDomainGroupAdd", "cdecl")
    CfgOutDomainGroupAdd.argtypes = [String, String]
    CfgOutDomainGroupAdd.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 69
if _libs["libPyFd.so"].has("CfgOutDomainGroupRemove", "cdecl"):
    CfgOutDomainGroupRemove = _libs["libPyFd.so"].get("CfgOutDomainGroupRemove", "cdecl")
    CfgOutDomainGroupRemove.argtypes = [String, String]
    CfgOutDomainGroupRemove.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 70
if _libs["libPyFd.so"].has("CfgOutInstallPrinter", "cdecl"):
    CfgOutInstallPrinter = _libs["libPyFd.so"].get("CfgOutInstallPrinter", "cdecl")
    CfgOutInstallPrinter.argtypes = [CfgOutPrinter_t]
    CfgOutInstallPrinter.restype = CfgOutPrinter_t

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 71
if _libs["libPyFd.so"].has("CfgOutGroupConsumerAdd", "cdecl"):
    CfgOutGroupConsumerAdd = _libs["libPyFd.so"].get("CfgOutGroupConsumerAdd", "cdecl")
    CfgOutGroupConsumerAdd.argtypes = [String, String, c_int, c_int, CfgOutRequest_t, String, String]
    CfgOutGroupConsumerAdd.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 74
if _libs["libPyFd.so"].has("CfgOutGroupConsumerDataAdd", "cdecl"):
    CfgOutGroupConsumerDataAdd = _libs["libPyFd.so"].get("CfgOutGroupConsumerDataAdd", "cdecl")
    CfgOutGroupConsumerDataAdd.argtypes = [String, String, Ulong]
    CfgOutGroupConsumerDataAdd.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 75
if _libs["libPyFd.so"].has("CfgOutGroupConsumerPost", "cdecl"):
    CfgOutGroupConsumerPost = _libs["libPyFd.so"].get("CfgOutGroupConsumerPost", "cdecl")
    CfgOutGroupConsumerPost.argtypes = [String, String, CfgOutBuildMsg_t, POINTER(None)]
    CfgOutGroupConsumerPost.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 77
if _libs["libPyFd.so"].has("CfgOutGroupConsumerRemove", "cdecl"):
    CfgOutGroupConsumerRemove = _libs["libPyFd.so"].get("CfgOutGroupConsumerRemove", "cdecl")
    CfgOutGroupConsumerRemove.argtypes = [String, String]
    CfgOutGroupConsumerRemove.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 78
if _libs["libPyFd.so"].has("CfgOutGroupConsumerRequest", "cdecl"):
    CfgOutGroupConsumerRequest = _libs["libPyFd.so"].get("CfgOutGroupConsumerRequest", "cdecl")
    CfgOutGroupConsumerRequest.argtypes = [String, String, CfgOutBuildMsg_t, POINTER(None), c_double]
    CfgOutGroupConsumerRequest.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 81
if _libs["libPyFd.so"].has("CfgOutGroupConsumerStatusGet", "cdecl"):
    CfgOutGroupConsumerStatusGet = _libs["libPyFd.so"].get("CfgOutGroupConsumerStatusGet", "cdecl")
    CfgOutGroupConsumerStatusGet.argtypes = [String, String]
    CfgOutGroupConsumerStatusGet.restype = CfgOutStatus_t

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 82
if _libs["libPyFd.so"].has("CfgOutGroupDebugSet", "cdecl"):
    CfgOutGroupDebugSet = _libs["libPyFd.so"].get("CfgOutGroupDebugSet", "cdecl")
    CfgOutGroupDebugSet.argtypes = [String, c_int]
    CfgOutGroupDebugSet.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 83
if _libs["libPyFd.so"].has("CfgOutGroupDefaultGet", "cdecl"):
    CfgOutGroupDefaultGet = _libs["libPyFd.so"].get("CfgOutGroupDefaultGet", "cdecl")
    CfgOutGroupDefaultGet.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CfgOutGroupDefaultGet.restype = ReturnString
    else:
        CfgOutGroupDefaultGet.restype = String
        CfgOutGroupDefaultGet.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 84
if _libs["libPyFd.so"].has("CfgOutGroupDefaultSet", "cdecl"):
    CfgOutGroupDefaultSet = _libs["libPyFd.so"].get("CfgOutGroupDefaultSet", "cdecl")
    CfgOutGroupDefaultSet.argtypes = [String]
    CfgOutGroupDefaultSet.restype = None

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 85
if _libs["libPyFd.so"].has("CfgOutGroupFree", "cdecl"):
    CfgOutGroupFree = _libs["libPyFd.so"].get("CfgOutGroupFree", "cdecl")
    CfgOutGroupFree.argtypes = [String]
    CfgOutGroupFree.restype = None

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 86
if _libs["libPyFd.so"].has("CfgOutGroupInstallBuilder", "cdecl"):
    CfgOutGroupInstallBuilder = _libs["libPyFd.so"].get("CfgOutGroupInstallBuilder", "cdecl")
    CfgOutGroupInstallBuilder.argtypes = [String, CfgOutBuildMsg_t, POINTER(None)]
    CfgOutGroupInstallBuilder.restype = CfgOutBuildMsg_t

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 89
if _libs["libPyFd.so"].has("CfgOutGroupNbConsumerGet", "cdecl"):
    CfgOutGroupNbConsumerGet = _libs["libPyFd.so"].get("CfgOutGroupNbConsumerGet", "cdecl")
    CfgOutGroupNbConsumerGet.argtypes = [String]
    CfgOutGroupNbConsumerGet.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 90
if _libs["libPyFd.so"].has("CfgOutGroupNew", "cdecl"):
    CfgOutGroupNew = _libs["libPyFd.so"].get("CfgOutGroupNew", "cdecl")
    CfgOutGroupNew.argtypes = [String, POINTER(CfgParse_t), c_int, c_int, c_int, c_int]
    CfgOutGroupNew.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 92
if _libs["libPyFd.so"].has("CfgOutGroupNsPeriodSet", "cdecl"):
    CfgOutGroupNsPeriodSet = _libs["libPyFd.so"].get("CfgOutGroupNsPeriodSet", "cdecl")
    CfgOutGroupNsPeriodSet.argtypes = [String, c_int]
    CfgOutGroupNsPeriodSet.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 93
if _libs["libPyFd.so"].has("CfgOutGroupPost", "cdecl"):
    CfgOutGroupPost = _libs["libPyFd.so"].get("CfgOutGroupPost", "cdecl")
    CfgOutGroupPost.argtypes = [String, CfgOutBuildMsg_t, POINTER(None)]
    CfgOutGroupPost.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 94
if _libs["libPyFd.so"].has("CfgOutGroupStatusGet", "cdecl"):
    CfgOutGroupStatusGet = _libs["libPyFd.so"].get("CfgOutGroupStatusGet", "cdecl")
    CfgOutGroupStatusGet.argtypes = [String, String, POINTER(CfgOutStatus_t)]
    CfgOutGroupStatusGet.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 96
if _libs["libPyFd.so"].has("CfgOutGroupThresholdSet", "cdecl"):
    CfgOutGroupThresholdSet = _libs["libPyFd.so"].get("CfgOutGroupThresholdSet", "cdecl")
    CfgOutGroupThresholdSet.argtypes = [String, c_int]
    CfgOutGroupThresholdSet.restype = None

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 97
if _libs["libPyFd.so"].has("CfgOutGroupUninstallBuilder", "cdecl"):
    CfgOutGroupUninstallBuilder = _libs["libPyFd.so"].get("CfgOutGroupUninstallBuilder", "cdecl")
    CfgOutGroupUninstallBuilder.argtypes = [String]
    CfgOutGroupUninstallBuilder.restype = CfgOutBuildMsg_t

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 98
if _libs["libPyFd.so"].has("CfgOutParserInit", "cdecl"):
    CfgOutParserInit = _libs["libPyFd.so"].get("CfgOutParserInit", "cdecl")
    CfgOutParserInit.argtypes = [POINTER(CfgParse_t)]
    CfgOutParserInit.restype = c_int

# /usr/include/libio.h: 246
class struct__IO_FILE(Structure):
    pass

FILE = struct__IO_FILE# /usr/include/stdio.h: 48

__FILE = struct__IO_FILE# /usr/include/stdio.h: 64

# /usr/include/wchar.h: 85
class union_anon_37(Union):
    pass

union_anon_37.__slots__ = [
    '__wch',
    '__wchb',
]
union_anon_37._fields_ = [
    ('__wch', c_uint),
    ('__wchb', c_char * int(4)),
]

# /usr/include/wchar.h: 94
class struct_anon_38(Structure):
    pass

struct_anon_38.__slots__ = [
    '__count',
    '__value',
]
struct_anon_38._fields_ = [
    ('__count', c_int),
    ('__value', union_anon_37),
]

__mbstate_t = struct_anon_38# /usr/include/wchar.h: 94

# /usr/include/_G_config.h: 25
class struct_anon_39(Structure):
    pass

struct_anon_39.__slots__ = [
    '__pos',
    '__state',
]
struct_anon_39._fields_ = [
    ('__pos', __off_t),
    ('__state', __mbstate_t),
]

_G_fpos_t = struct_anon_39# /usr/include/_G_config.h: 25

# /usr/include/_G_config.h: 30
class struct_anon_40(Structure):
    pass

struct_anon_40.__slots__ = [
    '__pos',
    '__state',
]
struct_anon_40._fields_ = [
    ('__pos', __off64_t),
    ('__state', __mbstate_t),
]

_G_fpos64_t = struct_anon_40# /usr/include/_G_config.h: 30

# /usr/include/libio.h: 145
class struct__IO_jump_t(Structure):
    pass

_IO_lock_t = None# /usr/include/libio.h: 155

# /usr/include/libio.h: 161
class struct__IO_marker(Structure):
    pass

struct__IO_marker.__slots__ = [
    '_next',
    '_sbuf',
    '_pos',
]
struct__IO_marker._fields_ = [
    ('_next', POINTER(struct__IO_marker)),
    ('_sbuf', POINTER(struct__IO_FILE)),
    ('_pos', c_int),
]

enum___codecvt_result = c_int# /usr/include/libio.h: 181

__codecvt_ok = 0# /usr/include/libio.h: 181

__codecvt_partial = (__codecvt_ok + 1)# /usr/include/libio.h: 181

__codecvt_error = (__codecvt_partial + 1)# /usr/include/libio.h: 181

__codecvt_noconv = (__codecvt_error + 1)# /usr/include/libio.h: 181

struct__IO_FILE.__slots__ = [
    '_flags',
    '_IO_read_ptr',
    '_IO_read_end',
    '_IO_read_base',
    '_IO_write_base',
    '_IO_write_ptr',
    '_IO_write_end',
    '_IO_buf_base',
    '_IO_buf_end',
    '_IO_save_base',
    '_IO_backup_base',
    '_IO_save_end',
    '_markers',
    '_chain',
    '_fileno',
    '_flags2',
    '_old_offset',
    '_cur_column',
    '_vtable_offset',
    '_shortbuf',
    '_lock',
    '_offset',
    '__pad1',
    '__pad2',
    '__pad3',
    '__pad4',
    '__pad5',
    '_mode',
    '_unused2',
]
struct__IO_FILE._fields_ = [
    ('_flags', c_int),
    ('_IO_read_ptr', String),
    ('_IO_read_end', String),
    ('_IO_read_base', String),
    ('_IO_write_base', String),
    ('_IO_write_ptr', String),
    ('_IO_write_end', String),
    ('_IO_buf_base', String),
    ('_IO_buf_end', String),
    ('_IO_save_base', String),
    ('_IO_backup_base', String),
    ('_IO_save_end', String),
    ('_markers', POINTER(struct__IO_marker)),
    ('_chain', POINTER(struct__IO_FILE)),
    ('_fileno', c_int),
    ('_flags2', c_int),
    ('_old_offset', __off_t),
    ('_cur_column', c_ushort),
    ('_vtable_offset', c_char),
    ('_shortbuf', c_char * int(1)),
    ('_lock', POINTER(_IO_lock_t)),
    ('_offset', __off64_t),
    ('__pad1', POINTER(None)),
    ('__pad2', POINTER(None)),
    ('__pad3', POINTER(None)),
    ('__pad4', POINTER(None)),
    ('__pad5', c_size_t),
    ('_mode', c_int),
    ('_unused2', c_char * int((((15 * sizeof(c_int)) - (4 * sizeof(POINTER(None)))) - sizeof(c_size_t)))),
]

_IO_FILE = struct__IO_FILE# /usr/include/libio.h: 316

# /usr/include/libio.h: 319
class struct__IO_FILE_plus(Structure):
    pass

# /usr/include/libio.h: 321
try:
    _IO_2_1_stdin_ = (struct__IO_FILE_plus).in_dll(_libs["libPyFd.so"], "_IO_2_1_stdin_")
except:
    pass

# /usr/include/libio.h: 322
try:
    _IO_2_1_stdout_ = (struct__IO_FILE_plus).in_dll(_libs["libPyFd.so"], "_IO_2_1_stdout_")
except:
    pass

# /usr/include/libio.h: 323
try:
    _IO_2_1_stderr_ = (struct__IO_FILE_plus).in_dll(_libs["libPyFd.so"], "_IO_2_1_stderr_")
except:
    pass

__io_read_fn = CFUNCTYPE(UNCHECKED(__ssize_t), POINTER(None), String, c_size_t)# /usr/include/libio.h: 339

__io_write_fn = CFUNCTYPE(UNCHECKED(__ssize_t), POINTER(None), String, c_size_t)# /usr/include/libio.h: 347

__io_seek_fn = CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(__off64_t), c_int)# /usr/include/libio.h: 356

__io_close_fn = CFUNCTYPE(UNCHECKED(c_int), POINTER(None))# /usr/include/libio.h: 359

# /usr/include/libio.h: 391
if _libs["libPyFd.so"].has("__underflow", "cdecl"):
    __underflow = _libs["libPyFd.so"].get("__underflow", "cdecl")
    __underflow.argtypes = [POINTER(_IO_FILE)]
    __underflow.restype = c_int

# /usr/include/libio.h: 392
if _libs["libPyFd.so"].has("__uflow", "cdecl"):
    __uflow = _libs["libPyFd.so"].get("__uflow", "cdecl")
    __uflow.argtypes = [POINTER(_IO_FILE)]
    __uflow.restype = c_int

# /usr/include/libio.h: 393
if _libs["libPyFd.so"].has("__overflow", "cdecl"):
    __overflow = _libs["libPyFd.so"].get("__overflow", "cdecl")
    __overflow.argtypes = [POINTER(_IO_FILE), c_int]
    __overflow.restype = c_int

# /usr/include/libio.h: 435
if _libs["libPyFd.so"].has("_IO_getc", "cdecl"):
    _IO_getc = _libs["libPyFd.so"].get("_IO_getc", "cdecl")
    _IO_getc.argtypes = [POINTER(_IO_FILE)]
    _IO_getc.restype = c_int

# /usr/include/libio.h: 436
if _libs["libPyFd.so"].has("_IO_putc", "cdecl"):
    _IO_putc = _libs["libPyFd.so"].get("_IO_putc", "cdecl")
    _IO_putc.argtypes = [c_int, POINTER(_IO_FILE)]
    _IO_putc.restype = c_int

# /usr/include/libio.h: 437
if _libs["libPyFd.so"].has("_IO_feof", "cdecl"):
    _IO_feof = _libs["libPyFd.so"].get("_IO_feof", "cdecl")
    _IO_feof.argtypes = [POINTER(_IO_FILE)]
    _IO_feof.restype = c_int

# /usr/include/libio.h: 438
if _libs["libPyFd.so"].has("_IO_ferror", "cdecl"):
    _IO_ferror = _libs["libPyFd.so"].get("_IO_ferror", "cdecl")
    _IO_ferror.argtypes = [POINTER(_IO_FILE)]
    _IO_ferror.restype = c_int

# /usr/include/libio.h: 440
if _libs["libPyFd.so"].has("_IO_peekc_locked", "cdecl"):
    _IO_peekc_locked = _libs["libPyFd.so"].get("_IO_peekc_locked", "cdecl")
    _IO_peekc_locked.argtypes = [POINTER(_IO_FILE)]
    _IO_peekc_locked.restype = c_int

# /usr/include/libio.h: 446
if _libs["libPyFd.so"].has("_IO_flockfile", "cdecl"):
    _IO_flockfile = _libs["libPyFd.so"].get("_IO_flockfile", "cdecl")
    _IO_flockfile.argtypes = [POINTER(_IO_FILE)]
    _IO_flockfile.restype = None

# /usr/include/libio.h: 447
if _libs["libPyFd.so"].has("_IO_funlockfile", "cdecl"):
    _IO_funlockfile = _libs["libPyFd.so"].get("_IO_funlockfile", "cdecl")
    _IO_funlockfile.argtypes = [POINTER(_IO_FILE)]
    _IO_funlockfile.restype = None

# /usr/include/libio.h: 448
if _libs["libPyFd.so"].has("_IO_ftrylockfile", "cdecl"):
    _IO_ftrylockfile = _libs["libPyFd.so"].get("_IO_ftrylockfile", "cdecl")
    _IO_ftrylockfile.argtypes = [POINTER(_IO_FILE)]
    _IO_ftrylockfile.restype = c_int

# /usr/include/libio.h: 469
if _libs["libPyFd.so"].has("_IO_padn", "cdecl"):
    _IO_padn = _libs["libPyFd.so"].get("_IO_padn", "cdecl")
    _IO_padn.argtypes = [POINTER(_IO_FILE), c_int, __ssize_t]
    _IO_padn.restype = __ssize_t

# /usr/include/libio.h: 470
if _libs["libPyFd.so"].has("_IO_sgetn", "cdecl"):
    _IO_sgetn = _libs["libPyFd.so"].get("_IO_sgetn", "cdecl")
    _IO_sgetn.argtypes = [POINTER(_IO_FILE), POINTER(None), c_size_t]
    _IO_sgetn.restype = c_size_t

# /usr/include/libio.h: 472
if _libs["libPyFd.so"].has("_IO_seekoff", "cdecl"):
    _IO_seekoff = _libs["libPyFd.so"].get("_IO_seekoff", "cdecl")
    _IO_seekoff.argtypes = [POINTER(_IO_FILE), __off64_t, c_int, c_int]
    _IO_seekoff.restype = __off64_t

# /usr/include/libio.h: 473
if _libs["libPyFd.so"].has("_IO_seekpos", "cdecl"):
    _IO_seekpos = _libs["libPyFd.so"].get("_IO_seekpos", "cdecl")
    _IO_seekpos.argtypes = [POINTER(_IO_FILE), __off64_t, c_int]
    _IO_seekpos.restype = __off64_t

# /usr/include/libio.h: 475
if _libs["libPyFd.so"].has("_IO_free_backup_area", "cdecl"):
    _IO_free_backup_area = _libs["libPyFd.so"].get("_IO_free_backup_area", "cdecl")
    _IO_free_backup_area.argtypes = [POINTER(_IO_FILE)]
    _IO_free_backup_area.restype = None

fpos_t = _G_fpos_t# /usr/include/stdio.h: 110

# /usr/include/stdio.h: 168
try:
    stdin = (POINTER(struct__IO_FILE)).in_dll(_libs["libPyFd.so"], "stdin")
except:
    pass

# /usr/include/stdio.h: 169
try:
    stdout = (POINTER(struct__IO_FILE)).in_dll(_libs["libPyFd.so"], "stdout")
except:
    pass

# /usr/include/stdio.h: 170
try:
    stderr = (POINTER(struct__IO_FILE)).in_dll(_libs["libPyFd.so"], "stderr")
except:
    pass

# /usr/include/stdio.h: 178
if _libs["libPyFd.so"].has("remove", "cdecl"):
    remove = _libs["libPyFd.so"].get("remove", "cdecl")
    remove.argtypes = [String]
    remove.restype = c_int

# /usr/include/stdio.h: 180
if _libs["libPyFd.so"].has("rename", "cdecl"):
    rename = _libs["libPyFd.so"].get("rename", "cdecl")
    rename.argtypes = [String, String]
    rename.restype = c_int

# /usr/include/stdio.h: 185
if _libs["libPyFd.so"].has("renameat", "cdecl"):
    renameat = _libs["libPyFd.so"].get("renameat", "cdecl")
    renameat.argtypes = [c_int, String, c_int, String]
    renameat.restype = c_int

# /usr/include/stdio.h: 195
if _libs["libPyFd.so"].has("tmpfile", "cdecl"):
    tmpfile = _libs["libPyFd.so"].get("tmpfile", "cdecl")
    tmpfile.argtypes = []
    tmpfile.restype = POINTER(FILE)

# /usr/include/stdio.h: 209
if _libs["libPyFd.so"].has("tmpnam", "cdecl"):
    tmpnam = _libs["libPyFd.so"].get("tmpnam", "cdecl")
    tmpnam.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        tmpnam.restype = ReturnString
    else:
        tmpnam.restype = String
        tmpnam.errcheck = ReturnString

# /usr/include/stdio.h: 215
if _libs["libPyFd.so"].has("tmpnam_r", "cdecl"):
    tmpnam_r = _libs["libPyFd.so"].get("tmpnam_r", "cdecl")
    tmpnam_r.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        tmpnam_r.restype = ReturnString
    else:
        tmpnam_r.restype = String
        tmpnam_r.errcheck = ReturnString

# /usr/include/stdio.h: 227
if _libs["libPyFd.so"].has("tempnam", "cdecl"):
    tempnam = _libs["libPyFd.so"].get("tempnam", "cdecl")
    tempnam.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        tempnam.restype = ReturnString
    else:
        tempnam.restype = String
        tempnam.errcheck = ReturnString

# /usr/include/stdio.h: 237
if _libs["libPyFd.so"].has("fclose", "cdecl"):
    fclose = _libs["libPyFd.so"].get("fclose", "cdecl")
    fclose.argtypes = [POINTER(FILE)]
    fclose.restype = c_int

# /usr/include/stdio.h: 242
if _libs["libPyFd.so"].has("fflush", "cdecl"):
    fflush = _libs["libPyFd.so"].get("fflush", "cdecl")
    fflush.argtypes = [POINTER(FILE)]
    fflush.restype = c_int

# /usr/include/stdio.h: 252
if _libs["libPyFd.so"].has("fflush_unlocked", "cdecl"):
    fflush_unlocked = _libs["libPyFd.so"].get("fflush_unlocked", "cdecl")
    fflush_unlocked.argtypes = [POINTER(FILE)]
    fflush_unlocked.restype = c_int

# /usr/include/stdio.h: 272
if _libs["libPyFd.so"].has("fopen", "cdecl"):
    fopen = _libs["libPyFd.so"].get("fopen", "cdecl")
    fopen.argtypes = [String, String]
    fopen.restype = POINTER(FILE)

# /usr/include/stdio.h: 278
if _libs["libPyFd.so"].has("freopen", "cdecl"):
    freopen = _libs["libPyFd.so"].get("freopen", "cdecl")
    freopen.argtypes = [String, String, POINTER(FILE)]
    freopen.restype = POINTER(FILE)

# /usr/include/stdio.h: 306
if _libs["libPyFd.so"].has("fdopen", "cdecl"):
    fdopen = _libs["libPyFd.so"].get("fdopen", "cdecl")
    fdopen.argtypes = [c_int, String]
    fdopen.restype = POINTER(FILE)

# /usr/include/stdio.h: 319
if _libs["libPyFd.so"].has("fmemopen", "cdecl"):
    fmemopen = _libs["libPyFd.so"].get("fmemopen", "cdecl")
    fmemopen.argtypes = [POINTER(None), c_size_t, String]
    fmemopen.restype = POINTER(FILE)

# /usr/include/stdio.h: 325
if _libs["libPyFd.so"].has("open_memstream", "cdecl"):
    open_memstream = _libs["libPyFd.so"].get("open_memstream", "cdecl")
    open_memstream.argtypes = [POINTER(POINTER(c_char)), POINTER(c_size_t)]
    open_memstream.restype = POINTER(FILE)

# /usr/include/stdio.h: 332
if _libs["libPyFd.so"].has("setbuf", "cdecl"):
    setbuf = _libs["libPyFd.so"].get("setbuf", "cdecl")
    setbuf.argtypes = [POINTER(FILE), String]
    setbuf.restype = None

# /usr/include/stdio.h: 336
if _libs["libPyFd.so"].has("setvbuf", "cdecl"):
    setvbuf = _libs["libPyFd.so"].get("setvbuf", "cdecl")
    setvbuf.argtypes = [POINTER(FILE), String, c_int, c_size_t]
    setvbuf.restype = c_int

# /usr/include/stdio.h: 343
if _libs["libPyFd.so"].has("setbuffer", "cdecl"):
    setbuffer = _libs["libPyFd.so"].get("setbuffer", "cdecl")
    setbuffer.argtypes = [POINTER(FILE), String, c_size_t]
    setbuffer.restype = None

# /usr/include/stdio.h: 347
if _libs["libPyFd.so"].has("setlinebuf", "cdecl"):
    setlinebuf = _libs["libPyFd.so"].get("setlinebuf", "cdecl")
    setlinebuf.argtypes = [POINTER(FILE)]
    setlinebuf.restype = None

# /usr/include/stdio.h: 356
if _libs["libPyFd.so"].has("fprintf", "cdecl"):
    _func = _libs["libPyFd.so"].get("fprintf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(FILE), String]
    fprintf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 362
if _libs["libPyFd.so"].has("printf", "cdecl"):
    _func = _libs["libPyFd.so"].get("printf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    printf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 364
if _libs["libPyFd.so"].has("sprintf", "cdecl"):
    _func = _libs["libPyFd.so"].get("sprintf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    sprintf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 386
if _libs["libPyFd.so"].has("snprintf", "cdecl"):
    _func = _libs["libPyFd.so"].get("snprintf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, c_size_t, String]
    snprintf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 415
if _libs["libPyFd.so"].has("dprintf", "cdecl"):
    _func = _libs["libPyFd.so"].get("dprintf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [c_int, String]
    dprintf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 425
if _libs["libPyFd.so"].has("fscanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("fscanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(FILE), String]
    fscanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 431
if _libs["libPyFd.so"].has("scanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("scanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    scanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 433
if _libs["libPyFd.so"].has("sscanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("sscanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    sscanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 452
if _libs["libPyFd.so"].has("__isoc99_fscanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("__isoc99_fscanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(FILE), String]
    __isoc99_fscanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 454
if _libs["libPyFd.so"].has("__isoc99_scanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("__isoc99_scanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    __isoc99_scanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 455
if _libs["libPyFd.so"].has("__isoc99_sscanf", "cdecl"):
    _func = _libs["libPyFd.so"].get("__isoc99_sscanf", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    __isoc99_sscanf = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/stdio.h: 531
if _libs["libPyFd.so"].has("fgetc", "cdecl"):
    fgetc = _libs["libPyFd.so"].get("fgetc", "cdecl")
    fgetc.argtypes = [POINTER(FILE)]
    fgetc.restype = c_int

# /usr/include/stdio.h: 532
if _libs["libPyFd.so"].has("getc", "cdecl"):
    getc = _libs["libPyFd.so"].get("getc", "cdecl")
    getc.argtypes = [POINTER(FILE)]
    getc.restype = c_int

# /usr/include/stdio.h: 538
if _libs["libPyFd.so"].has("getchar", "cdecl"):
    getchar = _libs["libPyFd.so"].get("getchar", "cdecl")
    getchar.argtypes = []
    getchar.restype = c_int

# /usr/include/stdio.h: 550
if _libs["libPyFd.so"].has("getc_unlocked", "cdecl"):
    getc_unlocked = _libs["libPyFd.so"].get("getc_unlocked", "cdecl")
    getc_unlocked.argtypes = [POINTER(FILE)]
    getc_unlocked.restype = c_int

# /usr/include/stdio.h: 551
if _libs["libPyFd.so"].has("getchar_unlocked", "cdecl"):
    getchar_unlocked = _libs["libPyFd.so"].get("getchar_unlocked", "cdecl")
    getchar_unlocked.argtypes = []
    getchar_unlocked.restype = c_int

# /usr/include/stdio.h: 561
if _libs["libPyFd.so"].has("fgetc_unlocked", "cdecl"):
    fgetc_unlocked = _libs["libPyFd.so"].get("fgetc_unlocked", "cdecl")
    fgetc_unlocked.argtypes = [POINTER(FILE)]
    fgetc_unlocked.restype = c_int

# /usr/include/stdio.h: 573
if _libs["libPyFd.so"].has("fputc", "cdecl"):
    fputc = _libs["libPyFd.so"].get("fputc", "cdecl")
    fputc.argtypes = [c_int, POINTER(FILE)]
    fputc.restype = c_int

# /usr/include/stdio.h: 574
if _libs["libPyFd.so"].has("putc", "cdecl"):
    putc = _libs["libPyFd.so"].get("putc", "cdecl")
    putc.argtypes = [c_int, POINTER(FILE)]
    putc.restype = c_int

# /usr/include/stdio.h: 580
if _libs["libPyFd.so"].has("putchar", "cdecl"):
    putchar = _libs["libPyFd.so"].get("putchar", "cdecl")
    putchar.argtypes = [c_int]
    putchar.restype = c_int

# /usr/include/stdio.h: 594
if _libs["libPyFd.so"].has("fputc_unlocked", "cdecl"):
    fputc_unlocked = _libs["libPyFd.so"].get("fputc_unlocked", "cdecl")
    fputc_unlocked.argtypes = [c_int, POINTER(FILE)]
    fputc_unlocked.restype = c_int

# /usr/include/stdio.h: 602
if _libs["libPyFd.so"].has("putc_unlocked", "cdecl"):
    putc_unlocked = _libs["libPyFd.so"].get("putc_unlocked", "cdecl")
    putc_unlocked.argtypes = [c_int, POINTER(FILE)]
    putc_unlocked.restype = c_int

# /usr/include/stdio.h: 603
if _libs["libPyFd.so"].has("putchar_unlocked", "cdecl"):
    putchar_unlocked = _libs["libPyFd.so"].get("putchar_unlocked", "cdecl")
    putchar_unlocked.argtypes = [c_int]
    putchar_unlocked.restype = c_int

# /usr/include/stdio.h: 610
if _libs["libPyFd.so"].has("getw", "cdecl"):
    getw = _libs["libPyFd.so"].get("getw", "cdecl")
    getw.argtypes = [POINTER(FILE)]
    getw.restype = c_int

# /usr/include/stdio.h: 613
if _libs["libPyFd.so"].has("putw", "cdecl"):
    putw = _libs["libPyFd.so"].get("putw", "cdecl")
    putw.argtypes = [c_int, POINTER(FILE)]
    putw.restype = c_int

# /usr/include/stdio.h: 622
if _libs["libPyFd.so"].has("fgets", "cdecl"):
    fgets = _libs["libPyFd.so"].get("fgets", "cdecl")
    fgets.argtypes = [String, c_int, POINTER(FILE)]
    if sizeof(c_int) == sizeof(c_void_p):
        fgets.restype = ReturnString
    else:
        fgets.restype = String
        fgets.errcheck = ReturnString

# /usr/include/stdio.h: 638
if _libs["libPyFd.so"].has("gets", "cdecl"):
    gets = _libs["libPyFd.so"].get("gets", "cdecl")
    gets.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        gets.restype = ReturnString
    else:
        gets.restype = String
        gets.errcheck = ReturnString

# /usr/include/stdio.h: 665
if _libs["libPyFd.so"].has("__getdelim", "cdecl"):
    __getdelim = _libs["libPyFd.so"].get("__getdelim", "cdecl")
    __getdelim.argtypes = [POINTER(POINTER(c_char)), POINTER(c_size_t), c_int, POINTER(FILE)]
    __getdelim.restype = __ssize_t

# /usr/include/stdio.h: 668
if _libs["libPyFd.so"].has("getdelim", "cdecl"):
    getdelim = _libs["libPyFd.so"].get("getdelim", "cdecl")
    getdelim.argtypes = [POINTER(POINTER(c_char)), POINTER(c_size_t), c_int, POINTER(FILE)]
    getdelim.restype = __ssize_t

# /usr/include/stdio.h: 678
if _libs["libPyFd.so"].has("getline", "cdecl"):
    getline = _libs["libPyFd.so"].get("getline", "cdecl")
    getline.argtypes = [POINTER(POINTER(c_char)), POINTER(c_size_t), POINTER(FILE)]
    getline.restype = __ssize_t

# /usr/include/stdio.h: 689
if _libs["libPyFd.so"].has("fputs", "cdecl"):
    fputs = _libs["libPyFd.so"].get("fputs", "cdecl")
    fputs.argtypes = [String, POINTER(FILE)]
    fputs.restype = c_int

# /usr/include/stdio.h: 695
if _libs["libPyFd.so"].has("puts", "cdecl"):
    puts = _libs["libPyFd.so"].get("puts", "cdecl")
    puts.argtypes = [String]
    puts.restype = c_int

# /usr/include/stdio.h: 702
if _libs["libPyFd.so"].has("ungetc", "cdecl"):
    ungetc = _libs["libPyFd.so"].get("ungetc", "cdecl")
    ungetc.argtypes = [c_int, POINTER(FILE)]
    ungetc.restype = c_int

# /usr/include/stdio.h: 709
if _libs["libPyFd.so"].has("fread", "cdecl"):
    fread = _libs["libPyFd.so"].get("fread", "cdecl")
    fread.argtypes = [POINTER(None), c_size_t, c_size_t, POINTER(FILE)]
    fread.restype = c_size_t

# /usr/include/stdio.h: 715
if _libs["libPyFd.so"].has("fwrite", "cdecl"):
    fwrite = _libs["libPyFd.so"].get("fwrite", "cdecl")
    fwrite.argtypes = [POINTER(None), c_size_t, c_size_t, POINTER(FILE)]
    fwrite.restype = c_size_t

# /usr/include/stdio.h: 737
if _libs["libPyFd.so"].has("fread_unlocked", "cdecl"):
    fread_unlocked = _libs["libPyFd.so"].get("fread_unlocked", "cdecl")
    fread_unlocked.argtypes = [POINTER(None), c_size_t, c_size_t, POINTER(FILE)]
    fread_unlocked.restype = c_size_t

# /usr/include/stdio.h: 739
if _libs["libPyFd.so"].has("fwrite_unlocked", "cdecl"):
    fwrite_unlocked = _libs["libPyFd.so"].get("fwrite_unlocked", "cdecl")
    fwrite_unlocked.argtypes = [POINTER(None), c_size_t, c_size_t, POINTER(FILE)]
    fwrite_unlocked.restype = c_size_t

# /usr/include/stdio.h: 749
if _libs["libPyFd.so"].has("fseek", "cdecl"):
    fseek = _libs["libPyFd.so"].get("fseek", "cdecl")
    fseek.argtypes = [POINTER(FILE), c_long, c_int]
    fseek.restype = c_int

# /usr/include/stdio.h: 754
if _libs["libPyFd.so"].has("ftell", "cdecl"):
    ftell = _libs["libPyFd.so"].get("ftell", "cdecl")
    ftell.argtypes = [POINTER(FILE)]
    ftell.restype = c_long

# /usr/include/stdio.h: 759
if _libs["libPyFd.so"].has("rewind", "cdecl"):
    rewind = _libs["libPyFd.so"].get("rewind", "cdecl")
    rewind.argtypes = [POINTER(FILE)]
    rewind.restype = None

# /usr/include/stdio.h: 773
if _libs["libPyFd.so"].has("fseeko", "cdecl"):
    fseeko = _libs["libPyFd.so"].get("fseeko", "cdecl")
    fseeko.argtypes = [POINTER(FILE), __off_t, c_int]
    fseeko.restype = c_int

# /usr/include/stdio.h: 778
if _libs["libPyFd.so"].has("ftello", "cdecl"):
    ftello = _libs["libPyFd.so"].get("ftello", "cdecl")
    ftello.argtypes = [POINTER(FILE)]
    ftello.restype = __off_t

# /usr/include/stdio.h: 798
if _libs["libPyFd.so"].has("fgetpos", "cdecl"):
    fgetpos = _libs["libPyFd.so"].get("fgetpos", "cdecl")
    fgetpos.argtypes = [POINTER(FILE), POINTER(fpos_t)]
    fgetpos.restype = c_int

# /usr/include/stdio.h: 803
if _libs["libPyFd.so"].has("fsetpos", "cdecl"):
    fsetpos = _libs["libPyFd.so"].get("fsetpos", "cdecl")
    fsetpos.argtypes = [POINTER(FILE), POINTER(fpos_t)]
    fsetpos.restype = c_int

# /usr/include/stdio.h: 826
if _libs["libPyFd.so"].has("clearerr", "cdecl"):
    clearerr = _libs["libPyFd.so"].get("clearerr", "cdecl")
    clearerr.argtypes = [POINTER(FILE)]
    clearerr.restype = None

# /usr/include/stdio.h: 828
if _libs["libPyFd.so"].has("feof", "cdecl"):
    feof = _libs["libPyFd.so"].get("feof", "cdecl")
    feof.argtypes = [POINTER(FILE)]
    feof.restype = c_int

# /usr/include/stdio.h: 830
if _libs["libPyFd.so"].has("ferror", "cdecl"):
    ferror = _libs["libPyFd.so"].get("ferror", "cdecl")
    ferror.argtypes = [POINTER(FILE)]
    ferror.restype = c_int

# /usr/include/stdio.h: 835
if _libs["libPyFd.so"].has("clearerr_unlocked", "cdecl"):
    clearerr_unlocked = _libs["libPyFd.so"].get("clearerr_unlocked", "cdecl")
    clearerr_unlocked.argtypes = [POINTER(FILE)]
    clearerr_unlocked.restype = None

# /usr/include/stdio.h: 836
if _libs["libPyFd.so"].has("feof_unlocked", "cdecl"):
    feof_unlocked = _libs["libPyFd.so"].get("feof_unlocked", "cdecl")
    feof_unlocked.argtypes = [POINTER(FILE)]
    feof_unlocked.restype = c_int

# /usr/include/stdio.h: 837
if _libs["libPyFd.so"].has("ferror_unlocked", "cdecl"):
    ferror_unlocked = _libs["libPyFd.so"].get("ferror_unlocked", "cdecl")
    ferror_unlocked.argtypes = [POINTER(FILE)]
    ferror_unlocked.restype = c_int

# /usr/include/stdio.h: 846
if _libs["libPyFd.so"].has("perror", "cdecl"):
    perror = _libs["libPyFd.so"].get("perror", "cdecl")
    perror.argtypes = [String]
    perror.restype = None

# /usr/include/bits/sys_errlist.h: 26
try:
    sys_nerr = (c_int).in_dll(_libs["libPyFd.so"], "sys_nerr")
except:
    pass

# /usr/include/bits/sys_errlist.h: 27
try:
    sys_errlist = (POINTER(POINTER(c_char))).in_dll(_libs["libPyFd.so"], "sys_errlist")
except:
    pass

# /usr/include/stdio.h: 858
if _libs["libPyFd.so"].has("fileno", "cdecl"):
    fileno = _libs["libPyFd.so"].get("fileno", "cdecl")
    fileno.argtypes = [POINTER(FILE)]
    fileno.restype = c_int

# /usr/include/stdio.h: 863
if _libs["libPyFd.so"].has("fileno_unlocked", "cdecl"):
    fileno_unlocked = _libs["libPyFd.so"].get("fileno_unlocked", "cdecl")
    fileno_unlocked.argtypes = [POINTER(FILE)]
    fileno_unlocked.restype = c_int

# /usr/include/stdio.h: 873
if _libs["libPyFd.so"].has("popen", "cdecl"):
    popen = _libs["libPyFd.so"].get("popen", "cdecl")
    popen.argtypes = [String, String]
    popen.restype = POINTER(FILE)

# /usr/include/stdio.h: 879
if _libs["libPyFd.so"].has("pclose", "cdecl"):
    pclose = _libs["libPyFd.so"].get("pclose", "cdecl")
    pclose.argtypes = [POINTER(FILE)]
    pclose.restype = c_int

# /usr/include/stdio.h: 885
if _libs["libPyFd.so"].has("ctermid", "cdecl"):
    ctermid = _libs["libPyFd.so"].get("ctermid", "cdecl")
    ctermid.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        ctermid.restype = ReturnString
    else:
        ctermid.restype = String
        ctermid.errcheck = ReturnString

# /usr/include/stdio.h: 913
if _libs["libPyFd.so"].has("flockfile", "cdecl"):
    flockfile = _libs["libPyFd.so"].get("flockfile", "cdecl")
    flockfile.argtypes = [POINTER(FILE)]
    flockfile.restype = None

# /usr/include/stdio.h: 917
if _libs["libPyFd.so"].has("ftrylockfile", "cdecl"):
    ftrylockfile = _libs["libPyFd.so"].get("ftrylockfile", "cdecl")
    ftrylockfile.argtypes = [POINTER(FILE)]
    ftrylockfile.restype = c_int

# /usr/include/stdio.h: 920
if _libs["libPyFd.so"].has("funlockfile", "cdecl"):
    funlockfile = _libs["libPyFd.so"].get("funlockfile", "cdecl")
    funlockfile.argtypes = [POINTER(FILE)]
    funlockfile.restype = None

enum_anon_41 = c_int# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerUnknow = (-1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerIdle = (CfgServerUnknow + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerConfigured = (CfgServerIdle + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerActive = (CfgServerConfigured + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerGolden = (CfgServerActive + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerError = (CfgServerGolden + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerEnd = (CfgServerError + 1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgServerState_t = enum_anon_41# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 64

CfgStateReachFnt_t = CFUNCTYPE(UNCHECKED(c_int), POINTER(None))# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 66

CfgStateStrFnt_t = CFUNCTYPE(UNCHECKED(String), c_int)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 67

CfgConfigFnt_t = CFUNCTYPE(UNCHECKED(None), )# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 68

enum_anon_42 = c_int# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 76

CFGSEND = (-1)# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 76

CFGDBGCM = 2# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 76

CFGDBGMAX = 1000# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 76

CfgDebug_t = enum_anon_42# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 76

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 82
class struct_CfgData(Structure):
    pass

CfgData_t = struct_CfgData# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 82

CfgUserActivationGetFnt_t = CFUNCTYPE(UNCHECKED(String), POINTER(None))# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 83

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 88
if _libs["libPyFd.so"].has("CfgBasename", "cdecl"):
    CfgBasename = _libs["libPyFd.so"].get("CfgBasename", "cdecl")
    CfgBasename.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgBasename.restype = ReturnString
    else:
        CfgBasename.restype = String
        CfgBasename.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 89
if _libs["libPyFd.so"].has("CfgCmName", "cdecl"):
    CfgCmName = _libs["libPyFd.so"].get("CfgCmName", "cdecl")
    CfgCmName.argtypes = [c_int, POINTER(POINTER(c_char))]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgCmName.restype = ReturnString
    else:
        CfgCmName.restype = String
        CfgCmName.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 90
if _libs["libPyFd.so"].has("CfgDirname", "cdecl"):
    CfgDirname = _libs["libPyFd.so"].get("CfgDirname", "cdecl")
    CfgDirname.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDirname.restype = ReturnString
    else:
        CfgDirname.restype = String
        CfgDirname.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 91
if _libs["libPyFd.so"].has("CfgFindPath", "cdecl"):
    CfgFindPath = _libs["libPyFd.so"].get("CfgFindPath", "cdecl")
    CfgFindPath.argtypes = [String, c_size_t, String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgFindPath.restype = ReturnString
    else:
        CfgFindPath.restype = String
        CfgFindPath.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 92
if _libs["libPyFd.so"].has("CfgFindPathExec", "cdecl"):
    CfgFindPathExec = _libs["libPyFd.so"].get("CfgFindPathExec", "cdecl")
    CfgFindPathExec.argtypes = [String, c_size_t, String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgFindPathExec.restype = ReturnString
    else:
        CfgFindPathExec.restype = String
        CfgFindPathExec.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 93
if _libs["libPyFd.so"].has("CfgGetDataSize", "cdecl"):
    CfgGetDataSize = _libs["libPyFd.so"].get("CfgGetDataSize", "cdecl")
    CfgGetDataSize.argtypes = [String, c_int, POINTER(c_size_t)]
    CfgGetDataSize.restype = c_size_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 94
if _libs["libPyFd.so"].has("CfgRunTimeStrBuilt", "cdecl"):
    CfgRunTimeStrBuilt = _libs["libPyFd.so"].get("CfgRunTimeStrBuilt", "cdecl")
    CfgRunTimeStrBuilt.argtypes = [time_t, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgRunTimeStrBuilt.restype = ReturnString
    else:
        CfgRunTimeStrBuilt.restype = String
        CfgRunTimeStrBuilt.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 95
if _libs["libPyFd.so"].has("CfgStrRemove", "cdecl"):
    CfgStrRemove = _libs["libPyFd.so"].get("CfgStrRemove", "cdecl")
    CfgStrRemove.argtypes = [String, String, c_char]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgStrRemove.restype = ReturnString
    else:
        CfgStrRemove.restype = String
        CfgStrRemove.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 96
if _libs["libPyFd.so"].has("CfgStrFmtCat", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgStrFmtCat", "cdecl")
    _restype = String
    _errcheck = None
    _argtypes = [String, CfgBool_t, String]
    CfgStrFmtCat = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 97
if _libs["libPyFd.so"].has("CfgStrFmtCatv", "cdecl"):
    CfgStrFmtCatv = _libs["libPyFd.so"].get("CfgStrFmtCatv", "cdecl")
    CfgStrFmtCatv.argtypes = [String, CfgBool_t, String, c_void_p]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgStrFmtCatv.restype = ReturnString
    else:
        CfgStrFmtCatv.restype = String
        CfgStrFmtCatv.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 99
for _lib in _libs.values():
    if not _lib.has("CfgSubSysName", "cdecl"):
        continue
    CfgSubSysName = _lib.get("CfgSubSysName", "cdecl")
    CfgSubSysName.argtypes = [c_int, POINTER(POINTER(c_char))]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgSubSysName.restype = ReturnString
    else:
        CfgSubSysName.restype = String
        CfgSubSysName.errcheck = ReturnString
    break

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 100
if _libs["libPyFd.so"].has("CfgTolower", "cdecl"):
    CfgTolower = _libs["libPyFd.so"].get("CfgTolower", "cdecl")
    CfgTolower.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgTolower.restype = ReturnString
    else:
        CfgTolower.restype = String
        CfgTolower.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 101
if _libs["libPyFd.so"].has("CfgToupper", "cdecl"):
    CfgToupper = _libs["libPyFd.so"].get("CfgToupper", "cdecl")
    CfgToupper.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgToupper.restype = ReturnString
    else:
        CfgToupper.restype = String
        CfgToupper.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 102
if _libs["libPyFd.so"].has("CfgWaitWithTimeout", "cdecl"):
    CfgWaitWithTimeout = _libs["libPyFd.so"].get("CfgWaitWithTimeout", "cdecl")
    CfgWaitWithTimeout.argtypes = [c_double]
    CfgWaitWithTimeout.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 104
if _libs["libPyFd.so"].has("CfgDataCloseLogStream", "cdecl"):
    CfgDataCloseLogStream = _libs["libPyFd.so"].get("CfgDataCloseLogStream", "cdecl")
    CfgDataCloseLogStream.argtypes = [POINTER(CfgData_t), c_int]
    CfgDataCloseLogStream.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 105
if _libs["libPyFd.so"].has("CfgDataConfAddv", "cdecl"):
    CfgDataConfAddv = _libs["libPyFd.so"].get("CfgDataConfAddv", "cdecl")
    CfgDataConfAddv.argtypes = [POINTER(CfgData_t), String, c_void_p]
    CfgDataConfAddv.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 106
if _libs["libPyFd.so"].has("CfgDataGetActivation", "cdecl"):
    CfgDataGetActivation = _libs["libPyFd.so"].get("CfgDataGetActivation", "cdecl")
    CfgDataGetActivation.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetActivation.restype = ReturnString
    else:
        CfgDataGetActivation.restype = String
        CfgDataGetActivation.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 107
if _libs["libPyFd.so"].has("CfgDataGetCmCleanupTmo", "cdecl"):
    CfgDataGetCmCleanupTmo = _libs["libPyFd.so"].get("CfgDataGetCmCleanupTmo", "cdecl")
    CfgDataGetCmCleanupTmo.argtypes = [POINTER(CfgData_t)]
    CfgDataGetCmCleanupTmo.restype = c_double

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 108
if _libs["libPyFd.so"].has("CfgDataGetCmDomainName", "cdecl"):
    CfgDataGetCmDomainName = _libs["libPyFd.so"].get("CfgDataGetCmDomainName", "cdecl")
    CfgDataGetCmDomainName.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetCmDomainName.restype = ReturnString
    else:
        CfgDataGetCmDomainName.restype = String
        CfgDataGetCmDomainName.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 109
if _libs["libPyFd.so"].has("CfgDataGetCmName", "cdecl"):
    CfgDataGetCmName = _libs["libPyFd.so"].get("CfgDataGetCmName", "cdecl")
    CfgDataGetCmName.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetCmName.restype = ReturnString
    else:
        CfgDataGetCmName.restype = String
        CfgDataGetCmName.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 110
if _libs["libPyFd.so"].has("CfgDataGetCommitFlag", "cdecl"):
    CfgDataGetCommitFlag = _libs["libPyFd.so"].get("CfgDataGetCommitFlag", "cdecl")
    CfgDataGetCommitFlag.argtypes = [POINTER(CfgData_t), POINTER(c_int), POINTER(c_int)]
    CfgDataGetCommitFlag.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 111
if _libs["libPyFd.so"].has("CfgDataGetConfig", "cdecl"):
    CfgDataGetConfig = _libs["libPyFd.so"].get("CfgDataGetConfig", "cdecl")
    CfgDataGetConfig.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetConfig.restype = ReturnString
    else:
        CfgDataGetConfig.restype = String
        CfgDataGetConfig.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 112
if _libs["libPyFd.so"].has("CfgDataGetConfigTime", "cdecl"):
    CfgDataGetConfigTime = _libs["libPyFd.so"].get("CfgDataGetConfigTime", "cdecl")
    CfgDataGetConfigTime.argtypes = [POINTER(CfgData_t)]
    CfgDataGetConfigTime.restype = time_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 113
if _libs["libPyFd.so"].has("CfgDataGetCurrentTime", "cdecl"):
    CfgDataGetCurrentTime = _libs["libPyFd.so"].get("CfgDataGetCurrentTime", "cdecl")
    CfgDataGetCurrentTime.argtypes = [POINTER(CfgData_t)]
    CfgDataGetCurrentTime.restype = time_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 114
if _libs["libPyFd.so"].has("CfgDataGetDebug", "cdecl"):
    CfgDataGetDebug = _libs["libPyFd.so"].get("CfgDataGetDebug", "cdecl")
    CfgDataGetDebug.argtypes = [POINTER(CfgData_t)]
    CfgDataGetDebug.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 115
if _libs["libPyFd.so"].has("CfgDataGetHostname", "cdecl"):
    CfgDataGetHostname = _libs["libPyFd.so"].get("CfgDataGetHostname", "cdecl")
    CfgDataGetHostname.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetHostname.restype = ReturnString
    else:
        CfgDataGetHostname.restype = String
        CfgDataGetHostname.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 116
if _libs["libPyFd.so"].has("CfgDataGetLogFilename", "cdecl"):
    CfgDataGetLogFilename = _libs["libPyFd.so"].get("CfgDataGetLogFilename", "cdecl")
    CfgDataGetLogFilename.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetLogFilename.restype = ReturnString
    else:
        CfgDataGetLogFilename.restype = String
        CfgDataGetLogFilename.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 117
if _libs["libPyFd.so"].has("CfgDataGetLogStream", "cdecl"):
    CfgDataGetLogStream = _libs["libPyFd.so"].get("CfgDataGetLogStream", "cdecl")
    CfgDataGetLogStream.argtypes = [POINTER(CfgData_t)]
    CfgDataGetLogStream.restype = POINTER(FILE)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 118
if _libs["libPyFd.so"].has("CfgDataGetMemSize", "cdecl"):
    CfgDataGetMemSize = _libs["libPyFd.so"].get("CfgDataGetMemSize", "cdecl")
    CfgDataGetMemSize.argtypes = [POINTER(CfgData_t)]
    CfgDataGetMemSize.restype = c_size_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 119
if _libs["libPyFd.so"].has("CfgDataGetMsgR", "cdecl"):
    CfgDataGetMsgR = _libs["libPyFd.so"].get("CfgDataGetMsgR", "cdecl")
    CfgDataGetMsgR.argtypes = [POINTER(CfgData_t)]
    CfgDataGetMsgR.restype = POINTER(CfgMsgR_t)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 120
if _libs["libPyFd.so"].has("CfgDataGetPid", "cdecl"):
    CfgDataGetPid = _libs["libPyFd.so"].get("CfgDataGetPid", "cdecl")
    CfgDataGetPid.argtypes = [POINTER(CfgData_t)]
    CfgDataGetPid.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 121
if _libs["libPyFd.so"].has("CfgDataGetRequestedState", "cdecl"):
    CfgDataGetRequestedState = _libs["libPyFd.so"].get("CfgDataGetRequestedState", "cdecl")
    CfgDataGetRequestedState.argtypes = [POINTER(CfgData_t)]
    CfgDataGetRequestedState.restype = CfgServerState_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 122
if _libs["libPyFd.so"].has("CfgDataGetRFlag", "cdecl"):
    CfgDataGetRFlag = _libs["libPyFd.so"].get("CfgDataGetRFlag", "cdecl")
    CfgDataGetRFlag.argtypes = [POINTER(CfgData_t), POINTER(c_int), POINTER(c_int), POINTER(c_int)]
    CfgDataGetRFlag.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 123
if _libs["libPyFd.so"].has("CfgDataGetState", "cdecl"):
    CfgDataGetState = _libs["libPyFd.so"].get("CfgDataGetState", "cdecl")
    CfgDataGetState.argtypes = [POINTER(CfgData_t)]
    CfgDataGetState.restype = CfgServerState_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 124
if _libs["libPyFd.so"].has("CfgDataGetStateStr", "cdecl"):
    CfgDataGetStateStr = _libs["libPyFd.so"].get("CfgDataGetStateStr", "cdecl")
    CfgDataGetStateStr.argtypes = [POINTER(CfgData_t), CfgServerState_t]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetStateStr.restype = ReturnString
    else:
        CfgDataGetStateStr.restype = String
        CfgDataGetStateStr.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 125
if _libs["libPyFd.so"].has("CfgDataGetStartTime", "cdecl"):
    CfgDataGetStartTime = _libs["libPyFd.so"].get("CfgDataGetStartTime", "cdecl")
    CfgDataGetStartTime.argtypes = [POINTER(CfgData_t)]
    CfgDataGetStartTime.restype = time_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 126
if _libs["libPyFd.so"].has("CfgDataGetStrTime", "cdecl"):
    CfgDataGetStrTime = _libs["libPyFd.so"].get("CfgDataGetStrTime", "cdecl")
    CfgDataGetStrTime.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetStrTime.restype = ReturnString
    else:
        CfgDataGetStrTime.restype = String
        CfgDataGetStrTime.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 127
if _libs["libPyFd.so"].has("CfgDataGetSysName", "cdecl"):
    CfgDataGetSysName = _libs["libPyFd.so"].get("CfgDataGetSysName", "cdecl")
    CfgDataGetSysName.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetSysName.restype = ReturnString
    else:
        CfgDataGetSysName.restype = String
        CfgDataGetSysName.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 128
if _libs["libPyFd.so"].has("CfgDataGetTag", "cdecl"):
    CfgDataGetTag = _libs["libPyFd.so"].get("CfgDataGetTag", "cdecl")
    CfgDataGetTag.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetTag.restype = ReturnString
    else:
        CfgDataGetTag.restype = String
        CfgDataGetTag.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 129
if _libs["libPyFd.so"].has("CfgDataGetUserActivation", "cdecl"):
    CfgDataGetUserActivation = _libs["libPyFd.so"].get("CfgDataGetUserActivation", "cdecl")
    CfgDataGetUserActivation.argtypes = [POINTER(CfgData_t)]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgDataGetUserActivation.restype = ReturnString
    else:
        CfgDataGetUserActivation.restype = String
        CfgDataGetUserActivation.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 130
if _libs["libPyFd.so"].has("CfgDataFree", "cdecl"):
    CfgDataFree = _libs["libPyFd.so"].get("CfgDataFree", "cdecl")
    CfgDataFree.argtypes = [POINTER(CfgData_t)]
    CfgDataFree.restype = POINTER(CfgData_t)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 131
if _libs["libPyFd.so"].has("CfgDataLogFilenameInit", "cdecl"):
    CfgDataLogFilenameInit = _libs["libPyFd.so"].get("CfgDataLogFilenameInit", "cdecl")
    CfgDataLogFilenameInit.argtypes = [POINTER(CfgData_t)]
    CfgDataLogFilenameInit.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 132
if _libs["libPyFd.so"].has("CfgDataLogFPrintv", "cdecl"):
    CfgDataLogFPrintv = _libs["libPyFd.so"].get("CfgDataLogFPrintv", "cdecl")
    CfgDataLogFPrintv.argtypes = [POINTER(CfgData_t), String, c_void_p]
    CfgDataLogFPrintv.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 133
if _libs["libPyFd.so"].has("CfgDataLogFPrint", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgDataLogFPrint", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [POINTER(CfgData_t), String]
    CfgDataLogFPrint = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 134
if _libs["libPyFd.so"].has("CfgDataMsgAddFmtv", "cdecl"):
    CfgDataMsgAddFmtv = _libs["libPyFd.so"].get("CfgDataMsgAddFmtv", "cdecl")
    CfgDataMsgAddFmtv.argtypes = [POINTER(CfgData_t), c_int, c_int, String, String, c_void_p]
    CfgDataMsgAddFmtv.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 136
if _libs["libPyFd.so"].has("CfgDataMsgLogReportClose", "cdecl"):
    CfgDataMsgLogReportClose = _libs["libPyFd.so"].get("CfgDataMsgLogReportClose", "cdecl")
    CfgDataMsgLogReportClose.argtypes = [POINTER(CfgData_t)]
    CfgDataMsgLogReportClose.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 137
if _libs["libPyFd.so"].has("CfgDataMsgLogReportOpen", "cdecl"):
    CfgDataMsgLogReportOpen = _libs["libPyFd.so"].get("CfgDataMsgLogReportOpen", "cdecl")
    CfgDataMsgLogReportOpen.argtypes = [POINTER(CfgData_t)]
    CfgDataMsgLogReportOpen.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 138
if _libs["libPyFd.so"].has("CfgDataMsgRSend", "cdecl"):
    CfgDataMsgRSend = _libs["libPyFd.so"].get("CfgDataMsgRSend", "cdecl")
    CfgDataMsgRSend.argtypes = [POINTER(CfgData_t), c_double]
    CfgDataMsgRSend.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 139
if _libs["libPyFd.so"].has("CfgDataMsgSendInit", "cdecl"):
    CfgDataMsgSendInit = _libs["libPyFd.so"].get("CfgDataMsgSendInit", "cdecl")
    CfgDataMsgSendInit.argtypes = [POINTER(CfgData_t), POINTER(CfgMsg_t)]
    CfgDataMsgSendInit.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 140
if _libs["libPyFd.so"].has("CfgDataMsgSendLog", "cdecl"):
    CfgDataMsgSendLog = _libs["libPyFd.so"].get("CfgDataMsgSendLog", "cdecl")
    CfgDataMsgSendLog.argtypes = [POINTER(CfgData_t), POINTER(CfgMsg_t)]
    CfgDataMsgSendLog.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 141
if _libs["libPyFd.so"].has("CfgDataMsgSendStdout", "cdecl"):
    CfgDataMsgSendStdout = _libs["libPyFd.so"].get("CfgDataMsgSendStdout", "cdecl")
    CfgDataMsgSendStdout.argtypes = [POINTER(CfgData_t), POINTER(CfgMsg_t)]
    CfgDataMsgSendStdout.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 142
if _libs["libPyFd.so"].has("CfgDataNew", "cdecl"):
    CfgDataNew = _libs["libPyFd.so"].get("CfgDataNew", "cdecl")
    CfgDataNew.argtypes = [c_int, POINTER(POINTER(c_char)), c_int]
    CfgDataNew.restype = POINTER(CfgData_t)

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 143
if _libs["libPyFd.so"].has("CfgDataOpenLogStream", "cdecl"):
    CfgDataOpenLogStream = _libs["libPyFd.so"].get("CfgDataOpenLogStream", "cdecl")
    CfgDataOpenLogStream.argtypes = [POINTER(CfgData_t)]
    CfgDataOpenLogStream.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 144
if _libs["libPyFd.so"].has("CfgDataReachState", "cdecl"):
    CfgDataReachState = _libs["libPyFd.so"].get("CfgDataReachState", "cdecl")
    CfgDataReachState.argtypes = [POINTER(CfgData_t), CfgServerState_t]
    CfgDataReachState.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 145
if _libs["libPyFd.so"].has("CfgDataSetCmCleanupTmo", "cdecl"):
    CfgDataSetCmCleanupTmo = _libs["libPyFd.so"].get("CfgDataSetCmCleanupTmo", "cdecl")
    CfgDataSetCmCleanupTmo.argtypes = [POINTER(CfgData_t), c_double]
    CfgDataSetCmCleanupTmo.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 146
if _libs["libPyFd.so"].has("CfgDataSetCmDomainName", "cdecl"):
    CfgDataSetCmDomainName = _libs["libPyFd.so"].get("CfgDataSetCmDomainName", "cdecl")
    CfgDataSetCmDomainName.argtypes = [POINTER(CfgData_t), String]
    CfgDataSetCmDomainName.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 147
if _libs["libPyFd.so"].has("CfgDataSetConfig", "cdecl"):
    CfgDataSetConfig = _libs["libPyFd.so"].get("CfgDataSetConfig", "cdecl")
    CfgDataSetConfig.argtypes = [POINTER(CfgData_t), String]
    CfgDataSetConfig.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 148
if _libs["libPyFd.so"].has("CfgDataSetConfigFnt", "cdecl"):
    CfgDataSetConfigFnt = _libs["libPyFd.so"].get("CfgDataSetConfigFnt", "cdecl")
    CfgDataSetConfigFnt.argtypes = [POINTER(CfgData_t), CfgConfigFnt_t]
    CfgDataSetConfigFnt.restype = CfgConfigFnt_t

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 150
if _libs["libPyFd.so"].has("CfgDataSetDebug", "cdecl"):
    CfgDataSetDebug = _libs["libPyFd.so"].get("CfgDataSetDebug", "cdecl")
    CfgDataSetDebug.argtypes = [POINTER(CfgData_t), c_int]
    CfgDataSetDebug.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 151
if _libs["libPyFd.so"].has("CfgDataSetNoDbSave", "cdecl"):
    CfgDataSetNoDbSave = _libs["libPyFd.so"].get("CfgDataSetNoDbSave", "cdecl")
    CfgDataSetNoDbSave.argtypes = [POINTER(CfgData_t), c_int]
    CfgDataSetNoDbSave.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 152
if _libs["libPyFd.so"].has("CfgDataSetNoFileSave", "cdecl"):
    CfgDataSetNoFileSave = _libs["libPyFd.so"].get("CfgDataSetNoFileSave", "cdecl")
    CfgDataSetNoFileSave.argtypes = [POINTER(CfgData_t), c_int]
    CfgDataSetNoFileSave.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 153
if _libs["libPyFd.so"].has("CfgDataSetPeriodTime", "cdecl"):
    CfgDataSetPeriodTime = _libs["libPyFd.so"].get("CfgDataSetPeriodTime", "cdecl")
    CfgDataSetPeriodTime.argtypes = [POINTER(CfgData_t), c_double]
    CfgDataSetPeriodTime.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 154
if _libs["libPyFd.so"].has("CfgDataSetPrio", "cdecl"):
    CfgDataSetPrio = _libs["libPyFd.so"].get("CfgDataSetPrio", "cdecl")
    CfgDataSetPrio.argtypes = [POINTER(CfgData_t), c_int]
    CfgDataSetPrio.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 155
if _libs["libPyFd.so"].has("CfgDataSetRFlag", "cdecl"):
    CfgDataSetRFlag = _libs["libPyFd.so"].get("CfgDataSetRFlag", "cdecl")
    CfgDataSetRFlag.argtypes = [POINTER(CfgData_t), c_int, c_int, c_int]
    CfgDataSetRFlag.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 156
if _libs["libPyFd.so"].has("CfgDataSetSchedAffinity", "cdecl"):
    CfgDataSetSchedAffinity = _libs["libPyFd.so"].get("CfgDataSetSchedAffinity", "cdecl")
    CfgDataSetSchedAffinity.argtypes = [POINTER(CfgData_t), String]
    CfgDataSetSchedAffinity.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 157
if _libs["libPyFd.so"].has("CfgDataSetStateFnt", "cdecl"):
    CfgDataSetStateFnt = _libs["libPyFd.so"].get("CfgDataSetStateFnt", "cdecl")
    CfgDataSetStateFnt.argtypes = [POINTER(CfgData_t), c_int, c_int, CfgStateReachFnt_t, POINTER(None)]
    CfgDataSetStateFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 159
if _libs["libPyFd.so"].has("CfgDataSetStateStrFnt", "cdecl"):
    CfgDataSetStateStrFnt = _libs["libPyFd.so"].get("CfgDataSetStateStrFnt", "cdecl")
    CfgDataSetStateStrFnt.argtypes = [POINTER(CfgData_t), CfgStateStrFnt_t]
    CfgDataSetStateStrFnt.restype = None

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 160
if _libs["libPyFd.so"].has("CfgDataSetUserActivationFnt", "cdecl"):
    CfgDataSetUserActivationFnt = _libs["libPyFd.so"].get("CfgDataSetUserActivationFnt", "cdecl")
    CfgDataSetUserActivationFnt.argtypes = [POINTER(CfgData_t), CfgUserActivationGetFnt_t, POINTER(None)]
    CfgDataSetUserActivationFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 164
class struct_CfgPrinter(Structure):
    pass

CfgPrinter_t = struct_CfgPrinter# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 164

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 165
if _libs["libPyFd.so"].has("CfgDataMsgPrinterv", "cdecl"):
    CfgDataMsgPrinterv = _libs["libPyFd.so"].get("CfgDataMsgPrinterv", "cdecl")
    CfgDataMsgPrinterv.argtypes = [POINTER(CfgData_t), String, c_void_p]
    CfgDataMsgPrinterv.restype = c_int

# /usr/include/fnmatch.h: 57
if _libs["libPyFd.so"].has("fnmatch", "cdecl"):
    fnmatch = _libs["libPyFd.so"].get("fnmatch", "cdecl")
    fnmatch.argtypes = [String, String, c_int]
    fnmatch.restype = c_int

# /usr/include/glob.h: 106
class struct_anon_43(Structure):
    pass

struct_anon_43.__slots__ = [
    'gl_pathc',
    'gl_pathv',
    'gl_offs',
    'gl_flags',
    'gl_closedir',
    'gl_readdir',
    'gl_opendir',
    'gl_lstat',
    'gl_stat',
]
struct_anon_43._fields_ = [
    ('gl_pathc', c_size_t),
    ('gl_pathv', POINTER(POINTER(c_char))),
    ('gl_offs', c_size_t),
    ('gl_flags', c_int),
    ('gl_closedir', CFUNCTYPE(UNCHECKED(None), POINTER(None))),
    ('gl_readdir', CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), POINTER(None))),
    ('gl_opendir', CFUNCTYPE(UNCHECKED(POINTER(c_ubyte)), String)),
    ('gl_lstat', CFUNCTYPE(UNCHECKED(c_int), String, POINTER(None))),
    ('gl_stat', CFUNCTYPE(UNCHECKED(c_int), String, POINTER(None))),
]

glob_t = struct_anon_43# /usr/include/glob.h: 106

# /usr/include/glob.h: 147
if _libs["libPyFd.so"].has("glob", "cdecl"):
    glob = _libs["libPyFd.so"].get("glob", "cdecl")
    glob.argtypes = [String, c_int, CFUNCTYPE(UNCHECKED(c_int), String, c_int), POINTER(glob_t)]
    glob.restype = c_int

# /usr/include/glob.h: 152
if _libs["libPyFd.so"].has("globfree", "cdecl"):
    globfree = _libs["libPyFd.so"].get("globfree", "cdecl")
    globfree.argtypes = [POINTER(glob_t)]
    globfree.restype = None

# /usr/include/bits/semaphore.h: 40
class union_anon_44(Union):
    pass

union_anon_44.__slots__ = [
    '__size',
    '__align',
]
union_anon_44._fields_ = [
    ('__size', c_char * int(32)),
    ('__align', c_long),
]

sem_t = union_anon_44# /usr/include/bits/semaphore.h: 40

# /usr/include/semaphore.h: 36
if _libs["libPyFd.so"].has("sem_init", "cdecl"):
    sem_init = _libs["libPyFd.so"].get("sem_init", "cdecl")
    sem_init.argtypes = [POINTER(sem_t), c_int, c_uint]
    sem_init.restype = c_int

# /usr/include/semaphore.h: 39
if _libs["libPyFd.so"].has("sem_destroy", "cdecl"):
    sem_destroy = _libs["libPyFd.so"].get("sem_destroy", "cdecl")
    sem_destroy.argtypes = [POINTER(sem_t)]
    sem_destroy.restype = c_int

# /usr/include/semaphore.h: 42
if _libs["libPyFd.so"].has("sem_open", "cdecl"):
    _func = _libs["libPyFd.so"].get("sem_open", "cdecl")
    _restype = POINTER(sem_t)
    _errcheck = None
    _argtypes = [String, c_int]
    sem_open = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/semaphore.h: 45
if _libs["libPyFd.so"].has("sem_close", "cdecl"):
    sem_close = _libs["libPyFd.so"].get("sem_close", "cdecl")
    sem_close.argtypes = [POINTER(sem_t)]
    sem_close.restype = c_int

# /usr/include/semaphore.h: 48
if _libs["libPyFd.so"].has("sem_unlink", "cdecl"):
    sem_unlink = _libs["libPyFd.so"].get("sem_unlink", "cdecl")
    sem_unlink.argtypes = [String]
    sem_unlink.restype = c_int

# /usr/include/semaphore.h: 54
if _libs["libPyFd.so"].has("sem_wait", "cdecl"):
    sem_wait = _libs["libPyFd.so"].get("sem_wait", "cdecl")
    sem_wait.argtypes = [POINTER(sem_t)]
    sem_wait.restype = c_int

# /usr/include/semaphore.h: 61
if _libs["libPyFd.so"].has("sem_timedwait", "cdecl"):
    sem_timedwait = _libs["libPyFd.so"].get("sem_timedwait", "cdecl")
    sem_timedwait.argtypes = [POINTER(sem_t), POINTER(struct_timespec)]
    sem_timedwait.restype = c_int

# /usr/include/semaphore.h: 66
if _libs["libPyFd.so"].has("sem_trywait", "cdecl"):
    sem_trywait = _libs["libPyFd.so"].get("sem_trywait", "cdecl")
    sem_trywait.argtypes = [POINTER(sem_t)]
    sem_trywait.restype = c_int

# /usr/include/semaphore.h: 69
if _libs["libPyFd.so"].has("sem_post", "cdecl"):
    sem_post = _libs["libPyFd.so"].get("sem_post", "cdecl")
    sem_post.argtypes = [POINTER(sem_t)]
    sem_post.restype = c_int

# /usr/include/semaphore.h: 72
if _libs["libPyFd.so"].has("sem_getvalue", "cdecl"):
    sem_getvalue = _libs["libPyFd.so"].get("sem_getvalue", "cdecl")
    sem_getvalue.argtypes = [POINTER(sem_t), POINTER(c_int)]
    sem_getvalue.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 42
class struct_CfgRequest(Structure):
    pass

struct_CfgRequest.__slots__ = [
    'request',
    'next',
]
struct_CfgRequest._fields_ = [
    ('request', POINTER(None)),
    ('next', POINTER(struct_CfgRequest)),
]

CfgRequest_t = struct_CfgRequest# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 45

CfgQueuePrinter_t = CFUNCTYPE(UNCHECKED(c_int), String, c_void_p)# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 47

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 57
class struct_CfgQueue(Structure):
    pass

struct_CfgQueue.__slots__ = [
    'name',
    'lock',
    'sync',
    'nbRequest',
    'threshold',
    'head',
    'tail',
]
struct_CfgQueue._fields_ = [
    ('name', String),
    ('lock', pthread_mutex_t),
    ('sync', sem_t),
    ('nbRequest', c_int),
    ('threshold', c_int),
    ('head', POINTER(CfgRequest_t)),
    ('tail', POINTER(CfgRequest_t)),
]

CfgQueue_t = struct_CfgQueue# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 57

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 59
if _libs["libPyFd.so"].has("CfgDequeue", "cdecl"):
    CfgDequeue = _libs["libPyFd.so"].get("CfgDequeue", "cdecl")
    CfgDequeue.argtypes = [POINTER(CfgQueue_t), c_double]
    CfgDequeue.restype = POINTER(c_ubyte)
    CfgDequeue.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 60
if _libs["libPyFd.so"].has("CfgEnqueue", "cdecl"):
    CfgEnqueue = _libs["libPyFd.so"].get("CfgEnqueue", "cdecl")
    CfgEnqueue.argtypes = [POINTER(CfgQueue_t), POINTER(None)]
    CfgEnqueue.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 61
if _libs["libPyFd.so"].has("CfgQueueFlush", "cdecl"):
    CfgQueueFlush = _libs["libPyFd.so"].get("CfgQueueFlush", "cdecl")
    CfgQueueFlush.argtypes = [POINTER(CfgQueue_t), c_int]
    CfgQueueFlush.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 62
if _libs["libPyFd.so"].has("CfgQueueFree", "cdecl"):
    CfgQueueFree = _libs["libPyFd.so"].get("CfgQueueFree", "cdecl")
    CfgQueueFree.argtypes = [POINTER(CfgQueue_t)]
    CfgQueueFree.restype = POINTER(CfgQueue_t)

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 63
if _libs["libPyFd.so"].has("CfgQueueGetValue", "cdecl"):
    CfgQueueGetValue = _libs["libPyFd.so"].get("CfgQueueGetValue", "cdecl")
    CfgQueueGetValue.argtypes = [POINTER(CfgQueue_t)]
    CfgQueueGetValue.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 64
if _libs["libPyFd.so"].has("CfgQueueInstallPrinter", "cdecl"):
    CfgQueueInstallPrinter = _libs["libPyFd.so"].get("CfgQueueInstallPrinter", "cdecl")
    CfgQueueInstallPrinter.argtypes = [CfgQueuePrinter_t]
    CfgQueueInstallPrinter.restype = CfgQueuePrinter_t

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 65
if _libs["libPyFd.so"].has("CfgQueueNamedNew", "cdecl"):
    CfgQueueNamedNew = _libs["libPyFd.so"].get("CfgQueueNamedNew", "cdecl")
    CfgQueueNamedNew.argtypes = [c_int, String]
    CfgQueueNamedNew.restype = POINTER(CfgQueue_t)

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 66
if _libs["libPyFd.so"].has("CfgQueueNew", "cdecl"):
    CfgQueueNew = _libs["libPyFd.so"].get("CfgQueueNew", "cdecl")
    CfgQueueNew.argtypes = [c_int]
    CfgQueueNew.restype = POINTER(CfgQueue_t)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 90
if _libs["libPyFd.so"].has("CfgConfAdd", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgConfAdd", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgConfAdd = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 91
if _libs["libPyFd.so"].has("CfgConfigCommit", "cdecl"):
    CfgConfigCommit = _libs["libPyFd.so"].get("CfgConfigCommit", "cdecl")
    CfgConfigCommit.argtypes = [String]
    CfgConfigCommit.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 92
if _libs["libPyFd.so"].has("CfgConfigLoad", "cdecl"):
    CfgConfigLoad = _libs["libPyFd.so"].get("CfgConfigLoad", "cdecl")
    CfgConfigLoad.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgConfigLoad.restype = ReturnString
    else:
        CfgConfigLoad.restype = String
        CfgConfigLoad.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 93
if _libs["libPyFd.so"].has("CfgClose", "cdecl"):
    CfgClose = _libs["libPyFd.so"].get("CfgClose", "cdecl")
    CfgClose.argtypes = []
    CfgClose.restype = None

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 94
if _libs["libPyFd.so"].has("CfgFinished", "cdecl"):
    CfgFinished = _libs["libPyFd.so"].get("CfgFinished", "cdecl")
    CfgFinished.argtypes = []
    CfgFinished.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 95
if _libs["libPyFd.so"].has("CfgFromFile", "cdecl"):
    CfgFromFile = _libs["libPyFd.so"].get("CfgFromFile", "cdecl")
    CfgFromFile.argtypes = [String]
    CfgFromFile.restype = CfgBool_t

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 96
if _libs["libPyFd.so"].has("CfgGetCmName", "cdecl"):
    CfgGetCmName = _libs["libPyFd.so"].get("CfgGetCmName", "cdecl")
    CfgGetCmName.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CfgGetCmName.restype = ReturnString
    else:
        CfgGetCmName.restype = String
        CfgGetCmName.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 97
if _libs["libPyFd.so"].has("CfgGetConfig", "cdecl"):
    CfgGetConfig = _libs["libPyFd.so"].get("CfgGetConfig", "cdecl")
    CfgGetConfig.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        CfgGetConfig.restype = ReturnString
    else:
        CfgGetConfig.restype = String
        CfgGetConfig.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 98
if _libs["libPyFd.so"].has("CfgGetDebug", "cdecl"):
    CfgGetDebug = _libs["libPyFd.so"].get("CfgGetDebug", "cdecl")
    CfgGetDebug.argtypes = []
    CfgGetDebug.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 99
if _libs["libPyFd.so"].has("CfgGetLogStream", "cdecl"):
    CfgGetLogStream = _libs["libPyFd.so"].get("CfgGetLogStream", "cdecl")
    CfgGetLogStream.argtypes = []
    CfgGetLogStream.restype = POINTER(FILE)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 100
if _libs["libPyFd.so"].has("CfgGetLogStreamFlush", "cdecl"):
    CfgGetLogStreamFlush = _libs["libPyFd.so"].get("CfgGetLogStreamFlush", "cdecl")
    CfgGetLogStreamFlush.argtypes = [c_double]
    CfgGetLogStreamFlush.restype = POINTER(FILE)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 101
if _libs["libPyFd.so"].has("CfgGetRequestedState", "cdecl"):
    CfgGetRequestedState = _libs["libPyFd.so"].get("CfgGetRequestedState", "cdecl")
    CfgGetRequestedState.argtypes = []
    CfgGetRequestedState.restype = CfgServerState_t

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 102
if _libs["libPyFd.so"].has("CfgGetState", "cdecl"):
    CfgGetState = _libs["libPyFd.so"].get("CfgGetState", "cdecl")
    CfgGetState.argtypes = []
    CfgGetState.restype = CfgServerState_t

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 103
if _libs["libPyFd.so"].has("CfgIdle", "cdecl"):
    CfgIdle = _libs["libPyFd.so"].get("CfgIdle", "cdecl")
    CfgIdle.argtypes = [c_int, POINTER(POINTER(c_char)), c_int]
    CfgIdle.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 104
if _libs["libPyFd.so"].has("CfgIdleWithUserActivationFnt", "cdecl"):
    CfgIdleWithUserActivationFnt = _libs["libPyFd.so"].get("CfgIdleWithUserActivationFnt", "cdecl")
    CfgIdleWithUserActivationFnt.argtypes = [c_int, POINTER(POINTER(c_char)), c_int, CfgUserActivationGetFnt_t, POINTER(None)]
    CfgIdleWithUserActivationFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 106
if _libs["libPyFd.so"].has("CfgLogFPrint", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgLogFPrint", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgLogFPrint = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 109
if _libs["libPyFd.so"].has("CfgMsgAddFmtv", "cdecl"):
    CfgMsgAddFmtv = _libs["libPyFd.so"].get("CfgMsgAddFmtv", "cdecl")
    CfgMsgAddFmtv.argtypes = [c_int, c_int, String, String, c_void_p]
    CfgMsgAddFmtv.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 112
if _libs["libPyFd.so"].has("CfgMsgAddFmt", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddFmt", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [c_int, c_int, String]
    CfgMsgAddFmt = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 115
if _libs["libPyFd.so"].has("CfgMsgAddFmtTag", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddFmtTag", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [c_int, c_int, String, String]
    CfgMsgAddFmtTag = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 117
if _libs["libPyFd.so"].has("CfgMsgAddInfo", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddInfo", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgAddInfo = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 120
if _libs["libPyFd.so"].has("CfgMsgAddError", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddError", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgAddError = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 123
if _libs["libPyFd.so"].has("CfgMsgAddFatal", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddFatal", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgAddFatal = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 126
if _libs["libPyFd.so"].has("CfgMsgAddUserInfo", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddUserInfo", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgAddUserInfo = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 129
if _libs["libPyFd.so"].has("CfgMsgAddWarning", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgAddWarning", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgAddWarning = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 131
if _libs["libPyFd.so"].has("CfgMsgSendWithTimeout", "cdecl"):
    CfgMsgSendWithTimeout = _libs["libPyFd.so"].get("CfgMsgSendWithTimeout", "cdecl")
    CfgMsgSendWithTimeout.argtypes = [c_double]
    CfgMsgSendWithTimeout.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 133
if _libs["libPyFd.so"].has("CfgMsgPrintInfo", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgPrintInfo", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgPrintInfo = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 136
if _libs["libPyFd.so"].has("CfgMsgPrintError", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgPrintError", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgPrintError = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 139
if _libs["libPyFd.so"].has("CfgMsgPrintWarning", "cdecl"):
    _func = _libs["libPyFd.so"].get("CfgMsgPrintWarning", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String]
    CfgMsgPrintWarning = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 143
for _lib in _libs.values():
    if not _lib.has("CfgMsgPrinter", "cdecl"):
        continue
    CfgMsgPrinter = _lib.get("CfgMsgPrinter", "cdecl")
    CfgMsgPrinter.argtypes = [String, c_void_p]
    CfgMsgPrinter.restype = c_int
    break

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 144
if _libs["libPyFd.so"].has("CfgParseIdleAdd", "cdecl"):
    CfgParseIdleAdd = _libs["libPyFd.so"].get("CfgParseIdleAdd", "cdecl")
    CfgParseIdleAdd.argtypes = [POINTER(CfgParse_t)]
    CfgParseIdleAdd.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 145
if _libs["libPyFd.so"].has("CfgParseIdleAddNoAction", "cdecl"):
    CfgParseIdleAddNoAction = _libs["libPyFd.so"].get("CfgParseIdleAddNoAction", "cdecl")
    CfgParseIdleAddNoAction.argtypes = [POINTER(CfgParse_t)]
    CfgParseIdleAddNoAction.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 146
if _libs["libPyFd.so"].has("CfgReachState", "cdecl"):
    CfgReachState = _libs["libPyFd.so"].get("CfgReachState", "cdecl")
    CfgReachState.argtypes = [CfgServerState_t]
    CfgReachState.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 147
if _libs["libPyFd.so"].has("CfgRunTimeStr", "cdecl"):
    CfgRunTimeStr = _libs["libPyFd.so"].get("CfgRunTimeStr", "cdecl")
    CfgRunTimeStr.argtypes = [String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        CfgRunTimeStr.restype = ReturnString
    else:
        CfgRunTimeStr.restype = String
        CfgRunTimeStr.errcheck = ReturnString

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 148
if _libs["libPyFd.so"].has("CfgSetConfigFnt", "cdecl"):
    CfgSetConfigFnt = _libs["libPyFd.so"].get("CfgSetConfigFnt", "cdecl")
    CfgSetConfigFnt.argtypes = [CfgConfigFnt_t]
    CfgSetConfigFnt.restype = CfgConfigFnt_t

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 149
if _libs["libPyFd.so"].has("CfgSetDebug", "cdecl"):
    CfgSetDebug = _libs["libPyFd.so"].get("CfgSetDebug", "cdecl")
    CfgSetDebug.argtypes = [c_int]
    CfgSetDebug.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 150
if _libs["libPyFd.so"].has("CfgSetStateFnt", "cdecl"):
    CfgSetStateFnt = _libs["libPyFd.so"].get("CfgSetStateFnt", "cdecl")
    CfgSetStateFnt.argtypes = [c_int, c_int, CfgStateReachFnt_t, POINTER(None)]
    CfgSetStateFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 152
if _libs["libPyFd.so"].has("CfgSetRFlag", "cdecl"):
    CfgSetRFlag = _libs["libPyFd.so"].get("CfgSetRFlag", "cdecl")
    CfgSetRFlag.argtypes = [c_int, c_int, c_int]
    CfgSetRFlag.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 153
if _libs["libPyFd.so"].has("CfgSetUserActivationFnt", "cdecl"):
    CfgSetUserActivationFnt = _libs["libPyFd.so"].get("CfgSetUserActivationFnt", "cdecl")
    CfgSetUserActivationFnt.argtypes = [CfgUserActivationGetFnt_t, POINTER(None)]
    CfgSetUserActivationFnt.restype = c_int

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 155
if _libs["libPyFd.so"].has("CfgTerminate", "cdecl"):
    CfgTerminate = _libs["libPyFd.so"].get("CfgTerminate", "cdecl")
    CfgTerminate.argtypes = []
    CfgTerminate.restype = None

# /usr/include/string.h: 42
if _libs["libPyFd.so"].has("memcpy", "cdecl"):
    memcpy = _libs["libPyFd.so"].get("memcpy", "cdecl")
    memcpy.argtypes = [POINTER(None), POINTER(None), c_size_t]
    memcpy.restype = POINTER(c_ubyte)
    memcpy.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/string.h: 46
if _libs["libPyFd.so"].has("memmove", "cdecl"):
    memmove = _libs["libPyFd.so"].get("memmove", "cdecl")
    memmove.argtypes = [POINTER(None), POINTER(None), c_size_t]
    memmove.restype = POINTER(c_ubyte)
    memmove.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/string.h: 54
if _libs["libPyFd.so"].has("memccpy", "cdecl"):
    memccpy = _libs["libPyFd.so"].get("memccpy", "cdecl")
    memccpy.argtypes = [POINTER(None), POINTER(None), c_int, c_size_t]
    memccpy.restype = POINTER(c_ubyte)
    memccpy.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/string.h: 62
if _libs["libPyFd.so"].has("memset", "cdecl"):
    memset = _libs["libPyFd.so"].get("memset", "cdecl")
    memset.argtypes = [POINTER(None), c_int, c_size_t]
    memset.restype = POINTER(c_ubyte)
    memset.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/string.h: 65
if _libs["libPyFd.so"].has("memcmp", "cdecl"):
    memcmp = _libs["libPyFd.so"].get("memcmp", "cdecl")
    memcmp.argtypes = [POINTER(None), POINTER(None), c_size_t]
    memcmp.restype = c_int

# /usr/include/string.h: 92
if _libs["libPyFd.so"].has("memchr", "cdecl"):
    memchr = _libs["libPyFd.so"].get("memchr", "cdecl")
    memchr.argtypes = [POINTER(None), c_int, c_size_t]
    memchr.restype = POINTER(c_ubyte)
    memchr.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/string.h: 125
if _libs["libPyFd.so"].has("strcpy", "cdecl"):
    strcpy = _libs["libPyFd.so"].get("strcpy", "cdecl")
    strcpy.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        strcpy.restype = ReturnString
    else:
        strcpy.restype = String
        strcpy.errcheck = ReturnString

# /usr/include/string.h: 128
if _libs["libPyFd.so"].has("strncpy", "cdecl"):
    strncpy = _libs["libPyFd.so"].get("strncpy", "cdecl")
    strncpy.argtypes = [String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        strncpy.restype = ReturnString
    else:
        strncpy.restype = String
        strncpy.errcheck = ReturnString

# /usr/include/string.h: 133
if _libs["libPyFd.so"].has("strcat", "cdecl"):
    strcat = _libs["libPyFd.so"].get("strcat", "cdecl")
    strcat.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        strcat.restype = ReturnString
    else:
        strcat.restype = String
        strcat.errcheck = ReturnString

# /usr/include/string.h: 136
if _libs["libPyFd.so"].has("strncat", "cdecl"):
    strncat = _libs["libPyFd.so"].get("strncat", "cdecl")
    strncat.argtypes = [String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        strncat.restype = ReturnString
    else:
        strncat.restype = String
        strncat.errcheck = ReturnString

# /usr/include/string.h: 140
if _libs["libPyFd.so"].has("strcmp", "cdecl"):
    strcmp = _libs["libPyFd.so"].get("strcmp", "cdecl")
    strcmp.argtypes = [String, String]
    strcmp.restype = c_int

# /usr/include/string.h: 143
if _libs["libPyFd.so"].has("strncmp", "cdecl"):
    strncmp = _libs["libPyFd.so"].get("strncmp", "cdecl")
    strncmp.argtypes = [String, String, c_size_t]
    strncmp.restype = c_int

# /usr/include/string.h: 147
if _libs["libPyFd.so"].has("strcoll", "cdecl"):
    strcoll = _libs["libPyFd.so"].get("strcoll", "cdecl")
    strcoll.argtypes = [String, String]
    strcoll.restype = c_int

# /usr/include/string.h: 150
if _libs["libPyFd.so"].has("strxfrm", "cdecl"):
    strxfrm = _libs["libPyFd.so"].get("strxfrm", "cdecl")
    strxfrm.argtypes = [String, String, c_size_t]
    strxfrm.restype = c_size_t

# /usr/include/string.h: 162
if _libs["libPyFd.so"].has("strcoll_l", "cdecl"):
    strcoll_l = _libs["libPyFd.so"].get("strcoll_l", "cdecl")
    strcoll_l.argtypes = [String, String, __locale_t]
    strcoll_l.restype = c_int

# /usr/include/string.h: 165
if _libs["libPyFd.so"].has("strxfrm_l", "cdecl"):
    strxfrm_l = _libs["libPyFd.so"].get("strxfrm_l", "cdecl")
    strxfrm_l.argtypes = [String, String, c_size_t, __locale_t]
    strxfrm_l.restype = c_size_t

# /usr/include/string.h: 172
if _libs["libPyFd.so"].has("strdup", "cdecl"):
    strdup = _libs["libPyFd.so"].get("strdup", "cdecl")
    strdup.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        strdup.restype = ReturnString
    else:
        strdup.restype = String
        strdup.errcheck = ReturnString

# /usr/include/string.h: 180
if _libs["libPyFd.so"].has("strndup", "cdecl"):
    strndup = _libs["libPyFd.so"].get("strndup", "cdecl")
    strndup.argtypes = [String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        strndup.restype = ReturnString
    else:
        strndup.restype = String
        strndup.errcheck = ReturnString

# /usr/include/string.h: 232
if _libs["libPyFd.so"].has("strchr", "cdecl"):
    strchr = _libs["libPyFd.so"].get("strchr", "cdecl")
    strchr.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        strchr.restype = ReturnString
    else:
        strchr.restype = String
        strchr.errcheck = ReturnString

# /usr/include/string.h: 259
if _libs["libPyFd.so"].has("strrchr", "cdecl"):
    strrchr = _libs["libPyFd.so"].get("strrchr", "cdecl")
    strrchr.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        strrchr.restype = ReturnString
    else:
        strrchr.restype = String
        strrchr.errcheck = ReturnString

# /usr/include/string.h: 281
if _libs["libPyFd.so"].has("strcspn", "cdecl"):
    strcspn = _libs["libPyFd.so"].get("strcspn", "cdecl")
    strcspn.argtypes = [String, String]
    strcspn.restype = c_size_t

# /usr/include/string.h: 285
if _libs["libPyFd.so"].has("strspn", "cdecl"):
    strspn = _libs["libPyFd.so"].get("strspn", "cdecl")
    strspn.argtypes = [String, String]
    strspn.restype = c_size_t

# /usr/include/string.h: 311
if _libs["libPyFd.so"].has("strpbrk", "cdecl"):
    strpbrk = _libs["libPyFd.so"].get("strpbrk", "cdecl")
    strpbrk.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        strpbrk.restype = ReturnString
    else:
        strpbrk.restype = String
        strpbrk.errcheck = ReturnString

# /usr/include/string.h: 338
if _libs["libPyFd.so"].has("strstr", "cdecl"):
    strstr = _libs["libPyFd.so"].get("strstr", "cdecl")
    strstr.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        strstr.restype = ReturnString
    else:
        strstr.restype = String
        strstr.errcheck = ReturnString

# /usr/include/string.h: 344
if _libs["libPyFd.so"].has("strtok", "cdecl"):
    strtok = _libs["libPyFd.so"].get("strtok", "cdecl")
    strtok.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        strtok.restype = ReturnString
    else:
        strtok.restype = String
        strtok.errcheck = ReturnString

# /usr/include/string.h: 350
if _libs["libPyFd.so"].has("__strtok_r", "cdecl"):
    __strtok_r = _libs["libPyFd.so"].get("__strtok_r", "cdecl")
    __strtok_r.argtypes = [String, String, POINTER(POINTER(c_char))]
    if sizeof(c_int) == sizeof(c_void_p):
        __strtok_r.restype = ReturnString
    else:
        __strtok_r.restype = String
        __strtok_r.errcheck = ReturnString

# /usr/include/string.h: 355
if _libs["libPyFd.so"].has("strtok_r", "cdecl"):
    strtok_r = _libs["libPyFd.so"].get("strtok_r", "cdecl")
    strtok_r.argtypes = [String, String, POINTER(POINTER(c_char))]
    if sizeof(c_int) == sizeof(c_void_p):
        strtok_r.restype = ReturnString
    else:
        strtok_r.restype = String
        strtok_r.errcheck = ReturnString

# /usr/include/string.h: 395
if _libs["libPyFd.so"].has("strlen", "cdecl"):
    strlen = _libs["libPyFd.so"].get("strlen", "cdecl")
    strlen.argtypes = [String]
    strlen.restype = c_size_t

# /usr/include/string.h: 402
if _libs["libPyFd.so"].has("strnlen", "cdecl"):
    strnlen = _libs["libPyFd.so"].get("strnlen", "cdecl")
    strnlen.argtypes = [String, c_size_t]
    strnlen.restype = c_size_t

# /usr/include/string.h: 409
if _libs["libPyFd.so"].has("strerror", "cdecl"):
    strerror = _libs["libPyFd.so"].get("strerror", "cdecl")
    strerror.argtypes = [c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        strerror.restype = ReturnString
    else:
        strerror.restype = String
        strerror.errcheck = ReturnString

# /usr/include/string.h: 427
if _libs["libPyFd.so"].has("__xpg_strerror_r", "cdecl"):
    __xpg_strerror_r = _libs["libPyFd.so"].get("__xpg_strerror_r", "cdecl")
    __xpg_strerror_r.argtypes = [c_int, String, c_size_t]
    __xpg_strerror_r.restype = c_int

# /usr/include/string.h: 441
if _libs["libPyFd.so"].has("strerror_l", "cdecl"):
    strerror_l = _libs["libPyFd.so"].get("strerror_l", "cdecl")
    strerror_l.argtypes = [c_int, __locale_t]
    if sizeof(c_int) == sizeof(c_void_p):
        strerror_l.restype = ReturnString
    else:
        strerror_l.restype = String
        strerror_l.errcheck = ReturnString

# /usr/include/string.h: 447
if _libs["libPyFd.so"].has("__bzero", "cdecl"):
    __bzero = _libs["libPyFd.so"].get("__bzero", "cdecl")
    __bzero.argtypes = [POINTER(None), c_size_t]
    __bzero.restype = None

# /usr/include/string.h: 451
if _libs["libPyFd.so"].has("bcopy", "cdecl"):
    bcopy = _libs["libPyFd.so"].get("bcopy", "cdecl")
    bcopy.argtypes = [POINTER(None), POINTER(None), c_size_t]
    bcopy.restype = None

# /usr/include/string.h: 455
if _libs["libPyFd.so"].has("bzero", "cdecl"):
    bzero = _libs["libPyFd.so"].get("bzero", "cdecl")
    bzero.argtypes = [POINTER(None), c_size_t]
    bzero.restype = None

# /usr/include/string.h: 458
if _libs["libPyFd.so"].has("bcmp", "cdecl"):
    bcmp = _libs["libPyFd.so"].get("bcmp", "cdecl")
    bcmp.argtypes = [POINTER(None), POINTER(None), c_size_t]
    bcmp.restype = c_int

# /usr/include/string.h: 485
if _libs["libPyFd.so"].has("index", "cdecl"):
    index = _libs["libPyFd.so"].get("index", "cdecl")
    index.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        index.restype = ReturnString
    else:
        index.restype = String
        index.errcheck = ReturnString

# /usr/include/string.h: 513
if _libs["libPyFd.so"].has("rindex", "cdecl"):
    rindex = _libs["libPyFd.so"].get("rindex", "cdecl")
    rindex.argtypes = [String, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        rindex.restype = ReturnString
    else:
        rindex.restype = String
        rindex.errcheck = ReturnString

# /usr/include/string.h: 519
if _libs["libPyFd.so"].has("ffs", "cdecl"):
    ffs = _libs["libPyFd.so"].get("ffs", "cdecl")
    ffs.argtypes = [c_int]
    ffs.restype = c_int

# /usr/include/string.h: 532
if _libs["libPyFd.so"].has("strcasecmp", "cdecl"):
    strcasecmp = _libs["libPyFd.so"].get("strcasecmp", "cdecl")
    strcasecmp.argtypes = [String, String]
    strcasecmp.restype = c_int

# /usr/include/string.h: 536
if _libs["libPyFd.so"].has("strncasecmp", "cdecl"):
    strncasecmp = _libs["libPyFd.so"].get("strncasecmp", "cdecl")
    strncasecmp.argtypes = [String, String, c_size_t]
    strncasecmp.restype = c_int

# /usr/include/string.h: 555
if _libs["libPyFd.so"].has("strsep", "cdecl"):
    strsep = _libs["libPyFd.so"].get("strsep", "cdecl")
    strsep.argtypes = [POINTER(POINTER(c_char)), String]
    if sizeof(c_int) == sizeof(c_void_p):
        strsep.restype = ReturnString
    else:
        strsep.restype = String
        strsep.errcheck = ReturnString

# /usr/include/string.h: 562
if _libs["libPyFd.so"].has("strsignal", "cdecl"):
    strsignal = _libs["libPyFd.so"].get("strsignal", "cdecl")
    strsignal.argtypes = [c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        strsignal.restype = ReturnString
    else:
        strsignal.restype = String
        strsignal.errcheck = ReturnString

# /usr/include/string.h: 565
if _libs["libPyFd.so"].has("__stpcpy", "cdecl"):
    __stpcpy = _libs["libPyFd.so"].get("__stpcpy", "cdecl")
    __stpcpy.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        __stpcpy.restype = ReturnString
    else:
        __stpcpy.restype = String
        __stpcpy.errcheck = ReturnString

# /usr/include/string.h: 567
if _libs["libPyFd.so"].has("stpcpy", "cdecl"):
    stpcpy = _libs["libPyFd.so"].get("stpcpy", "cdecl")
    stpcpy.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        stpcpy.restype = ReturnString
    else:
        stpcpy.restype = String
        stpcpy.errcheck = ReturnString

# /usr/include/string.h: 572
if _libs["libPyFd.so"].has("__stpncpy", "cdecl"):
    __stpncpy = _libs["libPyFd.so"].get("__stpncpy", "cdecl")
    __stpncpy.argtypes = [String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        __stpncpy.restype = ReturnString
    else:
        __stpncpy.restype = String
        __stpncpy.errcheck = ReturnString

# /usr/include/string.h: 575
if _libs["libPyFd.so"].has("stpncpy", "cdecl"):
    stpncpy = _libs["libPyFd.so"].get("stpncpy", "cdecl")
    stpncpy.argtypes = [String, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        stpncpy.restype = ReturnString
    else:
        stpncpy.restype = String
        stpncpy.errcheck = ReturnString

wchar_t = c_int# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/stddef.h: 324

# /usr/include/bits/waitstatus.h: 69
class struct_anon_45(Structure):
    pass

struct_anon_45.__slots__ = [
    '__w_termsig',
    '__w_coredump',
    '__w_retcode',
    'unnamed_1',
]
struct_anon_45._fields_ = [
    ('__w_termsig', c_uint, 7),
    ('__w_coredump', c_uint, 1),
    ('__w_retcode', c_uint, 8),
    ('unnamed_1', c_uint, 16),
]

# /usr/include/bits/waitstatus.h: 84
class struct_anon_46(Structure):
    pass

struct_anon_46.__slots__ = [
    '__w_stopval',
    '__w_stopsig',
    'unnamed_1',
]
struct_anon_46._fields_ = [
    ('__w_stopval', c_uint, 8),
    ('__w_stopsig', c_uint, 8),
    ('unnamed_1', c_uint, 16),
]

# /usr/include/bits/waitstatus.h: 66
class union_wait(Union):
    pass

union_wait.__slots__ = [
    'w_status',
    '__wait_terminated',
    '__wait_stopped',
]
union_wait._fields_ = [
    ('w_status', c_int),
    ('__wait_terminated', struct_anon_45),
    ('__wait_stopped', struct_anon_46),
]

# /usr/include/stdlib.h: 101
class struct_anon_47(Structure):
    pass

struct_anon_47.__slots__ = [
    'quot',
    'rem',
]
struct_anon_47._fields_ = [
    ('quot', c_int),
    ('rem', c_int),
]

div_t = struct_anon_47# /usr/include/stdlib.h: 101

# /usr/include/stdlib.h: 109
class struct_anon_48(Structure):
    pass

struct_anon_48.__slots__ = [
    'quot',
    'rem',
]
struct_anon_48._fields_ = [
    ('quot', c_long),
    ('rem', c_long),
]

ldiv_t = struct_anon_48# /usr/include/stdlib.h: 109

# /usr/include/stdlib.h: 121
class struct_anon_49(Structure):
    pass

struct_anon_49.__slots__ = [
    'quot',
    'rem',
]
struct_anon_49._fields_ = [
    ('quot', c_longlong),
    ('rem', c_longlong),
]

lldiv_t = struct_anon_49# /usr/include/stdlib.h: 121

# /usr/include/stdlib.h: 139
if _libs["libPyFd.so"].has("__ctype_get_mb_cur_max", "cdecl"):
    __ctype_get_mb_cur_max = _libs["libPyFd.so"].get("__ctype_get_mb_cur_max", "cdecl")
    __ctype_get_mb_cur_max.argtypes = []
    __ctype_get_mb_cur_max.restype = c_size_t

# /usr/include/stdlib.h: 144
if _libs["libPyFd.so"].has("atof", "cdecl"):
    atof = _libs["libPyFd.so"].get("atof", "cdecl")
    atof.argtypes = [String]
    atof.restype = c_double

# /usr/include/stdlib.h: 147
if _libs["libPyFd.so"].has("atoi", "cdecl"):
    atoi = _libs["libPyFd.so"].get("atoi", "cdecl")
    atoi.argtypes = [String]
    atoi.restype = c_int

# /usr/include/stdlib.h: 150
if _libs["libPyFd.so"].has("atol", "cdecl"):
    atol = _libs["libPyFd.so"].get("atol", "cdecl")
    atol.argtypes = [String]
    atol.restype = c_long

# /usr/include/stdlib.h: 157
if _libs["libPyFd.so"].has("atoll", "cdecl"):
    atoll = _libs["libPyFd.so"].get("atoll", "cdecl")
    atoll.argtypes = [String]
    atoll.restype = c_longlong

# /usr/include/stdlib.h: 164
if _libs["libPyFd.so"].has("strtod", "cdecl"):
    strtod = _libs["libPyFd.so"].get("strtod", "cdecl")
    strtod.argtypes = [String, POINTER(POINTER(c_char))]
    strtod.restype = c_double

# /usr/include/stdlib.h: 172
if _libs["libPyFd.so"].has("strtof", "cdecl"):
    strtof = _libs["libPyFd.so"].get("strtof", "cdecl")
    strtof.argtypes = [String, POINTER(POINTER(c_char))]
    strtof.restype = c_float

# /usr/include/stdlib.h: 175
if _libs["libPyFd.so"].has("strtold", "cdecl"):
    strtold = _libs["libPyFd.so"].get("strtold", "cdecl")
    strtold.argtypes = [String, POINTER(POINTER(c_char))]
    strtold.restype = c_longdouble

# /usr/include/stdlib.h: 183
if _libs["libPyFd.so"].has("strtol", "cdecl"):
    strtol = _libs["libPyFd.so"].get("strtol", "cdecl")
    strtol.argtypes = [String, POINTER(POINTER(c_char)), c_int]
    strtol.restype = c_long

# /usr/include/stdlib.h: 187
if _libs["libPyFd.so"].has("strtoul", "cdecl"):
    strtoul = _libs["libPyFd.so"].get("strtoul", "cdecl")
    strtoul.argtypes = [String, POINTER(POINTER(c_char)), c_int]
    strtoul.restype = c_ulong

# /usr/include/stdlib.h: 209
if _libs["libPyFd.so"].has("strtoll", "cdecl"):
    strtoll = _libs["libPyFd.so"].get("strtoll", "cdecl")
    strtoll.argtypes = [String, POINTER(POINTER(c_char)), c_int]
    strtoll.restype = c_longlong

# /usr/include/stdlib.h: 214
if _libs["libPyFd.so"].has("strtoull", "cdecl"):
    strtoull = _libs["libPyFd.so"].get("strtoull", "cdecl")
    strtoull.argtypes = [String, POINTER(POINTER(c_char)), c_int]
    strtoull.restype = c_ulonglong

# /usr/include/stdlib.h: 305
if _libs["libPyFd.so"].has("l64a", "cdecl"):
    l64a = _libs["libPyFd.so"].get("l64a", "cdecl")
    l64a.argtypes = [c_long]
    if sizeof(c_int) == sizeof(c_void_p):
        l64a.restype = ReturnString
    else:
        l64a.restype = String
        l64a.errcheck = ReturnString

# /usr/include/stdlib.h: 308
if _libs["libPyFd.so"].has("a64l", "cdecl"):
    a64l = _libs["libPyFd.so"].get("a64l", "cdecl")
    a64l.argtypes = [String]
    a64l.restype = c_long

# /usr/include/stdlib.h: 321
if _libs["libPyFd.so"].has("random", "cdecl"):
    random = _libs["libPyFd.so"].get("random", "cdecl")
    random.argtypes = []
    random.restype = c_long

# /usr/include/stdlib.h: 324
if _libs["libPyFd.so"].has("srandom", "cdecl"):
    srandom = _libs["libPyFd.so"].get("srandom", "cdecl")
    srandom.argtypes = [c_uint]
    srandom.restype = None

# /usr/include/stdlib.h: 330
if _libs["libPyFd.so"].has("initstate", "cdecl"):
    initstate = _libs["libPyFd.so"].get("initstate", "cdecl")
    initstate.argtypes = [c_uint, String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        initstate.restype = ReturnString
    else:
        initstate.restype = String
        initstate.errcheck = ReturnString

# /usr/include/stdlib.h: 335
if _libs["libPyFd.so"].has("setstate", "cdecl"):
    setstate = _libs["libPyFd.so"].get("setstate", "cdecl")
    setstate.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        setstate.restype = ReturnString
    else:
        setstate.restype = String
        setstate.errcheck = ReturnString

# /usr/include/stdlib.h: 343
class struct_random_data(Structure):
    pass

struct_random_data.__slots__ = [
    'fptr',
    'rptr',
    'state',
    'rand_type',
    'rand_deg',
    'rand_sep',
    'end_ptr',
]
struct_random_data._fields_ = [
    ('fptr', POINTER(c_int32)),
    ('rptr', POINTER(c_int32)),
    ('state', POINTER(c_int32)),
    ('rand_type', c_int),
    ('rand_deg', c_int),
    ('rand_sep', c_int),
    ('end_ptr', POINTER(c_int32)),
]

# /usr/include/stdlib.h: 354
if _libs["libPyFd.so"].has("random_r", "cdecl"):
    random_r = _libs["libPyFd.so"].get("random_r", "cdecl")
    random_r.argtypes = [POINTER(struct_random_data), POINTER(c_int32)]
    random_r.restype = c_int

# /usr/include/stdlib.h: 357
if _libs["libPyFd.so"].has("srandom_r", "cdecl"):
    srandom_r = _libs["libPyFd.so"].get("srandom_r", "cdecl")
    srandom_r.argtypes = [c_uint, POINTER(struct_random_data)]
    srandom_r.restype = c_int

# /usr/include/stdlib.h: 360
if _libs["libPyFd.so"].has("initstate_r", "cdecl"):
    initstate_r = _libs["libPyFd.so"].get("initstate_r", "cdecl")
    initstate_r.argtypes = [c_uint, String, c_size_t, POINTER(struct_random_data)]
    initstate_r.restype = c_int

# /usr/include/stdlib.h: 365
if _libs["libPyFd.so"].has("setstate_r", "cdecl"):
    setstate_r = _libs["libPyFd.so"].get("setstate_r", "cdecl")
    setstate_r.argtypes = [String, POINTER(struct_random_data)]
    setstate_r.restype = c_int

# /usr/include/stdlib.h: 374
if _libs["libPyFd.so"].has("rand", "cdecl"):
    rand = _libs["libPyFd.so"].get("rand", "cdecl")
    rand.argtypes = []
    rand.restype = c_int

# /usr/include/stdlib.h: 376
if _libs["libPyFd.so"].has("srand", "cdecl"):
    srand = _libs["libPyFd.so"].get("srand", "cdecl")
    srand.argtypes = [c_uint]
    srand.restype = None

# /usr/include/stdlib.h: 381
if _libs["libPyFd.so"].has("rand_r", "cdecl"):
    rand_r = _libs["libPyFd.so"].get("rand_r", "cdecl")
    rand_r.argtypes = [POINTER(c_uint)]
    rand_r.restype = c_int

# /usr/include/stdlib.h: 389
if _libs["libPyFd.so"].has("drand48", "cdecl"):
    drand48 = _libs["libPyFd.so"].get("drand48", "cdecl")
    drand48.argtypes = []
    drand48.restype = c_double

# /usr/include/stdlib.h: 390
if _libs["libPyFd.so"].has("erand48", "cdecl"):
    erand48 = _libs["libPyFd.so"].get("erand48", "cdecl")
    erand48.argtypes = [c_uint * int(3)]
    erand48.restype = c_double

# /usr/include/stdlib.h: 393
if _libs["libPyFd.so"].has("lrand48", "cdecl"):
    lrand48 = _libs["libPyFd.so"].get("lrand48", "cdecl")
    lrand48.argtypes = []
    lrand48.restype = c_long

# /usr/include/stdlib.h: 394
if _libs["libPyFd.so"].has("nrand48", "cdecl"):
    nrand48 = _libs["libPyFd.so"].get("nrand48", "cdecl")
    nrand48.argtypes = [c_uint * int(3)]
    nrand48.restype = c_long

# /usr/include/stdlib.h: 398
if _libs["libPyFd.so"].has("mrand48", "cdecl"):
    mrand48 = _libs["libPyFd.so"].get("mrand48", "cdecl")
    mrand48.argtypes = []
    mrand48.restype = c_long

# /usr/include/stdlib.h: 399
if _libs["libPyFd.so"].has("jrand48", "cdecl"):
    jrand48 = _libs["libPyFd.so"].get("jrand48", "cdecl")
    jrand48.argtypes = [c_uint * int(3)]
    jrand48.restype = c_long

# /usr/include/stdlib.h: 403
if _libs["libPyFd.so"].has("srand48", "cdecl"):
    srand48 = _libs["libPyFd.so"].get("srand48", "cdecl")
    srand48.argtypes = [c_long]
    srand48.restype = None

# /usr/include/stdlib.h: 404
if _libs["libPyFd.so"].has("seed48", "cdecl"):
    seed48 = _libs["libPyFd.so"].get("seed48", "cdecl")
    seed48.argtypes = [c_uint * int(3)]
    seed48.restype = POINTER(c_uint)

# /usr/include/stdlib.h: 406
if _libs["libPyFd.so"].has("lcong48", "cdecl"):
    lcong48 = _libs["libPyFd.so"].get("lcong48", "cdecl")
    lcong48.argtypes = [c_uint * int(7)]
    lcong48.restype = None

# /usr/include/stdlib.h: 412
class struct_drand48_data(Structure):
    pass

struct_drand48_data.__slots__ = [
    '__x',
    '__old_x',
    '__c',
    '__init',
    '__a',
]
struct_drand48_data._fields_ = [
    ('__x', c_uint * int(3)),
    ('__old_x', c_uint * int(3)),
    ('__c', c_uint),
    ('__init', c_uint),
    ('__a', c_ulonglong),
]

# /usr/include/stdlib.h: 422
if _libs["libPyFd.so"].has("drand48_r", "cdecl"):
    drand48_r = _libs["libPyFd.so"].get("drand48_r", "cdecl")
    drand48_r.argtypes = [POINTER(struct_drand48_data), POINTER(c_double)]
    drand48_r.restype = c_int

# /usr/include/stdlib.h: 424
if _libs["libPyFd.so"].has("erand48_r", "cdecl"):
    erand48_r = _libs["libPyFd.so"].get("erand48_r", "cdecl")
    erand48_r.argtypes = [c_uint * int(3), POINTER(struct_drand48_data), POINTER(c_double)]
    erand48_r.restype = c_int

# /usr/include/stdlib.h: 429
if _libs["libPyFd.so"].has("lrand48_r", "cdecl"):
    lrand48_r = _libs["libPyFd.so"].get("lrand48_r", "cdecl")
    lrand48_r.argtypes = [POINTER(struct_drand48_data), POINTER(c_long)]
    lrand48_r.restype = c_int

# /usr/include/stdlib.h: 432
if _libs["libPyFd.so"].has("nrand48_r", "cdecl"):
    nrand48_r = _libs["libPyFd.so"].get("nrand48_r", "cdecl")
    nrand48_r.argtypes = [c_uint * int(3), POINTER(struct_drand48_data), POINTER(c_long)]
    nrand48_r.restype = c_int

# /usr/include/stdlib.h: 438
if _libs["libPyFd.so"].has("mrand48_r", "cdecl"):
    mrand48_r = _libs["libPyFd.so"].get("mrand48_r", "cdecl")
    mrand48_r.argtypes = [POINTER(struct_drand48_data), POINTER(c_long)]
    mrand48_r.restype = c_int

# /usr/include/stdlib.h: 441
if _libs["libPyFd.so"].has("jrand48_r", "cdecl"):
    jrand48_r = _libs["libPyFd.so"].get("jrand48_r", "cdecl")
    jrand48_r.argtypes = [c_uint * int(3), POINTER(struct_drand48_data), POINTER(c_long)]
    jrand48_r.restype = c_int

# /usr/include/stdlib.h: 447
if _libs["libPyFd.so"].has("srand48_r", "cdecl"):
    srand48_r = _libs["libPyFd.so"].get("srand48_r", "cdecl")
    srand48_r.argtypes = [c_long, POINTER(struct_drand48_data)]
    srand48_r.restype = c_int

# /usr/include/stdlib.h: 450
if _libs["libPyFd.so"].has("seed48_r", "cdecl"):
    seed48_r = _libs["libPyFd.so"].get("seed48_r", "cdecl")
    seed48_r.argtypes = [c_uint * int(3), POINTER(struct_drand48_data)]
    seed48_r.restype = c_int

# /usr/include/stdlib.h: 453
if _libs["libPyFd.so"].has("lcong48_r", "cdecl"):
    lcong48_r = _libs["libPyFd.so"].get("lcong48_r", "cdecl")
    lcong48_r.argtypes = [c_uint * int(7), POINTER(struct_drand48_data)]
    lcong48_r.restype = c_int

# /usr/include/stdlib.h: 465
if _libs["libPyFd.so"].has("malloc", "cdecl"):
    malloc = _libs["libPyFd.so"].get("malloc", "cdecl")
    malloc.argtypes = [c_size_t]
    malloc.restype = POINTER(c_ubyte)
    malloc.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/stdlib.h: 467
if _libs["libPyFd.so"].has("calloc", "cdecl"):
    calloc = _libs["libPyFd.so"].get("calloc", "cdecl")
    calloc.argtypes = [c_size_t, c_size_t]
    calloc.restype = POINTER(c_ubyte)
    calloc.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/stdlib.h: 479
if _libs["libPyFd.so"].has("realloc", "cdecl"):
    realloc = _libs["libPyFd.so"].get("realloc", "cdecl")
    realloc.argtypes = [POINTER(None), c_size_t]
    realloc.restype = POINTER(c_ubyte)
    realloc.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/stdlib.h: 482
if _libs["libPyFd.so"].has("free", "cdecl"):
    free = _libs["libPyFd.so"].get("free", "cdecl")
    free.argtypes = [POINTER(None)]
    free.restype = None

# /usr/include/stdlib.h: 487
if _libs["libPyFd.so"].has("cfree", "cdecl"):
    cfree = _libs["libPyFd.so"].get("cfree", "cdecl")
    cfree.argtypes = [POINTER(None)]
    cfree.restype = None

# /usr/include/stdlib.h: 497
if _libs["libPyFd.so"].has("valloc", "cdecl"):
    valloc = _libs["libPyFd.so"].get("valloc", "cdecl")
    valloc.argtypes = [c_size_t]
    valloc.restype = POINTER(c_ubyte)
    valloc.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/stdlib.h: 502
if _libs["libPyFd.so"].has("posix_memalign", "cdecl"):
    posix_memalign = _libs["libPyFd.so"].get("posix_memalign", "cdecl")
    posix_memalign.argtypes = [POINTER(POINTER(None)), c_size_t, c_size_t]
    posix_memalign.restype = c_int

# /usr/include/stdlib.h: 514
if _libs["libPyFd.so"].has("abort", "cdecl"):
    abort = _libs["libPyFd.so"].get("abort", "cdecl")
    abort.argtypes = []
    abort.restype = None

# /usr/include/stdlib.h: 518
for _lib in _libs.values():
    if not _lib.has("atexit", "cdecl"):
        continue
    atexit = _lib.get("atexit", "cdecl")
    atexit.argtypes = [CFUNCTYPE(UNCHECKED(None), )]
    atexit.restype = c_int
    break

# /usr/include/stdlib.h: 534
if _libs["libPyFd.so"].has("on_exit", "cdecl"):
    on_exit = _libs["libPyFd.so"].get("on_exit", "cdecl")
    on_exit.argtypes = [CFUNCTYPE(UNCHECKED(None), c_int, POINTER(None)), POINTER(None)]
    on_exit.restype = c_int

# /usr/include/stdlib.h: 542
if _libs["libPyFd.so"].has("exit", "cdecl"):
    exit = _libs["libPyFd.so"].get("exit", "cdecl")
    exit.argtypes = [c_int]
    exit.restype = None

# /usr/include/stdlib.h: 556
if _libs["libPyFd.so"].has("_Exit", "cdecl"):
    _Exit = _libs["libPyFd.so"].get("_Exit", "cdecl")
    _Exit.argtypes = [c_int]
    _Exit.restype = None

# /usr/include/stdlib.h: 563
if _libs["libPyFd.so"].has("getenv", "cdecl"):
    getenv = _libs["libPyFd.so"].get("getenv", "cdecl")
    getenv.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        getenv.restype = ReturnString
    else:
        getenv.restype = String
        getenv.errcheck = ReturnString

# /usr/include/stdlib.h: 577
if _libs["libPyFd.so"].has("putenv", "cdecl"):
    putenv = _libs["libPyFd.so"].get("putenv", "cdecl")
    putenv.argtypes = [String]
    putenv.restype = c_int

# /usr/include/stdlib.h: 583
if _libs["libPyFd.so"].has("setenv", "cdecl"):
    setenv = _libs["libPyFd.so"].get("setenv", "cdecl")
    setenv.argtypes = [String, String, c_int]
    setenv.restype = c_int

# /usr/include/stdlib.h: 587
if _libs["libPyFd.so"].has("unsetenv", "cdecl"):
    unsetenv = _libs["libPyFd.so"].get("unsetenv", "cdecl")
    unsetenv.argtypes = [String]
    unsetenv.restype = c_int

# /usr/include/stdlib.h: 594
if _libs["libPyFd.so"].has("clearenv", "cdecl"):
    clearenv = _libs["libPyFd.so"].get("clearenv", "cdecl")
    clearenv.argtypes = []
    clearenv.restype = c_int

# /usr/include/stdlib.h: 605
if _libs["libPyFd.so"].has("mktemp", "cdecl"):
    mktemp = _libs["libPyFd.so"].get("mktemp", "cdecl")
    mktemp.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        mktemp.restype = ReturnString
    else:
        mktemp.restype = String
        mktemp.errcheck = ReturnString

# /usr/include/stdlib.h: 619
if _libs["libPyFd.so"].has("mkstemp", "cdecl"):
    mkstemp = _libs["libPyFd.so"].get("mkstemp", "cdecl")
    mkstemp.argtypes = [String]
    mkstemp.restype = c_int

# /usr/include/stdlib.h: 641
if _libs["libPyFd.so"].has("mkstemps", "cdecl"):
    mkstemps = _libs["libPyFd.so"].get("mkstemps", "cdecl")
    mkstemps.argtypes = [String, c_int]
    mkstemps.restype = c_int

# /usr/include/stdlib.h: 662
if _libs["libPyFd.so"].has("mkdtemp", "cdecl"):
    mkdtemp = _libs["libPyFd.so"].get("mkdtemp", "cdecl")
    mkdtemp.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        mkdtemp.restype = ReturnString
    else:
        mkdtemp.restype = String
        mkdtemp.errcheck = ReturnString

# /usr/include/stdlib.h: 716
if _libs["libPyFd.so"].has("system", "cdecl"):
    system = _libs["libPyFd.so"].get("system", "cdecl")
    system.argtypes = [String]
    system.restype = c_int

# /usr/include/stdlib.h: 733
if _libs["libPyFd.so"].has("realpath", "cdecl"):
    realpath = _libs["libPyFd.so"].get("realpath", "cdecl")
    realpath.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        realpath.restype = ReturnString
    else:
        realpath.restype = String
        realpath.errcheck = ReturnString

__compar_fn_t = CFUNCTYPE(UNCHECKED(c_int), POINTER(None), POINTER(None))# /usr/include/stdlib.h: 741

# /usr/include/stdlib.h: 754
if _libs["libPyFd.so"].has("bsearch", "cdecl"):
    bsearch = _libs["libPyFd.so"].get("bsearch", "cdecl")
    bsearch.argtypes = [POINTER(None), POINTER(None), c_size_t, c_size_t, __compar_fn_t]
    bsearch.restype = POINTER(c_ubyte)
    bsearch.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/stdlib.h: 760
if _libs["libPyFd.so"].has("qsort", "cdecl"):
    qsort = _libs["libPyFd.so"].get("qsort", "cdecl")
    qsort.argtypes = [POINTER(None), c_size_t, c_size_t, __compar_fn_t]
    qsort.restype = None

# /usr/include/stdlib.h: 770
if _libs["libPyFd.so"].has("abs", "cdecl"):
    abs = _libs["libPyFd.so"].get("abs", "cdecl")
    abs.argtypes = [c_int]
    abs.restype = c_int

# /usr/include/stdlib.h: 771
if _libs["libPyFd.so"].has("labs", "cdecl"):
    labs = _libs["libPyFd.so"].get("labs", "cdecl")
    labs.argtypes = [c_long]
    labs.restype = c_long

# /usr/include/stdlib.h: 775
if _libs["libPyFd.so"].has("llabs", "cdecl"):
    llabs = _libs["libPyFd.so"].get("llabs", "cdecl")
    llabs.argtypes = [c_longlong]
    llabs.restype = c_longlong

# /usr/include/stdlib.h: 784
if _libs["libPyFd.so"].has("div", "cdecl"):
    div = _libs["libPyFd.so"].get("div", "cdecl")
    div.argtypes = [c_int, c_int]
    div.restype = div_t

# /usr/include/stdlib.h: 786
if _libs["libPyFd.so"].has("ldiv", "cdecl"):
    ldiv = _libs["libPyFd.so"].get("ldiv", "cdecl")
    ldiv.argtypes = [c_long, c_long]
    ldiv.restype = ldiv_t

# /usr/include/stdlib.h: 792
if _libs["libPyFd.so"].has("lldiv", "cdecl"):
    lldiv = _libs["libPyFd.so"].get("lldiv", "cdecl")
    lldiv.argtypes = [c_longlong, c_longlong]
    lldiv.restype = lldiv_t

# /usr/include/stdlib.h: 807
if _libs["libPyFd.so"].has("ecvt", "cdecl"):
    ecvt = _libs["libPyFd.so"].get("ecvt", "cdecl")
    ecvt.argtypes = [c_double, c_int, POINTER(c_int), POINTER(c_int)]
    if sizeof(c_int) == sizeof(c_void_p):
        ecvt.restype = ReturnString
    else:
        ecvt.restype = String
        ecvt.errcheck = ReturnString

# /usr/include/stdlib.h: 813
if _libs["libPyFd.so"].has("fcvt", "cdecl"):
    fcvt = _libs["libPyFd.so"].get("fcvt", "cdecl")
    fcvt.argtypes = [c_double, c_int, POINTER(c_int), POINTER(c_int)]
    if sizeof(c_int) == sizeof(c_void_p):
        fcvt.restype = ReturnString
    else:
        fcvt.restype = String
        fcvt.errcheck = ReturnString

# /usr/include/stdlib.h: 819
if _libs["libPyFd.so"].has("gcvt", "cdecl"):
    gcvt = _libs["libPyFd.so"].get("gcvt", "cdecl")
    gcvt.argtypes = [c_double, c_int, String]
    if sizeof(c_int) == sizeof(c_void_p):
        gcvt.restype = ReturnString
    else:
        gcvt.restype = String
        gcvt.errcheck = ReturnString

# /usr/include/stdlib.h: 825
if _libs["libPyFd.so"].has("qecvt", "cdecl"):
    qecvt = _libs["libPyFd.so"].get("qecvt", "cdecl")
    qecvt.argtypes = [c_longdouble, c_int, POINTER(c_int), POINTER(c_int)]
    if sizeof(c_int) == sizeof(c_void_p):
        qecvt.restype = ReturnString
    else:
        qecvt.restype = String
        qecvt.errcheck = ReturnString

# /usr/include/stdlib.h: 828
if _libs["libPyFd.so"].has("qfcvt", "cdecl"):
    qfcvt = _libs["libPyFd.so"].get("qfcvt", "cdecl")
    qfcvt.argtypes = [c_longdouble, c_int, POINTER(c_int), POINTER(c_int)]
    if sizeof(c_int) == sizeof(c_void_p):
        qfcvt.restype = ReturnString
    else:
        qfcvt.restype = String
        qfcvt.errcheck = ReturnString

# /usr/include/stdlib.h: 831
if _libs["libPyFd.so"].has("qgcvt", "cdecl"):
    qgcvt = _libs["libPyFd.so"].get("qgcvt", "cdecl")
    qgcvt.argtypes = [c_longdouble, c_int, String]
    if sizeof(c_int) == sizeof(c_void_p):
        qgcvt.restype = ReturnString
    else:
        qgcvt.restype = String
        qgcvt.errcheck = ReturnString

# /usr/include/stdlib.h: 837
if _libs["libPyFd.so"].has("ecvt_r", "cdecl"):
    ecvt_r = _libs["libPyFd.so"].get("ecvt_r", "cdecl")
    ecvt_r.argtypes = [c_double, c_int, POINTER(c_int), POINTER(c_int), String, c_size_t]
    ecvt_r.restype = c_int

# /usr/include/stdlib.h: 840
if _libs["libPyFd.so"].has("fcvt_r", "cdecl"):
    fcvt_r = _libs["libPyFd.so"].get("fcvt_r", "cdecl")
    fcvt_r.argtypes = [c_double, c_int, POINTER(c_int), POINTER(c_int), String, c_size_t]
    fcvt_r.restype = c_int

# /usr/include/stdlib.h: 844
if _libs["libPyFd.so"].has("qecvt_r", "cdecl"):
    qecvt_r = _libs["libPyFd.so"].get("qecvt_r", "cdecl")
    qecvt_r.argtypes = [c_longdouble, c_int, POINTER(c_int), POINTER(c_int), String, c_size_t]
    qecvt_r.restype = c_int

# /usr/include/stdlib.h: 848
if _libs["libPyFd.so"].has("qfcvt_r", "cdecl"):
    qfcvt_r = _libs["libPyFd.so"].get("qfcvt_r", "cdecl")
    qfcvt_r.argtypes = [c_longdouble, c_int, POINTER(c_int), POINTER(c_int), String, c_size_t]
    qfcvt_r.restype = c_int

# /usr/include/stdlib.h: 859
if _libs["libPyFd.so"].has("mblen", "cdecl"):
    mblen = _libs["libPyFd.so"].get("mblen", "cdecl")
    mblen.argtypes = [String, c_size_t]
    mblen.restype = c_int

# /usr/include/stdlib.h: 862
if _libs["libPyFd.so"].has("mbtowc", "cdecl"):
    mbtowc = _libs["libPyFd.so"].get("mbtowc", "cdecl")
    mbtowc.argtypes = [POINTER(c_wchar), String, c_size_t]
    mbtowc.restype = c_int

# /usr/include/stdlib.h: 866
if _libs["libPyFd.so"].has("wctomb", "cdecl"):
    wctomb = _libs["libPyFd.so"].get("wctomb", "cdecl")
    wctomb.argtypes = [String, c_wchar]
    wctomb.restype = c_int

# /usr/include/stdlib.h: 870
if _libs["libPyFd.so"].has("mbstowcs", "cdecl"):
    mbstowcs = _libs["libPyFd.so"].get("mbstowcs", "cdecl")
    mbstowcs.argtypes = [POINTER(c_wchar), String, c_size_t]
    mbstowcs.restype = c_size_t

# /usr/include/stdlib.h: 873
if _libs["libPyFd.so"].has("wcstombs", "cdecl"):
    wcstombs = _libs["libPyFd.so"].get("wcstombs", "cdecl")
    wcstombs.argtypes = [String, POINTER(c_wchar), c_size_t]
    wcstombs.restype = c_size_t

# /usr/include/stdlib.h: 884
if _libs["libPyFd.so"].has("rpmatch", "cdecl"):
    rpmatch = _libs["libPyFd.so"].get("rpmatch", "cdecl")
    rpmatch.argtypes = [String]
    rpmatch.restype = c_int

# /usr/include/stdlib.h: 895
if _libs["libPyFd.so"].has("getsubopt", "cdecl"):
    getsubopt = _libs["libPyFd.so"].get("getsubopt", "cdecl")
    getsubopt.argtypes = [POINTER(POINTER(c_char)), POINTER(POINTER(c_char)), POINTER(POINTER(c_char))]
    getsubopt.restype = c_int

# /usr/include/stdlib.h: 947
if _libs["libPyFd.so"].has("getloadavg", "cdecl"):
    getloadavg = _libs["libPyFd.so"].get("getloadavg", "cdecl")
    getloadavg.argtypes = [POINTER(c_double), c_int]
    getloadavg.restype = c_int

FRLONG = c_long# /virgoApp/Fr/v8r40p5/src/FrIO.h: 19

FRULONG = c_ulong# /virgoApp/Fr/v8r40p5/src/FrIO.h: 20

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 30
class struct_FrIO(Structure):
    pass

struct_FrIO.__slots__ = [
    'fd',
    'buffer',
    'nBytesRead',
    'position',
]
struct_FrIO._fields_ = [
    ('fd', c_int),
    ('buffer', c_char * int(16384)),
    ('nBytesRead', c_int),
    ('position', c_int),
]

FrIO = struct_FrIO# /virgoApp/Fr/v8r40p5/src/FrIO.h: 42

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 44
if _libs["libPyFd.so"].has("FrIOOpenR", "cdecl"):
    FrIOOpenR = _libs["libPyFd.so"].get("FrIOOpenR", "cdecl")
    FrIOOpenR.argtypes = [String]
    FrIOOpenR.restype = POINTER(FrIO)

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 45
if _libs["libPyFd.so"].has("FrIOOpenW", "cdecl"):
    FrIOOpenW = _libs["libPyFd.so"].get("FrIOOpenW", "cdecl")
    FrIOOpenW.argtypes = [String]
    FrIOOpenW.restype = POINTER(FrIO)

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 46
if _libs["libPyFd.so"].has("FrIOClose", "cdecl"):
    FrIOClose = _libs["libPyFd.so"].get("FrIOClose", "cdecl")
    FrIOClose.argtypes = [POINTER(FrIO)]
    FrIOClose.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 47
if _libs["libPyFd.so"].has("FrIOWrite", "cdecl"):
    FrIOWrite = _libs["libPyFd.so"].get("FrIOWrite", "cdecl")
    FrIOWrite.argtypes = [POINTER(FrIO), String, FRLONG]
    FrIOWrite.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 48
if _libs["libPyFd.so"].has("FrIORead", "cdecl"):
    FrIORead = _libs["libPyFd.so"].get("FrIORead", "cdecl")
    FrIORead.argtypes = [POINTER(FrIO), String, FRLONG]
    FrIORead.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 49
if _libs["libPyFd.so"].has("FrIOSet", "cdecl"):
    FrIOSet = _libs["libPyFd.so"].get("FrIOSet", "cdecl")
    FrIOSet.argtypes = [POINTER(FrIO), FRLONG]
    FrIOSet.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 50
if _libs["libPyFd.so"].has("FrIOSetFromEnd", "cdecl"):
    FrIOSetFromEnd = _libs["libPyFd.so"].get("FrIOSetFromEnd", "cdecl")
    FrIOSetFromEnd.argtypes = [POINTER(FrIO), FRLONG]
    FrIOSetFromEnd.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 51
if _libs["libPyFd.so"].has("FrIOSetFromCur", "cdecl"):
    FrIOSetFromCur = _libs["libPyFd.so"].get("FrIOSetFromCur", "cdecl")
    FrIOSetFromCur.argtypes = [POINTER(FrIO), FRLONG]
    FrIOSetFromCur.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 52
if _libs["libPyFd.so"].has("FrIOTell", "cdecl"):
    FrIOTell = _libs["libPyFd.so"].get("FrIOTell", "cdecl")
    FrIOTell.argtypes = [POINTER(struct_FrIO)]
    FrIOTell.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 53
if _libs["libPyFd.so"].has("FrIOmkdir", "cdecl"):
    FrIOmkdir = _libs["libPyFd.so"].get("FrIOmkdir", "cdecl")
    FrIOmkdir.argtypes = [String]
    FrIOmkdir.restype = c_int

enum_anon_50 = c_int# /virgoApp/Fr/v8r40p5/src/FrameL.h: 38

FR_NO = 0# /virgoApp/Fr/v8r40p5/src/FrameL.h: 38

FR_YES = (FR_NO + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 38

FRBOOL = enum_anon_50# /virgoApp/Fr/v8r40p5/src/FrameL.h: 38

enum_anon_51 = c_int# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FRNATIVE = 0# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FRSWAP = (FRNATIVE + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FRCONTRACT = (FRSWAP + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FREXPAND = (FRCONTRACT + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FRCONTRACT_AND_SWAP = (FREXPAND + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FREXPAND_AND_SWAP = (FRCONTRACT_AND_SWAP + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

FRFORMAT = enum_anon_51# /virgoApp/Fr/v8r40p5/src/FrameL.h: 45

enum_anon_52 = c_int# /virgoApp/Fr/v8r40p5/src/FrameL.h: 49

FRTSADC = 0# /virgoApp/Fr/v8r40p5/src/FrameL.h: 49

FRTSSIM = (FRTSADC + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 49

FRTSPROC = (FRTSSIM + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 49

FRTSTYPE = enum_anon_52# /virgoApp/Fr/v8r40p5/src/FrameL.h: 49

enum_anon_53 = c_int# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_OK = 0# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_NO_FRAME = (FR_OK + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_NO_FILE = (FR_ERROR_NO_FRAME + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_MALLOC_FAILED = (FR_ERROR_NO_FILE + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_BUFF_OVERFLOW = (FR_ERROR_MALLOC_FAILED + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_WRITE_ERROR = (FR_ERROR_BUFF_OVERFLOW + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_READ_ERROR = (FR_ERROR_WRITE_ERROR + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_FRSET = (FR_ERROR_READ_ERROR + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_WRONG_CHAR_LENGTH = (FR_ERROR_FRSET + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_BAD_END_OF_FRAME = (FR_ERROR_WRONG_CHAR_LENGTH + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_OPEN_ERROR = (FR_ERROR_BAD_END_OF_FRAME + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_CHECKSUM = (FR_ERROR_OPEN_ERROR + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_BAD_NEVENT = (FR_ERROR_CHECKSUM + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_BAD_NSTAT = (FR_ERROR_BAD_NEVENT + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_TOO_LONG_STRING = (FR_ERROR_BAD_NSTAT + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FR_ERROR_WRONG_NBYTES = (FR_ERROR_TOO_LONG_STRING + 1)# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

FRERROR = enum_anon_53# /virgoApp/Fr/v8r40p5/src/FrameL.h: 66

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 151
class struct_FrameH(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 287
class struct_FrAdcData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 390
class struct_FrBasic(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 352
class struct_FrDetector(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 400
class struct_FrEndOfFrame(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 412
class struct_FrEndOfFile(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 426
class struct_FrEvent(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 714
class struct_FrMsg(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 505
class struct_FrFile(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 675
class struct_FrFileH(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 690
class struct_FrHistory(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 739
class struct_FrObject(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 795
class struct_FrRawData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 746
class struct_FrProcData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 819
class struct_FrSE(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 885
class struct_FrSH(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 905
class struct_FrSimData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 832
class struct_FrSegList(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 857
class struct_FrSerData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 988
class struct_FrStatData(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1031
class struct_FrSummary(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 934
class struct_FrSimEvent(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1055
class struct_FrTable(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1077
class struct_FrTag(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1091
class struct_FrTOC(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1152
class struct_FrTOCdet(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1163
class struct_FrTOCevt(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1185
class struct_FrTOCstat(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1198
class struct_FrTOCts(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1213
class struct_FrTOCtsH(Structure):
    pass

# /virgoApp/Fr/v8r40p5/src/FrVect.h: 41
class struct_FrVect(Structure):
    pass

FrAdcData = struct_FrAdcData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 117

FrameH = struct_FrameH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 118

FrBasic = struct_FrBasic# /virgoApp/Fr/v8r40p5/src/FrameL.h: 119

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 336
class struct_FrCList(Structure):
    pass

FrCList = struct_FrCList# /virgoApp/Fr/v8r40p5/src/FrameL.h: 120

FrDetector = struct_FrDetector# /virgoApp/Fr/v8r40p5/src/FrameL.h: 121

FrEndOfFrame = struct_FrEndOfFrame# /virgoApp/Fr/v8r40p5/src/FrameL.h: 122

FrEndOfFile = struct_FrEndOfFile# /virgoApp/Fr/v8r40p5/src/FrameL.h: 123

FrEvent = struct_FrEvent# /virgoApp/Fr/v8r40p5/src/FrameL.h: 124

FrMsg = struct_FrMsg# /virgoApp/Fr/v8r40p5/src/FrameL.h: 125

FrFile = struct_FrFile# /virgoApp/Fr/v8r40p5/src/FrameL.h: 126

FrFileH = struct_FrFileH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 127

FrHistory = struct_FrHistory# /virgoApp/Fr/v8r40p5/src/FrameL.h: 128

FrProcData = struct_FrProcData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 129

FrRawData = struct_FrRawData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 130

FrSegList = struct_FrSegList# /virgoApp/Fr/v8r40p5/src/FrameL.h: 131

FrSerData = struct_FrSerData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 132

FrSE = struct_FrSE# /virgoApp/Fr/v8r40p5/src/FrameL.h: 133

FrSH = struct_FrSH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 134

FrSimData = struct_FrSimData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 135

FrSimEvent = struct_FrSimEvent# /virgoApp/Fr/v8r40p5/src/FrameL.h: 136

FrStatData = struct_FrStatData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 137

FrSummary = struct_FrSummary# /virgoApp/Fr/v8r40p5/src/FrameL.h: 138

FrTable = struct_FrTable# /virgoApp/Fr/v8r40p5/src/FrameL.h: 139

FrTag = struct_FrTag# /virgoApp/Fr/v8r40p5/src/FrameL.h: 140

FrTOC = struct_FrTOC# /virgoApp/Fr/v8r40p5/src/FrameL.h: 141

FrTOCdet = struct_FrTOCdet# /virgoApp/Fr/v8r40p5/src/FrameL.h: 142

FrTOCevt = struct_FrTOCevt# /virgoApp/Fr/v8r40p5/src/FrameL.h: 143

FrTOCstat = struct_FrTOCstat# /virgoApp/Fr/v8r40p5/src/FrameL.h: 144

FrTOCts = struct_FrTOCts# /virgoApp/Fr/v8r40p5/src/FrameL.h: 145

FrTOCtsH = struct_FrTOCtsH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 146

FrVect = struct_FrVect# /virgoApp/Fr/v8r40p5/src/FrameL.h: 147

struct_FrameH.__slots__ = [
    'classe',
    'name',
    'run',
    'frame',
    'dataQuality',
    'GTimeS',
    'GTimeN',
    'ULeapS',
    'dt',
    'type',
    'user',
    'detectSim',
    'detectProc',
    'history',
    'rawData',
    'procData',
    'simData',
    'event',
    'simEvent',
    'summaryData',
    'auxData',
    'auxTable',
    'procDataOld',
    'simDataOld',
    'eventOld',
    'simEventOld',
    'summaryDataOld',
]
struct_FrameH._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('run', c_int),
    ('frame', c_uint),
    ('dataQuality', c_uint),
    ('GTimeS', c_uint),
    ('GTimeN', c_uint),
    ('ULeapS', c_ushort),
    ('dt', c_double),
    ('type', POINTER(FrVect)),
    ('user', POINTER(FrVect)),
    ('detectSim', POINTER(FrDetector)),
    ('detectProc', POINTER(FrDetector)),
    ('history', POINTER(FrHistory)),
    ('rawData', POINTER(FrRawData)),
    ('procData', POINTER(FrProcData)),
    ('simData', POINTER(FrSimData)),
    ('event', POINTER(FrEvent)),
    ('simEvent', POINTER(FrSimEvent)),
    ('summaryData', POINTER(FrSummary)),
    ('auxData', POINTER(FrVect)),
    ('auxTable', POINTER(FrTable)),
    ('procDataOld', POINTER(FrProcData)),
    ('simDataOld', POINTER(FrSimData)),
    ('eventOld', POINTER(FrEvent)),
    ('simEventOld', POINTER(FrSimEvent)),
    ('summaryDataOld', POINTER(FrSummary)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 184
if _libs["libPyFd.so"].has("FrameAddAdc", "cdecl"):
    FrameAddAdc = _libs["libPyFd.so"].get("FrameAddAdc", "cdecl")
    FrameAddAdc.argtypes = [POINTER(FrameH), POINTER(FrAdcData)]
    FrameAddAdc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 185
if _libs["libPyFd.so"].has("FrameAddEvent", "cdecl"):
    FrameAddEvent = _libs["libPyFd.so"].get("FrameAddEvent", "cdecl")
    FrameAddEvent.argtypes = [POINTER(FrameH), POINTER(FrEvent)]
    FrameAddEvent.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 186
if _libs["libPyFd.so"].has("FrameAddEventFast", "cdecl"):
    FrameAddEventFast = _libs["libPyFd.so"].get("FrameAddEventFast", "cdecl")
    FrameAddEventFast.argtypes = [POINTER(FrameH), POINTER(FrEvent)]
    FrameAddEventFast.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 187
if _libs["libPyFd.so"].has("FrameAddProc", "cdecl"):
    FrameAddProc = _libs["libPyFd.so"].get("FrameAddProc", "cdecl")
    FrameAddProc.argtypes = [POINTER(FrameH), POINTER(FrProcData)]
    FrameAddProc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 188
if _libs["libPyFd.so"].has("FrameAddSer", "cdecl"):
    FrameAddSer = _libs["libPyFd.so"].get("FrameAddSer", "cdecl")
    FrameAddSer.argtypes = [POINTER(FrameH), POINTER(FrSerData)]
    FrameAddSer.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 189
if _libs["libPyFd.so"].has("FrameAddSimData", "cdecl"):
    FrameAddSimData = _libs["libPyFd.so"].get("FrameAddSimData", "cdecl")
    FrameAddSimData.argtypes = [POINTER(FrameH), POINTER(FrSimData)]
    FrameAddSimData.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 190
if _libs["libPyFd.so"].has("FrameAddSimEvent", "cdecl"):
    FrameAddSimEvent = _libs["libPyFd.so"].get("FrameAddSimEvent", "cdecl")
    FrameAddSimEvent.argtypes = [POINTER(FrameH), POINTER(FrSimEvent)]
    FrameAddSimEvent.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 191
if _libs["libPyFd.so"].has("FrameAddStatData", "cdecl"):
    FrameAddStatData = _libs["libPyFd.so"].get("FrameAddStatData", "cdecl")
    FrameAddStatData.argtypes = [POINTER(FrameH), String, POINTER(FrStatData)]
    FrameAddStatData.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 192
if _libs["libPyFd.so"].has("FrameAddStatVector", "cdecl"):
    FrameAddStatVector = _libs["libPyFd.so"].get("FrameAddStatVector", "cdecl")
    FrameAddStatVector.argtypes = [POINTER(FrameH), String, String, c_uint, c_uint, c_uint, POINTER(FrVect)]
    FrameAddStatVector.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 194
if _libs["libPyFd.so"].has("FrameAddSum", "cdecl"):
    FrameAddSum = _libs["libPyFd.so"].get("FrameAddSum", "cdecl")
    FrameAddSum.argtypes = [POINTER(FrameH), POINTER(FrSummary)]
    FrameAddSum.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 195
if _libs["libPyFd.so"].has("FrameBufCheck", "cdecl"):
    FrameBufCheck = _libs["libPyFd.so"].get("FrameBufCheck", "cdecl")
    FrameBufCheck.argtypes = [String, FRLONG, FRBOOL]
    FrameBufCheck.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 196
if _libs["libPyFd.so"].has("FrameCompress", "cdecl"):
    FrameCompress = _libs["libPyFd.so"].get("FrameCompress", "cdecl")
    FrameCompress.argtypes = [POINTER(FrameH), c_int, c_int]
    FrameCompress.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 197
if _libs["libPyFd.so"].has("FrameCompDump", "cdecl"):
    FrameCompDump = _libs["libPyFd.so"].get("FrameCompDump", "cdecl")
    FrameCompDump.argtypes = [POINTER(FrameH), POINTER(FILE), c_int]
    FrameCompDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 198
if _libs["libPyFd.so"].has("FrameCopy", "cdecl"):
    FrameCopy = _libs["libPyFd.so"].get("FrameCopy", "cdecl")
    FrameCopy.argtypes = [POINTER(FrameH)]
    FrameCopy.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 199
if _libs["libPyFd.so"].has("FrameCopyPart", "cdecl"):
    FrameCopyPart = _libs["libPyFd.so"].get("FrameCopyPart", "cdecl")
    FrameCopyPart.argtypes = [POINTER(FrameH), c_double, c_double]
    FrameCopyPart.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 200
if _libs["libPyFd.so"].has("FrameDump", "cdecl"):
    FrameDump = _libs["libPyFd.so"].get("FrameDump", "cdecl")
    FrameDump.argtypes = [POINTER(FrameH), POINTER(FILE), c_int]
    FrameDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 201
if _libs["libPyFd.so"].has("FrameDumpToBuf", "cdecl"):
    FrameDumpToBuf = _libs["libPyFd.so"].get("FrameDumpToBuf", "cdecl")
    FrameDumpToBuf.argtypes = [POINTER(FrameH), c_int, String, FRLONG]
    if sizeof(c_int) == sizeof(c_void_p):
        FrameDumpToBuf.restype = ReturnString
    else:
        FrameDumpToBuf.restype = String
        FrameDumpToBuf.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 202
if _libs["libPyFd.so"].has("FrameDumpTopADC", "cdecl"):
    FrameDumpTopADC = _libs["libPyFd.so"].get("FrameDumpTopADC", "cdecl")
    FrameDumpTopADC.argtypes = [POINTER(FrameH), POINTER(FILE), c_int, c_int]
    FrameDumpTopADC.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 203
if _libs["libPyFd.so"].has("FrameExpand", "cdecl"):
    FrameExpand = _libs["libPyFd.so"].get("FrameExpand", "cdecl")
    FrameExpand.argtypes = [POINTER(FrameH)]
    FrameExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 204
if _libs["libPyFd.so"].has("FrameFindBasic", "cdecl"):
    FrameFindBasic = _libs["libPyFd.so"].get("FrameFindBasic", "cdecl")
    FrameFindBasic.argtypes = [POINTER(FrBasic), String]
    FrameFindBasic.restype = POINTER(FrBasic)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 205
if _libs["libPyFd.so"].has("FrameFindDetector", "cdecl"):
    FrameFindDetector = _libs["libPyFd.so"].get("FrameFindDetector", "cdecl")
    FrameFindDetector.argtypes = [POINTER(FrameH), String]
    FrameFindDetector.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 206
if _libs["libPyFd.so"].has("FrameFindVect", "cdecl"):
    FrameFindVect = _libs["libPyFd.so"].get("FrameFindVect", "cdecl")
    FrameFindVect.argtypes = [POINTER(FrameH), String]
    FrameFindVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 207
if _libs["libPyFd.so"].has("FrameFindAdcVect", "cdecl"):
    FrameFindAdcVect = _libs["libPyFd.so"].get("FrameFindAdcVect", "cdecl")
    FrameFindAdcVect.argtypes = [POINTER(FrameH), String]
    FrameFindAdcVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 208
if _libs["libPyFd.so"].has("FrameFindProcVect", "cdecl"):
    FrameFindProcVect = _libs["libPyFd.so"].get("FrameFindProcVect", "cdecl")
    FrameFindProcVect.argtypes = [POINTER(FrameH), String]
    FrameFindProcVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 209
if _libs["libPyFd.so"].has("FrameFindSimVect", "cdecl"):
    FrameFindSimVect = _libs["libPyFd.so"].get("FrameFindSimVect", "cdecl")
    FrameFindSimVect.argtypes = [POINTER(FrameH), String]
    FrameFindSimVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 210
if _libs["libPyFd.so"].has("FrameFindStatVect", "cdecl"):
    FrameFindStatVect = _libs["libPyFd.so"].get("FrameFindStatVect", "cdecl")
    FrameFindStatVect.argtypes = [POINTER(FrameH), String]
    FrameFindStatVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 211
if _libs["libPyFd.so"].has("FrameFindSumVect", "cdecl"):
    FrameFindSumVect = _libs["libPyFd.so"].get("FrameFindSumVect", "cdecl")
    FrameFindSumVect.argtypes = [POINTER(FrameH), String]
    FrameFindSumVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 212
if _libs["libPyFd.so"].has("FrameFree", "cdecl"):
    FrameFree = _libs["libPyFd.so"].get("FrameFree", "cdecl")
    FrameFree.argtypes = [POINTER(FrameH)]
    FrameFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 213
if _libs["libPyFd.so"].has("FrameGetAdcSize", "cdecl"):
    FrameGetAdcSize = _libs["libPyFd.so"].get("FrameGetAdcSize", "cdecl")
    FrameGetAdcSize.argtypes = [POINTER(FrameH)]
    FrameGetAdcSize.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 214
if _libs["libPyFd.so"].has("FrameGetLTOffset", "cdecl"):
    FrameGetLTOffset = _libs["libPyFd.so"].get("FrameGetLTOffset", "cdecl")
    FrameGetLTOffset.argtypes = [POINTER(FrameH), String]
    FrameGetLTOffset.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 215
if _libs["libPyFd.so"].has("FrameFindStatData", "cdecl"):
    FrameFindStatData = _libs["libPyFd.so"].get("FrameFindStatData", "cdecl")
    FrameFindStatData.argtypes = [POINTER(FrameH), String, String, c_int]
    FrameFindStatData.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 217
if _libs["libPyFd.so"].has("FrameGetStatVect", "cdecl"):
    FrameGetStatVect = _libs["libPyFd.so"].get("FrameGetStatVect", "cdecl")
    FrameGetStatVect.argtypes = [POINTER(FrameH), String, String, String, c_int]
    FrameGetStatVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 219
if _libs["libPyFd.so"].has("FrameMerge", "cdecl"):
    FrameMerge = _libs["libPyFd.so"].get("FrameMerge", "cdecl")
    FrameMerge.argtypes = [POINTER(FrameH), POINTER(FrameH)]
    FrameMerge.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 220
if _libs["libPyFd.so"].has("FrameLatency", "cdecl"):
    FrameLatency = _libs["libPyFd.so"].get("FrameLatency", "cdecl")
    FrameLatency.argtypes = [POINTER(FrameH)]
    FrameLatency.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 221
if _libs["libPyFd.so"].has("FrameNew", "cdecl"):
    FrameNew = _libs["libPyFd.so"].get("FrameNew", "cdecl")
    FrameNew.argtypes = [String]
    FrameNew.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 222
if _libs["libPyFd.so"].has("FrameRead", "cdecl"):
    FrameRead = _libs["libPyFd.so"].get("FrameRead", "cdecl")
    FrameRead.argtypes = [POINTER(FrFile)]
    FrameRead.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 223
if _libs["libPyFd.so"].has("FrameReadN", "cdecl"):
    FrameReadN = _libs["libPyFd.so"].get("FrameReadN", "cdecl")
    FrameReadN.argtypes = [POINTER(FrFile), c_int, c_int]
    FrameReadN.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 224
if _libs["libPyFd.so"].has("FrameReadRecycle", "cdecl"):
    FrameReadRecycle = _libs["libPyFd.so"].get("FrameReadRecycle", "cdecl")
    FrameReadRecycle.argtypes = [POINTER(FrFile), POINTER(FrameH)]
    FrameReadRecycle.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 225
if _libs["libPyFd.so"].has("FrameReadT", "cdecl"):
    FrameReadT = _libs["libPyFd.so"].get("FrameReadT", "cdecl")
    FrameReadT.argtypes = [POINTER(FrFile), c_double]
    FrameReadT.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 226
if _libs["libPyFd.so"].has("FrameReadTAdc", "cdecl"):
    FrameReadTAdc = _libs["libPyFd.so"].get("FrameReadTAdc", "cdecl")
    FrameReadTAdc.argtypes = [POINTER(FrFile), c_double, String]
    FrameReadTAdc.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 227
if _libs["libPyFd.so"].has("FrameReadTChnl", "cdecl"):
    FrameReadTChnl = _libs["libPyFd.so"].get("FrameReadTChnl", "cdecl")
    FrameReadTChnl.argtypes = [POINTER(FrFile), c_double, String]
    FrameReadTChnl.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 228
if _libs["libPyFd.so"].has("FrameReadTProc", "cdecl"):
    FrameReadTProc = _libs["libPyFd.so"].get("FrameReadTProc", "cdecl")
    FrameReadTProc.argtypes = [POINTER(FrFile), c_double, String]
    FrameReadTProc.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 229
if _libs["libPyFd.so"].has("FrameReadTSer", "cdecl"):
    FrameReadTSer = _libs["libPyFd.so"].get("FrameReadTSer", "cdecl")
    FrameReadTSer.argtypes = [POINTER(FrFile), c_double, String]
    FrameReadTSer.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 230
if _libs["libPyFd.so"].has("FrameReadTSim", "cdecl"):
    FrameReadTSim = _libs["libPyFd.so"].get("FrameReadTSim", "cdecl")
    FrameReadTSim.argtypes = [POINTER(FrFile), c_double, String]
    FrameReadTSim.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 231
if _libs["libPyFd.so"].has("FrameReadFromBuf", "cdecl"):
    FrameReadFromBuf = _libs["libPyFd.so"].get("FrameReadFromBuf", "cdecl")
    FrameReadFromBuf.argtypes = [String, FRLONG, c_int]
    FrameReadFromBuf.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 232
if _libs["libPyFd.so"].has("FrameRemoveUntagged", "cdecl"):
    FrameRemoveUntagged = _libs["libPyFd.so"].get("FrameRemoveUntagged", "cdecl")
    FrameRemoveUntagged.argtypes = [POINTER(FrameH)]
    FrameRemoveUntagged.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 233
if _libs["libPyFd.so"].has("FrameRemoveUntaggedData", "cdecl"):
    FrameRemoveUntaggedData = _libs["libPyFd.so"].get("FrameRemoveUntaggedData", "cdecl")
    FrameRemoveUntaggedData.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedData.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 234
if _libs["libPyFd.so"].has("FrameRemoveUntaggedAdc", "cdecl"):
    FrameRemoveUntaggedAdc = _libs["libPyFd.so"].get("FrameRemoveUntaggedAdc", "cdecl")
    FrameRemoveUntaggedAdc.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedAdc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 235
if _libs["libPyFd.so"].has("FrameRemoveUntaggedEvent", "cdecl"):
    FrameRemoveUntaggedEvent = _libs["libPyFd.so"].get("FrameRemoveUntaggedEvent", "cdecl")
    FrameRemoveUntaggedEvent.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedEvent.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 236
if _libs["libPyFd.so"].has("FrameRemoveUntaggedMsg", "cdecl"):
    FrameRemoveUntaggedMsg = _libs["libPyFd.so"].get("FrameRemoveUntaggedMsg", "cdecl")
    FrameRemoveUntaggedMsg.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedMsg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 237
if _libs["libPyFd.so"].has("FrameRemoveUntaggedProc", "cdecl"):
    FrameRemoveUntaggedProc = _libs["libPyFd.so"].get("FrameRemoveUntaggedProc", "cdecl")
    FrameRemoveUntaggedProc.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedProc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 238
if _libs["libPyFd.so"].has("FrameRemoveUntaggedSer", "cdecl"):
    FrameRemoveUntaggedSer = _libs["libPyFd.so"].get("FrameRemoveUntaggedSer", "cdecl")
    FrameRemoveUntaggedSer.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedSer.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 239
if _libs["libPyFd.so"].has("FrameRemoveUntaggedSim", "cdecl"):
    FrameRemoveUntaggedSim = _libs["libPyFd.so"].get("FrameRemoveUntaggedSim", "cdecl")
    FrameRemoveUntaggedSim.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedSim.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 240
if _libs["libPyFd.so"].has("FrameRemoveUntaggedSimEvt", "cdecl"):
    FrameRemoveUntaggedSimEvt = _libs["libPyFd.so"].get("FrameRemoveUntaggedSimEvt", "cdecl")
    FrameRemoveUntaggedSimEvt.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedSimEvt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 241
if _libs["libPyFd.so"].has("FrameRemoveUntaggedStat", "cdecl"):
    FrameRemoveUntaggedStat = _libs["libPyFd.so"].get("FrameRemoveUntaggedStat", "cdecl")
    FrameRemoveUntaggedStat.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedStat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 242
if _libs["libPyFd.so"].has("FrameRemoveUntaggedSum", "cdecl"):
    FrameRemoveUntaggedSum = _libs["libPyFd.so"].get("FrameRemoveUntaggedSum", "cdecl")
    FrameRemoveUntaggedSum.argtypes = [POINTER(FrameH)]
    FrameRemoveUntaggedSum.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 243
if _libs["libPyFd.so"].has("FrameRemoveDuplicatedADC", "cdecl"):
    FrameRemoveDuplicatedADC = _libs["libPyFd.so"].get("FrameRemoveDuplicatedADC", "cdecl")
    FrameRemoveDuplicatedADC.argtypes = [POINTER(FrameH)]
    FrameRemoveDuplicatedADC.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 244
if _libs["libPyFd.so"].has("FrameRemoveDuplicatedProc", "cdecl"):
    FrameRemoveDuplicatedProc = _libs["libPyFd.so"].get("FrameRemoveDuplicatedProc", "cdecl")
    FrameRemoveDuplicatedProc.argtypes = [POINTER(FrameH)]
    FrameRemoveDuplicatedProc.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 245
if _libs["libPyFd.so"].has("FrameReshape", "cdecl"):
    FrameReshape = _libs["libPyFd.so"].get("FrameReshape", "cdecl")
    FrameReshape.argtypes = [POINTER(FrameH), POINTER(POINTER(FrameH)), c_int]
    FrameReshape.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 246
if _libs["libPyFd.so"].has("FrameReshapeAdd", "cdecl"):
    FrameReshapeAdd = _libs["libPyFd.so"].get("FrameReshapeAdd", "cdecl")
    FrameReshapeAdd.argtypes = [POINTER(FrameH), POINTER(FrameH)]
    FrameReshapeAdd.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 247
if _libs["libPyFd.so"].has("FrameReshapeConvertSer", "cdecl"):
    FrameReshapeConvertSer = _libs["libPyFd.so"].get("FrameReshapeConvertSer", "cdecl")
    FrameReshapeConvertSer.argtypes = [POINTER(FrameH), POINTER(FrameH), c_double]
    FrameReshapeConvertSer.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 248
if _libs["libPyFd.so"].has("FrameReshapeEnd", "cdecl"):
    FrameReshapeEnd = _libs["libPyFd.so"].get("FrameReshapeEnd", "cdecl")
    FrameReshapeEnd.argtypes = [POINTER(FrameH)]
    FrameReshapeEnd.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 249
if _libs["libPyFd.so"].has("FrameReshapeNew", "cdecl"):
    FrameReshapeNew = _libs["libPyFd.so"].get("FrameReshapeNew", "cdecl")
    FrameReshapeNew.argtypes = [POINTER(FrameH), c_int, c_int]
    FrameReshapeNew.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 250
if _libs["libPyFd.so"].has("FrameSetPrefix", "cdecl"):
    FrameSetPrefix = _libs["libPyFd.so"].get("FrameSetPrefix", "cdecl")
    FrameSetPrefix.argtypes = [POINTER(FrameH), String]
    FrameSetPrefix.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 251
if _libs["libPyFd.so"].has("FrameSetSuffix", "cdecl"):
    FrameSetSuffix = _libs["libPyFd.so"].get("FrameSetSuffix", "cdecl")
    FrameSetSuffix.argtypes = [POINTER(FrameH), String]
    FrameSetSuffix.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 252
if _libs["libPyFd.so"].has("FrameStat", "cdecl"):
    FrameStat = _libs["libPyFd.so"].get("FrameStat", "cdecl")
    FrameStat.argtypes = [POINTER(FrameH), POINTER(FILE)]
    FrameStat.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 253
if _libs["libPyFd.so"].has("FrameTag", "cdecl"):
    FrameTag = _libs["libPyFd.so"].get("FrameTag", "cdecl")
    FrameTag.argtypes = [POINTER(FrameH), String]
    FrameTag.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 254
if _libs["libPyFd.so"].has("FrameTagAdc", "cdecl"):
    FrameTagAdc = _libs["libPyFd.so"].get("FrameTagAdc", "cdecl")
    FrameTagAdc.argtypes = [POINTER(FrameH), String]
    FrameTagAdc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 255
if _libs["libPyFd.so"].has("FrameTagBasic", "cdecl"):
    FrameTagBasic = _libs["libPyFd.so"].get("FrameTagBasic", "cdecl")
    FrameTagBasic.argtypes = [POINTER(POINTER(FrBasic)), POINTER(POINTER(FrBasic)), String]
    FrameTagBasic.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 256
if _libs["libPyFd.so"].has("FrameTagEvent", "cdecl"):
    FrameTagEvent = _libs["libPyFd.so"].get("FrameTagEvent", "cdecl")
    FrameTagEvent.argtypes = [POINTER(FrameH), String]
    FrameTagEvent.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 257
if _libs["libPyFd.so"].has("FrameTagMsg", "cdecl"):
    FrameTagMsg = _libs["libPyFd.so"].get("FrameTagMsg", "cdecl")
    FrameTagMsg.argtypes = [POINTER(FrameH), String]
    FrameTagMsg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 258
if _libs["libPyFd.so"].has("FrameTagProc", "cdecl"):
    FrameTagProc = _libs["libPyFd.so"].get("FrameTagProc", "cdecl")
    FrameTagProc.argtypes = [POINTER(FrameH), String]
    FrameTagProc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 259
if _libs["libPyFd.so"].has("FrameTagSer", "cdecl"):
    FrameTagSer = _libs["libPyFd.so"].get("FrameTagSer", "cdecl")
    FrameTagSer.argtypes = [POINTER(FrameH), String]
    FrameTagSer.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 260
if _libs["libPyFd.so"].has("FrameTagSim", "cdecl"):
    FrameTagSim = _libs["libPyFd.so"].get("FrameTagSim", "cdecl")
    FrameTagSim.argtypes = [POINTER(FrameH), String]
    FrameTagSim.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 261
if _libs["libPyFd.so"].has("FrameTagSimEvt", "cdecl"):
    FrameTagSimEvt = _libs["libPyFd.so"].get("FrameTagSimEvt", "cdecl")
    FrameTagSimEvt.argtypes = [POINTER(FrameH), String]
    FrameTagSimEvt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 262
if _libs["libPyFd.so"].has("FrameTagStat", "cdecl"):
    FrameTagStat = _libs["libPyFd.so"].get("FrameTagStat", "cdecl")
    FrameTagStat.argtypes = [POINTER(FrameH), String]
    FrameTagStat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 263
if _libs["libPyFd.so"].has("FrameTagSum", "cdecl"):
    FrameTagSum = _libs["libPyFd.so"].get("FrameTagSum", "cdecl")
    FrameTagSum.argtypes = [POINTER(FrameH), String]
    FrameTagSum.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 264
if _libs["libPyFd.so"].has("FrameUntag", "cdecl"):
    FrameUntag = _libs["libPyFd.so"].get("FrameUntag", "cdecl")
    FrameUntag.argtypes = [POINTER(FrameH)]
    FrameUntag.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 265
if _libs["libPyFd.so"].has("FrameUntagAdc", "cdecl"):
    FrameUntagAdc = _libs["libPyFd.so"].get("FrameUntagAdc", "cdecl")
    FrameUntagAdc.argtypes = [POINTER(FrameH)]
    FrameUntagAdc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 266
if _libs["libPyFd.so"].has("FrameUntagBasic", "cdecl"):
    FrameUntagBasic = _libs["libPyFd.so"].get("FrameUntagBasic", "cdecl")
    FrameUntagBasic.argtypes = [POINTER(POINTER(FrBasic)), POINTER(POINTER(FrBasic))]
    FrameUntagBasic.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 267
if _libs["libPyFd.so"].has("FrameUntagEvent", "cdecl"):
    FrameUntagEvent = _libs["libPyFd.so"].get("FrameUntagEvent", "cdecl")
    FrameUntagEvent.argtypes = [POINTER(FrameH)]
    FrameUntagEvent.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 268
if _libs["libPyFd.so"].has("FrameUntagMsg", "cdecl"):
    FrameUntagMsg = _libs["libPyFd.so"].get("FrameUntagMsg", "cdecl")
    FrameUntagMsg.argtypes = [POINTER(FrameH)]
    FrameUntagMsg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 269
if _libs["libPyFd.so"].has("FrameUntagProc", "cdecl"):
    FrameUntagProc = _libs["libPyFd.so"].get("FrameUntagProc", "cdecl")
    FrameUntagProc.argtypes = [POINTER(FrameH)]
    FrameUntagProc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 270
if _libs["libPyFd.so"].has("FrameUntagSer", "cdecl"):
    FrameUntagSer = _libs["libPyFd.so"].get("FrameUntagSer", "cdecl")
    FrameUntagSer.argtypes = [POINTER(FrameH)]
    FrameUntagSer.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 271
if _libs["libPyFd.so"].has("FrameUntagSim", "cdecl"):
    FrameUntagSim = _libs["libPyFd.so"].get("FrameUntagSim", "cdecl")
    FrameUntagSim.argtypes = [POINTER(FrameH)]
    FrameUntagSim.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 272
if _libs["libPyFd.so"].has("FrameUntagSimEvt", "cdecl"):
    FrameUntagSimEvt = _libs["libPyFd.so"].get("FrameUntagSimEvt", "cdecl")
    FrameUntagSimEvt.argtypes = [POINTER(FrameH)]
    FrameUntagSimEvt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 273
if _libs["libPyFd.so"].has("FrameUntagStat", "cdecl"):
    FrameUntagStat = _libs["libPyFd.so"].get("FrameUntagStat", "cdecl")
    FrameUntagStat.argtypes = [POINTER(FrameH)]
    FrameUntagStat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 274
if _libs["libPyFd.so"].has("FrameUntagSum", "cdecl"):
    FrameUntagSum = _libs["libPyFd.so"].get("FrameUntagSum", "cdecl")
    FrameUntagSum.argtypes = [POINTER(FrameH)]
    FrameUntagSum.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 275
if _libs["libPyFd.so"].has("FrameWrite", "cdecl"):
    FrameWrite = _libs["libPyFd.so"].get("FrameWrite", "cdecl")
    FrameWrite.argtypes = [POINTER(FrameH), POINTER(FrFile)]
    FrameWrite.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 276
if _libs["libPyFd.so"].has("FrameWriteToBuf", "cdecl"):
    FrameWriteToBuf = _libs["libPyFd.so"].get("FrameWriteToBuf", "cdecl")
    FrameWriteToBuf.argtypes = [POINTER(FrameH), c_int, String, FRLONG, c_int]
    FrameWriteToBuf.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 279
if _libs["libPyFd.so"].has("FrameHCopy", "cdecl"):
    FrameHCopy = _libs["libPyFd.so"].get("FrameHCopy", "cdecl")
    FrameHCopy.argtypes = [POINTER(FrameH)]
    FrameHCopy.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 280
if _libs["libPyFd.so"].has("FrameHDef", "cdecl"):
    FrameHDef = _libs["libPyFd.so"].get("FrameHDef", "cdecl")
    FrameHDef.argtypes = []
    FrameHDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 281
if _libs["libPyFd.so"].has("FrameHRead", "cdecl"):
    FrameHRead = _libs["libPyFd.so"].get("FrameHRead", "cdecl")
    FrameHRead.argtypes = [POINTER(FrFile)]
    FrameHRead.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 282
if _libs["libPyFd.so"].has("FrameHReadN", "cdecl"):
    FrameHReadN = _libs["libPyFd.so"].get("FrameHReadN", "cdecl")
    FrameHReadN.argtypes = [POINTER(FrFile), c_int, c_int]
    FrameHReadN.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 283
if _libs["libPyFd.so"].has("FrameHReadT", "cdecl"):
    FrameHReadT = _libs["libPyFd.so"].get("FrameHReadT", "cdecl")
    FrameHReadT.argtypes = [POINTER(FrFile), c_double]
    FrameHReadT.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 284
if _libs["libPyFd.so"].has("FrameHNew", "cdecl"):
    FrameHNew = _libs["libPyFd.so"].get("FrameHNew", "cdecl")
    FrameHNew.argtypes = [String]
    FrameHNew.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 285
if _libs["libPyFd.so"].has("FrameHWrite", "cdecl"):
    FrameHWrite = _libs["libPyFd.so"].get("FrameHWrite", "cdecl")
    FrameHWrite.argtypes = [POINTER(FrameH), POINTER(FrFile)]
    FrameHWrite.restype = None

struct_FrAdcData.__slots__ = [
    'classe',
    'name',
    'data',
    'aux',
    'next',
    'nextOld',
    'comment',
    'channelGroup',
    'channelNumber',
    'nBits',
    'bias',
    'slope',
    'units',
    'sampleRate',
    'timeOffset',
    'fShift',
    'phase',
    'dataValid',
]
struct_FrAdcData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('aux', POINTER(FrVect)),
    ('next', POINTER(FrAdcData)),
    ('nextOld', POINTER(FrAdcData)),
    ('comment', String),
    ('channelGroup', c_uint),
    ('channelNumber', c_uint),
    ('nBits', c_uint),
    ('bias', c_float),
    ('slope', c_float),
    ('units', String),
    ('sampleRate', c_double),
    ('timeOffset', c_double),
    ('fShift', c_double),
    ('phase', c_float),
    ('dataValid', c_ushort),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 313
if _libs["libPyFd.so"].has("FrAdcDataCopy", "cdecl"):
    FrAdcDataCopy = _libs["libPyFd.so"].get("FrAdcDataCopy", "cdecl")
    FrAdcDataCopy.argtypes = [POINTER(FrAdcData), POINTER(FrameH)]
    FrAdcDataCopy.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 314
if _libs["libPyFd.so"].has("FrAdcDataDecimate", "cdecl"):
    FrAdcDataDecimate = _libs["libPyFd.so"].get("FrAdcDataDecimate", "cdecl")
    FrAdcDataDecimate.argtypes = [POINTER(FrAdcData), c_int]
    FrAdcDataDecimate.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 315
if _libs["libPyFd.so"].has("FrAdcDataDef", "cdecl"):
    FrAdcDataDef = _libs["libPyFd.so"].get("FrAdcDataDef", "cdecl")
    FrAdcDataDef.argtypes = []
    FrAdcDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 316
if _libs["libPyFd.so"].has("FrAdcDataDump", "cdecl"):
    FrAdcDataDump = _libs["libPyFd.so"].get("FrAdcDataDump", "cdecl")
    FrAdcDataDump.argtypes = [POINTER(FrAdcData), POINTER(FILE), c_int]
    FrAdcDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 317
if _libs["libPyFd.so"].has("FrAdcDataFind", "cdecl"):
    FrAdcDataFind = _libs["libPyFd.so"].get("FrAdcDataFind", "cdecl")
    FrAdcDataFind.argtypes = [POINTER(FrameH), String]
    FrAdcDataFind.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 318
if _libs["libPyFd.so"].has("FrAdcDataFree", "cdecl"):
    FrAdcDataFree = _libs["libPyFd.so"].get("FrAdcDataFree", "cdecl")
    FrAdcDataFree.argtypes = [POINTER(FrAdcData)]
    FrAdcDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 319
if _libs["libPyFd.so"].has("FrAdcDataFreeOne", "cdecl"):
    FrAdcDataFreeOne = _libs["libPyFd.so"].get("FrAdcDataFreeOne", "cdecl")
    FrAdcDataFreeOne.argtypes = [POINTER(FrAdcData)]
    FrAdcDataFreeOne.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 320
if _libs["libPyFd.so"].has("FrAdcDataGetSize", "cdecl"):
    FrAdcDataGetSize = _libs["libPyFd.so"].get("FrAdcDataGetSize", "cdecl")
    FrAdcDataGetSize.argtypes = [POINTER(FrAdcData)]
    FrAdcDataGetSize.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 321
if _libs["libPyFd.so"].has("FrAdcDataNew", "cdecl"):
    FrAdcDataNew = _libs["libPyFd.so"].get("FrAdcDataNew", "cdecl")
    FrAdcDataNew.argtypes = [POINTER(FrameH), String, c_double, FRLONG, c_int]
    FrAdcDataNew.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 323
if _libs["libPyFd.so"].has("FrAdcDataNewF", "cdecl"):
    FrAdcDataNewF = _libs["libPyFd.so"].get("FrAdcDataNewF", "cdecl")
    FrAdcDataNewF.argtypes = [POINTER(FrameH), String, String, c_uint, c_uint, c_int, c_float, c_float, String, c_double, FRLONG]
    FrAdcDataNewF.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 327
if _libs["libPyFd.so"].has("FrAdcDataRead", "cdecl"):
    FrAdcDataRead = _libs["libPyFd.so"].get("FrAdcDataRead", "cdecl")
    FrAdcDataRead.argtypes = [POINTER(FrFile)]
    FrAdcDataRead.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 328
if _libs["libPyFd.so"].has("FrAdcDataReadT", "cdecl"):
    FrAdcDataReadT = _libs["libPyFd.so"].get("FrAdcDataReadT", "cdecl")
    FrAdcDataReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrAdcDataReadT.restype = POINTER(FrAdcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 329
if _libs["libPyFd.so"].has("FrAdcDataSetAux", "cdecl"):
    FrAdcDataSetAux = _libs["libPyFd.so"].get("FrAdcDataSetAux", "cdecl")
    FrAdcDataSetAux.argtypes = [POINTER(FrAdcData), POINTER(FrVect)]
    FrAdcDataSetAux.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 330
if _libs["libPyFd.so"].has("FrAdcDataSetDataValid", "cdecl"):
    FrAdcDataSetDataValid = _libs["libPyFd.so"].get("FrAdcDataSetDataValid", "cdecl")
    FrAdcDataSetDataValid.argtypes = [POINTER(FrAdcData), c_ushort]
    FrAdcDataSetDataValid.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 331
if _libs["libPyFd.so"].has("FrAdcDataSetFShift", "cdecl"):
    FrAdcDataSetFShift = _libs["libPyFd.so"].get("FrAdcDataSetFShift", "cdecl")
    FrAdcDataSetFShift.argtypes = [POINTER(FrAdcData), c_double, c_float]
    FrAdcDataSetFShift.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 332
if _libs["libPyFd.so"].has("FrAdcDataSetTOffset", "cdecl"):
    FrAdcDataSetTOffset = _libs["libPyFd.so"].get("FrAdcDataSetTOffset", "cdecl")
    FrAdcDataSetTOffset.argtypes = [POINTER(FrAdcData), c_double]
    FrAdcDataSetTOffset.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 333
if _libs["libPyFd.so"].has("FrAdcDataWrite", "cdecl"):
    FrAdcDataWrite = _libs["libPyFd.so"].get("FrAdcDataWrite", "cdecl")
    FrAdcDataWrite.argtypes = [POINTER(FrAdcData), POINTER(FrFile)]
    FrAdcDataWrite.restype = None

struct_FrCList.__slots__ = [
    'nChannels',
    'nameSize',
    'rowSize',
    'table',
]
struct_FrCList._fields_ = [
    ('nChannels', c_int),
    ('nameSize', c_int),
    ('rowSize', c_int),
    ('table', POINTER(None)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 343
if _libs["libPyFd.so"].has("FrCListBldAdc", "cdecl"):
    FrCListBldAdc = _libs["libPyFd.so"].get("FrCListBldAdc", "cdecl")
    FrCListBldAdc.argtypes = [POINTER(FrameH)]
    FrCListBldAdc.restype = POINTER(FrCList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 344
if _libs["libPyFd.so"].has("FrCListBldChannel", "cdecl"):
    FrCListBldChannel = _libs["libPyFd.so"].get("FrCListBldChannel", "cdecl")
    FrCListBldChannel.argtypes = [POINTER(FrameH)]
    FrCListBldChannel.restype = POINTER(FrCList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 345
if _libs["libPyFd.so"].has("FrCListBldSer", "cdecl"):
    FrCListBldSer = _libs["libPyFd.so"].get("FrCListBldSer", "cdecl")
    FrCListBldSer.argtypes = [POINTER(FrameH)]
    FrCListBldSer.restype = POINTER(FrCList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 346
if _libs["libPyFd.so"].has("FrCListBldProc", "cdecl"):
    FrCListBldProc = _libs["libPyFd.so"].get("FrCListBldProc", "cdecl")
    FrCListBldProc.argtypes = [POINTER(FrameH)]
    FrCListBldProc.restype = POINTER(FrCList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 347
if _libs["libPyFd.so"].has("FrCListFind", "cdecl"):
    FrCListFind = _libs["libPyFd.so"].get("FrCListFind", "cdecl")
    FrCListFind.argtypes = [POINTER(FrCList), String]
    FrCListFind.restype = POINTER(c_ubyte)
    FrCListFind.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 348
if _libs["libPyFd.so"].has("FrCListFindDuplicate", "cdecl"):
    FrCListFindDuplicate = _libs["libPyFd.so"].get("FrCListFindDuplicate", "cdecl")
    FrCListFindDuplicate.argtypes = [POINTER(FrCList), String, c_int]
    FrCListFindDuplicate.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 349
if _libs["libPyFd.so"].has("FrCListFree", "cdecl"):
    FrCListFree = _libs["libPyFd.so"].get("FrCListFree", "cdecl")
    FrCListFree.argtypes = [POINTER(FrCList)]
    FrCListFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 350
if _libs["libPyFd.so"].has("FrCListGetElement", "cdecl"):
    FrCListGetElement = _libs["libPyFd.so"].get("FrCListGetElement", "cdecl")
    FrCListGetElement.argtypes = [POINTER(FrCList), c_int]
    FrCListGetElement.restype = POINTER(c_ubyte)
    FrCListGetElement.errcheck = lambda v,*a : cast(v, c_void_p)

struct_FrDetector.__slots__ = [
    'classe',
    'name',
    'prefix',
    'longitude',
    'latitude',
    'elevation',
    'armXazimuth',
    'armYazimuth',
    'armXaltitude',
    'armYaltitude',
    'armXmidpoint',
    'armYmidpoint',
    'localTime',
    'aux',
    'table',
    'next',
    'sData',
    'sDataOld',
]
struct_FrDetector._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('prefix', c_char * int(2)),
    ('longitude', c_double),
    ('latitude', c_double),
    ('elevation', c_float),
    ('armXazimuth', c_float),
    ('armYazimuth', c_float),
    ('armXaltitude', c_float),
    ('armYaltitude', c_float),
    ('armXmidpoint', c_float),
    ('armYmidpoint', c_float),
    ('localTime', c_int),
    ('aux', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrDetector)),
    ('sData', POINTER(FrStatData)),
    ('sDataOld', POINTER(FrStatData)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 376
if _libs["libPyFd.so"].has("FrDetectorAddStatData", "cdecl"):
    FrDetectorAddStatData = _libs["libPyFd.so"].get("FrDetectorAddStatData", "cdecl")
    FrDetectorAddStatData.argtypes = [POINTER(FrDetector), POINTER(FrStatData)]
    FrDetectorAddStatData.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 377
if _libs["libPyFd.so"].has("FrDetectorDef", "cdecl"):
    FrDetectorDef = _libs["libPyFd.so"].get("FrDetectorDef", "cdecl")
    FrDetectorDef.argtypes = []
    FrDetectorDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 378
if _libs["libPyFd.so"].has("FrDetectorDump", "cdecl"):
    FrDetectorDump = _libs["libPyFd.so"].get("FrDetectorDump", "cdecl")
    FrDetectorDump.argtypes = [POINTER(FrDetector), POINTER(FILE), c_int]
    FrDetectorDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 379
if _libs["libPyFd.so"].has("FrDetectorMerge", "cdecl"):
    FrDetectorMerge = _libs["libPyFd.so"].get("FrDetectorMerge", "cdecl")
    FrDetectorMerge.argtypes = [POINTER(FrDetector), POINTER(FrDetector)]
    FrDetectorMerge.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 380
if _libs["libPyFd.so"].has("FrDetectorNew", "cdecl"):
    FrDetectorNew = _libs["libPyFd.so"].get("FrDetectorNew", "cdecl")
    FrDetectorNew.argtypes = [String]
    FrDetectorNew.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 381
if _libs["libPyFd.so"].has("FrDetectorFree", "cdecl"):
    FrDetectorFree = _libs["libPyFd.so"].get("FrDetectorFree", "cdecl")
    FrDetectorFree.argtypes = [POINTER(FrDetector)]
    FrDetectorFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 382
if _libs["libPyFd.so"].has("FrDetectorFindStatData", "cdecl"):
    FrDetectorFindStatData = _libs["libPyFd.so"].get("FrDetectorFindStatData", "cdecl")
    FrDetectorFindStatData.argtypes = [POINTER(FrDetector), String, c_int]
    FrDetectorFindStatData.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 383
if _libs["libPyFd.so"].has("FrDetectorRead", "cdecl"):
    FrDetectorRead = _libs["libPyFd.so"].get("FrDetectorRead", "cdecl")
    FrDetectorRead.argtypes = [POINTER(FrFile)]
    FrDetectorRead.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 384
if _libs["libPyFd.so"].has("FrDetectorUntagStat", "cdecl"):
    FrDetectorUntagStat = _libs["libPyFd.so"].get("FrDetectorUntagStat", "cdecl")
    FrDetectorUntagStat.argtypes = [POINTER(FrDetector)]
    FrDetectorUntagStat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 385
if _libs["libPyFd.so"].has("FrDetectorWrite", "cdecl"):
    FrDetectorWrite = _libs["libPyFd.so"].get("FrDetectorWrite", "cdecl")
    FrDetectorWrite.argtypes = [POINTER(FrDetector), POINTER(FrFile)]
    FrDetectorWrite.restype = None

struct_FrBasic.__slots__ = [
    'classe',
    'name',
    'data',
    'aux',
    'next',
    'nextOld',
]
struct_FrBasic._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('aux', POINTER(FrVect)),
    ('next', POINTER(FrBasic)),
    ('nextOld', POINTER(FrBasic)),
]

struct_FrEndOfFrame.__slots__ = [
    'classe',
    'run',
    'frame',
    'chkType',
    'chkSum',
]
struct_FrEndOfFrame._fields_ = [
    ('classe', POINTER(FrSH)),
    ('run', c_int),
    ('frame', c_uint),
    ('chkType', c_uint),
    ('chkSum', c_uint),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 408
if _libs["libPyFd.so"].has("FrEndOfFrameDef", "cdecl"):
    FrEndOfFrameDef = _libs["libPyFd.so"].get("FrEndOfFrameDef", "cdecl")
    FrEndOfFrameDef.argtypes = []
    FrEndOfFrameDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 409
if _libs["libPyFd.so"].has("FrEndOfFrameRead", "cdecl"):
    FrEndOfFrameRead = _libs["libPyFd.so"].get("FrEndOfFrameRead", "cdecl")
    FrEndOfFrameRead.argtypes = [POINTER(FrFile)]
    FrEndOfFrameRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 410
if _libs["libPyFd.so"].has("FrEndOfFrameWrite", "cdecl"):
    FrEndOfFrameWrite = _libs["libPyFd.so"].get("FrEndOfFrameWrite", "cdecl")
    FrEndOfFrameWrite.argtypes = [POINTER(FrameH), POINTER(FrFile)]
    FrEndOfFrameWrite.restype = None

struct_FrEndOfFile.__slots__ = [
    'classe',
    'nFrames',
    'nBytes',
    'chkType',
    'chkSum',
    'seekTOC',
]
struct_FrEndOfFile._fields_ = [
    ('classe', POINTER(FrSH)),
    ('nFrames', c_uint),
    ('nBytes', FRULONG),
    ('chkType', c_uint),
    ('chkSum', c_uint),
    ('seekTOC', FRULONG),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 421
if _libs["libPyFd.so"].has("FrEndOfFileDef", "cdecl"):
    FrEndOfFileDef = _libs["libPyFd.so"].get("FrEndOfFileDef", "cdecl")
    FrEndOfFileDef.argtypes = []
    FrEndOfFileDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 422
if _libs["libPyFd.so"].has("FrEndOfFileRead", "cdecl"):
    FrEndOfFileRead = _libs["libPyFd.so"].get("FrEndOfFileRead", "cdecl")
    FrEndOfFileRead.argtypes = [POINTER(FrFile)]
    FrEndOfFileRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 423
if _libs["libPyFd.so"].has("FrEndOfFileWrite", "cdecl"):
    FrEndOfFileWrite = _libs["libPyFd.so"].get("FrEndOfFileWrite", "cdecl")
    FrEndOfFileWrite.argtypes = [POINTER(FrFile)]
    FrEndOfFileWrite.restype = None

struct_FrEvent.__slots__ = [
    'classe',
    'name',
    'data',
    'table',
    'next',
    'nextOld',
    'comment',
    'inputs',
    'GTimeS',
    'GTimeN',
    'timeBefore',
    'timeAfter',
    'eventStatus',
    'amplitude',
    'probability',
    'statistics',
    'nParam',
    'parameters',
    'parameterNames',
]
struct_FrEvent._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrEvent)),
    ('nextOld', POINTER(FrEvent)),
    ('comment', String),
    ('inputs', String),
    ('GTimeS', c_uint),
    ('GTimeN', c_uint),
    ('timeBefore', c_float),
    ('timeAfter', c_float),
    ('eventStatus', c_uint),
    ('amplitude', c_float),
    ('probability', c_float),
    ('statistics', String),
    ('nParam', c_ushort),
    ('parameters', POINTER(c_double)),
    ('parameterNames', POINTER(POINTER(c_char))),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 449
if _libs["libPyFd.so"].has("FrEventAddParam", "cdecl"):
    FrEventAddParam = _libs["libPyFd.so"].get("FrEventAddParam", "cdecl")
    FrEventAddParam.argtypes = [POINTER(FrEvent), String, c_double]
    FrEventAddParam.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 450
if _libs["libPyFd.so"].has("FrEventAddVect", "cdecl"):
    FrEventAddVect = _libs["libPyFd.so"].get("FrEventAddVect", "cdecl")
    FrEventAddVect.argtypes = [POINTER(FrEvent), POINTER(FrVect), String]
    FrEventAddVect.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 451
if _libs["libPyFd.so"].has("FrEventAddVectF", "cdecl"):
    FrEventAddVectF = _libs["libPyFd.so"].get("FrEventAddVectF", "cdecl")
    FrEventAddVectF.argtypes = [POINTER(FrEvent), POINTER(FrVect), String]
    FrEventAddVectF.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 453
if _libs["libPyFd.so"].has("FrEventCopy", "cdecl"):
    FrEventCopy = _libs["libPyFd.so"].get("FrEventCopy", "cdecl")
    FrEventCopy.argtypes = [POINTER(FrEvent)]
    FrEventCopy.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 454
if _libs["libPyFd.so"].has("FrEventDef", "cdecl"):
    FrEventDef = _libs["libPyFd.so"].get("FrEventDef", "cdecl")
    FrEventDef.argtypes = []
    FrEventDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 455
if _libs["libPyFd.so"].has("FrEventDump", "cdecl"):
    FrEventDump = _libs["libPyFd.so"].get("FrEventDump", "cdecl")
    FrEventDump.argtypes = [POINTER(FrEvent), POINTER(FILE), c_int]
    FrEventDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 456
if _libs["libPyFd.so"].has("FrEventFind", "cdecl"):
    FrEventFind = _libs["libPyFd.so"].get("FrEventFind", "cdecl")
    FrEventFind.argtypes = [POINTER(FrameH), String, POINTER(FrEvent)]
    FrEventFind.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 457
if _libs["libPyFd.so"].has("FrEventFindVect", "cdecl"):
    FrEventFindVect = _libs["libPyFd.so"].get("FrEventFindVect", "cdecl")
    FrEventFindVect.argtypes = [POINTER(FrEvent), String]
    FrEventFindVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 458
if _libs["libPyFd.so"].has("FrEventFree", "cdecl"):
    FrEventFree = _libs["libPyFd.so"].get("FrEventFree", "cdecl")
    FrEventFree.argtypes = [POINTER(FrEvent)]
    FrEventFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 459
if _libs["libPyFd.so"].has("FrEventGetParam", "cdecl"):
    FrEventGetParam = _libs["libPyFd.so"].get("FrEventGetParam", "cdecl")
    FrEventGetParam.argtypes = [POINTER(FrEvent), String]
    FrEventGetParam.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 460
if _libs["libPyFd.so"].has("FrEventGetParamId", "cdecl"):
    FrEventGetParamId = _libs["libPyFd.so"].get("FrEventGetParamId", "cdecl")
    FrEventGetParamId.argtypes = [POINTER(FrEvent), String]
    FrEventGetParamId.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 461
if _libs["libPyFd.so"].has("FrEventGetVectD", "cdecl"):
    FrEventGetVectD = _libs["libPyFd.so"].get("FrEventGetVectD", "cdecl")
    FrEventGetVectD.argtypes = [POINTER(FrEvent), String]
    FrEventGetVectD.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 462
if _libs["libPyFd.so"].has("FrEventGetVectF", "cdecl"):
    FrEventGetVectF = _libs["libPyFd.so"].get("FrEventGetVectF", "cdecl")
    FrEventGetVectF.argtypes = [POINTER(FrEvent), String]
    FrEventGetVectF.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 463
if _libs["libPyFd.so"].has("FrEventNew", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrEventNew", "cdecl")
    _restype = POINTER(FrEvent)
    _errcheck = None
    _argtypes = [POINTER(FrameH), String, String, String, c_double, c_float, c_float, c_float, c_float, String, POINTER(FrVect), c_int]
    FrEventNew = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 468
if _libs["libPyFd.so"].has("FrEventRead", "cdecl"):
    FrEventRead = _libs["libPyFd.so"].get("FrEventRead", "cdecl")
    FrEventRead.argtypes = [POINTER(FrFile)]
    FrEventRead.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 469
if _libs["libPyFd.so"].has("FrEventReadData", "cdecl"):
    FrEventReadData = _libs["libPyFd.so"].get("FrEventReadData", "cdecl")
    FrEventReadData.argtypes = [POINTER(FrFile), POINTER(FrEvent)]
    FrEventReadData.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 470
if _libs["libPyFd.so"].has("FrEventReadT", "cdecl"):
    FrEventReadT = _libs["libPyFd.so"].get("FrEventReadT", "cdecl")
    FrEventReadT.argtypes = [POINTER(FrFile), String, c_double, c_double, c_double, c_double]
    FrEventReadT.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 472
if _libs["libPyFd.so"].has("FrEventReadTF", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrEventReadTF", "cdecl")
    _restype = POINTER(FrEvent)
    _errcheck = None
    _argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, c_int]
    FrEventReadTF = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 474
if _libs["libPyFd.so"].has("FrEventReadTF1", "cdecl"):
    FrEventReadTF1 = _libs["libPyFd.so"].get("FrEventReadTF1", "cdecl")
    FrEventReadTF1.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double]
    FrEventReadTF1.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 477
if _libs["libPyFd.so"].has("FrEventReadTF2", "cdecl"):
    FrEventReadTF2 = _libs["libPyFd.so"].get("FrEventReadTF2", "cdecl")
    FrEventReadTF2.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double, String, c_double, c_double]
    FrEventReadTF2.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 481
if _libs["libPyFd.so"].has("FrEventReadTF3", "cdecl"):
    FrEventReadTF3 = _libs["libPyFd.so"].get("FrEventReadTF3", "cdecl")
    FrEventReadTF3.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double]
    FrEventReadTF3.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 486
if _libs["libPyFd.so"].has("FrEventReadTF4", "cdecl"):
    FrEventReadTF4 = _libs["libPyFd.so"].get("FrEventReadTF4", "cdecl")
    FrEventReadTF4.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double]
    FrEventReadTF4.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 492
if _libs["libPyFd.so"].has("FrEventReadTF5", "cdecl"):
    FrEventReadTF5 = _libs["libPyFd.so"].get("FrEventReadTF5", "cdecl")
    FrEventReadTF5.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double, String, c_double, c_double]
    FrEventReadTF5.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 499
if _libs["libPyFd.so"].has("FrEventSaveOnFile", "cdecl"):
    FrEventSaveOnFile = _libs["libPyFd.so"].get("FrEventSaveOnFile", "cdecl")
    FrEventSaveOnFile.argtypes = [POINTER(FrEvent), POINTER(FrFile)]
    FrEventSaveOnFile.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 501
if _libs["libPyFd.so"].has("FrEventWrite", "cdecl"):
    FrEventWrite = _libs["libPyFd.so"].get("FrEventWrite", "cdecl")
    FrEventWrite.argtypes = [POINTER(FrEvent), POINTER(FrFile)]
    FrEventWrite.restype = None

struct_FrFile.__slots__ = [
    'fileH',
    'current',
    'inMemory',
    'compress',
    'gzipLevel',
    'sh',
    'firstSH',
    'curSH',
    'maxSH',
    'fmType',
    'fmLong',
    'endOfFrame',
    'curFrame',
    'fmtVersion',
    'header',
    'run',
    'nFrames',
    'nBytes',
    'nBytesE',
    'nBytesF',
    'nBytesR',
    'frfd',
    'error',
    'buf',
    'p',
    'pStart',
    'pMax',
    'bufSize',
    'sDataSim',
    'sDataProc',
    'sDataCur',
    'dicWrite',
    'oldLocalTime',
    'length',
    'vectorType',
    'detectorType',
    'type',
    'instance',
    'instanceH',
    'vectInstance',
    'nSH',
    'nSE',
    'toc',
    'noTOCts',
    'historyMsg',
    'fLength',
    'dirPeriod',
    'startTime',
    'closingTime',
    'currentEndTime',
    'path',
    'prefix',
    'dirName',
    'segList',
    'convertH',
    'aligned',
    'chkSumFiFlag',
    'chkSumFrFlag',
    'chkSumFi',
    'chkSumFr',
    'chkSumFrHeader',
    'chkSumFiRead',
    'chkSumFrRead',
    'chkTypeFiRead',
    'chkTypeFrRead',
    'relocation',
    'lastInstance',
    'refType',
    'refInstance',
    'address',
    'refAddress',
    'nRef',
    'lastSlope',
    'lastBias',
    'lastUnits',
]
struct_FrFile._fields_ = [
    ('fileH', POINTER(FrFileH)),
    ('current', POINTER(FrFileH)),
    ('inMemory', FRBOOL),
    ('compress', c_int),
    ('gzipLevel', c_ushort),
    ('sh', POINTER(POINTER(FrSH))),
    ('firstSH', POINTER(FrSH)),
    ('curSH', POINTER(FrSH)),
    ('maxSH', c_int),
    ('fmType', FRFORMAT),
    ('fmLong', FRFORMAT),
    ('endOfFrame', FRBOOL),
    ('curFrame', POINTER(FrameH)),
    ('fmtVersion', c_int),
    ('header', c_ubyte * int(40)),
    ('run', c_int),
    ('nFrames', c_uint),
    ('nBytes', FRULONG),
    ('nBytesE', FRULONG),
    ('nBytesF', FRULONG),
    ('nBytesR', FRULONG),
    ('frfd', POINTER(FrIO)),
    ('error', FRERROR),
    ('buf', String),
    ('p', String),
    ('pStart', String),
    ('pMax', String),
    ('bufSize', FRLONG),
    ('sDataSim', POINTER(FrStatData)),
    ('sDataProc', POINTER(FrStatData)),
    ('sDataCur', POINTER(FrStatData)),
    ('dicWrite', FRBOOL * int(100)),
    ('oldLocalTime', c_int),
    ('length', FRLONG),
    ('vectorType', c_ushort),
    ('detectorType', c_ushort),
    ('type', c_ushort),
    ('instance', c_uint),
    ('instanceH', c_uint),
    ('vectInstance', c_uint),
    ('nSH', c_int),
    ('nSE', c_int),
    ('toc', POINTER(FrTOC)),
    ('noTOCts', FRBOOL),
    ('historyMsg', String),
    ('fLength', c_int),
    ('dirPeriod', c_int),
    ('startTime', c_int),
    ('closingTime', c_int),
    ('currentEndTime', c_int),
    ('path', String),
    ('prefix', String),
    ('dirName', String),
    ('segList', POINTER(FrSegList)),
    ('convertH', FRBOOL),
    ('aligned', FRBOOL),
    ('chkSumFiFlag', FRBOOL),
    ('chkSumFrFlag', FRBOOL),
    ('chkSumFi', c_uint),
    ('chkSumFr', c_uint),
    ('chkSumFrHeader', c_uint),
    ('chkSumFiRead', c_uint),
    ('chkSumFrRead', c_uint),
    ('chkTypeFiRead', c_uint),
    ('chkTypeFrRead', c_uint),
    ('relocation', FRBOOL),
    ('lastInstance', c_int * int(100)),
    ('refType', c_int * int(50)),
    ('refInstance', c_int * int(50)),
    ('address', POINTER(None) * int(50)),
    ('refAddress', POINTER(POINTER(None)) * int(50)),
    ('nRef', c_int),
    ('lastSlope', c_double),
    ('lastBias', c_double),
    ('lastUnits', String),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 587
if _libs["libPyFd.so"].has("FrFileBreakName", "cdecl"):
    FrFileBreakName = _libs["libPyFd.so"].get("FrFileBreakName", "cdecl")
    FrFileBreakName.argtypes = [String, POINTER(FrFileH), POINTER(POINTER(FrSegList))]
    FrFileBreakName.restype = POINTER(FrFileH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 588
if _libs["libPyFd.so"].has("FrFileDbg", "cdecl"):
    FrFileDbg = _libs["libPyFd.so"].get("FrFileDbg", "cdecl")
    FrFileDbg.argtypes = [POINTER(FrFile)]
    FrFileDbg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 589
if _libs["libPyFd.so"].has("FrFileFree", "cdecl"):
    FrFileFree = _libs["libPyFd.so"].get("FrFileFree", "cdecl")
    FrFileFree.argtypes = [POINTER(FrFile)]
    FrFileFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 590
if _libs["libPyFd.so"].has("FrFileNew", "cdecl"):
    FrFileNew = _libs["libPyFd.so"].get("FrFileNew", "cdecl")
    FrFileNew.argtypes = [String, c_int, String, FRLONG]
    FrFileNew.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 592
if _libs["libPyFd.so"].has("FrFileIAddSegList", "cdecl"):
    FrFileIAddSegList = _libs["libPyFd.so"].get("FrFileIAddSegList", "cdecl")
    FrFileIAddSegList.argtypes = [POINTER(FrFile), POINTER(FrSegList)]
    FrFileIAddSegList.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 593
if _libs["libPyFd.so"].has("FrFileIClose", "cdecl"):
    FrFileIClose = _libs["libPyFd.so"].get("FrFileIClose", "cdecl")
    FrFileIClose.argtypes = [POINTER(FrFile)]
    FrFileIClose.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 594
if _libs["libPyFd.so"].has("FrFileIDump", "cdecl"):
    FrFileIDump = _libs["libPyFd.so"].get("FrFileIDump", "cdecl")
    FrFileIDump.argtypes = [POINTER(FrFile), POINTER(FILE), c_int, String]
    FrFileIDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 595
if _libs["libPyFd.so"].has("FrFileIDumpT", "cdecl"):
    FrFileIDumpT = _libs["libPyFd.so"].get("FrFileIDumpT", "cdecl")
    FrFileIDumpT.argtypes = [POINTER(FrFile), POINTER(FILE), c_int, String, c_double, c_double]
    FrFileIDumpT.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 597
if _libs["libPyFd.so"].has("FrFileIDumpEvt", "cdecl"):
    FrFileIDumpEvt = _libs["libPyFd.so"].get("FrFileIDumpEvt", "cdecl")
    FrFileIDumpEvt.argtypes = [POINTER(FrFile), POINTER(FILE), c_int]
    FrFileIDumpEvt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 598
if _libs["libPyFd.so"].has("FrFileIDumpFr", "cdecl"):
    FrFileIDumpFr = _libs["libPyFd.so"].get("FrFileIDumpFr", "cdecl")
    FrFileIDumpFr.argtypes = [POINTER(FrFile), POINTER(FILE), c_int, c_double, c_double]
    FrFileIDumpFr.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 600
if _libs["libPyFd.so"].has("FrFileIEnd", "cdecl"):
    FrFileIEnd = _libs["libPyFd.so"].get("FrFileIEnd", "cdecl")
    FrFileIEnd.argtypes = [POINTER(FrFile)]
    FrFileIEnd.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 601
if _libs["libPyFd.so"].has("FrFileIGetAdcNames", "cdecl"):
    FrFileIGetAdcNames = _libs["libPyFd.so"].get("FrFileIGetAdcNames", "cdecl")
    FrFileIGetAdcNames.argtypes = [POINTER(FrFile)]
    FrFileIGetAdcNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 602
if _libs["libPyFd.so"].has("FrFileIGetChannelList", "cdecl"):
    FrFileIGetChannelList = _libs["libPyFd.so"].get("FrFileIGetChannelList", "cdecl")
    FrFileIGetChannelList.argtypes = [POINTER(FrFile), c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        FrFileIGetChannelList.restype = ReturnString
    else:
        FrFileIGetChannelList.restype = String
        FrFileIGetChannelList.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 603
if _libs["libPyFd.so"].has("FrFileIGetDetectorNames", "cdecl"):
    FrFileIGetDetectorNames = _libs["libPyFd.so"].get("FrFileIGetDetectorNames", "cdecl")
    FrFileIGetDetectorNames.argtypes = [POINTER(FrFile)]
    FrFileIGetDetectorNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 604
if _libs["libPyFd.so"].has("FrFileIGetEventInfo", "cdecl"):
    FrFileIGetEventInfo = _libs["libPyFd.so"].get("FrFileIGetEventInfo", "cdecl")
    FrFileIGetEventInfo.argtypes = [POINTER(FrFile), String, c_double, c_double, c_double, c_double]
    FrFileIGetEventInfo.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 606
if _libs["libPyFd.so"].has("FrFileIGetEventNames", "cdecl"):
    FrFileIGetEventNames = _libs["libPyFd.so"].get("FrFileIGetEventNames", "cdecl")
    FrFileIGetEventNames.argtypes = [POINTER(FrFile)]
    FrFileIGetEventNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 607
if _libs["libPyFd.so"].has("FrFileIGetFrameInfo", "cdecl"):
    FrFileIGetFrameInfo = _libs["libPyFd.so"].get("FrFileIGetFrameInfo", "cdecl")
    FrFileIGetFrameInfo.argtypes = [POINTER(FrFile), c_double, c_double]
    FrFileIGetFrameInfo.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 608
if _libs["libPyFd.so"].has("FrFileIGetFrameInfo1", "cdecl"):
    FrFileIGetFrameInfo1 = _libs["libPyFd.so"].get("FrFileIGetFrameInfo1", "cdecl")
    FrFileIGetFrameInfo1.argtypes = [POINTER(FrFile), c_double, c_double]
    FrFileIGetFrameInfo1.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 609
if _libs["libPyFd.so"].has("FrFileIGetProcNames", "cdecl"):
    FrFileIGetProcNames = _libs["libPyFd.so"].get("FrFileIGetProcNames", "cdecl")
    FrFileIGetProcNames.argtypes = [POINTER(FrFile)]
    FrFileIGetProcNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 610
if _libs["libPyFd.so"].has("FrFileIGetSerNames", "cdecl"):
    FrFileIGetSerNames = _libs["libPyFd.so"].get("FrFileIGetSerNames", "cdecl")
    FrFileIGetSerNames.argtypes = [POINTER(FrFile)]
    FrFileIGetSerNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 611
if _libs["libPyFd.so"].has("FrFileIGetSimEventInfo", "cdecl"):
    FrFileIGetSimEventInfo = _libs["libPyFd.so"].get("FrFileIGetSimEventInfo", "cdecl")
    FrFileIGetSimEventInfo.argtypes = [POINTER(FrFile), String, c_double, c_double, c_double, c_double]
    FrFileIGetSimEventInfo.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 613
if _libs["libPyFd.so"].has("FrFileIGetSimEventNames", "cdecl"):
    FrFileIGetSimEventNames = _libs["libPyFd.so"].get("FrFileIGetSimEventNames", "cdecl")
    FrFileIGetSimEventNames.argtypes = [POINTER(FrFile)]
    FrFileIGetSimEventNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 614
if _libs["libPyFd.so"].has("FrFileIGetSimNames", "cdecl"):
    FrFileIGetSimNames = _libs["libPyFd.so"].get("FrFileIGetSimNames", "cdecl")
    FrFileIGetSimNames.argtypes = [POINTER(FrFile)]
    FrFileIGetSimNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 615
if _libs["libPyFd.so"].has("FrFileIGetStatNames", "cdecl"):
    FrFileIGetStatNames = _libs["libPyFd.so"].get("FrFileIGetStatNames", "cdecl")
    FrFileIGetStatNames.argtypes = [POINTER(FrFile)]
    FrFileIGetStatNames.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 617
if _libs["libPyFd.so"].has("FrFileIGetV", "cdecl"):
    FrFileIGetV = _libs["libPyFd.so"].get("FrFileIGetV", "cdecl")
    FrFileIGetV.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetV.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 618
if _libs["libPyFd.so"].has("FrFileIGetVect", "cdecl"):
    FrFileIGetVect = _libs["libPyFd.so"].get("FrFileIGetVect", "cdecl")
    FrFileIGetVect.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 619
if _libs["libPyFd.so"].has("FrFileIGetVectD", "cdecl"):
    FrFileIGetVectD = _libs["libPyFd.so"].get("FrFileIGetVectD", "cdecl")
    FrFileIGetVectD.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetVectD.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 620
if _libs["libPyFd.so"].has("FrFileIGetVectDN", "cdecl"):
    FrFileIGetVectDN = _libs["libPyFd.so"].get("FrFileIGetVectDN", "cdecl")
    FrFileIGetVectDN.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetVectDN.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 621
if _libs["libPyFd.so"].has("FrFileIGetVectF", "cdecl"):
    FrFileIGetVectF = _libs["libPyFd.so"].get("FrFileIGetVectF", "cdecl")
    FrFileIGetVectF.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetVectF.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 622
if _libs["libPyFd.so"].has("FrFileIGetVectFN", "cdecl"):
    FrFileIGetVectFN = _libs["libPyFd.so"].get("FrFileIGetVectFN", "cdecl")
    FrFileIGetVectFN.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetVectFN.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 624
if _libs["libPyFd.so"].has("FrFileIGetVAdc", "cdecl"):
    FrFileIGetVAdc = _libs["libPyFd.so"].get("FrFileIGetVAdc", "cdecl")
    FrFileIGetVAdc.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int]
    FrFileIGetVAdc.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 626
if _libs["libPyFd.so"].has("FrFileIGetVProc", "cdecl"):
    FrFileIGetVProc = _libs["libPyFd.so"].get("FrFileIGetVProc", "cdecl")
    FrFileIGetVProc.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int]
    FrFileIGetVProc.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 628
if _libs["libPyFd.so"].has("FrFileIGetVSim", "cdecl"):
    FrFileIGetVSim = _libs["libPyFd.so"].get("FrFileIGetVSim", "cdecl")
    FrFileIGetVSim.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int]
    FrFileIGetVSim.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 630
if _libs["libPyFd.so"].has("FrFileIGetVType", "cdecl"):
    FrFileIGetVType = _libs["libPyFd.so"].get("FrFileIGetVType", "cdecl")
    FrFileIGetVType.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, FRTSTYPE]
    FrFileIGetVType.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 632
if _libs["libPyFd.so"].has("FrFileIGetNextEventTime", "cdecl"):
    FrFileIGetNextEventTime = _libs["libPyFd.so"].get("FrFileIGetNextEventTime", "cdecl")
    FrFileIGetNextEventTime.argtypes = [POINTER(FrFile), String, c_double, c_double]
    FrFileIGetNextEventTime.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 634
if _libs["libPyFd.so"].has("FrFileIGoToNextRecord", "cdecl"):
    FrFileIGoToNextRecord = _libs["libPyFd.so"].get("FrFileIGoToNextRecord", "cdecl")
    FrFileIGoToNextRecord.argtypes = [POINTER(FrFile)]
    FrFileIGoToNextRecord.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 635
if _libs["libPyFd.so"].has("FrFileIInMemoryNew", "cdecl"):
    FrFileIInMemoryNew = _libs["libPyFd.so"].get("FrFileIInMemoryNew", "cdecl")
    FrFileIInMemoryNew.argtypes = []
    FrFileIInMemoryNew.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 636
if _libs["libPyFd.so"].has("FrFileIInMemoryAddBuffer", "cdecl"):
    FrFileIInMemoryAddBuffer = _libs["libPyFd.so"].get("FrFileIInMemoryAddBuffer", "cdecl")
    FrFileIInMemoryAddBuffer.argtypes = [POINTER(FrFile), String, c_int, c_double]
    FrFileIInMemoryAddBuffer.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 637
if _libs["libPyFd.so"].has("FrFileINew", "cdecl"):
    FrFileINew = _libs["libPyFd.so"].get("FrFileINew", "cdecl")
    FrFileINew.argtypes = [String]
    FrFileINew.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 638
if _libs["libPyFd.so"].has("FrFileINewFd", "cdecl"):
    FrFileINewFd = _libs["libPyFd.so"].get("FrFileINewFd", "cdecl")
    FrFileINewFd.argtypes = [POINTER(FrIO)]
    FrFileINewFd.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 639
if _libs["libPyFd.so"].has("FrFileINext", "cdecl"):
    FrFileINext = _libs["libPyFd.so"].get("FrFileINext", "cdecl")
    FrFileINext.argtypes = [POINTER(FrFile), c_double, c_double, POINTER(FrFileH), FRBOOL]
    FrFileINext.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 641
if _libs["libPyFd.so"].has("FrFileIncSH", "cdecl"):
    FrFileIncSH = _libs["libPyFd.so"].get("FrFileIncSH", "cdecl")
    FrFileIncSH.argtypes = [POINTER(FrFile), c_ushort]
    FrFileIncSH.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 642
if _libs["libPyFd.so"].has("FrFileIOpen", "cdecl"):
    FrFileIOpen = _libs["libPyFd.so"].get("FrFileIOpen", "cdecl")
    FrFileIOpen.argtypes = [POINTER(FrFile)]
    FrFileIOpen.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 643
if _libs["libPyFd.so"].has("FrFileIOSet", "cdecl"):
    FrFileIOSet = _libs["libPyFd.so"].get("FrFileIOSet", "cdecl")
    FrFileIOSet.argtypes = [POINTER(FrFile), FRLONG]
    FrFileIOSet.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 644
if _libs["libPyFd.so"].has("FrFileIOSetFromEnd", "cdecl"):
    FrFileIOSetFromEnd = _libs["libPyFd.so"].get("FrFileIOSetFromEnd", "cdecl")
    FrFileIOSetFromEnd.argtypes = [POINTER(FrFile), FRLONG]
    FrFileIOSetFromEnd.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 645
if _libs["libPyFd.so"].has("FrFileIOSetFromCur", "cdecl"):
    FrFileIOSetFromCur = _libs["libPyFd.so"].get("FrFileIOSetFromCur", "cdecl")
    FrFileIOSetFromCur.argtypes = [POINTER(FrFile), FRLONG]
    FrFileIOSetFromCur.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 646
if _libs["libPyFd.so"].has("FrFileIOTell", "cdecl"):
    FrFileIOTell = _libs["libPyFd.so"].get("FrFileIOTell", "cdecl")
    FrFileIOTell.argtypes = [POINTER(FrFile)]
    FrFileIOTell.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 647
if _libs["libPyFd.so"].has("FrFileIRewind", "cdecl"):
    FrFileIRewind = _libs["libPyFd.so"].get("FrFileIRewind", "cdecl")
    FrFileIRewind.argtypes = [POINTER(FrFile)]
    FrFileIRewind.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 648
if _libs["libPyFd.so"].has("FrFileISegListMatch", "cdecl"):
    FrFileISegListMatch = _libs["libPyFd.so"].get("FrFileISegListMatch", "cdecl")
    FrFileISegListMatch.argtypes = [POINTER(FrFile)]
    FrFileISegListMatch.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 649
if _libs["libPyFd.so"].has("FrFileISetTime", "cdecl"):
    FrFileISetTime = _libs["libPyFd.so"].get("FrFileISetTime", "cdecl")
    FrFileISetTime.argtypes = [POINTER(FrFile), c_double]
    FrFileISetTime.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 650
if _libs["libPyFd.so"].has("FrFileIStat", "cdecl"):
    FrFileIStat = _libs["libPyFd.so"].get("FrFileIStat", "cdecl")
    FrFileIStat.argtypes = [POINTER(FrFile), POINTER(FILE)]
    FrFileIStat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 651
if _libs["libPyFd.so"].has("FrFileITEnd", "cdecl"):
    FrFileITEnd = _libs["libPyFd.so"].get("FrFileITEnd", "cdecl")
    FrFileITEnd.argtypes = [POINTER(FrFile)]
    FrFileITEnd.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 652
if _libs["libPyFd.so"].has("FrFileITFirstEvt", "cdecl"):
    FrFileITFirstEvt = _libs["libPyFd.so"].get("FrFileITFirstEvt", "cdecl")
    FrFileITFirstEvt.argtypes = [POINTER(FrFile)]
    FrFileITFirstEvt.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 653
if _libs["libPyFd.so"].has("FrFileITLastEvt", "cdecl"):
    FrFileITLastEvt = _libs["libPyFd.so"].get("FrFileITLastEvt", "cdecl")
    FrFileITLastEvt.argtypes = [POINTER(FrFile)]
    FrFileITLastEvt.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 654
if _libs["libPyFd.so"].has("FrFileITNextFrame", "cdecl"):
    FrFileITNextFrame = _libs["libPyFd.so"].get("FrFileITNextFrame", "cdecl")
    FrFileITNextFrame.argtypes = [POINTER(FrFile), c_double]
    FrFileITNextFrame.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 655
if _libs["libPyFd.so"].has("FrFileITStart", "cdecl"):
    FrFileITStart = _libs["libPyFd.so"].get("FrFileITStart", "cdecl")
    FrFileITStart.argtypes = [POINTER(FrFile)]
    FrFileITStart.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 657
if _libs["libPyFd.so"].has("FrFileOEnd", "cdecl"):
    FrFileOEnd = _libs["libPyFd.so"].get("FrFileOEnd", "cdecl")
    FrFileOEnd.argtypes = [POINTER(FrFile)]
    FrFileOEnd.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 658
if _libs["libPyFd.so"].has("FrFileONew", "cdecl"):
    FrFileONew = _libs["libPyFd.so"].get("FrFileONew", "cdecl")
    FrFileONew.argtypes = [String, c_int]
    FrFileONew.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 659
if _libs["libPyFd.so"].has("FrFileONewH", "cdecl"):
    FrFileONewH = _libs["libPyFd.so"].get("FrFileONewH", "cdecl")
    FrFileONewH.argtypes = [String, c_int, String]
    FrFileONewH.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 660
if _libs["libPyFd.so"].has("FrFileONewFd", "cdecl"):
    FrFileONewFd = _libs["libPyFd.so"].get("FrFileONewFd", "cdecl")
    FrFileONewFd.argtypes = [POINTER(FrIO), c_int]
    FrFileONewFd.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 661
if _libs["libPyFd.so"].has("FrFileONewFdH", "cdecl"):
    FrFileONewFdH = _libs["libPyFd.so"].get("FrFileONewFdH", "cdecl")
    FrFileONewFdH.argtypes = [POINTER(FrIO), c_int, String]
    FrFileONewFdH.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 662
if _libs["libPyFd.so"].has("FrFileONewM", "cdecl"):
    FrFileONewM = _libs["libPyFd.so"].get("FrFileONewM", "cdecl")
    FrFileONewM.argtypes = [String, c_int, String, c_int]
    FrFileONewM.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 663
if _libs["libPyFd.so"].has("FrFileONewMD", "cdecl"):
    FrFileONewMD = _libs["libPyFd.so"].get("FrFileONewMD", "cdecl")
    FrFileONewMD.argtypes = [String, c_int, String, c_int, String, c_int]
    FrFileONewMD.restype = POINTER(FrFile)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 666
if _libs["libPyFd.so"].has("FrFileOpenCacheFile", "cdecl"):
    FrFileOpenCacheFile = _libs["libPyFd.so"].get("FrFileOpenCacheFile", "cdecl")
    FrFileOpenCacheFile.argtypes = [String]
    FrFileOpenCacheFile.restype = POINTER(FrFileH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 667
if _libs["libPyFd.so"].has("FrFileOpenFFL", "cdecl"):
    FrFileOpenFFL = _libs["libPyFd.so"].get("FrFileOpenFFL", "cdecl")
    FrFileOpenFFL.argtypes = [String, POINTER(POINTER(FrFileH)), POINTER(POINTER(FrSegList))]
    FrFileOpenFFL.restype = POINTER(POINTER(FrFileH))

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 668
if _libs["libPyFd.so"].has("FrFileOOpen", "cdecl"):
    FrFileOOpen = _libs["libPyFd.so"].get("FrFileOOpen", "cdecl")
    FrFileOOpen.argtypes = [POINTER(FrFile)]
    FrFileOOpen.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 669
if _libs["libPyFd.so"].has("FrFileORealloc", "cdecl"):
    FrFileORealloc = _libs["libPyFd.so"].get("FrFileORealloc", "cdecl")
    FrFileORealloc.argtypes = [POINTER(FrFile), String, c_int]
    FrFileORealloc.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 670
if _libs["libPyFd.so"].has("FrFileOReopen", "cdecl"):
    FrFileOReopen = _libs["libPyFd.so"].get("FrFileOReopen", "cdecl")
    FrFileOReopen.argtypes = [POINTER(FrFile), c_int]
    FrFileOReopen.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 671
if _libs["libPyFd.so"].has("FrFileOSetMsg", "cdecl"):
    FrFileOSetMsg = _libs["libPyFd.so"].get("FrFileOSetMsg", "cdecl")
    FrFileOSetMsg.argtypes = [POINTER(FrFile), String]
    FrFileOSetMsg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 672
if _libs["libPyFd.so"].has("FrFileOSetGzipLevel", "cdecl"):
    FrFileOSetGzipLevel = _libs["libPyFd.so"].get("FrFileOSetGzipLevel", "cdecl")
    FrFileOSetGzipLevel.argtypes = [POINTER(FrFile), c_ushort]
    FrFileOSetGzipLevel.restype = None

struct_FrFileH.__slots__ = [
    'fileName',
    'tStart',
    'length',
    'tFirstEvt',
    'tLastEvt',
    'iMBuffer',
    'iMBSize',
    'next',
]
struct_FrFileH._fields_ = [
    ('fileName', String),
    ('tStart', c_double),
    ('length', c_double),
    ('tFirstEvt', c_double),
    ('tLastEvt', c_double),
    ('iMBuffer', String),
    ('iMBSize', c_int),
    ('next', POINTER(FrFileH)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 686
if _libs["libPyFd.so"].has("FrGetLeapS", "cdecl"):
    FrGetLeapS = _libs["libPyFd.so"].get("FrGetLeapS", "cdecl")
    FrGetLeapS.argtypes = [c_uint]
    FrGetLeapS.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 687
if _libs["libPyFd.so"].has("FrGetCurrentGPS", "cdecl"):
    FrGetCurrentGPS = _libs["libPyFd.so"].get("FrGetCurrentGPS", "cdecl")
    FrGetCurrentGPS.argtypes = []
    FrGetCurrentGPS.restype = c_double

struct_FrHistory.__slots__ = [
    'classe',
    'name',
    'time',
    'comment',
    'next',
]
struct_FrHistory._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('time', c_uint),
    ('comment', String),
    ('next', POINTER(FrHistory)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 699
if _libs["libPyFd.so"].has("FrHistoryAdd", "cdecl"):
    FrHistoryAdd = _libs["libPyFd.so"].get("FrHistoryAdd", "cdecl")
    FrHistoryAdd.argtypes = [POINTER(FrameH), String]
    FrHistoryAdd.restype = POINTER(FrHistory)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 700
if _libs["libPyFd.so"].has("FrHistoryCopy", "cdecl"):
    FrHistoryCopy = _libs["libPyFd.so"].get("FrHistoryCopy", "cdecl")
    FrHistoryCopy.argtypes = [POINTER(FrHistory)]
    FrHistoryCopy.restype = POINTER(FrHistory)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 701
if _libs["libPyFd.so"].has("FrHistoryDef", "cdecl"):
    FrHistoryDef = _libs["libPyFd.so"].get("FrHistoryDef", "cdecl")
    FrHistoryDef.argtypes = []
    FrHistoryDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 702
if _libs["libPyFd.so"].has("FrHistoryFree", "cdecl"):
    FrHistoryFree = _libs["libPyFd.so"].get("FrHistoryFree", "cdecl")
    FrHistoryFree.argtypes = [POINTER(FrHistory)]
    FrHistoryFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 703
if _libs["libPyFd.so"].has("FrHistoryNew", "cdecl"):
    FrHistoryNew = _libs["libPyFd.so"].get("FrHistoryNew", "cdecl")
    FrHistoryNew.argtypes = [String, c_uint, String]
    FrHistoryNew.restype = POINTER(FrHistory)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 704
if _libs["libPyFd.so"].has("FrHistoryRead", "cdecl"):
    FrHistoryRead = _libs["libPyFd.so"].get("FrHistoryRead", "cdecl")
    FrHistoryRead.argtypes = [POINTER(FrFile)]
    FrHistoryRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 705
if _libs["libPyFd.so"].has("FrHistoryWrite", "cdecl"):
    FrHistoryWrite = _libs["libPyFd.so"].get("FrHistoryWrite", "cdecl")
    FrHistoryWrite.argtypes = [POINTER(FrHistory), POINTER(FrFile)]
    FrHistoryWrite.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 708
if _libs["libPyFd.so"].has("FrSetAll", "cdecl"):
    FrSetAll = _libs["libPyFd.so"].get("FrSetAll", "cdecl")
    FrSetAll.argtypes = [POINTER(FrFile)]
    FrSetAll.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 709
if _libs["libPyFd.so"].has("FrSetBAT", "cdecl"):
    FrSetBAT = _libs["libPyFd.so"].get("FrSetBAT", "cdecl")
    FrSetBAT.argtypes = [POINTER(FrFile), c_uint, POINTER(None)]
    FrSetBAT.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 710
if _libs["libPyFd.so"].has("FrSetBRT", "cdecl"):
    FrSetBRT = _libs["libPyFd.so"].get("FrSetBRT", "cdecl")
    FrSetBRT.argtypes = [POINTER(FrFile), c_uint, c_ushort, POINTER(None)]
    FrSetBRT.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 712
if _libs["libPyFd.so"].has("FrSetIni", "cdecl"):
    FrSetIni = _libs["libPyFd.so"].get("FrSetIni", "cdecl")
    FrSetIni.argtypes = [POINTER(FrFile)]
    FrSetIni.restype = None

struct_FrMsg.__slots__ = [
    'classe',
    'alarm',
    'dummy1',
    'dummy2',
    'next',
    'nextOld',
    'message',
    'severity',
    'GTimeS',
    'GTimeN',
]
struct_FrMsg._fields_ = [
    ('classe', POINTER(FrSH)),
    ('alarm', String),
    ('dummy1', POINTER(FrVect)),
    ('dummy2', POINTER(FrVect)),
    ('next', POINTER(FrMsg)),
    ('nextOld', POINTER(FrMsg)),
    ('message', String),
    ('severity', c_uint),
    ('GTimeS', c_uint),
    ('GTimeN', c_uint),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 729
if _libs["libPyFd.so"].has("FrMsgAdd", "cdecl"):
    FrMsgAdd = _libs["libPyFd.so"].get("FrMsgAdd", "cdecl")
    FrMsgAdd.argtypes = [POINTER(FrameH), String, String, c_uint]
    FrMsgAdd.restype = POINTER(FrMsg)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 731
if _libs["libPyFd.so"].has("FrMsgDef", "cdecl"):
    FrMsgDef = _libs["libPyFd.so"].get("FrMsgDef", "cdecl")
    FrMsgDef.argtypes = []
    FrMsgDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 732
if _libs["libPyFd.so"].has("FrMsgDump", "cdecl"):
    FrMsgDump = _libs["libPyFd.so"].get("FrMsgDump", "cdecl")
    FrMsgDump.argtypes = [POINTER(FrMsg), POINTER(FILE), c_int]
    FrMsgDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 733
if _libs["libPyFd.so"].has("FrMsgFind", "cdecl"):
    FrMsgFind = _libs["libPyFd.so"].get("FrMsgFind", "cdecl")
    FrMsgFind.argtypes = [POINTER(FrameH), String, POINTER(FrMsg)]
    FrMsgFind.restype = POINTER(FrMsg)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 734
if _libs["libPyFd.so"].has("FrMsgFree", "cdecl"):
    FrMsgFree = _libs["libPyFd.so"].get("FrMsgFree", "cdecl")
    FrMsgFree.argtypes = [POINTER(FrMsg)]
    FrMsgFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 735
if _libs["libPyFd.so"].has("FrMsgFreeOne", "cdecl"):
    FrMsgFreeOne = _libs["libPyFd.so"].get("FrMsgFreeOne", "cdecl")
    FrMsgFreeOne.argtypes = [POINTER(FrMsg)]
    FrMsgFreeOne.restype = POINTER(FrMsg)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 736
if _libs["libPyFd.so"].has("FrMsgRead", "cdecl"):
    FrMsgRead = _libs["libPyFd.so"].get("FrMsgRead", "cdecl")
    FrMsgRead.argtypes = [POINTER(FrFile)]
    FrMsgRead.restype = POINTER(FrMsg)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 737
if _libs["libPyFd.so"].has("FrMsgWrite", "cdecl"):
    FrMsgWrite = _libs["libPyFd.so"].get("FrMsgWrite", "cdecl")
    FrMsgWrite.argtypes = [POINTER(FrMsg), POINTER(FrFile)]
    FrMsgWrite.restype = None

struct_FrObject.__slots__ = [
    'classe',
    'name',
]
struct_FrObject._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 744
if _libs["libPyFd.so"].has("FrObjectDef", "cdecl"):
    FrObjectDef = _libs["libPyFd.so"].get("FrObjectDef", "cdecl")
    FrObjectDef.argtypes = []
    FrObjectDef.restype = POINTER(FrSH)

struct_FrProcData.__slots__ = [
    'classe',
    'name',
    'data',
    'aux',
    'next',
    'nextOld',
    'type',
    'subType',
    'comment',
    'timeOffset',
    'tRange',
    'fShift',
    'phase',
    'fRange',
    'BW',
    'nAuxParam',
    'auxParam',
    'auxParamNames',
    'table',
    'history',
]
struct_FrProcData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('aux', POINTER(FrVect)),
    ('next', POINTER(FrProcData)),
    ('nextOld', POINTER(FrProcData)),
    ('type', c_ushort),
    ('subType', c_ushort),
    ('comment', String),
    ('timeOffset', c_double),
    ('tRange', c_double),
    ('fShift', c_double),
    ('phase', c_float),
    ('fRange', c_double),
    ('BW', c_double),
    ('nAuxParam', c_ushort),
    ('auxParam', POINTER(c_double)),
    ('auxParamNames', POINTER(POINTER(c_char))),
    ('table', POINTER(FrTable)),
    ('history', POINTER(FrHistory)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 775
if _libs["libPyFd.so"].has("FrProcDataAddHistory", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrProcDataAddHistory", "cdecl")
    _restype = POINTER(FrHistory)
    _errcheck = None
    _argtypes = [POINTER(FrProcData), String, c_int]
    FrProcDataAddHistory = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 776
if _libs["libPyFd.so"].has("FrProcDataAddParam", "cdecl"):
    FrProcDataAddParam = _libs["libPyFd.so"].get("FrProcDataAddParam", "cdecl")
    FrProcDataAddParam.argtypes = [POINTER(FrProcData), String, c_double]
    FrProcDataAddParam.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 777
if _libs["libPyFd.so"].has("FrProcDataAttachVect", "cdecl"):
    FrProcDataAttachVect = _libs["libPyFd.so"].get("FrProcDataAttachVect", "cdecl")
    FrProcDataAttachVect.argtypes = [POINTER(FrProcData), POINTER(FrVect)]
    FrProcDataAttachVect.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 778
if _libs["libPyFd.so"].has("FrProcDataCopy", "cdecl"):
    FrProcDataCopy = _libs["libPyFd.so"].get("FrProcDataCopy", "cdecl")
    FrProcDataCopy.argtypes = [POINTER(FrProcData), POINTER(FrameH)]
    FrProcDataCopy.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 779
if _libs["libPyFd.so"].has("FrProcDataDef", "cdecl"):
    FrProcDataDef = _libs["libPyFd.so"].get("FrProcDataDef", "cdecl")
    FrProcDataDef.argtypes = []
    FrProcDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 780
if _libs["libPyFd.so"].has("FrProcDataDump", "cdecl"):
    FrProcDataDump = _libs["libPyFd.so"].get("FrProcDataDump", "cdecl")
    FrProcDataDump.argtypes = [POINTER(FrProcData), POINTER(FILE), c_int]
    FrProcDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 781
if _libs["libPyFd.so"].has("FrProcDataFind", "cdecl"):
    FrProcDataFind = _libs["libPyFd.so"].get("FrProcDataFind", "cdecl")
    FrProcDataFind.argtypes = [POINTER(FrameH), String]
    FrProcDataFind.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 782
if _libs["libPyFd.so"].has("FrProcDataFindVect", "cdecl"):
    FrProcDataFindVect = _libs["libPyFd.so"].get("FrProcDataFindVect", "cdecl")
    FrProcDataFindVect.argtypes = [POINTER(FrProcData), String]
    FrProcDataFindVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 783
if _libs["libPyFd.so"].has("FrProcDataFree", "cdecl"):
    FrProcDataFree = _libs["libPyFd.so"].get("FrProcDataFree", "cdecl")
    FrProcDataFree.argtypes = [POINTER(FrProcData)]
    FrProcDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 784
if _libs["libPyFd.so"].has("FrProcDataFreeOne", "cdecl"):
    FrProcDataFreeOne = _libs["libPyFd.so"].get("FrProcDataFreeOne", "cdecl")
    FrProcDataFreeOne.argtypes = [POINTER(FrProcData)]
    FrProcDataFreeOne.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 785
if _libs["libPyFd.so"].has("FrProcDataGetParam", "cdecl"):
    FrProcDataGetParam = _libs["libPyFd.so"].get("FrProcDataGetParam", "cdecl")
    FrProcDataGetParam.argtypes = [POINTER(FrProcData), String]
    FrProcDataGetParam.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 786
if _libs["libPyFd.so"].has("FrProcDataGetParamId", "cdecl"):
    FrProcDataGetParamId = _libs["libPyFd.so"].get("FrProcDataGetParamId", "cdecl")
    FrProcDataGetParamId.argtypes = [POINTER(FrProcData), String]
    FrProcDataGetParamId.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 787
if _libs["libPyFd.so"].has("FrProcDataNew", "cdecl"):
    FrProcDataNew = _libs["libPyFd.so"].get("FrProcDataNew", "cdecl")
    FrProcDataNew.argtypes = [POINTER(FrameH), String, c_double, FRLONG, c_int]
    FrProcDataNew.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 789
if _libs["libPyFd.so"].has("FrProcDataNewV", "cdecl"):
    FrProcDataNewV = _libs["libPyFd.so"].get("FrProcDataNewV", "cdecl")
    FrProcDataNewV.argtypes = [POINTER(FrameH), POINTER(FrVect)]
    FrProcDataNewV.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 790
if _libs["libPyFd.so"].has("FrProcDataNewVT", "cdecl"):
    FrProcDataNewVT = _libs["libPyFd.so"].get("FrProcDataNewVT", "cdecl")
    FrProcDataNewVT.argtypes = [POINTER(FrameH), POINTER(FrVect), c_int]
    FrProcDataNewVT.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 791
if _libs["libPyFd.so"].has("FrProcDataRead", "cdecl"):
    FrProcDataRead = _libs["libPyFd.so"].get("FrProcDataRead", "cdecl")
    FrProcDataRead.argtypes = [POINTER(FrFile)]
    FrProcDataRead.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 792
if _libs["libPyFd.so"].has("FrProcDataReadT", "cdecl"):
    FrProcDataReadT = _libs["libPyFd.so"].get("FrProcDataReadT", "cdecl")
    FrProcDataReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrProcDataReadT.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 793
if _libs["libPyFd.so"].has("FrProcDataWrite", "cdecl"):
    FrProcDataWrite = _libs["libPyFd.so"].get("FrProcDataWrite", "cdecl")
    FrProcDataWrite.argtypes = [POINTER(FrProcData), POINTER(FrFile)]
    FrProcDataWrite.restype = None

struct_FrRawData.__slots__ = [
    'classe',
    'name',
    'firstSer',
    'firstAdc',
    'firstTable',
    'logMsg',
    'more',
    'firstAdcOld',
    'firstSerOld',
    'logMsgOld',
]
struct_FrRawData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('firstSer', POINTER(FrSerData)),
    ('firstAdc', POINTER(FrAdcData)),
    ('firstTable', POINTER(FrTable)),
    ('logMsg', POINTER(FrMsg)),
    ('more', POINTER(FrVect)),
    ('firstAdcOld', POINTER(FrAdcData)),
    ('firstSerOld', POINTER(FrSerData)),
    ('logMsgOld', POINTER(FrMsg)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 809
if _libs["libPyFd.so"].has("FrRawDataDef", "cdecl"):
    FrRawDataDef = _libs["libPyFd.so"].get("FrRawDataDef", "cdecl")
    FrRawDataDef.argtypes = []
    FrRawDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 810
if _libs["libPyFd.so"].has("FrRawDataDump", "cdecl"):
    FrRawDataDump = _libs["libPyFd.so"].get("FrRawDataDump", "cdecl")
    FrRawDataDump.argtypes = [POINTER(FrRawData), POINTER(FILE), c_int]
    FrRawDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 811
if _libs["libPyFd.so"].has("FrRawDataFree", "cdecl"):
    FrRawDataFree = _libs["libPyFd.so"].get("FrRawDataFree", "cdecl")
    FrRawDataFree.argtypes = [POINTER(FrRawData)]
    FrRawDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 812
if _libs["libPyFd.so"].has("FrRawDataNew", "cdecl"):
    FrRawDataNew = _libs["libPyFd.so"].get("FrRawDataNew", "cdecl")
    FrRawDataNew.argtypes = [POINTER(FrameH)]
    FrRawDataNew.restype = POINTER(FrRawData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 813
if _libs["libPyFd.so"].has("FrRawDataRead", "cdecl"):
    FrRawDataRead = _libs["libPyFd.so"].get("FrRawDataRead", "cdecl")
    FrRawDataRead.argtypes = [POINTER(FrFile)]
    FrRawDataRead.restype = POINTER(FrRawData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 814
if _libs["libPyFd.so"].has("FrRawDataUntagAdc", "cdecl"):
    FrRawDataUntagAdc = _libs["libPyFd.so"].get("FrRawDataUntagAdc", "cdecl")
    FrRawDataUntagAdc.argtypes = [POINTER(FrRawData)]
    FrRawDataUntagAdc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 815
if _libs["libPyFd.so"].has("FrRawDataUntagMsg", "cdecl"):
    FrRawDataUntagMsg = _libs["libPyFd.so"].get("FrRawDataUntagMsg", "cdecl")
    FrRawDataUntagMsg.argtypes = [POINTER(FrRawData)]
    FrRawDataUntagMsg.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 816
if _libs["libPyFd.so"].has("FrRawDataUntagSer", "cdecl"):
    FrRawDataUntagSer = _libs["libPyFd.so"].get("FrRawDataUntagSer", "cdecl")
    FrRawDataUntagSer.argtypes = [POINTER(FrRawData)]
    FrRawDataUntagSer.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 817
if _libs["libPyFd.so"].has("FrRawDataWrite", "cdecl"):
    FrRawDataWrite = _libs["libPyFd.so"].get("FrRawDataWrite", "cdecl")
    FrRawDataWrite.argtypes = [POINTER(FrRawData), POINTER(FrFile)]
    FrRawDataWrite.restype = None

struct_FrSE.__slots__ = [
    'classe',
    'name',
    'type',
    'comment',
    'next',
]
struct_FrSE._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('type', String),
    ('comment', String),
    ('next', POINTER(FrSE)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 827
if _libs["libPyFd.so"].has("FrSEDef", "cdecl"):
    FrSEDef = _libs["libPyFd.so"].get("FrSEDef", "cdecl")
    FrSEDef.argtypes = []
    FrSEDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 828
if _libs["libPyFd.so"].has("FrSENew", "cdecl"):
    FrSENew = _libs["libPyFd.so"].get("FrSENew", "cdecl")
    FrSENew.argtypes = [POINTER(FrSH), String, String, String]
    FrSENew.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 829
if _libs["libPyFd.so"].has("FrSERead", "cdecl"):
    FrSERead = _libs["libPyFd.so"].get("FrSERead", "cdecl")
    FrSERead.argtypes = [POINTER(FrFile)]
    FrSERead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 830
if _libs["libPyFd.so"].has("FrSEWrite", "cdecl"):
    FrSEWrite = _libs["libPyFd.so"].get("FrSEWrite", "cdecl")
    FrSEWrite.argtypes = [POINTER(FrSE), POINTER(FrFile)]
    FrSEWrite.restype = None

struct_FrSegList.__slots__ = [
    'name',
    'tStart',
    'tEnd',
    'next',
]
struct_FrSegList._fields_ = [
    ('name', String),
    ('tStart', POINTER(FrVect)),
    ('tEnd', POINTER(FrVect)),
    ('next', POINTER(FrSegList)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 839
if _libs["libPyFd.so"].has("FrSegListAdd", "cdecl"):
    FrSegListAdd = _libs["libPyFd.so"].get("FrSegListAdd", "cdecl")
    FrSegListAdd.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListAdd.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 840
if _libs["libPyFd.so"].has("FrSegListBuildVect", "cdecl"):
    FrSegListBuildVect = _libs["libPyFd.so"].get("FrSegListBuildVect", "cdecl")
    FrSegListBuildVect.argtypes = [POINTER(FrSegList), c_double, c_double, c_int]
    FrSegListBuildVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 842
if _libs["libPyFd.so"].has("FrSegListCoverage", "cdecl"):
    FrSegListCoverage = _libs["libPyFd.so"].get("FrSegListCoverage", "cdecl")
    FrSegListCoverage.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListCoverage.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 843
if _libs["libPyFd.so"].has("FrSegListDump", "cdecl"):
    FrSegListDump = _libs["libPyFd.so"].get("FrSegListDump", "cdecl")
    FrSegListDump.argtypes = [POINTER(FrSegList), POINTER(FILE), c_int]
    FrSegListDump.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 844
if _libs["libPyFd.so"].has("FrSegListFind", "cdecl"):
    FrSegListFind = _libs["libPyFd.so"].get("FrSegListFind", "cdecl")
    FrSegListFind.argtypes = [POINTER(FrSegList), c_double]
    FrSegListFind.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 845
if _libs["libPyFd.so"].has("FrSegListFindFirst", "cdecl"):
    FrSegListFindFirst = _libs["libPyFd.so"].get("FrSegListFindFirst", "cdecl")
    FrSegListFindFirst.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListFindFirst.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 846
if _libs["libPyFd.so"].has("FrSegListFindFirstT", "cdecl"):
    FrSegListFindFirstT = _libs["libPyFd.so"].get("FrSegListFindFirstT", "cdecl")
    FrSegListFindFirstT.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListFindFirstT.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 847
if _libs["libPyFd.so"].has("FrSegListFindLastT", "cdecl"):
    FrSegListFindLastT = _libs["libPyFd.so"].get("FrSegListFindLastT", "cdecl")
    FrSegListFindLastT.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListFindLastT.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 848
if _libs["libPyFd.so"].has("FrSegListFree", "cdecl"):
    FrSegListFree = _libs["libPyFd.so"].get("FrSegListFree", "cdecl")
    FrSegListFree.argtypes = [POINTER(FrSegList)]
    FrSegListFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 849
if _libs["libPyFd.so"].has("FrSegListIntersect", "cdecl"):
    FrSegListIntersect = _libs["libPyFd.so"].get("FrSegListIntersect", "cdecl")
    FrSegListIntersect.argtypes = [POINTER(FrSegList), POINTER(FrSegList)]
    FrSegListIntersect.restype = POINTER(FrSegList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 850
if _libs["libPyFd.so"].has("FrSegListNew", "cdecl"):
    FrSegListNew = _libs["libPyFd.so"].get("FrSegListNew", "cdecl")
    FrSegListNew.argtypes = [String]
    FrSegListNew.restype = POINTER(FrSegList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 851
if _libs["libPyFd.so"].has("FrSegListPrint", "cdecl"):
    FrSegListPrint = _libs["libPyFd.so"].get("FrSegListPrint", "cdecl")
    FrSegListPrint.argtypes = [POINTER(FrSegList), String]
    FrSegListPrint.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 852
if _libs["libPyFd.so"].has("FrSegListRead", "cdecl"):
    FrSegListRead = _libs["libPyFd.so"].get("FrSegListRead", "cdecl")
    FrSegListRead.argtypes = [String]
    FrSegListRead.restype = POINTER(FrSegList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 853
if _libs["libPyFd.so"].has("FrSegListReadFP", "cdecl"):
    FrSegListReadFP = _libs["libPyFd.so"].get("FrSegListReadFP", "cdecl")
    FrSegListReadFP.argtypes = [POINTER(FILE), String]
    FrSegListReadFP.restype = POINTER(FrSegList)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 854
if _libs["libPyFd.so"].has("FrSegListShrink", "cdecl"):
    FrSegListShrink = _libs["libPyFd.so"].get("FrSegListShrink", "cdecl")
    FrSegListShrink.argtypes = [POINTER(FrSegList), c_double, c_double]
    FrSegListShrink.restype = c_int

struct_FrSerData.__slots__ = [
    'classe',
    'name',
    'serial',
    'table',
    'next',
    'nextOld',
    'timeSec',
    'timeNsec',
    'sampleRate',
    'data',
]
struct_FrSerData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('serial', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrSerData)),
    ('nextOld', POINTER(FrSerData)),
    ('timeSec', c_uint),
    ('timeNsec', c_uint),
    ('sampleRate', c_double),
    ('data', String),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 871
if _libs["libPyFd.so"].has("FrSerDataDef", "cdecl"):
    FrSerDataDef = _libs["libPyFd.so"].get("FrSerDataDef", "cdecl")
    FrSerDataDef.argtypes = []
    FrSerDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 872
if _libs["libPyFd.so"].has("FrSerDataDump", "cdecl"):
    FrSerDataDump = _libs["libPyFd.so"].get("FrSerDataDump", "cdecl")
    FrSerDataDump.argtypes = [POINTER(FrSerData), POINTER(FILE), c_int]
    FrSerDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 873
if _libs["libPyFd.so"].has("FrSerDataFind", "cdecl"):
    FrSerDataFind = _libs["libPyFd.so"].get("FrSerDataFind", "cdecl")
    FrSerDataFind.argtypes = [POINTER(FrameH), String, POINTER(FrSerData)]
    FrSerDataFind.restype = POINTER(FrSerData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 874
if _libs["libPyFd.so"].has("FrSerDataFree", "cdecl"):
    FrSerDataFree = _libs["libPyFd.so"].get("FrSerDataFree", "cdecl")
    FrSerDataFree.argtypes = [POINTER(FrSerData)]
    FrSerDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 877
if _libs["libPyFd.so"].has("FrSerDataGetValue", "cdecl"):
    FrSerDataGetValue = _libs["libPyFd.so"].get("FrSerDataGetValue", "cdecl")
    FrSerDataGetValue.argtypes = [POINTER(FrameH), String, String, c_double]
    FrSerDataGetValue.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 879
if _libs["libPyFd.so"].has("FrSerDataNew", "cdecl"):
    FrSerDataNew = _libs["libPyFd.so"].get("FrSerDataNew", "cdecl")
    FrSerDataNew.argtypes = [POINTER(FrameH), String, c_double, String, c_double]
    FrSerDataNew.restype = POINTER(FrSerData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 881
if _libs["libPyFd.so"].has("FrSerDataRead", "cdecl"):
    FrSerDataRead = _libs["libPyFd.so"].get("FrSerDataRead", "cdecl")
    FrSerDataRead.argtypes = [POINTER(FrFile)]
    FrSerDataRead.restype = POINTER(FrSerData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 882
if _libs["libPyFd.so"].has("FrSerDataReadT", "cdecl"):
    FrSerDataReadT = _libs["libPyFd.so"].get("FrSerDataReadT", "cdecl")
    FrSerDataReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrSerDataReadT.restype = POINTER(FrSerData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 883
if _libs["libPyFd.so"].has("FrSerDataWrite", "cdecl"):
    FrSerDataWrite = _libs["libPyFd.so"].get("FrSerDataWrite", "cdecl")
    FrSerDataWrite.argtypes = [POINTER(FrSerData), POINTER(FrFile)]
    FrSerDataWrite.restype = None

struct_FrSH.__slots__ = [
    'classe',
    'name',
    'id',
    'comment',
    'nBytes',
    'nInstances',
    'firstE',
    'objRead',
    'nSE',
    'shRef',
]
struct_FrSH._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('id', c_ushort),
    ('comment', String),
    ('nBytes', FRLONG),
    ('nInstances', c_int),
    ('firstE', POINTER(FrSE)),
    ('objRead', CFUNCTYPE(UNCHECKED(None), POINTER(FrFile))),
    ('nSE', c_int),
    ('shRef', POINTER(FrSH)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 899
if _libs["libPyFd.so"].has("FrSHDef", "cdecl"):
    FrSHDef = _libs["libPyFd.so"].get("FrSHDef", "cdecl")
    FrSHDef.argtypes = []
    FrSHDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 900
if _libs["libPyFd.so"].has("FrSHMatch", "cdecl"):
    FrSHMatch = _libs["libPyFd.so"].get("FrSHMatch", "cdecl")
    FrSHMatch.argtypes = [POINTER(FrFile)]
    FrSHMatch.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 901
if _libs["libPyFd.so"].has("FrSHNew", "cdecl"):
    FrSHNew = _libs["libPyFd.so"].get("FrSHNew", "cdecl")
    FrSHNew.argtypes = [String, String]
    FrSHNew.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 902
if _libs["libPyFd.so"].has("FrSHRead", "cdecl"):
    FrSHRead = _libs["libPyFd.so"].get("FrSHRead", "cdecl")
    FrSHRead.argtypes = [POINTER(FrFile)]
    FrSHRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 903
if _libs["libPyFd.so"].has("FrSHWrite", "cdecl"):
    FrSHWrite = _libs["libPyFd.so"].get("FrSHWrite", "cdecl")
    FrSHWrite.argtypes = [POINTER(FrSH), POINTER(FrFile)]
    FrSHWrite.restype = None

struct_FrSimData.__slots__ = [
    'classe',
    'name',
    'data',
    'input',
    'next',
    'nextOld',
    'comment',
    'sampleRate',
    'timeOffset',
    'fShift',
    'phase',
    'table',
]
struct_FrSimData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('input', POINTER(FrVect)),
    ('next', POINTER(FrSimData)),
    ('nextOld', POINTER(FrSimData)),
    ('comment', String),
    ('sampleRate', c_double),
    ('timeOffset', c_double),
    ('fShift', c_double),
    ('phase', c_float),
    ('table', POINTER(FrTable)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 923
if _libs["libPyFd.so"].has("FrSimDataDef", "cdecl"):
    FrSimDataDef = _libs["libPyFd.so"].get("FrSimDataDef", "cdecl")
    FrSimDataDef.argtypes = []
    FrSimDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 924
if _libs["libPyFd.so"].has("FrSimDataDump", "cdecl"):
    FrSimDataDump = _libs["libPyFd.so"].get("FrSimDataDump", "cdecl")
    FrSimDataDump.argtypes = [POINTER(FrSimData), POINTER(FILE), c_int]
    FrSimDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 925
if _libs["libPyFd.so"].has("FrSimDataFind", "cdecl"):
    FrSimDataFind = _libs["libPyFd.so"].get("FrSimDataFind", "cdecl")
    FrSimDataFind.argtypes = [POINTER(FrameH), String]
    FrSimDataFind.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 926
if _libs["libPyFd.so"].has("FrSimDataFree", "cdecl"):
    FrSimDataFree = _libs["libPyFd.so"].get("FrSimDataFree", "cdecl")
    FrSimDataFree.argtypes = [POINTER(FrSimData)]
    FrSimDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 927
if _libs["libPyFd.so"].has("FrSimDataFreeOne", "cdecl"):
    FrSimDataFreeOne = _libs["libPyFd.so"].get("FrSimDataFreeOne", "cdecl")
    FrSimDataFreeOne.argtypes = [POINTER(FrSimData)]
    FrSimDataFreeOne.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 928
if _libs["libPyFd.so"].has("FrSimDataNew", "cdecl"):
    FrSimDataNew = _libs["libPyFd.so"].get("FrSimDataNew", "cdecl")
    FrSimDataNew.argtypes = [POINTER(FrameH), String, c_double, FRLONG, c_int]
    FrSimDataNew.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 930
if _libs["libPyFd.so"].has("FrSimDataRead", "cdecl"):
    FrSimDataRead = _libs["libPyFd.so"].get("FrSimDataRead", "cdecl")
    FrSimDataRead.argtypes = [POINTER(FrFile)]
    FrSimDataRead.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 931
if _libs["libPyFd.so"].has("FrSimDataReadT", "cdecl"):
    FrSimDataReadT = _libs["libPyFd.so"].get("FrSimDataReadT", "cdecl")
    FrSimDataReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrSimDataReadT.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 932
if _libs["libPyFd.so"].has("FrSimDataWrite", "cdecl"):
    FrSimDataWrite = _libs["libPyFd.so"].get("FrSimDataWrite", "cdecl")
    FrSimDataWrite.argtypes = [POINTER(FrSimData), POINTER(FrFile)]
    FrSimDataWrite.restype = None

struct_FrSimEvent.__slots__ = [
    'classe',
    'name',
    'data',
    'table',
    'next',
    'nextOld',
    'comment',
    'inputs',
    'GTimeS',
    'GTimeN',
    'timeBefore',
    'timeAfter',
    'amplitude',
    'nParam',
    'parameters',
    'parameterNames',
]
struct_FrSimEvent._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrSimEvent)),
    ('nextOld', POINTER(FrSimEvent)),
    ('comment', String),
    ('inputs', String),
    ('GTimeS', c_uint),
    ('GTimeN', c_uint),
    ('timeBefore', c_float),
    ('timeAfter', c_float),
    ('amplitude', c_float),
    ('nParam', c_ushort),
    ('parameters', POINTER(c_double)),
    ('parameterNames', POINTER(POINTER(c_char))),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 954
if _libs["libPyFd.so"].has("FrSimEventAddParam", "cdecl"):
    FrSimEventAddParam = _libs["libPyFd.so"].get("FrSimEventAddParam", "cdecl")
    FrSimEventAddParam.argtypes = [POINTER(FrSimEvent), String, c_double]
    FrSimEventAddParam.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 955
if _libs["libPyFd.so"].has("FrSimEventAddVect", "cdecl"):
    FrSimEventAddVect = _libs["libPyFd.so"].get("FrSimEventAddVect", "cdecl")
    FrSimEventAddVect.argtypes = [POINTER(FrSimEvent), POINTER(FrVect), String]
    FrSimEventAddVect.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 956
if _libs["libPyFd.so"].has("FrSimEventAddVectF", "cdecl"):
    FrSimEventAddVectF = _libs["libPyFd.so"].get("FrSimEventAddVectF", "cdecl")
    FrSimEventAddVectF.argtypes = [POINTER(FrSimEvent), POINTER(FrVect), String]
    FrSimEventAddVectF.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 958
if _libs["libPyFd.so"].has("FrSimEventCopy", "cdecl"):
    FrSimEventCopy = _libs["libPyFd.so"].get("FrSimEventCopy", "cdecl")
    FrSimEventCopy.argtypes = [POINTER(FrSimEvent)]
    FrSimEventCopy.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 959
if _libs["libPyFd.so"].has("FrSimEventDef", "cdecl"):
    FrSimEventDef = _libs["libPyFd.so"].get("FrSimEventDef", "cdecl")
    FrSimEventDef.argtypes = []
    FrSimEventDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 960
if _libs["libPyFd.so"].has("FrSimEventDump", "cdecl"):
    FrSimEventDump = _libs["libPyFd.so"].get("FrSimEventDump", "cdecl")
    FrSimEventDump.argtypes = [POINTER(FrSimEvent), POINTER(FILE), c_int]
    FrSimEventDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 961
if _libs["libPyFd.so"].has("FrSimEventFind", "cdecl"):
    FrSimEventFind = _libs["libPyFd.so"].get("FrSimEventFind", "cdecl")
    FrSimEventFind.argtypes = [POINTER(FrameH), String, POINTER(FrSimEvent)]
    FrSimEventFind.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 962
if _libs["libPyFd.so"].has("FrSimEventFindVect", "cdecl"):
    FrSimEventFindVect = _libs["libPyFd.so"].get("FrSimEventFindVect", "cdecl")
    FrSimEventFindVect.argtypes = [POINTER(FrSimEvent), String]
    FrSimEventFindVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 963
if _libs["libPyFd.so"].has("FrSimEventFree", "cdecl"):
    FrSimEventFree = _libs["libPyFd.so"].get("FrSimEventFree", "cdecl")
    FrSimEventFree.argtypes = [POINTER(FrSimEvent)]
    FrSimEventFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 964
if _libs["libPyFd.so"].has("FrSimEventGetParam", "cdecl"):
    FrSimEventGetParam = _libs["libPyFd.so"].get("FrSimEventGetParam", "cdecl")
    FrSimEventGetParam.argtypes = [POINTER(FrSimEvent), String]
    FrSimEventGetParam.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 965
if _libs["libPyFd.so"].has("FrSimEventGetParamId", "cdecl"):
    FrSimEventGetParamId = _libs["libPyFd.so"].get("FrSimEventGetParamId", "cdecl")
    FrSimEventGetParamId.argtypes = [POINTER(FrSimEvent), String]
    FrSimEventGetParamId.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 966
if _libs["libPyFd.so"].has("FrSimEventGetVectD", "cdecl"):
    FrSimEventGetVectD = _libs["libPyFd.so"].get("FrSimEventGetVectD", "cdecl")
    FrSimEventGetVectD.argtypes = [POINTER(FrSimEvent), String]
    FrSimEventGetVectD.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 967
if _libs["libPyFd.so"].has("FrSimEventGetVectF", "cdecl"):
    FrSimEventGetVectF = _libs["libPyFd.so"].get("FrSimEventGetVectF", "cdecl")
    FrSimEventGetVectF.argtypes = [POINTER(FrSimEvent), String]
    FrSimEventGetVectF.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 968
if _libs["libPyFd.so"].has("FrSimEventNew", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrSimEventNew", "cdecl")
    _restype = POINTER(FrSimEvent)
    _errcheck = None
    _argtypes = [POINTER(FrameH), String, String, String, c_double, c_float, c_float, c_float, c_int]
    FrSimEventNew = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 971
if _libs["libPyFd.so"].has("FrSimEventRead", "cdecl"):
    FrSimEventRead = _libs["libPyFd.so"].get("FrSimEventRead", "cdecl")
    FrSimEventRead.argtypes = [POINTER(FrFile)]
    FrSimEventRead.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 972
if _libs["libPyFd.so"].has("FrSimEventReadData", "cdecl"):
    FrSimEventReadData = _libs["libPyFd.so"].get("FrSimEventReadData", "cdecl")
    FrSimEventReadData.argtypes = [POINTER(FrFile), POINTER(FrSimEvent)]
    FrSimEventReadData.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 973
if _libs["libPyFd.so"].has("FrSimEventReadT", "cdecl"):
    FrSimEventReadT = _libs["libPyFd.so"].get("FrSimEventReadT", "cdecl")
    FrSimEventReadT.argtypes = [POINTER(FrFile), String, c_double, c_double, c_double, c_double]
    FrSimEventReadT.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 975
if _libs["libPyFd.so"].has("FrSimEventReadTF", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrSimEventReadTF", "cdecl")
    _restype = POINTER(FrSimEvent)
    _errcheck = None
    _argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, c_int]
    FrSimEventReadTF = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 977
if _libs["libPyFd.so"].has("FrSimEventReadTF1", "cdecl"):
    FrSimEventReadTF1 = _libs["libPyFd.so"].get("FrSimEventReadTF1", "cdecl")
    FrSimEventReadTF1.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double]
    FrSimEventReadTF1.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 980
if _libs["libPyFd.so"].has("FrSimEventReadTF2", "cdecl"):
    FrSimEventReadTF2 = _libs["libPyFd.so"].get("FrSimEventReadTF2", "cdecl")
    FrSimEventReadTF2.argtypes = [POINTER(FrFile), String, c_double, c_double, c_int, String, c_double, c_double, String, c_double, c_double]
    FrSimEventReadTF2.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 984
if _libs["libPyFd.so"].has("FrSimEventSetParam", "cdecl"):
    FrSimEventSetParam = _libs["libPyFd.so"].get("FrSimEventSetParam", "cdecl")
    FrSimEventSetParam.argtypes = [POINTER(FrSimEvent), String, c_double]
    FrSimEventSetParam.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 985
if _libs["libPyFd.so"].has("FrSimEventUpdateTime", "cdecl"):
    FrSimEventUpdateTime = _libs["libPyFd.so"].get("FrSimEventUpdateTime", "cdecl")
    FrSimEventUpdateTime.argtypes = [POINTER(FrSimEvent), c_double]
    FrSimEventUpdateTime.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 986
if _libs["libPyFd.so"].has("FrSimEventWrite", "cdecl"):
    FrSimEventWrite = _libs["libPyFd.so"].get("FrSimEventWrite", "cdecl")
    FrSimEventWrite.argtypes = [POINTER(FrSimEvent), POINTER(FrFile)]
    FrSimEventWrite.restype = None

struct_FrStatData.__slots__ = [
    'classe',
    'name',
    'data',
    'table',
    'next',
    'nextOld',
    'comment',
    'representation',
    'timeStart',
    'timeEnd',
    'version',
    'detector',
    'overlap',
    'detName',
]
struct_FrStatData._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('data', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrStatData)),
    ('nextOld', POINTER(FrStatData)),
    ('comment', String),
    ('representation', String),
    ('timeStart', c_uint),
    ('timeEnd', c_uint),
    ('version', c_uint),
    ('detector', POINTER(FrDetector)),
    ('overlap', c_int),
    ('detName', String),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1010
if _libs["libPyFd.so"].has("FrStatDataAdd", "cdecl"):
    FrStatDataAdd = _libs["libPyFd.so"].get("FrStatDataAdd", "cdecl")
    FrStatDataAdd.argtypes = [POINTER(FrDetector), POINTER(FrStatData)]
    FrStatDataAdd.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1011
if _libs["libPyFd.so"].has("FrStatDataAddR", "cdecl"):
    FrStatDataAddR = _libs["libPyFd.so"].get("FrStatDataAddR", "cdecl")
    FrStatDataAddR.argtypes = [POINTER(POINTER(FrStatData)), POINTER(FrStatData)]
    FrStatDataAddR.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1012
if _libs["libPyFd.so"].has("FrStatDataAddVect", "cdecl"):
    FrStatDataAddVect = _libs["libPyFd.so"].get("FrStatDataAddVect", "cdecl")
    FrStatDataAddVect.argtypes = [POINTER(FrStatData), POINTER(FrVect)]
    FrStatDataAddVect.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1013
if _libs["libPyFd.so"].has("FrStatDataChkT", "cdecl"):
    FrStatDataChkT = _libs["libPyFd.so"].get("FrStatDataChkT", "cdecl")
    FrStatDataChkT.argtypes = [POINTER(POINTER(FrStatData)), c_uint, c_uint]
    FrStatDataChkT.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1015
if _libs["libPyFd.so"].has("FrStatDataCopy", "cdecl"):
    FrStatDataCopy = _libs["libPyFd.so"].get("FrStatDataCopy", "cdecl")
    FrStatDataCopy.argtypes = [POINTER(FrStatData), POINTER(FrDetector)]
    FrStatDataCopy.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1016
if _libs["libPyFd.so"].has("FrStatDataDef", "cdecl"):
    FrStatDataDef = _libs["libPyFd.so"].get("FrStatDataDef", "cdecl")
    FrStatDataDef.argtypes = []
    FrStatDataDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1017
if _libs["libPyFd.so"].has("FrStatDataDump", "cdecl"):
    FrStatDataDump = _libs["libPyFd.so"].get("FrStatDataDump", "cdecl")
    FrStatDataDump.argtypes = [POINTER(FrStatData), POINTER(FILE), c_int]
    FrStatDataDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1018
if _libs["libPyFd.so"].has("FrStatDataFind", "cdecl"):
    FrStatDataFind = _libs["libPyFd.so"].get("FrStatDataFind", "cdecl")
    FrStatDataFind.argtypes = [POINTER(FrDetector), String, c_uint]
    FrStatDataFind.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1020
if _libs["libPyFd.so"].has("FrStatDataFree", "cdecl"):
    FrStatDataFree = _libs["libPyFd.so"].get("FrStatDataFree", "cdecl")
    FrStatDataFree.argtypes = [POINTER(FrStatData)]
    FrStatDataFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1021
if _libs["libPyFd.so"].has("FrStatDataFreeOne", "cdecl"):
    FrStatDataFreeOne = _libs["libPyFd.so"].get("FrStatDataFreeOne", "cdecl")
    FrStatDataFreeOne.argtypes = [POINTER(FrStatData)]
    FrStatDataFreeOne.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1022
if _libs["libPyFd.so"].has("FrStatDataNew", "cdecl"):
    FrStatDataNew = _libs["libPyFd.so"].get("FrStatDataNew", "cdecl")
    FrStatDataNew.argtypes = [String, String, String, c_uint, c_uint, c_uint, POINTER(FrVect), POINTER(FrTable)]
    FrStatDataNew.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1025
if _libs["libPyFd.so"].has("FrStatDataRead", "cdecl"):
    FrStatDataRead = _libs["libPyFd.so"].get("FrStatDataRead", "cdecl")
    FrStatDataRead.argtypes = [POINTER(FrFile)]
    FrStatDataRead.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1026
if _libs["libPyFd.so"].has("FrStatDataReadT", "cdecl"):
    FrStatDataReadT = _libs["libPyFd.so"].get("FrStatDataReadT", "cdecl")
    FrStatDataReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrStatDataReadT.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1027
if _libs["libPyFd.so"].has("FrStatDataRemove", "cdecl"):
    FrStatDataRemove = _libs["libPyFd.so"].get("FrStatDataRemove", "cdecl")
    FrStatDataRemove.argtypes = [POINTER(FrDetector), String]
    FrStatDataRemove.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1028
if _libs["libPyFd.so"].has("FrStatDataTouch", "cdecl"):
    FrStatDataTouch = _libs["libPyFd.so"].get("FrStatDataTouch", "cdecl")
    FrStatDataTouch.argtypes = [POINTER(FrStatData)]
    FrStatDataTouch.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1029
if _libs["libPyFd.so"].has("FrStatDataWrite", "cdecl"):
    FrStatDataWrite = _libs["libPyFd.so"].get("FrStatDataWrite", "cdecl")
    FrStatDataWrite.argtypes = [POINTER(FrStatData), POINTER(FrFile)]
    FrStatDataWrite.restype = None

struct_FrSummary.__slots__ = [
    'classe',
    'name',
    'moments',
    'table',
    'next',
    'nextOld',
    'comment',
    'test',
    'GTimeS',
    'GTimeN',
]
struct_FrSummary._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('moments', POINTER(FrVect)),
    ('table', POINTER(FrTable)),
    ('next', POINTER(FrSummary)),
    ('nextOld', POINTER(FrSummary)),
    ('comment', String),
    ('test', String),
    ('GTimeS', c_uint),
    ('GTimeN', c_uint),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1045
if _libs["libPyFd.so"].has("FrSummaryDef", "cdecl"):
    FrSummaryDef = _libs["libPyFd.so"].get("FrSummaryDef", "cdecl")
    FrSummaryDef.argtypes = []
    FrSummaryDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1046
if _libs["libPyFd.so"].has("FrSummaryDump", "cdecl"):
    FrSummaryDump = _libs["libPyFd.so"].get("FrSummaryDump", "cdecl")
    FrSummaryDump.argtypes = [POINTER(FrSummary), POINTER(FILE), c_int]
    FrSummaryDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1047
if _libs["libPyFd.so"].has("FrSummaryFind", "cdecl"):
    FrSummaryFind = _libs["libPyFd.so"].get("FrSummaryFind", "cdecl")
    FrSummaryFind.argtypes = [POINTER(FrameH), String]
    FrSummaryFind.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1048
if _libs["libPyFd.so"].has("FrSummaryFree", "cdecl"):
    FrSummaryFree = _libs["libPyFd.so"].get("FrSummaryFree", "cdecl")
    FrSummaryFree.argtypes = [POINTER(FrSummary)]
    FrSummaryFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1049
if _libs["libPyFd.so"].has("FrSummaryNew", "cdecl"):
    FrSummaryNew = _libs["libPyFd.so"].get("FrSummaryNew", "cdecl")
    FrSummaryNew.argtypes = [POINTER(FrameH), String, String, String, POINTER(FrVect), POINTER(FrTable)]
    FrSummaryNew.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1051
if _libs["libPyFd.so"].has("FrSummaryRead", "cdecl"):
    FrSummaryRead = _libs["libPyFd.so"].get("FrSummaryRead", "cdecl")
    FrSummaryRead.argtypes = [POINTER(FrFile)]
    FrSummaryRead.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1052
if _libs["libPyFd.so"].has("FrSummaryReadT", "cdecl"):
    FrSummaryReadT = _libs["libPyFd.so"].get("FrSummaryReadT", "cdecl")
    FrSummaryReadT.argtypes = [POINTER(FrFile), String, c_double]
    FrSummaryReadT.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1053
if _libs["libPyFd.so"].has("FrSummaryWrite", "cdecl"):
    FrSummaryWrite = _libs["libPyFd.so"].get("FrSummaryWrite", "cdecl")
    FrSummaryWrite.argtypes = [POINTER(FrSummary), POINTER(struct_FrFile)]
    FrSummaryWrite.restype = None

struct_FrTable.__slots__ = [
    'classe',
    'name',
    'comment',
    'nColumn',
    'nRow',
    'columnName',
    'column',
    'next',
]
struct_FrTable._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('comment', String),
    ('nColumn', c_ushort),
    ('nRow', c_uint),
    ('columnName', POINTER(POINTER(c_char))),
    ('column', POINTER(FrVect)),
    ('next', POINTER(FrTable)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1066
if _libs["libPyFd.so"].has("FrTableCompress", "cdecl"):
    FrTableCompress = _libs["libPyFd.so"].get("FrTableCompress", "cdecl")
    FrTableCompress.argtypes = [POINTER(FrTable), c_int, c_int]
    FrTableCompress.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1067
if _libs["libPyFd.so"].has("FrTableCopy", "cdecl"):
    FrTableCopy = _libs["libPyFd.so"].get("FrTableCopy", "cdecl")
    FrTableCopy.argtypes = [POINTER(FrTable)]
    FrTableCopy.restype = POINTER(FrTable)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1068
if _libs["libPyFd.so"].has("FrTableDef", "cdecl"):
    FrTableDef = _libs["libPyFd.so"].get("FrTableDef", "cdecl")
    FrTableDef.argtypes = []
    FrTableDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1069
if _libs["libPyFd.so"].has("FrTableDump", "cdecl"):
    FrTableDump = _libs["libPyFd.so"].get("FrTableDump", "cdecl")
    FrTableDump.argtypes = [POINTER(FrTable), POINTER(FILE), c_int]
    FrTableDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1070
if _libs["libPyFd.so"].has("FrTableExpand", "cdecl"):
    FrTableExpand = _libs["libPyFd.so"].get("FrTableExpand", "cdecl")
    FrTableExpand.argtypes = [POINTER(FrTable)]
    FrTableExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1071
if _libs["libPyFd.so"].has("FrTableGetCol", "cdecl"):
    FrTableGetCol = _libs["libPyFd.so"].get("FrTableGetCol", "cdecl")
    FrTableGetCol.argtypes = [POINTER(FrTable), String]
    FrTableGetCol.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1072
if _libs["libPyFd.so"].has("FrTableFree", "cdecl"):
    FrTableFree = _libs["libPyFd.so"].get("FrTableFree", "cdecl")
    FrTableFree.argtypes = [POINTER(FrTable)]
    FrTableFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1073
if _libs["libPyFd.so"].has("FrTableNew", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrTableNew", "cdecl")
    _restype = POINTER(FrTable)
    _errcheck = None
    _argtypes = [String, String, c_int, c_int]
    FrTableNew = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1074
if _libs["libPyFd.so"].has("FrTableRead", "cdecl"):
    FrTableRead = _libs["libPyFd.so"].get("FrTableRead", "cdecl")
    FrTableRead.argtypes = [POINTER(FrFile)]
    FrTableRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1075
if _libs["libPyFd.so"].has("FrTableWrite", "cdecl"):
    FrTableWrite = _libs["libPyFd.so"].get("FrTableWrite", "cdecl")
    FrTableWrite.argtypes = [POINTER(FrTable), POINTER(FrFile)]
    FrTableWrite.restype = None

struct_FrTag.__slots__ = [
    'start',
    'length',
    'next',
    'returnValue',
]
struct_FrTag._fields_ = [
    ('start', String),
    ('length', c_int),
    ('next', POINTER(FrTag)),
    ('returnValue', FRBOOL),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1084
if _libs["libPyFd.so"].has("FrTagFree", "cdecl"):
    FrTagFree = _libs["libPyFd.so"].get("FrTagFree", "cdecl")
    FrTagFree.argtypes = [POINTER(FrTag)]
    FrTagFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1085
if _libs["libPyFd.so"].has("FrTagGetSubTag", "cdecl"):
    FrTagGetSubTag = _libs["libPyFd.so"].get("FrTagGetSubTag", "cdecl")
    FrTagGetSubTag.argtypes = [String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        FrTagGetSubTag.restype = ReturnString
    else:
        FrTagGetSubTag.restype = String
        FrTagGetSubTag.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1086
if _libs["libPyFd.so"].has("FrTagMatch", "cdecl"):
    FrTagMatch = _libs["libPyFd.so"].get("FrTagMatch", "cdecl")
    FrTagMatch.argtypes = [POINTER(FrTag), String]
    FrTagMatch.restype = FRBOOL

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1087
if _libs["libPyFd.so"].has("FrTagMatch1", "cdecl"):
    FrTagMatch1 = _libs["libPyFd.so"].get("FrTagMatch1", "cdecl")
    FrTagMatch1.argtypes = [String, c_int, String, c_int]
    FrTagMatch1.restype = FRBOOL

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1088
if _libs["libPyFd.so"].has("FrTagNew", "cdecl"):
    FrTagNew = _libs["libPyFd.so"].get("FrTagNew", "cdecl")
    FrTagNew.argtypes = [String]
    FrTagNew.restype = POINTER(FrTag)

struct_FrTOC.__slots__ = [
    'classe',
    'ULeapS',
    'nFrame',
    'dataQuality',
    'GTimeS',
    'GTimeN',
    'dt',
    'runs',
    'frame',
    'positionH',
    'nFirstADC',
    'nFirstSer',
    'nFirstTable',
    'nFirstMsg',
    'nSH',
    'SHid',
    'SHidMax',
    'SHname',
    'detector',
    'nStatType',
    'stat',
    'adc',
    'proc',
    'sim',
    'ser',
    'summary',
    'adcH',
    'procH',
    'simH',
    'serH',
    'summaryH',
    'event',
    'simEvt',
    'maxFrame',
    'position',
]
struct_FrTOC._fields_ = [
    ('classe', POINTER(struct_FrSH)),
    ('ULeapS', c_short),
    ('nFrame', c_int),
    ('dataQuality', POINTER(c_uint)),
    ('GTimeS', POINTER(c_uint)),
    ('GTimeN', POINTER(c_uint)),
    ('dt', POINTER(c_double)),
    ('runs', POINTER(c_int)),
    ('frame', POINTER(c_int)),
    ('positionH', POINTER(FRULONG)),
    ('nFirstADC', POINTER(FRULONG)),
    ('nFirstSer', POINTER(FRULONG)),
    ('nFirstTable', POINTER(FRULONG)),
    ('nFirstMsg', POINTER(FRULONG)),
    ('nSH', c_uint),
    ('SHid', POINTER(c_ushort)),
    ('SHidMax', c_ushort),
    ('SHname', POINTER(POINTER(c_char))),
    ('detector', POINTER(FrTOCdet)),
    ('nStatType', c_int),
    ('stat', POINTER(FrTOCstat)),
    ('adc', POINTER(FrTOCts)),
    ('proc', POINTER(FrTOCts)),
    ('sim', POINTER(FrTOCts)),
    ('ser', POINTER(FrTOCts)),
    ('summary', POINTER(FrTOCts)),
    ('adcH', POINTER(FrTOCtsH)),
    ('procH', POINTER(FrTOCtsH)),
    ('simH', POINTER(FrTOCtsH)),
    ('serH', POINTER(FrTOCtsH)),
    ('summaryH', POINTER(FrTOCtsH)),
    ('event', POINTER(FrTOCevt)),
    ('simEvt', POINTER(FrTOCevt)),
    ('maxFrame', c_int),
    ('position', FRLONG),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1128
if _libs["libPyFd.so"].has("FrTOCDef", "cdecl"):
    FrTOCDef = _libs["libPyFd.so"].get("FrTOCDef", "cdecl")
    FrTOCDef.argtypes = []
    FrTOCDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1129
if _libs["libPyFd.so"].has("FrTOCDump", "cdecl"):
    FrTOCDump = _libs["libPyFd.so"].get("FrTOCDump", "cdecl")
    FrTOCDump.argtypes = [POINTER(FrTOC), POINTER(FILE), c_int, String]
    FrTOCDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1130
if _libs["libPyFd.so"].has("FrTOCFFLBuild", "cdecl"):
    FrTOCFFLBuild = _libs["libPyFd.so"].get("FrTOCFFLBuild", "cdecl")
    FrTOCFFLBuild.argtypes = [POINTER(FrFile)]
    FrTOCFFLBuild.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1131
if _libs["libPyFd.so"].has("FrTOCFree", "cdecl"):
    FrTOCFree = _libs["libPyFd.so"].get("FrTOCFree", "cdecl")
    FrTOCFree.argtypes = [POINTER(FrTOC)]
    FrTOCFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1132
if _libs["libPyFd.so"].has("FrTOCFrame", "cdecl"):
    FrTOCFrame = _libs["libPyFd.so"].get("FrTOCFrame", "cdecl")
    FrTOCFrame.argtypes = [POINTER(FrFile), POINTER(FrameH)]
    FrTOCFrame.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1133
if _libs["libPyFd.so"].has("FrTOCFrameFindN", "cdecl"):
    FrTOCFrameFindN = _libs["libPyFd.so"].get("FrTOCFrameFindN", "cdecl")
    FrTOCFrameFindN.argtypes = [POINTER(FrFile), c_int, c_int]
    FrTOCFrameFindN.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1134
if _libs["libPyFd.so"].has("FrTOCFrameFindNT", "cdecl"):
    FrTOCFrameFindNT = _libs["libPyFd.so"].get("FrTOCFrameFindNT", "cdecl")
    FrTOCFrameFindNT.argtypes = [POINTER(FrFile), c_double]
    FrTOCFrameFindNT.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1135
if _libs["libPyFd.so"].has("FrTOCFrameFindT", "cdecl"):
    FrTOCFrameFindT = _libs["libPyFd.so"].get("FrTOCFrameFindT", "cdecl")
    FrTOCFrameFindT.argtypes = [POINTER(FrFile), c_double]
    FrTOCFrameFindT.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1136
if _libs["libPyFd.so"].has("FrTOCGetFrameIndexOneFile", "cdecl"):
    FrTOCGetFrameIndexOneFile = _libs["libPyFd.so"].get("FrTOCGetFrameIndexOneFile", "cdecl")
    FrTOCGetFrameIndexOneFile.argtypes = [POINTER(FrFile), c_double]
    FrTOCGetFrameIndexOneFile.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1137
if _libs["libPyFd.so"].has("FrTOCGetLTOffset", "cdecl"):
    FrTOCGetLTOffset = _libs["libPyFd.so"].get("FrTOCGetLTOffset", "cdecl")
    FrTOCGetLTOffset.argtypes = [POINTER(FrFile), String]
    FrTOCGetLTOffset.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1138
if _libs["libPyFd.so"].has("FrTOCGetTimes", "cdecl"):
    FrTOCGetTimes = _libs["libPyFd.so"].get("FrTOCGetTimes", "cdecl")
    FrTOCGetTimes.argtypes = [POINTER(FrFile)]
    FrTOCGetTimes.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1139
if _libs["libPyFd.so"].has("FrTOCNew", "cdecl"):
    FrTOCNew = _libs["libPyFd.so"].get("FrTOCNew", "cdecl")
    FrTOCNew.argtypes = [POINTER(FrFile), POINTER(FrameH)]
    FrTOCNew.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1140
if _libs["libPyFd.so"].has("FrTOCRead", "cdecl"):
    FrTOCRead = _libs["libPyFd.so"].get("FrTOCRead", "cdecl")
    FrTOCRead.argtypes = [POINTER(FrFile), c_int]
    FrTOCRead.restype = POINTER(FrTOC)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1141
if _libs["libPyFd.so"].has("FrTOCReadFull", "cdecl"):
    FrTOCReadFull = _libs["libPyFd.so"].get("FrTOCReadFull", "cdecl")
    FrTOCReadFull.argtypes = [POINTER(FrFile)]
    FrTOCReadFull.restype = POINTER(FrTOC)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1142
if _libs["libPyFd.so"].has("FrTOCSegListMatch", "cdecl"):
    FrTOCSegListMatch = _libs["libPyFd.so"].get("FrTOCSegListMatch", "cdecl")
    FrTOCSegListMatch.argtypes = [POINTER(FrFile)]
    FrTOCSegListMatch.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1143
if _libs["libPyFd.so"].has("FrTOCSetPos", "cdecl"):
    FrTOCSetPos = _libs["libPyFd.so"].get("FrTOCSetPos", "cdecl")
    FrTOCSetPos.argtypes = [POINTER(FrFile), FRULONG]
    FrTOCSetPos.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1144
if _libs["libPyFd.so"].has("FrTOCSH", "cdecl"):
    FrTOCSH = _libs["libPyFd.so"].get("FrTOCSH", "cdecl")
    FrTOCSH.argtypes = [POINTER(FrFile), String, c_ushort]
    FrTOCSH.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1145
if _libs["libPyFd.so"].has("FrTOCSort", "cdecl"):
    FrTOCSort = _libs["libPyFd.so"].get("FrTOCSort", "cdecl")
    FrTOCSort.argtypes = [POINTER(FrFile)]
    FrTOCSort.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1146
if _libs["libPyFd.so"].has("FrTOCSort1", "cdecl"):
    FrTOCSort1 = _libs["libPyFd.so"].get("FrTOCSort1", "cdecl")
    FrTOCSort1.argtypes = [POINTER(POINTER(c_char)), POINTER(c_int), c_int, c_int]
    FrTOCSort1.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1147
if _libs["libPyFd.so"].has("FrTOCStatD", "cdecl"):
    FrTOCStatD = _libs["libPyFd.so"].get("FrTOCStatD", "cdecl")
    FrTOCStatD.argtypes = [POINTER(FrFile), POINTER(FrStatData)]
    FrTOCStatD.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1148
if _libs["libPyFd.so"].has("FrTOCStatDGet", "cdecl"):
    FrTOCStatDGet = _libs["libPyFd.so"].get("FrTOCStatDGet", "cdecl")
    FrTOCStatDGet.argtypes = [POINTER(FrFile), POINTER(FrameH)]
    FrTOCStatDGet.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1149
if _libs["libPyFd.so"].has("FrTOCStatRead", "cdecl"):
    FrTOCStatRead = _libs["libPyFd.so"].get("FrTOCStatRead", "cdecl")
    FrTOCStatRead.argtypes = [POINTER(FrFile)]
    FrTOCStatRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1150
if _libs["libPyFd.so"].has("FrTOCWrite", "cdecl"):
    FrTOCWrite = _libs["libPyFd.so"].get("FrTOCWrite", "cdecl")
    FrTOCWrite.argtypes = [POINTER(FrFile)]
    FrTOCWrite.restype = None

struct_FrTOCdet.__slots__ = [
    'name',
    'localTime',
    'position',
    'next',
]
struct_FrTOCdet._fields_ = [
    ('name', String),
    ('localTime', c_int),
    ('position', FRULONG),
    ('next', POINTER(FrTOCdet)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1158
if _libs["libPyFd.so"].has("FrTOCdetFree", "cdecl"):
    FrTOCdetFree = _libs["libPyFd.so"].get("FrTOCdetFree", "cdecl")
    FrTOCdetFree.argtypes = [POINTER(FrTOCdet)]
    FrTOCdetFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1159
if _libs["libPyFd.so"].has("FrTOCdetMark", "cdecl"):
    FrTOCdetMark = _libs["libPyFd.so"].get("FrTOCdetMark", "cdecl")
    FrTOCdetMark.argtypes = [POINTER(FrFile), String]
    FrTOCdetMark.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1160
if _libs["libPyFd.so"].has("FrTOCdetRead", "cdecl"):
    FrTOCdetRead = _libs["libPyFd.so"].get("FrTOCdetRead", "cdecl")
    FrTOCdetRead.argtypes = [POINTER(FrFile)]
    FrTOCdetRead.restype = POINTER(FrTOCdet)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1161
if _libs["libPyFd.so"].has("FrTOCdetWrite", "cdecl"):
    FrTOCdetWrite = _libs["libPyFd.so"].get("FrTOCdetWrite", "cdecl")
    FrTOCdetWrite.argtypes = [POINTER(FrFile)]
    FrTOCdetWrite.restype = None

struct_FrTOCevt.__slots__ = [
    'name',
    'nEvent',
    'GTimeS',
    'GTimeN',
    'amplitude',
    'position',
    'maxEvent',
    'next',
]
struct_FrTOCevt._fields_ = [
    ('name', String),
    ('nEvent', c_int),
    ('GTimeS', POINTER(c_uint)),
    ('GTimeN', POINTER(c_uint)),
    ('amplitude', POINTER(c_float)),
    ('position', POINTER(FRULONG)),
    ('maxEvent', c_int),
    ('next', POINTER(FrTOCevt)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1173
if _libs["libPyFd.so"].has("FrTOCevtDump", "cdecl"):
    FrTOCevtDump = _libs["libPyFd.so"].get("FrTOCevtDump", "cdecl")
    FrTOCevtDump.argtypes = [POINTER(FrTOCevt), POINTER(FILE), String, c_int, c_int]
    FrTOCevtDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1174
if _libs["libPyFd.so"].has("FrTOCevtFree", "cdecl"):
    FrTOCevtFree = _libs["libPyFd.so"].get("FrTOCevtFree", "cdecl")
    FrTOCevtFree.argtypes = [POINTER(FrTOCevt)]
    FrTOCevtFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1175
if _libs["libPyFd.so"].has("FrTOCevtGetEventInfo", "cdecl"):
    FrTOCevtGetEventInfo = _libs["libPyFd.so"].get("FrTOCevtGetEventInfo", "cdecl")
    FrTOCevtGetEventInfo.argtypes = [POINTER(FrTOCevt), String, c_double, c_double, c_double, c_double]
    FrTOCevtGetEventInfo.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1178
if _libs["libPyFd.so"].has("FrTOCevtMark", "cdecl"):
    FrTOCevtMark = _libs["libPyFd.so"].get("FrTOCevtMark", "cdecl")
    FrTOCevtMark.argtypes = [POINTER(FrFile), POINTER(POINTER(FrTOCevt)), String, c_uint, c_uint, c_float]
    FrTOCevtMark.restype = POINTER(FrTOCevt)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1180
if _libs["libPyFd.so"].has("FrTOCevtNew", "cdecl"):
    FrTOCevtNew = _libs["libPyFd.so"].get("FrTOCevtNew", "cdecl")
    FrTOCevtNew.argtypes = [String, c_int]
    FrTOCevtNew.restype = POINTER(FrTOCevt)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1181
if _libs["libPyFd.so"].has("FrTOCevtRead", "cdecl"):
    FrTOCevtRead = _libs["libPyFd.so"].get("FrTOCevtRead", "cdecl")
    FrTOCevtRead.argtypes = [POINTER(FrFile)]
    FrTOCevtRead.restype = POINTER(FrTOCevt)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1182
if _libs["libPyFd.so"].has("FrTOCevtSegListMatch", "cdecl"):
    FrTOCevtSegListMatch = _libs["libPyFd.so"].get("FrTOCevtSegListMatch", "cdecl")
    FrTOCevtSegListMatch.argtypes = [POINTER(FrFile), POINTER(FrTOCevt)]
    FrTOCevtSegListMatch.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1183
if _libs["libPyFd.so"].has("FrTOCevtWrite", "cdecl"):
    FrTOCevtWrite = _libs["libPyFd.so"].get("FrTOCevtWrite", "cdecl")
    FrTOCevtWrite.argtypes = [POINTER(FrFile), POINTER(FrTOCevt)]
    FrTOCevtWrite.restype = None

struct_FrTOCstat.__slots__ = [
    'name',
    'detector',
    'nStat',
    'tStart',
    'tEnd',
    'version',
    'position',
    'maxStat',
    'next',
]
struct_FrTOCstat._fields_ = [
    ('name', String),
    ('detector', String),
    ('nStat', c_int),
    ('tStart', POINTER(c_uint)),
    ('tEnd', POINTER(c_uint)),
    ('version', POINTER(c_uint)),
    ('position', POINTER(FRLONG)),
    ('maxStat', c_int),
    ('next', POINTER(struct_FrTOCstat)),
]

struct_FrTOCts.__slots__ = [
    'name',
    'channelID',
    'groupID',
    'position',
    'next',
]
struct_FrTOCts._fields_ = [
    ('name', String),
    ('channelID', c_uint),
    ('groupID', c_uint),
    ('position', POINTER(FRULONG)),
    ('next', POINTER(struct_FrTOCts)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1205
if _libs["libPyFd.so"].has("FrTOCtsFree", "cdecl"):
    FrTOCtsFree = _libs["libPyFd.so"].get("FrTOCtsFree", "cdecl")
    FrTOCtsFree.argtypes = [POINTER(FrTOCts)]
    FrTOCtsFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1206
if _libs["libPyFd.so"].has("FrTOCtsMark", "cdecl"):
    FrTOCtsMark = _libs["libPyFd.so"].get("FrTOCtsMark", "cdecl")
    FrTOCtsMark.argtypes = [POINTER(FrFile), POINTER(POINTER(FrTOCtsH)), String, c_uint, c_uint]
    FrTOCtsMark.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1208
if _libs["libPyFd.so"].has("FrTOCtsDump", "cdecl"):
    FrTOCtsDump = _libs["libPyFd.so"].get("FrTOCtsDump", "cdecl")
    FrTOCtsDump.argtypes = [POINTER(FrTOCts), POINTER(FILE), String, String, c_int]
    FrTOCtsDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1209
if _libs["libPyFd.so"].has("FrTOCtsRead", "cdecl"):
    FrTOCtsRead = _libs["libPyFd.so"].get("FrTOCtsRead", "cdecl")
    FrTOCtsRead.argtypes = [POINTER(FrFile), String, c_int]
    FrTOCtsRead.restype = POINTER(FrTOCts)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1210
if _libs["libPyFd.so"].has("FrTOCtsRealloc", "cdecl"):
    FrTOCtsRealloc = _libs["libPyFd.so"].get("FrTOCtsRealloc", "cdecl")
    FrTOCtsRealloc.argtypes = [POINTER(FrTOCtsH), POINTER(FrFile), c_int]
    FrTOCtsRealloc.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1211
if _libs["libPyFd.so"].has("FrTOCtsWrite", "cdecl"):
    FrTOCtsWrite = _libs["libPyFd.so"].get("FrTOCtsWrite", "cdecl")
    FrTOCtsWrite.argtypes = [POINTER(FrFile), POINTER(FrTOCtsH), String, c_int]
    FrTOCtsWrite.restype = None

struct_FrTOCtsH.__slots__ = [
    'nElement',
    'first',
    'next',
]
struct_FrTOCtsH._fields_ = [
    ('nElement', c_int),
    ('first', POINTER(struct_FrTOCts)),
    ('next', POINTER(struct_FrTOCtsH)),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1218
if _libs["libPyFd.so"].has("FrTOCtsHFree", "cdecl"):
    FrTOCtsHFree = _libs["libPyFd.so"].get("FrTOCtsHFree", "cdecl")
    FrTOCtsHFree.argtypes = [POINTER(struct_FrTOCtsH)]
    FrTOCtsHFree.restype = None

FRVECTTYPES = c_ushort# /virgoApp/Fr/v8r40p5/src/FrVect.h: 15

enum_anon_54 = c_int# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_C = 0# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_2S = (FR_VECT_C + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_8R = (FR_VECT_2S + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_4R = (FR_VECT_8R + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_4S = (FR_VECT_4R + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_8S = (FR_VECT_4S + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_8C = (FR_VECT_8S + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_16C = (FR_VECT_8C + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_STRING = (FR_VECT_16C + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_2U = (FR_VECT_STRING + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_4U = (FR_VECT_2U + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_8U = (FR_VECT_4U + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_1U = (FR_VECT_8U + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_8H = (FR_VECT_1U + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_16H = (FR_VECT_8H + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

FR_VECT_END = (FR_VECT_16H + 1)# /virgoApp/Fr/v8r40p5/src/FrVect.h: 17

struct_FrVect.__slots__ = [
    'classe',
    'name',
    'compress',
    'type',
    'nData',
    'nBytes',
    'data',
    'nDim',
    'nx',
    'dx',
    'startX',
    'unitX',
    'unitY',
    'next',
    'dataS',
    'dataI',
    'dataL',
    'dataF',
    'dataD',
    'dataU',
    'dataUS',
    'dataUI',
    'dataUL',
    'dataQ',
    'wSize',
    'space',
    'GTime',
    'ULeapS',
    'localTime',
    'dataUnzoomed',
    'nDataUnzoomed',
    'startXUnzoomed',
]
struct_FrVect._fields_ = [
    ('classe', POINTER(FrSH)),
    ('name', String),
    ('compress', c_ushort),
    ('type', FRVECTTYPES),
    ('nData', FRULONG),
    ('nBytes', FRULONG),
    ('data', String),
    ('nDim', c_uint),
    ('nx', POINTER(FRULONG)),
    ('dx', POINTER(c_double)),
    ('startX', POINTER(c_double)),
    ('unitX', POINTER(POINTER(c_char))),
    ('unitY', String),
    ('next', POINTER(FrVect)),
    ('dataS', POINTER(c_short)),
    ('dataI', POINTER(c_int)),
    ('dataL', POINTER(FRLONG)),
    ('dataF', POINTER(c_float)),
    ('dataD', POINTER(c_double)),
    ('dataU', POINTER(c_ubyte)),
    ('dataUS', POINTER(c_ushort)),
    ('dataUI', POINTER(c_uint)),
    ('dataUL', POINTER(FRULONG)),
    ('dataQ', POINTER(POINTER(c_char))),
    ('wSize', c_int),
    ('space', FRULONG),
    ('GTime', c_double),
    ('ULeapS', c_ushort),
    ('localTime', c_int),
    ('dataUnzoomed', String),
    ('nDataUnzoomed', FRULONG),
    ('startXUnzoomed', c_double),
]

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1225
if _libs["libPyFd.so"].has("FrVectCtoH", "cdecl"):
    FrVectCtoH = _libs["libPyFd.so"].get("FrVectCtoH", "cdecl")
    FrVectCtoH.argtypes = [POINTER(FrVect)]
    FrVectCtoH.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1226
if _libs["libPyFd.so"].has("FrVectCompData", "cdecl"):
    FrVectCompData = _libs["libPyFd.so"].get("FrVectCompData", "cdecl")
    FrVectCompData.argtypes = [POINTER(FrVect), c_int, c_int, POINTER(POINTER(c_ubyte)), POINTER(FRULONG)]
    FrVectCompData.restype = c_ushort

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1228
if _libs["libPyFd.so"].has("FrVectCompress", "cdecl"):
    FrVectCompress = _libs["libPyFd.so"].get("FrVectCompress", "cdecl")
    FrVectCompress.argtypes = [POINTER(FrVect), c_int, c_int]
    FrVectCompress.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1229
if _libs["libPyFd.so"].has("FrVectConcat", "cdecl"):
    FrVectConcat = _libs["libPyFd.so"].get("FrVectConcat", "cdecl")
    FrVectConcat.argtypes = [POINTER(FrVect), c_double, c_double]
    FrVectConcat.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1231
if _libs["libPyFd.so"].has("FrVectCopy", "cdecl"):
    FrVectCopy = _libs["libPyFd.so"].get("FrVectCopy", "cdecl")
    FrVectCopy.argtypes = [POINTER(FrVect)]
    FrVectCopy.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1232
if _libs["libPyFd.so"].has("FrVectCopyPartX", "cdecl"):
    FrVectCopyPartX = _libs["libPyFd.so"].get("FrVectCopyPartX", "cdecl")
    FrVectCopyPartX.argtypes = [POINTER(FrVect), c_double, c_double]
    FrVectCopyPartX.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1233
if _libs["libPyFd.so"].has("FrVectCopyPartI", "cdecl"):
    FrVectCopyPartI = _libs["libPyFd.so"].get("FrVectCopyPartI", "cdecl")
    FrVectCopyPartI.argtypes = [POINTER(FrVect), c_int, c_int]
    FrVectCopyPartI.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1234
if _libs["libPyFd.so"].has("FrVectCopyTo", "cdecl"):
    FrVectCopyTo = _libs["libPyFd.so"].get("FrVectCopyTo", "cdecl")
    FrVectCopyTo.argtypes = [POINTER(FrVect), c_double, POINTER(FrVect)]
    FrVectCopyTo.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1235
if _libs["libPyFd.so"].has("FrVectCopyToD", "cdecl"):
    FrVectCopyToD = _libs["libPyFd.so"].get("FrVectCopyToD", "cdecl")
    FrVectCopyToD.argtypes = [POINTER(FrVect), c_double, String]
    FrVectCopyToD.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1236
if _libs["libPyFd.so"].has("FrVectCopyToF", "cdecl"):
    FrVectCopyToF = _libs["libPyFd.so"].get("FrVectCopyToF", "cdecl")
    FrVectCopyToF.argtypes = [POINTER(FrVect), c_double, String]
    FrVectCopyToF.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1237
if _libs["libPyFd.so"].has("FrVectCopyToI", "cdecl"):
    FrVectCopyToI = _libs["libPyFd.so"].get("FrVectCopyToI", "cdecl")
    FrVectCopyToI.argtypes = [POINTER(FrVect), c_double, String]
    FrVectCopyToI.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1238
if _libs["libPyFd.so"].has("FrVectCopyToS", "cdecl"):
    FrVectCopyToS = _libs["libPyFd.so"].get("FrVectCopyToS", "cdecl")
    FrVectCopyToS.argtypes = [POINTER(FrVect), c_double, String]
    FrVectCopyToS.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1239
if _libs["libPyFd.so"].has("FrVectCopyToType", "cdecl"):
    FrVectCopyToType = _libs["libPyFd.so"].get("FrVectCopyToType", "cdecl")
    FrVectCopyToType.argtypes = [POINTER(FrVect), c_double, String, c_int]
    FrVectCopyToType.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1241
if _libs["libPyFd.so"].has("FrVectDecimate", "cdecl"):
    FrVectDecimate = _libs["libPyFd.so"].get("FrVectDecimate", "cdecl")
    FrVectDecimate.argtypes = [POINTER(FrVect), c_int, POINTER(FrVect)]
    FrVectDecimate.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1242
if _libs["libPyFd.so"].has("FrVectDecimateMax", "cdecl"):
    FrVectDecimateMax = _libs["libPyFd.so"].get("FrVectDecimateMax", "cdecl")
    FrVectDecimateMax.argtypes = [POINTER(FrVect), c_int]
    FrVectDecimateMax.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1243
if _libs["libPyFd.so"].has("FrVectDecimateMin", "cdecl"):
    FrVectDecimateMin = _libs["libPyFd.so"].get("FrVectDecimateMin", "cdecl")
    FrVectDecimateMin.argtypes = [POINTER(FrVect), c_int]
    FrVectDecimateMin.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1244
if _libs["libPyFd.so"].has("FrVectDef", "cdecl"):
    FrVectDef = _libs["libPyFd.so"].get("FrVectDef", "cdecl")
    FrVectDef.argtypes = []
    FrVectDef.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1245
if _libs["libPyFd.so"].has("FrVectDiff", "cdecl"):
    FrVectDiff = _libs["libPyFd.so"].get("FrVectDiff", "cdecl")
    FrVectDiff.argtypes = [POINTER(FrVect)]
    if sizeof(c_int) == sizeof(c_void_p):
        FrVectDiff.restype = ReturnString
    else:
        FrVectDiff.restype = String
        FrVectDiff.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1246
if _libs["libPyFd.so"].has("FrVectDump", "cdecl"):
    FrVectDump = _libs["libPyFd.so"].get("FrVectDump", "cdecl")
    FrVectDump.argtypes = [POINTER(FrVect), POINTER(FILE), c_int]
    FrVectDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1247
if _libs["libPyFd.so"].has("FrVectExpand", "cdecl"):
    FrVectExpand = _libs["libPyFd.so"].get("FrVectExpand", "cdecl")
    FrVectExpand.argtypes = [POINTER(FrVect)]
    FrVectExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1248
if _libs["libPyFd.so"].has("FrVectExpandF", "cdecl"):
    FrVectExpandF = _libs["libPyFd.so"].get("FrVectExpandF", "cdecl")
    FrVectExpandF.argtypes = [POINTER(FrVect)]
    FrVectExpandF.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1249
if _libs["libPyFd.so"].has("FrVectExtend", "cdecl"):
    FrVectExtend = _libs["libPyFd.so"].get("FrVectExtend", "cdecl")
    FrVectExtend.argtypes = [POINTER(FrVect), c_int, POINTER(FrVect), String]
    FrVectExtend.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1251
if _libs["libPyFd.so"].has("FrVectFillC", "cdecl"):
    FrVectFillC = _libs["libPyFd.so"].get("FrVectFillC", "cdecl")
    FrVectFillC.argtypes = [POINTER(FrVect), c_char]
    FrVectFillC.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1252
if _libs["libPyFd.so"].has("FrVectFillD", "cdecl"):
    FrVectFillD = _libs["libPyFd.so"].get("FrVectFillD", "cdecl")
    FrVectFillD.argtypes = [POINTER(FrVect), c_double]
    FrVectFillD.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1253
if _libs["libPyFd.so"].has("FrVectFillF", "cdecl"):
    FrVectFillF = _libs["libPyFd.so"].get("FrVectFillF", "cdecl")
    FrVectFillF.argtypes = [POINTER(FrVect), c_float]
    FrVectFillF.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1254
if _libs["libPyFd.so"].has("FrVectFillI", "cdecl"):
    FrVectFillI = _libs["libPyFd.so"].get("FrVectFillI", "cdecl")
    FrVectFillI.argtypes = [POINTER(FrVect), c_int]
    FrVectFillI.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1255
if _libs["libPyFd.so"].has("FrVectFillQ", "cdecl"):
    FrVectFillQ = _libs["libPyFd.so"].get("FrVectFillQ", "cdecl")
    FrVectFillQ.argtypes = [POINTER(FrVect), String]
    FrVectFillQ.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1256
if _libs["libPyFd.so"].has("FrVectFillS", "cdecl"):
    FrVectFillS = _libs["libPyFd.so"].get("FrVectFillS", "cdecl")
    FrVectFillS.argtypes = [POINTER(FrVect), c_short]
    FrVectFillS.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1257
if _libs["libPyFd.so"].has("FrVectFindQ", "cdecl"):
    FrVectFindQ = _libs["libPyFd.so"].get("FrVectFindQ", "cdecl")
    FrVectFindQ.argtypes = [POINTER(FrVect), String]
    FrVectFindQ.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1258
if _libs["libPyFd.so"].has("FrVectFixNAN", "cdecl"):
    FrVectFixNAN = _libs["libPyFd.so"].get("FrVectFixNAN", "cdecl")
    FrVectFixNAN.argtypes = [POINTER(FrVect)]
    FrVectFixNAN.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1259
if _libs["libPyFd.so"].has("FrVectFixVirgoImage", "cdecl"):
    FrVectFixVirgoImage = _libs["libPyFd.so"].get("FrVectFixVirgoImage", "cdecl")
    FrVectFixVirgoImage.argtypes = [POINTER(FrVect)]
    FrVectFixVirgoImage.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1260
if _libs["libPyFd.so"].has("FrVectFree", "cdecl"):
    FrVectFree = _libs["libPyFd.so"].get("FrVectFree", "cdecl")
    FrVectFree.argtypes = [POINTER(FrVect)]
    FrVectFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1263
if _libs["libPyFd.so"].has("FrVectGetIndex", "cdecl"):
    FrVectGetIndex = _libs["libPyFd.so"].get("FrVectGetIndex", "cdecl")
    FrVectGetIndex.argtypes = [POINTER(FrVect), c_double]
    FrVectGetIndex.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1264
if _libs["libPyFd.so"].has("FrVectGetTotSize", "cdecl"):
    FrVectGetTotSize = _libs["libPyFd.so"].get("FrVectGetTotSize", "cdecl")
    FrVectGetTotSize.argtypes = [POINTER(FrVect)]
    FrVectGetTotSize.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1265
if _libs["libPyFd.so"].has("FrVectGetV", "cdecl"):
    FrVectGetV = _libs["libPyFd.so"].get("FrVectGetV", "cdecl")
    FrVectGetV.argtypes = [POINTER(FrVect), FRULONG]
    FrVectGetV.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1266
if _libs["libPyFd.so"].has("FrVectGetValueI", "cdecl"):
    FrVectGetValueI = _libs["libPyFd.so"].get("FrVectGetValueI", "cdecl")
    FrVectGetValueI.argtypes = [POINTER(FrVect), FRULONG]
    FrVectGetValueI.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1267
if _libs["libPyFd.so"].has("FrVectGetValueX", "cdecl"):
    FrVectGetValueX = _libs["libPyFd.so"].get("FrVectGetValueX", "cdecl")
    FrVectGetValueX.argtypes = [POINTER(FrVect), c_double]
    FrVectGetValueX.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1268
if _libs["libPyFd.so"].has("FrVectGetValueGPS", "cdecl"):
    FrVectGetValueGPS = _libs["libPyFd.so"].get("FrVectGetValueGPS", "cdecl")
    FrVectGetValueGPS.argtypes = [POINTER(FrVect), c_double]
    FrVectGetValueGPS.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1270
if _libs["libPyFd.so"].has("FrVectHtoC", "cdecl"):
    FrVectHtoC = _libs["libPyFd.so"].get("FrVectHtoC", "cdecl")
    FrVectHtoC.argtypes = [POINTER(FrVect)]
    FrVectHtoC.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1271
if _libs["libPyFd.so"].has("FrVectInt", "cdecl"):
    FrVectInt = _libs["libPyFd.so"].get("FrVectInt", "cdecl")
    FrVectInt.argtypes = [POINTER(FrVect)]
    FrVectInt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1272
if _libs["libPyFd.so"].has("FrVectIsValid", "cdecl"):
    FrVectIsValid = _libs["libPyFd.so"].get("FrVectIsValid", "cdecl")
    FrVectIsValid.argtypes = [POINTER(FrVect)]
    FrVectIsValid.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1273
if _libs["libPyFd.so"].has("FrVectIsValidFillAux", "cdecl"):
    FrVectIsValidFillAux = _libs["libPyFd.so"].get("FrVectIsValidFillAux", "cdecl")
    FrVectIsValidFillAux.argtypes = [POINTER(FrVect)]
    FrVectIsValidFillAux.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1274
if _libs["libPyFd.so"].has("FrVectIsValidStrict", "cdecl"):
    FrVectIsValidStrict = _libs["libPyFd.so"].get("FrVectIsValidStrict", "cdecl")
    FrVectIsValidStrict.argtypes = [POINTER(FrVect)]
    FrVectIsValidStrict.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1275
if _libs["libPyFd.so"].has("FrVectLoad", "cdecl"):
    FrVectLoad = _libs["libPyFd.so"].get("FrVectLoad", "cdecl")
    FrVectLoad.argtypes = [String]
    FrVectLoad.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1276
if _libs["libPyFd.so"].has("FrVectMap", "cdecl"):
    FrVectMap = _libs["libPyFd.so"].get("FrVectMap", "cdecl")
    FrVectMap.argtypes = [POINTER(FrVect)]
    FrVectMap.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1277
if _libs["libPyFd.so"].has("FrVectMax", "cdecl"):
    FrVectMax = _libs["libPyFd.so"].get("FrVectMax", "cdecl")
    FrVectMax.argtypes = [POINTER(FrVect)]
    FrVectMax.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1278
if _libs["libPyFd.so"].has("FrVectMergeT", "cdecl"):
    FrVectMergeT = _libs["libPyFd.so"].get("FrVectMergeT", "cdecl")
    FrVectMergeT.argtypes = [POINTER(POINTER(FrVect)), c_int]
    FrVectMergeT.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1279
if _libs["libPyFd.so"].has("FrVectMean", "cdecl"):
    FrVectMean = _libs["libPyFd.so"].get("FrVectMean", "cdecl")
    FrVectMean.argtypes = [POINTER(FrVect)]
    FrVectMean.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1280
if _libs["libPyFd.so"].has("FrVectMin", "cdecl"):
    FrVectMin = _libs["libPyFd.so"].get("FrVectMin", "cdecl")
    FrVectMin.argtypes = [POINTER(FrVect)]
    FrVectMin.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1281
if _libs["libPyFd.so"].has("FrVectMinMax", "cdecl"):
    FrVectMinMax = _libs["libPyFd.so"].get("FrVectMinMax", "cdecl")
    FrVectMinMax.argtypes = [POINTER(FrVect), POINTER(c_double), POINTER(c_double)]
    FrVectMinMax.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1282
if _libs["libPyFd.so"].has("FrVectNew", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrVectNew", "cdecl")
    _restype = POINTER(FrVect)
    _errcheck = None
    _argtypes = [c_int, c_int]
    FrVectNew = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1283
if _libs["libPyFd.so"].has("FrVectNewL", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrVectNewL", "cdecl")
    _restype = POINTER(FrVect)
    _errcheck = None
    _argtypes = [c_int, c_int]
    FrVectNewL = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1284
if _libs["libPyFd.so"].has("FrVectNewTS", "cdecl"):
    FrVectNewTS = _libs["libPyFd.so"].get("FrVectNewTS", "cdecl")
    FrVectNewTS.argtypes = [String, c_double, FRLONG, c_int]
    FrVectNewTS.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1285
if _libs["libPyFd.so"].has("FrVectNew1D", "cdecl"):
    FrVectNew1D = _libs["libPyFd.so"].get("FrVectNew1D", "cdecl")
    FrVectNew1D.argtypes = [String, c_int, FRLONG, c_double, String, String]
    FrVectNew1D.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1287
if _libs["libPyFd.so"].has("FrVectRead", "cdecl"):
    FrVectRead = _libs["libPyFd.so"].get("FrVectRead", "cdecl")
    FrVectRead.argtypes = [POINTER(FrFile)]
    FrVectRead.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1288
if _libs["libPyFd.so"].has("FrVectReadNext", "cdecl"):
    FrVectReadNext = _libs["libPyFd.so"].get("FrVectReadNext", "cdecl")
    FrVectReadNext.argtypes = [POINTER(FrFile), c_double, String]
    FrVectReadNext.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1289
if _libs["libPyFd.so"].has("FrVectReadZoom", "cdecl"):
    FrVectReadZoom = _libs["libPyFd.so"].get("FrVectReadZoom", "cdecl")
    FrVectReadZoom.argtypes = [POINTER(FrFile), c_double, c_double]
    FrVectReadZoom.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1291
if _libs["libPyFd.so"].has("FrVectResample", "cdecl"):
    FrVectResample = _libs["libPyFd.so"].get("FrVectResample", "cdecl")
    FrVectResample.argtypes = [POINTER(FrVect), c_int, POINTER(FrVect), String]
    FrVectResample.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1292
if _libs["libPyFd.so"].has("FrVectReshapeAdd", "cdecl"):
    FrVectReshapeAdd = _libs["libPyFd.so"].get("FrVectReshapeAdd", "cdecl")
    FrVectReshapeAdd.argtypes = [POINTER(FrVect), POINTER(FrVect)]
    FrVectReshapeAdd.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1293
if _libs["libPyFd.so"].has("FrVectReshapeEnd", "cdecl"):
    FrVectReshapeEnd = _libs["libPyFd.so"].get("FrVectReshapeEnd", "cdecl")
    FrVectReshapeEnd.argtypes = [POINTER(FrVect)]
    FrVectReshapeEnd.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1294
if _libs["libPyFd.so"].has("FrVectReshapeNew", "cdecl"):
    FrVectReshapeNew = _libs["libPyFd.so"].get("FrVectReshapeNew", "cdecl")
    FrVectReshapeNew.argtypes = [POINTER(FrVect), c_double, c_double]
    FrVectReshapeNew.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1295
if _libs["libPyFd.so"].has("FrVectRMS", "cdecl"):
    FrVectRMS = _libs["libPyFd.so"].get("FrVectRMS", "cdecl")
    FrVectRMS.argtypes = [POINTER(FrVect)]
    FrVectRMS.restype = c_double

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1296
if _libs["libPyFd.so"].has("FrVectSave", "cdecl"):
    FrVectSave = _libs["libPyFd.so"].get("FrVectSave", "cdecl")
    FrVectSave.argtypes = [POINTER(FrVect), String]
    FrVectSave.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1298
if _libs["libPyFd.so"].has("FrVectSetMissingValues", "cdecl"):
    FrVectSetMissingValues = _libs["libPyFd.so"].get("FrVectSetMissingValues", "cdecl")
    FrVectSetMissingValues.argtypes = [POINTER(FrVect), c_double]
    FrVectSetMissingValues.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1299
if _libs["libPyFd.so"].has("FrVectSetName", "cdecl"):
    FrVectSetName = _libs["libPyFd.so"].get("FrVectSetName", "cdecl")
    FrVectSetName.argtypes = [POINTER(FrVect), String]
    FrVectSetName.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1300
if _libs["libPyFd.so"].has("FrVectSetUnitX", "cdecl"):
    FrVectSetUnitX = _libs["libPyFd.so"].get("FrVectSetUnitX", "cdecl")
    FrVectSetUnitX.argtypes = [POINTER(FrVect), String]
    FrVectSetUnitX.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1301
if _libs["libPyFd.so"].has("FrVectSetUnitY", "cdecl"):
    FrVectSetUnitY = _libs["libPyFd.so"].get("FrVectSetUnitY", "cdecl")
    FrVectSetUnitY.argtypes = [POINTER(FrVect), String]
    FrVectSetUnitY.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1303
if _libs["libPyFd.so"].has("FrVectStat", "cdecl"):
    FrVectStat = _libs["libPyFd.so"].get("FrVectStat", "cdecl")
    FrVectStat.argtypes = [POINTER(FrVect)]
    if sizeof(c_int) == sizeof(c_void_p):
        FrVectStat.restype = ReturnString
    else:
        FrVectStat.restype = String
        FrVectStat.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1304
if _libs["libPyFd.so"].has("FrVectToAudio", "cdecl"):
    FrVectToAudio = _libs["libPyFd.so"].get("FrVectToAudio", "cdecl")
    FrVectToAudio.argtypes = [POINTER(FrVect), String, String]
    FrVectToAudio.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1305
if _libs["libPyFd.so"].has("FrVectWrite", "cdecl"):
    FrVectWrite = _libs["libPyFd.so"].get("FrVectWrite", "cdecl")
    FrVectWrite.argtypes = [POINTER(FrVect), POINTER(FrFile)]
    FrVectWrite.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1306
if _libs["libPyFd.so"].has("FrVectFComp", "cdecl"):
    FrVectFComp = _libs["libPyFd.so"].get("FrVectFComp", "cdecl")
    FrVectFComp.argtypes = [POINTER(c_short), POINTER(FRULONG), POINTER(c_float), FRULONG, c_int]
    FrVectFComp.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1308
if _libs["libPyFd.so"].has("FrVectFExpand", "cdecl"):
    FrVectFExpand = _libs["libPyFd.so"].get("FrVectFExpand", "cdecl")
    FrVectFExpand.argtypes = [POINTER(c_float), POINTER(c_short), FRULONG]
    FrVectFExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1309
if _libs["libPyFd.so"].has("FrVectUComp", "cdecl"):
    FrVectUComp = _libs["libPyFd.so"].get("FrVectUComp", "cdecl")
    FrVectUComp.argtypes = [POINTER(FrVect), POINTER(c_ubyte), POINTER(FRULONG), POINTER(c_int)]
    FrVectUComp.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1311
if _libs["libPyFd.so"].has("FrVectUExpand", "cdecl"):
    FrVectUExpand = _libs["libPyFd.so"].get("FrVectUExpand", "cdecl")
    FrVectUExpand.argtypes = [POINTER(FrVect), POINTER(c_ubyte)]
    FrVectUExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1312
if _libs["libPyFd.so"].has("FrVectZComp", "cdecl"):
    FrVectZComp = _libs["libPyFd.so"].get("FrVectZComp", "cdecl")
    FrVectZComp.argtypes = [POINTER(c_ushort), POINTER(FRULONG), POINTER(c_short), FRULONG, c_int]
    FrVectZComp.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1314
if _libs["libPyFd.so"].has("FrVectZCompI", "cdecl"):
    FrVectZCompI = _libs["libPyFd.so"].get("FrVectZCompI", "cdecl")
    FrVectZCompI.argtypes = [POINTER(c_uint), POINTER(FRULONG), POINTER(c_int), FRULONG, c_int]
    FrVectZCompI.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1316
if _libs["libPyFd.so"].has("FrVectZExpand", "cdecl"):
    FrVectZExpand = _libs["libPyFd.so"].get("FrVectZExpand", "cdecl")
    FrVectZExpand.argtypes = [POINTER(c_short), POINTER(c_ushort), FRULONG]
    FrVectZExpand.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1317
if _libs["libPyFd.so"].has("FrVectZExpandI", "cdecl"):
    FrVectZExpandI = _libs["libPyFd.so"].get("FrVectZExpandI", "cdecl")
    FrVectZExpandI.argtypes = [POINTER(c_int), POINTER(c_uint), FRULONG]
    FrVectZExpandI.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1318
if _libs["libPyFd.so"].has("FrVectZExpandL", "cdecl"):
    FrVectZExpandL = _libs["libPyFd.so"].get("FrVectZExpandL", "cdecl")
    FrVectZExpandL.argtypes = [POINTER(c_longlong), POINTER(c_ulonglong), FRULONG]
    FrVectZExpandL.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1319
if _libs["libPyFd.so"].has("FrVectZoomIn", "cdecl"):
    FrVectZoomIn = _libs["libPyFd.so"].get("FrVectZoomIn", "cdecl")
    FrVectZoomIn.argtypes = [POINTER(FrVect), c_double, c_double]
    FrVectZoomIn.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1320
if _libs["libPyFd.so"].has("FrVectZoomInI", "cdecl"):
    FrVectZoomInI = _libs["libPyFd.so"].get("FrVectZoomInI", "cdecl")
    FrVectZoomInI.argtypes = [POINTER(FrVect), FRLONG, FRLONG]
    FrVectZoomInI.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1321
if _libs["libPyFd.so"].has("FrVectZoomOut", "cdecl"):
    FrVectZoomOut = _libs["libPyFd.so"].get("FrVectZoomOut", "cdecl")
    FrVectZoomOut.argtypes = [POINTER(FrVect)]
    FrVectZoomOut.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1325
if _libs["libPyFd.so"].has("FrLibIni", "cdecl"):
    FrLibIni = _libs["libPyFd.so"].get("FrLibIni", "cdecl")
    FrLibIni.argtypes = [String, POINTER(FILE), c_int]
    FrLibIni.restype = POINTER(FILE)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1326
if _libs["libPyFd.so"].has("FrLibShortIni", "cdecl"):
    FrLibShortIni = _libs["libPyFd.so"].get("FrLibShortIni", "cdecl")
    FrLibShortIni.argtypes = []
    FrLibShortIni.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1327
if _libs["libPyFd.so"].has("FrLibSetLvl", "cdecl"):
    FrLibSetLvl = _libs["libPyFd.so"].get("FrLibSetLvl", "cdecl")
    FrLibSetLvl.argtypes = [c_int]
    FrLibSetLvl.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1328
if _libs["libPyFd.so"].has("FrLibSetFlipPrefix", "cdecl"):
    FrLibSetFlipPrefix = _libs["libPyFd.so"].get("FrLibSetFlipPrefix", "cdecl")
    FrLibSetFlipPrefix.argtypes = [String]
    FrLibSetFlipPrefix.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1329
if _libs["libPyFd.so"].has("FrLibSetVersion", "cdecl"):
    FrLibSetVersion = _libs["libPyFd.so"].get("FrLibSetVersion", "cdecl")
    FrLibSetVersion.argtypes = [c_int]
    FrLibSetVersion.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1330
if _libs["libPyFd.so"].has("FrLibVersion", "cdecl"):
    FrLibVersion = _libs["libPyFd.so"].get("FrLibVersion", "cdecl")
    FrLibVersion.argtypes = [POINTER(FILE)]
    FrLibVersion.restype = c_float

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1331
if _libs["libPyFd.so"].has("FrLibVersionF", "cdecl"):
    FrLibVersionF = _libs["libPyFd.so"].get("FrLibVersionF", "cdecl")
    FrLibVersionF.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        FrLibVersionF.restype = ReturnString
    else:
        FrLibVersionF.restype = String
        FrLibVersionF.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1333
if _libs["libPyFd.so"].has("FrError", "cdecl"):
    FrError = _libs["libPyFd.so"].get("FrError", "cdecl")
    FrError.argtypes = [c_int, String, String]
    if sizeof(c_int) == sizeof(c_void_p):
        FrError.restype = ReturnString
    else:
        FrError.restype = String
        FrError.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1334
if _libs["libPyFd.so"].has("FrErrorGetHistory", "cdecl"):
    FrErrorGetHistory = _libs["libPyFd.so"].get("FrErrorGetHistory", "cdecl")
    FrErrorGetHistory.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        FrErrorGetHistory.restype = ReturnString
    else:
        FrErrorGetHistory.restype = String
        FrErrorGetHistory.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1335
if _libs["libPyFd.so"].has("FrErrorDefHandler", "cdecl"):
    FrErrorDefHandler = _libs["libPyFd.so"].get("FrErrorDefHandler", "cdecl")
    FrErrorDefHandler.argtypes = [c_int, String]
    FrErrorDefHandler.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1336
if _libs["libPyFd.so"].has("FrErrorSetHandler", "cdecl"):
    FrErrorSetHandler = _libs["libPyFd.so"].get("FrErrorSetHandler", "cdecl")
    FrErrorSetHandler.argtypes = [CFUNCTYPE(UNCHECKED(None), c_int, String)]
    FrErrorSetHandler.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1338
if _libs["libPyFd.so"].has("FrChkSum", "cdecl"):
    FrChkSum = _libs["libPyFd.so"].get("FrChkSum", "cdecl")
    FrChkSum.argtypes = [String, c_int, c_int]
    FrChkSum.restype = c_uint

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1339
if _libs["libPyFd.so"].has("FrCksumGnu", "cdecl"):
    FrCksumGnu = _libs["libPyFd.so"].get("FrCksumGnu", "cdecl")
    FrCksumGnu.argtypes = [String, FRLONG, POINTER(c_uint)]
    FrCksumGnu.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1341
if _libs["libPyFd.so"].has("FrDicAddS", "cdecl"):
    FrDicAddS = _libs["libPyFd.so"].get("FrDicAddS", "cdecl")
    FrDicAddS.argtypes = [String, CFUNCTYPE(UNCHECKED(None), )]
    FrDicAddS.restype = POINTER(FrSH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1342
if _libs["libPyFd.so"].has("FrDicAssignId", "cdecl"):
    FrDicAssignId = _libs["libPyFd.so"].get("FrDicAssignId", "cdecl")
    FrDicAssignId.argtypes = [POINTER(struct_FrFile), c_ushort, POINTER(None)]
    FrDicAssignId.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1343
if _libs["libPyFd.so"].has("FrDicGetId", "cdecl"):
    FrDicGetId = _libs["libPyFd.so"].get("FrDicGetId", "cdecl")
    FrDicGetId.argtypes = [POINTER(struct_FrFile), c_ushort, POINTER(None)]
    FrDicGetId.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1344
if _libs["libPyFd.so"].has("FrDicIni", "cdecl"):
    FrDicIni = _libs["libPyFd.so"].get("FrDicIni", "cdecl")
    FrDicIni.argtypes = [POINTER(struct_FrFile)]
    FrDicIni.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1347
if _libs["libPyFd.so"].has("FrStrCpy", "cdecl"):
    FrStrCpy = _libs["libPyFd.so"].get("FrStrCpy", "cdecl")
    FrStrCpy.argtypes = [POINTER(POINTER(c_char)), String]
    if sizeof(c_int) == sizeof(c_void_p):
        FrStrCpy.restype = ReturnString
    else:
        FrStrCpy.restype = String
        FrStrCpy.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1348
if _libs["libPyFd.so"].has("FrStrGTime", "cdecl"):
    FrStrGTime = _libs["libPyFd.so"].get("FrStrGTime", "cdecl")
    FrStrGTime.argtypes = [c_uint]
    if sizeof(c_int) == sizeof(c_void_p):
        FrStrGTime.restype = ReturnString
    else:
        FrStrGTime.restype = String
        FrStrGTime.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1349
if _libs["libPyFd.so"].has("FrStrcmpAndPrefix", "cdecl"):
    FrStrcmpAndPrefix = _libs["libPyFd.so"].get("FrStrcmpAndPrefix", "cdecl")
    FrStrcmpAndPrefix.argtypes = [String, String]
    FrStrcmpAndPrefix.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1350
if _libs["libPyFd.so"].has("FrStrFlipPrefix", "cdecl"):
    FrStrFlipPrefix = _libs["libPyFd.so"].get("FrStrFlipPrefix", "cdecl")
    FrStrFlipPrefix.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        FrStrFlipPrefix.restype = ReturnString
    else:
        FrStrFlipPrefix.restype = String
        FrStrFlipPrefix.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1351
if _libs["libPyFd.so"].has("FrStrSetPrefix", "cdecl"):
    FrStrSetPrefix = _libs["libPyFd.so"].get("FrStrSetPrefix", "cdecl")
    FrStrSetPrefix.argtypes = [POINTER(POINTER(c_char)), String]
    FrStrSetPrefix.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1352
if _libs["libPyFd.so"].has("FrStrSetSuffix", "cdecl"):
    FrStrSetSuffix = _libs["libPyFd.so"].get("FrStrSetSuffix", "cdecl")
    FrStrSetSuffix.argtypes = [POINTER(POINTER(c_char)), String]
    FrStrSetSuffix.restype = c_int

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1353
if _libs["libPyFd.so"].has("FrStrUTC", "cdecl"):
    FrStrUTC = _libs["libPyFd.so"].get("FrStrUTC", "cdecl")
    FrStrUTC.argtypes = [c_uint, c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        FrStrUTC.restype = ReturnString
    else:
        FrStrUTC.restype = String
        FrStrUTC.errcheck = ReturnString

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1354
if _libs["libPyFd.so"].has("FrGPS2UTC", "cdecl"):
    FrGPS2UTC = _libs["libPyFd.so"].get("FrGPS2UTC", "cdecl")
    FrGPS2UTC.argtypes = [c_uint, c_int]
    FrGPS2UTC.restype = time_t

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1360
if _libs["libPyFd.so"].has("FrPutNewRecord", "cdecl"):
    FrPutNewRecord = _libs["libPyFd.so"].get("FrPutNewRecord", "cdecl")
    FrPutNewRecord.argtypes = [POINTER(FrFile), POINTER(None), FRBOOL]
    FrPutNewRecord.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1361
if _libs["libPyFd.so"].has("FrPutChar", "cdecl"):
    FrPutChar = _libs["libPyFd.so"].get("FrPutChar", "cdecl")
    FrPutChar.argtypes = [POINTER(FrFile), c_char]
    FrPutChar.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1362
if _libs["libPyFd.so"].has("FrPutDouble", "cdecl"):
    FrPutDouble = _libs["libPyFd.so"].get("FrPutDouble", "cdecl")
    FrPutDouble.argtypes = [POINTER(FrFile), c_double]
    FrPutDouble.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1363
if _libs["libPyFd.so"].has("FrPutFloat", "cdecl"):
    FrPutFloat = _libs["libPyFd.so"].get("FrPutFloat", "cdecl")
    FrPutFloat.argtypes = [POINTER(FrFile), c_float]
    FrPutFloat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1364
if _libs["libPyFd.so"].has("FrPutInt", "cdecl"):
    FrPutInt = _libs["libPyFd.so"].get("FrPutInt", "cdecl")
    FrPutInt.argtypes = [POINTER(FrFile), c_int]
    FrPutInt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1365
if _libs["libPyFd.so"].has("FrPutIntU", "cdecl"):
    FrPutIntU = _libs["libPyFd.so"].get("FrPutIntU", "cdecl")
    FrPutIntU.argtypes = [POINTER(FrFile), c_uint]
    FrPutIntU.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1366
if _libs["libPyFd.so"].has("FrPutLong", "cdecl"):
    FrPutLong = _libs["libPyFd.so"].get("FrPutLong", "cdecl")
    FrPutLong.argtypes = [POINTER(FrFile), FRLONG]
    FrPutLong.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1367
if _libs["libPyFd.so"].has("FrPutShort", "cdecl"):
    FrPutShort = _libs["libPyFd.so"].get("FrPutShort", "cdecl")
    FrPutShort.argtypes = [POINTER(FrFile), c_short]
    FrPutShort.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1368
if _libs["libPyFd.so"].has("FrPutShortU", "cdecl"):
    FrPutShortU = _libs["libPyFd.so"].get("FrPutShortU", "cdecl")
    FrPutShortU.argtypes = [POINTER(FrFile), c_ushort]
    FrPutShortU.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1369
if _libs["libPyFd.so"].has("FrPutSChar", "cdecl"):
    FrPutSChar = _libs["libPyFd.so"].get("FrPutSChar", "cdecl")
    FrPutSChar.argtypes = [POINTER(FrFile), String]
    FrPutSChar.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1370
if _libs["libPyFd.so"].has("FrPutStruct", "cdecl"):
    FrPutStruct = _libs["libPyFd.so"].get("FrPutStruct", "cdecl")
    FrPutStruct.argtypes = [POINTER(FrFile), POINTER(None)]
    FrPutStruct.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1372
if _libs["libPyFd.so"].has("FrPutVC", "cdecl"):
    FrPutVC = _libs["libPyFd.so"].get("FrPutVC", "cdecl")
    FrPutVC.argtypes = [POINTER(FrFile), String, c_int]
    FrPutVC.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1373
if _libs["libPyFd.so"].has("FrPutVD", "cdecl"):
    FrPutVD = _libs["libPyFd.so"].get("FrPutVD", "cdecl")
    FrPutVD.argtypes = [POINTER(FrFile), POINTER(c_double), c_int]
    FrPutVD.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1374
if _libs["libPyFd.so"].has("FrPutVF", "cdecl"):
    FrPutVF = _libs["libPyFd.so"].get("FrPutVF", "cdecl")
    FrPutVF.argtypes = [POINTER(FrFile), POINTER(c_float), c_int]
    FrPutVF.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1375
if _libs["libPyFd.so"].has("FrPutVFD", "cdecl"):
    FrPutVFD = _libs["libPyFd.so"].get("FrPutVFD", "cdecl")
    FrPutVFD.argtypes = [POINTER(FrFile), POINTER(c_double), c_int]
    FrPutVFD.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1376
if _libs["libPyFd.so"].has("FrPutVI", "cdecl"):
    FrPutVI = _libs["libPyFd.so"].get("FrPutVI", "cdecl")
    FrPutVI.argtypes = [POINTER(FrFile), POINTER(c_int), c_int]
    FrPutVI.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1377
if _libs["libPyFd.so"].has("FrPutVL", "cdecl"):
    FrPutVL = _libs["libPyFd.so"].get("FrPutVL", "cdecl")
    FrPutVL.argtypes = [POINTER(FrFile), POINTER(FRLONG), c_int]
    FrPutVL.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1378
if _libs["libPyFd.so"].has("FrPutVQ", "cdecl"):
    FrPutVQ = _libs["libPyFd.so"].get("FrPutVQ", "cdecl")
    FrPutVQ.argtypes = [POINTER(FrFile), POINTER(POINTER(c_char)), c_int]
    FrPutVQ.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1379
if _libs["libPyFd.so"].has("FrPutVS", "cdecl"):
    FrPutVS = _libs["libPyFd.so"].get("FrPutVS", "cdecl")
    FrPutVS.argtypes = [POINTER(FrFile), POINTER(c_short), c_int]
    FrPutVS.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1381
if _libs["libPyFd.so"].has("FrPutWriteRecord", "cdecl"):
    FrPutWriteRecord = _libs["libPyFd.so"].get("FrPutWriteRecord", "cdecl")
    FrPutWriteRecord.argtypes = [POINTER(FrFile), FRBOOL]
    FrPutWriteRecord.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1385
if _libs["libPyFd.so"].has("FrReadHeader", "cdecl"):
    FrReadHeader = _libs["libPyFd.so"].get("FrReadHeader", "cdecl")
    FrReadHeader.argtypes = [POINTER(FrFile), POINTER(None)]
    FrReadHeader.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1387
if _libs["libPyFd.so"].has("FrRead", "cdecl"):
    FrRead = _libs["libPyFd.so"].get("FrRead", "cdecl")
    FrRead.argtypes = [POINTER(FrFile), String, FRULONG]
    FrRead.restype = FRLONG

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1388
if _libs["libPyFd.so"].has("FrReadDouble", "cdecl"):
    FrReadDouble = _libs["libPyFd.so"].get("FrReadDouble", "cdecl")
    FrReadDouble.argtypes = [POINTER(FrFile), POINTER(c_double)]
    FrReadDouble.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1389
if _libs["libPyFd.so"].has("FrReadFloat", "cdecl"):
    FrReadFloat = _libs["libPyFd.so"].get("FrReadFloat", "cdecl")
    FrReadFloat.argtypes = [POINTER(FrFile), POINTER(c_float)]
    FrReadFloat.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1390
if _libs["libPyFd.so"].has("FrReadInt", "cdecl"):
    FrReadInt = _libs["libPyFd.so"].get("FrReadInt", "cdecl")
    FrReadInt.argtypes = [POINTER(FrFile), POINTER(c_int)]
    FrReadInt.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1391
if _libs["libPyFd.so"].has("FrReadIntU", "cdecl"):
    FrReadIntU = _libs["libPyFd.so"].get("FrReadIntU", "cdecl")
    FrReadIntU.argtypes = [POINTER(FrFile), POINTER(c_uint)]
    FrReadIntU.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1392
if _libs["libPyFd.so"].has("FrReadLong", "cdecl"):
    FrReadLong = _libs["libPyFd.so"].get("FrReadLong", "cdecl")
    FrReadLong.argtypes = [POINTER(FrFile), POINTER(FRLONG)]
    FrReadLong.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1393
if _libs["libPyFd.so"].has("FrReadRecord", "cdecl"):
    FrReadRecord = _libs["libPyFd.so"].get("FrReadRecord", "cdecl")
    FrReadRecord.argtypes = [POINTER(FrFile)]
    FrReadRecord.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1394
if _libs["libPyFd.so"].has("FrReadSChar", "cdecl"):
    FrReadSChar = _libs["libPyFd.so"].get("FrReadSChar", "cdecl")
    FrReadSChar.argtypes = [POINTER(FrFile), POINTER(POINTER(c_char))]
    FrReadSChar.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1395
if _libs["libPyFd.so"].has("FrReadShort", "cdecl"):
    FrReadShort = _libs["libPyFd.so"].get("FrReadShort", "cdecl")
    FrReadShort.argtypes = [POINTER(FrFile), POINTER(c_short)]
    FrReadShort.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1396
if _libs["libPyFd.so"].has("FrReadShortU", "cdecl"):
    FrReadShortU = _libs["libPyFd.so"].get("FrReadShortU", "cdecl")
    FrReadShortU.argtypes = [POINTER(FrFile), POINTER(c_ushort)]
    FrReadShortU.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1397
if _libs["libPyFd.so"].has("FrReadSkipRecord", "cdecl"):
    FrReadSkipRecord = _libs["libPyFd.so"].get("FrReadSkipRecord", "cdecl")
    FrReadSkipRecord.argtypes = [POINTER(FrFile)]
    FrReadSkipRecord.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1398
if _libs["libPyFd.so"].has("FrReadStruct", "cdecl"):
    FrReadStruct = _libs["libPyFd.so"].get("FrReadStruct", "cdecl")
    FrReadStruct.argtypes = [POINTER(FrFile), POINTER(None)]
    FrReadStruct.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1399
if _libs["libPyFd.so"].has("FrReadStructHeader", "cdecl"):
    FrReadStructHeader = _libs["libPyFd.so"].get("FrReadStructHeader", "cdecl")
    FrReadStructHeader.argtypes = [POINTER(FrFile)]
    FrReadStructHeader.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1400
if _libs["libPyFd.so"].has("FrReadStructChksum", "cdecl"):
    FrReadStructChksum = _libs["libPyFd.so"].get("FrReadStructChksum", "cdecl")
    FrReadStructChksum.argtypes = [POINTER(FrFile)]
    FrReadStructChksum.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1401
if _libs["libPyFd.so"].has("FrReadVC", "cdecl"):
    FrReadVC = _libs["libPyFd.so"].get("FrReadVC", "cdecl")
    FrReadVC.argtypes = [POINTER(FrFile), POINTER(POINTER(c_char)), FRULONG]
    FrReadVC.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1402
if _libs["libPyFd.so"].has("FrReadVD", "cdecl"):
    FrReadVD = _libs["libPyFd.so"].get("FrReadVD", "cdecl")
    FrReadVD.argtypes = [POINTER(FrFile), POINTER(POINTER(c_double)), FRULONG]
    FrReadVD.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1403
if _libs["libPyFd.so"].has("FrReadVF", "cdecl"):
    FrReadVF = _libs["libPyFd.so"].get("FrReadVF", "cdecl")
    FrReadVF.argtypes = [POINTER(FrFile), POINTER(POINTER(c_float)), FRULONG]
    FrReadVF.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1404
if _libs["libPyFd.so"].has("FrReadVFD", "cdecl"):
    FrReadVFD = _libs["libPyFd.so"].get("FrReadVFD", "cdecl")
    FrReadVFD.argtypes = [POINTER(FrFile), POINTER(POINTER(c_double)), FRULONG]
    FrReadVFD.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1405
if _libs["libPyFd.so"].has("FrReadVI", "cdecl"):
    FrReadVI = _libs["libPyFd.so"].get("FrReadVI", "cdecl")
    FrReadVI.argtypes = [POINTER(FrFile), POINTER(POINTER(c_int)), FRULONG]
    FrReadVI.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1406
if _libs["libPyFd.so"].has("FrReadVL", "cdecl"):
    FrReadVL = _libs["libPyFd.so"].get("FrReadVL", "cdecl")
    FrReadVL.argtypes = [POINTER(FrFile), POINTER(POINTER(FRLONG)), FRULONG]
    FrReadVL.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1407
if _libs["libPyFd.so"].has("FrReadVQ", "cdecl"):
    FrReadVQ = _libs["libPyFd.so"].get("FrReadVQ", "cdecl")
    FrReadVQ.argtypes = [POINTER(FrFile), POINTER(POINTER(POINTER(c_char))), FRULONG]
    FrReadVQ.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1408
if _libs["libPyFd.so"].has("FrReadVS", "cdecl"):
    FrReadVS = _libs["libPyFd.so"].get("FrReadVS", "cdecl")
    FrReadVS.argtypes = [POINTER(FrFile), POINTER(POINTER(c_short)), FRULONG]
    FrReadVS.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1411
if _libs["libPyFd.so"].has("FrBack3DetectorRead", "cdecl"):
    FrBack3DetectorRead = _libs["libPyFd.so"].get("FrBack3DetectorRead", "cdecl")
    FrBack3DetectorRead.argtypes = [POINTER(FrFile)]
    FrBack3DetectorRead.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1412
if _libs["libPyFd.so"].has("FrBack3FrameHRead", "cdecl"):
    FrBack3FrameHRead = _libs["libPyFd.so"].get("FrBack3FrameHRead", "cdecl")
    FrBack3FrameHRead.argtypes = [POINTER(FrFile)]
    FrBack3FrameHRead.restype = POINTER(FrameH)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1413
if _libs["libPyFd.so"].has("FrBack3ProcDataRead", "cdecl"):
    FrBack3ProcDataRead = _libs["libPyFd.so"].get("FrBack3ProcDataRead", "cdecl")
    FrBack3ProcDataRead.argtypes = [POINTER(FrFile)]
    FrBack3ProcDataRead.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1414
if _libs["libPyFd.so"].has("FrBack3RawDataRead", "cdecl"):
    FrBack3RawDataRead = _libs["libPyFd.so"].get("FrBack3RawDataRead", "cdecl")
    FrBack3RawDataRead.argtypes = [POINTER(FrFile)]
    FrBack3RawDataRead.restype = POINTER(FrRawData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1415
if _libs["libPyFd.so"].has("FrBack3SimDataRead", "cdecl"):
    FrBack3SimDataRead = _libs["libPyFd.so"].get("FrBack3SimDataRead", "cdecl")
    FrBack3SimDataRead.argtypes = [POINTER(FrFile)]
    FrBack3SimDataRead.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1416
if _libs["libPyFd.so"].has("FrBack3StatDataRead", "cdecl"):
    FrBack3StatDataRead = _libs["libPyFd.so"].get("FrBack3StatDataRead", "cdecl")
    FrBack3StatDataRead.argtypes = [POINTER(FrFile)]
    FrBack3StatDataRead.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1417
if _libs["libPyFd.so"].has("FrBack3SummaryRead", "cdecl"):
    FrBack3SummaryRead = _libs["libPyFd.so"].get("FrBack3SummaryRead", "cdecl")
    FrBack3SummaryRead.argtypes = [POINTER(FrFile)]
    FrBack3SummaryRead.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1418
if _libs["libPyFd.so"].has("FrBack3EventRead", "cdecl"):
    FrBack3EventRead = _libs["libPyFd.so"].get("FrBack3EventRead", "cdecl")
    FrBack3EventRead.argtypes = [POINTER(FrFile)]
    FrBack3EventRead.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1419
if _libs["libPyFd.so"].has("FrBack3VectRead", "cdecl"):
    FrBack3VectRead = _libs["libPyFd.so"].get("FrBack3VectRead", "cdecl")
    FrBack3VectRead.argtypes = [POINTER(FrFile)]
    FrBack3VectRead.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1421
if _libs["libPyFd.so"].has("FrBack4DetectorRead", "cdecl"):
    FrBack4DetectorRead = _libs["libPyFd.so"].get("FrBack4DetectorRead", "cdecl")
    FrBack4DetectorRead.argtypes = [POINTER(FrFile)]
    FrBack4DetectorRead.restype = POINTER(FrDetector)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1422
if _libs["libPyFd.so"].has("FrBack4EndOfFrameRead", "cdecl"):
    FrBack4EndOfFrameRead = _libs["libPyFd.so"].get("FrBack4EndOfFrameRead", "cdecl")
    FrBack4EndOfFrameRead.argtypes = [POINTER(FrFile)]
    FrBack4EndOfFrameRead.restype = None

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1423
if _libs["libPyFd.so"].has("FrBack4EventRead", "cdecl"):
    FrBack4EventRead = _libs["libPyFd.so"].get("FrBack4EventRead", "cdecl")
    FrBack4EventRead.argtypes = [POINTER(FrFile)]
    FrBack4EventRead.restype = POINTER(FrEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1424
if _libs["libPyFd.so"].has("FrBack4MsgRead", "cdecl"):
    FrBack4MsgRead = _libs["libPyFd.so"].get("FrBack4MsgRead", "cdecl")
    FrBack4MsgRead.argtypes = [POINTER(FrFile)]
    FrBack4MsgRead.restype = POINTER(FrMsg)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1425
if _libs["libPyFd.so"].has("FrBack4ProcDataRead", "cdecl"):
    FrBack4ProcDataRead = _libs["libPyFd.so"].get("FrBack4ProcDataRead", "cdecl")
    FrBack4ProcDataRead.argtypes = [POINTER(FrFile)]
    FrBack4ProcDataRead.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1426
if _libs["libPyFd.so"].has("FrBack4SimDataRead", "cdecl"):
    FrBack4SimDataRead = _libs["libPyFd.so"].get("FrBack4SimDataRead", "cdecl")
    FrBack4SimDataRead.argtypes = [POINTER(FrFile)]
    FrBack4SimDataRead.restype = POINTER(FrSimData)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1427
if _libs["libPyFd.so"].has("FrBack4SimEventRead", "cdecl"):
    FrBack4SimEventRead = _libs["libPyFd.so"].get("FrBack4SimEventRead", "cdecl")
    FrBack4SimEventRead.argtypes = [POINTER(FrFile)]
    FrBack4SimEventRead.restype = POINTER(FrSimEvent)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1428
if _libs["libPyFd.so"].has("FrBack4SummaryRead", "cdecl"):
    FrBack4SummaryRead = _libs["libPyFd.so"].get("FrBack4SummaryRead", "cdecl")
    FrBack4SummaryRead.argtypes = [POINTER(FrFile)]
    FrBack4SummaryRead.restype = POINTER(FrSummary)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1429
if _libs["libPyFd.so"].has("FrBack4TOCevtRead", "cdecl"):
    FrBack4TOCevtRead = _libs["libPyFd.so"].get("FrBack4TOCevtRead", "cdecl")
    FrBack4TOCevtRead.argtypes = [POINTER(FrFile)]
    FrBack4TOCevtRead.restype = POINTER(FrTOCevt)

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1431
if _libs["libPyFd.so"].has("FrBack5ProcDataRead", "cdecl"):
    FrBack5ProcDataRead = _libs["libPyFd.so"].get("FrBack5ProcDataRead", "cdecl")
    FrBack5ProcDataRead.argtypes = [POINTER(FrFile)]
    FrBack5ProcDataRead.restype = POINTER(FrProcData)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 20
class struct_FrFilter(Structure):
    pass

FrFilter = struct_FrFilter# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 18

struct_FrFilter.__slots__ = [
    'name',
    'fs',
    'ntaps',
    'a',
    'b',
    'gain',
    'reg',
    'alpha',
    'beta',
    'nCall',
    'output',
    'next',
]
struct_FrFilter._fields_ = [
    ('name', String),
    ('fs', c_double),
    ('ntaps', c_int),
    ('a', POINTER(c_double)),
    ('b', POINTER(c_double)),
    ('gain', c_double),
    ('reg', POINTER(c_double)),
    ('alpha', POINTER(c_double)),
    ('beta', POINTER(c_double)),
    ('nCall', c_int),
    ('output', POINTER(FrVect)),
    ('next', POINTER(FrFilter)),
]

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 36
if _libs["libPyFd.so"].has("FrFilterFree", "cdecl"):
    FrFilterFree = _libs["libPyFd.so"].get("FrFilterFree", "cdecl")
    FrFilterFree.argtypes = [POINTER(FrFilter)]
    FrFilterFree.restype = None

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 37
if _libs["libPyFd.so"].has("FrFilterNew", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrFilterNew", "cdecl")
    _restype = POINTER(FrFilter)
    _errcheck = None
    _argtypes = [String, c_double, c_double, c_int]
    FrFilterNew = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 41
if _libs["libPyFd.so"].has("FrFilterDump", "cdecl"):
    FrFilterDump = _libs["libPyFd.so"].get("FrFilterDump", "cdecl")
    FrFilterDump.argtypes = [POINTER(FrFilter), POINTER(FILE), c_int]
    FrFilterDump.restype = None

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 44
if _libs["libPyFd.so"].has("FrFilterPackToVect", "cdecl"):
    FrFilterPackToVect = _libs["libPyFd.so"].get("FrFilterPackToVect", "cdecl")
    FrFilterPackToVect.argtypes = [POINTER(FrFilter)]
    FrFilterPackToVect.restype = POINTER(FrVect)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 47
if _libs["libPyFd.so"].has("FrFilterGetFromVect", "cdecl"):
    FrFilterGetFromVect = _libs["libPyFd.so"].get("FrFilterGetFromVect", "cdecl")
    FrFilterGetFromVect.argtypes = [POINTER(FrVect)]
    FrFilterGetFromVect.restype = POINTER(FrFilter)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 50
if _libs["libPyFd.so"].has("FrProcDataAddFilter", "cdecl"):
    FrProcDataAddFilter = _libs["libPyFd.so"].get("FrProcDataAddFilter", "cdecl")
    FrProcDataAddFilter.argtypes = [POINTER(FrProcData), POINTER(FrFilter)]
    FrProcDataAddFilter.restype = None

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 54
if _libs["libPyFd.so"].has("FrProcDataGetFilter", "cdecl"):
    FrProcDataGetFilter = _libs["libPyFd.so"].get("FrProcDataGetFilter", "cdecl")
    FrProcDataGetFilter.argtypes = [POINTER(FrProcData), String]
    FrProcDataGetFilter.restype = POINTER(FrFilter)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 58
if _libs["libPyFd.so"].has("FrStatDataAddFilter", "cdecl"):
    FrStatDataAddFilter = _libs["libPyFd.so"].get("FrStatDataAddFilter", "cdecl")
    FrStatDataAddFilter.argtypes = [POINTER(FrStatData), POINTER(FrFilter)]
    FrStatDataAddFilter.restype = None

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 59
if _libs["libPyFd.so"].has("FrameAddStatFilter", "cdecl"):
    FrameAddStatFilter = _libs["libPyFd.so"].get("FrameAddStatFilter", "cdecl")
    FrameAddStatFilter.argtypes = [POINTER(FrameH), String, String, c_uint, c_uint, c_uint, POINTER(FrFilter)]
    FrameAddStatFilter.restype = POINTER(FrStatData)

# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 62
if _libs["libPyFd.so"].has("FrameGetStatFilter", "cdecl"):
    FrameGetStatFilter = _libs["libPyFd.so"].get("FrameGetStatFilter", "cdecl")
    FrameGetStatFilter.argtypes = [POINTER(FrameH), String, String, String, c_int]
    FrameGetStatFilter.restype = POINTER(FrFilter)

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 18
if _libs["libPyFd.so"].has("FrvClone", "cdecl"):
    FrvClone = _libs["libPyFd.so"].get("FrvClone", "cdecl")
    FrvClone.argtypes = [POINTER(FrVect), String]
    FrvClone.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 29
if _libs["libPyFd.so"].has("FrvDecimateD", "cdecl"):
    FrvDecimateD = _libs["libPyFd.so"].get("FrvDecimateD", "cdecl")
    FrvDecimateD.argtypes = [POINTER(FrVect), c_int, String]
    FrvDecimateD.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 30
if _libs["libPyFd.so"].has("FrvDecimateF", "cdecl"):
    FrvDecimateF = _libs["libPyFd.so"].get("FrvDecimateF", "cdecl")
    FrvDecimateF.argtypes = [POINTER(FrVect), c_int, String]
    FrvDecimateF.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 31
if _libs["libPyFd.so"].has("FrvDecimateI", "cdecl"):
    FrvDecimateI = _libs["libPyFd.so"].get("FrvDecimateI", "cdecl")
    FrvDecimateI.argtypes = [POINTER(FrVect), c_int, String]
    FrvDecimateI.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 32
if _libs["libPyFd.so"].has("FrvDecimateS", "cdecl"):
    FrvDecimateS = _libs["libPyFd.so"].get("FrvDecimateS", "cdecl")
    FrvDecimateS.argtypes = [POINTER(FrVect), c_int, String]
    FrvDecimateS.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 17
class struct_FrvBuf(Structure):
    pass

struct_FrvBuf.__slots__ = [
    'nDataOut',
    'step',
    'outType',
    'decimate',
    'decSign',
    'delay',
    'intDelay',
    'work',
    'first',
    'last',
    'workSize',
    'lastGTime',
    'input',
    'output',
]
struct_FrvBuf._fields_ = [
    ('nDataOut', c_int),
    ('step', c_int),
    ('outType', c_int),
    ('decimate', c_int),
    ('decSign', c_int),
    ('delay', c_int),
    ('intDelay', FRBOOL),
    ('work', String),
    ('first', c_long),
    ('last', c_long),
    ('workSize', c_long),
    ('lastGTime', c_double),
    ('input', POINTER(FrVect)),
    ('output', POINTER(FrVect)),
]

FrvBuf = struct_FrvBuf# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 37

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 39
if _libs["libPyFd.so"].has("FrvBufFree", "cdecl"):
    FrvBufFree = _libs["libPyFd.so"].get("FrvBufFree", "cdecl")
    FrvBufFree.argtypes = [POINTER(FrvBuf)]
    FrvBufFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 40
if _libs["libPyFd.so"].has("FrvBufFeed", "cdecl"):
    FrvBufFeed = _libs["libPyFd.so"].get("FrvBufFeed", "cdecl")
    FrvBufFeed.argtypes = [POINTER(FrvBuf), POINTER(FrVect)]
    FrvBufFeed.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 41
if _libs["libPyFd.so"].has("FrvBufFeedN", "cdecl"):
    FrvBufFeedN = _libs["libPyFd.so"].get("FrvBufFeedN", "cdecl")
    FrvBufFeedN.argtypes = [POINTER(FrvBuf), POINTER(FrVect), c_int, c_int]
    FrvBufFeedN.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 42
if _libs["libPyFd.so"].has("FrvBufGetNext", "cdecl"):
    FrvBufGetNext = _libs["libPyFd.so"].get("FrvBufGetNext", "cdecl")
    FrvBufGetNext.argtypes = [POINTER(FrvBuf)]
    FrvBufGetNext.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 43
if _libs["libPyFd.so"].has("FrvBufInit", "cdecl"):
    FrvBufInit = _libs["libPyFd.so"].get("FrvBufInit", "cdecl")
    FrvBufInit.argtypes = [POINTER(FrvBuf), POINTER(FrVect)]
    FrvBufInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 44
if _libs["libPyFd.so"].has("FrvBufNew", "cdecl"):
    FrvBufNew = _libs["libPyFd.so"].get("FrvBufNew", "cdecl")
    FrvBufNew.argtypes = [c_int, c_int, c_int, c_int, c_int]
    FrvBufNew.restype = POINTER(FrvBuf)

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 45
if _libs["libPyFd.so"].has("FrvBufNewID", "cdecl"):
    FrvBufNewID = _libs["libPyFd.so"].get("FrvBufNewID", "cdecl")
    FrvBufNewID.argtypes = [c_int, c_int, c_int, c_int, c_int]
    FrvBufNewID.restype = POINTER(FrvBuf)

# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 46
if _libs["libPyFd.so"].has("FrvBufStillToGo", "cdecl"):
    FrvBufStillToGo = _libs["libPyFd.so"].get("FrvBufStillToGo", "cdecl")
    FrvBufStillToGo.argtypes = [POINTER(FrvBuf)]
    FrvBufStillToGo.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 21
class struct_FrvBandRms(Structure):
    pass

FrvBandRms = struct_FrvBandRms# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 18

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 36
class struct_FrvRFFT(Structure):
    pass

FrvRFFT = struct_FrvRFFT# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 19

struct_FrvBandRms.__slots__ = [
    'fft',
    'channel',
    'nAverage',
    'freqMin',
    'freqMax',
    'rms',
    'GTime',
]
struct_FrvBandRms._fields_ = [
    ('fft', POINTER(FrvRFFT)),
    ('channel', String),
    ('nAverage', c_int),
    ('freqMin', c_double),
    ('freqMax', c_double),
    ('rms', c_double),
    ('GTime', c_double),
]

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 31
if _libs["libPyFd.so"].has("FrvBandRmsFree", "cdecl"):
    FrvBandRmsFree = _libs["libPyFd.so"].get("FrvBandRmsFree", "cdecl")
    FrvBandRmsFree.argtypes = [POINTER(FrvBandRms)]
    FrvBandRmsFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 32
if _libs["libPyFd.so"].has("FrvBandRmsNew", "cdecl"):
    FrvBandRmsNew = _libs["libPyFd.so"].get("FrvBandRmsNew", "cdecl")
    FrvBandRmsNew.argtypes = [String, c_double, c_int, c_double, c_double]
    FrvBandRmsNew.restype = POINTER(FrvBandRms)

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 34
if _libs["libPyFd.so"].has("FrvBandRmsProc", "cdecl"):
    FrvBandRmsProc = _libs["libPyFd.so"].get("FrvBandRmsProc", "cdecl")
    FrvBandRmsProc.argtypes = [POINTER(FrvBandRms), POINTER(FrameH)]
    FrvBandRmsProc.restype = c_int

struct_FrvRFFT.__slots__ = [
    'nAverage',
    'fftSize',
    'decimate',
    'duration',
    'medianPeriod',
    'optionA',
    'optionM',
    'optionH',
    'optionO',
    'optionN',
    'optionP',
    'optionS',
    'optionR',
    'optionF',
    'nData',
    'nDataP2',
    'dt',
    'dnu',
    'window',
    'temp',
    'buffer',
    'name',
    'plan',
    'array_for_sorting',
    'array_for_median',
    'mean',
    'output',
    'amplitude',
    'amplitudeA',
    'nFFT',
    'err',
]
struct_FrvRFFT._fields_ = [
    ('nAverage', c_long),
    ('fftSize', c_int),
    ('decimate', c_int),
    ('duration', c_double),
    ('medianPeriod', c_int),
    ('optionA', FRBOOL),
    ('optionM', FRBOOL),
    ('optionH', FRBOOL),
    ('optionO', FRBOOL),
    ('optionN', FRBOOL),
    ('optionP', FRBOOL),
    ('optionS', FRBOOL),
    ('optionR', FRBOOL),
    ('optionF', FRBOOL),
    ('nData', c_long),
    ('nDataP2', c_long),
    ('dt', c_double),
    ('dnu', c_double),
    ('window', POINTER(struct_FrVect)),
    ('temp', POINTER(struct_FrVect)),
    ('buffer', POINTER(struct_FrvBuf)),
    ('name', String),
    ('plan', POINTER(None)),
    ('array_for_sorting', POINTER(c_double)),
    ('array_for_median', POINTER(POINTER(c_double))),
    ('mean', c_double),
    ('output', POINTER(struct_FrVect)),
    ('amplitude', POINTER(struct_FrVect)),
    ('amplitudeA', POINTER(struct_FrVect)),
    ('nFFT', c_long),
    ('err', c_char * int(256)),
]

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 73
if _libs["libPyFd.so"].has("FrvRFFTFree", "cdecl"):
    FrvRFFTFree = _libs["libPyFd.so"].get("FrvRFFTFree", "cdecl")
    FrvRFFTFree.argtypes = [POINTER(FrvRFFT)]
    FrvRFFTFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 74
if _libs["libPyFd.so"].has("FrvRFFTInit", "cdecl"):
    FrvRFFTInit = _libs["libPyFd.so"].get("FrvRFFTInit", "cdecl")
    FrvRFFTInit.argtypes = [POINTER(FrvRFFT), POINTER(FrVect)]
    FrvRFFTInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 75
if _libs["libPyFd.so"].has("FrvRFFTNew", "cdecl"):
    FrvRFFTNew = _libs["libPyFd.so"].get("FrvRFFTNew", "cdecl")
    FrvRFFTNew.argtypes = [String, c_int, c_int]
    FrvRFFTNew.restype = POINTER(FrvRFFT)

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 76
if _libs["libPyFd.so"].has("FrvRFFTNewT", "cdecl"):
    FrvRFFTNewT = _libs["libPyFd.so"].get("FrvRFFTNewT", "cdecl")
    FrvRFFTNewT.argtypes = [String, c_double, c_int]
    FrvRFFTNewT.restype = POINTER(FrvRFFT)

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 77
if _libs["libPyFd.so"].has("FrvRFFTFor", "cdecl"):
    FrvRFFTFor = _libs["libPyFd.so"].get("FrvRFFTFor", "cdecl")
    FrvRFFTFor.argtypes = [POINTER(FrvRFFT), POINTER(FrVect)]
    FrvRFFTFor.restype = POINTER(FrvRFFT)

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 78
if _libs["libPyFd.so"].has("FrvRFFTSetMedianPeriod", "cdecl"):
    FrvRFFTSetMedianPeriod = _libs["libPyFd.so"].get("FrvRFFTSetMedianPeriod", "cdecl")
    FrvRFFTSetMedianPeriod.argtypes = [POINTER(FrvRFFT), c_int]
    FrvRFFTSetMedianPeriod.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 80
if _libs["libPyFd.so"].has("FrvFFTD704", "cdecl"):
    FrvFFTD704 = _libs["libPyFd.so"].get("FrvFFTD704", "cdecl")
    FrvFFTD704.argtypes = [POINTER(c_double), c_long]
    FrvFFTD704.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 82
if _libs["libPyFd.so"].has("MedianBias", "cdecl"):
    MedianBias = _libs["libPyFd.so"].get("MedianBias", "cdecl")
    MedianBias.argtypes = [c_int]
    MedianBias.restype = c_double

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 20
class struct_FrvFilter2(Structure):
    pass

FrvFilter2 = struct_FrvFilter2# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 17

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 68
class struct_FrvFilterB(Structure):
    pass

FrvFilterB = struct_FrvFilterB# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 18

struct_FrvFilter2.__slots__ = [
    'a0',
    'a1',
    'a2',
    'b0',
    'b1',
    'b2',
    'reg0',
    'reg1',
    'reg2',
    'alfa0',
    'alfa1',
    'alfa2',
    'beta0',
    'beta1',
    'beta2',
    'output',
    'error',
    'nCall',
    'outputIsInput',
    'nResets',
    'next',
]
struct_FrvFilter2._fields_ = [
    ('a0', c_double),
    ('a1', c_double),
    ('a2', c_double),
    ('b0', c_double),
    ('b1', c_double),
    ('b2', c_double),
    ('reg0', c_double),
    ('reg1', c_double),
    ('reg2', c_double),
    ('alfa0', c_double),
    ('alfa1', c_double),
    ('alfa2', c_double),
    ('beta0', c_double),
    ('beta1', c_double),
    ('beta2', c_double),
    ('output', POINTER(FrVect)),
    ('error', c_char * int(256)),
    ('nCall', c_int),
    ('outputIsInput', FRBOOL),
    ('nResets', c_int),
    ('next', POINTER(FrvFilter2)),
]

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 62
if _libs["libPyFd.so"].has("FrvFilter2Free", "cdecl"):
    FrvFilter2Free = _libs["libPyFd.so"].get("FrvFilter2Free", "cdecl")
    FrvFilter2Free.argtypes = [POINTER(FrvFilter2)]
    FrvFilter2Free.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 63
if _libs["libPyFd.so"].has("FrvFilter2Proc", "cdecl"):
    FrvFilter2Proc = _libs["libPyFd.so"].get("FrvFilter2Proc", "cdecl")
    FrvFilter2Proc.argtypes = [POINTER(FrvFilter2), POINTER(FrVect)]
    FrvFilter2Proc.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 64
if _libs["libPyFd.so"].has("FrvFilter2Init", "cdecl"):
    FrvFilter2Init = _libs["libPyFd.so"].get("FrvFilter2Init", "cdecl")
    FrvFilter2Init.argtypes = [POINTER(FrvFilter2), POINTER(FrVect)]
    FrvFilter2Init.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 65
if _libs["libPyFd.so"].has("FrvFilter2New", "cdecl"):
    FrvFilter2New = _libs["libPyFd.so"].get("FrvFilter2New", "cdecl")
    FrvFilter2New.argtypes = [c_double, c_double, c_double, c_double, c_double, c_double]
    FrvFilter2New.restype = POINTER(FrvFilter2)

struct_FrvFilterB.__slots__ = [
    'name',
    'order',
    'fMin',
    'fMax',
    'fMaxPreWrp',
    'filterHP',
    'filterLP',
    'filter2',
    'output',
    'errorPrinted',
    'nResets',
    'lastError',
    'next',
]
struct_FrvFilterB._fields_ = [
    ('name', String),
    ('order', c_int),
    ('fMin', c_double),
    ('fMax', c_double),
    ('fMaxPreWrp', c_double),
    ('filterHP', POINTER(FrvFilter2)),
    ('filterLP', POINTER(FrvFilter2)),
    ('filter2', POINTER(FrvFilter2)),
    ('output', POINTER(FrVect)),
    ('errorPrinted', FRBOOL),
    ('nResets', c_int),
    ('lastError', c_int),
    ('next', POINTER(FrvFilterB)),
]

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 84
if _libs["libPyFd.so"].has("FrvFilterButFree", "cdecl"):
    FrvFilterButFree = _libs["libPyFd.so"].get("FrvFilterButFree", "cdecl")
    FrvFilterButFree.argtypes = [POINTER(FrvFilterB)]
    FrvFilterButFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 85
if _libs["libPyFd.so"].has("FrvFilterButNew", "cdecl"):
    FrvFilterButNew = _libs["libPyFd.so"].get("FrvFilterButNew", "cdecl")
    FrvFilterButNew.argtypes = [c_int, c_double, c_double, String]
    FrvFilterButNew.restype = POINTER(FrvFilterB)

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 86
if _libs["libPyFd.so"].has("FrvFilterButProc", "cdecl"):
    FrvFilterButProc = _libs["libPyFd.so"].get("FrvFilterButProc", "cdecl")
    FrvFilterButProc.argtypes = [POINTER(FrvFilterB), POINTER(FrVect)]
    FrvFilterButProc.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 87
if _libs["libPyFd.so"].has("FrvFilterButReset", "cdecl"):
    FrvFilterButReset = _libs["libPyFd.so"].get("FrvFilterButReset", "cdecl")
    FrvFilterButReset.argtypes = [POINTER(FrvFilterB)]
    FrvFilterButReset.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 21
class struct_FrvStat(Structure):
    pass

struct_FrvStat.__slots__ = [
    'decay',
    'decayTime',
    'nDecay',
    'dt',
    'meanA',
    'rmsA',
    'x2A',
    'mean',
    'rms',
]
struct_FrvStat._fields_ = [
    ('decay', c_double),
    ('decayTime', c_double),
    ('nDecay', c_long),
    ('dt', c_double),
    ('meanA', c_double),
    ('rmsA', c_double),
    ('x2A', c_double),
    ('mean', POINTER(struct_FrVect)),
    ('rms', POINTER(struct_FrVect)),
]

FrvStat = struct_FrvStat# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 35

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 37
if _libs["libPyFd.so"].has("FrvStatFree", "cdecl"):
    FrvStatFree = _libs["libPyFd.so"].get("FrvStatFree", "cdecl")
    FrvStatFree.argtypes = [POINTER(FrvStat)]
    FrvStatFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 38
if _libs["libPyFd.so"].has("FrvStatNew", "cdecl"):
    FrvStatNew = _libs["libPyFd.so"].get("FrvStatNew", "cdecl")
    FrvStatNew.argtypes = []
    FrvStatNew.restype = POINTER(FrvStat)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 39
if _libs["libPyFd.so"].has("FrvStatProc", "cdecl"):
    FrvStatProc = _libs["libPyFd.so"].get("FrvStatProc", "cdecl")
    FrvStatProc.argtypes = [POINTER(FrvStat), POINTER(FrVect)]
    FrvStatProc.restype = POINTER(FrvStat)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 40
if _libs["libPyFd.so"].has("FrvStatProcA", "cdecl"):
    FrvStatProcA = _libs["libPyFd.so"].get("FrvStatProcA", "cdecl")
    FrvStatProcA.argtypes = [POINTER(FrvStat), POINTER(FrVect)]
    FrvStatProcA.restype = POINTER(FrvStat)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 41
if _libs["libPyFd.so"].has("FrvStatProcV", "cdecl"):
    FrvStatProcV = _libs["libPyFd.so"].get("FrvStatProcV", "cdecl")
    FrvStatProcV.argtypes = [POINTER(FrvStat), c_double]
    FrvStatProcV.restype = POINTER(FrvStat)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 42
if _libs["libPyFd.so"].has("FrvStatReset", "cdecl"):
    FrvStatReset = _libs["libPyFd.so"].get("FrvStatReset", "cdecl")
    FrvStatReset.argtypes = [POINTER(FrvStat)]
    FrvStatReset.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 43
if _libs["libPyFd.so"].has("FrvStatSetDecay", "cdecl"):
    FrvStatSetDecay = _libs["libPyFd.so"].get("FrvStatSetDecay", "cdecl")
    FrvStatSetDecay.argtypes = [POINTER(FrvStat), c_double]
    FrvStatSetDecay.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 44
if _libs["libPyFd.so"].has("FrvStatSetDecayTime", "cdecl"):
    FrvStatSetDecayTime = _libs["libPyFd.so"].get("FrvStatSetDecayTime", "cdecl")
    FrvStatSetDecayTime.argtypes = [POINTER(FrvStat), c_double]
    FrvStatSetDecayTime.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 46
if _libs["libPyFd.so"].has("FrvAdd", "cdecl"):
    FrvAdd = _libs["libPyFd.so"].get("FrvAdd", "cdecl")
    FrvAdd.argtypes = [POINTER(FrVect), POINTER(FrVect), POINTER(FrVect), String]
    FrvAdd.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 47
if _libs["libPyFd.so"].has("FrvBias", "cdecl"):
    FrvBias = _libs["libPyFd.so"].get("FrvBias", "cdecl")
    FrvBias.argtypes = [POINTER(FrVect), c_double, POINTER(FrVect)]
    FrvBias.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 48
if _libs["libPyFd.so"].has("FrvCombine2", "cdecl"):
    FrvCombine2 = _libs["libPyFd.so"].get("FrvCombine2", "cdecl")
    FrvCombine2.argtypes = [c_double, POINTER(FrVect), c_double, POINTER(FrVect), POINTER(FrVect), String]
    FrvCombine2.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 51
if _libs["libPyFd.so"].has("FrvCombine", "cdecl"):
    _func = _libs["libPyFd.so"].get("FrvCombine", "cdecl")
    _restype = POINTER(FrVect)
    _errcheck = None
    _argtypes = [c_int]
    FrvCombine = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 53
if _libs["libPyFd.so"].has("FrvDelta", "cdecl"):
    FrvDelta = _libs["libPyFd.so"].get("FrvDelta", "cdecl")
    FrvDelta.argtypes = [POINTER(FrVect), POINTER(c_double), POINTER(c_double)]
    FrvDelta.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 54
if _libs["libPyFd.so"].has("FrvDivide", "cdecl"):
    FrvDivide = _libs["libPyFd.so"].get("FrvDivide", "cdecl")
    FrvDivide.argtypes = [POINTER(FrVect), POINTER(FrVect), POINTER(FrVect), String]
    FrvDivide.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 55
if _libs["libPyFd.so"].has("FrvFlatten", "cdecl"):
    FrvFlatten = _libs["libPyFd.so"].get("FrvFlatten", "cdecl")
    FrvFlatten.argtypes = [POINTER(FrVect), POINTER(FrVect)]
    FrvFlatten.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 57
if _libs["libPyFd.so"].has("FrvFillGaus", "cdecl"):
    FrvFillGaus = _libs["libPyFd.so"].get("FrvFillGaus", "cdecl")
    FrvFillGaus.argtypes = [POINTER(FrVect), c_double, c_double]
    FrvFillGaus.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 58
if _libs["libPyFd.so"].has("FrvGaus", "cdecl"):
    FrvGaus = _libs["libPyFd.so"].get("FrvGaus", "cdecl")
    FrvGaus.argtypes = [c_int]
    FrvGaus.restype = c_double

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 59
if _libs["libPyFd.so"].has("FrvUniform", "cdecl"):
    FrvUniform = _libs["libPyFd.so"].get("FrvUniform", "cdecl")
    FrvUniform.argtypes = []
    FrvUniform.restype = c_double

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 61
if _libs["libPyFd.so"].has("FrvIntegrate", "cdecl"):
    FrvIntegrate = _libs["libPyFd.so"].get("FrvIntegrate", "cdecl")
    FrvIntegrate.argtypes = [POINTER(FrVect), c_int, String]
    FrvIntegrate.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 62
if _libs["libPyFd.so"].has("FrvInterpolate", "cdecl"):
    FrvInterpolate = _libs["libPyFd.so"].get("FrvInterpolate", "cdecl")
    FrvInterpolate.argtypes = [POINTER(FrVect), POINTER(FrVect), c_int, c_int, c_int, String]
    FrvInterpolate.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 63
if _libs["libPyFd.so"].has("FrvInterpolatePhase", "cdecl"):
    FrvInterpolatePhase = _libs["libPyFd.so"].get("FrvInterpolatePhase", "cdecl")
    FrvInterpolatePhase.argtypes = [POINTER(FrVect), POINTER(FrVect), c_int, c_int, c_int, String]
    FrvInterpolatePhase.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 67
if _libs["libPyFd.so"].has("FrvModulus", "cdecl"):
    FrvModulus = _libs["libPyFd.so"].get("FrvModulus", "cdecl")
    FrvModulus.argtypes = [POINTER(FrVect), POINTER(FrVect), String]
    FrvModulus.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 68
if _libs["libPyFd.so"].has("FrvMult", "cdecl"):
    FrvMult = _libs["libPyFd.so"].get("FrvMult", "cdecl")
    FrvMult.argtypes = [POINTER(FrVect), POINTER(FrVect), POINTER(FrVect), String]
    FrvMult.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 69
if _libs["libPyFd.so"].has("FrvMultConj", "cdecl"):
    FrvMultConj = _libs["libPyFd.so"].get("FrvMultConj", "cdecl")
    FrvMultConj.argtypes = [POINTER(FrVect), POINTER(FrVect), POINTER(FrVect), String]
    FrvMultConj.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 70
if _libs["libPyFd.so"].has("FrvPhase", "cdecl"):
    FrvPhase = _libs["libPyFd.so"].get("FrvPhase", "cdecl")
    FrvPhase.argtypes = [POINTER(FrVect), POINTER(FrVect), String]
    FrvPhase.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 71
if _libs["libPyFd.so"].has("FrvRms", "cdecl"):
    FrvRms = _libs["libPyFd.so"].get("FrvRms", "cdecl")
    FrvRms.argtypes = [POINTER(FrVect), POINTER(c_double), POINTER(c_double)]
    FrvRms.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 72
if _libs["libPyFd.so"].has("FrvScale", "cdecl"):
    FrvScale = _libs["libPyFd.so"].get("FrvScale", "cdecl")
    FrvScale.argtypes = [c_double, POINTER(FrVect), POINTER(FrVect), String]
    FrvScale.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 73
if _libs["libPyFd.so"].has("FrvSub", "cdecl"):
    FrvSub = _libs["libPyFd.so"].get("FrvSub", "cdecl")
    FrvSub.argtypes = [POINTER(FrVect), POINTER(FrVect), POINTER(FrVect), String]
    FrvSub.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 74
if _libs["libPyFd.so"].has("FrvZeroMean", "cdecl"):
    FrvZeroMean = _libs["libPyFd.so"].get("FrvZeroMean", "cdecl")
    FrvZeroMean.argtypes = [POINTER(FrVect), POINTER(FrVect)]
    FrvZeroMean.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 21
class struct_FrvCoGap(Structure):
    pass

FrvCoGap = struct_FrvCoGap# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 18

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 42
class struct_FrvTF(Structure):
    pass

FrvTF = struct_FrvTF# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 19

struct_FrvCoGap.__slots__ = [
    'tf',
    'channel1',
    'channel2',
    'nAverage',
    'freqMin',
    'freqMax',
    'threshold',
    'maxFreqGap',
    'meanCoherence',
    'startGap',
    'GTime',
]
struct_FrvCoGap._fields_ = [
    ('tf', POINTER(FrvTF)),
    ('channel1', String),
    ('channel2', String),
    ('nAverage', c_int),
    ('freqMin', c_double),
    ('freqMax', c_double),
    ('threshold', c_double),
    ('maxFreqGap', c_double),
    ('meanCoherence', c_double),
    ('startGap', c_double),
    ('GTime', c_double),
]

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 35
if _libs["libPyFd.so"].has("FrvCoGapFree", "cdecl"):
    FrvCoGapFree = _libs["libPyFd.so"].get("FrvCoGapFree", "cdecl")
    FrvCoGapFree.argtypes = [POINTER(FrvCoGap)]
    FrvCoGapFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 36
if _libs["libPyFd.so"].has("FrvCoGapNew", "cdecl"):
    FrvCoGapNew = _libs["libPyFd.so"].get("FrvCoGapNew", "cdecl")
    FrvCoGapNew.argtypes = [String, String, c_double, c_int, c_double, c_double, c_double]
    FrvCoGapNew.restype = POINTER(FrvCoGap)

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 39
if _libs["libPyFd.so"].has("FrvCoGapProc", "cdecl"):
    FrvCoGapProc = _libs["libPyFd.so"].get("FrvCoGapProc", "cdecl")
    FrvCoGapProc.argtypes = [POINTER(FrvCoGap), POINTER(FrameH)]
    FrvCoGapProc.restype = c_int

struct_FrvTF.__slots__ = [
    'decay',
    'nAverage',
    'outSize',
    'decimate',
    'duration',
    'optionC',
    'optionE',
    'output',
    'correlation',
    'modulus',
    'phase',
    'coherence',
    'errorM',
    'errorP',
    'bufferS',
    'bufferR',
    'fftS',
    'fftR',
    'nCall',
    'err',
]
struct_FrvTF._fields_ = [
    ('decay', c_double),
    ('nAverage', c_long),
    ('outSize', c_int),
    ('decimate', c_int),
    ('duration', c_double),
    ('optionC', FRBOOL),
    ('optionE', FRBOOL),
    ('output', POINTER(FrVect)),
    ('correlation', POINTER(FrVect)),
    ('modulus', POINTER(FrVect)),
    ('phase', POINTER(FrVect)),
    ('coherence', POINTER(FrVect)),
    ('errorM', POINTER(FrVect)),
    ('errorP', POINTER(FrVect)),
    ('bufferS', POINTER(FrvBuf)),
    ('bufferR', POINTER(FrvBuf)),
    ('fftS', POINTER(FrvRFFT)),
    ('fftR', POINTER(FrvRFFT)),
    ('nCall', c_long),
    ('err', c_char * int(256)),
]

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 68
if _libs["libPyFd.so"].has("FrvTFError", "cdecl"):
    FrvTFError = _libs["libPyFd.so"].get("FrvTFError", "cdecl")
    FrvTFError.argtypes = [POINTER(FrvTF)]
    FrvTFError.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 69
if _libs["libPyFd.so"].has("FrvTFFree", "cdecl"):
    FrvTFFree = _libs["libPyFd.so"].get("FrvTFFree", "cdecl")
    FrvTFFree.argtypes = [POINTER(FrvTF)]
    FrvTFFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 70
if _libs["libPyFd.so"].has("FrvTFInit", "cdecl"):
    FrvTFInit = _libs["libPyFd.so"].get("FrvTFInit", "cdecl")
    FrvTFInit.argtypes = [POINTER(FrvTF), POINTER(FrVect), POINTER(FrVect)]
    FrvTFInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 71
if _libs["libPyFd.so"].has("FrvTFNew", "cdecl"):
    FrvTFNew = _libs["libPyFd.so"].get("FrvTFNew", "cdecl")
    FrvTFNew.argtypes = [String, c_int, c_int]
    FrvTFNew.restype = POINTER(FrvTF)

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 72
if _libs["libPyFd.so"].has("FrvTFNewT", "cdecl"):
    FrvTFNewT = _libs["libPyFd.so"].get("FrvTFNewT", "cdecl")
    FrvTFNewT.argtypes = [String, c_double, c_int]
    FrvTFNewT.restype = POINTER(FrvTF)

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 73
if _libs["libPyFd.so"].has("FrvTFProc", "cdecl"):
    FrvTFProc = _libs["libPyFd.so"].get("FrvTFProc", "cdecl")
    FrvTFProc.argtypes = [POINTER(FrvTF), POINTER(FrVect), POINTER(FrVect)]
    FrvTFProc.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 74
if _libs["libPyFd.so"].has("FrvTFReset", "cdecl"):
    FrvTFReset = _libs["libPyFd.so"].get("FrvTFReset", "cdecl")
    FrvTFReset.argtypes = [POINTER(FrvTF)]
    FrvTFReset.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 19
class struct_FrvCorr(Structure):
    pass

FrvCorr = struct_FrvCorr# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 17

struct_FrvCorr.__slots__ = [
    'normalize',
    'maxlag',
    'past1',
    'past2',
    'average',
    'present',
    'present0',
    'average0',
    'nCall',
    'error',
]
struct_FrvCorr._fields_ = [
    ('normalize', c_int),
    ('maxlag', c_int),
    ('past1', POINTER(c_double)),
    ('past2', POINTER(c_double)),
    ('average', POINTER(struct_FrVect)),
    ('present', POINTER(struct_FrVect)),
    ('present0', POINTER(c_double)),
    ('average0', POINTER(c_double)),
    ('nCall', c_int),
    ('error', c_char * int(256)),
]

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 36
if _libs["libPyFd.so"].has("FrvCorrFree", "cdecl"):
    FrvCorrFree = _libs["libPyFd.so"].get("FrvCorrFree", "cdecl")
    FrvCorrFree.argtypes = [POINTER(FrvCorr)]
    FrvCorrFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 37
if _libs["libPyFd.so"].has("FrvCorrProc", "cdecl"):
    FrvCorrProc = _libs["libPyFd.so"].get("FrvCorrProc", "cdecl")
    FrvCorrProc.argtypes = [POINTER(FrvCorr), POINTER(FrVect), POINTER(FrVect)]
    FrvCorrProc.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 38
if _libs["libPyFd.so"].has("FrvCorrInit", "cdecl"):
    FrvCorrInit = _libs["libPyFd.so"].get("FrvCorrInit", "cdecl")
    FrvCorrInit.argtypes = [POINTER(FrvCorr), POINTER(FrVect), POINTER(FrVect)]
    FrvCorrInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 39
if _libs["libPyFd.so"].has("FrvCorrNew", "cdecl"):
    FrvCorrNew = _libs["libPyFd.so"].get("FrvCorrNew", "cdecl")
    FrvCorrNew.argtypes = [c_int, c_int]
    FrvCorrNew.restype = POINTER(FrvCorr)

# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 40
if _libs["libPyFd.so"].has("FrvCorrSetPast", "cdecl"):
    FrvCorrSetPast = _libs["libPyFd.so"].get("FrvCorrSetPast", "cdecl")
    FrvCorrSetPast.argtypes = [POINTER(FrvCorr), POINTER(c_double), POINTER(c_double), c_int]
    FrvCorrSetPast.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 19
class struct_FrvLinFilt(Structure):
    pass

FrvLinFilt = struct_FrvLinFilt# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 17

struct_FrvLinFilt.__slots__ = [
    'a',
    'ym',
    'b',
    'xm',
    'na',
    'mb',
    'output',
    'error',
    'nCall',
    'name',
    'outputIsInput',
    'next',
]
struct_FrvLinFilt._fields_ = [
    ('a', POINTER(c_double)),
    ('ym', POINTER(c_double)),
    ('b', POINTER(c_double)),
    ('xm', POINTER(c_double)),
    ('na', c_int),
    ('mb', c_int),
    ('output', POINTER(struct_FrVect)),
    ('error', c_char * int(256)),
    ('nCall', c_int),
    ('name', String),
    ('outputIsInput', FRBOOL),
    ('next', POINTER(FrvLinFilt)),
]

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 36
if _libs["libPyFd.so"].has("FrvLinFiltFree", "cdecl"):
    FrvLinFiltFree = _libs["libPyFd.so"].get("FrvLinFiltFree", "cdecl")
    FrvLinFiltFree.argtypes = [POINTER(FrvLinFilt)]
    FrvLinFiltFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 37
if _libs["libPyFd.so"].has("FrvLinFiltProc", "cdecl"):
    FrvLinFiltProc = _libs["libPyFd.so"].get("FrvLinFiltProc", "cdecl")
    FrvLinFiltProc.argtypes = [POINTER(FrvLinFilt), POINTER(FrVect)]
    FrvLinFiltProc.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 38
if _libs["libPyFd.so"].has("FrvLinFiltInit", "cdecl"):
    FrvLinFiltInit = _libs["libPyFd.so"].get("FrvLinFiltInit", "cdecl")
    FrvLinFiltInit.argtypes = [POINTER(FrvLinFilt), POINTER(FrVect)]
    FrvLinFiltInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 39
if _libs["libPyFd.so"].has("FrvLinFiltNew", "cdecl"):
    FrvLinFiltNew = _libs["libPyFd.so"].get("FrvLinFiltNew", "cdecl")
    FrvLinFiltNew.argtypes = [POINTER(c_double), POINTER(c_double), c_int, c_int]
    FrvLinFiltNew.restype = POINTER(FrvLinFilt)

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 40
if _libs["libPyFd.so"].has("FrvLinFiltSetIni", "cdecl"):
    FrvLinFiltSetIni = _libs["libPyFd.so"].get("FrvLinFiltSetIni", "cdecl")
    FrvLinFiltSetIni.argtypes = [POINTER(FrvLinFilt), POINTER(c_double), POINTER(c_double)]
    FrvLinFiltSetIni.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 41
if _libs["libPyFd.so"].has("FrvLinFiltMult", "cdecl"):
    FrvLinFiltMult = _libs["libPyFd.so"].get("FrvLinFiltMult", "cdecl")
    FrvLinFiltMult.argtypes = [POINTER(FrvLinFilt), POINTER(FrvLinFilt)]
    FrvLinFiltMult.restype = POINTER(FrvLinFilt)

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 42
if _libs["libPyFd.so"].has("FrvLinFiltCopy", "cdecl"):
    FrvLinFiltCopy = _libs["libPyFd.so"].get("FrvLinFiltCopy", "cdecl")
    FrvLinFiltCopy.argtypes = [POINTER(FrvLinFilt)]
    FrvLinFiltCopy.restype = POINTER(FrvLinFilt)

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 43
if _libs["libPyFd.so"].has("FrvLinFiltAddZP", "cdecl"):
    FrvLinFiltAddZP = _libs["libPyFd.so"].get("FrvLinFiltAddZP", "cdecl")
    FrvLinFiltAddZP.argtypes = [POINTER(FrvLinFilt), c_double, c_double, c_int]
    FrvLinFiltAddZP.restype = POINTER(FrvLinFilt)

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 44
if _libs["libPyFd.so"].has("FrvLinFiltSetGain", "cdecl"):
    FrvLinFiltSetGain = _libs["libPyFd.so"].get("FrvLinFiltSetGain", "cdecl")
    FrvLinFiltSetGain.argtypes = [POINTER(FrvLinFilt), c_double, c_double]
    FrvLinFiltSetGain.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 45
if _libs["libPyFd.so"].has("FrvButtOrder", "cdecl"):
    FrvButtOrder = _libs["libPyFd.so"].get("FrvButtOrder", "cdecl")
    FrvButtOrder.argtypes = [c_double, c_double, c_double, c_double, POINTER(c_double)]
    FrvButtOrder.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 46
if _libs["libPyFd.so"].has("FrvButtFilt", "cdecl"):
    FrvButtFilt = _libs["libPyFd.so"].get("FrvButtFilt", "cdecl")
    FrvButtFilt.argtypes = [c_int, c_double, POINTER(c_double), POINTER(c_double)]
    FrvButtFilt.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 47
if _libs["libPyFd.so"].has("FrvButtCell", "cdecl"):
    FrvButtCell = _libs["libPyFd.so"].get("FrvButtCell", "cdecl")
    FrvButtCell.argtypes = [c_double, c_int, c_int, POINTER(c_double), POINTER(c_double)]
    FrvButtCell.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 48
if _libs["libPyFd.so"].has("FrvLinFiltButt", "cdecl"):
    FrvLinFiltButt = _libs["libPyFd.so"].get("FrvLinFiltButt", "cdecl")
    FrvLinFiltButt.argtypes = [c_double, c_double, c_double, c_double, c_int, c_double]
    FrvLinFiltButt.restype = POINTER(FrvLinFilt)

# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 49
if _libs["libPyFd.so"].has("FrvLinFiltButtLowToHigh", "cdecl"):
    FrvLinFiltButtLowToHigh = _libs["libPyFd.so"].get("FrvLinFiltButtLowToHigh", "cdecl")
    FrvLinFiltButtLowToHigh.argtypes = [POINTER(FrvLinFilt)]
    FrvLinFiltButtLowToHigh.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 32
class struct_FrvSmartD(Structure):
    pass

FrvSmartD = struct_FrvSmartD# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 30

struct_FrvSmartD.__slots__ = [
    'factor',
    'nsteps',
    'steps',
    'bank',
    'vectors',
    'error',
    'input',
    'output',
    'name',
    'next',
]
struct_FrvSmartD._fields_ = [
    ('factor', c_int),
    ('nsteps', c_int),
    ('steps', POINTER(c_int)),
    ('bank', POINTER(POINTER(FrvLinFilt))),
    ('vectors', POINTER(POINTER(FrVect))),
    ('error', c_char * int(256)),
    ('input', POINTER(FrVect)),
    ('output', POINTER(FrVect)),
    ('name', String),
    ('next', POINTER(FrvSmartD)),
]

# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 48
if _libs["libPyFd.so"].has("FrvSmartDInit", "cdecl"):
    FrvSmartDInit = _libs["libPyFd.so"].get("FrvSmartDInit", "cdecl")
    FrvSmartDInit.argtypes = [c_int, c_double, c_double, c_double, c_double]
    FrvSmartDInit.restype = POINTER(FrvSmartD)

# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 49
if _libs["libPyFd.so"].has("FrvSmartDFree", "cdecl"):
    FrvSmartDFree = _libs["libPyFd.so"].get("FrvSmartDFree", "cdecl")
    FrvSmartDFree.argtypes = [POINTER(FrvSmartD)]
    FrvSmartDFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 50
if _libs["libPyFd.so"].has("FrvSmartDProc", "cdecl"):
    FrvSmartDProc = _libs["libPyFd.so"].get("FrvSmartDProc", "cdecl")
    FrvSmartDProc.argtypes = [POINTER(FrvSmartD), POINTER(FrVect), POINTER(FrVect)]
    FrvSmartDProc.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 51
if _libs["libPyFd.so"].has("FrvSmartDReset", "cdecl"):
    FrvSmartDReset = _libs["libPyFd.so"].get("FrvSmartDReset", "cdecl")
    FrvSmartDReset.argtypes = [POINTER(FrvSmartD), c_double]
    FrvSmartDReset.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 22
class struct_FrvFDFilter(Structure):
    pass

FrvFDFilter = struct_FrvFDFilter# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 15

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 47
class struct_FrvFDFilterOut(Structure):
    pass

FrvFDFilterOut = struct_FrvFDFilterOut# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 16

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 61
class struct_FrvFDFHole(Structure):
    pass

FrvFDFHole = struct_FrvFDFHole# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 17

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 69
class struct_FrvFDFTFBin(Structure):
    pass

FrvFDFTFBin = struct_FrvFDFTFBin# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 18

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 83
class struct_FrvFDFilter2(Structure):
    pass

FrvFDFilter2 = struct_FrvFDFilter2# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 19

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 76
class struct_FrvFDFPhaseBump(Structure):
    pass

FrvFDFPhaseBump = struct_FrvFDFPhaseBump# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 20

struct_FrvFDFilter.__slots__ = [
    'name',
    'gain',
    'delay',
    'nData',
    'first',
    'buffer',
    'windowIn',
    'fftInput',
    'fft',
    'fftTF',
    'plan_for',
    'hole',
    'filter2',
    'tfBins',
    'tfBinLast',
    'phaseBump',
    'tf',
    'tfModulus',
    'tfPhase',
    'fOut',
    'dTF',
    'next',
]
struct_FrvFDFilter._fields_ = [
    ('name', String),
    ('gain', c_double),
    ('delay', c_double),
    ('nData', c_int),
    ('first', c_int),
    ('buffer', POINTER(FrvBuf)),
    ('windowIn', POINTER(FrVect)),
    ('fftInput', POINTER(FrVect)),
    ('fft', POINTER(FrVect)),
    ('fftTF', POINTER(FrVect)),
    ('plan_for', POINTER(None)),
    ('hole', POINTER(FrvFDFHole)),
    ('filter2', POINTER(FrvFDFilter2)),
    ('tfBins', POINTER(FrvFDFTFBin)),
    ('tfBinLast', POINTER(FrvFDFTFBin)),
    ('phaseBump', POINTER(FrvFDFPhaseBump)),
    ('tf', POINTER(FrVect)),
    ('tfModulus', POINTER(FrVect)),
    ('tfPhase', POINTER(FrVect)),
    ('fOut', POINTER(FrvFDFilterOut)),
    ('dTF', POINTER(FrVect)),
    ('next', POINTER(FrvFDFilter)),
]

struct_FrvFDFilterOut.__slots__ = [
    'sampleRateOut',
    'freqStart',
    'windowOut',
    'fftResized',
    'fftOut',
    'output1',
    'output2',
    'last',
    'output',
    'plan_back',
    'deadZone',
]
struct_FrvFDFilterOut._fields_ = [
    ('sampleRateOut', c_double),
    ('freqStart', c_double),
    ('windowOut', POINTER(FrVect)),
    ('fftResized', POINTER(FrVect)),
    ('fftOut', POINTER(FrVect)),
    ('output1', POINTER(FrVect)),
    ('output2', POINTER(FrVect)),
    ('last', POINTER(FrVect)),
    ('output', POINTER(FrVect)),
    ('plan_back', POINTER(None)),
    ('deadZone', c_double),
]

struct_FrvFDFHole.__slots__ = [
    'fMin',
    'fMax',
    'scale',
    'delay',
    'next',
]
struct_FrvFDFHole._fields_ = [
    ('fMin', c_double),
    ('fMax', c_double),
    ('scale', c_double),
    ('delay', c_double),
    ('next', POINTER(FrvFDFHole)),
]

struct_FrvFDFTFBin.__slots__ = [
    'freq',
    'scale',
    'phase',
    'next',
]
struct_FrvFDFTFBin._fields_ = [
    ('freq', c_double),
    ('scale', c_double),
    ('phase', c_double),
    ('next', POINTER(FrvFDFTFBin)),
]

struct_FrvFDFPhaseBump.__slots__ = [
    'freq',
    'width',
    'dPhi',
    'next',
]
struct_FrvFDFPhaseBump._fields_ = [
    ('freq', c_double),
    ('width', c_double),
    ('dPhi', c_double),
    ('next', POINTER(FrvFDFPhaseBump)),
]

struct_FrvFDFilter2.__slots__ = [
    'fStart',
    'scale',
    'delay',
    'a0',
    'a1',
    'a2',
    'b0',
    'b1',
    'b2',
    'next',
]
struct_FrvFDFilter2._fields_ = [
    ('fStart', c_double),
    ('scale', c_double),
    ('delay', c_double),
    ('a0', c_double),
    ('a1', c_double),
    ('a2', c_double),
    ('b0', c_double),
    ('b1', c_double),
    ('b2', c_double),
    ('next', POINTER(FrvFDFilter2)),
]

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 115
if _libs["libPyFd.so"].has("FrvFDFilterNew", "cdecl"):
    FrvFDFilterNew = _libs["libPyFd.so"].get("FrvFDFilterNew", "cdecl")
    FrvFDFilterNew.argtypes = [c_double, c_double, c_double, c_double]
    FrvFDFilterNew.restype = POINTER(FrvFDFilter)

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 118
if _libs["libPyFd.so"].has("FrvFDFilterAddHole", "cdecl"):
    FrvFDFilterAddHole = _libs["libPyFd.so"].get("FrvFDFilterAddHole", "cdecl")
    FrvFDFilterAddHole.argtypes = [POINTER(FrvFDFilter), c_double, c_double, c_double, c_double]
    FrvFDFilterAddHole.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 121
if _libs["libPyFd.so"].has("FrvFDFilterAddTFBin", "cdecl"):
    FrvFDFilterAddTFBin = _libs["libPyFd.so"].get("FrvFDFilterAddTFBin", "cdecl")
    FrvFDFilterAddTFBin.argtypes = [POINTER(FrvFDFilter), c_double, c_double, c_double]
    FrvFDFilterAddTFBin.restype = POINTER(FrvFDFTFBin)

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 123
if _libs["libPyFd.so"].has("FrvFDFilterAddFilter2", "cdecl"):
    FrvFDFilterAddFilter2 = _libs["libPyFd.so"].get("FrvFDFilterAddFilter2", "cdecl")
    FrvFDFilterAddFilter2.argtypes = [POINTER(FrvFDFilter), c_double, c_double, c_double, c_double, c_double, c_double, c_double, c_double, c_double]
    FrvFDFilterAddFilter2.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 128
if _libs["libPyFd.so"].has("FrvFDFilterAddPole", "cdecl"):
    FrvFDFilterAddPole = _libs["libPyFd.so"].get("FrvFDFilterAddPole", "cdecl")
    FrvFDFilterAddPole.argtypes = [POINTER(FrvFDFilter), c_double, c_double]
    FrvFDFilterAddPole.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 129
if _libs["libPyFd.so"].has("FrvFDFilterAddZero", "cdecl"):
    FrvFDFilterAddZero = _libs["libPyFd.so"].get("FrvFDFilterAddZero", "cdecl")
    FrvFDFilterAddZero.argtypes = [POINTER(FrvFDFilter), c_double, c_double]
    FrvFDFilterAddZero.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 130
if _libs["libPyFd.so"].has("FrvFDFilterAddPhaseBump", "cdecl"):
    FrvFDFilterAddPhaseBump = _libs["libPyFd.so"].get("FrvFDFilterAddPhaseBump", "cdecl")
    FrvFDFilterAddPhaseBump.argtypes = [POINTER(FrvFDFilter), c_double, c_double, c_double]
    FrvFDFilterAddPhaseBump.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 135
if _libs["libPyFd.so"].has("FrvFDFilterBuildTFBin", "cdecl"):
    FrvFDFilterBuildTFBin = _libs["libPyFd.so"].get("FrvFDFilterBuildTFBin", "cdecl")
    FrvFDFilterBuildTFBin.argtypes = [POINTER(FrvFDFilter)]
    FrvFDFilterBuildTFBin.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 136
if _libs["libPyFd.so"].has("FrvFDFilterOutNew", "cdecl"):
    FrvFDFilterOutNew = _libs["libPyFd.so"].get("FrvFDFilterOutNew", "cdecl")
    FrvFDFilterOutNew.argtypes = [c_double]
    FrvFDFilterOutNew.restype = POINTER(FrvFDFilterOut)

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 137
if _libs["libPyFd.so"].has("FrvFDFilterOutNewHP", "cdecl"):
    FrvFDFilterOutNewHP = _libs["libPyFd.so"].get("FrvFDFilterOutNewHP", "cdecl")
    FrvFDFilterOutNewHP.argtypes = [c_double, c_double]
    FrvFDFilterOutNewHP.restype = POINTER(FrvFDFilterOut)

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 138
if _libs["libPyFd.so"].has("FrvFDFilterOutInit", "cdecl"):
    FrvFDFilterOutInit = _libs["libPyFd.so"].get("FrvFDFilterOutInit", "cdecl")
    FrvFDFilterOutInit.argtypes = [POINTER(FrvFDFilterOut), POINTER(FrVect)]
    FrvFDFilterOutInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 139
if _libs["libPyFd.so"].has("FrvFDFilterOutProc", "cdecl"):
    FrvFDFilterOutProc = _libs["libPyFd.so"].get("FrvFDFilterOutProc", "cdecl")
    FrvFDFilterOutProc.argtypes = [POINTER(FrvFDFilterOut), POINTER(FrVect), c_double]
    FrvFDFilterOutProc.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 141
if _libs["libPyFd.so"].has("FrvFDFilterInit", "cdecl"):
    FrvFDFilterInit = _libs["libPyFd.so"].get("FrvFDFilterInit", "cdecl")
    FrvFDFilterInit.argtypes = [POINTER(FrvFDFilter), POINTER(FrVect)]
    FrvFDFilterInit.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 142
if _libs["libPyFd.so"].has("FrvFDFilterSetName", "cdecl"):
    FrvFDFilterSetName = _libs["libPyFd.so"].get("FrvFDFilterSetName", "cdecl")
    FrvFDFilterSetName.argtypes = [POINTER(FrvFDFilter), String]
    FrvFDFilterSetName.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 143
if _libs["libPyFd.so"].has("FrvFDFilterSetSkip", "cdecl"):
    FrvFDFilterSetSkip = _libs["libPyFd.so"].get("FrvFDFilterSetSkip", "cdecl")
    FrvFDFilterSetSkip.argtypes = [POINTER(FrvFDFilter), c_double]
    FrvFDFilterSetSkip.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 144
if _libs["libPyFd.so"].has("FrvFDFilterPhaseAt", "cdecl"):
    FrvFDFilterPhaseAt = _libs["libPyFd.so"].get("FrvFDFilterPhaseAt", "cdecl")
    FrvFDFilterPhaseAt.argtypes = [POINTER(FrvFDFilter), c_double]
    FrvFDFilterPhaseAt.restype = c_double

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 145
if _libs["libPyFd.so"].has("FrvFDFilterProc", "cdecl"):
    FrvFDFilterProc = _libs["libPyFd.so"].get("FrvFDFilterProc", "cdecl")
    FrvFDFilterProc.argtypes = [POINTER(FrvFDFilter), POINTER(FrVect)]
    FrvFDFilterProc.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 146
if _libs["libPyFd.so"].has("FrvFDFilterProcFFT", "cdecl"):
    FrvFDFilterProcFFT = _libs["libPyFd.so"].get("FrvFDFilterProcFFT", "cdecl")
    FrvFDFilterProcFFT.argtypes = [POINTER(FrvFDFilter), POINTER(FrVect)]
    FrvFDFilterProcFFT.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 147
if _libs["libPyFd.so"].has("FrvFDFilterProcTF", "cdecl"):
    FrvFDFilterProcTF = _libs["libPyFd.so"].get("FrvFDFilterProcTF", "cdecl")
    FrvFDFilterProcTF.argtypes = [POINTER(FrvFDFilter)]
    FrvFDFilterProcTF.restype = c_int

# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 148
if _libs["libPyFd.so"].has("FrvFDFilterFree", "cdecl"):
    FrvFDFilterFree = _libs["libPyFd.so"].get("FrvFDFilterFree", "cdecl")
    FrvFDFilterFree.argtypes = [POINTER(FrvFDFilter)]
    FrvFDFilterFree.restype = POINTER(c_ubyte)
    FrvFDFilterFree.errcheck = lambda v,*a : cast(v, c_void_p)

# /virgoApp/Frv/v4r35p2/src/Frv.h: 21
if _libs["libPyFd.so"].has("FrvLibVersion", "cdecl"):
    FrvLibVersion = _libs["libPyFd.so"].get("FrvLibVersion", "cdecl")
    FrvLibVersion.argtypes = [POINTER(FILE)]
    FrvLibVersion.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 16
class struct_FrvCh(Structure):
    pass

struct_FrvCh.__slots__ = [
    'name',
    'smsParam',
    'duration',
    'stillToFeed',
    'lastGPS',
    'dt',
    'init',
    'isSerData',
    'buffer',
    'output',
]
struct_FrvCh._fields_ = [
    ('name', String),
    ('smsParam', String),
    ('duration', c_double),
    ('stillToFeed', c_double),
    ('lastGPS', c_double),
    ('dt', c_int),
    ('init', FRBOOL),
    ('isSerData', FRBOOL),
    ('buffer', POINTER(FrvBuf)),
    ('output', POINTER(FrVect)),
]

FrvCh = struct_FrvCh# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 29

# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 31
if _libs["libPyFd.so"].has("FrvChFree", "cdecl"):
    FrvChFree = _libs["libPyFd.so"].get("FrvChFree", "cdecl")
    FrvChFree.argtypes = [POINTER(FrvCh)]
    FrvChFree.restype = None

# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 32
if _libs["libPyFd.so"].has("FrvChFeed", "cdecl"):
    FrvChFeed = _libs["libPyFd.so"].get("FrvChFeed", "cdecl")
    FrvChFeed.argtypes = [POINTER(FrvCh), POINTER(FrameH)]
    FrvChFeed.restype = c_double

# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 33
if _libs["libPyFd.so"].has("FrvChGetVect", "cdecl"):
    FrvChGetVect = _libs["libPyFd.so"].get("FrvChGetVect", "cdecl")
    FrvChGetVect.argtypes = [POINTER(FrvCh)]
    FrvChGetVect.restype = POINTER(FrVect)

# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 34
if _libs["libPyFd.so"].has("FrvChNew", "cdecl"):
    FrvChNew = _libs["libPyFd.so"].get("FrvChNew", "cdecl")
    FrvChNew.argtypes = [String, c_double]
    FrvChNew.restype = POINTER(FrvCh)

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 7
class struct_FdCList(Structure):
    pass

FdCList = struct_FdCList# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 5

struct_FdCList.__slots__ = [
    'gps_ms',
    'nSorted',
    'nChnl',
    'maxChnl',
    'chnl',
    'nDuplicated',
    'firstDup',
]
struct_FdCList._fields_ = [
    ('gps_ms', c_long),
    ('nSorted', c_int),
    ('nChnl', c_int),
    ('maxChnl', c_int),
    ('chnl', POINTER(POINTER(c_int))),
    ('nDuplicated', c_int),
    ('firstDup', c_char * int(512)),
]

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 20
if _libs["libPyFd.so"].has("FdCListNew", "cdecl"):
    FdCListNew = _libs["libPyFd.so"].get("FdCListNew", "cdecl")
    FdCListNew.argtypes = []
    FdCListNew.restype = POINTER(FdCList)

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 21
if _libs["libPyFd.so"].has("FdCListBuildAdc", "cdecl"):
    FdCListBuildAdc = _libs["libPyFd.so"].get("FdCListBuildAdc", "cdecl")
    FdCListBuildAdc.argtypes = [POINTER(FdCList), POINTER(FrameH), c_int]
    FdCListBuildAdc.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 22
if _libs["libPyFd.so"].has("FdCListBuildSer", "cdecl"):
    FdCListBuildSer = _libs["libPyFd.so"].get("FdCListBuildSer", "cdecl")
    FdCListBuildSer.argtypes = [POINTER(FdCList), POINTER(FrameH), c_int]
    FdCListBuildSer.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 23
if _libs["libPyFd.so"].has("FdCListBuildSim", "cdecl"):
    FdCListBuildSim = _libs["libPyFd.so"].get("FdCListBuildSim", "cdecl")
    FdCListBuildSim.argtypes = [POINTER(FdCList), POINTER(FrameH), c_int]
    FdCListBuildSim.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 24
if _libs["libPyFd.so"].has("FdCListBuildProc", "cdecl"):
    FdCListBuildProc = _libs["libPyFd.so"].get("FdCListBuildProc", "cdecl")
    FdCListBuildProc.argtypes = [POINTER(FdCList), POINTER(FrameH), c_int]
    FdCListBuildProc.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 25
if _libs["libPyFd.so"].has("FdCListDump", "cdecl"):
    FdCListDump = _libs["libPyFd.so"].get("FdCListDump", "cdecl")
    FdCListDump.argtypes = [POINTER(FdCList)]
    if sizeof(c_int) == sizeof(c_void_p):
        FdCListDump.restype = ReturnString
    else:
        FdCListDump.restype = String
        FdCListDump.errcheck = ReturnString

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 26
if _libs["libPyFd.so"].has("FdCListFree", "cdecl"):
    FdCListFree = _libs["libPyFd.so"].get("FdCListFree", "cdecl")
    FdCListFree.argtypes = [POINTER(FdCList)]
    FdCListFree.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 27
if _libs["libPyFd.so"].has("FdCListMerge", "cdecl"):
    FdCListMerge = _libs["libPyFd.so"].get("FdCListMerge", "cdecl")
    FdCListMerge.argtypes = [POINTER(FdCList), POINTER(FdCList), POINTER(FdCList), POINTER(FdCList)]
    FdCListMerge.restype = POINTER(FdCList)

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 10
for _lib in _libs.values():
    if not _lib.has("FdOCmSendAdd", "cdecl"):
        continue
    FdOCmSendAdd = _lib.get("FdOCmSendAdd", "cdecl")
    FdOCmSendAdd.argtypes = [String, String, String, c_int, c_int]
    FdOCmSendAdd.restype = c_int
    break

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 12
for _lib in _libs.values():
    if not _lib.has("FdOCmSendRemove", "cdecl"):
        continue
    FdOCmSendRemove = _lib.get("FdOCmSendRemove", "cdecl")
    FdOCmSendRemove.argtypes = [String, String]
    FdOCmSendRemove.restype = c_int
    break

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 13
if _libs["libPyFd.so"].has("FdOCmServerAdd", "cdecl"):
    FdOCmServerAdd = _libs["libPyFd.so"].get("FdOCmServerAdd", "cdecl")
    FdOCmServerAdd.argtypes = [c_int, c_int, c_int]
    FdOCmServerAdd.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 14
if _libs["libPyFd.so"].has("FdDataSenderRequest", "cdecl"):
    FdDataSenderRequest = _libs["libPyFd.so"].get("FdDataSenderRequest", "cdecl")
    FdDataSenderRequest.argtypes = [String, String, String, c_int, c_int, c_int]
    FdDataSenderRequest.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 16
if _libs["libPyFd.so"].has("FdOCmCleanup", "cdecl"):
    FdOCmCleanup = _libs["libPyFd.so"].get("FdOCmCleanup", "cdecl")
    FdOCmCleanup.argtypes = []
    FdOCmCleanup.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdCm.h: 18
for _lib in _libs.values():
    if not _lib.has("FdGetFrameWithSize", "cdecl"):
        continue
    FdGetFrameWithSize = _lib.get("FdGetFrameWithSize", "cdecl")
    FdGetFrameWithSize.argtypes = [CmMessage, c_int, POINTER(c_int)]
    FdGetFrameWithSize.restype = POINTER(FrameH)
    break

# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 18
class struct_FdFrMrgr(Structure):
    pass

FdFrMrgr = struct_FdFrMrgr# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 16

struct_FdFrMrgr.__slots__ = [
    'sList',
    'nFrames',
    'debug',
    'nSources',
    'nMissing',
    'lastGpsOut',
    'sNames',
    'frames',
    'gps',
    'missingSt',
    'missingPr',
    'latencies',
    'missingSrc',
    'serData',
    'serDataSize',
    'nOuts',
    'status',
]
struct_FdFrMrgr._fields_ = [
    ('sList', String),
    ('nFrames', c_int),
    ('debug', c_int),
    ('nSources', c_int),
    ('nMissing', c_int),
    ('lastGpsOut', c_double),
    ('sNames', POINTER(POINTER(c_char))),
    ('frames', POINTER(POINTER(FrameH))),
    ('gps', POINTER(c_double)),
    ('missingSt', POINTER(FRBOOL)),
    ('missingPr', POINTER(FRBOOL)),
    ('latencies', POINTER(c_double)),
    ('missingSrc', String),
    ('serData', String),
    ('serDataSize', c_int),
    ('nOuts', c_int),
    ('status', String),
]

# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 40
if _libs["libPyFd.so"].has("FdFrMrgrAddSource", "cdecl"):
    FdFrMrgrAddSource = _libs["libPyFd.so"].get("FdFrMrgrAddSource", "cdecl")
    FdFrMrgrAddSource.argtypes = [POINTER(FdFrMrgr), String]
    FdFrMrgrAddSource.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 41
if _libs["libPyFd.so"].has("FdFrMrgrNew", "cdecl"):
    FdFrMrgrNew = _libs["libPyFd.so"].get("FdFrMrgrNew", "cdecl")
    FdFrMrgrNew.argtypes = [c_int, String]
    FdFrMrgrNew.restype = POINTER(FdFrMrgr)

# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 42
if _libs["libPyFd.so"].has("FdFrMrgrProc", "cdecl"):
    FdFrMrgrProc = _libs["libPyFd.so"].get("FdFrMrgrProc", "cdecl")
    FdFrMrgrProc.argtypes = [POINTER(FdFrMrgr), POINTER(FrameH), String]
    FdFrMrgrProc.restype = POINTER(FrameH)

# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 43
if _libs["libPyFd.so"].has("FdFrMrgrRemoveSource", "cdecl"):
    FdFrMrgrRemoveSource = _libs["libPyFd.so"].get("FdFrMrgrRemoveSource", "cdecl")
    FdFrMrgrRemoveSource.argtypes = [POINTER(FdFrMrgr), String]
    FdFrMrgrRemoveSource.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 82
class struct_FdIO(Structure):
    pass

FdIO = struct_FdIO# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 11

useconds_t = __useconds_t# /usr/include/unistd.h: 255

intptr_t = __intptr_t# /usr/include/unistd.h: 267

socklen_t = __socklen_t# /usr/include/unistd.h: 274

# /usr/include/unistd.h: 287
if _libs["libPyFd.so"].has("access", "cdecl"):
    access = _libs["libPyFd.so"].get("access", "cdecl")
    access.argtypes = [String, c_int]
    access.restype = c_int

# /usr/include/unistd.h: 304
if _libs["libPyFd.so"].has("faccessat", "cdecl"):
    faccessat = _libs["libPyFd.so"].get("faccessat", "cdecl")
    faccessat.argtypes = [c_int, String, c_int, c_int]
    faccessat.restype = c_int

# /usr/include/unistd.h: 334
if _libs["libPyFd.so"].has("lseek", "cdecl"):
    lseek = _libs["libPyFd.so"].get("lseek", "cdecl")
    lseek.argtypes = [c_int, __off_t, c_int]
    lseek.restype = __off_t

# /usr/include/unistd.h: 353
if _libs["libPyFd.so"].has("close", "cdecl"):
    close = _libs["libPyFd.so"].get("close", "cdecl")
    close.argtypes = [c_int]
    close.restype = c_int

# /usr/include/unistd.h: 360
if _libs["libPyFd.so"].has("read", "cdecl"):
    read = _libs["libPyFd.so"].get("read", "cdecl")
    read.argtypes = [c_int, POINTER(None), c_size_t]
    read.restype = c_ptrdiff_t

# /usr/include/unistd.h: 366
if _libs["libPyFd.so"].has("write", "cdecl"):
    write = _libs["libPyFd.so"].get("write", "cdecl")
    write.argtypes = [c_int, POINTER(None), c_size_t]
    write.restype = c_ptrdiff_t

# /usr/include/unistd.h: 376
if _libs["libPyFd.so"].has("pread", "cdecl"):
    pread = _libs["libPyFd.so"].get("pread", "cdecl")
    pread.argtypes = [c_int, POINTER(None), c_size_t, __off_t]
    pread.restype = c_ptrdiff_t

# /usr/include/unistd.h: 384
if _libs["libPyFd.so"].has("pwrite", "cdecl"):
    pwrite = _libs["libPyFd.so"].get("pwrite", "cdecl")
    pwrite.argtypes = [c_int, POINTER(None), c_size_t, __off_t]
    pwrite.restype = c_ptrdiff_t

# /usr/include/unistd.h: 417
if _libs["libPyFd.so"].has("pipe", "cdecl"):
    pipe = _libs["libPyFd.so"].get("pipe", "cdecl")
    pipe.argtypes = [c_int * int(2)]
    pipe.restype = c_int

# /usr/include/unistd.h: 432
if _libs["libPyFd.so"].has("alarm", "cdecl"):
    alarm = _libs["libPyFd.so"].get("alarm", "cdecl")
    alarm.argtypes = [c_uint]
    alarm.restype = c_uint

# /usr/include/unistd.h: 444
if _libs["libPyFd.so"].has("sleep", "cdecl"):
    sleep = _libs["libPyFd.so"].get("sleep", "cdecl")
    sleep.argtypes = [c_uint]
    sleep.restype = c_uint

# /usr/include/unistd.h: 452
if _libs["libPyFd.so"].has("ualarm", "cdecl"):
    ualarm = _libs["libPyFd.so"].get("ualarm", "cdecl")
    ualarm.argtypes = [__useconds_t, __useconds_t]
    ualarm.restype = __useconds_t

# /usr/include/unistd.h: 460
if _libs["libPyFd.so"].has("usleep", "cdecl"):
    usleep = _libs["libPyFd.so"].get("usleep", "cdecl")
    usleep.argtypes = [__useconds_t]
    usleep.restype = c_int

# /usr/include/unistd.h: 469
if _libs["libPyFd.so"].has("pause", "cdecl"):
    pause = _libs["libPyFd.so"].get("pause", "cdecl")
    pause.argtypes = []
    pause.restype = c_int

# /usr/include/unistd.h: 473
if _libs["libPyFd.so"].has("chown", "cdecl"):
    chown = _libs["libPyFd.so"].get("chown", "cdecl")
    chown.argtypes = [String, __uid_t, __gid_t]
    chown.restype = c_int

# /usr/include/unistd.h: 478
if _libs["libPyFd.so"].has("fchown", "cdecl"):
    fchown = _libs["libPyFd.so"].get("fchown", "cdecl")
    fchown.argtypes = [c_int, __uid_t, __gid_t]
    fchown.restype = c_int

# /usr/include/unistd.h: 483
if _libs["libPyFd.so"].has("lchown", "cdecl"):
    lchown = _libs["libPyFd.so"].get("lchown", "cdecl")
    lchown.argtypes = [String, __uid_t, __gid_t]
    lchown.restype = c_int

# /usr/include/unistd.h: 491
if _libs["libPyFd.so"].has("fchownat", "cdecl"):
    fchownat = _libs["libPyFd.so"].get("fchownat", "cdecl")
    fchownat.argtypes = [c_int, String, __uid_t, __gid_t, c_int]
    fchownat.restype = c_int

# /usr/include/unistd.h: 497
if _libs["libPyFd.so"].has("chdir", "cdecl"):
    chdir = _libs["libPyFd.so"].get("chdir", "cdecl")
    chdir.argtypes = [String]
    chdir.restype = c_int

# /usr/include/unistd.h: 501
if _libs["libPyFd.so"].has("fchdir", "cdecl"):
    fchdir = _libs["libPyFd.so"].get("fchdir", "cdecl")
    fchdir.argtypes = [c_int]
    fchdir.restype = c_int

# /usr/include/unistd.h: 511
if _libs["libPyFd.so"].has("getcwd", "cdecl"):
    getcwd = _libs["libPyFd.so"].get("getcwd", "cdecl")
    getcwd.argtypes = [String, c_size_t]
    if sizeof(c_int) == sizeof(c_void_p):
        getcwd.restype = ReturnString
    else:
        getcwd.restype = String
        getcwd.errcheck = ReturnString

# /usr/include/unistd.h: 525
if _libs["libPyFd.so"].has("getwd", "cdecl"):
    getwd = _libs["libPyFd.so"].get("getwd", "cdecl")
    getwd.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        getwd.restype = ReturnString
    else:
        getwd.restype = String
        getwd.errcheck = ReturnString

# /usr/include/unistd.h: 531
if _libs["libPyFd.so"].has("dup", "cdecl"):
    dup = _libs["libPyFd.so"].get("dup", "cdecl")
    dup.argtypes = [c_int]
    dup.restype = c_int

# /usr/include/unistd.h: 534
if _libs["libPyFd.so"].has("dup2", "cdecl"):
    dup2 = _libs["libPyFd.so"].get("dup2", "cdecl")
    dup2.argtypes = [c_int, c_int]
    dup2.restype = c_int

# /usr/include/unistd.h: 543
try:
    __environ = (POINTER(POINTER(c_char))).in_dll(_libs["libPyFd.so"], "__environ")
except:
    pass

# /usr/include/unistd.h: 551
if _libs["libPyFd.so"].has("execve", "cdecl"):
    execve = _libs["libPyFd.so"].get("execve", "cdecl")
    execve.argtypes = [String, POINTER(POINTER(c_char)), POINTER(POINTER(c_char))]
    execve.restype = c_int

# /usr/include/unistd.h: 557
if _libs["libPyFd.so"].has("fexecve", "cdecl"):
    fexecve = _libs["libPyFd.so"].get("fexecve", "cdecl")
    fexecve.argtypes = [c_int, POINTER(POINTER(c_char)), POINTER(POINTER(c_char))]
    fexecve.restype = c_int

# /usr/include/unistd.h: 563
if _libs["libPyFd.so"].has("execv", "cdecl"):
    execv = _libs["libPyFd.so"].get("execv", "cdecl")
    execv.argtypes = [String, POINTER(POINTER(c_char))]
    execv.restype = c_int

# /usr/include/unistd.h: 568
if _libs["libPyFd.so"].has("execle", "cdecl"):
    _func = _libs["libPyFd.so"].get("execle", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    execle = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/unistd.h: 573
if _libs["libPyFd.so"].has("execl", "cdecl"):
    _func = _libs["libPyFd.so"].get("execl", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    execl = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/unistd.h: 578
if _libs["libPyFd.so"].has("execvp", "cdecl"):
    execvp = _libs["libPyFd.so"].get("execvp", "cdecl")
    execvp.argtypes = [String, POINTER(POINTER(c_char))]
    execvp.restype = c_int

# /usr/include/unistd.h: 584
if _libs["libPyFd.so"].has("execlp", "cdecl"):
    _func = _libs["libPyFd.so"].get("execlp", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, String]
    execlp = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/unistd.h: 598
if _libs["libPyFd.so"].has("nice", "cdecl"):
    nice = _libs["libPyFd.so"].get("nice", "cdecl")
    nice.argtypes = [c_int]
    nice.restype = c_int

# /usr/include/unistd.h: 603
if _libs["libPyFd.so"].has("_exit", "cdecl"):
    _exit = _libs["libPyFd.so"].get("_exit", "cdecl")
    _exit.argtypes = [c_int]
    _exit.restype = None

enum_anon_55 = c_int# /usr/include/bits/confname.h: 25

_PC_LINK_MAX = 0# /usr/include/bits/confname.h: 25

_PC_MAX_CANON = (_PC_LINK_MAX + 1)# /usr/include/bits/confname.h: 25

_PC_MAX_INPUT = (_PC_MAX_CANON + 1)# /usr/include/bits/confname.h: 25

_PC_NAME_MAX = (_PC_MAX_INPUT + 1)# /usr/include/bits/confname.h: 25

_PC_PATH_MAX = (_PC_NAME_MAX + 1)# /usr/include/bits/confname.h: 25

_PC_PIPE_BUF = (_PC_PATH_MAX + 1)# /usr/include/bits/confname.h: 25

_PC_CHOWN_RESTRICTED = (_PC_PIPE_BUF + 1)# /usr/include/bits/confname.h: 25

_PC_NO_TRUNC = (_PC_CHOWN_RESTRICTED + 1)# /usr/include/bits/confname.h: 25

_PC_VDISABLE = (_PC_NO_TRUNC + 1)# /usr/include/bits/confname.h: 25

_PC_SYNC_IO = (_PC_VDISABLE + 1)# /usr/include/bits/confname.h: 25

_PC_ASYNC_IO = (_PC_SYNC_IO + 1)# /usr/include/bits/confname.h: 25

_PC_PRIO_IO = (_PC_ASYNC_IO + 1)# /usr/include/bits/confname.h: 25

_PC_SOCK_MAXBUF = (_PC_PRIO_IO + 1)# /usr/include/bits/confname.h: 25

_PC_FILESIZEBITS = (_PC_SOCK_MAXBUF + 1)# /usr/include/bits/confname.h: 25

_PC_REC_INCR_XFER_SIZE = (_PC_FILESIZEBITS + 1)# /usr/include/bits/confname.h: 25

_PC_REC_MAX_XFER_SIZE = (_PC_REC_INCR_XFER_SIZE + 1)# /usr/include/bits/confname.h: 25

_PC_REC_MIN_XFER_SIZE = (_PC_REC_MAX_XFER_SIZE + 1)# /usr/include/bits/confname.h: 25

_PC_REC_XFER_ALIGN = (_PC_REC_MIN_XFER_SIZE + 1)# /usr/include/bits/confname.h: 25

_PC_ALLOC_SIZE_MIN = (_PC_REC_XFER_ALIGN + 1)# /usr/include/bits/confname.h: 25

_PC_SYMLINK_MAX = (_PC_ALLOC_SIZE_MIN + 1)# /usr/include/bits/confname.h: 25

_PC_2_SYMLINKS = (_PC_SYMLINK_MAX + 1)# /usr/include/bits/confname.h: 25

enum_anon_56 = c_int# /usr/include/bits/confname.h: 72

_SC_ARG_MAX = 0# /usr/include/bits/confname.h: 72

_SC_CHILD_MAX = (_SC_ARG_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_CLK_TCK = (_SC_CHILD_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_NGROUPS_MAX = (_SC_CLK_TCK + 1)# /usr/include/bits/confname.h: 72

_SC_OPEN_MAX = (_SC_NGROUPS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_STREAM_MAX = (_SC_OPEN_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TZNAME_MAX = (_SC_STREAM_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_JOB_CONTROL = (_SC_TZNAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SAVED_IDS = (_SC_JOB_CONTROL + 1)# /usr/include/bits/confname.h: 72

_SC_REALTIME_SIGNALS = (_SC_SAVED_IDS + 1)# /usr/include/bits/confname.h: 72

_SC_PRIORITY_SCHEDULING = (_SC_REALTIME_SIGNALS + 1)# /usr/include/bits/confname.h: 72

_SC_TIMERS = (_SC_PRIORITY_SCHEDULING + 1)# /usr/include/bits/confname.h: 72

_SC_ASYNCHRONOUS_IO = (_SC_TIMERS + 1)# /usr/include/bits/confname.h: 72

_SC_PRIORITIZED_IO = (_SC_ASYNCHRONOUS_IO + 1)# /usr/include/bits/confname.h: 72

_SC_SYNCHRONIZED_IO = (_SC_PRIORITIZED_IO + 1)# /usr/include/bits/confname.h: 72

_SC_FSYNC = (_SC_SYNCHRONIZED_IO + 1)# /usr/include/bits/confname.h: 72

_SC_MAPPED_FILES = (_SC_FSYNC + 1)# /usr/include/bits/confname.h: 72

_SC_MEMLOCK = (_SC_MAPPED_FILES + 1)# /usr/include/bits/confname.h: 72

_SC_MEMLOCK_RANGE = (_SC_MEMLOCK + 1)# /usr/include/bits/confname.h: 72

_SC_MEMORY_PROTECTION = (_SC_MEMLOCK_RANGE + 1)# /usr/include/bits/confname.h: 72

_SC_MESSAGE_PASSING = (_SC_MEMORY_PROTECTION + 1)# /usr/include/bits/confname.h: 72

_SC_SEMAPHORES = (_SC_MESSAGE_PASSING + 1)# /usr/include/bits/confname.h: 72

_SC_SHARED_MEMORY_OBJECTS = (_SC_SEMAPHORES + 1)# /usr/include/bits/confname.h: 72

_SC_AIO_LISTIO_MAX = (_SC_SHARED_MEMORY_OBJECTS + 1)# /usr/include/bits/confname.h: 72

_SC_AIO_MAX = (_SC_AIO_LISTIO_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_AIO_PRIO_DELTA_MAX = (_SC_AIO_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_DELAYTIMER_MAX = (_SC_AIO_PRIO_DELTA_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_MQ_OPEN_MAX = (_SC_DELAYTIMER_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_MQ_PRIO_MAX = (_SC_MQ_OPEN_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_VERSION = (_SC_MQ_PRIO_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_PAGESIZE = (_SC_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_RTSIG_MAX = (_SC_PAGESIZE + 1)# /usr/include/bits/confname.h: 72

_SC_SEM_NSEMS_MAX = (_SC_RTSIG_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SEM_VALUE_MAX = (_SC_SEM_NSEMS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SIGQUEUE_MAX = (_SC_SEM_VALUE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TIMER_MAX = (_SC_SIGQUEUE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_BC_BASE_MAX = (_SC_TIMER_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_BC_DIM_MAX = (_SC_BC_BASE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_BC_SCALE_MAX = (_SC_BC_DIM_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_BC_STRING_MAX = (_SC_BC_SCALE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_COLL_WEIGHTS_MAX = (_SC_BC_STRING_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_EQUIV_CLASS_MAX = (_SC_COLL_WEIGHTS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_EXPR_NEST_MAX = (_SC_EQUIV_CLASS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_LINE_MAX = (_SC_EXPR_NEST_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_RE_DUP_MAX = (_SC_LINE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_CHARCLASS_NAME_MAX = (_SC_RE_DUP_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_2_VERSION = (_SC_CHARCLASS_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_2_C_BIND = (_SC_2_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_2_C_DEV = (_SC_2_C_BIND + 1)# /usr/include/bits/confname.h: 72

_SC_2_FORT_DEV = (_SC_2_C_DEV + 1)# /usr/include/bits/confname.h: 72

_SC_2_FORT_RUN = (_SC_2_FORT_DEV + 1)# /usr/include/bits/confname.h: 72

_SC_2_SW_DEV = (_SC_2_FORT_RUN + 1)# /usr/include/bits/confname.h: 72

_SC_2_LOCALEDEF = (_SC_2_SW_DEV + 1)# /usr/include/bits/confname.h: 72

_SC_PII = (_SC_2_LOCALEDEF + 1)# /usr/include/bits/confname.h: 72

_SC_PII_XTI = (_SC_PII + 1)# /usr/include/bits/confname.h: 72

_SC_PII_SOCKET = (_SC_PII_XTI + 1)# /usr/include/bits/confname.h: 72

_SC_PII_INTERNET = (_SC_PII_SOCKET + 1)# /usr/include/bits/confname.h: 72

_SC_PII_OSI = (_SC_PII_INTERNET + 1)# /usr/include/bits/confname.h: 72

_SC_POLL = (_SC_PII_OSI + 1)# /usr/include/bits/confname.h: 72

_SC_SELECT = (_SC_POLL + 1)# /usr/include/bits/confname.h: 72

_SC_UIO_MAXIOV = (_SC_SELECT + 1)# /usr/include/bits/confname.h: 72

_SC_IOV_MAX = _SC_UIO_MAXIOV# /usr/include/bits/confname.h: 72

_SC_PII_INTERNET_STREAM = (_SC_IOV_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_PII_INTERNET_DGRAM = (_SC_PII_INTERNET_STREAM + 1)# /usr/include/bits/confname.h: 72

_SC_PII_OSI_COTS = (_SC_PII_INTERNET_DGRAM + 1)# /usr/include/bits/confname.h: 72

_SC_PII_OSI_CLTS = (_SC_PII_OSI_COTS + 1)# /usr/include/bits/confname.h: 72

_SC_PII_OSI_M = (_SC_PII_OSI_CLTS + 1)# /usr/include/bits/confname.h: 72

_SC_T_IOV_MAX = (_SC_PII_OSI_M + 1)# /usr/include/bits/confname.h: 72

_SC_THREADS = (_SC_T_IOV_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_SAFE_FUNCTIONS = (_SC_THREADS + 1)# /usr/include/bits/confname.h: 72

_SC_GETGR_R_SIZE_MAX = (_SC_THREAD_SAFE_FUNCTIONS + 1)# /usr/include/bits/confname.h: 72

_SC_GETPW_R_SIZE_MAX = (_SC_GETGR_R_SIZE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_LOGIN_NAME_MAX = (_SC_GETPW_R_SIZE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TTY_NAME_MAX = (_SC_LOGIN_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_DESTRUCTOR_ITERATIONS = (_SC_TTY_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_KEYS_MAX = (_SC_THREAD_DESTRUCTOR_ITERATIONS + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_STACK_MIN = (_SC_THREAD_KEYS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_THREADS_MAX = (_SC_THREAD_STACK_MIN + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_ATTR_STACKADDR = (_SC_THREAD_THREADS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_ATTR_STACKSIZE = (_SC_THREAD_ATTR_STACKADDR + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_PRIORITY_SCHEDULING = (_SC_THREAD_ATTR_STACKSIZE + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_PRIO_INHERIT = (_SC_THREAD_PRIORITY_SCHEDULING + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_PRIO_PROTECT = (_SC_THREAD_PRIO_INHERIT + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_PROCESS_SHARED = (_SC_THREAD_PRIO_PROTECT + 1)# /usr/include/bits/confname.h: 72

_SC_NPROCESSORS_CONF = (_SC_THREAD_PROCESS_SHARED + 1)# /usr/include/bits/confname.h: 72

_SC_NPROCESSORS_ONLN = (_SC_NPROCESSORS_CONF + 1)# /usr/include/bits/confname.h: 72

_SC_PHYS_PAGES = (_SC_NPROCESSORS_ONLN + 1)# /usr/include/bits/confname.h: 72

_SC_AVPHYS_PAGES = (_SC_PHYS_PAGES + 1)# /usr/include/bits/confname.h: 72

_SC_ATEXIT_MAX = (_SC_AVPHYS_PAGES + 1)# /usr/include/bits/confname.h: 72

_SC_PASS_MAX = (_SC_ATEXIT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_VERSION = (_SC_PASS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_XCU_VERSION = (_SC_XOPEN_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_UNIX = (_SC_XOPEN_XCU_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_CRYPT = (_SC_XOPEN_UNIX + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_ENH_I18N = (_SC_XOPEN_CRYPT + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_SHM = (_SC_XOPEN_ENH_I18N + 1)# /usr/include/bits/confname.h: 72

_SC_2_CHAR_TERM = (_SC_XOPEN_SHM + 1)# /usr/include/bits/confname.h: 72

_SC_2_C_VERSION = (_SC_2_CHAR_TERM + 1)# /usr/include/bits/confname.h: 72

_SC_2_UPE = (_SC_2_C_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_XPG2 = (_SC_2_UPE + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_XPG3 = (_SC_XOPEN_XPG2 + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_XPG4 = (_SC_XOPEN_XPG3 + 1)# /usr/include/bits/confname.h: 72

_SC_CHAR_BIT = (_SC_XOPEN_XPG4 + 1)# /usr/include/bits/confname.h: 72

_SC_CHAR_MAX = (_SC_CHAR_BIT + 1)# /usr/include/bits/confname.h: 72

_SC_CHAR_MIN = (_SC_CHAR_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_INT_MAX = (_SC_CHAR_MIN + 1)# /usr/include/bits/confname.h: 72

_SC_INT_MIN = (_SC_INT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_LONG_BIT = (_SC_INT_MIN + 1)# /usr/include/bits/confname.h: 72

_SC_WORD_BIT = (_SC_LONG_BIT + 1)# /usr/include/bits/confname.h: 72

_SC_MB_LEN_MAX = (_SC_WORD_BIT + 1)# /usr/include/bits/confname.h: 72

_SC_NZERO = (_SC_MB_LEN_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SSIZE_MAX = (_SC_NZERO + 1)# /usr/include/bits/confname.h: 72

_SC_SCHAR_MAX = (_SC_SSIZE_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SCHAR_MIN = (_SC_SCHAR_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_SHRT_MAX = (_SC_SCHAR_MIN + 1)# /usr/include/bits/confname.h: 72

_SC_SHRT_MIN = (_SC_SHRT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_UCHAR_MAX = (_SC_SHRT_MIN + 1)# /usr/include/bits/confname.h: 72

_SC_UINT_MAX = (_SC_UCHAR_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_ULONG_MAX = (_SC_UINT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_USHRT_MAX = (_SC_ULONG_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_ARGMAX = (_SC_USHRT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_LANGMAX = (_SC_NL_ARGMAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_MSGMAX = (_SC_NL_LANGMAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_NMAX = (_SC_NL_MSGMAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_SETMAX = (_SC_NL_NMAX + 1)# /usr/include/bits/confname.h: 72

_SC_NL_TEXTMAX = (_SC_NL_SETMAX + 1)# /usr/include/bits/confname.h: 72

_SC_XBS5_ILP32_OFF32 = (_SC_NL_TEXTMAX + 1)# /usr/include/bits/confname.h: 72

_SC_XBS5_ILP32_OFFBIG = (_SC_XBS5_ILP32_OFF32 + 1)# /usr/include/bits/confname.h: 72

_SC_XBS5_LP64_OFF64 = (_SC_XBS5_ILP32_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_XBS5_LPBIG_OFFBIG = (_SC_XBS5_LP64_OFF64 + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_LEGACY = (_SC_XBS5_LPBIG_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_REALTIME = (_SC_XOPEN_LEGACY + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_REALTIME_THREADS = (_SC_XOPEN_REALTIME + 1)# /usr/include/bits/confname.h: 72

_SC_ADVISORY_INFO = (_SC_XOPEN_REALTIME_THREADS + 1)# /usr/include/bits/confname.h: 72

_SC_BARRIERS = (_SC_ADVISORY_INFO + 1)# /usr/include/bits/confname.h: 72

_SC_BASE = (_SC_BARRIERS + 1)# /usr/include/bits/confname.h: 72

_SC_C_LANG_SUPPORT = (_SC_BASE + 1)# /usr/include/bits/confname.h: 72

_SC_C_LANG_SUPPORT_R = (_SC_C_LANG_SUPPORT + 1)# /usr/include/bits/confname.h: 72

_SC_CLOCK_SELECTION = (_SC_C_LANG_SUPPORT_R + 1)# /usr/include/bits/confname.h: 72

_SC_CPUTIME = (_SC_CLOCK_SELECTION + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_CPUTIME = (_SC_CPUTIME + 1)# /usr/include/bits/confname.h: 72

_SC_DEVICE_IO = (_SC_THREAD_CPUTIME + 1)# /usr/include/bits/confname.h: 72

_SC_DEVICE_SPECIFIC = (_SC_DEVICE_IO + 1)# /usr/include/bits/confname.h: 72

_SC_DEVICE_SPECIFIC_R = (_SC_DEVICE_SPECIFIC + 1)# /usr/include/bits/confname.h: 72

_SC_FD_MGMT = (_SC_DEVICE_SPECIFIC_R + 1)# /usr/include/bits/confname.h: 72

_SC_FIFO = (_SC_FD_MGMT + 1)# /usr/include/bits/confname.h: 72

_SC_PIPE = (_SC_FIFO + 1)# /usr/include/bits/confname.h: 72

_SC_FILE_ATTRIBUTES = (_SC_PIPE + 1)# /usr/include/bits/confname.h: 72

_SC_FILE_LOCKING = (_SC_FILE_ATTRIBUTES + 1)# /usr/include/bits/confname.h: 72

_SC_FILE_SYSTEM = (_SC_FILE_LOCKING + 1)# /usr/include/bits/confname.h: 72

_SC_MONOTONIC_CLOCK = (_SC_FILE_SYSTEM + 1)# /usr/include/bits/confname.h: 72

_SC_MULTI_PROCESS = (_SC_MONOTONIC_CLOCK + 1)# /usr/include/bits/confname.h: 72

_SC_SINGLE_PROCESS = (_SC_MULTI_PROCESS + 1)# /usr/include/bits/confname.h: 72

_SC_NETWORKING = (_SC_SINGLE_PROCESS + 1)# /usr/include/bits/confname.h: 72

_SC_READER_WRITER_LOCKS = (_SC_NETWORKING + 1)# /usr/include/bits/confname.h: 72

_SC_SPIN_LOCKS = (_SC_READER_WRITER_LOCKS + 1)# /usr/include/bits/confname.h: 72

_SC_REGEXP = (_SC_SPIN_LOCKS + 1)# /usr/include/bits/confname.h: 72

_SC_REGEX_VERSION = (_SC_REGEXP + 1)# /usr/include/bits/confname.h: 72

_SC_SHELL = (_SC_REGEX_VERSION + 1)# /usr/include/bits/confname.h: 72

_SC_SIGNALS = (_SC_SHELL + 1)# /usr/include/bits/confname.h: 72

_SC_SPAWN = (_SC_SIGNALS + 1)# /usr/include/bits/confname.h: 72

_SC_SPORADIC_SERVER = (_SC_SPAWN + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_SPORADIC_SERVER = (_SC_SPORADIC_SERVER + 1)# /usr/include/bits/confname.h: 72

_SC_SYSTEM_DATABASE = (_SC_THREAD_SPORADIC_SERVER + 1)# /usr/include/bits/confname.h: 72

_SC_SYSTEM_DATABASE_R = (_SC_SYSTEM_DATABASE + 1)# /usr/include/bits/confname.h: 72

_SC_TIMEOUTS = (_SC_SYSTEM_DATABASE_R + 1)# /usr/include/bits/confname.h: 72

_SC_TYPED_MEMORY_OBJECTS = (_SC_TIMEOUTS + 1)# /usr/include/bits/confname.h: 72

_SC_USER_GROUPS = (_SC_TYPED_MEMORY_OBJECTS + 1)# /usr/include/bits/confname.h: 72

_SC_USER_GROUPS_R = (_SC_USER_GROUPS + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS = (_SC_USER_GROUPS_R + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS_ACCOUNTING = (_SC_2_PBS + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS_LOCATE = (_SC_2_PBS_ACCOUNTING + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS_MESSAGE = (_SC_2_PBS_LOCATE + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS_TRACK = (_SC_2_PBS_MESSAGE + 1)# /usr/include/bits/confname.h: 72

_SC_SYMLOOP_MAX = (_SC_2_PBS_TRACK + 1)# /usr/include/bits/confname.h: 72

_SC_STREAMS = (_SC_SYMLOOP_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_2_PBS_CHECKPOINT = (_SC_STREAMS + 1)# /usr/include/bits/confname.h: 72

_SC_V6_ILP32_OFF32 = (_SC_2_PBS_CHECKPOINT + 1)# /usr/include/bits/confname.h: 72

_SC_V6_ILP32_OFFBIG = (_SC_V6_ILP32_OFF32 + 1)# /usr/include/bits/confname.h: 72

_SC_V6_LP64_OFF64 = (_SC_V6_ILP32_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_V6_LPBIG_OFFBIG = (_SC_V6_LP64_OFF64 + 1)# /usr/include/bits/confname.h: 72

_SC_HOST_NAME_MAX = (_SC_V6_LPBIG_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE = (_SC_HOST_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_EVENT_FILTER = (_SC_TRACE + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_INHERIT = (_SC_TRACE_EVENT_FILTER + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_LOG = (_SC_TRACE_INHERIT + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_ICACHE_SIZE = (_SC_TRACE_LOG + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_ICACHE_ASSOC = (_SC_LEVEL1_ICACHE_SIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_ICACHE_LINESIZE = (_SC_LEVEL1_ICACHE_ASSOC + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_DCACHE_SIZE = (_SC_LEVEL1_ICACHE_LINESIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_DCACHE_ASSOC = (_SC_LEVEL1_DCACHE_SIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL1_DCACHE_LINESIZE = (_SC_LEVEL1_DCACHE_ASSOC + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL2_CACHE_SIZE = (_SC_LEVEL1_DCACHE_LINESIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL2_CACHE_ASSOC = (_SC_LEVEL2_CACHE_SIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL2_CACHE_LINESIZE = (_SC_LEVEL2_CACHE_ASSOC + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL3_CACHE_SIZE = (_SC_LEVEL2_CACHE_LINESIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL3_CACHE_ASSOC = (_SC_LEVEL3_CACHE_SIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL3_CACHE_LINESIZE = (_SC_LEVEL3_CACHE_ASSOC + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL4_CACHE_SIZE = (_SC_LEVEL3_CACHE_LINESIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL4_CACHE_ASSOC = (_SC_LEVEL4_CACHE_SIZE + 1)# /usr/include/bits/confname.h: 72

_SC_LEVEL4_CACHE_LINESIZE = (_SC_LEVEL4_CACHE_ASSOC + 1)# /usr/include/bits/confname.h: 72

_SC_IPV6 = (_SC_LEVEL1_ICACHE_SIZE + 50)# /usr/include/bits/confname.h: 72

_SC_RAW_SOCKETS = (_SC_IPV6 + 1)# /usr/include/bits/confname.h: 72

_SC_V7_ILP32_OFF32 = (_SC_RAW_SOCKETS + 1)# /usr/include/bits/confname.h: 72

_SC_V7_ILP32_OFFBIG = (_SC_V7_ILP32_OFF32 + 1)# /usr/include/bits/confname.h: 72

_SC_V7_LP64_OFF64 = (_SC_V7_ILP32_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_V7_LPBIG_OFFBIG = (_SC_V7_LP64_OFF64 + 1)# /usr/include/bits/confname.h: 72

_SC_SS_REPL_MAX = (_SC_V7_LPBIG_OFFBIG + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_EVENT_NAME_MAX = (_SC_SS_REPL_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_NAME_MAX = (_SC_TRACE_EVENT_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_SYS_MAX = (_SC_TRACE_NAME_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_TRACE_USER_EVENT_MAX = (_SC_TRACE_SYS_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_XOPEN_STREAMS = (_SC_TRACE_USER_EVENT_MAX + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_ROBUST_PRIO_INHERIT = (_SC_XOPEN_STREAMS + 1)# /usr/include/bits/confname.h: 72

_SC_THREAD_ROBUST_PRIO_PROTECT = (_SC_THREAD_ROBUST_PRIO_INHERIT + 1)# /usr/include/bits/confname.h: 72

enum_anon_57 = c_int# /usr/include/bits/confname.h: 534

_CS_PATH = 0# /usr/include/bits/confname.h: 534

_CS_V6_WIDTH_RESTRICTED_ENVS = (_CS_PATH + 1)# /usr/include/bits/confname.h: 534

_CS_GNU_LIBC_VERSION = (_CS_V6_WIDTH_RESTRICTED_ENVS + 1)# /usr/include/bits/confname.h: 534

_CS_GNU_LIBPTHREAD_VERSION = (_CS_GNU_LIBC_VERSION + 1)# /usr/include/bits/confname.h: 534

_CS_V5_WIDTH_RESTRICTED_ENVS = (_CS_GNU_LIBPTHREAD_VERSION + 1)# /usr/include/bits/confname.h: 534

_CS_V7_WIDTH_RESTRICTED_ENVS = (_CS_V5_WIDTH_RESTRICTED_ENVS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS_CFLAGS = 1000# /usr/include/bits/confname.h: 534

_CS_LFS_LDFLAGS = (_CS_LFS_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS_LIBS = (_CS_LFS_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS_LINTFLAGS = (_CS_LFS_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS64_CFLAGS = (_CS_LFS_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS64_LDFLAGS = (_CS_LFS64_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS64_LIBS = (_CS_LFS64_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_LFS64_LINTFLAGS = (_CS_LFS64_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFF32_CFLAGS = 1100# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFF32_LDFLAGS = (_CS_XBS5_ILP32_OFF32_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFF32_LIBS = (_CS_XBS5_ILP32_OFF32_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFF32_LINTFLAGS = (_CS_XBS5_ILP32_OFF32_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFFBIG_CFLAGS = (_CS_XBS5_ILP32_OFF32_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFFBIG_LDFLAGS = (_CS_XBS5_ILP32_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFFBIG_LIBS = (_CS_XBS5_ILP32_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_ILP32_OFFBIG_LINTFLAGS = (_CS_XBS5_ILP32_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LP64_OFF64_CFLAGS = (_CS_XBS5_ILP32_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LP64_OFF64_LDFLAGS = (_CS_XBS5_LP64_OFF64_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LP64_OFF64_LIBS = (_CS_XBS5_LP64_OFF64_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LP64_OFF64_LINTFLAGS = (_CS_XBS5_LP64_OFF64_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LPBIG_OFFBIG_CFLAGS = (_CS_XBS5_LP64_OFF64_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LPBIG_OFFBIG_LDFLAGS = (_CS_XBS5_LPBIG_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LPBIG_OFFBIG_LIBS = (_CS_XBS5_LPBIG_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_XBS5_LPBIG_OFFBIG_LINTFLAGS = (_CS_XBS5_LPBIG_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFF32_CFLAGS = (_CS_XBS5_LPBIG_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFF32_LDFLAGS = (_CS_POSIX_V6_ILP32_OFF32_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFF32_LIBS = (_CS_POSIX_V6_ILP32_OFF32_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFF32_LINTFLAGS = (_CS_POSIX_V6_ILP32_OFF32_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFFBIG_CFLAGS = (_CS_POSIX_V6_ILP32_OFF32_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS = (_CS_POSIX_V6_ILP32_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFFBIG_LIBS = (_CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS = (_CS_POSIX_V6_ILP32_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LP64_OFF64_CFLAGS = (_CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LP64_OFF64_LDFLAGS = (_CS_POSIX_V6_LP64_OFF64_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LP64_OFF64_LIBS = (_CS_POSIX_V6_LP64_OFF64_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LP64_OFF64_LINTFLAGS = (_CS_POSIX_V6_LP64_OFF64_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS = (_CS_POSIX_V6_LP64_OFF64_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS = (_CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LPBIG_OFFBIG_LIBS = (_CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS = (_CS_POSIX_V6_LPBIG_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFF32_CFLAGS = (_CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFF32_LDFLAGS = (_CS_POSIX_V7_ILP32_OFF32_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFF32_LIBS = (_CS_POSIX_V7_ILP32_OFF32_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFF32_LINTFLAGS = (_CS_POSIX_V7_ILP32_OFF32_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFFBIG_CFLAGS = (_CS_POSIX_V7_ILP32_OFF32_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS = (_CS_POSIX_V7_ILP32_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFFBIG_LIBS = (_CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS = (_CS_POSIX_V7_ILP32_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LP64_OFF64_CFLAGS = (_CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LP64_OFF64_LDFLAGS = (_CS_POSIX_V7_LP64_OFF64_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LP64_OFF64_LIBS = (_CS_POSIX_V7_LP64_OFF64_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LP64_OFF64_LINTFLAGS = (_CS_POSIX_V7_LP64_OFF64_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS = (_CS_POSIX_V7_LP64_OFF64_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS = (_CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LPBIG_OFFBIG_LIBS = (_CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS = (_CS_POSIX_V7_LPBIG_OFFBIG_LIBS + 1)# /usr/include/bits/confname.h: 534

_CS_V6_ENV = (_CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS + 1)# /usr/include/bits/confname.h: 534

_CS_V7_ENV = (_CS_V6_ENV + 1)# /usr/include/bits/confname.h: 534

# /usr/include/unistd.h: 612
if _libs["libPyFd.so"].has("pathconf", "cdecl"):
    pathconf = _libs["libPyFd.so"].get("pathconf", "cdecl")
    pathconf.argtypes = [String, c_int]
    pathconf.restype = c_long

# /usr/include/unistd.h: 616
if _libs["libPyFd.so"].has("fpathconf", "cdecl"):
    fpathconf = _libs["libPyFd.so"].get("fpathconf", "cdecl")
    fpathconf.argtypes = [c_int, c_int]
    fpathconf.restype = c_long

# /usr/include/unistd.h: 619
if _libs["libPyFd.so"].has("sysconf", "cdecl"):
    sysconf = _libs["libPyFd.so"].get("sysconf", "cdecl")
    sysconf.argtypes = [c_int]
    sysconf.restype = c_long

# /usr/include/unistd.h: 623
if _libs["libPyFd.so"].has("confstr", "cdecl"):
    confstr = _libs["libPyFd.so"].get("confstr", "cdecl")
    confstr.argtypes = [c_int, String, c_size_t]
    confstr.restype = c_size_t

# /usr/include/unistd.h: 628
if _libs["libPyFd.so"].has("getpid", "cdecl"):
    getpid = _libs["libPyFd.so"].get("getpid", "cdecl")
    getpid.argtypes = []
    getpid.restype = __pid_t

# /usr/include/unistd.h: 631
if _libs["libPyFd.so"].has("getppid", "cdecl"):
    getppid = _libs["libPyFd.so"].get("getppid", "cdecl")
    getppid.argtypes = []
    getppid.restype = __pid_t

# /usr/include/unistd.h: 636
if _libs["libPyFd.so"].has("getpgrp", "cdecl"):
    getpgrp = _libs["libPyFd.so"].get("getpgrp", "cdecl")
    getpgrp.argtypes = []
    getpgrp.restype = __pid_t

# /usr/include/unistd.h: 646
if _libs["libPyFd.so"].has("__getpgid", "cdecl"):
    __getpgid = _libs["libPyFd.so"].get("__getpgid", "cdecl")
    __getpgid.argtypes = [__pid_t]
    __getpgid.restype = __pid_t

# /usr/include/unistd.h: 648
if _libs["libPyFd.so"].has("getpgid", "cdecl"):
    getpgid = _libs["libPyFd.so"].get("getpgid", "cdecl")
    getpgid.argtypes = [__pid_t]
    getpgid.restype = __pid_t

# /usr/include/unistd.h: 655
if _libs["libPyFd.so"].has("setpgid", "cdecl"):
    setpgid = _libs["libPyFd.so"].get("setpgid", "cdecl")
    setpgid.argtypes = [__pid_t, __pid_t]
    setpgid.restype = c_int

# /usr/include/unistd.h: 672
if _libs["libPyFd.so"].has("setpgrp", "cdecl"):
    setpgrp = _libs["libPyFd.so"].get("setpgrp", "cdecl")
    setpgrp.argtypes = []
    setpgrp.restype = c_int

# /usr/include/unistd.h: 689
if _libs["libPyFd.so"].has("setsid", "cdecl"):
    setsid = _libs["libPyFd.so"].get("setsid", "cdecl")
    setsid.argtypes = []
    setsid.restype = __pid_t

# /usr/include/unistd.h: 693
if _libs["libPyFd.so"].has("getsid", "cdecl"):
    getsid = _libs["libPyFd.so"].get("getsid", "cdecl")
    getsid.argtypes = [__pid_t]
    getsid.restype = __pid_t

# /usr/include/unistd.h: 697
if _libs["libPyFd.so"].has("getuid", "cdecl"):
    getuid = _libs["libPyFd.so"].get("getuid", "cdecl")
    getuid.argtypes = []
    getuid.restype = __uid_t

# /usr/include/unistd.h: 700
if _libs["libPyFd.so"].has("geteuid", "cdecl"):
    geteuid = _libs["libPyFd.so"].get("geteuid", "cdecl")
    geteuid.argtypes = []
    geteuid.restype = __uid_t

# /usr/include/unistd.h: 703
if _libs["libPyFd.so"].has("getgid", "cdecl"):
    getgid = _libs["libPyFd.so"].get("getgid", "cdecl")
    getgid.argtypes = []
    getgid.restype = __gid_t

# /usr/include/unistd.h: 706
if _libs["libPyFd.so"].has("getegid", "cdecl"):
    getegid = _libs["libPyFd.so"].get("getegid", "cdecl")
    getegid.argtypes = []
    getegid.restype = __gid_t

# /usr/include/unistd.h: 711
if _libs["libPyFd.so"].has("getgroups", "cdecl"):
    getgroups = _libs["libPyFd.so"].get("getgroups", "cdecl")
    getgroups.argtypes = [c_int, POINTER(__gid_t)]
    getgroups.restype = c_int

# /usr/include/unistd.h: 722
if _libs["libPyFd.so"].has("setuid", "cdecl"):
    setuid = _libs["libPyFd.so"].get("setuid", "cdecl")
    setuid.argtypes = [__uid_t]
    setuid.restype = c_int

# /usr/include/unistd.h: 727
if _libs["libPyFd.so"].has("setreuid", "cdecl"):
    setreuid = _libs["libPyFd.so"].get("setreuid", "cdecl")
    setreuid.argtypes = [__uid_t, __uid_t]
    setreuid.restype = c_int

# /usr/include/unistd.h: 732
if _libs["libPyFd.so"].has("seteuid", "cdecl"):
    seteuid = _libs["libPyFd.so"].get("seteuid", "cdecl")
    seteuid.argtypes = [__uid_t]
    seteuid.restype = c_int

# /usr/include/unistd.h: 739
if _libs["libPyFd.so"].has("setgid", "cdecl"):
    setgid = _libs["libPyFd.so"].get("setgid", "cdecl")
    setgid.argtypes = [__gid_t]
    setgid.restype = c_int

# /usr/include/unistd.h: 744
if _libs["libPyFd.so"].has("setregid", "cdecl"):
    setregid = _libs["libPyFd.so"].get("setregid", "cdecl")
    setregid.argtypes = [__gid_t, __gid_t]
    setregid.restype = c_int

# /usr/include/unistd.h: 749
if _libs["libPyFd.so"].has("setegid", "cdecl"):
    setegid = _libs["libPyFd.so"].get("setegid", "cdecl")
    setegid.argtypes = [__gid_t]
    setegid.restype = c_int

# /usr/include/unistd.h: 778
if _libs["libPyFd.so"].has("fork", "cdecl"):
    fork = _libs["libPyFd.so"].get("fork", "cdecl")
    fork.argtypes = []
    fork.restype = __pid_t

# /usr/include/unistd.h: 786
if _libs["libPyFd.so"].has("vfork", "cdecl"):
    vfork = _libs["libPyFd.so"].get("vfork", "cdecl")
    vfork.argtypes = []
    vfork.restype = __pid_t

# /usr/include/unistd.h: 792
if _libs["libPyFd.so"].has("ttyname", "cdecl"):
    ttyname = _libs["libPyFd.so"].get("ttyname", "cdecl")
    ttyname.argtypes = [c_int]
    if sizeof(c_int) == sizeof(c_void_p):
        ttyname.restype = ReturnString
    else:
        ttyname.restype = String
        ttyname.errcheck = ReturnString

# /usr/include/unistd.h: 796
if _libs["libPyFd.so"].has("ttyname_r", "cdecl"):
    ttyname_r = _libs["libPyFd.so"].get("ttyname_r", "cdecl")
    ttyname_r.argtypes = [c_int, String, c_size_t]
    ttyname_r.restype = c_int

# /usr/include/unistd.h: 801
if _libs["libPyFd.so"].has("isatty", "cdecl"):
    isatty = _libs["libPyFd.so"].get("isatty", "cdecl")
    isatty.argtypes = [c_int]
    isatty.restype = c_int

# /usr/include/unistd.h: 807
if _libs["libPyFd.so"].has("ttyslot", "cdecl"):
    ttyslot = _libs["libPyFd.so"].get("ttyslot", "cdecl")
    ttyslot.argtypes = []
    ttyslot.restype = c_int

# /usr/include/unistd.h: 812
if _libs["libPyFd.so"].has("link", "cdecl"):
    link = _libs["libPyFd.so"].get("link", "cdecl")
    link.argtypes = [String, String]
    link.restype = c_int

# /usr/include/unistd.h: 818
if _libs["libPyFd.so"].has("linkat", "cdecl"):
    linkat = _libs["libPyFd.so"].get("linkat", "cdecl")
    linkat.argtypes = [c_int, String, c_int, String, c_int]
    linkat.restype = c_int

# /usr/include/unistd.h: 825
if _libs["libPyFd.so"].has("symlink", "cdecl"):
    symlink = _libs["libPyFd.so"].get("symlink", "cdecl")
    symlink.argtypes = [String, String]
    symlink.restype = c_int

# /usr/include/unistd.h: 831
if _libs["libPyFd.so"].has("readlink", "cdecl"):
    readlink = _libs["libPyFd.so"].get("readlink", "cdecl")
    readlink.argtypes = [String, String, c_size_t]
    readlink.restype = c_ptrdiff_t

# /usr/include/unistd.h: 838
if _libs["libPyFd.so"].has("symlinkat", "cdecl"):
    symlinkat = _libs["libPyFd.so"].get("symlinkat", "cdecl")
    symlinkat.argtypes = [String, c_int, String]
    symlinkat.restype = c_int

# /usr/include/unistd.h: 842
if _libs["libPyFd.so"].has("readlinkat", "cdecl"):
    readlinkat = _libs["libPyFd.so"].get("readlinkat", "cdecl")
    readlinkat.argtypes = [c_int, String, String, c_size_t]
    readlinkat.restype = c_ptrdiff_t

# /usr/include/unistd.h: 848
if _libs["libPyFd.so"].has("unlink", "cdecl"):
    unlink = _libs["libPyFd.so"].get("unlink", "cdecl")
    unlink.argtypes = [String]
    unlink.restype = c_int

# /usr/include/unistd.h: 852
if _libs["libPyFd.so"].has("unlinkat", "cdecl"):
    unlinkat = _libs["libPyFd.so"].get("unlinkat", "cdecl")
    unlinkat.argtypes = [c_int, String, c_int]
    unlinkat.restype = c_int

# /usr/include/unistd.h: 857
if _libs["libPyFd.so"].has("rmdir", "cdecl"):
    rmdir = _libs["libPyFd.so"].get("rmdir", "cdecl")
    rmdir.argtypes = [String]
    rmdir.restype = c_int

# /usr/include/unistd.h: 861
if _libs["libPyFd.so"].has("tcgetpgrp", "cdecl"):
    tcgetpgrp = _libs["libPyFd.so"].get("tcgetpgrp", "cdecl")
    tcgetpgrp.argtypes = [c_int]
    tcgetpgrp.restype = __pid_t

# /usr/include/unistd.h: 864
if _libs["libPyFd.so"].has("tcsetpgrp", "cdecl"):
    tcsetpgrp = _libs["libPyFd.so"].get("tcsetpgrp", "cdecl")
    tcsetpgrp.argtypes = [c_int, __pid_t]
    tcsetpgrp.restype = c_int

# /usr/include/unistd.h: 871
if _libs["libPyFd.so"].has("getlogin", "cdecl"):
    getlogin = _libs["libPyFd.so"].get("getlogin", "cdecl")
    getlogin.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        getlogin.restype = ReturnString
    else:
        getlogin.restype = String
        getlogin.errcheck = ReturnString

# /usr/include/unistd.h: 879
if _libs["libPyFd.so"].has("getlogin_r", "cdecl"):
    getlogin_r = _libs["libPyFd.so"].get("getlogin_r", "cdecl")
    getlogin_r.argtypes = [String, c_size_t]
    getlogin_r.restype = c_int

# /usr/include/unistd.h: 884
if _libs["libPyFd.so"].has("setlogin", "cdecl"):
    setlogin = _libs["libPyFd.so"].get("setlogin", "cdecl")
    setlogin.argtypes = [String]
    setlogin.restype = c_int

# /usr/include/getopt.h: 58
try:
    optarg = (String).in_dll(_libs["libPyFd.so"], "optarg")
except:
    pass

# /usr/include/getopt.h: 72
try:
    optind = (c_int).in_dll(_libs["libPyFd.so"], "optind")
except:
    pass

# /usr/include/getopt.h: 77
try:
    opterr = (c_int).in_dll(_libs["libPyFd.so"], "opterr")
except:
    pass

# /usr/include/getopt.h: 81
try:
    optopt = (c_int).in_dll(_libs["libPyFd.so"], "optopt")
except:
    pass

# /usr/include/getopt.h: 151
if _libs["libPyFd.so"].has("getopt", "cdecl"):
    getopt = _libs["libPyFd.so"].get("getopt", "cdecl")
    getopt.argtypes = [c_int, POINTER(POINTER(c_char)), String]
    getopt.restype = c_int

# /usr/include/unistd.h: 901
if _libs["libPyFd.so"].has("gethostname", "cdecl"):
    gethostname = _libs["libPyFd.so"].get("gethostname", "cdecl")
    gethostname.argtypes = [String, c_size_t]
    gethostname.restype = c_int

# /usr/include/unistd.h: 908
if _libs["libPyFd.so"].has("sethostname", "cdecl"):
    sethostname = _libs["libPyFd.so"].get("sethostname", "cdecl")
    sethostname.argtypes = [String, c_size_t]
    sethostname.restype = c_int

# /usr/include/unistd.h: 913
if _libs["libPyFd.so"].has("sethostid", "cdecl"):
    sethostid = _libs["libPyFd.so"].get("sethostid", "cdecl")
    sethostid.argtypes = [c_long]
    sethostid.restype = c_int

# /usr/include/unistd.h: 919
if _libs["libPyFd.so"].has("getdomainname", "cdecl"):
    getdomainname = _libs["libPyFd.so"].get("getdomainname", "cdecl")
    getdomainname.argtypes = [String, c_size_t]
    getdomainname.restype = c_int

# /usr/include/unistd.h: 921
if _libs["libPyFd.so"].has("setdomainname", "cdecl"):
    setdomainname = _libs["libPyFd.so"].get("setdomainname", "cdecl")
    setdomainname.argtypes = [String, c_size_t]
    setdomainname.restype = c_int

# /usr/include/unistd.h: 928
if _libs["libPyFd.so"].has("vhangup", "cdecl"):
    vhangup = _libs["libPyFd.so"].get("vhangup", "cdecl")
    vhangup.argtypes = []
    vhangup.restype = c_int

# /usr/include/unistd.h: 931
if _libs["libPyFd.so"].has("revoke", "cdecl"):
    revoke = _libs["libPyFd.so"].get("revoke", "cdecl")
    revoke.argtypes = [String]
    revoke.restype = c_int

# /usr/include/unistd.h: 939
if _libs["libPyFd.so"].has("profil", "cdecl"):
    profil = _libs["libPyFd.so"].get("profil", "cdecl")
    profil.argtypes = [POINTER(c_uint), c_size_t, c_size_t, c_uint]
    profil.restype = c_int

# /usr/include/unistd.h: 947
if _libs["libPyFd.so"].has("acct", "cdecl"):
    acct = _libs["libPyFd.so"].get("acct", "cdecl")
    acct.argtypes = [String]
    acct.restype = c_int

# /usr/include/unistd.h: 951
if _libs["libPyFd.so"].has("getusershell", "cdecl"):
    getusershell = _libs["libPyFd.so"].get("getusershell", "cdecl")
    getusershell.argtypes = []
    if sizeof(c_int) == sizeof(c_void_p):
        getusershell.restype = ReturnString
    else:
        getusershell.restype = String
        getusershell.errcheck = ReturnString

# /usr/include/unistd.h: 952
if _libs["libPyFd.so"].has("endusershell", "cdecl"):
    endusershell = _libs["libPyFd.so"].get("endusershell", "cdecl")
    endusershell.argtypes = []
    endusershell.restype = None

# /usr/include/unistd.h: 953
if _libs["libPyFd.so"].has("setusershell", "cdecl"):
    setusershell = _libs["libPyFd.so"].get("setusershell", "cdecl")
    setusershell.argtypes = []
    setusershell.restype = None

# /usr/include/unistd.h: 959
if _libs["libPyFd.so"].has("daemon", "cdecl"):
    daemon = _libs["libPyFd.so"].get("daemon", "cdecl")
    daemon.argtypes = [c_int, c_int]
    daemon.restype = c_int

# /usr/include/unistd.h: 966
if _libs["libPyFd.so"].has("chroot", "cdecl"):
    chroot = _libs["libPyFd.so"].get("chroot", "cdecl")
    chroot.argtypes = [String]
    chroot.restype = c_int

# /usr/include/unistd.h: 970
if _libs["libPyFd.so"].has("getpass", "cdecl"):
    getpass = _libs["libPyFd.so"].get("getpass", "cdecl")
    getpass.argtypes = [String]
    if sizeof(c_int) == sizeof(c_void_p):
        getpass.restype = ReturnString
    else:
        getpass.restype = String
        getpass.errcheck = ReturnString

# /usr/include/unistd.h: 978
if _libs["libPyFd.so"].has("fsync", "cdecl"):
    fsync = _libs["libPyFd.so"].get("fsync", "cdecl")
    fsync.argtypes = [c_int]
    fsync.restype = c_int

# /usr/include/unistd.h: 991
if _libs["libPyFd.so"].has("gethostid", "cdecl"):
    gethostid = _libs["libPyFd.so"].get("gethostid", "cdecl")
    gethostid.argtypes = []
    gethostid.restype = c_long

# /usr/include/unistd.h: 994
if _libs["libPyFd.so"].has("sync", "cdecl"):
    sync = _libs["libPyFd.so"].get("sync", "cdecl")
    sync.argtypes = []
    sync.restype = None

# /usr/include/unistd.h: 1000
if _libs["libPyFd.so"].has("getpagesize", "cdecl"):
    getpagesize = _libs["libPyFd.so"].get("getpagesize", "cdecl")
    getpagesize.argtypes = []
    getpagesize.restype = c_int

# /usr/include/unistd.h: 1005
if _libs["libPyFd.so"].has("getdtablesize", "cdecl"):
    getdtablesize = _libs["libPyFd.so"].get("getdtablesize", "cdecl")
    getdtablesize.argtypes = []
    getdtablesize.restype = c_int

# /usr/include/unistd.h: 1015
if _libs["libPyFd.so"].has("truncate", "cdecl"):
    truncate = _libs["libPyFd.so"].get("truncate", "cdecl")
    truncate.argtypes = [String, __off_t]
    truncate.restype = c_int

# /usr/include/unistd.h: 1038
if _libs["libPyFd.so"].has("ftruncate", "cdecl"):
    ftruncate = _libs["libPyFd.so"].get("ftruncate", "cdecl")
    ftruncate.argtypes = [c_int, __off_t]
    ftruncate.restype = c_int

# /usr/include/unistd.h: 1059
if _libs["libPyFd.so"].has("brk", "cdecl"):
    brk = _libs["libPyFd.so"].get("brk", "cdecl")
    brk.argtypes = [POINTER(None)]
    brk.restype = c_int

# /usr/include/unistd.h: 1065
if _libs["libPyFd.so"].has("sbrk", "cdecl"):
    sbrk = _libs["libPyFd.so"].get("sbrk", "cdecl")
    sbrk.argtypes = [intptr_t]
    sbrk.restype = POINTER(c_ubyte)
    sbrk.errcheck = lambda v,*a : cast(v, c_void_p)

# /usr/include/unistd.h: 1080
if _libs["libPyFd.so"].has("syscall", "cdecl"):
    _func = _libs["libPyFd.so"].get("syscall", "cdecl")
    _restype = c_long
    _errcheck = None
    _argtypes = [c_long]
    syscall = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/unistd.h: 1103
if _libs["libPyFd.so"].has("lockf", "cdecl"):
    lockf = _libs["libPyFd.so"].get("lockf", "cdecl")
    lockf.argtypes = [c_int, c_int, __off_t]
    lockf.restype = c_int

# /usr/include/unistd.h: 1134
if _libs["libPyFd.so"].has("fdatasync", "cdecl"):
    fdatasync = _libs["libPyFd.so"].get("fdatasync", "cdecl")
    fdatasync.argtypes = [c_int]
    fdatasync.restype = c_int

# /usr/include/bits/huge_val.h: 42
class union_anon_58(Union):
    pass

union_anon_58.__slots__ = [
    '__c',
    '__d',
]
union_anon_58._fields_ = [
    ('__c', c_ubyte * int(8)),
    ('__d', c_double),
]

__huge_val_t = union_anon_58# /usr/include/bits/huge_val.h: 42

# /usr/include/bits/huge_valf.h: 40
class union_anon_59(Union):
    pass

union_anon_59.__slots__ = [
    '__c',
    '__f',
]
union_anon_59._fields_ = [
    ('__c', c_ubyte * int(4)),
    ('__f', c_float),
]

__huge_valf_t = union_anon_59# /usr/include/bits/huge_valf.h: 40

# /usr/include/bits/huge_vall.h: 38
class union_anon_60(Union):
    pass

union_anon_60.__slots__ = [
    '__c',
    '__ld',
]
union_anon_60._fields_ = [
    ('__c', c_ubyte * int(12)),
    ('__ld', c_longdouble),
]

# /usr/include/bits/nan.h: 48
class union_anon_61(Union):
    pass

union_anon_61.__slots__ = [
    '__c',
    '__d',
]
union_anon_61._fields_ = [
    ('__c', c_ubyte * int(4)),
    ('__d', c_float),
]

float_t = c_float# /usr/include/bits/mathdef.h: 28

double_t = c_double# /usr/include/bits/mathdef.h: 29

# /usr/include/bits/mathcalls.h: 54
if _libs["libPyFd.so"].has("acos", "cdecl"):
    acos = _libs["libPyFd.so"].get("acos", "cdecl")
    acos.argtypes = [c_double]
    acos.restype = c_double

# /usr/include/bits/mathcalls.h: 54
for _lib in _libs.values():
    if not _lib.has("__acos", "cdecl"):
        continue
    __acos = _lib.get("__acos", "cdecl")
    __acos.argtypes = [c_double]
    __acos.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 56
if _libs["libPyFd.so"].has("asin", "cdecl"):
    asin = _libs["libPyFd.so"].get("asin", "cdecl")
    asin.argtypes = [c_double]
    asin.restype = c_double

# /usr/include/bits/mathcalls.h: 56
for _lib in _libs.values():
    if not _lib.has("__asin", "cdecl"):
        continue
    __asin = _lib.get("__asin", "cdecl")
    __asin.argtypes = [c_double]
    __asin.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 58
if _libs["libPyFd.so"].has("atan", "cdecl"):
    atan = _libs["libPyFd.so"].get("atan", "cdecl")
    atan.argtypes = [c_double]
    atan.restype = c_double

# /usr/include/bits/mathcalls.h: 58
for _lib in _libs.values():
    if not _lib.has("__atan", "cdecl"):
        continue
    __atan = _lib.get("__atan", "cdecl")
    __atan.argtypes = [c_double]
    __atan.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 60
if _libs["libPyFd.so"].has("atan2", "cdecl"):
    atan2 = _libs["libPyFd.so"].get("atan2", "cdecl")
    atan2.argtypes = [c_double, c_double]
    atan2.restype = c_double

# /usr/include/bits/mathcalls.h: 60
for _lib in _libs.values():
    if not _lib.has("__atan2", "cdecl"):
        continue
    __atan2 = _lib.get("__atan2", "cdecl")
    __atan2.argtypes = [c_double, c_double]
    __atan2.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 63
if _libs["libPyFd.so"].has("cos", "cdecl"):
    cos = _libs["libPyFd.so"].get("cos", "cdecl")
    cos.argtypes = [c_double]
    cos.restype = c_double

# /usr/include/bits/mathcalls.h: 63
for _lib in _libs.values():
    if not _lib.has("__cos", "cdecl"):
        continue
    __cos = _lib.get("__cos", "cdecl")
    __cos.argtypes = [c_double]
    __cos.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 65
if _libs["libPyFd.so"].has("sin", "cdecl"):
    sin = _libs["libPyFd.so"].get("sin", "cdecl")
    sin.argtypes = [c_double]
    sin.restype = c_double

# /usr/include/bits/mathcalls.h: 65
for _lib in _libs.values():
    if not _lib.has("__sin", "cdecl"):
        continue
    __sin = _lib.get("__sin", "cdecl")
    __sin.argtypes = [c_double]
    __sin.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 67
if _libs["libPyFd.so"].has("tan", "cdecl"):
    tan = _libs["libPyFd.so"].get("tan", "cdecl")
    tan.argtypes = [c_double]
    tan.restype = c_double

# /usr/include/bits/mathcalls.h: 67
for _lib in _libs.values():
    if not _lib.has("__tan", "cdecl"):
        continue
    __tan = _lib.get("__tan", "cdecl")
    __tan.argtypes = [c_double]
    __tan.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 72
if _libs["libPyFd.so"].has("cosh", "cdecl"):
    cosh = _libs["libPyFd.so"].get("cosh", "cdecl")
    cosh.argtypes = [c_double]
    cosh.restype = c_double

# /usr/include/bits/mathcalls.h: 72
for _lib in _libs.values():
    if not _lib.has("__cosh", "cdecl"):
        continue
    __cosh = _lib.get("__cosh", "cdecl")
    __cosh.argtypes = [c_double]
    __cosh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 74
if _libs["libPyFd.so"].has("sinh", "cdecl"):
    sinh = _libs["libPyFd.so"].get("sinh", "cdecl")
    sinh.argtypes = [c_double]
    sinh.restype = c_double

# /usr/include/bits/mathcalls.h: 74
for _lib in _libs.values():
    if not _lib.has("__sinh", "cdecl"):
        continue
    __sinh = _lib.get("__sinh", "cdecl")
    __sinh.argtypes = [c_double]
    __sinh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 76
if _libs["libPyFd.so"].has("tanh", "cdecl"):
    tanh = _libs["libPyFd.so"].get("tanh", "cdecl")
    tanh.argtypes = [c_double]
    tanh.restype = c_double

# /usr/include/bits/mathcalls.h: 76
for _lib in _libs.values():
    if not _lib.has("__tanh", "cdecl"):
        continue
    __tanh = _lib.get("__tanh", "cdecl")
    __tanh.argtypes = [c_double]
    __tanh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 88
if _libs["libPyFd.so"].has("acosh", "cdecl"):
    acosh = _libs["libPyFd.so"].get("acosh", "cdecl")
    acosh.argtypes = [c_double]
    acosh.restype = c_double

# /usr/include/bits/mathcalls.h: 88
for _lib in _libs.values():
    if not _lib.has("__acosh", "cdecl"):
        continue
    __acosh = _lib.get("__acosh", "cdecl")
    __acosh.argtypes = [c_double]
    __acosh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 90
if _libs["libPyFd.so"].has("asinh", "cdecl"):
    asinh = _libs["libPyFd.so"].get("asinh", "cdecl")
    asinh.argtypes = [c_double]
    asinh.restype = c_double

# /usr/include/bits/mathcalls.h: 90
for _lib in _libs.values():
    if not _lib.has("__asinh", "cdecl"):
        continue
    __asinh = _lib.get("__asinh", "cdecl")
    __asinh.argtypes = [c_double]
    __asinh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 92
if _libs["libPyFd.so"].has("atanh", "cdecl"):
    atanh = _libs["libPyFd.so"].get("atanh", "cdecl")
    atanh.argtypes = [c_double]
    atanh.restype = c_double

# /usr/include/bits/mathcalls.h: 92
for _lib in _libs.values():
    if not _lib.has("__atanh", "cdecl"):
        continue
    __atanh = _lib.get("__atanh", "cdecl")
    __atanh.argtypes = [c_double]
    __atanh.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 100
if _libs["libPyFd.so"].has("exp", "cdecl"):
    exp = _libs["libPyFd.so"].get("exp", "cdecl")
    exp.argtypes = [c_double]
    exp.restype = c_double

# /usr/include/bits/mathcalls.h: 100
for _lib in _libs.values():
    if not _lib.has("__exp", "cdecl"):
        continue
    __exp = _lib.get("__exp", "cdecl")
    __exp.argtypes = [c_double]
    __exp.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 103
if _libs["libPyFd.so"].has("frexp", "cdecl"):
    frexp = _libs["libPyFd.so"].get("frexp", "cdecl")
    frexp.argtypes = [c_double, POINTER(c_int)]
    frexp.restype = c_double

# /usr/include/bits/mathcalls.h: 103
for _lib in _libs.values():
    if not _lib.has("__frexp", "cdecl"):
        continue
    __frexp = _lib.get("__frexp", "cdecl")
    __frexp.argtypes = [c_double, POINTER(c_int)]
    __frexp.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 106
if _libs["libPyFd.so"].has("ldexp", "cdecl"):
    ldexp = _libs["libPyFd.so"].get("ldexp", "cdecl")
    ldexp.argtypes = [c_double, c_int]
    ldexp.restype = c_double

# /usr/include/bits/mathcalls.h: 106
for _lib in _libs.values():
    if not _lib.has("__ldexp", "cdecl"):
        continue
    __ldexp = _lib.get("__ldexp", "cdecl")
    __ldexp.argtypes = [c_double, c_int]
    __ldexp.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 109
if _libs["libPyFd.so"].has("log", "cdecl"):
    log = _libs["libPyFd.so"].get("log", "cdecl")
    log.argtypes = [c_double]
    log.restype = c_double

# /usr/include/bits/mathcalls.h: 109
for _lib in _libs.values():
    if not _lib.has("__log", "cdecl"):
        continue
    __log = _lib.get("__log", "cdecl")
    __log.argtypes = [c_double]
    __log.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 112
if _libs["libPyFd.so"].has("log10", "cdecl"):
    log10 = _libs["libPyFd.so"].get("log10", "cdecl")
    log10.argtypes = [c_double]
    log10.restype = c_double

# /usr/include/bits/mathcalls.h: 112
for _lib in _libs.values():
    if not _lib.has("__log10", "cdecl"):
        continue
    __log10 = _lib.get("__log10", "cdecl")
    __log10.argtypes = [c_double]
    __log10.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 115
if _libs["libPyFd.so"].has("modf", "cdecl"):
    modf = _libs["libPyFd.so"].get("modf", "cdecl")
    modf.argtypes = [c_double, POINTER(c_double)]
    modf.restype = c_double

# /usr/include/bits/mathcalls.h: 115
for _lib in _libs.values():
    if not _lib.has("__modf", "cdecl"):
        continue
    __modf = _lib.get("__modf", "cdecl")
    __modf.argtypes = [c_double, POINTER(c_double)]
    __modf.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 129
if _libs["libPyFd.so"].has("expm1", "cdecl"):
    expm1 = _libs["libPyFd.so"].get("expm1", "cdecl")
    expm1.argtypes = [c_double]
    expm1.restype = c_double

# /usr/include/bits/mathcalls.h: 129
for _lib in _libs.values():
    if not _lib.has("__expm1", "cdecl"):
        continue
    __expm1 = _lib.get("__expm1", "cdecl")
    __expm1.argtypes = [c_double]
    __expm1.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 132
if _libs["libPyFd.so"].has("log1p", "cdecl"):
    log1p = _libs["libPyFd.so"].get("log1p", "cdecl")
    log1p.argtypes = [c_double]
    log1p.restype = c_double

# /usr/include/bits/mathcalls.h: 132
for _lib in _libs.values():
    if not _lib.has("__log1p", "cdecl"):
        continue
    __log1p = _lib.get("__log1p", "cdecl")
    __log1p.argtypes = [c_double]
    __log1p.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 135
if _libs["libPyFd.so"].has("logb", "cdecl"):
    logb = _libs["libPyFd.so"].get("logb", "cdecl")
    logb.argtypes = [c_double]
    logb.restype = c_double

# /usr/include/bits/mathcalls.h: 135
for _lib in _libs.values():
    if not _lib.has("__logb", "cdecl"):
        continue
    __logb = _lib.get("__logb", "cdecl")
    __logb.argtypes = [c_double]
    __logb.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 142
if _libs["libPyFd.so"].has("exp2", "cdecl"):
    exp2 = _libs["libPyFd.so"].get("exp2", "cdecl")
    exp2.argtypes = [c_double]
    exp2.restype = c_double

# /usr/include/bits/mathcalls.h: 142
for _lib in _libs.values():
    if not _lib.has("__exp2", "cdecl"):
        continue
    __exp2 = _lib.get("__exp2", "cdecl")
    __exp2.argtypes = [c_double]
    __exp2.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 145
if _libs["libPyFd.so"].has("log2", "cdecl"):
    log2 = _libs["libPyFd.so"].get("log2", "cdecl")
    log2.argtypes = [c_double]
    log2.restype = c_double

# /usr/include/bits/mathcalls.h: 145
for _lib in _libs.values():
    if not _lib.has("__log2", "cdecl"):
        continue
    __log2 = _lib.get("__log2", "cdecl")
    __log2.argtypes = [c_double]
    __log2.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 154
if _libs["libPyFd.so"].has("pow", "cdecl"):
    pow = _libs["libPyFd.so"].get("pow", "cdecl")
    pow.argtypes = [c_double, c_double]
    pow.restype = c_double

# /usr/include/bits/mathcalls.h: 154
for _lib in _libs.values():
    if not _lib.has("__pow", "cdecl"):
        continue
    __pow = _lib.get("__pow", "cdecl")
    __pow.argtypes = [c_double, c_double]
    __pow.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 157
if _libs["libPyFd.so"].has("sqrt", "cdecl"):
    sqrt = _libs["libPyFd.so"].get("sqrt", "cdecl")
    sqrt.argtypes = [c_double]
    sqrt.restype = c_double

# /usr/include/bits/mathcalls.h: 157
for _lib in _libs.values():
    if not _lib.has("__sqrt", "cdecl"):
        continue
    __sqrt = _lib.get("__sqrt", "cdecl")
    __sqrt.argtypes = [c_double]
    __sqrt.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 163
if _libs["libPyFd.so"].has("hypot", "cdecl"):
    hypot = _libs["libPyFd.so"].get("hypot", "cdecl")
    hypot.argtypes = [c_double, c_double]
    hypot.restype = c_double

# /usr/include/bits/mathcalls.h: 163
for _lib in _libs.values():
    if not _lib.has("__hypot", "cdecl"):
        continue
    __hypot = _lib.get("__hypot", "cdecl")
    __hypot.argtypes = [c_double, c_double]
    __hypot.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 170
if _libs["libPyFd.so"].has("cbrt", "cdecl"):
    cbrt = _libs["libPyFd.so"].get("cbrt", "cdecl")
    cbrt.argtypes = [c_double]
    cbrt.restype = c_double

# /usr/include/bits/mathcalls.h: 170
for _lib in _libs.values():
    if not _lib.has("__cbrt", "cdecl"):
        continue
    __cbrt = _lib.get("__cbrt", "cdecl")
    __cbrt.argtypes = [c_double]
    __cbrt.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 179
if _libs["libPyFd.so"].has("ceil", "cdecl"):
    ceil = _libs["libPyFd.so"].get("ceil", "cdecl")
    ceil.argtypes = [c_double]
    ceil.restype = c_double

# /usr/include/bits/mathcalls.h: 179
for _lib in _libs.values():
    if not _lib.has("__ceil", "cdecl"):
        continue
    __ceil = _lib.get("__ceil", "cdecl")
    __ceil.argtypes = [c_double]
    __ceil.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 182
if _libs["libPyFd.so"].has("fabs", "cdecl"):
    fabs = _libs["libPyFd.so"].get("fabs", "cdecl")
    fabs.argtypes = [c_double]
    fabs.restype = c_double

# /usr/include/bits/mathcalls.h: 182
for _lib in _libs.values():
    if not _lib.has("__fabs", "cdecl"):
        continue
    __fabs = _lib.get("__fabs", "cdecl")
    __fabs.argtypes = [c_double]
    __fabs.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 185
if _libs["libPyFd.so"].has("floor", "cdecl"):
    floor = _libs["libPyFd.so"].get("floor", "cdecl")
    floor.argtypes = [c_double]
    floor.restype = c_double

# /usr/include/bits/mathcalls.h: 185
for _lib in _libs.values():
    if not _lib.has("__floor", "cdecl"):
        continue
    __floor = _lib.get("__floor", "cdecl")
    __floor.argtypes = [c_double]
    __floor.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 188
if _libs["libPyFd.so"].has("fmod", "cdecl"):
    fmod = _libs["libPyFd.so"].get("fmod", "cdecl")
    fmod.argtypes = [c_double, c_double]
    fmod.restype = c_double

# /usr/include/bits/mathcalls.h: 188
for _lib in _libs.values():
    if not _lib.has("__fmod", "cdecl"):
        continue
    __fmod = _lib.get("__fmod", "cdecl")
    __fmod.argtypes = [c_double, c_double]
    __fmod.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 193
if _libs["libPyFd.so"].has("__isinf", "cdecl"):
    __isinf = _libs["libPyFd.so"].get("__isinf", "cdecl")
    __isinf.argtypes = [c_double]
    __isinf.restype = c_int

# /usr/include/bits/mathcalls.h: 196
if _libs["libPyFd.so"].has("__finite", "cdecl"):
    __finite = _libs["libPyFd.so"].get("__finite", "cdecl")
    __finite.argtypes = [c_double]
    __finite.restype = c_int

# /usr/include/bits/mathcalls.h: 202
if _libs["libPyFd.so"].has("isinf", "cdecl"):
    isinf = _libs["libPyFd.so"].get("isinf", "cdecl")
    isinf.argtypes = [c_double]
    isinf.restype = c_int

# /usr/include/bits/mathcalls.h: 205
if _libs["libPyFd.so"].has("finite", "cdecl"):
    finite = _libs["libPyFd.so"].get("finite", "cdecl")
    finite.argtypes = [c_double]
    finite.restype = c_int

# /usr/include/bits/mathcalls.h: 208
if _libs["libPyFd.so"].has("drem", "cdecl"):
    drem = _libs["libPyFd.so"].get("drem", "cdecl")
    drem.argtypes = [c_double, c_double]
    drem.restype = c_double

# /usr/include/bits/mathcalls.h: 208
for _lib in _libs.values():
    if not _lib.has("__drem", "cdecl"):
        continue
    __drem = _lib.get("__drem", "cdecl")
    __drem.argtypes = [c_double, c_double]
    __drem.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 212
if _libs["libPyFd.so"].has("significand", "cdecl"):
    significand = _libs["libPyFd.so"].get("significand", "cdecl")
    significand.argtypes = [c_double]
    significand.restype = c_double

# /usr/include/bits/mathcalls.h: 212
for _lib in _libs.values():
    if not _lib.has("__significand", "cdecl"):
        continue
    __significand = _lib.get("__significand", "cdecl")
    __significand.argtypes = [c_double]
    __significand.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 218
if _libs["libPyFd.so"].has("copysign", "cdecl"):
    copysign = _libs["libPyFd.so"].get("copysign", "cdecl")
    copysign.argtypes = [c_double, c_double]
    copysign.restype = c_double

# /usr/include/bits/mathcalls.h: 218
for _lib in _libs.values():
    if not _lib.has("__copysign", "cdecl"):
        continue
    __copysign = _lib.get("__copysign", "cdecl")
    __copysign.argtypes = [c_double, c_double]
    __copysign.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 225
if _libs["libPyFd.so"].has("nan", "cdecl"):
    nan = _libs["libPyFd.so"].get("nan", "cdecl")
    nan.argtypes = [String]
    nan.restype = c_double

# /usr/include/bits/mathcalls.h: 225
for _lib in _libs.values():
    if not _lib.has("__nan", "cdecl"):
        continue
    __nan = _lib.get("__nan", "cdecl")
    __nan.argtypes = [String]
    __nan.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 231
if _libs["libPyFd.so"].has("__isnan", "cdecl"):
    __isnan = _libs["libPyFd.so"].get("__isnan", "cdecl")
    __isnan.argtypes = [c_double]
    __isnan.restype = c_int

# /usr/include/bits/mathcalls.h: 235
if _libs["libPyFd.so"].has("isnan", "cdecl"):
    isnan = _libs["libPyFd.so"].get("isnan", "cdecl")
    isnan.argtypes = [c_double]
    isnan.restype = c_int

# /usr/include/bits/mathcalls.h: 238
if _libs["libPyFd.so"].has("j0", "cdecl"):
    j0 = _libs["libPyFd.so"].get("j0", "cdecl")
    j0.argtypes = [c_double]
    j0.restype = c_double

# /usr/include/bits/mathcalls.h: 238
for _lib in _libs.values():
    if not _lib.has("__j0", "cdecl"):
        continue
    __j0 = _lib.get("__j0", "cdecl")
    __j0.argtypes = [c_double]
    __j0.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 239
if _libs["libPyFd.so"].has("j1", "cdecl"):
    j1 = _libs["libPyFd.so"].get("j1", "cdecl")
    j1.argtypes = [c_double]
    j1.restype = c_double

# /usr/include/bits/mathcalls.h: 239
for _lib in _libs.values():
    if not _lib.has("__j1", "cdecl"):
        continue
    __j1 = _lib.get("__j1", "cdecl")
    __j1.argtypes = [c_double]
    __j1.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 240
if _libs["libPyFd.so"].has("jn", "cdecl"):
    jn = _libs["libPyFd.so"].get("jn", "cdecl")
    jn.argtypes = [c_int, c_double]
    jn.restype = c_double

# /usr/include/bits/mathcalls.h: 240
for _lib in _libs.values():
    if not _lib.has("__jn", "cdecl"):
        continue
    __jn = _lib.get("__jn", "cdecl")
    __jn.argtypes = [c_int, c_double]
    __jn.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 241
if _libs["libPyFd.so"].has("y0", "cdecl"):
    y0 = _libs["libPyFd.so"].get("y0", "cdecl")
    y0.argtypes = [c_double]
    y0.restype = c_double

# /usr/include/bits/mathcalls.h: 241
for _lib in _libs.values():
    if not _lib.has("__y0", "cdecl"):
        continue
    __y0 = _lib.get("__y0", "cdecl")
    __y0.argtypes = [c_double]
    __y0.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 242
if _libs["libPyFd.so"].has("y1", "cdecl"):
    y1 = _libs["libPyFd.so"].get("y1", "cdecl")
    y1.argtypes = [c_double]
    y1.restype = c_double

# /usr/include/bits/mathcalls.h: 242
for _lib in _libs.values():
    if not _lib.has("__y1", "cdecl"):
        continue
    __y1 = _lib.get("__y1", "cdecl")
    __y1.argtypes = [c_double]
    __y1.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 243
if _libs["libPyFd.so"].has("yn", "cdecl"):
    yn = _libs["libPyFd.so"].get("yn", "cdecl")
    yn.argtypes = [c_int, c_double]
    yn.restype = c_double

# /usr/include/bits/mathcalls.h: 243
for _lib in _libs.values():
    if not _lib.has("__yn", "cdecl"):
        continue
    __yn = _lib.get("__yn", "cdecl")
    __yn.argtypes = [c_int, c_double]
    __yn.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 250
if _libs["libPyFd.so"].has("erf", "cdecl"):
    erf = _libs["libPyFd.so"].get("erf", "cdecl")
    erf.argtypes = [c_double]
    erf.restype = c_double

# /usr/include/bits/mathcalls.h: 250
for _lib in _libs.values():
    if not _lib.has("__erf", "cdecl"):
        continue
    __erf = _lib.get("__erf", "cdecl")
    __erf.argtypes = [c_double]
    __erf.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 251
if _libs["libPyFd.so"].has("erfc", "cdecl"):
    erfc = _libs["libPyFd.so"].get("erfc", "cdecl")
    erfc.argtypes = [c_double]
    erfc.restype = c_double

# /usr/include/bits/mathcalls.h: 251
for _lib in _libs.values():
    if not _lib.has("__erfc", "cdecl"):
        continue
    __erfc = _lib.get("__erfc", "cdecl")
    __erfc.argtypes = [c_double]
    __erfc.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 252
if _libs["libPyFd.so"].has("lgamma", "cdecl"):
    lgamma = _libs["libPyFd.so"].get("lgamma", "cdecl")
    lgamma.argtypes = [c_double]
    lgamma.restype = c_double

# /usr/include/bits/mathcalls.h: 252
for _lib in _libs.values():
    if not _lib.has("__lgamma", "cdecl"):
        continue
    __lgamma = _lib.get("__lgamma", "cdecl")
    __lgamma.argtypes = [c_double]
    __lgamma.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 259
if _libs["libPyFd.so"].has("tgamma", "cdecl"):
    tgamma = _libs["libPyFd.so"].get("tgamma", "cdecl")
    tgamma.argtypes = [c_double]
    tgamma.restype = c_double

# /usr/include/bits/mathcalls.h: 259
for _lib in _libs.values():
    if not _lib.has("__tgamma", "cdecl"):
        continue
    __tgamma = _lib.get("__tgamma", "cdecl")
    __tgamma.argtypes = [c_double]
    __tgamma.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 265
if _libs["libPyFd.so"].has("gamma", "cdecl"):
    gamma = _libs["libPyFd.so"].get("gamma", "cdecl")
    gamma.argtypes = [c_double]
    gamma.restype = c_double

# /usr/include/bits/mathcalls.h: 265
for _lib in _libs.values():
    if not _lib.has("__gamma", "cdecl"):
        continue
    __gamma = _lib.get("__gamma", "cdecl")
    __gamma.argtypes = [c_double]
    __gamma.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 272
if _libs["libPyFd.so"].has("lgamma_r", "cdecl"):
    lgamma_r = _libs["libPyFd.so"].get("lgamma_r", "cdecl")
    lgamma_r.argtypes = [c_double, POINTER(c_int)]
    lgamma_r.restype = c_double

# /usr/include/bits/mathcalls.h: 272
for _lib in _libs.values():
    if not _lib.has("__lgamma_r", "cdecl"):
        continue
    __lgamma_r = _lib.get("__lgamma_r", "cdecl")
    __lgamma_r.argtypes = [c_double, POINTER(c_int)]
    __lgamma_r.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 280
if _libs["libPyFd.so"].has("rint", "cdecl"):
    rint = _libs["libPyFd.so"].get("rint", "cdecl")
    rint.argtypes = [c_double]
    rint.restype = c_double

# /usr/include/bits/mathcalls.h: 280
for _lib in _libs.values():
    if not _lib.has("__rint", "cdecl"):
        continue
    __rint = _lib.get("__rint", "cdecl")
    __rint.argtypes = [c_double]
    __rint.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 283
if _libs["libPyFd.so"].has("nextafter", "cdecl"):
    nextafter = _libs["libPyFd.so"].get("nextafter", "cdecl")
    nextafter.argtypes = [c_double, c_double]
    nextafter.restype = c_double

# /usr/include/bits/mathcalls.h: 283
for _lib in _libs.values():
    if not _lib.has("__nextafter", "cdecl"):
        continue
    __nextafter = _lib.get("__nextafter", "cdecl")
    __nextafter.argtypes = [c_double, c_double]
    __nextafter.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 285
if _libs["libPyFd.so"].has("nexttoward", "cdecl"):
    nexttoward = _libs["libPyFd.so"].get("nexttoward", "cdecl")
    nexttoward.argtypes = [c_double, c_longdouble]
    nexttoward.restype = c_double

# /usr/include/bits/mathcalls.h: 285
for _lib in _libs.values():
    if not _lib.has("__nexttoward", "cdecl"):
        continue
    __nexttoward = _lib.get("__nexttoward", "cdecl")
    __nexttoward.argtypes = [c_double, c_longdouble]
    __nexttoward.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 289
if _libs["libPyFd.so"].has("remainder", "cdecl"):
    remainder = _libs["libPyFd.so"].get("remainder", "cdecl")
    remainder.argtypes = [c_double, c_double]
    remainder.restype = c_double

# /usr/include/bits/mathcalls.h: 289
for _lib in _libs.values():
    if not _lib.has("__remainder", "cdecl"):
        continue
    __remainder = _lib.get("__remainder", "cdecl")
    __remainder.argtypes = [c_double, c_double]
    __remainder.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 293
if _libs["libPyFd.so"].has("scalbn", "cdecl"):
    scalbn = _libs["libPyFd.so"].get("scalbn", "cdecl")
    scalbn.argtypes = [c_double, c_int]
    scalbn.restype = c_double

# /usr/include/bits/mathcalls.h: 293
for _lib in _libs.values():
    if not _lib.has("__scalbn", "cdecl"):
        continue
    __scalbn = _lib.get("__scalbn", "cdecl")
    __scalbn.argtypes = [c_double, c_int]
    __scalbn.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 297
if _libs["libPyFd.so"].has("ilogb", "cdecl"):
    ilogb = _libs["libPyFd.so"].get("ilogb", "cdecl")
    ilogb.argtypes = [c_double]
    ilogb.restype = c_int

# /usr/include/bits/mathcalls.h: 297
for _lib in _libs.values():
    if not _lib.has("__ilogb", "cdecl"):
        continue
    __ilogb = _lib.get("__ilogb", "cdecl")
    __ilogb.argtypes = [c_double]
    __ilogb.restype = c_int
    break

# /usr/include/bits/mathcalls.h: 302
if _libs["libPyFd.so"].has("scalbln", "cdecl"):
    scalbln = _libs["libPyFd.so"].get("scalbln", "cdecl")
    scalbln.argtypes = [c_double, c_long]
    scalbln.restype = c_double

# /usr/include/bits/mathcalls.h: 302
for _lib in _libs.values():
    if not _lib.has("__scalbln", "cdecl"):
        continue
    __scalbln = _lib.get("__scalbln", "cdecl")
    __scalbln.argtypes = [c_double, c_long]
    __scalbln.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 306
if _libs["libPyFd.so"].has("nearbyint", "cdecl"):
    nearbyint = _libs["libPyFd.so"].get("nearbyint", "cdecl")
    nearbyint.argtypes = [c_double]
    nearbyint.restype = c_double

# /usr/include/bits/mathcalls.h: 306
for _lib in _libs.values():
    if not _lib.has("__nearbyint", "cdecl"):
        continue
    __nearbyint = _lib.get("__nearbyint", "cdecl")
    __nearbyint.argtypes = [c_double]
    __nearbyint.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 310
if _libs["libPyFd.so"].has("round", "cdecl"):
    round = _libs["libPyFd.so"].get("round", "cdecl")
    round.argtypes = [c_double]
    round.restype = c_double

# /usr/include/bits/mathcalls.h: 310
for _lib in _libs.values():
    if not _lib.has("__round", "cdecl"):
        continue
    __round = _lib.get("__round", "cdecl")
    __round.argtypes = [c_double]
    __round.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 314
if _libs["libPyFd.so"].has("trunc", "cdecl"):
    trunc = _libs["libPyFd.so"].get("trunc", "cdecl")
    trunc.argtypes = [c_double]
    trunc.restype = c_double

# /usr/include/bits/mathcalls.h: 314
for _lib in _libs.values():
    if not _lib.has("__trunc", "cdecl"):
        continue
    __trunc = _lib.get("__trunc", "cdecl")
    __trunc.argtypes = [c_double]
    __trunc.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 319
if _libs["libPyFd.so"].has("remquo", "cdecl"):
    remquo = _libs["libPyFd.so"].get("remquo", "cdecl")
    remquo.argtypes = [c_double, c_double, POINTER(c_int)]
    remquo.restype = c_double

# /usr/include/bits/mathcalls.h: 319
for _lib in _libs.values():
    if not _lib.has("__remquo", "cdecl"):
        continue
    __remquo = _lib.get("__remquo", "cdecl")
    __remquo.argtypes = [c_double, c_double, POINTER(c_int)]
    __remquo.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 326
if _libs["libPyFd.so"].has("lrint", "cdecl"):
    lrint = _libs["libPyFd.so"].get("lrint", "cdecl")
    lrint.argtypes = [c_double]
    lrint.restype = c_long

# /usr/include/bits/mathcalls.h: 326
for _lib in _libs.values():
    if not _lib.has("__lrint", "cdecl"):
        continue
    __lrint = _lib.get("__lrint", "cdecl")
    __lrint.argtypes = [c_double]
    __lrint.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 327
if _libs["libPyFd.so"].has("llrint", "cdecl"):
    llrint = _libs["libPyFd.so"].get("llrint", "cdecl")
    llrint.argtypes = [c_double]
    llrint.restype = c_longlong

# /usr/include/bits/mathcalls.h: 327
for _lib in _libs.values():
    if not _lib.has("__llrint", "cdecl"):
        continue
    __llrint = _lib.get("__llrint", "cdecl")
    __llrint.argtypes = [c_double]
    __llrint.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 331
if _libs["libPyFd.so"].has("lround", "cdecl"):
    lround = _libs["libPyFd.so"].get("lround", "cdecl")
    lround.argtypes = [c_double]
    lround.restype = c_long

# /usr/include/bits/mathcalls.h: 331
for _lib in _libs.values():
    if not _lib.has("__lround", "cdecl"):
        continue
    __lround = _lib.get("__lround", "cdecl")
    __lround.argtypes = [c_double]
    __lround.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 332
if _libs["libPyFd.so"].has("llround", "cdecl"):
    llround = _libs["libPyFd.so"].get("llround", "cdecl")
    llround.argtypes = [c_double]
    llround.restype = c_longlong

# /usr/include/bits/mathcalls.h: 332
for _lib in _libs.values():
    if not _lib.has("__llround", "cdecl"):
        continue
    __llround = _lib.get("__llround", "cdecl")
    __llround.argtypes = [c_double]
    __llround.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 336
if _libs["libPyFd.so"].has("fdim", "cdecl"):
    fdim = _libs["libPyFd.so"].get("fdim", "cdecl")
    fdim.argtypes = [c_double, c_double]
    fdim.restype = c_double

# /usr/include/bits/mathcalls.h: 336
for _lib in _libs.values():
    if not _lib.has("__fdim", "cdecl"):
        continue
    __fdim = _lib.get("__fdim", "cdecl")
    __fdim.argtypes = [c_double, c_double]
    __fdim.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 339
if _libs["libPyFd.so"].has("fmax", "cdecl"):
    fmax = _libs["libPyFd.so"].get("fmax", "cdecl")
    fmax.argtypes = [c_double, c_double]
    fmax.restype = c_double

# /usr/include/bits/mathcalls.h: 339
for _lib in _libs.values():
    if not _lib.has("__fmax", "cdecl"):
        continue
    __fmax = _lib.get("__fmax", "cdecl")
    __fmax.argtypes = [c_double, c_double]
    __fmax.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 342
if _libs["libPyFd.so"].has("fmin", "cdecl"):
    fmin = _libs["libPyFd.so"].get("fmin", "cdecl")
    fmin.argtypes = [c_double, c_double]
    fmin.restype = c_double

# /usr/include/bits/mathcalls.h: 342
for _lib in _libs.values():
    if not _lib.has("__fmin", "cdecl"):
        continue
    __fmin = _lib.get("__fmin", "cdecl")
    __fmin.argtypes = [c_double, c_double]
    __fmin.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 346
if _libs["libPyFd.so"].has("__fpclassify", "cdecl"):
    __fpclassify = _libs["libPyFd.so"].get("__fpclassify", "cdecl")
    __fpclassify.argtypes = [c_double]
    __fpclassify.restype = c_int

# /usr/include/bits/mathcalls.h: 350
if _libs["libPyFd.so"].has("__signbit", "cdecl"):
    __signbit = _libs["libPyFd.so"].get("__signbit", "cdecl")
    __signbit.argtypes = [c_double]
    __signbit.restype = c_int

# /usr/include/bits/mathcalls.h: 355
if _libs["libPyFd.so"].has("fma", "cdecl"):
    fma = _libs["libPyFd.so"].get("fma", "cdecl")
    fma.argtypes = [c_double, c_double, c_double]
    fma.restype = c_double

# /usr/include/bits/mathcalls.h: 355
for _lib in _libs.values():
    if not _lib.has("__fma", "cdecl"):
        continue
    __fma = _lib.get("__fma", "cdecl")
    __fma.argtypes = [c_double, c_double, c_double]
    __fma.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 364
if _libs["libPyFd.so"].has("scalb", "cdecl"):
    scalb = _libs["libPyFd.so"].get("scalb", "cdecl")
    scalb.argtypes = [c_double, c_double]
    scalb.restype = c_double

# /usr/include/bits/mathcalls.h: 364
for _lib in _libs.values():
    if not _lib.has("__scalb", "cdecl"):
        continue
    __scalb = _lib.get("__scalb", "cdecl")
    __scalb.argtypes = [c_double, c_double]
    __scalb.restype = c_double
    break

# /usr/include/bits/mathcalls.h: 54
if _libs["libPyFd.so"].has("acosf", "cdecl"):
    acosf = _libs["libPyFd.so"].get("acosf", "cdecl")
    acosf.argtypes = [c_float]
    acosf.restype = c_float

# /usr/include/bits/mathcalls.h: 54
for _lib in _libs.values():
    if not _lib.has("__acosf", "cdecl"):
        continue
    __acosf = _lib.get("__acosf", "cdecl")
    __acosf.argtypes = [c_float]
    __acosf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 56
if _libs["libPyFd.so"].has("asinf", "cdecl"):
    asinf = _libs["libPyFd.so"].get("asinf", "cdecl")
    asinf.argtypes = [c_float]
    asinf.restype = c_float

# /usr/include/bits/mathcalls.h: 56
for _lib in _libs.values():
    if not _lib.has("__asinf", "cdecl"):
        continue
    __asinf = _lib.get("__asinf", "cdecl")
    __asinf.argtypes = [c_float]
    __asinf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 58
if _libs["libPyFd.so"].has("atanf", "cdecl"):
    atanf = _libs["libPyFd.so"].get("atanf", "cdecl")
    atanf.argtypes = [c_float]
    atanf.restype = c_float

# /usr/include/bits/mathcalls.h: 58
for _lib in _libs.values():
    if not _lib.has("__atanf", "cdecl"):
        continue
    __atanf = _lib.get("__atanf", "cdecl")
    __atanf.argtypes = [c_float]
    __atanf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 60
if _libs["libPyFd.so"].has("atan2f", "cdecl"):
    atan2f = _libs["libPyFd.so"].get("atan2f", "cdecl")
    atan2f.argtypes = [c_float, c_float]
    atan2f.restype = c_float

# /usr/include/bits/mathcalls.h: 60
for _lib in _libs.values():
    if not _lib.has("__atan2f", "cdecl"):
        continue
    __atan2f = _lib.get("__atan2f", "cdecl")
    __atan2f.argtypes = [c_float, c_float]
    __atan2f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 63
if _libs["libPyFd.so"].has("cosf", "cdecl"):
    cosf = _libs["libPyFd.so"].get("cosf", "cdecl")
    cosf.argtypes = [c_float]
    cosf.restype = c_float

# /usr/include/bits/mathcalls.h: 63
for _lib in _libs.values():
    if not _lib.has("__cosf", "cdecl"):
        continue
    __cosf = _lib.get("__cosf", "cdecl")
    __cosf.argtypes = [c_float]
    __cosf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 65
if _libs["libPyFd.so"].has("sinf", "cdecl"):
    sinf = _libs["libPyFd.so"].get("sinf", "cdecl")
    sinf.argtypes = [c_float]
    sinf.restype = c_float

# /usr/include/bits/mathcalls.h: 65
for _lib in _libs.values():
    if not _lib.has("__sinf", "cdecl"):
        continue
    __sinf = _lib.get("__sinf", "cdecl")
    __sinf.argtypes = [c_float]
    __sinf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 67
if _libs["libPyFd.so"].has("tanf", "cdecl"):
    tanf = _libs["libPyFd.so"].get("tanf", "cdecl")
    tanf.argtypes = [c_float]
    tanf.restype = c_float

# /usr/include/bits/mathcalls.h: 67
for _lib in _libs.values():
    if not _lib.has("__tanf", "cdecl"):
        continue
    __tanf = _lib.get("__tanf", "cdecl")
    __tanf.argtypes = [c_float]
    __tanf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 72
if _libs["libPyFd.so"].has("coshf", "cdecl"):
    coshf = _libs["libPyFd.so"].get("coshf", "cdecl")
    coshf.argtypes = [c_float]
    coshf.restype = c_float

# /usr/include/bits/mathcalls.h: 72
for _lib in _libs.values():
    if not _lib.has("__coshf", "cdecl"):
        continue
    __coshf = _lib.get("__coshf", "cdecl")
    __coshf.argtypes = [c_float]
    __coshf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 74
if _libs["libPyFd.so"].has("sinhf", "cdecl"):
    sinhf = _libs["libPyFd.so"].get("sinhf", "cdecl")
    sinhf.argtypes = [c_float]
    sinhf.restype = c_float

# /usr/include/bits/mathcalls.h: 74
for _lib in _libs.values():
    if not _lib.has("__sinhf", "cdecl"):
        continue
    __sinhf = _lib.get("__sinhf", "cdecl")
    __sinhf.argtypes = [c_float]
    __sinhf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 76
if _libs["libPyFd.so"].has("tanhf", "cdecl"):
    tanhf = _libs["libPyFd.so"].get("tanhf", "cdecl")
    tanhf.argtypes = [c_float]
    tanhf.restype = c_float

# /usr/include/bits/mathcalls.h: 76
for _lib in _libs.values():
    if not _lib.has("__tanhf", "cdecl"):
        continue
    __tanhf = _lib.get("__tanhf", "cdecl")
    __tanhf.argtypes = [c_float]
    __tanhf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 88
if _libs["libPyFd.so"].has("acoshf", "cdecl"):
    acoshf = _libs["libPyFd.so"].get("acoshf", "cdecl")
    acoshf.argtypes = [c_float]
    acoshf.restype = c_float

# /usr/include/bits/mathcalls.h: 88
for _lib in _libs.values():
    if not _lib.has("__acoshf", "cdecl"):
        continue
    __acoshf = _lib.get("__acoshf", "cdecl")
    __acoshf.argtypes = [c_float]
    __acoshf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 90
if _libs["libPyFd.so"].has("asinhf", "cdecl"):
    asinhf = _libs["libPyFd.so"].get("asinhf", "cdecl")
    asinhf.argtypes = [c_float]
    asinhf.restype = c_float

# /usr/include/bits/mathcalls.h: 90
for _lib in _libs.values():
    if not _lib.has("__asinhf", "cdecl"):
        continue
    __asinhf = _lib.get("__asinhf", "cdecl")
    __asinhf.argtypes = [c_float]
    __asinhf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 92
if _libs["libPyFd.so"].has("atanhf", "cdecl"):
    atanhf = _libs["libPyFd.so"].get("atanhf", "cdecl")
    atanhf.argtypes = [c_float]
    atanhf.restype = c_float

# /usr/include/bits/mathcalls.h: 92
for _lib in _libs.values():
    if not _lib.has("__atanhf", "cdecl"):
        continue
    __atanhf = _lib.get("__atanhf", "cdecl")
    __atanhf.argtypes = [c_float]
    __atanhf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 100
if _libs["libPyFd.so"].has("expf", "cdecl"):
    expf = _libs["libPyFd.so"].get("expf", "cdecl")
    expf.argtypes = [c_float]
    expf.restype = c_float

# /usr/include/bits/mathcalls.h: 100
for _lib in _libs.values():
    if not _lib.has("__expf", "cdecl"):
        continue
    __expf = _lib.get("__expf", "cdecl")
    __expf.argtypes = [c_float]
    __expf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 103
if _libs["libPyFd.so"].has("frexpf", "cdecl"):
    frexpf = _libs["libPyFd.so"].get("frexpf", "cdecl")
    frexpf.argtypes = [c_float, POINTER(c_int)]
    frexpf.restype = c_float

# /usr/include/bits/mathcalls.h: 103
for _lib in _libs.values():
    if not _lib.has("__frexpf", "cdecl"):
        continue
    __frexpf = _lib.get("__frexpf", "cdecl")
    __frexpf.argtypes = [c_float, POINTER(c_int)]
    __frexpf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 106
if _libs["libPyFd.so"].has("ldexpf", "cdecl"):
    ldexpf = _libs["libPyFd.so"].get("ldexpf", "cdecl")
    ldexpf.argtypes = [c_float, c_int]
    ldexpf.restype = c_float

# /usr/include/bits/mathcalls.h: 106
for _lib in _libs.values():
    if not _lib.has("__ldexpf", "cdecl"):
        continue
    __ldexpf = _lib.get("__ldexpf", "cdecl")
    __ldexpf.argtypes = [c_float, c_int]
    __ldexpf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 109
if _libs["libPyFd.so"].has("logf", "cdecl"):
    logf = _libs["libPyFd.so"].get("logf", "cdecl")
    logf.argtypes = [c_float]
    logf.restype = c_float

# /usr/include/bits/mathcalls.h: 109
for _lib in _libs.values():
    if not _lib.has("__logf", "cdecl"):
        continue
    __logf = _lib.get("__logf", "cdecl")
    __logf.argtypes = [c_float]
    __logf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 112
if _libs["libPyFd.so"].has("log10f", "cdecl"):
    log10f = _libs["libPyFd.so"].get("log10f", "cdecl")
    log10f.argtypes = [c_float]
    log10f.restype = c_float

# /usr/include/bits/mathcalls.h: 112
for _lib in _libs.values():
    if not _lib.has("__log10f", "cdecl"):
        continue
    __log10f = _lib.get("__log10f", "cdecl")
    __log10f.argtypes = [c_float]
    __log10f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 115
if _libs["libPyFd.so"].has("modff", "cdecl"):
    modff = _libs["libPyFd.so"].get("modff", "cdecl")
    modff.argtypes = [c_float, POINTER(c_float)]
    modff.restype = c_float

# /usr/include/bits/mathcalls.h: 115
for _lib in _libs.values():
    if not _lib.has("__modff", "cdecl"):
        continue
    __modff = _lib.get("__modff", "cdecl")
    __modff.argtypes = [c_float, POINTER(c_float)]
    __modff.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 129
if _libs["libPyFd.so"].has("expm1f", "cdecl"):
    expm1f = _libs["libPyFd.so"].get("expm1f", "cdecl")
    expm1f.argtypes = [c_float]
    expm1f.restype = c_float

# /usr/include/bits/mathcalls.h: 129
for _lib in _libs.values():
    if not _lib.has("__expm1f", "cdecl"):
        continue
    __expm1f = _lib.get("__expm1f", "cdecl")
    __expm1f.argtypes = [c_float]
    __expm1f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 132
if _libs["libPyFd.so"].has("log1pf", "cdecl"):
    log1pf = _libs["libPyFd.so"].get("log1pf", "cdecl")
    log1pf.argtypes = [c_float]
    log1pf.restype = c_float

# /usr/include/bits/mathcalls.h: 132
for _lib in _libs.values():
    if not _lib.has("__log1pf", "cdecl"):
        continue
    __log1pf = _lib.get("__log1pf", "cdecl")
    __log1pf.argtypes = [c_float]
    __log1pf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 135
if _libs["libPyFd.so"].has("logbf", "cdecl"):
    logbf = _libs["libPyFd.so"].get("logbf", "cdecl")
    logbf.argtypes = [c_float]
    logbf.restype = c_float

# /usr/include/bits/mathcalls.h: 135
for _lib in _libs.values():
    if not _lib.has("__logbf", "cdecl"):
        continue
    __logbf = _lib.get("__logbf", "cdecl")
    __logbf.argtypes = [c_float]
    __logbf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 142
if _libs["libPyFd.so"].has("exp2f", "cdecl"):
    exp2f = _libs["libPyFd.so"].get("exp2f", "cdecl")
    exp2f.argtypes = [c_float]
    exp2f.restype = c_float

# /usr/include/bits/mathcalls.h: 142
for _lib in _libs.values():
    if not _lib.has("__exp2f", "cdecl"):
        continue
    __exp2f = _lib.get("__exp2f", "cdecl")
    __exp2f.argtypes = [c_float]
    __exp2f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 145
if _libs["libPyFd.so"].has("log2f", "cdecl"):
    log2f = _libs["libPyFd.so"].get("log2f", "cdecl")
    log2f.argtypes = [c_float]
    log2f.restype = c_float

# /usr/include/bits/mathcalls.h: 145
for _lib in _libs.values():
    if not _lib.has("__log2f", "cdecl"):
        continue
    __log2f = _lib.get("__log2f", "cdecl")
    __log2f.argtypes = [c_float]
    __log2f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 154
if _libs["libPyFd.so"].has("powf", "cdecl"):
    powf = _libs["libPyFd.so"].get("powf", "cdecl")
    powf.argtypes = [c_float, c_float]
    powf.restype = c_float

# /usr/include/bits/mathcalls.h: 154
for _lib in _libs.values():
    if not _lib.has("__powf", "cdecl"):
        continue
    __powf = _lib.get("__powf", "cdecl")
    __powf.argtypes = [c_float, c_float]
    __powf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 157
if _libs["libPyFd.so"].has("sqrtf", "cdecl"):
    sqrtf = _libs["libPyFd.so"].get("sqrtf", "cdecl")
    sqrtf.argtypes = [c_float]
    sqrtf.restype = c_float

# /usr/include/bits/mathcalls.h: 157
for _lib in _libs.values():
    if not _lib.has("__sqrtf", "cdecl"):
        continue
    __sqrtf = _lib.get("__sqrtf", "cdecl")
    __sqrtf.argtypes = [c_float]
    __sqrtf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 163
if _libs["libPyFd.so"].has("hypotf", "cdecl"):
    hypotf = _libs["libPyFd.so"].get("hypotf", "cdecl")
    hypotf.argtypes = [c_float, c_float]
    hypotf.restype = c_float

# /usr/include/bits/mathcalls.h: 163
for _lib in _libs.values():
    if not _lib.has("__hypotf", "cdecl"):
        continue
    __hypotf = _lib.get("__hypotf", "cdecl")
    __hypotf.argtypes = [c_float, c_float]
    __hypotf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 170
if _libs["libPyFd.so"].has("cbrtf", "cdecl"):
    cbrtf = _libs["libPyFd.so"].get("cbrtf", "cdecl")
    cbrtf.argtypes = [c_float]
    cbrtf.restype = c_float

# /usr/include/bits/mathcalls.h: 170
for _lib in _libs.values():
    if not _lib.has("__cbrtf", "cdecl"):
        continue
    __cbrtf = _lib.get("__cbrtf", "cdecl")
    __cbrtf.argtypes = [c_float]
    __cbrtf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 179
if _libs["libPyFd.so"].has("ceilf", "cdecl"):
    ceilf = _libs["libPyFd.so"].get("ceilf", "cdecl")
    ceilf.argtypes = [c_float]
    ceilf.restype = c_float

# /usr/include/bits/mathcalls.h: 179
for _lib in _libs.values():
    if not _lib.has("__ceilf", "cdecl"):
        continue
    __ceilf = _lib.get("__ceilf", "cdecl")
    __ceilf.argtypes = [c_float]
    __ceilf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 182
if _libs["libPyFd.so"].has("fabsf", "cdecl"):
    fabsf = _libs["libPyFd.so"].get("fabsf", "cdecl")
    fabsf.argtypes = [c_float]
    fabsf.restype = c_float

# /usr/include/bits/mathcalls.h: 182
for _lib in _libs.values():
    if not _lib.has("__fabsf", "cdecl"):
        continue
    __fabsf = _lib.get("__fabsf", "cdecl")
    __fabsf.argtypes = [c_float]
    __fabsf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 185
if _libs["libPyFd.so"].has("floorf", "cdecl"):
    floorf = _libs["libPyFd.so"].get("floorf", "cdecl")
    floorf.argtypes = [c_float]
    floorf.restype = c_float

# /usr/include/bits/mathcalls.h: 185
for _lib in _libs.values():
    if not _lib.has("__floorf", "cdecl"):
        continue
    __floorf = _lib.get("__floorf", "cdecl")
    __floorf.argtypes = [c_float]
    __floorf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 188
if _libs["libPyFd.so"].has("fmodf", "cdecl"):
    fmodf = _libs["libPyFd.so"].get("fmodf", "cdecl")
    fmodf.argtypes = [c_float, c_float]
    fmodf.restype = c_float

# /usr/include/bits/mathcalls.h: 188
for _lib in _libs.values():
    if not _lib.has("__fmodf", "cdecl"):
        continue
    __fmodf = _lib.get("__fmodf", "cdecl")
    __fmodf.argtypes = [c_float, c_float]
    __fmodf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 193
if _libs["libPyFd.so"].has("__isinff", "cdecl"):
    __isinff = _libs["libPyFd.so"].get("__isinff", "cdecl")
    __isinff.argtypes = [c_float]
    __isinff.restype = c_int

# /usr/include/bits/mathcalls.h: 196
if _libs["libPyFd.so"].has("__finitef", "cdecl"):
    __finitef = _libs["libPyFd.so"].get("__finitef", "cdecl")
    __finitef.argtypes = [c_float]
    __finitef.restype = c_int

# /usr/include/bits/mathcalls.h: 202
if _libs["libPyFd.so"].has("isinff", "cdecl"):
    isinff = _libs["libPyFd.so"].get("isinff", "cdecl")
    isinff.argtypes = [c_float]
    isinff.restype = c_int

# /usr/include/bits/mathcalls.h: 205
if _libs["libPyFd.so"].has("finitef", "cdecl"):
    finitef = _libs["libPyFd.so"].get("finitef", "cdecl")
    finitef.argtypes = [c_float]
    finitef.restype = c_int

# /usr/include/bits/mathcalls.h: 208
if _libs["libPyFd.so"].has("dremf", "cdecl"):
    dremf = _libs["libPyFd.so"].get("dremf", "cdecl")
    dremf.argtypes = [c_float, c_float]
    dremf.restype = c_float

# /usr/include/bits/mathcalls.h: 208
for _lib in _libs.values():
    if not _lib.has("__dremf", "cdecl"):
        continue
    __dremf = _lib.get("__dremf", "cdecl")
    __dremf.argtypes = [c_float, c_float]
    __dremf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 212
if _libs["libPyFd.so"].has("significandf", "cdecl"):
    significandf = _libs["libPyFd.so"].get("significandf", "cdecl")
    significandf.argtypes = [c_float]
    significandf.restype = c_float

# /usr/include/bits/mathcalls.h: 212
for _lib in _libs.values():
    if not _lib.has("__significandf", "cdecl"):
        continue
    __significandf = _lib.get("__significandf", "cdecl")
    __significandf.argtypes = [c_float]
    __significandf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 218
if _libs["libPyFd.so"].has("copysignf", "cdecl"):
    copysignf = _libs["libPyFd.so"].get("copysignf", "cdecl")
    copysignf.argtypes = [c_float, c_float]
    copysignf.restype = c_float

# /usr/include/bits/mathcalls.h: 218
for _lib in _libs.values():
    if not _lib.has("__copysignf", "cdecl"):
        continue
    __copysignf = _lib.get("__copysignf", "cdecl")
    __copysignf.argtypes = [c_float, c_float]
    __copysignf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 225
if _libs["libPyFd.so"].has("nanf", "cdecl"):
    nanf = _libs["libPyFd.so"].get("nanf", "cdecl")
    nanf.argtypes = [String]
    nanf.restype = c_float

# /usr/include/bits/mathcalls.h: 225
for _lib in _libs.values():
    if not _lib.has("__nanf", "cdecl"):
        continue
    __nanf = _lib.get("__nanf", "cdecl")
    __nanf.argtypes = [String]
    __nanf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 231
if _libs["libPyFd.so"].has("__isnanf", "cdecl"):
    __isnanf = _libs["libPyFd.so"].get("__isnanf", "cdecl")
    __isnanf.argtypes = [c_float]
    __isnanf.restype = c_int

# /usr/include/bits/mathcalls.h: 235
if _libs["libPyFd.so"].has("isnanf", "cdecl"):
    isnanf = _libs["libPyFd.so"].get("isnanf", "cdecl")
    isnanf.argtypes = [c_float]
    isnanf.restype = c_int

# /usr/include/bits/mathcalls.h: 238
if _libs["libPyFd.so"].has("j0f", "cdecl"):
    j0f = _libs["libPyFd.so"].get("j0f", "cdecl")
    j0f.argtypes = [c_float]
    j0f.restype = c_float

# /usr/include/bits/mathcalls.h: 238
for _lib in _libs.values():
    if not _lib.has("__j0f", "cdecl"):
        continue
    __j0f = _lib.get("__j0f", "cdecl")
    __j0f.argtypes = [c_float]
    __j0f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 239
if _libs["libPyFd.so"].has("j1f", "cdecl"):
    j1f = _libs["libPyFd.so"].get("j1f", "cdecl")
    j1f.argtypes = [c_float]
    j1f.restype = c_float

# /usr/include/bits/mathcalls.h: 239
for _lib in _libs.values():
    if not _lib.has("__j1f", "cdecl"):
        continue
    __j1f = _lib.get("__j1f", "cdecl")
    __j1f.argtypes = [c_float]
    __j1f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 240
if _libs["libPyFd.so"].has("jnf", "cdecl"):
    jnf = _libs["libPyFd.so"].get("jnf", "cdecl")
    jnf.argtypes = [c_int, c_float]
    jnf.restype = c_float

# /usr/include/bits/mathcalls.h: 240
for _lib in _libs.values():
    if not _lib.has("__jnf", "cdecl"):
        continue
    __jnf = _lib.get("__jnf", "cdecl")
    __jnf.argtypes = [c_int, c_float]
    __jnf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 241
if _libs["libPyFd.so"].has("y0f", "cdecl"):
    y0f = _libs["libPyFd.so"].get("y0f", "cdecl")
    y0f.argtypes = [c_float]
    y0f.restype = c_float

# /usr/include/bits/mathcalls.h: 241
for _lib in _libs.values():
    if not _lib.has("__y0f", "cdecl"):
        continue
    __y0f = _lib.get("__y0f", "cdecl")
    __y0f.argtypes = [c_float]
    __y0f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 242
if _libs["libPyFd.so"].has("y1f", "cdecl"):
    y1f = _libs["libPyFd.so"].get("y1f", "cdecl")
    y1f.argtypes = [c_float]
    y1f.restype = c_float

# /usr/include/bits/mathcalls.h: 242
for _lib in _libs.values():
    if not _lib.has("__y1f", "cdecl"):
        continue
    __y1f = _lib.get("__y1f", "cdecl")
    __y1f.argtypes = [c_float]
    __y1f.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 243
if _libs["libPyFd.so"].has("ynf", "cdecl"):
    ynf = _libs["libPyFd.so"].get("ynf", "cdecl")
    ynf.argtypes = [c_int, c_float]
    ynf.restype = c_float

# /usr/include/bits/mathcalls.h: 243
for _lib in _libs.values():
    if not _lib.has("__ynf", "cdecl"):
        continue
    __ynf = _lib.get("__ynf", "cdecl")
    __ynf.argtypes = [c_int, c_float]
    __ynf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 250
if _libs["libPyFd.so"].has("erff", "cdecl"):
    erff = _libs["libPyFd.so"].get("erff", "cdecl")
    erff.argtypes = [c_float]
    erff.restype = c_float

# /usr/include/bits/mathcalls.h: 250
for _lib in _libs.values():
    if not _lib.has("__erff", "cdecl"):
        continue
    __erff = _lib.get("__erff", "cdecl")
    __erff.argtypes = [c_float]
    __erff.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 251
if _libs["libPyFd.so"].has("erfcf", "cdecl"):
    erfcf = _libs["libPyFd.so"].get("erfcf", "cdecl")
    erfcf.argtypes = [c_float]
    erfcf.restype = c_float

# /usr/include/bits/mathcalls.h: 251
for _lib in _libs.values():
    if not _lib.has("__erfcf", "cdecl"):
        continue
    __erfcf = _lib.get("__erfcf", "cdecl")
    __erfcf.argtypes = [c_float]
    __erfcf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 252
if _libs["libPyFd.so"].has("lgammaf", "cdecl"):
    lgammaf = _libs["libPyFd.so"].get("lgammaf", "cdecl")
    lgammaf.argtypes = [c_float]
    lgammaf.restype = c_float

# /usr/include/bits/mathcalls.h: 252
for _lib in _libs.values():
    if not _lib.has("__lgammaf", "cdecl"):
        continue
    __lgammaf = _lib.get("__lgammaf", "cdecl")
    __lgammaf.argtypes = [c_float]
    __lgammaf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 259
if _libs["libPyFd.so"].has("tgammaf", "cdecl"):
    tgammaf = _libs["libPyFd.so"].get("tgammaf", "cdecl")
    tgammaf.argtypes = [c_float]
    tgammaf.restype = c_float

# /usr/include/bits/mathcalls.h: 259
for _lib in _libs.values():
    if not _lib.has("__tgammaf", "cdecl"):
        continue
    __tgammaf = _lib.get("__tgammaf", "cdecl")
    __tgammaf.argtypes = [c_float]
    __tgammaf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 265
if _libs["libPyFd.so"].has("gammaf", "cdecl"):
    gammaf = _libs["libPyFd.so"].get("gammaf", "cdecl")
    gammaf.argtypes = [c_float]
    gammaf.restype = c_float

# /usr/include/bits/mathcalls.h: 265
for _lib in _libs.values():
    if not _lib.has("__gammaf", "cdecl"):
        continue
    __gammaf = _lib.get("__gammaf", "cdecl")
    __gammaf.argtypes = [c_float]
    __gammaf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 272
if _libs["libPyFd.so"].has("lgammaf_r", "cdecl"):
    lgammaf_r = _libs["libPyFd.so"].get("lgammaf_r", "cdecl")
    lgammaf_r.argtypes = [c_float, POINTER(c_int)]
    lgammaf_r.restype = c_float

# /usr/include/bits/mathcalls.h: 272
for _lib in _libs.values():
    if not _lib.has("__lgammaf_r", "cdecl"):
        continue
    __lgammaf_r = _lib.get("__lgammaf_r", "cdecl")
    __lgammaf_r.argtypes = [c_float, POINTER(c_int)]
    __lgammaf_r.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 280
if _libs["libPyFd.so"].has("rintf", "cdecl"):
    rintf = _libs["libPyFd.so"].get("rintf", "cdecl")
    rintf.argtypes = [c_float]
    rintf.restype = c_float

# /usr/include/bits/mathcalls.h: 280
for _lib in _libs.values():
    if not _lib.has("__rintf", "cdecl"):
        continue
    __rintf = _lib.get("__rintf", "cdecl")
    __rintf.argtypes = [c_float]
    __rintf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 283
if _libs["libPyFd.so"].has("nextafterf", "cdecl"):
    nextafterf = _libs["libPyFd.so"].get("nextafterf", "cdecl")
    nextafterf.argtypes = [c_float, c_float]
    nextafterf.restype = c_float

# /usr/include/bits/mathcalls.h: 283
for _lib in _libs.values():
    if not _lib.has("__nextafterf", "cdecl"):
        continue
    __nextafterf = _lib.get("__nextafterf", "cdecl")
    __nextafterf.argtypes = [c_float, c_float]
    __nextafterf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 285
if _libs["libPyFd.so"].has("nexttowardf", "cdecl"):
    nexttowardf = _libs["libPyFd.so"].get("nexttowardf", "cdecl")
    nexttowardf.argtypes = [c_float, c_longdouble]
    nexttowardf.restype = c_float

# /usr/include/bits/mathcalls.h: 285
for _lib in _libs.values():
    if not _lib.has("__nexttowardf", "cdecl"):
        continue
    __nexttowardf = _lib.get("__nexttowardf", "cdecl")
    __nexttowardf.argtypes = [c_float, c_longdouble]
    __nexttowardf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 289
if _libs["libPyFd.so"].has("remainderf", "cdecl"):
    remainderf = _libs["libPyFd.so"].get("remainderf", "cdecl")
    remainderf.argtypes = [c_float, c_float]
    remainderf.restype = c_float

# /usr/include/bits/mathcalls.h: 289
for _lib in _libs.values():
    if not _lib.has("__remainderf", "cdecl"):
        continue
    __remainderf = _lib.get("__remainderf", "cdecl")
    __remainderf.argtypes = [c_float, c_float]
    __remainderf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 293
if _libs["libPyFd.so"].has("scalbnf", "cdecl"):
    scalbnf = _libs["libPyFd.so"].get("scalbnf", "cdecl")
    scalbnf.argtypes = [c_float, c_int]
    scalbnf.restype = c_float

# /usr/include/bits/mathcalls.h: 293
for _lib in _libs.values():
    if not _lib.has("__scalbnf", "cdecl"):
        continue
    __scalbnf = _lib.get("__scalbnf", "cdecl")
    __scalbnf.argtypes = [c_float, c_int]
    __scalbnf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 297
if _libs["libPyFd.so"].has("ilogbf", "cdecl"):
    ilogbf = _libs["libPyFd.so"].get("ilogbf", "cdecl")
    ilogbf.argtypes = [c_float]
    ilogbf.restype = c_int

# /usr/include/bits/mathcalls.h: 297
for _lib in _libs.values():
    if not _lib.has("__ilogbf", "cdecl"):
        continue
    __ilogbf = _lib.get("__ilogbf", "cdecl")
    __ilogbf.argtypes = [c_float]
    __ilogbf.restype = c_int
    break

# /usr/include/bits/mathcalls.h: 302
if _libs["libPyFd.so"].has("scalblnf", "cdecl"):
    scalblnf = _libs["libPyFd.so"].get("scalblnf", "cdecl")
    scalblnf.argtypes = [c_float, c_long]
    scalblnf.restype = c_float

# /usr/include/bits/mathcalls.h: 302
for _lib in _libs.values():
    if not _lib.has("__scalblnf", "cdecl"):
        continue
    __scalblnf = _lib.get("__scalblnf", "cdecl")
    __scalblnf.argtypes = [c_float, c_long]
    __scalblnf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 306
if _libs["libPyFd.so"].has("nearbyintf", "cdecl"):
    nearbyintf = _libs["libPyFd.so"].get("nearbyintf", "cdecl")
    nearbyintf.argtypes = [c_float]
    nearbyintf.restype = c_float

# /usr/include/bits/mathcalls.h: 306
for _lib in _libs.values():
    if not _lib.has("__nearbyintf", "cdecl"):
        continue
    __nearbyintf = _lib.get("__nearbyintf", "cdecl")
    __nearbyintf.argtypes = [c_float]
    __nearbyintf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 310
if _libs["libPyFd.so"].has("roundf", "cdecl"):
    roundf = _libs["libPyFd.so"].get("roundf", "cdecl")
    roundf.argtypes = [c_float]
    roundf.restype = c_float

# /usr/include/bits/mathcalls.h: 310
for _lib in _libs.values():
    if not _lib.has("__roundf", "cdecl"):
        continue
    __roundf = _lib.get("__roundf", "cdecl")
    __roundf.argtypes = [c_float]
    __roundf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 314
if _libs["libPyFd.so"].has("truncf", "cdecl"):
    truncf = _libs["libPyFd.so"].get("truncf", "cdecl")
    truncf.argtypes = [c_float]
    truncf.restype = c_float

# /usr/include/bits/mathcalls.h: 314
for _lib in _libs.values():
    if not _lib.has("__truncf", "cdecl"):
        continue
    __truncf = _lib.get("__truncf", "cdecl")
    __truncf.argtypes = [c_float]
    __truncf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 319
if _libs["libPyFd.so"].has("remquof", "cdecl"):
    remquof = _libs["libPyFd.so"].get("remquof", "cdecl")
    remquof.argtypes = [c_float, c_float, POINTER(c_int)]
    remquof.restype = c_float

# /usr/include/bits/mathcalls.h: 319
for _lib in _libs.values():
    if not _lib.has("__remquof", "cdecl"):
        continue
    __remquof = _lib.get("__remquof", "cdecl")
    __remquof.argtypes = [c_float, c_float, POINTER(c_int)]
    __remquof.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 326
if _libs["libPyFd.so"].has("lrintf", "cdecl"):
    lrintf = _libs["libPyFd.so"].get("lrintf", "cdecl")
    lrintf.argtypes = [c_float]
    lrintf.restype = c_long

# /usr/include/bits/mathcalls.h: 326
for _lib in _libs.values():
    if not _lib.has("__lrintf", "cdecl"):
        continue
    __lrintf = _lib.get("__lrintf", "cdecl")
    __lrintf.argtypes = [c_float]
    __lrintf.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 327
if _libs["libPyFd.so"].has("llrintf", "cdecl"):
    llrintf = _libs["libPyFd.so"].get("llrintf", "cdecl")
    llrintf.argtypes = [c_float]
    llrintf.restype = c_longlong

# /usr/include/bits/mathcalls.h: 327
for _lib in _libs.values():
    if not _lib.has("__llrintf", "cdecl"):
        continue
    __llrintf = _lib.get("__llrintf", "cdecl")
    __llrintf.argtypes = [c_float]
    __llrintf.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 331
if _libs["libPyFd.so"].has("lroundf", "cdecl"):
    lroundf = _libs["libPyFd.so"].get("lroundf", "cdecl")
    lroundf.argtypes = [c_float]
    lroundf.restype = c_long

# /usr/include/bits/mathcalls.h: 331
for _lib in _libs.values():
    if not _lib.has("__lroundf", "cdecl"):
        continue
    __lroundf = _lib.get("__lroundf", "cdecl")
    __lroundf.argtypes = [c_float]
    __lroundf.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 332
if _libs["libPyFd.so"].has("llroundf", "cdecl"):
    llroundf = _libs["libPyFd.so"].get("llroundf", "cdecl")
    llroundf.argtypes = [c_float]
    llroundf.restype = c_longlong

# /usr/include/bits/mathcalls.h: 332
for _lib in _libs.values():
    if not _lib.has("__llroundf", "cdecl"):
        continue
    __llroundf = _lib.get("__llroundf", "cdecl")
    __llroundf.argtypes = [c_float]
    __llroundf.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 336
if _libs["libPyFd.so"].has("fdimf", "cdecl"):
    fdimf = _libs["libPyFd.so"].get("fdimf", "cdecl")
    fdimf.argtypes = [c_float, c_float]
    fdimf.restype = c_float

# /usr/include/bits/mathcalls.h: 336
for _lib in _libs.values():
    if not _lib.has("__fdimf", "cdecl"):
        continue
    __fdimf = _lib.get("__fdimf", "cdecl")
    __fdimf.argtypes = [c_float, c_float]
    __fdimf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 339
if _libs["libPyFd.so"].has("fmaxf", "cdecl"):
    fmaxf = _libs["libPyFd.so"].get("fmaxf", "cdecl")
    fmaxf.argtypes = [c_float, c_float]
    fmaxf.restype = c_float

# /usr/include/bits/mathcalls.h: 339
for _lib in _libs.values():
    if not _lib.has("__fmaxf", "cdecl"):
        continue
    __fmaxf = _lib.get("__fmaxf", "cdecl")
    __fmaxf.argtypes = [c_float, c_float]
    __fmaxf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 342
if _libs["libPyFd.so"].has("fminf", "cdecl"):
    fminf = _libs["libPyFd.so"].get("fminf", "cdecl")
    fminf.argtypes = [c_float, c_float]
    fminf.restype = c_float

# /usr/include/bits/mathcalls.h: 342
for _lib in _libs.values():
    if not _lib.has("__fminf", "cdecl"):
        continue
    __fminf = _lib.get("__fminf", "cdecl")
    __fminf.argtypes = [c_float, c_float]
    __fminf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 346
if _libs["libPyFd.so"].has("__fpclassifyf", "cdecl"):
    __fpclassifyf = _libs["libPyFd.so"].get("__fpclassifyf", "cdecl")
    __fpclassifyf.argtypes = [c_float]
    __fpclassifyf.restype = c_int

# /usr/include/bits/mathcalls.h: 350
if _libs["libPyFd.so"].has("__signbitf", "cdecl"):
    __signbitf = _libs["libPyFd.so"].get("__signbitf", "cdecl")
    __signbitf.argtypes = [c_float]
    __signbitf.restype = c_int

# /usr/include/bits/mathcalls.h: 355
if _libs["libPyFd.so"].has("fmaf", "cdecl"):
    fmaf = _libs["libPyFd.so"].get("fmaf", "cdecl")
    fmaf.argtypes = [c_float, c_float, c_float]
    fmaf.restype = c_float

# /usr/include/bits/mathcalls.h: 355
for _lib in _libs.values():
    if not _lib.has("__fmaf", "cdecl"):
        continue
    __fmaf = _lib.get("__fmaf", "cdecl")
    __fmaf.argtypes = [c_float, c_float, c_float]
    __fmaf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 364
if _libs["libPyFd.so"].has("scalbf", "cdecl"):
    scalbf = _libs["libPyFd.so"].get("scalbf", "cdecl")
    scalbf.argtypes = [c_float, c_float]
    scalbf.restype = c_float

# /usr/include/bits/mathcalls.h: 364
for _lib in _libs.values():
    if not _lib.has("__scalbf", "cdecl"):
        continue
    __scalbf = _lib.get("__scalbf", "cdecl")
    __scalbf.argtypes = [c_float, c_float]
    __scalbf.restype = c_float
    break

# /usr/include/bits/mathcalls.h: 54
if _libs["libPyFd.so"].has("acosl", "cdecl"):
    acosl = _libs["libPyFd.so"].get("acosl", "cdecl")
    acosl.argtypes = [c_longdouble]
    acosl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 54
for _lib in _libs.values():
    if not _lib.has("__acosl", "cdecl"):
        continue
    __acosl = _lib.get("__acosl", "cdecl")
    __acosl.argtypes = [c_longdouble]
    __acosl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 56
if _libs["libPyFd.so"].has("asinl", "cdecl"):
    asinl = _libs["libPyFd.so"].get("asinl", "cdecl")
    asinl.argtypes = [c_longdouble]
    asinl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 56
for _lib in _libs.values():
    if not _lib.has("__asinl", "cdecl"):
        continue
    __asinl = _lib.get("__asinl", "cdecl")
    __asinl.argtypes = [c_longdouble]
    __asinl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 58
if _libs["libPyFd.so"].has("atanl", "cdecl"):
    atanl = _libs["libPyFd.so"].get("atanl", "cdecl")
    atanl.argtypes = [c_longdouble]
    atanl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 58
for _lib in _libs.values():
    if not _lib.has("__atanl", "cdecl"):
        continue
    __atanl = _lib.get("__atanl", "cdecl")
    __atanl.argtypes = [c_longdouble]
    __atanl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 60
if _libs["libPyFd.so"].has("atan2l", "cdecl"):
    atan2l = _libs["libPyFd.so"].get("atan2l", "cdecl")
    atan2l.argtypes = [c_longdouble, c_longdouble]
    atan2l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 60
for _lib in _libs.values():
    if not _lib.has("__atan2l", "cdecl"):
        continue
    __atan2l = _lib.get("__atan2l", "cdecl")
    __atan2l.argtypes = [c_longdouble, c_longdouble]
    __atan2l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 63
if _libs["libPyFd.so"].has("cosl", "cdecl"):
    cosl = _libs["libPyFd.so"].get("cosl", "cdecl")
    cosl.argtypes = [c_longdouble]
    cosl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 63
for _lib in _libs.values():
    if not _lib.has("__cosl", "cdecl"):
        continue
    __cosl = _lib.get("__cosl", "cdecl")
    __cosl.argtypes = [c_longdouble]
    __cosl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 65
if _libs["libPyFd.so"].has("sinl", "cdecl"):
    sinl = _libs["libPyFd.so"].get("sinl", "cdecl")
    sinl.argtypes = [c_longdouble]
    sinl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 65
for _lib in _libs.values():
    if not _lib.has("__sinl", "cdecl"):
        continue
    __sinl = _lib.get("__sinl", "cdecl")
    __sinl.argtypes = [c_longdouble]
    __sinl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 67
if _libs["libPyFd.so"].has("tanl", "cdecl"):
    tanl = _libs["libPyFd.so"].get("tanl", "cdecl")
    tanl.argtypes = [c_longdouble]
    tanl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 67
for _lib in _libs.values():
    if not _lib.has("__tanl", "cdecl"):
        continue
    __tanl = _lib.get("__tanl", "cdecl")
    __tanl.argtypes = [c_longdouble]
    __tanl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 72
if _libs["libPyFd.so"].has("coshl", "cdecl"):
    coshl = _libs["libPyFd.so"].get("coshl", "cdecl")
    coshl.argtypes = [c_longdouble]
    coshl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 72
for _lib in _libs.values():
    if not _lib.has("__coshl", "cdecl"):
        continue
    __coshl = _lib.get("__coshl", "cdecl")
    __coshl.argtypes = [c_longdouble]
    __coshl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 74
if _libs["libPyFd.so"].has("sinhl", "cdecl"):
    sinhl = _libs["libPyFd.so"].get("sinhl", "cdecl")
    sinhl.argtypes = [c_longdouble]
    sinhl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 74
for _lib in _libs.values():
    if not _lib.has("__sinhl", "cdecl"):
        continue
    __sinhl = _lib.get("__sinhl", "cdecl")
    __sinhl.argtypes = [c_longdouble]
    __sinhl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 76
if _libs["libPyFd.so"].has("tanhl", "cdecl"):
    tanhl = _libs["libPyFd.so"].get("tanhl", "cdecl")
    tanhl.argtypes = [c_longdouble]
    tanhl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 76
for _lib in _libs.values():
    if not _lib.has("__tanhl", "cdecl"):
        continue
    __tanhl = _lib.get("__tanhl", "cdecl")
    __tanhl.argtypes = [c_longdouble]
    __tanhl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 88
if _libs["libPyFd.so"].has("acoshl", "cdecl"):
    acoshl = _libs["libPyFd.so"].get("acoshl", "cdecl")
    acoshl.argtypes = [c_longdouble]
    acoshl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 88
for _lib in _libs.values():
    if not _lib.has("__acoshl", "cdecl"):
        continue
    __acoshl = _lib.get("__acoshl", "cdecl")
    __acoshl.argtypes = [c_longdouble]
    __acoshl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 90
if _libs["libPyFd.so"].has("asinhl", "cdecl"):
    asinhl = _libs["libPyFd.so"].get("asinhl", "cdecl")
    asinhl.argtypes = [c_longdouble]
    asinhl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 90
for _lib in _libs.values():
    if not _lib.has("__asinhl", "cdecl"):
        continue
    __asinhl = _lib.get("__asinhl", "cdecl")
    __asinhl.argtypes = [c_longdouble]
    __asinhl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 92
if _libs["libPyFd.so"].has("atanhl", "cdecl"):
    atanhl = _libs["libPyFd.so"].get("atanhl", "cdecl")
    atanhl.argtypes = [c_longdouble]
    atanhl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 92
for _lib in _libs.values():
    if not _lib.has("__atanhl", "cdecl"):
        continue
    __atanhl = _lib.get("__atanhl", "cdecl")
    __atanhl.argtypes = [c_longdouble]
    __atanhl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 100
if _libs["libPyFd.so"].has("expl", "cdecl"):
    expl = _libs["libPyFd.so"].get("expl", "cdecl")
    expl.argtypes = [c_longdouble]
    expl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 100
for _lib in _libs.values():
    if not _lib.has("__expl", "cdecl"):
        continue
    __expl = _lib.get("__expl", "cdecl")
    __expl.argtypes = [c_longdouble]
    __expl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 103
if _libs["libPyFd.so"].has("frexpl", "cdecl"):
    frexpl = _libs["libPyFd.so"].get("frexpl", "cdecl")
    frexpl.argtypes = [c_longdouble, POINTER(c_int)]
    frexpl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 103
for _lib in _libs.values():
    if not _lib.has("__frexpl", "cdecl"):
        continue
    __frexpl = _lib.get("__frexpl", "cdecl")
    __frexpl.argtypes = [c_longdouble, POINTER(c_int)]
    __frexpl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 106
if _libs["libPyFd.so"].has("ldexpl", "cdecl"):
    ldexpl = _libs["libPyFd.so"].get("ldexpl", "cdecl")
    ldexpl.argtypes = [c_longdouble, c_int]
    ldexpl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 106
for _lib in _libs.values():
    if not _lib.has("__ldexpl", "cdecl"):
        continue
    __ldexpl = _lib.get("__ldexpl", "cdecl")
    __ldexpl.argtypes = [c_longdouble, c_int]
    __ldexpl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 109
if _libs["libPyFd.so"].has("logl", "cdecl"):
    logl = _libs["libPyFd.so"].get("logl", "cdecl")
    logl.argtypes = [c_longdouble]
    logl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 109
for _lib in _libs.values():
    if not _lib.has("__logl", "cdecl"):
        continue
    __logl = _lib.get("__logl", "cdecl")
    __logl.argtypes = [c_longdouble]
    __logl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 112
if _libs["libPyFd.so"].has("log10l", "cdecl"):
    log10l = _libs["libPyFd.so"].get("log10l", "cdecl")
    log10l.argtypes = [c_longdouble]
    log10l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 112
for _lib in _libs.values():
    if not _lib.has("__log10l", "cdecl"):
        continue
    __log10l = _lib.get("__log10l", "cdecl")
    __log10l.argtypes = [c_longdouble]
    __log10l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 115
if _libs["libPyFd.so"].has("modfl", "cdecl"):
    modfl = _libs["libPyFd.so"].get("modfl", "cdecl")
    modfl.argtypes = [c_longdouble, POINTER(c_longdouble)]
    modfl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 115
for _lib in _libs.values():
    if not _lib.has("__modfl", "cdecl"):
        continue
    __modfl = _lib.get("__modfl", "cdecl")
    __modfl.argtypes = [c_longdouble, POINTER(c_longdouble)]
    __modfl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 129
if _libs["libPyFd.so"].has("expm1l", "cdecl"):
    expm1l = _libs["libPyFd.so"].get("expm1l", "cdecl")
    expm1l.argtypes = [c_longdouble]
    expm1l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 129
for _lib in _libs.values():
    if not _lib.has("__expm1l", "cdecl"):
        continue
    __expm1l = _lib.get("__expm1l", "cdecl")
    __expm1l.argtypes = [c_longdouble]
    __expm1l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 132
if _libs["libPyFd.so"].has("log1pl", "cdecl"):
    log1pl = _libs["libPyFd.so"].get("log1pl", "cdecl")
    log1pl.argtypes = [c_longdouble]
    log1pl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 132
for _lib in _libs.values():
    if not _lib.has("__log1pl", "cdecl"):
        continue
    __log1pl = _lib.get("__log1pl", "cdecl")
    __log1pl.argtypes = [c_longdouble]
    __log1pl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 135
if _libs["libPyFd.so"].has("logbl", "cdecl"):
    logbl = _libs["libPyFd.so"].get("logbl", "cdecl")
    logbl.argtypes = [c_longdouble]
    logbl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 135
for _lib in _libs.values():
    if not _lib.has("__logbl", "cdecl"):
        continue
    __logbl = _lib.get("__logbl", "cdecl")
    __logbl.argtypes = [c_longdouble]
    __logbl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 142
if _libs["libPyFd.so"].has("exp2l", "cdecl"):
    exp2l = _libs["libPyFd.so"].get("exp2l", "cdecl")
    exp2l.argtypes = [c_longdouble]
    exp2l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 142
for _lib in _libs.values():
    if not _lib.has("__exp2l", "cdecl"):
        continue
    __exp2l = _lib.get("__exp2l", "cdecl")
    __exp2l.argtypes = [c_longdouble]
    __exp2l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 145
if _libs["libPyFd.so"].has("log2l", "cdecl"):
    log2l = _libs["libPyFd.so"].get("log2l", "cdecl")
    log2l.argtypes = [c_longdouble]
    log2l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 145
for _lib in _libs.values():
    if not _lib.has("__log2l", "cdecl"):
        continue
    __log2l = _lib.get("__log2l", "cdecl")
    __log2l.argtypes = [c_longdouble]
    __log2l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 154
if _libs["libPyFd.so"].has("powl", "cdecl"):
    powl = _libs["libPyFd.so"].get("powl", "cdecl")
    powl.argtypes = [c_longdouble, c_longdouble]
    powl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 154
for _lib in _libs.values():
    if not _lib.has("__powl", "cdecl"):
        continue
    __powl = _lib.get("__powl", "cdecl")
    __powl.argtypes = [c_longdouble, c_longdouble]
    __powl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 157
if _libs["libPyFd.so"].has("sqrtl", "cdecl"):
    sqrtl = _libs["libPyFd.so"].get("sqrtl", "cdecl")
    sqrtl.argtypes = [c_longdouble]
    sqrtl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 157
for _lib in _libs.values():
    if not _lib.has("__sqrtl", "cdecl"):
        continue
    __sqrtl = _lib.get("__sqrtl", "cdecl")
    __sqrtl.argtypes = [c_longdouble]
    __sqrtl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 163
if _libs["libPyFd.so"].has("hypotl", "cdecl"):
    hypotl = _libs["libPyFd.so"].get("hypotl", "cdecl")
    hypotl.argtypes = [c_longdouble, c_longdouble]
    hypotl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 163
for _lib in _libs.values():
    if not _lib.has("__hypotl", "cdecl"):
        continue
    __hypotl = _lib.get("__hypotl", "cdecl")
    __hypotl.argtypes = [c_longdouble, c_longdouble]
    __hypotl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 170
if _libs["libPyFd.so"].has("cbrtl", "cdecl"):
    cbrtl = _libs["libPyFd.so"].get("cbrtl", "cdecl")
    cbrtl.argtypes = [c_longdouble]
    cbrtl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 170
for _lib in _libs.values():
    if not _lib.has("__cbrtl", "cdecl"):
        continue
    __cbrtl = _lib.get("__cbrtl", "cdecl")
    __cbrtl.argtypes = [c_longdouble]
    __cbrtl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 179
if _libs["libPyFd.so"].has("ceill", "cdecl"):
    ceill = _libs["libPyFd.so"].get("ceill", "cdecl")
    ceill.argtypes = [c_longdouble]
    ceill.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 179
for _lib in _libs.values():
    if not _lib.has("__ceill", "cdecl"):
        continue
    __ceill = _lib.get("__ceill", "cdecl")
    __ceill.argtypes = [c_longdouble]
    __ceill.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 182
if _libs["libPyFd.so"].has("fabsl", "cdecl"):
    fabsl = _libs["libPyFd.so"].get("fabsl", "cdecl")
    fabsl.argtypes = [c_longdouble]
    fabsl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 182
for _lib in _libs.values():
    if not _lib.has("__fabsl", "cdecl"):
        continue
    __fabsl = _lib.get("__fabsl", "cdecl")
    __fabsl.argtypes = [c_longdouble]
    __fabsl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 185
if _libs["libPyFd.so"].has("floorl", "cdecl"):
    floorl = _libs["libPyFd.so"].get("floorl", "cdecl")
    floorl.argtypes = [c_longdouble]
    floorl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 185
for _lib in _libs.values():
    if not _lib.has("__floorl", "cdecl"):
        continue
    __floorl = _lib.get("__floorl", "cdecl")
    __floorl.argtypes = [c_longdouble]
    __floorl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 188
if _libs["libPyFd.so"].has("fmodl", "cdecl"):
    fmodl = _libs["libPyFd.so"].get("fmodl", "cdecl")
    fmodl.argtypes = [c_longdouble, c_longdouble]
    fmodl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 188
for _lib in _libs.values():
    if not _lib.has("__fmodl", "cdecl"):
        continue
    __fmodl = _lib.get("__fmodl", "cdecl")
    __fmodl.argtypes = [c_longdouble, c_longdouble]
    __fmodl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 193
if _libs["libPyFd.so"].has("__isinfl", "cdecl"):
    __isinfl = _libs["libPyFd.so"].get("__isinfl", "cdecl")
    __isinfl.argtypes = [c_longdouble]
    __isinfl.restype = c_int

# /usr/include/bits/mathcalls.h: 196
if _libs["libPyFd.so"].has("__finitel", "cdecl"):
    __finitel = _libs["libPyFd.so"].get("__finitel", "cdecl")
    __finitel.argtypes = [c_longdouble]
    __finitel.restype = c_int

# /usr/include/bits/mathcalls.h: 202
if _libs["libPyFd.so"].has("isinfl", "cdecl"):
    isinfl = _libs["libPyFd.so"].get("isinfl", "cdecl")
    isinfl.argtypes = [c_longdouble]
    isinfl.restype = c_int

# /usr/include/bits/mathcalls.h: 205
if _libs["libPyFd.so"].has("finitel", "cdecl"):
    finitel = _libs["libPyFd.so"].get("finitel", "cdecl")
    finitel.argtypes = [c_longdouble]
    finitel.restype = c_int

# /usr/include/bits/mathcalls.h: 208
if _libs["libPyFd.so"].has("dreml", "cdecl"):
    dreml = _libs["libPyFd.so"].get("dreml", "cdecl")
    dreml.argtypes = [c_longdouble, c_longdouble]
    dreml.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 208
for _lib in _libs.values():
    if not _lib.has("__dreml", "cdecl"):
        continue
    __dreml = _lib.get("__dreml", "cdecl")
    __dreml.argtypes = [c_longdouble, c_longdouble]
    __dreml.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 212
if _libs["libPyFd.so"].has("significandl", "cdecl"):
    significandl = _libs["libPyFd.so"].get("significandl", "cdecl")
    significandl.argtypes = [c_longdouble]
    significandl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 212
for _lib in _libs.values():
    if not _lib.has("__significandl", "cdecl"):
        continue
    __significandl = _lib.get("__significandl", "cdecl")
    __significandl.argtypes = [c_longdouble]
    __significandl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 218
if _libs["libPyFd.so"].has("copysignl", "cdecl"):
    copysignl = _libs["libPyFd.so"].get("copysignl", "cdecl")
    copysignl.argtypes = [c_longdouble, c_longdouble]
    copysignl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 218
for _lib in _libs.values():
    if not _lib.has("__copysignl", "cdecl"):
        continue
    __copysignl = _lib.get("__copysignl", "cdecl")
    __copysignl.argtypes = [c_longdouble, c_longdouble]
    __copysignl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 225
if _libs["libPyFd.so"].has("nanl", "cdecl"):
    nanl = _libs["libPyFd.so"].get("nanl", "cdecl")
    nanl.argtypes = [String]
    nanl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 225
for _lib in _libs.values():
    if not _lib.has("__nanl", "cdecl"):
        continue
    __nanl = _lib.get("__nanl", "cdecl")
    __nanl.argtypes = [String]
    __nanl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 231
if _libs["libPyFd.so"].has("__isnanl", "cdecl"):
    __isnanl = _libs["libPyFd.so"].get("__isnanl", "cdecl")
    __isnanl.argtypes = [c_longdouble]
    __isnanl.restype = c_int

# /usr/include/bits/mathcalls.h: 235
if _libs["libPyFd.so"].has("isnanl", "cdecl"):
    isnanl = _libs["libPyFd.so"].get("isnanl", "cdecl")
    isnanl.argtypes = [c_longdouble]
    isnanl.restype = c_int

# /usr/include/bits/mathcalls.h: 238
if _libs["libPyFd.so"].has("j0l", "cdecl"):
    j0l = _libs["libPyFd.so"].get("j0l", "cdecl")
    j0l.argtypes = [c_longdouble]
    j0l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 238
for _lib in _libs.values():
    if not _lib.has("__j0l", "cdecl"):
        continue
    __j0l = _lib.get("__j0l", "cdecl")
    __j0l.argtypes = [c_longdouble]
    __j0l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 239
if _libs["libPyFd.so"].has("j1l", "cdecl"):
    j1l = _libs["libPyFd.so"].get("j1l", "cdecl")
    j1l.argtypes = [c_longdouble]
    j1l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 239
for _lib in _libs.values():
    if not _lib.has("__j1l", "cdecl"):
        continue
    __j1l = _lib.get("__j1l", "cdecl")
    __j1l.argtypes = [c_longdouble]
    __j1l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 240
if _libs["libPyFd.so"].has("jnl", "cdecl"):
    jnl = _libs["libPyFd.so"].get("jnl", "cdecl")
    jnl.argtypes = [c_int, c_longdouble]
    jnl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 240
for _lib in _libs.values():
    if not _lib.has("__jnl", "cdecl"):
        continue
    __jnl = _lib.get("__jnl", "cdecl")
    __jnl.argtypes = [c_int, c_longdouble]
    __jnl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 241
if _libs["libPyFd.so"].has("y0l", "cdecl"):
    y0l = _libs["libPyFd.so"].get("y0l", "cdecl")
    y0l.argtypes = [c_longdouble]
    y0l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 241
for _lib in _libs.values():
    if not _lib.has("__y0l", "cdecl"):
        continue
    __y0l = _lib.get("__y0l", "cdecl")
    __y0l.argtypes = [c_longdouble]
    __y0l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 242
if _libs["libPyFd.so"].has("y1l", "cdecl"):
    y1l = _libs["libPyFd.so"].get("y1l", "cdecl")
    y1l.argtypes = [c_longdouble]
    y1l.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 242
for _lib in _libs.values():
    if not _lib.has("__y1l", "cdecl"):
        continue
    __y1l = _lib.get("__y1l", "cdecl")
    __y1l.argtypes = [c_longdouble]
    __y1l.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 243
if _libs["libPyFd.so"].has("ynl", "cdecl"):
    ynl = _libs["libPyFd.so"].get("ynl", "cdecl")
    ynl.argtypes = [c_int, c_longdouble]
    ynl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 243
for _lib in _libs.values():
    if not _lib.has("__ynl", "cdecl"):
        continue
    __ynl = _lib.get("__ynl", "cdecl")
    __ynl.argtypes = [c_int, c_longdouble]
    __ynl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 250
if _libs["libPyFd.so"].has("erfl", "cdecl"):
    erfl = _libs["libPyFd.so"].get("erfl", "cdecl")
    erfl.argtypes = [c_longdouble]
    erfl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 250
for _lib in _libs.values():
    if not _lib.has("__erfl", "cdecl"):
        continue
    __erfl = _lib.get("__erfl", "cdecl")
    __erfl.argtypes = [c_longdouble]
    __erfl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 251
if _libs["libPyFd.so"].has("erfcl", "cdecl"):
    erfcl = _libs["libPyFd.so"].get("erfcl", "cdecl")
    erfcl.argtypes = [c_longdouble]
    erfcl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 251
for _lib in _libs.values():
    if not _lib.has("__erfcl", "cdecl"):
        continue
    __erfcl = _lib.get("__erfcl", "cdecl")
    __erfcl.argtypes = [c_longdouble]
    __erfcl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 252
if _libs["libPyFd.so"].has("lgammal", "cdecl"):
    lgammal = _libs["libPyFd.so"].get("lgammal", "cdecl")
    lgammal.argtypes = [c_longdouble]
    lgammal.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 252
for _lib in _libs.values():
    if not _lib.has("__lgammal", "cdecl"):
        continue
    __lgammal = _lib.get("__lgammal", "cdecl")
    __lgammal.argtypes = [c_longdouble]
    __lgammal.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 259
if _libs["libPyFd.so"].has("tgammal", "cdecl"):
    tgammal = _libs["libPyFd.so"].get("tgammal", "cdecl")
    tgammal.argtypes = [c_longdouble]
    tgammal.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 259
for _lib in _libs.values():
    if not _lib.has("__tgammal", "cdecl"):
        continue
    __tgammal = _lib.get("__tgammal", "cdecl")
    __tgammal.argtypes = [c_longdouble]
    __tgammal.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 265
if _libs["libPyFd.so"].has("gammal", "cdecl"):
    gammal = _libs["libPyFd.so"].get("gammal", "cdecl")
    gammal.argtypes = [c_longdouble]
    gammal.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 265
for _lib in _libs.values():
    if not _lib.has("__gammal", "cdecl"):
        continue
    __gammal = _lib.get("__gammal", "cdecl")
    __gammal.argtypes = [c_longdouble]
    __gammal.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 272
if _libs["libPyFd.so"].has("lgammal_r", "cdecl"):
    lgammal_r = _libs["libPyFd.so"].get("lgammal_r", "cdecl")
    lgammal_r.argtypes = [c_longdouble, POINTER(c_int)]
    lgammal_r.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 272
for _lib in _libs.values():
    if not _lib.has("__lgammal_r", "cdecl"):
        continue
    __lgammal_r = _lib.get("__lgammal_r", "cdecl")
    __lgammal_r.argtypes = [c_longdouble, POINTER(c_int)]
    __lgammal_r.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 280
if _libs["libPyFd.so"].has("rintl", "cdecl"):
    rintl = _libs["libPyFd.so"].get("rintl", "cdecl")
    rintl.argtypes = [c_longdouble]
    rintl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 280
for _lib in _libs.values():
    if not _lib.has("__rintl", "cdecl"):
        continue
    __rintl = _lib.get("__rintl", "cdecl")
    __rintl.argtypes = [c_longdouble]
    __rintl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 283
if _libs["libPyFd.so"].has("nextafterl", "cdecl"):
    nextafterl = _libs["libPyFd.so"].get("nextafterl", "cdecl")
    nextafterl.argtypes = [c_longdouble, c_longdouble]
    nextafterl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 283
for _lib in _libs.values():
    if not _lib.has("__nextafterl", "cdecl"):
        continue
    __nextafterl = _lib.get("__nextafterl", "cdecl")
    __nextafterl.argtypes = [c_longdouble, c_longdouble]
    __nextafterl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 285
if _libs["libPyFd.so"].has("nexttowardl", "cdecl"):
    nexttowardl = _libs["libPyFd.so"].get("nexttowardl", "cdecl")
    nexttowardl.argtypes = [c_longdouble, c_longdouble]
    nexttowardl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 285
for _lib in _libs.values():
    if not _lib.has("__nexttowardl", "cdecl"):
        continue
    __nexttowardl = _lib.get("__nexttowardl", "cdecl")
    __nexttowardl.argtypes = [c_longdouble, c_longdouble]
    __nexttowardl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 289
if _libs["libPyFd.so"].has("remainderl", "cdecl"):
    remainderl = _libs["libPyFd.so"].get("remainderl", "cdecl")
    remainderl.argtypes = [c_longdouble, c_longdouble]
    remainderl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 289
for _lib in _libs.values():
    if not _lib.has("__remainderl", "cdecl"):
        continue
    __remainderl = _lib.get("__remainderl", "cdecl")
    __remainderl.argtypes = [c_longdouble, c_longdouble]
    __remainderl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 293
if _libs["libPyFd.so"].has("scalbnl", "cdecl"):
    scalbnl = _libs["libPyFd.so"].get("scalbnl", "cdecl")
    scalbnl.argtypes = [c_longdouble, c_int]
    scalbnl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 293
for _lib in _libs.values():
    if not _lib.has("__scalbnl", "cdecl"):
        continue
    __scalbnl = _lib.get("__scalbnl", "cdecl")
    __scalbnl.argtypes = [c_longdouble, c_int]
    __scalbnl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 297
if _libs["libPyFd.so"].has("ilogbl", "cdecl"):
    ilogbl = _libs["libPyFd.so"].get("ilogbl", "cdecl")
    ilogbl.argtypes = [c_longdouble]
    ilogbl.restype = c_int

# /usr/include/bits/mathcalls.h: 297
for _lib in _libs.values():
    if not _lib.has("__ilogbl", "cdecl"):
        continue
    __ilogbl = _lib.get("__ilogbl", "cdecl")
    __ilogbl.argtypes = [c_longdouble]
    __ilogbl.restype = c_int
    break

# /usr/include/bits/mathcalls.h: 302
if _libs["libPyFd.so"].has("scalblnl", "cdecl"):
    scalblnl = _libs["libPyFd.so"].get("scalblnl", "cdecl")
    scalblnl.argtypes = [c_longdouble, c_long]
    scalblnl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 302
for _lib in _libs.values():
    if not _lib.has("__scalblnl", "cdecl"):
        continue
    __scalblnl = _lib.get("__scalblnl", "cdecl")
    __scalblnl.argtypes = [c_longdouble, c_long]
    __scalblnl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 306
if _libs["libPyFd.so"].has("nearbyintl", "cdecl"):
    nearbyintl = _libs["libPyFd.so"].get("nearbyintl", "cdecl")
    nearbyintl.argtypes = [c_longdouble]
    nearbyintl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 306
for _lib in _libs.values():
    if not _lib.has("__nearbyintl", "cdecl"):
        continue
    __nearbyintl = _lib.get("__nearbyintl", "cdecl")
    __nearbyintl.argtypes = [c_longdouble]
    __nearbyintl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 310
if _libs["libPyFd.so"].has("roundl", "cdecl"):
    roundl = _libs["libPyFd.so"].get("roundl", "cdecl")
    roundl.argtypes = [c_longdouble]
    roundl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 310
for _lib in _libs.values():
    if not _lib.has("__roundl", "cdecl"):
        continue
    __roundl = _lib.get("__roundl", "cdecl")
    __roundl.argtypes = [c_longdouble]
    __roundl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 314
if _libs["libPyFd.so"].has("truncl", "cdecl"):
    truncl = _libs["libPyFd.so"].get("truncl", "cdecl")
    truncl.argtypes = [c_longdouble]
    truncl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 314
for _lib in _libs.values():
    if not _lib.has("__truncl", "cdecl"):
        continue
    __truncl = _lib.get("__truncl", "cdecl")
    __truncl.argtypes = [c_longdouble]
    __truncl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 319
if _libs["libPyFd.so"].has("remquol", "cdecl"):
    remquol = _libs["libPyFd.so"].get("remquol", "cdecl")
    remquol.argtypes = [c_longdouble, c_longdouble, POINTER(c_int)]
    remquol.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 319
for _lib in _libs.values():
    if not _lib.has("__remquol", "cdecl"):
        continue
    __remquol = _lib.get("__remquol", "cdecl")
    __remquol.argtypes = [c_longdouble, c_longdouble, POINTER(c_int)]
    __remquol.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 326
if _libs["libPyFd.so"].has("lrintl", "cdecl"):
    lrintl = _libs["libPyFd.so"].get("lrintl", "cdecl")
    lrintl.argtypes = [c_longdouble]
    lrintl.restype = c_long

# /usr/include/bits/mathcalls.h: 326
for _lib in _libs.values():
    if not _lib.has("__lrintl", "cdecl"):
        continue
    __lrintl = _lib.get("__lrintl", "cdecl")
    __lrintl.argtypes = [c_longdouble]
    __lrintl.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 327
if _libs["libPyFd.so"].has("llrintl", "cdecl"):
    llrintl = _libs["libPyFd.so"].get("llrintl", "cdecl")
    llrintl.argtypes = [c_longdouble]
    llrintl.restype = c_longlong

# /usr/include/bits/mathcalls.h: 327
for _lib in _libs.values():
    if not _lib.has("__llrintl", "cdecl"):
        continue
    __llrintl = _lib.get("__llrintl", "cdecl")
    __llrintl.argtypes = [c_longdouble]
    __llrintl.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 331
if _libs["libPyFd.so"].has("lroundl", "cdecl"):
    lroundl = _libs["libPyFd.so"].get("lroundl", "cdecl")
    lroundl.argtypes = [c_longdouble]
    lroundl.restype = c_long

# /usr/include/bits/mathcalls.h: 331
for _lib in _libs.values():
    if not _lib.has("__lroundl", "cdecl"):
        continue
    __lroundl = _lib.get("__lroundl", "cdecl")
    __lroundl.argtypes = [c_longdouble]
    __lroundl.restype = c_long
    break

# /usr/include/bits/mathcalls.h: 332
if _libs["libPyFd.so"].has("llroundl", "cdecl"):
    llroundl = _libs["libPyFd.so"].get("llroundl", "cdecl")
    llroundl.argtypes = [c_longdouble]
    llroundl.restype = c_longlong

# /usr/include/bits/mathcalls.h: 332
for _lib in _libs.values():
    if not _lib.has("__llroundl", "cdecl"):
        continue
    __llroundl = _lib.get("__llroundl", "cdecl")
    __llroundl.argtypes = [c_longdouble]
    __llroundl.restype = c_longlong
    break

# /usr/include/bits/mathcalls.h: 336
if _libs["libPyFd.so"].has("fdiml", "cdecl"):
    fdiml = _libs["libPyFd.so"].get("fdiml", "cdecl")
    fdiml.argtypes = [c_longdouble, c_longdouble]
    fdiml.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 336
for _lib in _libs.values():
    if not _lib.has("__fdiml", "cdecl"):
        continue
    __fdiml = _lib.get("__fdiml", "cdecl")
    __fdiml.argtypes = [c_longdouble, c_longdouble]
    __fdiml.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 339
if _libs["libPyFd.so"].has("fmaxl", "cdecl"):
    fmaxl = _libs["libPyFd.so"].get("fmaxl", "cdecl")
    fmaxl.argtypes = [c_longdouble, c_longdouble]
    fmaxl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 339
for _lib in _libs.values():
    if not _lib.has("__fmaxl", "cdecl"):
        continue
    __fmaxl = _lib.get("__fmaxl", "cdecl")
    __fmaxl.argtypes = [c_longdouble, c_longdouble]
    __fmaxl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 342
if _libs["libPyFd.so"].has("fminl", "cdecl"):
    fminl = _libs["libPyFd.so"].get("fminl", "cdecl")
    fminl.argtypes = [c_longdouble, c_longdouble]
    fminl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 342
for _lib in _libs.values():
    if not _lib.has("__fminl", "cdecl"):
        continue
    __fminl = _lib.get("__fminl", "cdecl")
    __fminl.argtypes = [c_longdouble, c_longdouble]
    __fminl.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 346
if _libs["libPyFd.so"].has("__fpclassifyl", "cdecl"):
    __fpclassifyl = _libs["libPyFd.so"].get("__fpclassifyl", "cdecl")
    __fpclassifyl.argtypes = [c_longdouble]
    __fpclassifyl.restype = c_int

# /usr/include/bits/mathcalls.h: 350
if _libs["libPyFd.so"].has("__signbitl", "cdecl"):
    __signbitl = _libs["libPyFd.so"].get("__signbitl", "cdecl")
    __signbitl.argtypes = [c_longdouble]
    __signbitl.restype = c_int

# /usr/include/bits/mathcalls.h: 355
if _libs["libPyFd.so"].has("fmal", "cdecl"):
    fmal = _libs["libPyFd.so"].get("fmal", "cdecl")
    fmal.argtypes = [c_longdouble, c_longdouble, c_longdouble]
    fmal.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 355
for _lib in _libs.values():
    if not _lib.has("__fmal", "cdecl"):
        continue
    __fmal = _lib.get("__fmal", "cdecl")
    __fmal.argtypes = [c_longdouble, c_longdouble, c_longdouble]
    __fmal.restype = c_longdouble
    break

# /usr/include/bits/mathcalls.h: 364
if _libs["libPyFd.so"].has("scalbl", "cdecl"):
    scalbl = _libs["libPyFd.so"].get("scalbl", "cdecl")
    scalbl.argtypes = [c_longdouble, c_longdouble]
    scalbl.restype = c_longdouble

# /usr/include/bits/mathcalls.h: 364
for _lib in _libs.values():
    if not _lib.has("__scalbl", "cdecl"):
        continue
    __scalbl = _lib.get("__scalbl", "cdecl")
    __scalbl.argtypes = [c_longdouble, c_longdouble]
    __scalbl.restype = c_longdouble
    break

# /usr/include/math.h: 149
try:
    signgam = (c_int).in_dll(_libs["libPyFd.so"], "signgam")
except:
    pass

enum_anon_62 = c_int# /usr/include/math.h: 190

FP_NAN = 0# /usr/include/math.h: 190

FP_INFINITE = 1# /usr/include/math.h: 190

FP_ZERO = 2# /usr/include/math.h: 190

FP_SUBNORMAL = 3# /usr/include/math.h: 190

FP_NORMAL = 4# /usr/include/math.h: 190

enum_anon_63 = c_int# /usr/include/math.h: 295

_IEEE_ = (-1)# /usr/include/math.h: 295

_SVID_ = (_IEEE_ + 1)# /usr/include/math.h: 295

_XOPEN_ = (_SVID_ + 1)# /usr/include/math.h: 295

_POSIX_ = (_XOPEN_ + 1)# /usr/include/math.h: 295

_ISOC_ = (_POSIX_ + 1)# /usr/include/math.h: 295

_LIB_VERSION_TYPE = enum_anon_63# /usr/include/math.h: 295

# /usr/include/math.h: 300
try:
    _LIB_VERSION = (_LIB_VERSION_TYPE).in_dll(_libs["libPyFd.so"], "_LIB_VERSION")
except:
    pass

# /usr/include/math.h: 313
class struct_exception(Structure):
    pass

struct_exception.__slots__ = [
    'type',
    'name',
    'arg1',
    'arg2',
    'retval',
]
struct_exception._fields_ = [
    ('type', c_int),
    ('name', String),
    ('arg1', c_double),
    ('arg2', c_double),
    ('retval', c_double),
]

# /usr/include/math.h: 326
if _libs["libPyFd.so"].has("matherr", "cdecl"):
    matherr = _libs["libPyFd.so"].get("matherr", "cdecl")
    matherr.argtypes = [POINTER(struct_exception)]
    matherr.restype = c_int

# /usr/include/bits/sigset.h: 103
if _libs["libPyFd.so"].has("__sigismember", "cdecl"):
    __sigismember = _libs["libPyFd.so"].get("__sigismember", "cdecl")
    __sigismember.argtypes = [POINTER(__sigset_t), c_int]
    __sigismember.restype = c_int

# /usr/include/bits/sigset.h: 104
if _libs["libPyFd.so"].has("__sigaddset", "cdecl"):
    __sigaddset = _libs["libPyFd.so"].get("__sigaddset", "cdecl")
    __sigaddset.argtypes = [POINTER(__sigset_t), c_int]
    __sigaddset.restype = c_int

# /usr/include/bits/sigset.h: 105
if _libs["libPyFd.so"].has("__sigdelset", "cdecl"):
    __sigdelset = _libs["libPyFd.so"].get("__sigdelset", "cdecl")
    __sigdelset.argtypes = [POINTER(__sigset_t), c_int]
    __sigdelset.restype = c_int

sig_atomic_t = __sig_atomic_t# /usr/include/signal.h: 40

# /usr/include/bits/siginfo.h: 36
class union_sigval(Union):
    pass

union_sigval.__slots__ = [
    'sival_int',
    'sival_ptr',
]
union_sigval._fields_ = [
    ('sival_int', c_int),
    ('sival_ptr', POINTER(None)),
]

sigval_t = union_sigval# /usr/include/bits/siginfo.h: 36

__sigchld_clock_t = __clock_t# /usr/include/bits/siginfo.h: 58

# /usr/include/bits/siginfo.h: 74
class struct_anon_64(Structure):
    pass

struct_anon_64.__slots__ = [
    'si_pid',
    'si_uid',
]
struct_anon_64._fields_ = [
    ('si_pid', __pid_t),
    ('si_uid', __uid_t),
]

# /usr/include/bits/siginfo.h: 81
class struct_anon_65(Structure):
    pass

struct_anon_65.__slots__ = [
    'si_tid',
    'si_overrun',
    'si_sigval',
]
struct_anon_65._fields_ = [
    ('si_tid', c_int),
    ('si_overrun', c_int),
    ('si_sigval', sigval_t),
]

# /usr/include/bits/siginfo.h: 89
class struct_anon_66(Structure):
    pass

struct_anon_66.__slots__ = [
    'si_pid',
    'si_uid',
    'si_sigval',
]
struct_anon_66._fields_ = [
    ('si_pid', __pid_t),
    ('si_uid', __uid_t),
    ('si_sigval', sigval_t),
]

# /usr/include/bits/siginfo.h: 97
class struct_anon_67(Structure):
    pass

struct_anon_67.__slots__ = [
    'si_pid',
    'si_uid',
    'si_status',
    'si_utime',
    'si_stime',
]
struct_anon_67._fields_ = [
    ('si_pid', __pid_t),
    ('si_uid', __uid_t),
    ('si_status', c_int),
    ('si_utime', __sigchld_clock_t),
    ('si_stime', __sigchld_clock_t),
]

# /usr/include/bits/siginfo.h: 107
class struct_anon_68(Structure):
    pass

struct_anon_68.__slots__ = [
    'si_addr',
]
struct_anon_68._fields_ = [
    ('si_addr', POINTER(None)),
]

# /usr/include/bits/siginfo.h: 113
class struct_anon_69(Structure):
    pass

struct_anon_69.__slots__ = [
    'si_band',
    'si_fd',
]
struct_anon_69._fields_ = [
    ('si_band', c_long),
    ('si_fd', c_int),
]

# /usr/include/bits/siginfo.h: 120
class struct_anon_70(Structure):
    pass

struct_anon_70.__slots__ = [
    '_call_addr',
    '_syscall',
    '_arch',
]
struct_anon_70._fields_ = [
    ('_call_addr', POINTER(None)),
    ('_syscall', c_int),
    ('_arch', c_uint),
]

# /usr/include/bits/siginfo.h: 69
class union_anon_71(Union):
    pass

union_anon_71.__slots__ = [
    '_pad',
    '_kill',
    '_timer',
    '_rt',
    '_sigchld',
    '_sigfault',
    '_sigpoll',
    '_sigsys',
]
union_anon_71._fields_ = [
    ('_pad', c_int * int(((128 / sizeof(c_int)) - 4))),
    ('_kill', struct_anon_64),
    ('_timer', struct_anon_65),
    ('_rt', struct_anon_66),
    ('_sigchld', struct_anon_67),
    ('_sigfault', struct_anon_68),
    ('_sigpoll', struct_anon_69),
    ('_sigsys', struct_anon_70),
]

# /usr/include/bits/siginfo.h: 127
class struct_anon_72(Structure):
    pass

struct_anon_72.__slots__ = [
    'si_signo',
    'si_errno',
    'si_code',
    '_sifields',
]
struct_anon_72._fields_ = [
    ('si_signo', c_int),
    ('si_errno', c_int),
    ('si_code', c_int),
    ('_sifields', union_anon_71),
]

siginfo_t = struct_anon_72# /usr/include/bits/siginfo.h: 127

enum_anon_73 = c_int# /usr/include/bits/siginfo.h: 151

SI_ASYNCNL = (-60)# /usr/include/bits/siginfo.h: 151

SI_TKILL = (-6)# /usr/include/bits/siginfo.h: 151

SI_SIGIO = (SI_TKILL + 1)# /usr/include/bits/siginfo.h: 151

SI_ASYNCIO = (SI_SIGIO + 1)# /usr/include/bits/siginfo.h: 151

SI_MESGQ = (SI_ASYNCIO + 1)# /usr/include/bits/siginfo.h: 151

SI_TIMER = (SI_MESGQ + 1)# /usr/include/bits/siginfo.h: 151

SI_QUEUE = (SI_TIMER + 1)# /usr/include/bits/siginfo.h: 151

SI_USER = (SI_QUEUE + 1)# /usr/include/bits/siginfo.h: 151

SI_KERNEL = 128# /usr/include/bits/siginfo.h: 151

enum_anon_74 = c_int# /usr/include/bits/siginfo.h: 175

ILL_ILLOPC = 1# /usr/include/bits/siginfo.h: 175

ILL_ILLOPN = (ILL_ILLOPC + 1)# /usr/include/bits/siginfo.h: 175

ILL_ILLADR = (ILL_ILLOPN + 1)# /usr/include/bits/siginfo.h: 175

ILL_ILLTRP = (ILL_ILLADR + 1)# /usr/include/bits/siginfo.h: 175

ILL_PRVOPC = (ILL_ILLTRP + 1)# /usr/include/bits/siginfo.h: 175

ILL_PRVREG = (ILL_PRVOPC + 1)# /usr/include/bits/siginfo.h: 175

ILL_COPROC = (ILL_PRVREG + 1)# /usr/include/bits/siginfo.h: 175

ILL_BADSTK = (ILL_COPROC + 1)# /usr/include/bits/siginfo.h: 175

enum_anon_75 = c_int# /usr/include/bits/siginfo.h: 196

FPE_INTDIV = 1# /usr/include/bits/siginfo.h: 196

FPE_INTOVF = (FPE_INTDIV + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTDIV = (FPE_INTOVF + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTOVF = (FPE_FLTDIV + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTUND = (FPE_FLTOVF + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTRES = (FPE_FLTUND + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTINV = (FPE_FLTRES + 1)# /usr/include/bits/siginfo.h: 196

FPE_FLTSUB = (FPE_FLTINV + 1)# /usr/include/bits/siginfo.h: 196

enum_anon_76 = c_int# /usr/include/bits/siginfo.h: 217

SEGV_MAPERR = 1# /usr/include/bits/siginfo.h: 217

SEGV_ACCERR = (SEGV_MAPERR + 1)# /usr/include/bits/siginfo.h: 217

enum_anon_77 = c_int# /usr/include/bits/siginfo.h: 226

BUS_ADRALN = 1# /usr/include/bits/siginfo.h: 226

BUS_ADRERR = (BUS_ADRALN + 1)# /usr/include/bits/siginfo.h: 226

BUS_OBJERR = (BUS_ADRERR + 1)# /usr/include/bits/siginfo.h: 226

enum_anon_78 = c_int# /usr/include/bits/siginfo.h: 237

TRAP_BRKPT = 1# /usr/include/bits/siginfo.h: 237

TRAP_TRACE = (TRAP_BRKPT + 1)# /usr/include/bits/siginfo.h: 237

enum_anon_79 = c_int# /usr/include/bits/siginfo.h: 246

CLD_EXITED = 1# /usr/include/bits/siginfo.h: 246

CLD_KILLED = (CLD_EXITED + 1)# /usr/include/bits/siginfo.h: 246

CLD_DUMPED = (CLD_KILLED + 1)# /usr/include/bits/siginfo.h: 246

CLD_TRAPPED = (CLD_DUMPED + 1)# /usr/include/bits/siginfo.h: 246

CLD_STOPPED = (CLD_TRAPPED + 1)# /usr/include/bits/siginfo.h: 246

CLD_CONTINUED = (CLD_STOPPED + 1)# /usr/include/bits/siginfo.h: 246

enum_anon_80 = c_int# /usr/include/bits/siginfo.h: 263

POLL_IN = 1# /usr/include/bits/siginfo.h: 263

POLL_OUT = (POLL_IN + 1)# /usr/include/bits/siginfo.h: 263

POLL_MSG = (POLL_OUT + 1)# /usr/include/bits/siginfo.h: 263

POLL_ERR = (POLL_MSG + 1)# /usr/include/bits/siginfo.h: 263

POLL_PRI = (POLL_ERR + 1)# /usr/include/bits/siginfo.h: 263

POLL_HUP = (POLL_PRI + 1)# /usr/include/bits/siginfo.h: 263

# /usr/include/bits/siginfo.h: 315
class struct_anon_81(Structure):
    pass

struct_anon_81.__slots__ = [
    '_function',
    '_attribute',
]
struct_anon_81._fields_ = [
    ('_function', CFUNCTYPE(UNCHECKED(None), sigval_t)),
    ('_attribute', POINTER(pthread_attr_t)),
]

# /usr/include/bits/siginfo.h: 307
class union_anon_82(Union):
    pass

union_anon_82.__slots__ = [
    '_pad',
    '_tid',
    '_sigev_thread',
]
union_anon_82._fields_ = [
    ('_pad', c_int * int(((64 / sizeof(c_int)) - 4))),
    ('_tid', __pid_t),
    ('_sigev_thread', struct_anon_81),
]

struct_sigevent.__slots__ = [
    'sigev_value',
    'sigev_signo',
    'sigev_notify',
    '_sigev_un',
]
struct_sigevent._fields_ = [
    ('sigev_value', sigval_t),
    ('sigev_signo', c_int),
    ('sigev_notify', c_int),
    ('_sigev_un', union_anon_82),
]

sigevent_t = struct_sigevent# /usr/include/bits/siginfo.h: 321

enum_anon_83 = c_int# /usr/include/bits/siginfo.h: 328

SIGEV_SIGNAL = 0# /usr/include/bits/siginfo.h: 328

SIGEV_NONE = (SIGEV_SIGNAL + 1)# /usr/include/bits/siginfo.h: 328

SIGEV_THREAD = (SIGEV_NONE + 1)# /usr/include/bits/siginfo.h: 328

SIGEV_THREAD_ID = 4# /usr/include/bits/siginfo.h: 328

__sighandler_t = CFUNCTYPE(UNCHECKED(None), c_int)# /usr/include/signal.h: 85

# /usr/include/signal.h: 90
if _libs["libPyFd.so"].has("__sysv_signal", "cdecl"):
    __sysv_signal = _libs["libPyFd.so"].get("__sysv_signal", "cdecl")
    __sysv_signal.argtypes = [c_int, __sighandler_t]
    __sysv_signal.restype = __sighandler_t

# /usr/include/signal.h: 102
if _libs["libPyFd.so"].has("signal", "cdecl"):
    signal = _libs["libPyFd.so"].get("signal", "cdecl")
    signal.argtypes = [c_int, __sighandler_t]
    signal.restype = __sighandler_t

# /usr/include/signal.h: 127
if _libs["libPyFd.so"].has("kill", "cdecl"):
    kill = _libs["libPyFd.so"].get("kill", "cdecl")
    kill.argtypes = [__pid_t, c_int]
    kill.restype = c_int

# /usr/include/signal.h: 134
if _libs["libPyFd.so"].has("killpg", "cdecl"):
    killpg = _libs["libPyFd.so"].get("killpg", "cdecl")
    killpg.argtypes = [__pid_t, c_int]
    killpg.restype = c_int

# /usr/include/signal.h: 139
if _libs["libPyFd.so"].has("raise", "cdecl"):
    _raise = _libs["libPyFd.so"].get("raise", "cdecl")
    _raise.argtypes = [c_int]
    _raise.restype = c_int

# /usr/include/signal.h: 144
if _libs["libPyFd.so"].has("ssignal", "cdecl"):
    ssignal = _libs["libPyFd.so"].get("ssignal", "cdecl")
    ssignal.argtypes = [c_int, __sighandler_t]
    ssignal.restype = __sighandler_t

# /usr/include/signal.h: 146
if _libs["libPyFd.so"].has("gsignal", "cdecl"):
    gsignal = _libs["libPyFd.so"].get("gsignal", "cdecl")
    gsignal.argtypes = [c_int]
    gsignal.restype = c_int

# /usr/include/signal.h: 151
if _libs["libPyFd.so"].has("psignal", "cdecl"):
    psignal = _libs["libPyFd.so"].get("psignal", "cdecl")
    psignal.argtypes = [c_int, String]
    psignal.restype = None

# /usr/include/signal.h: 156
if _libs["libPyFd.so"].has("psiginfo", "cdecl"):
    psiginfo = _libs["libPyFd.so"].get("psiginfo", "cdecl")
    psiginfo.argtypes = [POINTER(siginfo_t), String]
    psiginfo.restype = None

# /usr/include/signal.h: 169
if _libs["libPyFd.so"].has("__sigpause", "cdecl"):
    __sigpause = _libs["libPyFd.so"].get("__sigpause", "cdecl")
    __sigpause.argtypes = [c_int, c_int]
    __sigpause.restype = c_int

# /usr/include/signal.h: 197
if _libs["libPyFd.so"].has("sigblock", "cdecl"):
    sigblock = _libs["libPyFd.so"].get("sigblock", "cdecl")
    sigblock.argtypes = [c_int]
    sigblock.restype = c_int

# /usr/include/signal.h: 200
if _libs["libPyFd.so"].has("sigsetmask", "cdecl"):
    sigsetmask = _libs["libPyFd.so"].get("sigsetmask", "cdecl")
    sigsetmask.argtypes = [c_int]
    sigsetmask.restype = c_int

# /usr/include/signal.h: 203
if _libs["libPyFd.so"].has("siggetmask", "cdecl"):
    siggetmask = _libs["libPyFd.so"].get("siggetmask", "cdecl")
    siggetmask.argtypes = []
    siggetmask.restype = c_int

sig_t = __sighandler_t# /usr/include/signal.h: 217

# /usr/include/signal.h: 223
if _libs["libPyFd.so"].has("sigemptyset", "cdecl"):
    sigemptyset = _libs["libPyFd.so"].get("sigemptyset", "cdecl")
    sigemptyset.argtypes = [POINTER(sigset_t)]
    sigemptyset.restype = c_int

# /usr/include/signal.h: 226
if _libs["libPyFd.so"].has("sigfillset", "cdecl"):
    sigfillset = _libs["libPyFd.so"].get("sigfillset", "cdecl")
    sigfillset.argtypes = [POINTER(sigset_t)]
    sigfillset.restype = c_int

# /usr/include/signal.h: 229
if _libs["libPyFd.so"].has("sigaddset", "cdecl"):
    sigaddset = _libs["libPyFd.so"].get("sigaddset", "cdecl")
    sigaddset.argtypes = [POINTER(sigset_t), c_int]
    sigaddset.restype = c_int

# /usr/include/signal.h: 232
if _libs["libPyFd.so"].has("sigdelset", "cdecl"):
    sigdelset = _libs["libPyFd.so"].get("sigdelset", "cdecl")
    sigdelset.argtypes = [POINTER(sigset_t), c_int]
    sigdelset.restype = c_int

# /usr/include/signal.h: 235
if _libs["libPyFd.so"].has("sigismember", "cdecl"):
    sigismember = _libs["libPyFd.so"].get("sigismember", "cdecl")
    sigismember.argtypes = [POINTER(sigset_t), c_int]
    sigismember.restype = c_int

# /usr/include/bits/sigaction.h: 28
class union_anon_84(Union):
    pass

union_anon_84.__slots__ = [
    'sa_handler',
    'sa_sigaction',
]
union_anon_84._fields_ = [
    ('sa_handler', __sighandler_t),
    ('sa_sigaction', CFUNCTYPE(UNCHECKED(None), c_int, POINTER(siginfo_t), POINTER(None))),
]

# /usr/include/bits/sigaction.h: 24
class struct_sigaction(Structure):
    pass

struct_sigaction.__slots__ = [
    '__sigaction_handler',
    'sa_mask',
    'sa_flags',
    'sa_restorer',
]
struct_sigaction._fields_ = [
    ('__sigaction_handler', union_anon_84),
    ('sa_mask', __sigset_t),
    ('sa_flags', c_int),
    ('sa_restorer', CFUNCTYPE(UNCHECKED(None), )),
]

# /usr/include/signal.h: 256
if _libs["libPyFd.so"].has("sigprocmask", "cdecl"):
    sigprocmask = _libs["libPyFd.so"].get("sigprocmask", "cdecl")
    sigprocmask.argtypes = [c_int, POINTER(sigset_t), POINTER(sigset_t)]
    sigprocmask.restype = c_int

# /usr/include/signal.h: 264
if _libs["libPyFd.so"].has("sigsuspend", "cdecl"):
    sigsuspend = _libs["libPyFd.so"].get("sigsuspend", "cdecl")
    sigsuspend.argtypes = [POINTER(sigset_t)]
    sigsuspend.restype = c_int

# /usr/include/signal.h: 267
if _libs["libPyFd.so"].has("sigaction", "cdecl"):
    sigaction = _libs["libPyFd.so"].get("sigaction", "cdecl")
    sigaction.argtypes = [c_int, POINTER(struct_sigaction), POINTER(struct_sigaction)]
    sigaction.restype = c_int

# /usr/include/signal.h: 271
if _libs["libPyFd.so"].has("sigpending", "cdecl"):
    sigpending = _libs["libPyFd.so"].get("sigpending", "cdecl")
    sigpending.argtypes = [POINTER(sigset_t)]
    sigpending.restype = c_int

# /usr/include/signal.h: 278
if _libs["libPyFd.so"].has("sigwait", "cdecl"):
    sigwait = _libs["libPyFd.so"].get("sigwait", "cdecl")
    sigwait.argtypes = [POINTER(sigset_t), POINTER(c_int)]
    sigwait.restype = c_int

# /usr/include/signal.h: 286
if _libs["libPyFd.so"].has("sigwaitinfo", "cdecl"):
    sigwaitinfo = _libs["libPyFd.so"].get("sigwaitinfo", "cdecl")
    sigwaitinfo.argtypes = [POINTER(sigset_t), POINTER(siginfo_t)]
    sigwaitinfo.restype = c_int

# /usr/include/signal.h: 294
if _libs["libPyFd.so"].has("sigtimedwait", "cdecl"):
    sigtimedwait = _libs["libPyFd.so"].get("sigtimedwait", "cdecl")
    sigtimedwait.argtypes = [POINTER(sigset_t), POINTER(siginfo_t), POINTER(struct_timespec)]
    sigtimedwait.restype = c_int

# /usr/include/signal.h: 301
if _libs["libPyFd.so"].has("sigqueue", "cdecl"):
    sigqueue = _libs["libPyFd.so"].get("sigqueue", "cdecl")
    sigqueue.argtypes = [__pid_t, c_int, union_sigval]
    sigqueue.restype = c_int

# /usr/include/signal.h: 311
try:
    _sys_siglist = (POINTER(c_char) * int(65)).in_dll(_libs["libPyFd.so"], "_sys_siglist")
except:
    pass

# /usr/include/signal.h: 312
try:
    sys_siglist = (POINTER(c_char) * int(65)).in_dll(_libs["libPyFd.so"], "sys_siglist")
except:
    pass

# /usr/include/signal.h: 315
class struct_sigvec(Structure):
    pass

struct_sigvec.__slots__ = [
    'sv_handler',
    'sv_mask',
    'sv_flags',
]
struct_sigvec._fields_ = [
    ('sv_handler', __sighandler_t),
    ('sv_mask', c_int),
    ('sv_flags', c_int),
]

# /usr/include/signal.h: 335
if _libs["libPyFd.so"].has("sigvec", "cdecl"):
    sigvec = _libs["libPyFd.so"].get("sigvec", "cdecl")
    sigvec.argtypes = [c_int, POINTER(struct_sigvec), POINTER(struct_sigvec)]
    sigvec.restype = c_int

# /usr/include/bits/sigcontext.h: 29
class struct__fpx_sw_bytes(Structure):
    pass

struct__fpx_sw_bytes.__slots__ = [
    'magic1',
    'extended_size',
    'xstate_bv',
    'xstate_size',
    'padding',
]
struct__fpx_sw_bytes._fields_ = [
    ('magic1', __uint32_t),
    ('extended_size', __uint32_t),
    ('xstate_bv', __uint64_t),
    ('xstate_size', __uint32_t),
    ('padding', __uint32_t * int(7)),
]

# /usr/include/bits/sigcontext.h: 38
class struct__fpreg(Structure):
    pass

struct__fpreg.__slots__ = [
    'significand',
    'exponent',
]
struct__fpreg._fields_ = [
    ('significand', c_ushort * int(4)),
    ('exponent', c_ushort),
]

# /usr/include/bits/sigcontext.h: 44
class struct__fpxreg(Structure):
    pass

struct__fpxreg.__slots__ = [
    'significand',
    'exponent',
    'padding',
]
struct__fpxreg._fields_ = [
    ('significand', c_ushort * int(4)),
    ('exponent', c_ushort),
    ('padding', c_ushort * int(3)),
]

# /usr/include/bits/sigcontext.h: 51
class struct__xmmreg(Structure):
    pass

struct__xmmreg.__slots__ = [
    'element',
]
struct__xmmreg._fields_ = [
    ('element', __uint32_t * int(4)),
]

# /usr/include/bits/sigcontext.h: 121
class struct__fpstate(Structure):
    pass

struct__fpstate.__slots__ = [
    'cwd',
    'swd',
    'ftw',
    'fop',
    'rip',
    'rdp',
    'mxcsr',
    'mxcr_mask',
    '_st',
    '_xmm',
    'padding',
]
struct__fpstate._fields_ = [
    ('cwd', __uint16_t),
    ('swd', __uint16_t),
    ('ftw', __uint16_t),
    ('fop', __uint16_t),
    ('rip', __uint64_t),
    ('rdp', __uint64_t),
    ('mxcsr', __uint32_t),
    ('mxcr_mask', __uint32_t),
    ('_st', struct__fpxreg * int(8)),
    ('_xmm', struct__xmmreg * int(16)),
    ('padding', __uint32_t * int(24)),
]

# /usr/include/bits/sigcontext.h: 165
class union_anon_85(Union):
    pass

union_anon_85.__slots__ = [
    'fpstate',
    '__fpstate_word',
]
union_anon_85._fields_ = [
    ('fpstate', POINTER(struct__fpstate)),
    ('__fpstate_word', __uint64_t),
]

# /usr/include/bits/sigcontext.h: 137
class struct_sigcontext(Structure):
    pass

struct_sigcontext.__slots__ = [
    'r8',
    'r9',
    'r10',
    'r11',
    'r12',
    'r13',
    'r14',
    'r15',
    'rdi',
    'rsi',
    'rbp',
    'rbx',
    'rdx',
    'rax',
    'rcx',
    'rsp',
    'rip',
    'eflags',
    'cs',
    'gs',
    'fs',
    '__pad0',
    'err',
    'trapno',
    'oldmask',
    'cr2',
    'unnamed_1',
    '__reserved1',
]
struct_sigcontext._anonymous_ = [
    'unnamed_1',
]
struct_sigcontext._fields_ = [
    ('r8', __uint64_t),
    ('r9', __uint64_t),
    ('r10', __uint64_t),
    ('r11', __uint64_t),
    ('r12', __uint64_t),
    ('r13', __uint64_t),
    ('r14', __uint64_t),
    ('r15', __uint64_t),
    ('rdi', __uint64_t),
    ('rsi', __uint64_t),
    ('rbp', __uint64_t),
    ('rbx', __uint64_t),
    ('rdx', __uint64_t),
    ('rax', __uint64_t),
    ('rcx', __uint64_t),
    ('rsp', __uint64_t),
    ('rip', __uint64_t),
    ('eflags', __uint64_t),
    ('cs', c_ushort),
    ('gs', c_ushort),
    ('fs', c_ushort),
    ('__pad0', c_ushort),
    ('err', __uint64_t),
    ('trapno', __uint64_t),
    ('oldmask', __uint64_t),
    ('cr2', __uint64_t),
    ('unnamed_1', union_anon_85),
    ('__reserved1', __uint64_t * int(8)),
]

# /usr/include/bits/sigcontext.h: 175
class struct__xsave_hdr(Structure):
    pass

struct__xsave_hdr.__slots__ = [
    'xstate_bv',
    'reserved1',
    'reserved2',
]
struct__xsave_hdr._fields_ = [
    ('xstate_bv', __uint64_t),
    ('reserved1', __uint64_t * int(2)),
    ('reserved2', __uint64_t * int(5)),
]

# /usr/include/bits/sigcontext.h: 182
class struct__ymmh_state(Structure):
    pass

struct__ymmh_state.__slots__ = [
    'ymmh_space',
]
struct__ymmh_state._fields_ = [
    ('ymmh_space', __uint32_t * int(64)),
]

# /usr/include/bits/sigcontext.h: 187
class struct__xstate(Structure):
    pass

struct__xstate.__slots__ = [
    'fpstate',
    'xstate_hdr',
    'ymmh',
]
struct__xstate._fields_ = [
    ('fpstate', struct__fpstate),
    ('xstate_hdr', struct__xsave_hdr),
    ('ymmh', struct__ymmh_state),
]

# /usr/include/signal.h: 343
if _libs["libPyFd.so"].has("sigreturn", "cdecl"):
    sigreturn = _libs["libPyFd.so"].get("sigreturn", "cdecl")
    sigreturn.argtypes = [POINTER(struct_sigcontext)]
    sigreturn.restype = c_int

# /usr/include/signal.h: 355
if _libs["libPyFd.so"].has("siginterrupt", "cdecl"):
    siginterrupt = _libs["libPyFd.so"].get("siginterrupt", "cdecl")
    siginterrupt.argtypes = [c_int, c_int]
    siginterrupt.restype = c_int

# /usr/include/bits/sigstack.h: 25
class struct_sigstack(Structure):
    pass

struct_sigstack.__slots__ = [
    'ss_sp',
    'ss_onstack',
]
struct_sigstack._fields_ = [
    ('ss_sp', POINTER(None)),
    ('ss_onstack', c_int),
]

enum_anon_86 = c_int# /usr/include/bits/sigstack.h: 33

SS_ONSTACK = 1# /usr/include/bits/sigstack.h: 33

SS_DISABLE = (SS_ONSTACK + 1)# /usr/include/bits/sigstack.h: 33

# /usr/include/bits/sigstack.h: 54
class struct_sigaltstack(Structure):
    pass

struct_sigaltstack.__slots__ = [
    'ss_sp',
    'ss_flags',
    'ss_size',
]
struct_sigaltstack._fields_ = [
    ('ss_sp', POINTER(None)),
    ('ss_flags', c_int),
    ('ss_size', c_size_t),
]

stack_t = struct_sigaltstack# /usr/include/bits/sigstack.h: 54

greg_t = c_longlong# /usr/include/sys/ucontext.h: 31

gregset_t = greg_t * int(23)# /usr/include/sys/ucontext.h: 37

# /usr/include/sys/ucontext.h: 92
class struct__libc_fpxreg(Structure):
    pass

struct__libc_fpxreg.__slots__ = [
    'significand',
    'exponent',
    'padding',
]
struct__libc_fpxreg._fields_ = [
    ('significand', c_uint * int(4)),
    ('exponent', c_uint),
    ('padding', c_uint * int(3)),
]

# /usr/include/sys/ucontext.h: 99
class struct__libc_xmmreg(Structure):
    pass

struct__libc_xmmreg.__slots__ = [
    'element',
]
struct__libc_xmmreg._fields_ = [
    ('element', __uint32_t * int(4)),
]

# /usr/include/sys/ucontext.h: 104
class struct__libc_fpstate(Structure):
    pass

struct__libc_fpstate.__slots__ = [
    'cwd',
    'swd',
    'ftw',
    'fop',
    'rip',
    'rdp',
    'mxcsr',
    'mxcr_mask',
    '_st',
    '_xmm',
    'padding',
]
struct__libc_fpstate._fields_ = [
    ('cwd', __uint16_t),
    ('swd', __uint16_t),
    ('ftw', __uint16_t),
    ('fop', __uint16_t),
    ('rip', __uint64_t),
    ('rdp', __uint64_t),
    ('mxcsr', __uint32_t),
    ('mxcr_mask', __uint32_t),
    ('_st', struct__libc_fpxreg * int(8)),
    ('_xmm', struct__libc_xmmreg * int(16)),
    ('padding', __uint32_t * int(24)),
]

fpregset_t = POINTER(struct__libc_fpstate)# /usr/include/sys/ucontext.h: 121

# /usr/include/sys/ucontext.h: 130
class struct_anon_87(Structure):
    pass

struct_anon_87.__slots__ = [
    'gregs',
    'fpregs',
    '__reserved1',
]
struct_anon_87._fields_ = [
    ('gregs', gregset_t),
    ('fpregs', fpregset_t),
    ('__reserved1', c_ulonglong * int(8)),
]

mcontext_t = struct_anon_87# /usr/include/sys/ucontext.h: 130

# /usr/include/sys/ucontext.h: 133
class struct_ucontext(Structure):
    pass

struct_ucontext.__slots__ = [
    'uc_flags',
    'uc_link',
    'uc_stack',
    'uc_mcontext',
    'uc_sigmask',
    '__fpregs_mem',
]
struct_ucontext._fields_ = [
    ('uc_flags', c_ulong),
    ('uc_link', POINTER(struct_ucontext)),
    ('uc_stack', stack_t),
    ('uc_mcontext', mcontext_t),
    ('uc_sigmask', __sigset_t),
    ('__fpregs_mem', struct__libc_fpstate),
]

ucontext_t = struct_ucontext# /usr/include/sys/ucontext.h: 141

# /usr/include/signal.h: 366
if _libs["libPyFd.so"].has("sigstack", "cdecl"):
    sigstack = _libs["libPyFd.so"].get("sigstack", "cdecl")
    sigstack.argtypes = [POINTER(struct_sigstack), POINTER(struct_sigstack)]
    sigstack.restype = c_int

# /usr/include/signal.h: 371
if _libs["libPyFd.so"].has("sigaltstack", "cdecl"):
    sigaltstack = _libs["libPyFd.so"].get("sigaltstack", "cdecl")
    sigaltstack.argtypes = [POINTER(struct_sigaltstack), POINTER(struct_sigaltstack)]
    sigaltstack.restype = c_int

# /usr/include/bits/sigthread.h: 30
if _libs["libPyFd.so"].has("pthread_sigmask", "cdecl"):
    pthread_sigmask = _libs["libPyFd.so"].get("pthread_sigmask", "cdecl")
    pthread_sigmask.argtypes = [c_int, POINTER(__sigset_t), POINTER(__sigset_t)]
    pthread_sigmask.restype = c_int

# /usr/include/bits/sigthread.h: 35
if _libs["libPyFd.so"].has("pthread_kill", "cdecl"):
    pthread_kill = _libs["libPyFd.so"].get("pthread_kill", "cdecl")
    pthread_kill.argtypes = [pthread_t, c_int]
    pthread_kill.restype = c_int

# /usr/include/signal.h: 403
if _libs["libPyFd.so"].has("__libc_current_sigrtmin", "cdecl"):
    __libc_current_sigrtmin = _libs["libPyFd.so"].get("__libc_current_sigrtmin", "cdecl")
    __libc_current_sigrtmin.argtypes = []
    __libc_current_sigrtmin.restype = c_int

# /usr/include/signal.h: 405
if _libs["libPyFd.so"].has("__libc_current_sigrtmax", "cdecl"):
    __libc_current_sigrtmax = _libs["libPyFd.so"].get("__libc_current_sigrtmax", "cdecl")
    __libc_current_sigrtmax.argtypes = []
    __libc_current_sigrtmax.restype = c_int

# /usr/include/bits/fcntl.h: 35
class struct_flock(Structure):
    pass

struct_flock.__slots__ = [
    'l_type',
    'l_whence',
    'l_start',
    'l_len',
    'l_pid',
]
struct_flock._fields_ = [
    ('l_type', c_int),
    ('l_whence', c_int),
    ('l_start', __off_t),
    ('l_len', __off_t),
    ('l_pid', __pid_t),
]

# /usr/include/bits/stat.h: 46
class struct_stat(Structure):
    pass

struct_stat.__slots__ = [
    'st_dev',
    'st_ino',
    'st_nlink',
    'st_mode',
    'st_uid',
    'st_gid',
    '__pad0',
    'st_rdev',
    'st_size',
    'st_blksize',
    'st_blocks',
    'st_atim',
    'st_mtim',
    'st_ctim',
    '__unused',
]
struct_stat._fields_ = [
    ('st_dev', __dev_t),
    ('st_ino', __ino_t),
    ('st_nlink', __nlink_t),
    ('st_mode', __mode_t),
    ('st_uid', __uid_t),
    ('st_gid', __gid_t),
    ('__pad0', c_int),
    ('st_rdev', __dev_t),
    ('st_size', __off_t),
    ('st_blksize', __blksize_t),
    ('st_blocks', __blkcnt_t),
    ('st_atim', struct_timespec),
    ('st_mtim', struct_timespec),
    ('st_ctim', struct_timespec),
    ('__unused', __syscall_slong_t * int(3)),
]

# /usr/include/fcntl.h: 163
if _libs["libPyFd.so"].has("fcntl", "cdecl"):
    _func = _libs["libPyFd.so"].get("fcntl", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [c_int, c_int]
    fcntl = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/fcntl.h: 173
if _libs["libPyFd.so"].has("open", "cdecl"):
    _func = _libs["libPyFd.so"].get("open", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [String, c_int]
    open = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/fcntl.h: 197
if _libs["libPyFd.so"].has("openat", "cdecl"):
    _func = _libs["libPyFd.so"].get("openat", "cdecl")
    _restype = c_int
    _errcheck = None
    _argtypes = [c_int, String, c_int]
    openat = _variadic_function(_func,_restype,_argtypes,_errcheck)

# /usr/include/fcntl.h: 219
if _libs["libPyFd.so"].has("creat", "cdecl"):
    creat = _libs["libPyFd.so"].get("creat", "cdecl")
    creat.argtypes = [String, mode_t]
    creat.restype = c_int

# /usr/include/fcntl.h: 265
if _libs["libPyFd.so"].has("posix_fadvise", "cdecl"):
    posix_fadvise = _libs["libPyFd.so"].get("posix_fadvise", "cdecl")
    posix_fadvise.argtypes = [c_int, off_t, off_t, c_int]
    posix_fadvise.restype = c_int

# /usr/include/fcntl.h: 287
if _libs["libPyFd.so"].has("posix_fallocate", "cdecl"):
    posix_fallocate = _libs["libPyFd.so"].get("posix_fallocate", "cdecl")
    posix_fallocate.argtypes = [c_int, off_t, off_t]
    posix_fallocate.restype = c_int

enum_anon_88 = c_int# /usr/include/ctype.h: 47

_ISupper = (0 < 8) and ((1 << 0) << 8) or ((1 << 0) >> 8)# /usr/include/ctype.h: 47

_ISlower = (1 < 8) and ((1 << 1) << 8) or ((1 << 1) >> 8)# /usr/include/ctype.h: 47

_ISalpha = (2 < 8) and ((1 << 2) << 8) or ((1 << 2) >> 8)# /usr/include/ctype.h: 47

_ISdigit = (3 < 8) and ((1 << 3) << 8) or ((1 << 3) >> 8)# /usr/include/ctype.h: 47

_ISxdigit = (4 < 8) and ((1 << 4) << 8) or ((1 << 4) >> 8)# /usr/include/ctype.h: 47

_ISspace = (5 < 8) and ((1 << 5) << 8) or ((1 << 5) >> 8)# /usr/include/ctype.h: 47

_ISprint = (6 < 8) and ((1 << 6) << 8) or ((1 << 6) >> 8)# /usr/include/ctype.h: 47

_ISgraph = (7 < 8) and ((1 << 7) << 8) or ((1 << 7) >> 8)# /usr/include/ctype.h: 47

_ISblank = (8 < 8) and ((1 << 8) << 8) or ((1 << 8) >> 8)# /usr/include/ctype.h: 47

_IScntrl = (9 < 8) and ((1 << 9) << 8) or ((1 << 9) >> 8)# /usr/include/ctype.h: 47

_ISpunct = (10 < 8) and ((1 << 10) << 8) or ((1 << 10) >> 8)# /usr/include/ctype.h: 47

_ISalnum = (11 < 8) and ((1 << 11) << 8) or ((1 << 11) >> 8)# /usr/include/ctype.h: 47

# /usr/include/ctype.h: 80
if _libs["libPyFd.so"].has("__ctype_b_loc", "cdecl"):
    __ctype_b_loc = _libs["libPyFd.so"].get("__ctype_b_loc", "cdecl")
    __ctype_b_loc.argtypes = []
    __ctype_b_loc.restype = POINTER(POINTER(c_uint))

# /usr/include/ctype.h: 82
if _libs["libPyFd.so"].has("__ctype_tolower_loc", "cdecl"):
    __ctype_tolower_loc = _libs["libPyFd.so"].get("__ctype_tolower_loc", "cdecl")
    __ctype_tolower_loc.argtypes = []
    __ctype_tolower_loc.restype = POINTER(POINTER(__int32_t))

# /usr/include/ctype.h: 84
if _libs["libPyFd.so"].has("__ctype_toupper_loc", "cdecl"):
    __ctype_toupper_loc = _libs["libPyFd.so"].get("__ctype_toupper_loc", "cdecl")
    __ctype_toupper_loc.argtypes = []
    __ctype_toupper_loc.restype = POINTER(POINTER(__int32_t))

# /usr/include/ctype.h: 111
if _libs["libPyFd.so"].has("isalnum", "cdecl"):
    isalnum = _libs["libPyFd.so"].get("isalnum", "cdecl")
    isalnum.argtypes = [c_int]
    isalnum.restype = c_int

# /usr/include/ctype.h: 112
if _libs["libPyFd.so"].has("isalpha", "cdecl"):
    isalpha = _libs["libPyFd.so"].get("isalpha", "cdecl")
    isalpha.argtypes = [c_int]
    isalpha.restype = c_int

# /usr/include/ctype.h: 113
if _libs["libPyFd.so"].has("iscntrl", "cdecl"):
    iscntrl = _libs["libPyFd.so"].get("iscntrl", "cdecl")
    iscntrl.argtypes = [c_int]
    iscntrl.restype = c_int

# /usr/include/ctype.h: 114
if _libs["libPyFd.so"].has("isdigit", "cdecl"):
    isdigit = _libs["libPyFd.so"].get("isdigit", "cdecl")
    isdigit.argtypes = [c_int]
    isdigit.restype = c_int

# /usr/include/ctype.h: 115
if _libs["libPyFd.so"].has("islower", "cdecl"):
    islower = _libs["libPyFd.so"].get("islower", "cdecl")
    islower.argtypes = [c_int]
    islower.restype = c_int

# /usr/include/ctype.h: 116
if _libs["libPyFd.so"].has("isgraph", "cdecl"):
    isgraph = _libs["libPyFd.so"].get("isgraph", "cdecl")
    isgraph.argtypes = [c_int]
    isgraph.restype = c_int

# /usr/include/ctype.h: 117
if _libs["libPyFd.so"].has("isprint", "cdecl"):
    isprint = _libs["libPyFd.so"].get("isprint", "cdecl")
    isprint.argtypes = [c_int]
    isprint.restype = c_int

# /usr/include/ctype.h: 118
if _libs["libPyFd.so"].has("ispunct", "cdecl"):
    ispunct = _libs["libPyFd.so"].get("ispunct", "cdecl")
    ispunct.argtypes = [c_int]
    ispunct.restype = c_int

# /usr/include/ctype.h: 119
if _libs["libPyFd.so"].has("isspace", "cdecl"):
    isspace = _libs["libPyFd.so"].get("isspace", "cdecl")
    isspace.argtypes = [c_int]
    isspace.restype = c_int

# /usr/include/ctype.h: 120
if _libs["libPyFd.so"].has("isupper", "cdecl"):
    isupper = _libs["libPyFd.so"].get("isupper", "cdecl")
    isupper.argtypes = [c_int]
    isupper.restype = c_int

# /usr/include/ctype.h: 121
if _libs["libPyFd.so"].has("isxdigit", "cdecl"):
    isxdigit = _libs["libPyFd.so"].get("isxdigit", "cdecl")
    isxdigit.argtypes = [c_int]
    isxdigit.restype = c_int

# /usr/include/ctype.h: 125
if _libs["libPyFd.so"].has("tolower", "cdecl"):
    tolower = _libs["libPyFd.so"].get("tolower", "cdecl")
    tolower.argtypes = [c_int]
    tolower.restype = c_int

# /usr/include/ctype.h: 128
if _libs["libPyFd.so"].has("toupper", "cdecl"):
    toupper = _libs["libPyFd.so"].get("toupper", "cdecl")
    toupper.argtypes = [c_int]
    toupper.restype = c_int

# /usr/include/ctype.h: 137
if _libs["libPyFd.so"].has("isblank", "cdecl"):
    isblank = _libs["libPyFd.so"].get("isblank", "cdecl")
    isblank.argtypes = [c_int]
    isblank.restype = c_int

# /usr/include/ctype.h: 151
if _libs["libPyFd.so"].has("isascii", "cdecl"):
    isascii = _libs["libPyFd.so"].get("isascii", "cdecl")
    isascii.argtypes = [c_int]
    isascii.restype = c_int

# /usr/include/ctype.h: 155
if _libs["libPyFd.so"].has("toascii", "cdecl"):
    toascii = _libs["libPyFd.so"].get("toascii", "cdecl")
    toascii.argtypes = [c_int]
    toascii.restype = c_int

# /usr/include/ctype.h: 159
if _libs["libPyFd.so"].has("_toupper", "cdecl"):
    _toupper = _libs["libPyFd.so"].get("_toupper", "cdecl")
    _toupper.argtypes = [c_int]
    _toupper.restype = c_int

# /usr/include/ctype.h: 160
if _libs["libPyFd.so"].has("_tolower", "cdecl"):
    _tolower = _libs["libPyFd.so"].get("_tolower", "cdecl")
    _tolower.argtypes = [c_int]
    _tolower.restype = c_int

# /usr/include/ctype.h: 272
if _libs["libPyFd.so"].has("isalnum_l", "cdecl"):
    isalnum_l = _libs["libPyFd.so"].get("isalnum_l", "cdecl")
    isalnum_l.argtypes = [c_int, __locale_t]
    isalnum_l.restype = c_int

# /usr/include/ctype.h: 273
if _libs["libPyFd.so"].has("isalpha_l", "cdecl"):
    isalpha_l = _libs["libPyFd.so"].get("isalpha_l", "cdecl")
    isalpha_l.argtypes = [c_int, __locale_t]
    isalpha_l.restype = c_int

# /usr/include/ctype.h: 274
if _libs["libPyFd.so"].has("iscntrl_l", "cdecl"):
    iscntrl_l = _libs["libPyFd.so"].get("iscntrl_l", "cdecl")
    iscntrl_l.argtypes = [c_int, __locale_t]
    iscntrl_l.restype = c_int

# /usr/include/ctype.h: 275
if _libs["libPyFd.so"].has("isdigit_l", "cdecl"):
    isdigit_l = _libs["libPyFd.so"].get("isdigit_l", "cdecl")
    isdigit_l.argtypes = [c_int, __locale_t]
    isdigit_l.restype = c_int

# /usr/include/ctype.h: 276
if _libs["libPyFd.so"].has("islower_l", "cdecl"):
    islower_l = _libs["libPyFd.so"].get("islower_l", "cdecl")
    islower_l.argtypes = [c_int, __locale_t]
    islower_l.restype = c_int

# /usr/include/ctype.h: 277
if _libs["libPyFd.so"].has("isgraph_l", "cdecl"):
    isgraph_l = _libs["libPyFd.so"].get("isgraph_l", "cdecl")
    isgraph_l.argtypes = [c_int, __locale_t]
    isgraph_l.restype = c_int

# /usr/include/ctype.h: 278
if _libs["libPyFd.so"].has("isprint_l", "cdecl"):
    isprint_l = _libs["libPyFd.so"].get("isprint_l", "cdecl")
    isprint_l.argtypes = [c_int, __locale_t]
    isprint_l.restype = c_int

# /usr/include/ctype.h: 279
if _libs["libPyFd.so"].has("ispunct_l", "cdecl"):
    ispunct_l = _libs["libPyFd.so"].get("ispunct_l", "cdecl")
    ispunct_l.argtypes = [c_int, __locale_t]
    ispunct_l.restype = c_int

# /usr/include/ctype.h: 280
if _libs["libPyFd.so"].has("isspace_l", "cdecl"):
    isspace_l = _libs["libPyFd.so"].get("isspace_l", "cdecl")
    isspace_l.argtypes = [c_int, __locale_t]
    isspace_l.restype = c_int

# /usr/include/ctype.h: 281
if _libs["libPyFd.so"].has("isupper_l", "cdecl"):
    isupper_l = _libs["libPyFd.so"].get("isupper_l", "cdecl")
    isupper_l.argtypes = [c_int, __locale_t]
    isupper_l.restype = c_int

# /usr/include/ctype.h: 282
if _libs["libPyFd.so"].has("isxdigit_l", "cdecl"):
    isxdigit_l = _libs["libPyFd.so"].get("isxdigit_l", "cdecl")
    isxdigit_l.argtypes = [c_int, __locale_t]
    isxdigit_l.restype = c_int

# /usr/include/ctype.h: 284
if _libs["libPyFd.so"].has("isblank_l", "cdecl"):
    isblank_l = _libs["libPyFd.so"].get("isblank_l", "cdecl")
    isblank_l.argtypes = [c_int, __locale_t]
    isblank_l.restype = c_int

# /usr/include/ctype.h: 288
if _libs["libPyFd.so"].has("__tolower_l", "cdecl"):
    __tolower_l = _libs["libPyFd.so"].get("__tolower_l", "cdecl")
    __tolower_l.argtypes = [c_int, __locale_t]
    __tolower_l.restype = c_int

# /usr/include/ctype.h: 289
if _libs["libPyFd.so"].has("tolower_l", "cdecl"):
    tolower_l = _libs["libPyFd.so"].get("tolower_l", "cdecl")
    tolower_l.argtypes = [c_int, __locale_t]
    tolower_l.restype = c_int

# /usr/include/ctype.h: 292
if _libs["libPyFd.so"].has("__toupper_l", "cdecl"):
    __toupper_l = _libs["libPyFd.so"].get("__toupper_l", "cdecl")
    __toupper_l.argtypes = [c_int, __locale_t]
    __toupper_l.restype = c_int

# /usr/include/ctype.h: 293
if _libs["libPyFd.so"].has("toupper_l", "cdecl"):
    toupper_l = _libs["libPyFd.so"].get("toupper_l", "cdecl")
    toupper_l.argtypes = [c_int, __locale_t]
    toupper_l.restype = c_int

# /usr/include/bits/dirent.h: 22
class struct_dirent(Structure):
    pass

struct_dirent.__slots__ = [
    'd_ino',
    'd_off',
    'd_reclen',
    'd_type',
    'd_name',
]
struct_dirent._fields_ = [
    ('d_ino', __ino_t),
    ('d_off', __off_t),
    ('d_reclen', c_uint),
    ('d_type', c_ubyte),
    ('d_name', c_char * int(256)),
]

enum_anon_89 = c_int# /usr/include/dirent.h: 98

DT_UNKNOWN = 0# /usr/include/dirent.h: 98

DT_FIFO = 1# /usr/include/dirent.h: 98

DT_CHR = 2# /usr/include/dirent.h: 98

DT_DIR = 4# /usr/include/dirent.h: 98

DT_BLK = 6# /usr/include/dirent.h: 98

DT_REG = 8# /usr/include/dirent.h: 98

DT_LNK = 10# /usr/include/dirent.h: 98

DT_SOCK = 12# /usr/include/dirent.h: 98

DT_WHT = 14# /usr/include/dirent.h: 98

# /usr/include/dirent.h: 128
class struct___dirstream(Structure):
    pass

DIR = struct___dirstream# /usr/include/dirent.h: 128

# /usr/include/dirent.h: 135
if _libs["libPyFd.so"].has("opendir", "cdecl"):
    opendir = _libs["libPyFd.so"].get("opendir", "cdecl")
    opendir.argtypes = [String]
    opendir.restype = POINTER(DIR)

# /usr/include/dirent.h: 142
if _libs["libPyFd.so"].has("fdopendir", "cdecl"):
    fdopendir = _libs["libPyFd.so"].get("fdopendir", "cdecl")
    fdopendir.argtypes = [c_int]
    fdopendir.restype = POINTER(DIR)

# /usr/include/dirent.h: 150
if _libs["libPyFd.so"].has("closedir", "cdecl"):
    closedir = _libs["libPyFd.so"].get("closedir", "cdecl")
    closedir.argtypes = [POINTER(DIR)]
    closedir.restype = c_int

# /usr/include/dirent.h: 163
if _libs["libPyFd.so"].has("readdir", "cdecl"):
    readdir = _libs["libPyFd.so"].get("readdir", "cdecl")
    readdir.argtypes = [POINTER(DIR)]
    readdir.restype = POINTER(struct_dirent)

# /usr/include/dirent.h: 184
if _libs["libPyFd.so"].has("readdir_r", "cdecl"):
    readdir_r = _libs["libPyFd.so"].get("readdir_r", "cdecl")
    readdir_r.argtypes = [POINTER(DIR), POINTER(struct_dirent), POINTER(POINTER(struct_dirent))]
    readdir_r.restype = c_int

# /usr/include/dirent.h: 209
if _libs["libPyFd.so"].has("rewinddir", "cdecl"):
    rewinddir = _libs["libPyFd.so"].get("rewinddir", "cdecl")
    rewinddir.argtypes = [POINTER(DIR)]
    rewinddir.restype = None

# /usr/include/dirent.h: 215
if _libs["libPyFd.so"].has("seekdir", "cdecl"):
    seekdir = _libs["libPyFd.so"].get("seekdir", "cdecl")
    seekdir.argtypes = [POINTER(DIR), c_long]
    seekdir.restype = None

# /usr/include/dirent.h: 218
if _libs["libPyFd.so"].has("telldir", "cdecl"):
    telldir = _libs["libPyFd.so"].get("telldir", "cdecl")
    telldir.argtypes = [POINTER(DIR)]
    telldir.restype = c_long

# /usr/include/dirent.h: 224
if _libs["libPyFd.so"].has("dirfd", "cdecl"):
    dirfd = _libs["libPyFd.so"].get("dirfd", "cdecl")
    dirfd.argtypes = [POINTER(DIR)]
    dirfd.restype = c_int

# /usr/include/dirent.h: 255
if _libs["libPyFd.so"].has("scandir", "cdecl"):
    scandir = _libs["libPyFd.so"].get("scandir", "cdecl")
    scandir.argtypes = [String, POINTER(POINTER(POINTER(struct_dirent))), CFUNCTYPE(UNCHECKED(c_int), POINTER(struct_dirent)), CFUNCTYPE(UNCHECKED(c_int), POINTER(POINTER(struct_dirent)), POINTER(POINTER(struct_dirent)))]
    scandir.restype = c_int

# /usr/include/dirent.h: 325
if _libs["libPyFd.so"].has("alphasort", "cdecl"):
    alphasort = _libs["libPyFd.so"].get("alphasort", "cdecl")
    alphasort.argtypes = [POINTER(POINTER(struct_dirent)), POINTER(POINTER(struct_dirent))]
    alphasort.restype = c_int

# /usr/include/dirent.h: 353
if _libs["libPyFd.so"].has("getdirentries", "cdecl"):
    getdirentries = _libs["libPyFd.so"].get("getdirentries", "cdecl")
    getdirentries.argtypes = [c_int, String, c_size_t, POINTER(__off_t)]
    getdirentries.restype = __ssize_t

# /usr/include/sys/time.h: 56
class struct_timezone(Structure):
    pass

struct_timezone.__slots__ = [
    'tz_minuteswest',
    'tz_dsttime',
]
struct_timezone._fields_ = [
    ('tz_minuteswest', c_int),
    ('tz_dsttime', c_int),
]

__timezone_ptr_t = POINTER(struct_timezone)# /usr/include/sys/time.h: 62

# /usr/include/sys/time.h: 72
if _libs["libPyFd.so"].has("gettimeofday", "cdecl"):
    gettimeofday = _libs["libPyFd.so"].get("gettimeofday", "cdecl")
    gettimeofday.argtypes = [POINTER(struct_timeval), __timezone_ptr_t]
    gettimeofday.restype = c_int

# /usr/include/sys/time.h: 78
if _libs["libPyFd.so"].has("settimeofday", "cdecl"):
    settimeofday = _libs["libPyFd.so"].get("settimeofday", "cdecl")
    settimeofday.argtypes = [POINTER(struct_timeval), POINTER(struct_timezone)]
    settimeofday.restype = c_int

# /usr/include/sys/time.h: 86
if _libs["libPyFd.so"].has("adjtime", "cdecl"):
    adjtime = _libs["libPyFd.so"].get("adjtime", "cdecl")
    adjtime.argtypes = [POINTER(struct_timeval), POINTER(struct_timeval)]
    adjtime.restype = c_int

enum___itimer_which = c_int# /usr/include/sys/time.h: 92

ITIMER_REAL = 0# /usr/include/sys/time.h: 92

ITIMER_VIRTUAL = 1# /usr/include/sys/time.h: 92

ITIMER_PROF = 2# /usr/include/sys/time.h: 92

# /usr/include/sys/time.h: 108
class struct_itimerval(Structure):
    pass

struct_itimerval.__slots__ = [
    'it_interval',
    'it_value',
]
struct_itimerval._fields_ = [
    ('it_interval', struct_timeval),
    ('it_value', struct_timeval),
]

__itimer_which_t = c_int# /usr/include/sys/time.h: 121

# /usr/include/sys/time.h: 126
if _libs["libPyFd.so"].has("getitimer", "cdecl"):
    getitimer = _libs["libPyFd.so"].get("getitimer", "cdecl")
    getitimer.argtypes = [__itimer_which_t, POINTER(struct_itimerval)]
    getitimer.restype = c_int

# /usr/include/sys/time.h: 132
if _libs["libPyFd.so"].has("setitimer", "cdecl"):
    setitimer = _libs["libPyFd.so"].get("setitimer", "cdecl")
    setitimer.argtypes = [__itimer_which_t, POINTER(struct_itimerval), POINTER(struct_itimerval)]
    setitimer.restype = c_int

# /usr/include/sys/time.h: 139
if _libs["libPyFd.so"].has("utimes", "cdecl"):
    utimes = _libs["libPyFd.so"].get("utimes", "cdecl")
    utimes.argtypes = [String, struct_timeval * int(2)]
    utimes.restype = c_int

# /usr/include/sys/time.h: 144
if _libs["libPyFd.so"].has("lutimes", "cdecl"):
    lutimes = _libs["libPyFd.so"].get("lutimes", "cdecl")
    lutimes.argtypes = [String, struct_timeval * int(2)]
    lutimes.restype = c_int

# /usr/include/sys/time.h: 148
if _libs["libPyFd.so"].has("futimes", "cdecl"):
    futimes = _libs["libPyFd.so"].get("futimes", "cdecl")
    futimes.argtypes = [c_int, struct_timeval * int(2)]
    futimes.restype = c_int

# /usr/include/sys/timeb.h: 31
class struct_timeb(Structure):
    pass

struct_timeb.__slots__ = [
    'time',
    'millitm',
    'timezone',
    'dstflag',
]
struct_timeb._fields_ = [
    ('time', time_t),
    ('millitm', c_uint),
    ('timezone', c_int),
    ('dstflag', c_int),
]

# /usr/include/sys/timeb.h: 41
if _libs["libPyFd.so"].has("ftime", "cdecl"):
    ftime = _libs["libPyFd.so"].get("ftime", "cdecl")
    ftime.argtypes = [POINTER(struct_timeb)]
    ftime.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdUtil.h: 20
if _libs["libPyFd.so"].has("FdGetFrameFromMessage", "cdecl"):
    FdGetFrameFromMessage = _libs["libPyFd.so"].get("FdGetFrameFromMessage", "cdecl")
    FdGetFrameFromMessage.argtypes = [CmMessage, c_int, POINTER(c_int)]
    FdGetFrameFromMessage.restype = POINTER(FrameH)

# /users/poulton/packages/Fd/v9r0/src/FdUtil.h: 22
if _libs["libPyFd.so"].has("FdPutFrameInMessage", "cdecl"):
    FdPutFrameInMessage = _libs["libPyFd.so"].get("FdPutFrameInMessage", "cdecl")
    FdPutFrameInMessage.argtypes = [POINTER(FrameH), c_int, POINTER(c_int), c_int]
    FdPutFrameInMessage.restype = CmMessage

# /users/poulton/packages/Fd/v9r0/src/FdUtil.h: 24
if _libs["libPyFd.so"].has("FdRemoveFramesRequest", "cdecl"):
    FdRemoveFramesRequest = _libs["libPyFd.so"].get("FdRemoveFramesRequest", "cdecl")
    FdRemoveFramesRequest.argtypes = [String, String]
    FdRemoveFramesRequest.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdUtil.h: 25
if _libs["libPyFd.so"].has("FdRequestChannelsList", "cdecl"):
    FdRequestChannelsList = _libs["libPyFd.so"].get("FdRequestChannelsList", "cdecl")
    FdRequestChannelsList.argtypes = [String, c_int]
    FdRequestChannelsList.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdUtil.h: 26
if _libs["libPyFd.so"].has("FdRequestFrames", "cdecl"):
    FdRequestFrames = _libs["libPyFd.so"].get("FdRequestFrames", "cdecl")
    FdRequestFrames.argtypes = [String, String, String, c_int, c_int]
    FdRequestFrames.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 13
class struct_FrRandomG(Structure):
    pass

FrRandomG = struct_FrRandomG# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 11

struct_FrRandomG.__slots__ = [
    'iset',
    'gset',
    'seed',
]
struct_FrRandomG._fields_ = [
    ('iset', c_long),
    ('gset', c_double),
    ('seed', c_long),
]

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 20
if _libs["libPyFd.so"].has("FrSerDataAddData", "cdecl"):
    FrSerDataAddData = _libs["libPyFd.so"].get("FrSerDataAddData", "cdecl")
    FrSerDataAddData.argtypes = [POINTER(FrSerData), String]
    FrSerDataAddData.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 21
if _libs["libPyFd.so"].has("FrStrcmp", "cdecl"):
    FrStrcmp = _libs["libPyFd.so"].get("FrStrcmp", "cdecl")
    FrStrcmp.argtypes = [String, String]
    FrStrcmp.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 22
if _libs["libPyFd.so"].has("FrvFDFilterFreeTFBin", "cdecl"):
    FrvFDFilterFreeTFBin = _libs["libPyFd.so"].get("FrvFDFilterFreeTFBin", "cdecl")
    FrvFDFilterFreeTFBin.argtypes = [POINTER(FrvFDFilter)]
    FrvFDFilterFreeTFBin.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 24
if _libs["libPyFd.so"].has("FrFrameEnlarge", "cdecl"):
    FrFrameEnlarge = _libs["libPyFd.so"].get("FrFrameEnlarge", "cdecl")
    FrFrameEnlarge.argtypes = [POINTER(FrameH), POINTER(POINTER(FrameH)), c_double]
    FrFrameEnlarge.restype = POINTER(FrameH)

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 27
if _libs["libPyFd.so"].has("FrRandGNew", "cdecl"):
    FrRandGNew = _libs["libPyFd.so"].get("FrRandGNew", "cdecl")
    FrRandGNew.argtypes = [c_long]
    FrRandGNew.restype = POINTER(FrRandomG)

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 28
if _libs["libPyFd.so"].has("FrRandG", "cdecl"):
    FrRandG = _libs["libPyFd.so"].get("FrRandG", "cdecl")
    FrRandG.argtypes = [POINTER(FrRandomG)]
    FrRandG.restype = c_double

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 29
if _libs["libPyFd.so"].has("FrRand1", "cdecl"):
    FrRand1 = _libs["libPyFd.so"].get("FrRand1", "cdecl")
    FrRand1.argtypes = [POINTER(c_long)]
    FrRand1.restype = c_double

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 30
if _libs["libPyFd.so"].has("FrUMrand2", "cdecl"):
    FrUMrand2 = _libs["libPyFd.so"].get("FrUMrand2", "cdecl")
    FrUMrand2.argtypes = [POINTER(c_double), POINTER(c_double)]
    FrUMrand2.restype = c_double

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 31
if _libs["libPyFd.so"].has("FrVectFixName", "cdecl"):
    FrVectFixName = _libs["libPyFd.so"].get("FrVectFixName", "cdecl")
    FrVectFixName.argtypes = [POINTER(FrVect)]
    FrVectFixName.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 32
if _libs["libPyFd.so"].has("FrameFreqCut", "cdecl"):
    FrameFreqCut = _libs["libPyFd.so"].get("FrameFreqCut", "cdecl")
    FrameFreqCut.argtypes = [POINTER(FrameH), c_double]
    FrameFreqCut.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 53
class struct_FdAction(Structure):
    pass

FdAction = struct_FdAction# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 51

struct_FdAction.__slots__ = [
    'data',
    'action',
    'type',
    'toBeRemoved',
    'debugLvl',
    'serData',
    'serDataSize',
    'userInfo',
    'userInfoSize',
    'state',
    'next',
    'lastTime',
    'frameDt',
    'tag',
]
struct_FdAction._fields_ = [
    ('data', POINTER(None)),
    ('action', CFUNCTYPE(UNCHECKED(None), )),
    ('type', String),
    ('toBeRemoved', FRBOOL),
    ('debugLvl', c_int),
    ('serData', String),
    ('serDataSize', c_int),
    ('userInfo', String),
    ('userInfoSize', c_int),
    ('state', c_int),
    ('next', POINTER(FdAction)),
    ('lastTime', c_int),
    ('frameDt', c_int),
    ('tag', String),
]

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 75
if _libs["libPyFd.so"].has("FdActionNew", "cdecl"):
    FdActionNew = _libs["libPyFd.so"].get("FdActionNew", "cdecl")
    FdActionNew.argtypes = [POINTER(POINTER(FdAction)), POINTER(None), CFUNCTYPE(UNCHECKED(None), ), String]
    FdActionNew.restype = POINTER(FdAction)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 77
if _libs["libPyFd.so"].has("FdActionNewNoThread", "cdecl"):
    FdActionNewNoThread = _libs["libPyFd.so"].get("FdActionNewNoThread", "cdecl")
    FdActionNewNoThread.argtypes = [POINTER(POINTER(FdAction)), POINTER(None), CFUNCTYPE(UNCHECKED(None), ), String]
    FdActionNewNoThread.restype = POINTER(FdAction)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 79
if _libs["libPyFd.so"].has("FdActionRemove", "cdecl"):
    FdActionRemove = _libs["libPyFd.so"].get("FdActionRemove", "cdecl")
    FdActionRemove.argtypes = [POINTER(FdAction)]
    FdActionRemove.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 80
if _libs["libPyFd.so"].has("FdActionGetLast", "cdecl"):
    FdActionGetLast = _libs["libPyFd.so"].get("FdActionGetLast", "cdecl")
    FdActionGetLast.argtypes = [POINTER(FdAction)]
    FdActionGetLast.restype = POINTER(FdAction)

struct_FdIO.__slots__ = [
    'actionsIn',
    'actionsOut',
    'deleteMsg',
    'frameFormat',
    'getFrTimeOut',
    'putFrTimeOut',
    'noFrMsgTimeOut',
    'getFrStatus',
    'iFrameList',
    'iFrameListIndex',
    'iFrameListSize',
    'dynamicSrc',
    'inputTag',
    'userInfo',
    'serData',
    'lastFrameDt',
    'lastFrameGTime',
    'lastFrameTime',
    'maxSpeed',
    'minLatency',
    'compressIn',
    'nFrames',
    'nextStop',
    'nextStopD',
    'inputTime',
    'outputTime',
    'parser',
    'noConfigCheck',
    'tStart',
    'autoState',
    'chPrefix',
    'cmPrinter',
]
struct_FdIO._fields_ = [
    ('actionsIn', POINTER(FdAction)),
    ('actionsOut', POINTER(FdAction)),
    ('deleteMsg', FRBOOL),
    ('frameFormat', c_int),
    ('getFrTimeOut', c_double),
    ('putFrTimeOut', c_double),
    ('noFrMsgTimeOut', c_int),
    ('getFrStatus', FRBOOL),
    ('iFrameList', POINTER(POINTER(FrameH))),
    ('iFrameListIndex', c_int),
    ('iFrameListSize', c_int),
    ('dynamicSrc', String),
    ('inputTag', String),
    ('userInfo', String),
    ('serData', String),
    ('lastFrameDt', c_double),
    ('lastFrameGTime', c_double),
    ('lastFrameTime', c_int),
    ('maxSpeed', c_double),
    ('minLatency', c_int),
    ('compressIn', c_int),
    ('nFrames', c_int),
    ('nextStop', c_int),
    ('nextStopD', c_int),
    ('inputTime', c_double),
    ('outputTime', c_double),
    ('parser', POINTER(CfgParse_t)),
    ('noConfigCheck', CfgBool_t),
    ('tStart', c_int),
    ('autoState', CfgBool_t),
    ('chPrefix', String),
    ('cmPrinter', CmConnectPrinter),
]

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 118
if _libs["libPyFd.so"].has("FdIOGetRoot", "cdecl"):
    FdIOGetRoot = _libs["libPyFd.so"].get("FdIOGetRoot", "cdecl")
    FdIOGetRoot.argtypes = []
    FdIOGetRoot.restype = POINTER(FdIO)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 119
if _libs["libPyFd.so"].has("FdIOGetCompressIn", "cdecl"):
    FdIOGetCompressIn = _libs["libPyFd.so"].get("FdIOGetCompressIn", "cdecl")
    FdIOGetCompressIn.argtypes = []
    FdIOGetCompressIn.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 120
if _libs["libPyFd.so"].has("FdIONew", "cdecl"):
    FdIONew = _libs["libPyFd.so"].get("FdIONew", "cdecl")
    FdIONew.argtypes = [c_int, POINTER(POINTER(c_char))]
    FdIONew.restype = POINTER(FdIO)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 121
if _libs["libPyFd.so"].has("FdIONewNoCfgIdle", "cdecl"):
    FdIONewNoCfgIdle = _libs["libPyFd.so"].get("FdIONewNoCfgIdle", "cdecl")
    FdIONewNoCfgIdle.argtypes = []
    FdIONewNoCfgIdle.restype = POINTER(FdIO)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 122
if _libs["libPyFd.so"].has("FdIOParseAndIni", "cdecl"):
    FdIOParseAndIni = _libs["libPyFd.so"].get("FdIOParseAndIni", "cdecl")
    FdIOParseAndIni.argtypes = [POINTER(FdIO)]
    FdIOParseAndIni.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 123
for _lib in _libs.values():
    if not _lib.has("FdIODataSenderRequest", "cdecl"):
        continue
    FdIODataSenderRequest = _lib.get("FdIODataSenderRequest", "cdecl")
    FdIODataSenderRequest.argtypes = [String, String, String, String, c_int, c_int]
    FdIODataSenderRequest.restype = None
    break

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 124
for _lib in _libs.values():
    if not _lib.has("FdIODataSenderWaitingTime", "cdecl"):
        continue
    FdIODataSenderWaitingTime = _lib.get("FdIODataSenderWaitingTime", "cdecl")
    FdIODataSenderWaitingTime.argtypes = [String, String, c_double]
    FdIODataSenderWaitingTime.restype = None
    break

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 125
for _lib in _libs.values():
    if not _lib.has("FdIOStat", "cdecl"):
        continue
    FdIOStat = _lib.get("FdIOStat", "cdecl")
    FdIOStat.argtypes = [POINTER(struct_FdIO), POINTER(FrameH)]
    FdIOStat.restype = None
    break

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 126
if _libs["libPyFd.so"].has("FdIOGetFrame", "cdecl"):
    FdIOGetFrame = _libs["libPyFd.so"].get("FdIOGetFrame", "cdecl")
    FdIOGetFrame.argtypes = [POINTER(FdIO)]
    FdIOGetFrame.restype = POINTER(FrameH)

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 127
if _libs["libPyFd.so"].has("FdIOPutFrame", "cdecl"):
    FdIOPutFrame = _libs["libPyFd.so"].get("FdIOPutFrame", "cdecl")
    FdIOPutFrame.argtypes = [POINTER(FdIO), POINTER(FrameH)]
    FdIOPutFrame.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 128
if _libs["libPyFd.so"].has("FdUpdateState", "cdecl"):
    FdUpdateState = _libs["libPyFd.so"].get("FdUpdateState", "cdecl")
    FdUpdateState.argtypes = [POINTER(FdIO), c_int]
    FdUpdateState.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 129
if _libs["libPyFd.so"].has("FdSetUserState", "cdecl"):
    FdSetUserState = _libs["libPyFd.so"].get("FdSetUserState", "cdecl")
    FdSetUserState.argtypes = [POINTER(FdIO), c_int]
    FdSetUserState.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 130
if _libs["libPyFd.so"].has("FdResizeAdd", "cdecl"):
    FdResizeAdd = _libs["libPyFd.so"].get("FdResizeAdd", "cdecl")
    FdResizeAdd.argtypes = [POINTER(POINTER(FdAction)), c_double, c_double]
    FdResizeAdd.restype = c_int

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 131
if _libs["libPyFd.so"].has("FdIOSetInputFrameDuration", "cdecl"):
    FdIOSetInputFrameDuration = _libs["libPyFd.so"].get("FdIOSetInputFrameDuration", "cdecl")
    FdIOSetInputFrameDuration.argtypes = [POINTER(FdIO), c_int]
    FdIOSetInputFrameDuration.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 132
if _libs["libPyFd.so"].has("FdOFileCheckPath", "cdecl"):
    FdOFileCheckPath = _libs["libPyFd.so"].get("FdOFileCheckPath", "cdecl")
    FdOFileCheckPath.argtypes = [String]
    FdOFileCheckPath.restype = None

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 133
if _libs["libPyFd.so"].has("FdStatBuild", "cdecl"):
    FdStatBuild = _libs["libPyFd.so"].get("FdStatBuild", "cdecl")
    FdStatBuild.argtypes = [POINTER(FdIO), POINTER(FrameH)]
    FdStatBuild.restype = None

# /usr/include/sys/stat.h: 210
for _lib in _libs.values():
    if not _lib.has("stat", "cdecl"):
        continue
    stat = _lib.get("stat", "cdecl")
    stat.argtypes = [String, POINTER(struct_stat)]
    stat.restype = c_int
    break

# /usr/include/sys/stat.h: 215
for _lib in _libs.values():
    if not _lib.has("fstat", "cdecl"):
        continue
    fstat = _lib.get("fstat", "cdecl")
    fstat.argtypes = [c_int, POINTER(struct_stat)]
    fstat.restype = c_int
    break

# /usr/include/sys/stat.h: 239
for _lib in _libs.values():
    if not _lib.has("fstatat", "cdecl"):
        continue
    fstatat = _lib.get("fstatat", "cdecl")
    fstatat.argtypes = [c_int, String, POINTER(struct_stat), c_int]
    fstatat.restype = c_int
    break

# /usr/include/sys/stat.h: 264
for _lib in _libs.values():
    if not _lib.has("lstat", "cdecl"):
        continue
    lstat = _lib.get("lstat", "cdecl")
    lstat.argtypes = [String, POINTER(struct_stat)]
    lstat.restype = c_int
    break

# /usr/include/sys/stat.h: 285
if _libs["libPyFd.so"].has("chmod", "cdecl"):
    chmod = _libs["libPyFd.so"].get("chmod", "cdecl")
    chmod.argtypes = [String, __mode_t]
    chmod.restype = c_int

# /usr/include/sys/stat.h: 292
if _libs["libPyFd.so"].has("lchmod", "cdecl"):
    lchmod = _libs["libPyFd.so"].get("lchmod", "cdecl")
    lchmod.argtypes = [String, __mode_t]
    lchmod.restype = c_int

# /usr/include/sys/stat.h: 298
if _libs["libPyFd.so"].has("fchmod", "cdecl"):
    fchmod = _libs["libPyFd.so"].get("fchmod", "cdecl")
    fchmod.argtypes = [c_int, __mode_t]
    fchmod.restype = c_int

# /usr/include/sys/stat.h: 304
if _libs["libPyFd.so"].has("fchmodat", "cdecl"):
    fchmodat = _libs["libPyFd.so"].get("fchmodat", "cdecl")
    fchmodat.argtypes = [c_int, String, __mode_t, c_int]
    fchmodat.restype = c_int

# /usr/include/sys/stat.h: 313
if _libs["libPyFd.so"].has("umask", "cdecl"):
    umask = _libs["libPyFd.so"].get("umask", "cdecl")
    umask.argtypes = [__mode_t]
    umask.restype = __mode_t

# /usr/include/sys/stat.h: 322
if _libs["libPyFd.so"].has("mkdir", "cdecl"):
    mkdir = _libs["libPyFd.so"].get("mkdir", "cdecl")
    mkdir.argtypes = [String, __mode_t]
    mkdir.restype = c_int

# /usr/include/sys/stat.h: 329
if _libs["libPyFd.so"].has("mkdirat", "cdecl"):
    mkdirat = _libs["libPyFd.so"].get("mkdirat", "cdecl")
    mkdirat.argtypes = [c_int, String, __mode_t]
    mkdirat.restype = c_int

# /usr/include/sys/stat.h: 337
for _lib in _libs.values():
    if not _lib.has("mknod", "cdecl"):
        continue
    mknod = _lib.get("mknod", "cdecl")
    mknod.argtypes = [String, __mode_t, __dev_t]
    mknod.restype = c_int
    break

# /usr/include/sys/stat.h: 344
for _lib in _libs.values():
    if not _lib.has("mknodat", "cdecl"):
        continue
    mknodat = _lib.get("mknodat", "cdecl")
    mknodat.argtypes = [c_int, String, __mode_t, __dev_t]
    mknodat.restype = c_int
    break

# /usr/include/sys/stat.h: 351
if _libs["libPyFd.so"].has("mkfifo", "cdecl"):
    mkfifo = _libs["libPyFd.so"].get("mkfifo", "cdecl")
    mkfifo.argtypes = [String, __mode_t]
    mkfifo.restype = c_int

# /usr/include/sys/stat.h: 358
if _libs["libPyFd.so"].has("mkfifoat", "cdecl"):
    mkfifoat = _libs["libPyFd.so"].get("mkfifoat", "cdecl")
    mkfifoat.argtypes = [c_int, String, __mode_t]
    mkfifoat.restype = c_int

# /usr/include/sys/stat.h: 365
if _libs["libPyFd.so"].has("utimensat", "cdecl"):
    utimensat = _libs["libPyFd.so"].get("utimensat", "cdecl")
    utimensat.argtypes = [c_int, String, struct_timespec * int(2), c_int]
    utimensat.restype = c_int

# /usr/include/sys/stat.h: 373
if _libs["libPyFd.so"].has("futimens", "cdecl"):
    futimens = _libs["libPyFd.so"].get("futimens", "cdecl")
    futimens.argtypes = [c_int, struct_timespec * int(2)]
    futimens.restype = c_int

# /usr/include/sys/stat.h: 400
if _libs["libPyFd.so"].has("__fxstat", "cdecl"):
    __fxstat = _libs["libPyFd.so"].get("__fxstat", "cdecl")
    __fxstat.argtypes = [c_int, c_int, POINTER(struct_stat)]
    __fxstat.restype = c_int

# /usr/include/sys/stat.h: 402
if _libs["libPyFd.so"].has("__xstat", "cdecl"):
    __xstat = _libs["libPyFd.so"].get("__xstat", "cdecl")
    __xstat.argtypes = [c_int, String, POINTER(struct_stat)]
    __xstat.restype = c_int

# /usr/include/sys/stat.h: 404
if _libs["libPyFd.so"].has("__lxstat", "cdecl"):
    __lxstat = _libs["libPyFd.so"].get("__lxstat", "cdecl")
    __lxstat.argtypes = [c_int, String, POINTER(struct_stat)]
    __lxstat.restype = c_int

# /usr/include/sys/stat.h: 406
if _libs["libPyFd.so"].has("__fxstatat", "cdecl"):
    __fxstatat = _libs["libPyFd.so"].get("__fxstatat", "cdecl")
    __fxstatat.argtypes = [c_int, c_int, String, POINTER(struct_stat), c_int]
    __fxstatat.restype = c_int

# /usr/include/sys/stat.h: 443
if _libs["libPyFd.so"].has("__xmknod", "cdecl"):
    __xmknod = _libs["libPyFd.so"].get("__xmknod", "cdecl")
    __xmknod.argtypes = [c_int, String, __mode_t, POINTER(__dev_t)]
    __xmknod.restype = c_int

# /usr/include/sys/stat.h: 446
if _libs["libPyFd.so"].has("__xmknodat", "cdecl"):
    __xmknodat = _libs["libPyFd.so"].get("__xmknodat", "cdecl")
    __xmknodat.argtypes = [c_int, c_int, String, __mode_t, POINTER(__dev_t)]
    __xmknodat.restype = c_int

# /usr/include/bits/errno.h: 50
if _libs["libPyFd.so"].has("__errno_location", "cdecl"):
    __errno_location = _libs["libPyFd.so"].get("__errno_location", "cdecl")
    __errno_location.argtypes = []
    __errno_location.restype = POINTER(c_int)

# /users/poulton/packages/Fd/v9r0/src/FdIDir.h: 14
class struct_FdIDir(Structure):
    pass

FdIDir = struct_FdIDir# /users/poulton/packages/Fd/v9r0/src/FdIDir.h: 12

struct_FdIDir.__slots__ = [
    'nextFile',
    'tStart',
    'tNextFrame',
    'dtFile',
    'nFramesPerSec',
    'lastMtimeS',
    'lastMtimeN',
    'timeLastFrame',
    'nPrint',
    'nWarningsPrfx',
    'scanMode',
    'dirName',
    'prefix',
    'frameInfo',
    'lastRead',
    'openError',
    'noFileError',
    'iFile',
    'action',
    'next',
]
struct_FdIDir._fields_ = [
    ('nextFile', String),
    ('tStart', FRLONG),
    ('tNextFrame', FRLONG),
    ('dtFile', FRLONG),
    ('nFramesPerSec', c_int),
    ('lastMtimeS', c_int),
    ('lastMtimeN', c_int),
    ('timeLastFrame', c_int),
    ('nPrint', c_int),
    ('nWarningsPrfx', c_int),
    ('scanMode', c_int),
    ('dirName', String),
    ('prefix', String),
    ('frameInfo', String),
    ('lastRead', FRBOOL),
    ('openError', FRBOOL),
    ('noFileError', FRBOOL),
    ('iFile', POINTER(FrFile)),
    ('action', POINTER(FdAction)),
    ('next', POINTER(FdIDir)),
]

# /users/poulton/packages/Fd/v9r0/src/FdIDir.h: 37
if _libs["libPyFd.so"].has("FdIDirNew", "cdecl"):
    FdIDirNew = _libs["libPyFd.so"].get("FdIDirNew", "cdecl")
    FdIDirNew.argtypes = [String, c_int]
    FdIDirNew.restype = POINTER(FdIDir)

# /users/poulton/packages/Fd/v9r0/src/FdIDir.h: 38
if _libs["libPyFd.so"].has("FdIDirProcessOne", "cdecl"):
    FdIDirProcessOne = _libs["libPyFd.so"].get("FdIDirProcessOne", "cdecl")
    FdIDirProcessOne.argtypes = [POINTER(FdIDir), c_int]
    FdIDirProcessOne.restype = POINTER(FrameH)

# /users/poulton/packages/PyFd/v4r2/src/FdIOBuf.h: 7
if _libs["libPyFd.so"].has("FdIFrameFromBuf", "cdecl"):
    FdIFrameFromBuf = _libs["libPyFd.so"].get("FdIFrameFromBuf", "cdecl")
    FdIFrameFromBuf.argtypes = [POINTER(FdIO), String, FRLONG, c_int]
    FdIFrameFromBuf.restype = POINTER(FrameH)

# <built-in>
try:
    __CHAR_BIT__ = 8
except:
    pass

# <built-in>
try:
    __SCHAR_MAX__ = 127
except:
    pass

# <built-in>
try:
    __SHRT_MAX__ = 32767
except:
    pass

# <built-in>
try:
    __INT_MAX__ = 2147483647
except:
    pass

# <built-in>
try:
    __LONG_MAX__ = 9.223372036854776e+18
except:
    pass

__const = c_int# <command-line>: 4

# <command-line>: 7
try:
    CTYPESGEN = 1
except:
    pass

# /usr/include/stdc-predef.h: 19
try:
    _STDC_PREDEF_H = 1
except:
    pass

# /usr/include/stdc-predef.h: 30
try:
    __STDC_IEC_559__ = 1
except:
    pass

# /usr/include/stdc-predef.h: 31
try:
    __STDC_IEC_559_COMPLEX__ = 1
except:
    pass

# /usr/include/stdc-predef.h: 35
try:
    __STDC_ISO_10646__ = 201103.0
except:
    pass

# /usr/include/stdc-predef.h: 38
try:
    __STDC_NO_THREADS__ = 1
except:
    pass

# /usr/include/sys/types.h: 23
try:
    _SYS_TYPES_H = 1
except:
    pass

# /usr/include/features.h: 19
try:
    _FEATURES_H = 1
except:
    pass

# /usr/include/features.h: 133
try:
    __USE_ANSI = 1
except:
    pass

# /usr/include/features.h: 146
def __GNUC_PREREQ(maj, min):
    return 0

# /usr/include/features.h: 188
try:
    _BSD_SOURCE = 1
except:
    pass

# /usr/include/features.h: 189
try:
    _SVID_SOURCE = 1
except:
    pass

# /usr/include/features.h: 223
try:
    _POSIX_SOURCE = 1
except:
    pass

# /usr/include/features.h: 231
try:
    _POSIX_C_SOURCE = 200809.0
except:
    pass

# /usr/include/features.h: 233
try:
    __USE_POSIX_IMPLICITLY = 1
except:
    pass

# /usr/include/features.h: 237
try:
    __USE_POSIX = 1
except:
    pass

# /usr/include/features.h: 241
try:
    __USE_POSIX2 = 1
except:
    pass

# /usr/include/features.h: 245
try:
    __USE_POSIX199309 = 1
except:
    pass

# /usr/include/features.h: 249
try:
    __USE_POSIX199506 = 1
except:
    pass

# /usr/include/features.h: 253
try:
    __USE_XOPEN2K = 1
except:
    pass

# /usr/include/features.h: 255
try:
    __USE_ISOC95 = 1
except:
    pass

# /usr/include/features.h: 257
try:
    __USE_ISOC99 = 1
except:
    pass

# /usr/include/features.h: 261
try:
    __USE_XOPEN2K8 = 1
except:
    pass

# /usr/include/features.h: 263
try:
    _ATFILE_SOURCE = 1
except:
    pass

# /usr/include/features.h: 305
try:
    __USE_MISC = 1
except:
    pass

# /usr/include/features.h: 309
try:
    __USE_BSD = 1
except:
    pass

# /usr/include/features.h: 313
try:
    __USE_SVID = 1
except:
    pass

# /usr/include/features.h: 317
try:
    __USE_ATFILE = 1
except:
    pass

# /usr/include/features.h: 340
try:
    __USE_FORTIFY_LEVEL = 0
except:
    pass

# /usr/include/features.h: 354
try:
    __GNU_LIBRARY__ = 6
except:
    pass

# /usr/include/features.h: 358
try:
    __GLIBC__ = 2
except:
    pass

# /usr/include/features.h: 359
try:
    __GLIBC_MINOR__ = 17
except:
    pass

# /usr/include/features.h: 361
def __GLIBC_PREREQ(maj, min):
    return (((__GLIBC__ << 16) + __GLIBC_MINOR__) >= ((maj << 16) + min))

# /usr/include/sys/cdefs.h: 20
try:
    _SYS_CDEFS_H = 1
except:
    pass

# /usr/include/sys/cdefs.h: 77
def __NTH(fct):
    return fct

# /usr/include/sys/cdefs.h: 83
def __P(args):
    return args

# /usr/include/sys/cdefs.h: 84
def __PMT(args):
    return args

# /usr/include/sys/cdefs.h: 90
def __STRING(x):
    return x

__ptr_t = POINTER(None)# /usr/include/sys/cdefs.h: 93

__long_double_t = c_longdouble# /usr/include/sys/cdefs.h: 94

# /usr/include/sys/cdefs.h: 388
def __glibc_unlikely(cond):
    return cond

# /usr/include/sys/cdefs.h: 389
def __glibc_likely(cond):
    return cond

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/sys/cdefs.h: 414
def __LDBL_REDIR1(name, proto, alias):
    return (name + proto)

# /usr/include/sys/cdefs.h: 415
def __LDBL_REDIR(name, proto):
    return (name + proto)

# /usr/include/bits/types.h: 24
try:
    _BITS_TYPES_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

__S16_TYPE = c_int# /usr/include/bits/types.h: 98

__U16_TYPE = c_uint# /usr/include/bits/types.h: 99

__S32_TYPE = c_int# /usr/include/bits/types.h: 100

__U32_TYPE = c_uint# /usr/include/bits/types.h: 101

__SLONGWORD_TYPE = c_long# /usr/include/bits/types.h: 102

__ULONGWORD_TYPE = c_ulong# /usr/include/bits/types.h: 103

__SQUAD_TYPE = c_long# /usr/include/bits/types.h: 117

__UQUAD_TYPE = c_ulong# /usr/include/bits/types.h: 118

__SWORD_TYPE = c_long# /usr/include/bits/types.h: 119

__UWORD_TYPE = c_ulong# /usr/include/bits/types.h: 120

__SLONG32_TYPE = c_int# /usr/include/bits/types.h: 121

__ULONG32_TYPE = c_uint# /usr/include/bits/types.h: 122

__S64_TYPE = c_long# /usr/include/bits/types.h: 123

__U64_TYPE = c_ulong# /usr/include/bits/types.h: 124

# /usr/include/bits/typesizes.h: 24
try:
    _BITS_TYPESIZES_H = 1
except:
    pass

__TIMER_T_TYPE = POINTER(None)# /usr/include/bits/typesizes.h: 70

# /usr/include/bits/typesizes.h: 72
class struct_anon_90(Structure):
    pass

struct_anon_90.__slots__ = [
    '__val',
]
struct_anon_90._fields_ = [
    ('__val', c_int * int(2)),
]

__FSID_T_TYPE = struct_anon_90# /usr/include/bits/typesizes.h: 72

# /usr/include/bits/typesizes.h: 79
try:
    __OFF_T_MATCHES_OFF64_T = 1
except:
    pass

# /usr/include/bits/typesizes.h: 82
try:
    __INO_T_MATCHES_INO64_T = 1
except:
    pass

# /usr/include/bits/typesizes.h: 86
try:
    __FD_SETSIZE = 1024
except:
    pass

# /usr/include/time.h: 53
try:
    __clock_t_defined = 1
except:
    pass

# /usr/include/time.h: 69
try:
    __time_t_defined = 1
except:
    pass

# /usr/include/time.h: 86
try:
    __clockid_t_defined = 1
except:
    pass

# /usr/include/time.h: 98
try:
    __timer_t_defined = 1
except:
    pass

# /usr/include/sys/types.h: 211
try:
    __BIT_TYPES_DEFINED__ = 1
except:
    pass

# /usr/include/endian.h: 19
try:
    _ENDIAN_H = 1
except:
    pass

# /usr/include/endian.h: 31
try:
    __LITTLE_ENDIAN = 1234
except:
    pass

# /usr/include/endian.h: 32
try:
    __BIG_ENDIAN = 4321
except:
    pass

# /usr/include/endian.h: 33
try:
    __PDP_ENDIAN = 3412
except:
    pass

# /usr/include/bits/endian.h: 7
try:
    __BYTE_ORDER = __LITTLE_ENDIAN
except:
    pass

# /usr/include/endian.h: 41
try:
    __FLOAT_WORD_ORDER = __BYTE_ORDER
except:
    pass

# /usr/include/endian.h: 45
try:
    LITTLE_ENDIAN = __LITTLE_ENDIAN
except:
    pass

# /usr/include/endian.h: 46
try:
    BIG_ENDIAN = __BIG_ENDIAN
except:
    pass

# /usr/include/endian.h: 47
try:
    PDP_ENDIAN = __PDP_ENDIAN
except:
    pass

# /usr/include/endian.h: 48
try:
    BYTE_ORDER = __BYTE_ORDER
except:
    pass

# /usr/include/bits/byteswap.h: 24
try:
    _BITS_BYTESWAP_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/byteswap.h: 31
def __bswap_constant_16(x):
    return (c_uint (ord_if_char((((x >> 8) & 255) | ((x & 255) << 8))))).value

# /usr/include/bits/byteswap.h: 38
def __bswap_constant_32(x):
    return (((((x & 4278190080) >> 24) | ((x & 16711680) >> 8)) | ((x & 65280) << 8)) | ((x & 255) << 24))

# /usr/include/endian.h: 64
def htole16(x):
    return x

# /usr/include/endian.h: 66
def le16toh(x):
    return x

# /usr/include/endian.h: 69
def htole32(x):
    return x

# /usr/include/endian.h: 71
def le32toh(x):
    return x

# /usr/include/sys/select.h: 22
try:
    _SYS_SELECT_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/select.h: 58
def __FD_SET(d, set):
    return None

# /usr/include/bits/select.h: 60
def __FD_CLR(d, set):
    return None

# /usr/include/bits/select.h: 62
def __FD_ISSET(d, set):
    return ((((__FDS_BITS (set)) [(__FD_ELT (d))]) & (__FD_MASK (d))) != 0)

# /usr/include/bits/sigset.h: 21
try:
    _SIGSET_H_types = 1
except:
    pass

# /usr/include/bits/sigset.h: 27
try:
    _SIGSET_NWORDS = (1024 / (8 * sizeof(c_ulong)))
except:
    pass

# /usr/include/time.h: 114
try:
    __timespec_defined = 1
except:
    pass

# /usr/include/bits/time.h: 25
try:
    _STRUCT_TIMEVAL = 1
except:
    pass

# /usr/include/sys/select.h: 59
try:
    __NFDBITS = (8 * (c_int (ord_if_char(sizeof(__fd_mask)))).value)
except:
    pass

# /usr/include/sys/select.h: 60
def __FD_ELT(d):
    return (d / __NFDBITS)

# /usr/include/sys/select.h: 61
def __FD_MASK(d):
    return ((__fd_mask (ord_if_char(1))).value << (d % __NFDBITS))

# /usr/include/sys/select.h: 73
def __FDS_BITS(set):
    return (set.contents.__fds_bits)

# /usr/include/sys/select.h: 78
try:
    FD_SETSIZE = __FD_SETSIZE
except:
    pass

# /usr/include/sys/select.h: 85
try:
    NFDBITS = __NFDBITS
except:
    pass

# /usr/include/sys/select.h: 90
def FD_SET(fd, fdsetp):
    return (__FD_SET (fd, fdsetp))

# /usr/include/sys/select.h: 91
def FD_CLR(fd, fdsetp):
    return (__FD_CLR (fd, fdsetp))

# /usr/include/sys/select.h: 92
def FD_ISSET(fd, fdsetp):
    return (__FD_ISSET (fd, fdsetp))

# /usr/include/sys/sysmacros.h: 21
try:
    _SYS_SYSMACROS_H = 1
except:
    pass

# /usr/include/bits/pthreadtypes.h: 19
try:
    _BITS_PTHREADTYPES_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/pthreadtypes.h: 25
try:
    __SIZEOF_PTHREAD_ATTR_T = 56
except:
    pass

# /usr/include/bits/pthreadtypes.h: 26
try:
    __SIZEOF_PTHREAD_MUTEX_T = 40
except:
    pass

# /usr/include/bits/pthreadtypes.h: 27
try:
    __SIZEOF_PTHREAD_MUTEXATTR_T = 4
except:
    pass

# /usr/include/bits/pthreadtypes.h: 28
try:
    __SIZEOF_PTHREAD_COND_T = 48
except:
    pass

# /usr/include/bits/pthreadtypes.h: 29
try:
    __SIZEOF_PTHREAD_CONDATTR_T = 4
except:
    pass

# /usr/include/bits/pthreadtypes.h: 30
try:
    __SIZEOF_PTHREAD_RWLOCK_T = 56
except:
    pass

# /usr/include/bits/pthreadtypes.h: 31
try:
    __SIZEOF_PTHREAD_RWLOCKATTR_T = 8
except:
    pass

# /usr/include/bits/pthreadtypes.h: 32
try:
    __SIZEOF_PTHREAD_BARRIER_T = 32
except:
    pass

# /usr/include/bits/pthreadtypes.h: 33
try:
    __SIZEOF_PTHREAD_BARRIERATTR_T = 4
except:
    pass

# /usr/include/bits/pthreadtypes.h: 70
try:
    __have_pthread_attr_t = 1
except:
    pass

# /usr/include/bits/pthreadtypes.h: 107
try:
    __PTHREAD_MUTEX_HAVE_PREV = 1
except:
    pass

# /usr/include/bits/pthreadtypes.h: 192
try:
    __PTHREAD_RWLOCK_INT_FLAGS_SHARED = 1
except:
    pass

# /usr/include/pthread.h: 19
try:
    _PTHREAD_H = 1
except:
    pass

# /usr/include/sched.h: 21
try:
    _SCHED_H = 1
except:
    pass

# /usr/include/bits/sched.h: 29
try:
    SCHED_OTHER = 0
except:
    pass

# /usr/include/bits/sched.h: 30
try:
    SCHED_FIFO = 1
except:
    pass

# /usr/include/bits/sched.h: 31
try:
    SCHED_RR = 2
except:
    pass

# /usr/include/bits/sched.h: 102
try:
    __defined_schedparam = 1
except:
    pass

# /usr/include/bits/sched.h: 115
try:
    __CPU_SETSIZE = 1024
except:
    pass

# /usr/include/bits/sched.h: 116
try:
    __NCPUBITS = (8 * sizeof(__cpu_mask))
except:
    pass

# /usr/include/bits/sched.h: 122
def __CPUELT(cpu):
    return (cpu / __NCPUBITS)

# /usr/include/bits/sched.h: 123
def __CPUMASK(cpu):
    return ((__cpu_mask (ord_if_char(1))).value << (cpu % __NCPUBITS))

# /usr/include/bits/sched.h: 167
def __CPU_COUNT_S(setsize, cpusetp):
    return (__sched_cpucount (setsize, cpusetp))

# /usr/include/bits/sched.h: 197
def __CPU_ALLOC_SIZE(count):
    return ((((count + __NCPUBITS) - 1) / __NCPUBITS) * sizeof(__cpu_mask))

# /usr/include/bits/sched.h: 199
def __CPU_ALLOC(count):
    return (__sched_cpualloc (count))

# /usr/include/bits/sched.h: 200
def __CPU_FREE(cpuset):
    return (__sched_cpufree (cpuset))

# /usr/include/time.h: 26
try:
    _TIME_H = 1
except:
    pass

# /usr/include/bits/time.h: 40
try:
    _BITS_TIME_H = 1
except:
    pass

# /usr/include/bits/time.h: 48
try:
    CLOCKS_PER_SEC = 1000000.0
except:
    pass

# /usr/include/bits/time.h: 61
try:
    CLOCK_REALTIME = 0
except:
    pass

# /usr/include/bits/time.h: 63
try:
    CLOCK_MONOTONIC = 1
except:
    pass

# /usr/include/bits/time.h: 65
try:
    CLOCK_PROCESS_CPUTIME_ID = 2
except:
    pass

# /usr/include/bits/time.h: 67
try:
    CLOCK_THREAD_CPUTIME_ID = 3
except:
    pass

# /usr/include/bits/time.h: 69
try:
    CLOCK_MONOTONIC_RAW = 4
except:
    pass

# /usr/include/bits/time.h: 71
try:
    CLOCK_REALTIME_COARSE = 5
except:
    pass

# /usr/include/bits/time.h: 73
try:
    CLOCK_MONOTONIC_COARSE = 6
except:
    pass

# /usr/include/bits/time.h: 75
try:
    CLOCK_BOOTTIME = 7
except:
    pass

# /usr/include/bits/time.h: 77
try:
    CLOCK_REALTIME_ALARM = 8
except:
    pass

# /usr/include/bits/time.h: 79
try:
    CLOCK_BOOTTIME_ALARM = 9
except:
    pass

# /usr/include/bits/time.h: 81
try:
    CLOCK_TAI = 11
except:
    pass

# /usr/include/bits/time.h: 84
try:
    TIMER_ABSTIME = 1
except:
    pass

# /usr/include/xlocale.h: 21
try:
    _XLOCALE_H = 1
except:
    pass

# /usr/include/time.h: 310
def __isleap(year):
    return (((year % 4) == 0) and (((year % 100) != 0) or ((year % 400) == 0)))

# /usr/include/bits/setjmp.h: 20
try:
    _BITS_SETJMP_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/pthread.h: 35
try:
    PTHREAD_CREATE_JOINABLE = PTHREAD_CREATE_JOINABLE
except:
    pass

# /usr/include/pthread.h: 37
try:
    PTHREAD_CREATE_DETACHED = PTHREAD_CREATE_DETACHED
except:
    pass

# /usr/include/pthread.h: 160
try:
    PTHREAD_INHERIT_SCHED = PTHREAD_INHERIT_SCHED
except:
    pass

# /usr/include/pthread.h: 162
try:
    PTHREAD_EXPLICIT_SCHED = PTHREAD_EXPLICIT_SCHED
except:
    pass

# /usr/include/pthread.h: 170
try:
    PTHREAD_SCOPE_SYSTEM = PTHREAD_SCOPE_SYSTEM
except:
    pass

# /usr/include/pthread.h: 172
try:
    PTHREAD_SCOPE_PROCESS = PTHREAD_SCOPE_PROCESS
except:
    pass

# /usr/include/pthread.h: 180
try:
    PTHREAD_PROCESS_PRIVATE = PTHREAD_PROCESS_PRIVATE
except:
    pass

# /usr/include/pthread.h: 182
try:
    PTHREAD_PROCESS_SHARED = PTHREAD_PROCESS_SHARED
except:
    pass

# /usr/include/pthread.h: 204
try:
    PTHREAD_CANCEL_ENABLE = PTHREAD_CANCEL_ENABLE
except:
    pass

# /usr/include/pthread.h: 206
try:
    PTHREAD_CANCEL_DISABLE = PTHREAD_CANCEL_DISABLE
except:
    pass

# /usr/include/pthread.h: 211
try:
    PTHREAD_CANCEL_DEFERRED = PTHREAD_CANCEL_DEFERRED
except:
    pass

# /usr/include/pthread.h: 213
try:
    PTHREAD_CANCEL_ASYNCHRONOUS = PTHREAD_CANCEL_ASYNCHRONOUS
except:
    pass

# /usr/include/pthread.h: 215
try:
    PTHREAD_CANCELED = cast((-1), POINTER(None))
except:
    pass

# /usr/include/pthread.h: 219
try:
    PTHREAD_ONCE_INIT = 0
except:
    pass

# /usr/include/pthread.h: 226
try:
    PTHREAD_BARRIER_SERIAL_THREAD = (-1)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 36
def XSTR(s):
    return (STR (s))

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 37
def STR(s):
    return s

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 46
try:
    CBF_OK = 0
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 47
try:
    CBF_FAIL = (-1)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 48
try:
    CBF_EXIT = (-2)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfHeader.h: 49
try:
    CBF_CONTINUE = (-3)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfHash.h: 40
try:
    CBFHROOT = (-1)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CbfClean.h: 37
try:
    CBFCLEAN_MAX = 128
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 43
try:
    CFG_OK = CBF_OK
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 44
try:
    CFG_FAIL = CBF_FAIL
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 45
try:
    CFG_EXIT = CBF_EXIT
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgHeader.h: 46
try:
    CFG_CONTINUE = CBF_CONTINUE
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgList.h: 59
try:
    CFG_NAME_SORT_NUMBER = ((CFG_NAME_SORT_LAST - CFG_NAME_SORT_FIRST) + 1)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgList.h: 80
def CfgNameListSize(names):
    return (names.contents.size)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 81
def CfgNameListSortOption(names):
    return (names.contents.sort)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 83
def CfgNameListName(names, num):
    return (((names.contents.list) [num]).name)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 84
def CfgNameListVData(names, num):
    return (((names.contents.list) [num]).vData)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 85
def CfgNameListIData(names, num):
    return (((names.contents.list) [num]).iData)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 86
def CfgNameListDData(names, num):
    return (((names.contents.list) [num]).dData)

# /virgoApp/Cfg/v9r0/src/CfgList.h: 116
try:
    CfgNameListRemove = CfgNameListRemoveName
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgList.h: 117
def CfgNameListNumber(names):
    return names and (names.contents.size) or CFG_FAIL

# /virgoApp/Cfg/v9r0/src/CfgList.h: 118
def CfgNameListEmpty(names):
    return (names and (names.contents.size)) and 0 or 1

# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 49
try:
    CFG_MSG_BUF_SIZE = 4096
except:
    pass

# /virgoApp/Cm/v9r0/src/GC.h: 54
def GCReferenceAssignIn(loc, container, object):
    return (GCReferenceSet (cast(pointer(loc), POINTER(POINTER(None))), container, object))

# /virgoApp/Cm/v9r0/src/CmConnect.h: 101
try:
    CmConnectInstallDisconnectionHandler = CmConnectInstallDHandler
except:
    pass

# /virgoApp/Cm/v9r0/src/CmConnect.h: 102
try:
    CmConnectInstallConnectionHandler = CmConnectInstallCHandler
except:
    pass

# /virgoApp/Cm/v9r0/src/CmConnect.h: 103
try:
    CmConnectStartupAsMultipleServer = CmConnectStartupAsMS
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 37
try:
    CFG_NO_ARG = (-3)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 38
try:
    CFG_KEY_ATTRIBUTE = 4207852222
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 39
try:
    CFG_KEY = 3135168173
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 40
try:
    CFG_NONE_KEY = 4294967295
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 41
try:
    CFG_MAX_ATTR = 128
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 42
try:
    CFG_MAX_STACK = (CFG_MAX_ATTR + 4)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 43
try:
    CFG_MAX_HENUM = 256
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 44
try:
    CFG_DSIZE = (sizeof(c_double) / sizeof(Ulong))
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 45
try:
    CFG_MAX_NAME = 256
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 46
try:
    CFG_MAXPATHLEN = 1024
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 48
def CFG_VA_LIST_IDX(idx, narg):
    return (-((idx << 16) | (narg & 65535)))

# /virgoApp/Cfg/v9r0/src/CfgParse.h: 49
try:
    CFG_VA_LIST = (CFG_VA_LIST_IDX (1, 1))
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 55
try:
    CFGOUT_TCP_TMO = (-1.0)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 56
try:
    CFGOUT_INPROGRESS = CFG_CONTINUE
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 57
try:
    CFGOUT_CSM_ADD_TYPE = 'CFGOUT_CSM_ADD'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 58
try:
    CFGOUT_CSM_RM_TYPE = 'CFGOUT_CSM_RM'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 59
try:
    CFGOUT_GRP_ADD_TYPE = 'CFGOUT_GRP_ADD'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgOut.h: 60
try:
    CFGOUT_GRP_RM_TYPE = 'CFGOUT_GRP_RM'
except:
    pass

# /usr/include/stdio.h: 26
try:
    _STDIO_H = 1
except:
    pass

# /usr/include/stdio.h: 56
try:
    __FILE_defined = 1
except:
    pass

# /usr/include/stdio.h: 66
try:
    ____FILE_defined = 1
except:
    pass

# /usr/include/_G_config.h: 5
try:
    _G_config_h = 1
except:
    pass

# /usr/include/wchar.h: 80
try:
    ____mbstate_t_defined = 1
except:
    pass

# /usr/include/_G_config.h: 48
try:
    _G_HAVE_MMAP = 1
except:
    pass

# /usr/include/_G_config.h: 49
try:
    _G_HAVE_MREMAP = 1
except:
    pass

# /usr/include/_G_config.h: 51
try:
    _G_IO_IO_FILE_VERSION = 131073
except:
    pass

# /usr/include/_G_config.h: 56
try:
    _G_BUFSIZ = 8192
except:
    pass

_IO_fpos_t = _G_fpos_t# /usr/include/libio.h: 34

_IO_fpos64_t = _G_fpos64_t# /usr/include/libio.h: 35

_IO_size_t = c_size_t# /usr/include/libio.h: 36

_IO_ssize_t = __ssize_t# /usr/include/libio.h: 37

_IO_off_t = __off_t# /usr/include/libio.h: 38

_IO_off64_t = __off64_t# /usr/include/libio.h: 39

_IO_pid_t = __pid_t# /usr/include/libio.h: 40

_IO_uid_t = __uid_t# /usr/include/libio.h: 41

# /usr/include/libio.h: 44
try:
    _IO_BUFSIZ = _G_BUFSIZ
except:
    pass

# /usr/include/libio.h: 60
try:
    _IO_UNIFIED_JUMPTABLES = 1
except:
    pass

# /usr/include/libio.h: 63
try:
    EOF = (-1)
except:
    pass

# /usr/include/libio.h: 78
try:
    _IOS_INPUT = 1
except:
    pass

# /usr/include/libio.h: 79
try:
    _IOS_OUTPUT = 2
except:
    pass

# /usr/include/libio.h: 80
try:
    _IOS_ATEND = 4
except:
    pass

# /usr/include/libio.h: 81
try:
    _IOS_APPEND = 8
except:
    pass

# /usr/include/libio.h: 82
try:
    _IOS_TRUNC = 16
except:
    pass

# /usr/include/libio.h: 83
try:
    _IOS_NOCREATE = 32
except:
    pass

# /usr/include/libio.h: 84
try:
    _IOS_NOREPLACE = 64
except:
    pass

# /usr/include/libio.h: 85
try:
    _IOS_BIN = 128
except:
    pass

# /usr/include/libio.h: 93
try:
    _IO_MAGIC = 4222418944
except:
    pass

# /usr/include/libio.h: 94
try:
    _OLD_STDIO_MAGIC = 4206624768
except:
    pass

# /usr/include/libio.h: 95
try:
    _IO_MAGIC_MASK = 4294901760
except:
    pass

# /usr/include/libio.h: 96
try:
    _IO_USER_BUF = 1
except:
    pass

# /usr/include/libio.h: 97
try:
    _IO_UNBUFFERED = 2
except:
    pass

# /usr/include/libio.h: 98
try:
    _IO_NO_READS = 4
except:
    pass

# /usr/include/libio.h: 99
try:
    _IO_NO_WRITES = 8
except:
    pass

# /usr/include/libio.h: 100
try:
    _IO_EOF_SEEN = 16
except:
    pass

# /usr/include/libio.h: 101
try:
    _IO_ERR_SEEN = 32
except:
    pass

# /usr/include/libio.h: 102
try:
    _IO_DELETE_DONT_CLOSE = 64
except:
    pass

# /usr/include/libio.h: 103
try:
    _IO_LINKED = 128
except:
    pass

# /usr/include/libio.h: 104
try:
    _IO_IN_BACKUP = 256
except:
    pass

# /usr/include/libio.h: 105
try:
    _IO_LINE_BUF = 512
except:
    pass

# /usr/include/libio.h: 106
try:
    _IO_TIED_PUT_GET = 1024
except:
    pass

# /usr/include/libio.h: 107
try:
    _IO_CURRENTLY_PUTTING = 2048
except:
    pass

# /usr/include/libio.h: 108
try:
    _IO_IS_APPENDING = 4096
except:
    pass

# /usr/include/libio.h: 109
try:
    _IO_IS_FILEBUF = 8192
except:
    pass

# /usr/include/libio.h: 110
try:
    _IO_BAD_SEEN = 16384
except:
    pass

# /usr/include/libio.h: 111
try:
    _IO_USER_LOCK = 32768
except:
    pass

# /usr/include/libio.h: 113
try:
    _IO_FLAGS2_MMAP = 1
except:
    pass

# /usr/include/libio.h: 114
try:
    _IO_FLAGS2_NOTCANCEL = 2
except:
    pass

# /usr/include/libio.h: 118
try:
    _IO_FLAGS2_USER_WBUF = 8
except:
    pass

# /usr/include/libio.h: 126
try:
    _IO_SKIPWS = 1
except:
    pass

# /usr/include/libio.h: 127
try:
    _IO_LEFT = 2
except:
    pass

# /usr/include/libio.h: 128
try:
    _IO_RIGHT = 4
except:
    pass

# /usr/include/libio.h: 129
try:
    _IO_INTERNAL = 10
except:
    pass

# /usr/include/libio.h: 130
try:
    _IO_DEC = 20
except:
    pass

# /usr/include/libio.h: 131
try:
    _IO_OCT = 40
except:
    pass

# /usr/include/libio.h: 132
try:
    _IO_HEX = 100
except:
    pass

# /usr/include/libio.h: 133
try:
    _IO_SHOWBASE = 200
except:
    pass

# /usr/include/libio.h: 134
try:
    _IO_SHOWPOINT = 400
except:
    pass

# /usr/include/libio.h: 135
try:
    _IO_UPPERCASE = 1000
except:
    pass

# /usr/include/libio.h: 136
try:
    _IO_SHOWPOS = 2000
except:
    pass

# /usr/include/libio.h: 137
try:
    _IO_SCIENTIFIC = 4000
except:
    pass

# /usr/include/libio.h: 138
try:
    _IO_FIXED = 10000
except:
    pass

# /usr/include/libio.h: 139
try:
    _IO_UNITBUF = 20000
except:
    pass

# /usr/include/libio.h: 140
try:
    _IO_STDIO = 40000
except:
    pass

# /usr/include/libio.h: 141
try:
    _IO_DONT_CLOSE = 100000
except:
    pass

# /usr/include/libio.h: 142
try:
    _IO_BOOLALPHA = 200000
except:
    pass

# /usr/include/libio.h: 325
try:
    _IO_stdin = cast(pointer(_IO_2_1_stdin_), POINTER(_IO_FILE))
except:
    pass

# /usr/include/libio.h: 326
try:
    _IO_stdout = cast(pointer(_IO_2_1_stdout_), POINTER(_IO_FILE))
except:
    pass

# /usr/include/libio.h: 327
try:
    _IO_stderr = cast(pointer(_IO_2_1_stderr_), POINTER(_IO_FILE))
except:
    pass

# /usr/include/libio.h: 403
def _IO_BE(expr, res):
    return expr

# /usr/include/libio.h: 406
def _IO_getc_unlocked(_fp):
    return (_IO_BE ((((_fp.contents._IO_read_ptr).value) >= ((_fp.contents._IO_read_end).value)), 0)) and (__uflow (_fp)) or (cast((((_fp.contents._IO_read_ptr).value) + 1), POINTER(c_ubyte))[0])

# /usr/include/libio.h: 409
def _IO_peekc_unlocked(_fp):
    return ((_IO_BE ((((_fp.contents._IO_read_ptr).value) >= ((_fp.contents._IO_read_end).value)), 0)) and ((__underflow (_fp)) == EOF)) and EOF or (cast((_fp.contents._IO_read_ptr), POINTER(c_ubyte))[0])

# /usr/include/libio.h: 413
def _IO_putc_unlocked(_ch, _fp):
    return (_IO_BE ((((_fp.contents._IO_write_ptr).value) >= ((_fp.contents._IO_write_end).value)), 0)) and (__overflow (_fp, (c_ubyte (ord_if_char(_ch))).value)) or (c_ubyte (ord_if_char(_ch))).value

# /usr/include/libio.h: 432
def _IO_feof_unlocked(__fp):
    return ((((__fp.contents._flags).value) & _IO_EOF_SEEN) != 0)

# /usr/include/libio.h: 433
def _IO_ferror_unlocked(__fp):
    return ((((__fp.contents._flags).value) & _IO_ERR_SEEN) != 0)

# /usr/include/libio.h: 443
def _IO_PENDING_OUTPUT_COUNT(_fp):
    return (((_fp.contents._IO_write_ptr).value) - ((_fp.contents._IO_write_base).value))

# /usr/include/libio.h: 457
def _IO_peekc(_fp):
    return (_IO_peekc_unlocked (_fp))

# /usr/include/stdio.h: 120
try:
    _IOFBF = 0
except:
    pass

# /usr/include/stdio.h: 121
try:
    _IOLBF = 1
except:
    pass

# /usr/include/stdio.h: 122
try:
    _IONBF = 2
except:
    pass

# /usr/include/stdio.h: 127
try:
    BUFSIZ = _IO_BUFSIZ
except:
    pass

# /usr/include/stdio.h: 140
try:
    SEEK_SET = 0
except:
    pass

# /usr/include/stdio.h: 141
try:
    SEEK_CUR = 1
except:
    pass

# /usr/include/stdio.h: 142
try:
    SEEK_END = 2
except:
    pass

# /usr/include/stdio.h: 151
try:
    P_tmpdir = '/tmp'
except:
    pass

# /usr/include/bits/stdio_lim.h: 23
try:
    L_tmpnam = 20
except:
    pass

# /usr/include/bits/stdio_lim.h: 24
try:
    TMP_MAX = 238328
except:
    pass

# /usr/include/bits/stdio_lim.h: 25
try:
    FILENAME_MAX = 4096
except:
    pass

# /usr/include/bits/stdio_lim.h: 28
try:
    L_ctermid = 9
except:
    pass

# /usr/include/bits/stdio_lim.h: 37
try:
    FOPEN_MAX = 16
except:
    pass

# /usr/include/stdio.h: 172
try:
    stdin = stdin
except:
    pass

# /usr/include/stdio.h: 173
try:
    stdout = stdout
except:
    pass

# /usr/include/stdio.h: 174
try:
    stderr = stderr
except:
    pass

# /usr/include/stdio.h: 457
try:
    fscanf = __isoc99_fscanf
except:
    pass

# /usr/include/stdio.h: 458
try:
    scanf = __isoc99_scanf
except:
    pass

# /usr/include/stdio.h: 459
try:
    sscanf = __isoc99_sscanf
except:
    pass

# /usr/include/stdio.h: 543
def getc(_fp):
    return (_IO_getc (_fp))

# /usr/include/stdio.h: 585
def putc(_ch, _fp):
    return (_IO_putc (_ch, _fp))

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 53
try:
    CFG_TIME_FMT = '%Y-%m-%d-%Hh%Mm%S-UTC'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 54
try:
    CFG_PERIOD = 1
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 78
try:
    CFG_CLINFO = (-1)
except:
    pass

# /usr/include/fnmatch.h: 20
try:
    _FNMATCH_H = 1
except:
    pass

# /usr/include/fnmatch.h: 33
try:
    FNM_PATHNAME = (1 << 0)
except:
    pass

# /usr/include/fnmatch.h: 34
try:
    FNM_NOESCAPE = (1 << 1)
except:
    pass

# /usr/include/fnmatch.h: 35
try:
    FNM_PERIOD = (1 << 2)
except:
    pass

# /usr/include/fnmatch.h: 45
try:
    FNM_NOMATCH = 1
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgFnmatch.h: 45
try:
    CfgFnmatch = fnmatch
except:
    pass

# /usr/include/glob.h: 20
try:
    _GLOB_H = 1
except:
    pass

__size_t = c_size_t# /usr/include/glob.h: 36

# /usr/include/glob.h: 40
try:
    GLOB_ERR = (1 << 0)
except:
    pass

# /usr/include/glob.h: 41
try:
    GLOB_MARK = (1 << 1)
except:
    pass

# /usr/include/glob.h: 42
try:
    GLOB_NOSORT = (1 << 2)
except:
    pass

# /usr/include/glob.h: 43
try:
    GLOB_DOOFFS = (1 << 3)
except:
    pass

# /usr/include/glob.h: 44
try:
    GLOB_NOCHECK = (1 << 4)
except:
    pass

# /usr/include/glob.h: 45
try:
    GLOB_APPEND = (1 << 5)
except:
    pass

# /usr/include/glob.h: 46
try:
    GLOB_NOESCAPE = (1 << 6)
except:
    pass

# /usr/include/glob.h: 47
try:
    GLOB_PERIOD = (1 << 7)
except:
    pass

# /usr/include/glob.h: 50
try:
    GLOB_MAGCHAR = (1 << 8)
except:
    pass

# /usr/include/glob.h: 51
try:
    GLOB_ALTDIRFUNC = (1 << 9)
except:
    pass

# /usr/include/glob.h: 52
try:
    GLOB_BRACE = (1 << 10)
except:
    pass

# /usr/include/glob.h: 53
try:
    GLOB_NOMAGIC = (1 << 11)
except:
    pass

# /usr/include/glob.h: 54
try:
    GLOB_TILDE = (1 << 12)
except:
    pass

# /usr/include/glob.h: 55
try:
    GLOB_ONLYDIR = (1 << 13)
except:
    pass

# /usr/include/glob.h: 56
try:
    GLOB_TILDE_CHECK = (1 << 14)
except:
    pass

# /usr/include/glob.h: 58
try:
    __GLOB_FLAGS = (((((((((((((GLOB_ERR | GLOB_MARK) | GLOB_NOSORT) | GLOB_DOOFFS) | GLOB_NOESCAPE) | GLOB_NOCHECK) | GLOB_APPEND) | GLOB_PERIOD) | GLOB_ALTDIRFUNC) | GLOB_BRACE) | GLOB_NOMAGIC) | GLOB_TILDE) | GLOB_ONLYDIR) | GLOB_TILDE_CHECK)
except:
    pass

# /usr/include/glob.h: 69
try:
    GLOB_NOSPACE = 1
except:
    pass

# /usr/include/glob.h: 70
try:
    GLOB_ABORTED = 2
except:
    pass

# /usr/include/glob.h: 71
try:
    GLOB_NOMATCH = 3
except:
    pass

# /usr/include/glob.h: 72
try:
    GLOB_NOSYS = 4
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgGlob.h: 36
try:
    CfgGlob = glob
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgGlob.h: 37
try:
    CfgGlobfree = globfree
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgSnprintf.h: 46
try:
    CfgSnprintf = snprintf
except:
    pass

# /usr/include/semaphore.h: 19
try:
    _SEMAPHORE_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/semaphore.h: 26
try:
    __SIZEOF_SEM_T = 32
except:
    pass

# /usr/include/bits/semaphore.h: 33
try:
    SEM_FAILED = cast(0, POINTER(sem_t))
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 40
try:
    CFGQUEUE_CHECK = (-1.0)
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 38
try:
    CFG_NOCM = 'none'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 40
try:
    CFG_CM_UI_RQ_ACTIVATION = 'UIRqActivation'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 41
try:
    CFG_CM_UI_ACTIVATION = 'UIActivation'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 52
try:
    CFG_CM_UI_RQ_INFO = 'UIRqInfo'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 53
try:
    CFG_CM_UI_INFO = 'UIInfo'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 63
try:
    CFG_CM_UI_RQ_LOG = 'UIRqLog'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 64
try:
    CFG_CM_UI_LOG = 'UILog'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 77
try:
    CFG_CM_FB_GET_CONFIG = 'FbGetConfig'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 78
try:
    CFG_CM_FB_CONFIG_DATA = 'FbConfigData'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 83
try:
    CFG_CM_EXIT = 'CfgExit'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 84
try:
    CFG_CM_KILL = 'CfgKill'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 85
try:
    CFG_CM_RESTART = 'CfgReStart'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 86
try:
    CFG_CM_RFLAG = 'CfgRFlag'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 87
try:
    CFG_CM_SVCFG = 'CfgSaveConfig'
except:
    pass

# /virgoApp/Cfg/v9r0/src/CfgVirgo.h: 142
try:
    CfgMsgPrintFatal = CfgMsgAddFatal
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 11
try:
    FRPI = 3.14159265358979
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 12
try:
    FRTWOPI = 6.283185307179586
except:
    pass

# /usr/include/string.h: 23
try:
    _STRING_H = 1
except:
    pass

# /usr/include/string.h: 429
try:
    strerror_r = __xpg_strerror_r
except:
    pass

# /usr/include/stdlib.h: 37
try:
    _STDLIB_H = 1
except:
    pass

# /usr/include/bits/waitflags.h: 25
try:
    WNOHANG = 1
except:
    pass

# /usr/include/bits/waitflags.h: 26
try:
    WUNTRACED = 2
except:
    pass

# /usr/include/bits/waitflags.h: 29
try:
    WSTOPPED = 2
except:
    pass

# /usr/include/bits/waitflags.h: 30
try:
    WEXITED = 4
except:
    pass

# /usr/include/bits/waitflags.h: 31
try:
    WCONTINUED = 8
except:
    pass

# /usr/include/bits/waitflags.h: 32
try:
    WNOWAIT = 16777216
except:
    pass

# /usr/include/bits/waitflags.h: 34
try:
    __WNOTHREAD = 536870912
except:
    pass

# /usr/include/bits/waitflags.h: 36
try:
    __WALL = 1073741824
except:
    pass

# /usr/include/bits/waitflags.h: 37
try:
    __WCLONE = 2147483648
except:
    pass

# /usr/include/bits/waitstatus.h: 28
def __WEXITSTATUS(status):
    return ((status & 65280) >> 8)

# /usr/include/bits/waitstatus.h: 31
def __WTERMSIG(status):
    return (status & 127)

# /usr/include/bits/waitstatus.h: 34
def __WSTOPSIG(status):
    return (__WEXITSTATUS (status))

# /usr/include/bits/waitstatus.h: 37
def __WIFEXITED(status):
    return ((__WTERMSIG (status)) == 0)

# /usr/include/bits/waitstatus.h: 40
def __WIFSIGNALED(status):
    return (((c_char ((((status & 127) + 1)))).value >> 1) > 0)

# /usr/include/bits/waitstatus.h: 44
def __WIFSTOPPED(status):
    return ((status & 255) == 127)

# /usr/include/bits/waitstatus.h: 49
def __WIFCONTINUED(status):
    return (status == __W_CONTINUED)

# /usr/include/bits/waitstatus.h: 53
def __WCOREDUMP(status):
    return (status & __WCOREFLAG)

# /usr/include/bits/waitstatus.h: 56
def __W_EXITCODE(ret, sig):
    return ((ret << 8) | sig)

# /usr/include/bits/waitstatus.h: 57
def __W_STOPCODE(sig):
    return ((sig << 8) | 127)

# /usr/include/bits/waitstatus.h: 58
try:
    __W_CONTINUED = 65535
except:
    pass

# /usr/include/bits/waitstatus.h: 59
try:
    __WCOREFLAG = 128
except:
    pass

# /usr/include/stdlib.h: 54
def __WAIT_INT(status):
    return (cast(pointer(status), POINTER(c_int))[0])

__WAIT_STATUS = POINTER(None)# /usr/include/stdlib.h: 63

__WAIT_STATUS_DEFN = POINTER(None)# /usr/include/stdlib.h: 64

# /usr/include/stdlib.h: 84
def WEXITSTATUS(status):
    return (__WEXITSTATUS ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 85
def WTERMSIG(status):
    return (__WTERMSIG ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 86
def WSTOPSIG(status):
    return (__WSTOPSIG ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 87
def WIFEXITED(status):
    return (__WIFEXITED ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 88
def WIFSIGNALED(status):
    return (__WIFSIGNALED ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 89
def WIFSTOPPED(status):
    return (__WIFSTOPPED ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 91
def WIFCONTINUED(status):
    return (__WIFCONTINUED ((__WAIT_INT (status))))

# /usr/include/stdlib.h: 110
try:
    __ldiv_t_defined = 1
except:
    pass

# /usr/include/stdlib.h: 122
try:
    __lldiv_t_defined = 1
except:
    pass

# /usr/include/stdlib.h: 128
try:
    RAND_MAX = 2147483647
except:
    pass

# /usr/include/stdlib.h: 133
try:
    EXIT_FAILURE = 1
except:
    pass

# /usr/include/stdlib.h: 134
try:
    EXIT_SUCCESS = 0
except:
    pass

# /usr/include/stdlib.h: 138
try:
    MB_CUR_MAX = (__ctype_get_mb_cur_max ())
except:
    pass

# /usr/include/alloca.h: 19
try:
    _ALLOCA_H = 1
except:
    pass

# /usr/include/limits.h: 24
try:
    _LIBC_LIMITS_H_ = 1
except:
    pass

# /usr/include/limits.h: 32
try:
    MB_LEN_MAX = 16
except:
    pass

# /usr/include/limits.h: 43
try:
    _LIMITS_H = 1
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/limits.h: 54
try:
    CHAR_BIT = 8
except:
    pass

# /usr/include/limits.h: 57
try:
    SCHAR_MIN = (-128)
except:
    pass

# /usr/include/limits.h: 58
try:
    SCHAR_MAX = 127
except:
    pass

# /usr/include/limits.h: 61
try:
    UCHAR_MAX = 255
except:
    pass

# /usr/include/limits.h: 68
try:
    CHAR_MIN = SCHAR_MIN
except:
    pass

# /usr/include/limits.h: 69
try:
    CHAR_MAX = SCHAR_MAX
except:
    pass

# /usr/include/limits.h: 73
try:
    SHRT_MIN = (-32768)
except:
    pass

# /usr/include/limits.h: 74
try:
    SHRT_MAX = 32767
except:
    pass

# /usr/include/limits.h: 77
try:
    USHRT_MAX = 65535
except:
    pass

# /usr/include/limits.h: 80
try:
    INT_MIN = ((-INT_MAX) - 1)
except:
    pass

# /usr/include/limits.h: 81
try:
    INT_MAX = 2147483647
except:
    pass

# /usr/include/limits.h: 84
try:
    UINT_MAX = 4294967295
except:
    pass

# /usr/include/limits.h: 88
try:
    LONG_MAX = 9.223372036854776e+18
except:
    pass

# /usr/include/limits.h: 92
try:
    LONG_MIN = ((-LONG_MAX) - 1.0)
except:
    pass

# /usr/include/limits.h: 96
try:
    ULONG_MAX = 18446744073709551615
except:
    pass

# /usr/include/limits.h: 104
try:
    LLONG_MAX = 9223372036854775807
except:
    pass

# /usr/include/limits.h: 105
try:
    LLONG_MIN = ((-LLONG_MAX) - 1)
except:
    pass

# /usr/include/limits.h: 108
try:
    ULLONG_MAX = 18446744073709551615
except:
    pass

# /usr/include/bits/posix1_lim.h: 25
try:
    _BITS_POSIX1_LIM_H = 1
except:
    pass

# /usr/include/bits/posix1_lim.h: 31
try:
    _POSIX_AIO_LISTIO_MAX = 2
except:
    pass

# /usr/include/bits/posix1_lim.h: 34
try:
    _POSIX_AIO_MAX = 1
except:
    pass

# /usr/include/bits/posix1_lim.h: 37
try:
    _POSIX_ARG_MAX = 4096
except:
    pass

# /usr/include/bits/posix1_lim.h: 41
try:
    _POSIX_CHILD_MAX = 25
except:
    pass

# /usr/include/bits/posix1_lim.h: 47
try:
    _POSIX_DELAYTIMER_MAX = 32
except:
    pass

# /usr/include/bits/posix1_lim.h: 51
try:
    _POSIX_HOST_NAME_MAX = 255
except:
    pass

# /usr/include/bits/posix1_lim.h: 54
try:
    _POSIX_LINK_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 57
try:
    _POSIX_LOGIN_NAME_MAX = 9
except:
    pass

# /usr/include/bits/posix1_lim.h: 60
try:
    _POSIX_MAX_CANON = 255
except:
    pass

# /usr/include/bits/posix1_lim.h: 64
try:
    _POSIX_MAX_INPUT = 255
except:
    pass

# /usr/include/bits/posix1_lim.h: 67
try:
    _POSIX_MQ_OPEN_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 70
try:
    _POSIX_MQ_PRIO_MAX = 32
except:
    pass

# /usr/include/bits/posix1_lim.h: 73
try:
    _POSIX_NAME_MAX = 14
except:
    pass

# /usr/include/bits/posix1_lim.h: 77
try:
    _POSIX_NGROUPS_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 84
try:
    _POSIX_OPEN_MAX = 20
except:
    pass

# /usr/include/bits/posix1_lim.h: 96
try:
    _POSIX_PATH_MAX = 256
except:
    pass

# /usr/include/bits/posix1_lim.h: 99
try:
    _POSIX_PIPE_BUF = 512
except:
    pass

# /usr/include/bits/posix1_lim.h: 103
try:
    _POSIX_RE_DUP_MAX = 255
except:
    pass

# /usr/include/bits/posix1_lim.h: 106
try:
    _POSIX_RTSIG_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 109
try:
    _POSIX_SEM_NSEMS_MAX = 256
except:
    pass

# /usr/include/bits/posix1_lim.h: 112
try:
    _POSIX_SEM_VALUE_MAX = 32767
except:
    pass

# /usr/include/bits/posix1_lim.h: 115
try:
    _POSIX_SIGQUEUE_MAX = 32
except:
    pass

# /usr/include/bits/posix1_lim.h: 118
try:
    _POSIX_SSIZE_MAX = 32767
except:
    pass

# /usr/include/bits/posix1_lim.h: 121
try:
    _POSIX_STREAM_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 124
try:
    _POSIX_SYMLINK_MAX = 255
except:
    pass

# /usr/include/bits/posix1_lim.h: 128
try:
    _POSIX_SYMLOOP_MAX = 8
except:
    pass

# /usr/include/bits/posix1_lim.h: 131
try:
    _POSIX_TIMER_MAX = 32
except:
    pass

# /usr/include/bits/posix1_lim.h: 134
try:
    _POSIX_TTY_NAME_MAX = 9
except:
    pass

# /usr/include/bits/posix1_lim.h: 138
try:
    _POSIX_TZNAME_MAX = 6
except:
    pass

# /usr/include/bits/posix1_lim.h: 156
try:
    _POSIX_CLOCKRES_MIN = 20000000
except:
    pass

# /usr/include/linux/limits.h: 4
try:
    NR_OPEN = 1024
except:
    pass

# /usr/include/linux/limits.h: 6
try:
    NGROUPS_MAX = 65536
except:
    pass

# /usr/include/linux/limits.h: 7
try:
    ARG_MAX = 131072
except:
    pass

# /usr/include/linux/limits.h: 8
try:
    LINK_MAX = 127
except:
    pass

# /usr/include/linux/limits.h: 9
try:
    MAX_CANON = 255
except:
    pass

# /usr/include/linux/limits.h: 10
try:
    MAX_INPUT = 255
except:
    pass

# /usr/include/linux/limits.h: 11
try:
    NAME_MAX = 255
except:
    pass

# /usr/include/linux/limits.h: 12
try:
    PATH_MAX = 4096
except:
    pass

# /usr/include/linux/limits.h: 13
try:
    PIPE_BUF = 4096
except:
    pass

# /usr/include/linux/limits.h: 14
try:
    XATTR_NAME_MAX = 255
except:
    pass

# /usr/include/linux/limits.h: 15
try:
    XATTR_SIZE_MAX = 65536
except:
    pass

# /usr/include/linux/limits.h: 16
try:
    XATTR_LIST_MAX = 65536
except:
    pass

# /usr/include/linux/limits.h: 18
try:
    RTSIG_MAX = 32
except:
    pass

# /usr/include/bits/local_lim.h: 42
# #undef NR_OPEN
try:
    del NR_OPEN
except NameError:
    pass

# /usr/include/bits/local_lim.h: 47
# #undef LINK_MAX
try:
    del LINK_MAX
except NameError:
    pass

# /usr/include/bits/local_lim.h: 57
# #undef ARG_MAX
try:
    del ARG_MAX
except NameError:
    pass

# /usr/include/bits/local_lim.h: 62
try:
    _POSIX_THREAD_KEYS_MAX = 128
except:
    pass

# /usr/include/bits/local_lim.h: 64
try:
    PTHREAD_KEYS_MAX = 1024
except:
    pass

# /usr/include/bits/local_lim.h: 67
try:
    _POSIX_THREAD_DESTRUCTOR_ITERATIONS = 4
except:
    pass

# /usr/include/bits/local_lim.h: 69
try:
    PTHREAD_DESTRUCTOR_ITERATIONS = _POSIX_THREAD_DESTRUCTOR_ITERATIONS
except:
    pass

# /usr/include/bits/local_lim.h: 72
try:
    _POSIX_THREAD_THREADS_MAX = 64
except:
    pass

# /usr/include/bits/local_lim.h: 78
try:
    AIO_PRIO_DELTA_MAX = 20
except:
    pass

# /usr/include/bits/local_lim.h: 81
try:
    PTHREAD_STACK_MIN = 16384
except:
    pass

# /usr/include/bits/local_lim.h: 84
try:
    DELAYTIMER_MAX = 2147483647
except:
    pass

# /usr/include/bits/local_lim.h: 87
try:
    TTY_NAME_MAX = 32
except:
    pass

# /usr/include/bits/local_lim.h: 90
try:
    LOGIN_NAME_MAX = 256
except:
    pass

# /usr/include/bits/local_lim.h: 93
try:
    HOST_NAME_MAX = 64
except:
    pass

# /usr/include/bits/local_lim.h: 96
try:
    MQ_PRIO_MAX = 32768
except:
    pass

# /usr/include/bits/local_lim.h: 99
try:
    SEM_VALUE_MAX = 2147483647
except:
    pass

# /usr/include/bits/posix1_lim.h: 164
try:
    SSIZE_MAX = LONG_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 23
try:
    _BITS_POSIX2_LIM_H = 1
except:
    pass

# /usr/include/bits/posix2_lim.h: 27
try:
    _POSIX2_BC_BASE_MAX = 99
except:
    pass

# /usr/include/bits/posix2_lim.h: 30
try:
    _POSIX2_BC_DIM_MAX = 2048
except:
    pass

# /usr/include/bits/posix2_lim.h: 33
try:
    _POSIX2_BC_SCALE_MAX = 99
except:
    pass

# /usr/include/bits/posix2_lim.h: 36
try:
    _POSIX2_BC_STRING_MAX = 1000
except:
    pass

# /usr/include/bits/posix2_lim.h: 40
try:
    _POSIX2_COLL_WEIGHTS_MAX = 2
except:
    pass

# /usr/include/bits/posix2_lim.h: 44
try:
    _POSIX2_EXPR_NEST_MAX = 32
except:
    pass

# /usr/include/bits/posix2_lim.h: 47
try:
    _POSIX2_LINE_MAX = 2048
except:
    pass

# /usr/include/bits/posix2_lim.h: 51
try:
    _POSIX2_RE_DUP_MAX = 255
except:
    pass

# /usr/include/bits/posix2_lim.h: 55
try:
    _POSIX2_CHARCLASS_NAME_MAX = 14
except:
    pass

# /usr/include/bits/posix2_lim.h: 63
try:
    BC_BASE_MAX = _POSIX2_BC_BASE_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 66
try:
    BC_DIM_MAX = _POSIX2_BC_DIM_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 69
try:
    BC_SCALE_MAX = _POSIX2_BC_SCALE_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 72
try:
    BC_STRING_MAX = _POSIX2_BC_STRING_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 75
try:
    COLL_WEIGHTS_MAX = 255
except:
    pass

# /usr/include/bits/posix2_lim.h: 78
try:
    EXPR_NEST_MAX = _POSIX2_EXPR_NEST_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 81
try:
    LINE_MAX = _POSIX2_LINE_MAX
except:
    pass

# /usr/include/bits/posix2_lim.h: 84
try:
    CHARCLASS_NAME_MAX = 2048
except:
    pass

# /usr/include/bits/posix2_lim.h: 88
try:
    RE_DUP_MAX = 32767
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 63
# #undef CHAR_BIT
try:
    del CHAR_BIT
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 64
try:
    CHAR_BIT = __CHAR_BIT__
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 72
# #undef SCHAR_MIN
try:
    del SCHAR_MIN
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 73
try:
    SCHAR_MIN = ((-SCHAR_MAX) - 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 74
# #undef SCHAR_MAX
try:
    del SCHAR_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 75
try:
    SCHAR_MAX = __SCHAR_MAX__
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 78
# #undef UCHAR_MAX
try:
    del UCHAR_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 82
try:
    UCHAR_MAX = ((SCHAR_MAX * 2) + 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 96
# #undef CHAR_MIN
try:
    del CHAR_MIN
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 97
try:
    CHAR_MIN = SCHAR_MIN
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 98
# #undef CHAR_MAX
try:
    del CHAR_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 99
try:
    CHAR_MAX = SCHAR_MAX
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 103
# #undef SHRT_MIN
try:
    del SHRT_MIN
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 104
try:
    SHRT_MIN = ((-SHRT_MAX) - 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 105
# #undef SHRT_MAX
try:
    del SHRT_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 106
try:
    SHRT_MAX = __SHRT_MAX__
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 109
# #undef USHRT_MAX
try:
    del USHRT_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 113
try:
    USHRT_MAX = ((SHRT_MAX * 2) + 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 117
# #undef INT_MIN
try:
    del INT_MIN
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 118
try:
    INT_MIN = ((-INT_MAX) - 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 119
# #undef INT_MAX
try:
    del INT_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 120
try:
    INT_MAX = __INT_MAX__
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 123
# #undef UINT_MAX
try:
    del UINT_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 124
try:
    UINT_MAX = ((INT_MAX * 2) + 1)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 128
# #undef LONG_MIN
try:
    del LONG_MIN
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 129
try:
    LONG_MIN = ((-LONG_MAX) - 1.0)
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 130
# #undef LONG_MAX
try:
    del LONG_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 131
try:
    LONG_MAX = __LONG_MAX__
except:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 134
# #undef ULONG_MAX
try:
    del ULONG_MAX
except NameError:
    pass

# /usr/lib/gcc/x86_64-redhat-linux/4.8.5/include/limits.h: 135
try:
    ULONG_MAX = ((LONG_MAX * 2) + 1)
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 21
try:
    FRLLD = 'ld'
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrIO.h: 28
try:
    FRIOBSIZE = 16384
except:
    pass

FRSCHAR = c_char# /virgoApp/Fr/v8r40p5/src/FrameL.h: 33

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 68
try:
    FRMAPMAXSH = 100
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 69
try:
    FRMAPMAXREF = 4
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 70
try:
    FRMAPMAXINSTANCE = 500
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 72
try:
    FRGPSOFF = 315964800
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 73
try:
    FRGPSTAI = 19
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 83
try:
    FRGPSLEAPS = (FrGetLeapS (4294967295))
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrameL.h: 503
try:
    FRMAXREF = 50
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrVect.h: 34
try:
    FR_VECT_C8 = FR_VECT_8C
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrVect.h: 35
try:
    FR_VECT_C16 = FR_VECT_16C
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrVect.h: 36
try:
    FR_VECT_H8 = FR_VECT_8H
except:
    pass

# /virgoApp/Fr/v8r40p5/src/FrVect.h: 37
try:
    FR_VECT_H16 = FR_VECT_16H
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 20
try:
    FrvDecimate = FrVectDecimate
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 21
try:
    FrvCopyTo = FrVectCopyTo
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 22
try:
    FrvCopyToD = FrVectCopyToD
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 23
try:
    FrvCopyToF = FrVectCopyToF
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 24
try:
    FrvCopyToI = FrVectCopyToI
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 25
try:
    FrvCopyToS = FrVectCopyToS
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvCopy.h: 27
try:
    FrvDecimate = FrVectDecimate
except:
    pass

# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 19
try:
    FRVTWOPI = 6.283185307179586
except:
    pass

# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 15
try:
    _XOPEN_SOURCE = 500
except:
    pass

# /usr/include/unistd.h: 23
try:
    _UNISTD_H = 1
except:
    pass

# /usr/include/unistd.h: 34
try:
    _POSIX_VERSION = 200809.0
except:
    pass

# /usr/include/unistd.h: 53
try:
    __POSIX2_THIS_VERSION = 200809.0
except:
    pass

# /usr/include/unistd.h: 67
try:
    _POSIX2_VERSION = __POSIX2_THIS_VERSION
except:
    pass

# /usr/include/unistd.h: 71
try:
    _POSIX2_C_BIND = __POSIX2_THIS_VERSION
except:
    pass

# /usr/include/unistd.h: 75
try:
    _POSIX2_C_DEV = __POSIX2_THIS_VERSION
except:
    pass

# /usr/include/unistd.h: 79
try:
    _POSIX2_SW_DEV = __POSIX2_THIS_VERSION
except:
    pass

# /usr/include/unistd.h: 83
try:
    _POSIX2_LOCALEDEF = __POSIX2_THIS_VERSION
except:
    pass

# /usr/include/unistd.h: 87
try:
    _XOPEN_VERSION = 700
except:
    pass

# /usr/include/unistd.h: 97
try:
    _XOPEN_XCU_VERSION = 4
except:
    pass

# /usr/include/unistd.h: 100
try:
    _XOPEN_XPG2 = 1
except:
    pass

# /usr/include/unistd.h: 101
try:
    _XOPEN_XPG3 = 1
except:
    pass

# /usr/include/unistd.h: 102
try:
    _XOPEN_XPG4 = 1
except:
    pass

# /usr/include/unistd.h: 105
try:
    _XOPEN_UNIX = 1
except:
    pass

# /usr/include/unistd.h: 108
try:
    _XOPEN_CRYPT = 1
except:
    pass

# /usr/include/unistd.h: 112
try:
    _XOPEN_ENH_I18N = 1
except:
    pass

# /usr/include/unistd.h: 115
try:
    _XOPEN_LEGACY = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 20
try:
    _BITS_POSIX_OPT_H = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 23
try:
    _POSIX_JOB_CONTROL = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 26
try:
    _POSIX_SAVED_IDS = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 29
try:
    _POSIX_PRIORITY_SCHEDULING = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 32
try:
    _POSIX_SYNCHRONIZED_IO = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 35
try:
    _POSIX_FSYNC = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 38
try:
    _POSIX_MAPPED_FILES = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 41
try:
    _POSIX_MEMLOCK = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 44
try:
    _POSIX_MEMLOCK_RANGE = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 47
try:
    _POSIX_MEMORY_PROTECTION = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 50
try:
    _POSIX_CHOWN_RESTRICTED = 0
except:
    pass

# /usr/include/bits/posix_opt.h: 54
try:
    _POSIX_VDISABLE = b'\\0'
except:
    pass

# /usr/include/bits/posix_opt.h: 57
try:
    _POSIX_NO_TRUNC = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 60
try:
    _XOPEN_REALTIME = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 63
try:
    _XOPEN_REALTIME_THREADS = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 66
try:
    _XOPEN_SHM = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 69
try:
    _POSIX_THREADS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 72
try:
    _POSIX_REENTRANT_FUNCTIONS = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 73
try:
    _POSIX_THREAD_SAFE_FUNCTIONS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 76
try:
    _POSIX_THREAD_PRIORITY_SCHEDULING = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 79
try:
    _POSIX_THREAD_ATTR_STACKSIZE = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 82
try:
    _POSIX_THREAD_ATTR_STACKADDR = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 85
try:
    _POSIX_THREAD_PRIO_INHERIT = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 89
try:
    _POSIX_THREAD_PRIO_PROTECT = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 93
try:
    _POSIX_THREAD_ROBUST_PRIO_INHERIT = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 96
try:
    _POSIX_THREAD_ROBUST_PRIO_PROTECT = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 100
try:
    _POSIX_SEMAPHORES = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 103
try:
    _POSIX_REALTIME_SIGNALS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 106
try:
    _POSIX_ASYNCHRONOUS_IO = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 107
try:
    _POSIX_ASYNC_IO = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 109
try:
    _LFS_ASYNCHRONOUS_IO = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 111
try:
    _POSIX_PRIORITIZED_IO = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 114
try:
    _LFS64_ASYNCHRONOUS_IO = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 117
try:
    _LFS_LARGEFILE = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 118
try:
    _LFS64_LARGEFILE = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 119
try:
    _LFS64_STDIO = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 122
try:
    _POSIX_SHARED_MEMORY_OBJECTS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 125
try:
    _POSIX_CPUTIME = 0
except:
    pass

# /usr/include/bits/posix_opt.h: 128
try:
    _POSIX_THREAD_CPUTIME = 0
except:
    pass

# /usr/include/bits/posix_opt.h: 131
try:
    _POSIX_REGEXP = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 134
try:
    _POSIX_READER_WRITER_LOCKS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 137
try:
    _POSIX_SHELL = 1
except:
    pass

# /usr/include/bits/posix_opt.h: 140
try:
    _POSIX_TIMEOUTS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 143
try:
    _POSIX_SPIN_LOCKS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 146
try:
    _POSIX_SPAWN = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 149
try:
    _POSIX_TIMERS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 152
try:
    _POSIX_BARRIERS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 155
try:
    _POSIX_MESSAGE_PASSING = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 158
try:
    _POSIX_THREAD_PROCESS_SHARED = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 161
try:
    _POSIX_MONOTONIC_CLOCK = 0
except:
    pass

# /usr/include/bits/posix_opt.h: 164
try:
    _POSIX_CLOCK_SELECTION = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 167
try:
    _POSIX_ADVISORY_INFO = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 170
try:
    _POSIX_IPV6 = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 173
try:
    _POSIX_RAW_SOCKETS = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 176
try:
    _POSIX2_CHAR_TERM = 200809.0
except:
    pass

# /usr/include/bits/posix_opt.h: 179
try:
    _POSIX_SPORADIC_SERVER = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 180
try:
    _POSIX_THREAD_SPORADIC_SERVER = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 183
try:
    _POSIX_TRACE = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 184
try:
    _POSIX_TRACE_EVENT_FILTER = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 185
try:
    _POSIX_TRACE_INHERIT = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 186
try:
    _POSIX_TRACE_LOG = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 189
try:
    _POSIX_TYPED_MEMORY_OBJECTS = (-1)
except:
    pass

# /usr/include/bits/posix_opt.h: 192
try:
    _XOPEN_STREAMS = (-1)
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/environments.h: 56
try:
    _POSIX_V7_LPBIG_OFFBIG = (-1)
except:
    pass

# /usr/include/bits/environments.h: 57
try:
    _POSIX_V6_LPBIG_OFFBIG = (-1)
except:
    pass

# /usr/include/bits/environments.h: 58
try:
    _XBS5_LPBIG_OFFBIG = (-1)
except:
    pass

# /usr/include/bits/environments.h: 61
try:
    _POSIX_V7_LP64_OFF64 = 1
except:
    pass

# /usr/include/bits/environments.h: 62
try:
    _POSIX_V6_LP64_OFF64 = 1
except:
    pass

# /usr/include/bits/environments.h: 63
try:
    _XBS5_LP64_OFF64 = 1
except:
    pass

# /usr/include/bits/environments.h: 91
try:
    __ILP32_OFF32_CFLAGS = '-m32'
except:
    pass

# /usr/include/bits/environments.h: 92
try:
    __ILP32_OFFBIG_CFLAGS = '-m32 -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64'
except:
    pass

# /usr/include/bits/environments.h: 93
try:
    __ILP32_OFF32_LDFLAGS = '-m32'
except:
    pass

# /usr/include/bits/environments.h: 94
try:
    __ILP32_OFFBIG_LDFLAGS = '-m32'
except:
    pass

# /usr/include/bits/environments.h: 95
try:
    __LP64_OFF64_CFLAGS = '-m64'
except:
    pass

# /usr/include/bits/environments.h: 96
try:
    __LP64_OFF64_LDFLAGS = '-m64'
except:
    pass

# /usr/include/unistd.h: 210
try:
    STDIN_FILENO = 0
except:
    pass

# /usr/include/unistd.h: 211
try:
    STDOUT_FILENO = 1
except:
    pass

# /usr/include/unistd.h: 212
try:
    STDERR_FILENO = 2
except:
    pass

# /usr/include/unistd.h: 281
try:
    R_OK = 4
except:
    pass

# /usr/include/unistd.h: 282
try:
    W_OK = 2
except:
    pass

# /usr/include/unistd.h: 283
try:
    X_OK = 1
except:
    pass

# /usr/include/unistd.h: 284
try:
    F_OK = 0
except:
    pass

# /usr/include/unistd.h: 322
try:
    L_SET = SEEK_SET
except:
    pass

# /usr/include/unistd.h: 323
try:
    L_INCR = SEEK_CUR
except:
    pass

# /usr/include/unistd.h: 324
try:
    L_XTND = SEEK_END
except:
    pass

# /usr/include/bits/confname.h: 28
try:
    _PC_LINK_MAX = _PC_LINK_MAX
except:
    pass

# /usr/include/bits/confname.h: 30
try:
    _PC_MAX_CANON = _PC_MAX_CANON
except:
    pass

# /usr/include/bits/confname.h: 32
try:
    _PC_MAX_INPUT = _PC_MAX_INPUT
except:
    pass

# /usr/include/bits/confname.h: 34
try:
    _PC_NAME_MAX = _PC_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 36
try:
    _PC_PATH_MAX = _PC_PATH_MAX
except:
    pass

# /usr/include/bits/confname.h: 38
try:
    _PC_PIPE_BUF = _PC_PIPE_BUF
except:
    pass

# /usr/include/bits/confname.h: 40
try:
    _PC_CHOWN_RESTRICTED = _PC_CHOWN_RESTRICTED
except:
    pass

# /usr/include/bits/confname.h: 42
try:
    _PC_NO_TRUNC = _PC_NO_TRUNC
except:
    pass

# /usr/include/bits/confname.h: 44
try:
    _PC_VDISABLE = _PC_VDISABLE
except:
    pass

# /usr/include/bits/confname.h: 46
try:
    _PC_SYNC_IO = _PC_SYNC_IO
except:
    pass

# /usr/include/bits/confname.h: 48
try:
    _PC_ASYNC_IO = _PC_ASYNC_IO
except:
    pass

# /usr/include/bits/confname.h: 50
try:
    _PC_PRIO_IO = _PC_PRIO_IO
except:
    pass

# /usr/include/bits/confname.h: 52
try:
    _PC_SOCK_MAXBUF = _PC_SOCK_MAXBUF
except:
    pass

# /usr/include/bits/confname.h: 54
try:
    _PC_FILESIZEBITS = _PC_FILESIZEBITS
except:
    pass

# /usr/include/bits/confname.h: 56
try:
    _PC_REC_INCR_XFER_SIZE = _PC_REC_INCR_XFER_SIZE
except:
    pass

# /usr/include/bits/confname.h: 58
try:
    _PC_REC_MAX_XFER_SIZE = _PC_REC_MAX_XFER_SIZE
except:
    pass

# /usr/include/bits/confname.h: 60
try:
    _PC_REC_MIN_XFER_SIZE = _PC_REC_MIN_XFER_SIZE
except:
    pass

# /usr/include/bits/confname.h: 62
try:
    _PC_REC_XFER_ALIGN = _PC_REC_XFER_ALIGN
except:
    pass

# /usr/include/bits/confname.h: 64
try:
    _PC_ALLOC_SIZE_MIN = _PC_ALLOC_SIZE_MIN
except:
    pass

# /usr/include/bits/confname.h: 66
try:
    _PC_SYMLINK_MAX = _PC_SYMLINK_MAX
except:
    pass

# /usr/include/bits/confname.h: 68
try:
    _PC_2_SYMLINKS = _PC_2_SYMLINKS
except:
    pass

# /usr/include/bits/confname.h: 75
try:
    _SC_ARG_MAX = _SC_ARG_MAX
except:
    pass

# /usr/include/bits/confname.h: 77
try:
    _SC_CHILD_MAX = _SC_CHILD_MAX
except:
    pass

# /usr/include/bits/confname.h: 79
try:
    _SC_CLK_TCK = _SC_CLK_TCK
except:
    pass

# /usr/include/bits/confname.h: 81
try:
    _SC_NGROUPS_MAX = _SC_NGROUPS_MAX
except:
    pass

# /usr/include/bits/confname.h: 83
try:
    _SC_OPEN_MAX = _SC_OPEN_MAX
except:
    pass

# /usr/include/bits/confname.h: 85
try:
    _SC_STREAM_MAX = _SC_STREAM_MAX
except:
    pass

# /usr/include/bits/confname.h: 87
try:
    _SC_TZNAME_MAX = _SC_TZNAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 89
try:
    _SC_JOB_CONTROL = _SC_JOB_CONTROL
except:
    pass

# /usr/include/bits/confname.h: 91
try:
    _SC_SAVED_IDS = _SC_SAVED_IDS
except:
    pass

# /usr/include/bits/confname.h: 93
try:
    _SC_REALTIME_SIGNALS = _SC_REALTIME_SIGNALS
except:
    pass

# /usr/include/bits/confname.h: 95
try:
    _SC_PRIORITY_SCHEDULING = _SC_PRIORITY_SCHEDULING
except:
    pass

# /usr/include/bits/confname.h: 97
try:
    _SC_TIMERS = _SC_TIMERS
except:
    pass

# /usr/include/bits/confname.h: 99
try:
    _SC_ASYNCHRONOUS_IO = _SC_ASYNCHRONOUS_IO
except:
    pass

# /usr/include/bits/confname.h: 101
try:
    _SC_PRIORITIZED_IO = _SC_PRIORITIZED_IO
except:
    pass

# /usr/include/bits/confname.h: 103
try:
    _SC_SYNCHRONIZED_IO = _SC_SYNCHRONIZED_IO
except:
    pass

# /usr/include/bits/confname.h: 105
try:
    _SC_FSYNC = _SC_FSYNC
except:
    pass

# /usr/include/bits/confname.h: 107
try:
    _SC_MAPPED_FILES = _SC_MAPPED_FILES
except:
    pass

# /usr/include/bits/confname.h: 109
try:
    _SC_MEMLOCK = _SC_MEMLOCK
except:
    pass

# /usr/include/bits/confname.h: 111
try:
    _SC_MEMLOCK_RANGE = _SC_MEMLOCK_RANGE
except:
    pass

# /usr/include/bits/confname.h: 113
try:
    _SC_MEMORY_PROTECTION = _SC_MEMORY_PROTECTION
except:
    pass

# /usr/include/bits/confname.h: 115
try:
    _SC_MESSAGE_PASSING = _SC_MESSAGE_PASSING
except:
    pass

# /usr/include/bits/confname.h: 117
try:
    _SC_SEMAPHORES = _SC_SEMAPHORES
except:
    pass

# /usr/include/bits/confname.h: 119
try:
    _SC_SHARED_MEMORY_OBJECTS = _SC_SHARED_MEMORY_OBJECTS
except:
    pass

# /usr/include/bits/confname.h: 121
try:
    _SC_AIO_LISTIO_MAX = _SC_AIO_LISTIO_MAX
except:
    pass

# /usr/include/bits/confname.h: 123
try:
    _SC_AIO_MAX = _SC_AIO_MAX
except:
    pass

# /usr/include/bits/confname.h: 125
try:
    _SC_AIO_PRIO_DELTA_MAX = _SC_AIO_PRIO_DELTA_MAX
except:
    pass

# /usr/include/bits/confname.h: 127
try:
    _SC_DELAYTIMER_MAX = _SC_DELAYTIMER_MAX
except:
    pass

# /usr/include/bits/confname.h: 129
try:
    _SC_MQ_OPEN_MAX = _SC_MQ_OPEN_MAX
except:
    pass

# /usr/include/bits/confname.h: 131
try:
    _SC_MQ_PRIO_MAX = _SC_MQ_PRIO_MAX
except:
    pass

# /usr/include/bits/confname.h: 133
try:
    _SC_VERSION = _SC_VERSION
except:
    pass

# /usr/include/bits/confname.h: 135
try:
    _SC_PAGESIZE = _SC_PAGESIZE
except:
    pass

# /usr/include/bits/confname.h: 136
try:
    _SC_PAGE_SIZE = _SC_PAGESIZE
except:
    pass

# /usr/include/bits/confname.h: 138
try:
    _SC_RTSIG_MAX = _SC_RTSIG_MAX
except:
    pass

# /usr/include/bits/confname.h: 140
try:
    _SC_SEM_NSEMS_MAX = _SC_SEM_NSEMS_MAX
except:
    pass

# /usr/include/bits/confname.h: 142
try:
    _SC_SEM_VALUE_MAX = _SC_SEM_VALUE_MAX
except:
    pass

# /usr/include/bits/confname.h: 144
try:
    _SC_SIGQUEUE_MAX = _SC_SIGQUEUE_MAX
except:
    pass

# /usr/include/bits/confname.h: 146
try:
    _SC_TIMER_MAX = _SC_TIMER_MAX
except:
    pass

# /usr/include/bits/confname.h: 151
try:
    _SC_BC_BASE_MAX = _SC_BC_BASE_MAX
except:
    pass

# /usr/include/bits/confname.h: 153
try:
    _SC_BC_DIM_MAX = _SC_BC_DIM_MAX
except:
    pass

# /usr/include/bits/confname.h: 155
try:
    _SC_BC_SCALE_MAX = _SC_BC_SCALE_MAX
except:
    pass

# /usr/include/bits/confname.h: 157
try:
    _SC_BC_STRING_MAX = _SC_BC_STRING_MAX
except:
    pass

# /usr/include/bits/confname.h: 159
try:
    _SC_COLL_WEIGHTS_MAX = _SC_COLL_WEIGHTS_MAX
except:
    pass

# /usr/include/bits/confname.h: 161
try:
    _SC_EQUIV_CLASS_MAX = _SC_EQUIV_CLASS_MAX
except:
    pass

# /usr/include/bits/confname.h: 163
try:
    _SC_EXPR_NEST_MAX = _SC_EXPR_NEST_MAX
except:
    pass

# /usr/include/bits/confname.h: 165
try:
    _SC_LINE_MAX = _SC_LINE_MAX
except:
    pass

# /usr/include/bits/confname.h: 167
try:
    _SC_RE_DUP_MAX = _SC_RE_DUP_MAX
except:
    pass

# /usr/include/bits/confname.h: 169
try:
    _SC_CHARCLASS_NAME_MAX = _SC_CHARCLASS_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 172
try:
    _SC_2_VERSION = _SC_2_VERSION
except:
    pass

# /usr/include/bits/confname.h: 174
try:
    _SC_2_C_BIND = _SC_2_C_BIND
except:
    pass

# /usr/include/bits/confname.h: 176
try:
    _SC_2_C_DEV = _SC_2_C_DEV
except:
    pass

# /usr/include/bits/confname.h: 178
try:
    _SC_2_FORT_DEV = _SC_2_FORT_DEV
except:
    pass

# /usr/include/bits/confname.h: 180
try:
    _SC_2_FORT_RUN = _SC_2_FORT_RUN
except:
    pass

# /usr/include/bits/confname.h: 182
try:
    _SC_2_SW_DEV = _SC_2_SW_DEV
except:
    pass

# /usr/include/bits/confname.h: 184
try:
    _SC_2_LOCALEDEF = _SC_2_LOCALEDEF
except:
    pass

# /usr/include/bits/confname.h: 187
try:
    _SC_PII = _SC_PII
except:
    pass

# /usr/include/bits/confname.h: 189
try:
    _SC_PII_XTI = _SC_PII_XTI
except:
    pass

# /usr/include/bits/confname.h: 191
try:
    _SC_PII_SOCKET = _SC_PII_SOCKET
except:
    pass

# /usr/include/bits/confname.h: 193
try:
    _SC_PII_INTERNET = _SC_PII_INTERNET
except:
    pass

# /usr/include/bits/confname.h: 195
try:
    _SC_PII_OSI = _SC_PII_OSI
except:
    pass

# /usr/include/bits/confname.h: 197
try:
    _SC_POLL = _SC_POLL
except:
    pass

# /usr/include/bits/confname.h: 199
try:
    _SC_SELECT = _SC_SELECT
except:
    pass

# /usr/include/bits/confname.h: 201
try:
    _SC_UIO_MAXIOV = _SC_UIO_MAXIOV
except:
    pass

# /usr/include/bits/confname.h: 203
try:
    _SC_IOV_MAX = _SC_IOV_MAX
except:
    pass

# /usr/include/bits/confname.h: 205
try:
    _SC_PII_INTERNET_STREAM = _SC_PII_INTERNET_STREAM
except:
    pass

# /usr/include/bits/confname.h: 207
try:
    _SC_PII_INTERNET_DGRAM = _SC_PII_INTERNET_DGRAM
except:
    pass

# /usr/include/bits/confname.h: 209
try:
    _SC_PII_OSI_COTS = _SC_PII_OSI_COTS
except:
    pass

# /usr/include/bits/confname.h: 211
try:
    _SC_PII_OSI_CLTS = _SC_PII_OSI_CLTS
except:
    pass

# /usr/include/bits/confname.h: 213
try:
    _SC_PII_OSI_M = _SC_PII_OSI_M
except:
    pass

# /usr/include/bits/confname.h: 215
try:
    _SC_T_IOV_MAX = _SC_T_IOV_MAX
except:
    pass

# /usr/include/bits/confname.h: 219
try:
    _SC_THREADS = _SC_THREADS
except:
    pass

# /usr/include/bits/confname.h: 221
try:
    _SC_THREAD_SAFE_FUNCTIONS = _SC_THREAD_SAFE_FUNCTIONS
except:
    pass

# /usr/include/bits/confname.h: 223
try:
    _SC_GETGR_R_SIZE_MAX = _SC_GETGR_R_SIZE_MAX
except:
    pass

# /usr/include/bits/confname.h: 225
try:
    _SC_GETPW_R_SIZE_MAX = _SC_GETPW_R_SIZE_MAX
except:
    pass

# /usr/include/bits/confname.h: 227
try:
    _SC_LOGIN_NAME_MAX = _SC_LOGIN_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 229
try:
    _SC_TTY_NAME_MAX = _SC_TTY_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 231
try:
    _SC_THREAD_DESTRUCTOR_ITERATIONS = _SC_THREAD_DESTRUCTOR_ITERATIONS
except:
    pass

# /usr/include/bits/confname.h: 233
try:
    _SC_THREAD_KEYS_MAX = _SC_THREAD_KEYS_MAX
except:
    pass

# /usr/include/bits/confname.h: 235
try:
    _SC_THREAD_STACK_MIN = _SC_THREAD_STACK_MIN
except:
    pass

# /usr/include/bits/confname.h: 237
try:
    _SC_THREAD_THREADS_MAX = _SC_THREAD_THREADS_MAX
except:
    pass

# /usr/include/bits/confname.h: 239
try:
    _SC_THREAD_ATTR_STACKADDR = _SC_THREAD_ATTR_STACKADDR
except:
    pass

# /usr/include/bits/confname.h: 241
try:
    _SC_THREAD_ATTR_STACKSIZE = _SC_THREAD_ATTR_STACKSIZE
except:
    pass

# /usr/include/bits/confname.h: 243
try:
    _SC_THREAD_PRIORITY_SCHEDULING = _SC_THREAD_PRIORITY_SCHEDULING
except:
    pass

# /usr/include/bits/confname.h: 245
try:
    _SC_THREAD_PRIO_INHERIT = _SC_THREAD_PRIO_INHERIT
except:
    pass

# /usr/include/bits/confname.h: 247
try:
    _SC_THREAD_PRIO_PROTECT = _SC_THREAD_PRIO_PROTECT
except:
    pass

# /usr/include/bits/confname.h: 249
try:
    _SC_THREAD_PROCESS_SHARED = _SC_THREAD_PROCESS_SHARED
except:
    pass

# /usr/include/bits/confname.h: 252
try:
    _SC_NPROCESSORS_CONF = _SC_NPROCESSORS_CONF
except:
    pass

# /usr/include/bits/confname.h: 254
try:
    _SC_NPROCESSORS_ONLN = _SC_NPROCESSORS_ONLN
except:
    pass

# /usr/include/bits/confname.h: 256
try:
    _SC_PHYS_PAGES = _SC_PHYS_PAGES
except:
    pass

# /usr/include/bits/confname.h: 258
try:
    _SC_AVPHYS_PAGES = _SC_AVPHYS_PAGES
except:
    pass

# /usr/include/bits/confname.h: 260
try:
    _SC_ATEXIT_MAX = _SC_ATEXIT_MAX
except:
    pass

# /usr/include/bits/confname.h: 262
try:
    _SC_PASS_MAX = _SC_PASS_MAX
except:
    pass

# /usr/include/bits/confname.h: 265
try:
    _SC_XOPEN_VERSION = _SC_XOPEN_VERSION
except:
    pass

# /usr/include/bits/confname.h: 267
try:
    _SC_XOPEN_XCU_VERSION = _SC_XOPEN_XCU_VERSION
except:
    pass

# /usr/include/bits/confname.h: 269
try:
    _SC_XOPEN_UNIX = _SC_XOPEN_UNIX
except:
    pass

# /usr/include/bits/confname.h: 271
try:
    _SC_XOPEN_CRYPT = _SC_XOPEN_CRYPT
except:
    pass

# /usr/include/bits/confname.h: 273
try:
    _SC_XOPEN_ENH_I18N = _SC_XOPEN_ENH_I18N
except:
    pass

# /usr/include/bits/confname.h: 275
try:
    _SC_XOPEN_SHM = _SC_XOPEN_SHM
except:
    pass

# /usr/include/bits/confname.h: 278
try:
    _SC_2_CHAR_TERM = _SC_2_CHAR_TERM
except:
    pass

# /usr/include/bits/confname.h: 280
try:
    _SC_2_C_VERSION = _SC_2_C_VERSION
except:
    pass

# /usr/include/bits/confname.h: 282
try:
    _SC_2_UPE = _SC_2_UPE
except:
    pass

# /usr/include/bits/confname.h: 285
try:
    _SC_XOPEN_XPG2 = _SC_XOPEN_XPG2
except:
    pass

# /usr/include/bits/confname.h: 287
try:
    _SC_XOPEN_XPG3 = _SC_XOPEN_XPG3
except:
    pass

# /usr/include/bits/confname.h: 289
try:
    _SC_XOPEN_XPG4 = _SC_XOPEN_XPG4
except:
    pass

# /usr/include/bits/confname.h: 292
try:
    _SC_CHAR_BIT = _SC_CHAR_BIT
except:
    pass

# /usr/include/bits/confname.h: 294
try:
    _SC_CHAR_MAX = _SC_CHAR_MAX
except:
    pass

# /usr/include/bits/confname.h: 296
try:
    _SC_CHAR_MIN = _SC_CHAR_MIN
except:
    pass

# /usr/include/bits/confname.h: 298
try:
    _SC_INT_MAX = _SC_INT_MAX
except:
    pass

# /usr/include/bits/confname.h: 300
try:
    _SC_INT_MIN = _SC_INT_MIN
except:
    pass

# /usr/include/bits/confname.h: 302
try:
    _SC_LONG_BIT = _SC_LONG_BIT
except:
    pass

# /usr/include/bits/confname.h: 304
try:
    _SC_WORD_BIT = _SC_WORD_BIT
except:
    pass

# /usr/include/bits/confname.h: 306
try:
    _SC_MB_LEN_MAX = _SC_MB_LEN_MAX
except:
    pass

# /usr/include/bits/confname.h: 308
try:
    _SC_NZERO = _SC_NZERO
except:
    pass

# /usr/include/bits/confname.h: 310
try:
    _SC_SSIZE_MAX = _SC_SSIZE_MAX
except:
    pass

# /usr/include/bits/confname.h: 312
try:
    _SC_SCHAR_MAX = _SC_SCHAR_MAX
except:
    pass

# /usr/include/bits/confname.h: 314
try:
    _SC_SCHAR_MIN = _SC_SCHAR_MIN
except:
    pass

# /usr/include/bits/confname.h: 316
try:
    _SC_SHRT_MAX = _SC_SHRT_MAX
except:
    pass

# /usr/include/bits/confname.h: 318
try:
    _SC_SHRT_MIN = _SC_SHRT_MIN
except:
    pass

# /usr/include/bits/confname.h: 320
try:
    _SC_UCHAR_MAX = _SC_UCHAR_MAX
except:
    pass

# /usr/include/bits/confname.h: 322
try:
    _SC_UINT_MAX = _SC_UINT_MAX
except:
    pass

# /usr/include/bits/confname.h: 324
try:
    _SC_ULONG_MAX = _SC_ULONG_MAX
except:
    pass

# /usr/include/bits/confname.h: 326
try:
    _SC_USHRT_MAX = _SC_USHRT_MAX
except:
    pass

# /usr/include/bits/confname.h: 329
try:
    _SC_NL_ARGMAX = _SC_NL_ARGMAX
except:
    pass

# /usr/include/bits/confname.h: 331
try:
    _SC_NL_LANGMAX = _SC_NL_LANGMAX
except:
    pass

# /usr/include/bits/confname.h: 333
try:
    _SC_NL_MSGMAX = _SC_NL_MSGMAX
except:
    pass

# /usr/include/bits/confname.h: 335
try:
    _SC_NL_NMAX = _SC_NL_NMAX
except:
    pass

# /usr/include/bits/confname.h: 337
try:
    _SC_NL_SETMAX = _SC_NL_SETMAX
except:
    pass

# /usr/include/bits/confname.h: 339
try:
    _SC_NL_TEXTMAX = _SC_NL_TEXTMAX
except:
    pass

# /usr/include/bits/confname.h: 342
try:
    _SC_XBS5_ILP32_OFF32 = _SC_XBS5_ILP32_OFF32
except:
    pass

# /usr/include/bits/confname.h: 344
try:
    _SC_XBS5_ILP32_OFFBIG = _SC_XBS5_ILP32_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 346
try:
    _SC_XBS5_LP64_OFF64 = _SC_XBS5_LP64_OFF64
except:
    pass

# /usr/include/bits/confname.h: 348
try:
    _SC_XBS5_LPBIG_OFFBIG = _SC_XBS5_LPBIG_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 351
try:
    _SC_XOPEN_LEGACY = _SC_XOPEN_LEGACY
except:
    pass

# /usr/include/bits/confname.h: 353
try:
    _SC_XOPEN_REALTIME = _SC_XOPEN_REALTIME
except:
    pass

# /usr/include/bits/confname.h: 355
try:
    _SC_XOPEN_REALTIME_THREADS = _SC_XOPEN_REALTIME_THREADS
except:
    pass

# /usr/include/bits/confname.h: 358
try:
    _SC_ADVISORY_INFO = _SC_ADVISORY_INFO
except:
    pass

# /usr/include/bits/confname.h: 360
try:
    _SC_BARRIERS = _SC_BARRIERS
except:
    pass

# /usr/include/bits/confname.h: 362
try:
    _SC_BASE = _SC_BASE
except:
    pass

# /usr/include/bits/confname.h: 364
try:
    _SC_C_LANG_SUPPORT = _SC_C_LANG_SUPPORT
except:
    pass

# /usr/include/bits/confname.h: 366
try:
    _SC_C_LANG_SUPPORT_R = _SC_C_LANG_SUPPORT_R
except:
    pass

# /usr/include/bits/confname.h: 368
try:
    _SC_CLOCK_SELECTION = _SC_CLOCK_SELECTION
except:
    pass

# /usr/include/bits/confname.h: 370
try:
    _SC_CPUTIME = _SC_CPUTIME
except:
    pass

# /usr/include/bits/confname.h: 372
try:
    _SC_THREAD_CPUTIME = _SC_THREAD_CPUTIME
except:
    pass

# /usr/include/bits/confname.h: 374
try:
    _SC_DEVICE_IO = _SC_DEVICE_IO
except:
    pass

# /usr/include/bits/confname.h: 376
try:
    _SC_DEVICE_SPECIFIC = _SC_DEVICE_SPECIFIC
except:
    pass

# /usr/include/bits/confname.h: 378
try:
    _SC_DEVICE_SPECIFIC_R = _SC_DEVICE_SPECIFIC_R
except:
    pass

# /usr/include/bits/confname.h: 380
try:
    _SC_FD_MGMT = _SC_FD_MGMT
except:
    pass

# /usr/include/bits/confname.h: 382
try:
    _SC_FIFO = _SC_FIFO
except:
    pass

# /usr/include/bits/confname.h: 384
try:
    _SC_PIPE = _SC_PIPE
except:
    pass

# /usr/include/bits/confname.h: 386
try:
    _SC_FILE_ATTRIBUTES = _SC_FILE_ATTRIBUTES
except:
    pass

# /usr/include/bits/confname.h: 388
try:
    _SC_FILE_LOCKING = _SC_FILE_LOCKING
except:
    pass

# /usr/include/bits/confname.h: 390
try:
    _SC_FILE_SYSTEM = _SC_FILE_SYSTEM
except:
    pass

# /usr/include/bits/confname.h: 392
try:
    _SC_MONOTONIC_CLOCK = _SC_MONOTONIC_CLOCK
except:
    pass

# /usr/include/bits/confname.h: 394
try:
    _SC_MULTI_PROCESS = _SC_MULTI_PROCESS
except:
    pass

# /usr/include/bits/confname.h: 396
try:
    _SC_SINGLE_PROCESS = _SC_SINGLE_PROCESS
except:
    pass

# /usr/include/bits/confname.h: 398
try:
    _SC_NETWORKING = _SC_NETWORKING
except:
    pass

# /usr/include/bits/confname.h: 400
try:
    _SC_READER_WRITER_LOCKS = _SC_READER_WRITER_LOCKS
except:
    pass

# /usr/include/bits/confname.h: 402
try:
    _SC_SPIN_LOCKS = _SC_SPIN_LOCKS
except:
    pass

# /usr/include/bits/confname.h: 404
try:
    _SC_REGEXP = _SC_REGEXP
except:
    pass

# /usr/include/bits/confname.h: 406
try:
    _SC_REGEX_VERSION = _SC_REGEX_VERSION
except:
    pass

# /usr/include/bits/confname.h: 408
try:
    _SC_SHELL = _SC_SHELL
except:
    pass

# /usr/include/bits/confname.h: 410
try:
    _SC_SIGNALS = _SC_SIGNALS
except:
    pass

# /usr/include/bits/confname.h: 412
try:
    _SC_SPAWN = _SC_SPAWN
except:
    pass

# /usr/include/bits/confname.h: 414
try:
    _SC_SPORADIC_SERVER = _SC_SPORADIC_SERVER
except:
    pass

# /usr/include/bits/confname.h: 416
try:
    _SC_THREAD_SPORADIC_SERVER = _SC_THREAD_SPORADIC_SERVER
except:
    pass

# /usr/include/bits/confname.h: 418
try:
    _SC_SYSTEM_DATABASE = _SC_SYSTEM_DATABASE
except:
    pass

# /usr/include/bits/confname.h: 420
try:
    _SC_SYSTEM_DATABASE_R = _SC_SYSTEM_DATABASE_R
except:
    pass

# /usr/include/bits/confname.h: 422
try:
    _SC_TIMEOUTS = _SC_TIMEOUTS
except:
    pass

# /usr/include/bits/confname.h: 424
try:
    _SC_TYPED_MEMORY_OBJECTS = _SC_TYPED_MEMORY_OBJECTS
except:
    pass

# /usr/include/bits/confname.h: 426
try:
    _SC_USER_GROUPS = _SC_USER_GROUPS
except:
    pass

# /usr/include/bits/confname.h: 428
try:
    _SC_USER_GROUPS_R = _SC_USER_GROUPS_R
except:
    pass

# /usr/include/bits/confname.h: 430
try:
    _SC_2_PBS = _SC_2_PBS
except:
    pass

# /usr/include/bits/confname.h: 432
try:
    _SC_2_PBS_ACCOUNTING = _SC_2_PBS_ACCOUNTING
except:
    pass

# /usr/include/bits/confname.h: 434
try:
    _SC_2_PBS_LOCATE = _SC_2_PBS_LOCATE
except:
    pass

# /usr/include/bits/confname.h: 436
try:
    _SC_2_PBS_MESSAGE = _SC_2_PBS_MESSAGE
except:
    pass

# /usr/include/bits/confname.h: 438
try:
    _SC_2_PBS_TRACK = _SC_2_PBS_TRACK
except:
    pass

# /usr/include/bits/confname.h: 440
try:
    _SC_SYMLOOP_MAX = _SC_SYMLOOP_MAX
except:
    pass

# /usr/include/bits/confname.h: 442
try:
    _SC_STREAMS = _SC_STREAMS
except:
    pass

# /usr/include/bits/confname.h: 444
try:
    _SC_2_PBS_CHECKPOINT = _SC_2_PBS_CHECKPOINT
except:
    pass

# /usr/include/bits/confname.h: 447
try:
    _SC_V6_ILP32_OFF32 = _SC_V6_ILP32_OFF32
except:
    pass

# /usr/include/bits/confname.h: 449
try:
    _SC_V6_ILP32_OFFBIG = _SC_V6_ILP32_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 451
try:
    _SC_V6_LP64_OFF64 = _SC_V6_LP64_OFF64
except:
    pass

# /usr/include/bits/confname.h: 453
try:
    _SC_V6_LPBIG_OFFBIG = _SC_V6_LPBIG_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 456
try:
    _SC_HOST_NAME_MAX = _SC_HOST_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 458
try:
    _SC_TRACE = _SC_TRACE
except:
    pass

# /usr/include/bits/confname.h: 460
try:
    _SC_TRACE_EVENT_FILTER = _SC_TRACE_EVENT_FILTER
except:
    pass

# /usr/include/bits/confname.h: 462
try:
    _SC_TRACE_INHERIT = _SC_TRACE_INHERIT
except:
    pass

# /usr/include/bits/confname.h: 464
try:
    _SC_TRACE_LOG = _SC_TRACE_LOG
except:
    pass

# /usr/include/bits/confname.h: 467
try:
    _SC_LEVEL1_ICACHE_SIZE = _SC_LEVEL1_ICACHE_SIZE
except:
    pass

# /usr/include/bits/confname.h: 469
try:
    _SC_LEVEL1_ICACHE_ASSOC = _SC_LEVEL1_ICACHE_ASSOC
except:
    pass

# /usr/include/bits/confname.h: 471
try:
    _SC_LEVEL1_ICACHE_LINESIZE = _SC_LEVEL1_ICACHE_LINESIZE
except:
    pass

# /usr/include/bits/confname.h: 473
try:
    _SC_LEVEL1_DCACHE_SIZE = _SC_LEVEL1_DCACHE_SIZE
except:
    pass

# /usr/include/bits/confname.h: 475
try:
    _SC_LEVEL1_DCACHE_ASSOC = _SC_LEVEL1_DCACHE_ASSOC
except:
    pass

# /usr/include/bits/confname.h: 477
try:
    _SC_LEVEL1_DCACHE_LINESIZE = _SC_LEVEL1_DCACHE_LINESIZE
except:
    pass

# /usr/include/bits/confname.h: 479
try:
    _SC_LEVEL2_CACHE_SIZE = _SC_LEVEL2_CACHE_SIZE
except:
    pass

# /usr/include/bits/confname.h: 481
try:
    _SC_LEVEL2_CACHE_ASSOC = _SC_LEVEL2_CACHE_ASSOC
except:
    pass

# /usr/include/bits/confname.h: 483
try:
    _SC_LEVEL2_CACHE_LINESIZE = _SC_LEVEL2_CACHE_LINESIZE
except:
    pass

# /usr/include/bits/confname.h: 485
try:
    _SC_LEVEL3_CACHE_SIZE = _SC_LEVEL3_CACHE_SIZE
except:
    pass

# /usr/include/bits/confname.h: 487
try:
    _SC_LEVEL3_CACHE_ASSOC = _SC_LEVEL3_CACHE_ASSOC
except:
    pass

# /usr/include/bits/confname.h: 489
try:
    _SC_LEVEL3_CACHE_LINESIZE = _SC_LEVEL3_CACHE_LINESIZE
except:
    pass

# /usr/include/bits/confname.h: 491
try:
    _SC_LEVEL4_CACHE_SIZE = _SC_LEVEL4_CACHE_SIZE
except:
    pass

# /usr/include/bits/confname.h: 493
try:
    _SC_LEVEL4_CACHE_ASSOC = _SC_LEVEL4_CACHE_ASSOC
except:
    pass

# /usr/include/bits/confname.h: 495
try:
    _SC_LEVEL4_CACHE_LINESIZE = _SC_LEVEL4_CACHE_LINESIZE
except:
    pass

# /usr/include/bits/confname.h: 499
try:
    _SC_IPV6 = _SC_IPV6
except:
    pass

# /usr/include/bits/confname.h: 501
try:
    _SC_RAW_SOCKETS = _SC_RAW_SOCKETS
except:
    pass

# /usr/include/bits/confname.h: 504
try:
    _SC_V7_ILP32_OFF32 = _SC_V7_ILP32_OFF32
except:
    pass

# /usr/include/bits/confname.h: 506
try:
    _SC_V7_ILP32_OFFBIG = _SC_V7_ILP32_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 508
try:
    _SC_V7_LP64_OFF64 = _SC_V7_LP64_OFF64
except:
    pass

# /usr/include/bits/confname.h: 510
try:
    _SC_V7_LPBIG_OFFBIG = _SC_V7_LPBIG_OFFBIG
except:
    pass

# /usr/include/bits/confname.h: 513
try:
    _SC_SS_REPL_MAX = _SC_SS_REPL_MAX
except:
    pass

# /usr/include/bits/confname.h: 516
try:
    _SC_TRACE_EVENT_NAME_MAX = _SC_TRACE_EVENT_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 518
try:
    _SC_TRACE_NAME_MAX = _SC_TRACE_NAME_MAX
except:
    pass

# /usr/include/bits/confname.h: 520
try:
    _SC_TRACE_SYS_MAX = _SC_TRACE_SYS_MAX
except:
    pass

# /usr/include/bits/confname.h: 522
try:
    _SC_TRACE_USER_EVENT_MAX = _SC_TRACE_USER_EVENT_MAX
except:
    pass

# /usr/include/bits/confname.h: 525
try:
    _SC_XOPEN_STREAMS = _SC_XOPEN_STREAMS
except:
    pass

# /usr/include/bits/confname.h: 528
try:
    _SC_THREAD_ROBUST_PRIO_INHERIT = _SC_THREAD_ROBUST_PRIO_INHERIT
except:
    pass

# /usr/include/bits/confname.h: 530
try:
    _SC_THREAD_ROBUST_PRIO_PROTECT = _SC_THREAD_ROBUST_PRIO_PROTECT
except:
    pass

# /usr/include/bits/confname.h: 537
try:
    _CS_PATH = _CS_PATH
except:
    pass

# /usr/include/bits/confname.h: 540
try:
    _CS_V6_WIDTH_RESTRICTED_ENVS = _CS_V6_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 541
try:
    _CS_POSIX_V6_WIDTH_RESTRICTED_ENVS = _CS_V6_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 544
try:
    _CS_GNU_LIBC_VERSION = _CS_GNU_LIBC_VERSION
except:
    pass

# /usr/include/bits/confname.h: 546
try:
    _CS_GNU_LIBPTHREAD_VERSION = _CS_GNU_LIBPTHREAD_VERSION
except:
    pass

# /usr/include/bits/confname.h: 549
try:
    _CS_V5_WIDTH_RESTRICTED_ENVS = _CS_V5_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 550
try:
    _CS_POSIX_V5_WIDTH_RESTRICTED_ENVS = _CS_V5_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 553
try:
    _CS_V7_WIDTH_RESTRICTED_ENVS = _CS_V7_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 554
try:
    _CS_POSIX_V7_WIDTH_RESTRICTED_ENVS = _CS_V7_WIDTH_RESTRICTED_ENVS
except:
    pass

# /usr/include/bits/confname.h: 557
try:
    _CS_LFS_CFLAGS = _CS_LFS_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 559
try:
    _CS_LFS_LDFLAGS = _CS_LFS_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 561
try:
    _CS_LFS_LIBS = _CS_LFS_LIBS
except:
    pass

# /usr/include/bits/confname.h: 563
try:
    _CS_LFS_LINTFLAGS = _CS_LFS_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 565
try:
    _CS_LFS64_CFLAGS = _CS_LFS64_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 567
try:
    _CS_LFS64_LDFLAGS = _CS_LFS64_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 569
try:
    _CS_LFS64_LIBS = _CS_LFS64_LIBS
except:
    pass

# /usr/include/bits/confname.h: 571
try:
    _CS_LFS64_LINTFLAGS = _CS_LFS64_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 574
try:
    _CS_XBS5_ILP32_OFF32_CFLAGS = _CS_XBS5_ILP32_OFF32_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 576
try:
    _CS_XBS5_ILP32_OFF32_LDFLAGS = _CS_XBS5_ILP32_OFF32_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 578
try:
    _CS_XBS5_ILP32_OFF32_LIBS = _CS_XBS5_ILP32_OFF32_LIBS
except:
    pass

# /usr/include/bits/confname.h: 580
try:
    _CS_XBS5_ILP32_OFF32_LINTFLAGS = _CS_XBS5_ILP32_OFF32_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 582
try:
    _CS_XBS5_ILP32_OFFBIG_CFLAGS = _CS_XBS5_ILP32_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 584
try:
    _CS_XBS5_ILP32_OFFBIG_LDFLAGS = _CS_XBS5_ILP32_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 586
try:
    _CS_XBS5_ILP32_OFFBIG_LIBS = _CS_XBS5_ILP32_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 588
try:
    _CS_XBS5_ILP32_OFFBIG_LINTFLAGS = _CS_XBS5_ILP32_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 590
try:
    _CS_XBS5_LP64_OFF64_CFLAGS = _CS_XBS5_LP64_OFF64_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 592
try:
    _CS_XBS5_LP64_OFF64_LDFLAGS = _CS_XBS5_LP64_OFF64_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 594
try:
    _CS_XBS5_LP64_OFF64_LIBS = _CS_XBS5_LP64_OFF64_LIBS
except:
    pass

# /usr/include/bits/confname.h: 596
try:
    _CS_XBS5_LP64_OFF64_LINTFLAGS = _CS_XBS5_LP64_OFF64_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 598
try:
    _CS_XBS5_LPBIG_OFFBIG_CFLAGS = _CS_XBS5_LPBIG_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 600
try:
    _CS_XBS5_LPBIG_OFFBIG_LDFLAGS = _CS_XBS5_LPBIG_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 602
try:
    _CS_XBS5_LPBIG_OFFBIG_LIBS = _CS_XBS5_LPBIG_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 604
try:
    _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS = _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 607
try:
    _CS_POSIX_V6_ILP32_OFF32_CFLAGS = _CS_POSIX_V6_ILP32_OFF32_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 609
try:
    _CS_POSIX_V6_ILP32_OFF32_LDFLAGS = _CS_POSIX_V6_ILP32_OFF32_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 611
try:
    _CS_POSIX_V6_ILP32_OFF32_LIBS = _CS_POSIX_V6_ILP32_OFF32_LIBS
except:
    pass

# /usr/include/bits/confname.h: 613
try:
    _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS = _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 615
try:
    _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS = _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 617
try:
    _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS = _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 619
try:
    _CS_POSIX_V6_ILP32_OFFBIG_LIBS = _CS_POSIX_V6_ILP32_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 621
try:
    _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS = _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 623
try:
    _CS_POSIX_V6_LP64_OFF64_CFLAGS = _CS_POSIX_V6_LP64_OFF64_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 625
try:
    _CS_POSIX_V6_LP64_OFF64_LDFLAGS = _CS_POSIX_V6_LP64_OFF64_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 627
try:
    _CS_POSIX_V6_LP64_OFF64_LIBS = _CS_POSIX_V6_LP64_OFF64_LIBS
except:
    pass

# /usr/include/bits/confname.h: 629
try:
    _CS_POSIX_V6_LP64_OFF64_LINTFLAGS = _CS_POSIX_V6_LP64_OFF64_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 631
try:
    _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS = _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 633
try:
    _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS = _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 635
try:
    _CS_POSIX_V6_LPBIG_OFFBIG_LIBS = _CS_POSIX_V6_LPBIG_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 637
try:
    _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS = _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 640
try:
    _CS_POSIX_V7_ILP32_OFF32_CFLAGS = _CS_POSIX_V7_ILP32_OFF32_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 642
try:
    _CS_POSIX_V7_ILP32_OFF32_LDFLAGS = _CS_POSIX_V7_ILP32_OFF32_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 644
try:
    _CS_POSIX_V7_ILP32_OFF32_LIBS = _CS_POSIX_V7_ILP32_OFF32_LIBS
except:
    pass

# /usr/include/bits/confname.h: 646
try:
    _CS_POSIX_V7_ILP32_OFF32_LINTFLAGS = _CS_POSIX_V7_ILP32_OFF32_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 648
try:
    _CS_POSIX_V7_ILP32_OFFBIG_CFLAGS = _CS_POSIX_V7_ILP32_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 650
try:
    _CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS = _CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 652
try:
    _CS_POSIX_V7_ILP32_OFFBIG_LIBS = _CS_POSIX_V7_ILP32_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 654
try:
    _CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS = _CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 656
try:
    _CS_POSIX_V7_LP64_OFF64_CFLAGS = _CS_POSIX_V7_LP64_OFF64_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 658
try:
    _CS_POSIX_V7_LP64_OFF64_LDFLAGS = _CS_POSIX_V7_LP64_OFF64_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 660
try:
    _CS_POSIX_V7_LP64_OFF64_LIBS = _CS_POSIX_V7_LP64_OFF64_LIBS
except:
    pass

# /usr/include/bits/confname.h: 662
try:
    _CS_POSIX_V7_LP64_OFF64_LINTFLAGS = _CS_POSIX_V7_LP64_OFF64_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 664
try:
    _CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS = _CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS
except:
    pass

# /usr/include/bits/confname.h: 666
try:
    _CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS = _CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS
except:
    pass

# /usr/include/bits/confname.h: 668
try:
    _CS_POSIX_V7_LPBIG_OFFBIG_LIBS = _CS_POSIX_V7_LPBIG_OFFBIG_LIBS
except:
    pass

# /usr/include/bits/confname.h: 670
try:
    _CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS = _CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS
except:
    pass

# /usr/include/bits/confname.h: 673
try:
    _CS_V6_ENV = _CS_V6_ENV
except:
    pass

# /usr/include/bits/confname.h: 675
try:
    _CS_V7_ENV = _CS_V7_ENV
except:
    pass

# /usr/include/unistd.h: 1097
try:
    F_ULOCK = 0
except:
    pass

# /usr/include/unistd.h: 1098
try:
    F_LOCK = 1
except:
    pass

# /usr/include/unistd.h: 1099
try:
    F_TLOCK = 2
except:
    pass

# /usr/include/unistd.h: 1100
try:
    F_TEST = 3
except:
    pass

# /usr/include/math.h: 25
try:
    _MATH_H = 1
except:
    pass

# /usr/include/bits/huge_vall.h: 33
class union_anon_91(Union):
    pass

union_anon_91.__slots__ = [
    '__c',
    '__ld',
]
union_anon_91._fields_ = [
    ('__c', c_ubyte * int(12)),
    ('__ld', c_longdouble),
]

__huge_vall_t = union_anon_91# /usr/include/bits/huge_vall.h: 33

# /usr/include/bits/mathdef.h: 23
try:
    _MATH_H_MATHDEF = 1
except:
    pass

# /usr/include/bits/mathdef.h: 42
try:
    FP_ILOGB0 = ((-2147483647) - 1)
except:
    pass

# /usr/include/bits/mathdef.h: 43
try:
    FP_ILOGBNAN = ((-2147483647) - 1)
except:
    pass

_Mdouble_ = c_double# /usr/include/math.h: 66

_Mfloat_ = c_float# /usr/include/math.h: 83

_Mlong_double_ = c_longdouble# /usr/include/math.h: 126

# /usr/include/math.h: 132
try:
    __MATH_DECLARE_LDOUBLE = 1
except:
    pass

# /usr/include/math.h: 193
try:
    FP_NAN = 0
except:
    pass

# /usr/include/math.h: 196
try:
    FP_INFINITE = 1
except:
    pass

# /usr/include/math.h: 199
try:
    FP_ZERO = 2
except:
    pass

# /usr/include/math.h: 202
try:
    FP_SUBNORMAL = 3
except:
    pass

# /usr/include/math.h: 205
try:
    FP_NORMAL = 4
except:
    pass

# /usr/include/math.h: 214
def fpclassify(x):
    return (sizeof(x) == sizeof(c_float)) and (__fpclassifyf (x)) or (sizeof(x) == sizeof(c_double)) and (__fpclassify (x)) or (__fpclassifyl (x))

# /usr/include/math.h: 226
def signbit(x):
    return (sizeof(x) == sizeof(c_float)) and (__signbitf (x)) or (sizeof(x) == sizeof(c_double)) and (__signbit (x)) or (__signbitl (x))

# /usr/include/math.h: 238
def isfinite(x):
    return (sizeof(x) == sizeof(c_float)) and (__finitef (x)) or (sizeof(x) == sizeof(c_double)) and (__finite (x)) or (__finitel (x))

# /usr/include/math.h: 246
def isnormal(x):
    return ((fpclassify (x)) == FP_NORMAL)

# /usr/include/math.h: 254
def isnan(x):
    return (sizeof(x) == sizeof(c_float)) and (__isnanf (x)) or (sizeof(x) == sizeof(c_double)) and (__isnan (x)) or (__isnanl (x))

# /usr/include/math.h: 266
def isinf(x):
    return (sizeof(x) == sizeof(c_float)) and (__isinff (x)) or (sizeof(x) == sizeof(c_double)) and (__isinf (x)) or (__isinfl (x))

# /usr/include/math.h: 274
try:
    MATH_ERRNO = 1
except:
    pass

# /usr/include/math.h: 275
try:
    MATH_ERREXCEPT = 2
except:
    pass

# /usr/include/math.h: 281
try:
    math_errhandling = (MATH_ERRNO | MATH_ERREXCEPT)
except:
    pass

# /usr/include/math.h: 329
try:
    X_TLOSS = 1.414847550405688e+16
except:
    pass

# /usr/include/math.h: 332
try:
    DOMAIN = 1
except:
    pass

# /usr/include/math.h: 333
try:
    SING = 2
except:
    pass

# /usr/include/math.h: 334
try:
    OVERFLOW = 3
except:
    pass

# /usr/include/math.h: 335
try:
    UNDERFLOW = 4
except:
    pass

# /usr/include/math.h: 336
try:
    TLOSS = 5
except:
    pass

# /usr/include/math.h: 337
try:
    PLOSS = 6
except:
    pass

# /usr/include/math.h: 340
try:
    HUGE = 3.40282347e+38
except:
    pass

# /usr/include/math.h: 354
try:
    M_E = 2.718281828459045
except:
    pass

# /usr/include/math.h: 355
try:
    M_LOG2E = 1.4426950408889634
except:
    pass

# /usr/include/math.h: 356
try:
    M_LOG10E = 0.4342944819032518
except:
    pass

# /usr/include/math.h: 357
try:
    M_LN2 = 0.6931471805599453
except:
    pass

# /usr/include/math.h: 358
try:
    M_LN10 = 2.302585092994046
except:
    pass

# /usr/include/math.h: 359
try:
    M_PI = 3.141592653589793
except:
    pass

# /usr/include/math.h: 360
try:
    M_PI_2 = 1.5707963267948966
except:
    pass

# /usr/include/math.h: 361
try:
    M_PI_4 = 0.7853981633974483
except:
    pass

# /usr/include/math.h: 362
try:
    M_1_PI = 0.3183098861837907
except:
    pass

# /usr/include/math.h: 363
try:
    M_2_PI = 0.6366197723675814
except:
    pass

# /usr/include/math.h: 364
try:
    M_2_SQRTPI = 1.1283791670955126
except:
    pass

# /usr/include/math.h: 365
try:
    M_SQRT2 = 1.4142135623730951
except:
    pass

# /usr/include/math.h: 366
try:
    M_SQRT1_2 = 0.7071067811865476
except:
    pass

# /usr/include/bits/sigset.h: 43
try:
    _SIGSET_H_fns = 1
except:
    pass

# /usr/include/bits/sigset.h: 50
def __sigmask(sig):
    return ((c_ulong (ord_if_char(1))).value << ((sig - 1) % (8 * sizeof(c_ulong))))

# /usr/include/bits/sigset.h: 54
def __sigword(sig):
    return ((sig - 1) / (8 * sizeof(c_ulong)))

# /usr/include/bits/signum.h: 22
try:
    SIG_ERR = (__sighandler_t (ord_if_char((-1)))).value
except:
    pass

# /usr/include/bits/signum.h: 23
try:
    SIG_DFL = (__sighandler_t (ord_if_char(0))).value
except:
    pass

# /usr/include/bits/signum.h: 24
try:
    SIG_IGN = (__sighandler_t (ord_if_char(1))).value
except:
    pass

# /usr/include/bits/signum.h: 32
try:
    SIGHUP = 1
except:
    pass

# /usr/include/bits/signum.h: 33
try:
    SIGINT = 2
except:
    pass

# /usr/include/bits/signum.h: 34
try:
    SIGQUIT = 3
except:
    pass

# /usr/include/bits/signum.h: 35
try:
    SIGILL = 4
except:
    pass

# /usr/include/bits/signum.h: 36
try:
    SIGTRAP = 5
except:
    pass

# /usr/include/bits/signum.h: 37
try:
    SIGABRT = 6
except:
    pass

# /usr/include/bits/signum.h: 38
try:
    SIGIOT = 6
except:
    pass

# /usr/include/bits/signum.h: 39
try:
    SIGBUS = 7
except:
    pass

# /usr/include/bits/signum.h: 40
try:
    SIGFPE = 8
except:
    pass

# /usr/include/bits/signum.h: 41
try:
    SIGKILL = 9
except:
    pass

# /usr/include/bits/signum.h: 42
try:
    SIGUSR1 = 10
except:
    pass

# /usr/include/bits/signum.h: 43
try:
    SIGSEGV = 11
except:
    pass

# /usr/include/bits/signum.h: 44
try:
    SIGUSR2 = 12
except:
    pass

# /usr/include/bits/signum.h: 45
try:
    SIGPIPE = 13
except:
    pass

# /usr/include/bits/signum.h: 46
try:
    SIGALRM = 14
except:
    pass

# /usr/include/bits/signum.h: 47
try:
    SIGTERM = 15
except:
    pass

# /usr/include/bits/signum.h: 48
try:
    SIGSTKFLT = 16
except:
    pass

# /usr/include/bits/signum.h: 49
try:
    SIGCLD = SIGCHLD
except:
    pass

# /usr/include/bits/signum.h: 50
try:
    SIGCHLD = 17
except:
    pass

# /usr/include/bits/signum.h: 51
try:
    SIGCONT = 18
except:
    pass

# /usr/include/bits/signum.h: 52
try:
    SIGSTOP = 19
except:
    pass

# /usr/include/bits/signum.h: 53
try:
    SIGTSTP = 20
except:
    pass

# /usr/include/bits/signum.h: 54
try:
    SIGTTIN = 21
except:
    pass

# /usr/include/bits/signum.h: 55
try:
    SIGTTOU = 22
except:
    pass

# /usr/include/bits/signum.h: 56
try:
    SIGURG = 23
except:
    pass

# /usr/include/bits/signum.h: 57
try:
    SIGXCPU = 24
except:
    pass

# /usr/include/bits/signum.h: 58
try:
    SIGXFSZ = 25
except:
    pass

# /usr/include/bits/signum.h: 59
try:
    SIGVTALRM = 26
except:
    pass

# /usr/include/bits/signum.h: 60
try:
    SIGPROF = 27
except:
    pass

# /usr/include/bits/signum.h: 61
try:
    SIGWINCH = 28
except:
    pass

# /usr/include/bits/signum.h: 62
try:
    SIGPOLL = SIGIO
except:
    pass

# /usr/include/bits/signum.h: 63
try:
    SIGIO = 29
except:
    pass

# /usr/include/bits/signum.h: 64
try:
    SIGPWR = 30
except:
    pass

# /usr/include/bits/signum.h: 65
try:
    SIGSYS = 31
except:
    pass

# /usr/include/bits/signum.h: 66
try:
    SIGUNUSED = 31
except:
    pass

# /usr/include/bits/signum.h: 68
try:
    _NSIG = 65
except:
    pass

# /usr/include/bits/signum.h: 71
try:
    SIGRTMIN = (__libc_current_sigrtmin ())
except:
    pass

# /usr/include/bits/signum.h: 72
try:
    SIGRTMAX = (__libc_current_sigrtmax ())
except:
    pass

# /usr/include/bits/signum.h: 76
try:
    __SIGRTMIN = 32
except:
    pass

# /usr/include/bits/signum.h: 77
try:
    __SIGRTMAX = (_NSIG - 1)
except:
    pass

# /usr/include/bits/wordsize.h: 4
try:
    __WORDSIZE = 64
except:
    pass

# /usr/include/bits/wordsize.h: 10
try:
    __WORDSIZE_TIME64_COMPAT32 = 1
except:
    pass

# /usr/include/bits/wordsize.h: 12
try:
    __SYSCALL_WORDSIZE = 64
except:
    pass

# /usr/include/bits/siginfo.h: 29
try:
    __have_sigval_t = 1
except:
    pass

# /usr/include/bits/siginfo.h: 41
try:
    __have_siginfo_t = 1
except:
    pass

# /usr/include/bits/siginfo.h: 43
try:
    __SI_MAX_SIZE = 128
except:
    pass

# /usr/include/bits/siginfo.h: 45
try:
    __SI_PAD_SIZE = ((__SI_MAX_SIZE / sizeof(c_int)) - 4)
except:
    pass

# /usr/include/bits/siginfo.h: 154
try:
    SI_ASYNCNL = SI_ASYNCNL
except:
    pass

# /usr/include/bits/siginfo.h: 156
try:
    SI_TKILL = SI_TKILL
except:
    pass

# /usr/include/bits/siginfo.h: 158
try:
    SI_SIGIO = SI_SIGIO
except:
    pass

# /usr/include/bits/siginfo.h: 160
try:
    SI_ASYNCIO = SI_ASYNCIO
except:
    pass

# /usr/include/bits/siginfo.h: 162
try:
    SI_MESGQ = SI_MESGQ
except:
    pass

# /usr/include/bits/siginfo.h: 164
try:
    SI_TIMER = SI_TIMER
except:
    pass

# /usr/include/bits/siginfo.h: 166
try:
    SI_QUEUE = SI_QUEUE
except:
    pass

# /usr/include/bits/siginfo.h: 168
try:
    SI_USER = SI_USER
except:
    pass

# /usr/include/bits/siginfo.h: 170
try:
    SI_KERNEL = SI_KERNEL
except:
    pass

# /usr/include/bits/siginfo.h: 178
try:
    ILL_ILLOPC = ILL_ILLOPC
except:
    pass

# /usr/include/bits/siginfo.h: 180
try:
    ILL_ILLOPN = ILL_ILLOPN
except:
    pass

# /usr/include/bits/siginfo.h: 182
try:
    ILL_ILLADR = ILL_ILLADR
except:
    pass

# /usr/include/bits/siginfo.h: 184
try:
    ILL_ILLTRP = ILL_ILLTRP
except:
    pass

# /usr/include/bits/siginfo.h: 186
try:
    ILL_PRVOPC = ILL_PRVOPC
except:
    pass

# /usr/include/bits/siginfo.h: 188
try:
    ILL_PRVREG = ILL_PRVREG
except:
    pass

# /usr/include/bits/siginfo.h: 190
try:
    ILL_COPROC = ILL_COPROC
except:
    pass

# /usr/include/bits/siginfo.h: 192
try:
    ILL_BADSTK = ILL_BADSTK
except:
    pass

# /usr/include/bits/siginfo.h: 199
try:
    FPE_INTDIV = FPE_INTDIV
except:
    pass

# /usr/include/bits/siginfo.h: 201
try:
    FPE_INTOVF = FPE_INTOVF
except:
    pass

# /usr/include/bits/siginfo.h: 203
try:
    FPE_FLTDIV = FPE_FLTDIV
except:
    pass

# /usr/include/bits/siginfo.h: 205
try:
    FPE_FLTOVF = FPE_FLTOVF
except:
    pass

# /usr/include/bits/siginfo.h: 207
try:
    FPE_FLTUND = FPE_FLTUND
except:
    pass

# /usr/include/bits/siginfo.h: 209
try:
    FPE_FLTRES = FPE_FLTRES
except:
    pass

# /usr/include/bits/siginfo.h: 211
try:
    FPE_FLTINV = FPE_FLTINV
except:
    pass

# /usr/include/bits/siginfo.h: 213
try:
    FPE_FLTSUB = FPE_FLTSUB
except:
    pass

# /usr/include/bits/siginfo.h: 220
try:
    SEGV_MAPERR = SEGV_MAPERR
except:
    pass

# /usr/include/bits/siginfo.h: 222
try:
    SEGV_ACCERR = SEGV_ACCERR
except:
    pass

# /usr/include/bits/siginfo.h: 229
try:
    BUS_ADRALN = BUS_ADRALN
except:
    pass

# /usr/include/bits/siginfo.h: 231
try:
    BUS_ADRERR = BUS_ADRERR
except:
    pass

# /usr/include/bits/siginfo.h: 233
try:
    BUS_OBJERR = BUS_OBJERR
except:
    pass

# /usr/include/bits/siginfo.h: 240
try:
    TRAP_BRKPT = TRAP_BRKPT
except:
    pass

# /usr/include/bits/siginfo.h: 242
try:
    TRAP_TRACE = TRAP_TRACE
except:
    pass

# /usr/include/bits/siginfo.h: 249
try:
    CLD_EXITED = CLD_EXITED
except:
    pass

# /usr/include/bits/siginfo.h: 251
try:
    CLD_KILLED = CLD_KILLED
except:
    pass

# /usr/include/bits/siginfo.h: 253
try:
    CLD_DUMPED = CLD_DUMPED
except:
    pass

# /usr/include/bits/siginfo.h: 255
try:
    CLD_TRAPPED = CLD_TRAPPED
except:
    pass

# /usr/include/bits/siginfo.h: 257
try:
    CLD_STOPPED = CLD_STOPPED
except:
    pass

# /usr/include/bits/siginfo.h: 259
try:
    CLD_CONTINUED = CLD_CONTINUED
except:
    pass

# /usr/include/bits/siginfo.h: 266
try:
    POLL_IN = POLL_IN
except:
    pass

# /usr/include/bits/siginfo.h: 268
try:
    POLL_OUT = POLL_OUT
except:
    pass

# /usr/include/bits/siginfo.h: 270
try:
    POLL_MSG = POLL_MSG
except:
    pass

# /usr/include/bits/siginfo.h: 272
try:
    POLL_ERR = POLL_ERR
except:
    pass

# /usr/include/bits/siginfo.h: 274
try:
    POLL_PRI = POLL_PRI
except:
    pass

# /usr/include/bits/siginfo.h: 276
try:
    POLL_HUP = POLL_HUP
except:
    pass

# /usr/include/bits/siginfo.h: 285
try:
    __have_sigevent_t = 1
except:
    pass

# /usr/include/bits/siginfo.h: 288
try:
    __SIGEV_MAX_SIZE = 64
except:
    pass

# /usr/include/bits/siginfo.h: 290
try:
    __SIGEV_PAD_SIZE = ((__SIGEV_MAX_SIZE / sizeof(c_int)) - 4)
except:
    pass

# /usr/include/bits/siginfo.h: 331
try:
    SIGEV_SIGNAL = SIGEV_SIGNAL
except:
    pass

# /usr/include/bits/siginfo.h: 333
try:
    SIGEV_NONE = SIGEV_NONE
except:
    pass

# /usr/include/bits/siginfo.h: 335
try:
    SIGEV_THREAD = SIGEV_THREAD
except:
    pass

# /usr/include/bits/siginfo.h: 338
try:
    SIGEV_THREAD_ID = SIGEV_THREAD_ID
except:
    pass

# /usr/include/signal.h: 194
def sigmask(sig):
    return (__sigmask (sig))

# /usr/include/signal.h: 208
try:
    NSIG = _NSIG
except:
    pass

# /usr/include/bits/sigaction.h: 53
try:
    SA_NOCLDSTOP = 1
except:
    pass

# /usr/include/bits/sigaction.h: 54
try:
    SA_NOCLDWAIT = 2
except:
    pass

# /usr/include/bits/sigaction.h: 55
try:
    SA_SIGINFO = 4
except:
    pass

# /usr/include/bits/sigaction.h: 58
try:
    SA_ONSTACK = 134217728
except:
    pass

# /usr/include/bits/sigaction.h: 61
try:
    SA_RESTART = 268435456
except:
    pass

# /usr/include/bits/sigaction.h: 62
try:
    SA_NODEFER = 1073741824
except:
    pass

# /usr/include/bits/sigaction.h: 64
try:
    SA_RESETHAND = 2147483648
except:
    pass

# /usr/include/bits/sigaction.h: 67
try:
    SA_INTERRUPT = 536870912
except:
    pass

# /usr/include/bits/sigaction.h: 70
try:
    SA_NOMASK = SA_NODEFER
except:
    pass

# /usr/include/bits/sigaction.h: 71
try:
    SA_ONESHOT = SA_RESETHAND
except:
    pass

# /usr/include/bits/sigaction.h: 72
try:
    SA_STACK = SA_ONSTACK
except:
    pass

# /usr/include/bits/sigaction.h: 76
try:
    SIG_BLOCK = 0
except:
    pass

# /usr/include/bits/sigaction.h: 77
try:
    SIG_UNBLOCK = 1
except:
    pass

# /usr/include/bits/sigaction.h: 78
try:
    SIG_SETMASK = 2
except:
    pass

# /usr/include/signal.h: 325
try:
    SV_ONSTACK = (1 << 0)
except:
    pass

# /usr/include/signal.h: 326
try:
    SV_INTERRUPT = (1 << 1)
except:
    pass

# /usr/include/signal.h: 327
try:
    SV_RESETHAND = (1 << 2)
except:
    pass

# /usr/include/bits/sigcontext.h: 19
try:
    _BITS_SIGCONTEXT_H = 1
except:
    pass

# /usr/include/bits/sigcontext.h: 25
try:
    FP_XSTATE_MAGIC1 = 1179670611
except:
    pass

# /usr/include/bits/sigcontext.h: 26
try:
    FP_XSTATE_MAGIC2 = 1179670597
except:
    pass

# /usr/include/bits/sigcontext.h: 27
try:
    FP_XSTATE_MAGIC2_SIZE = sizeof(FP_XSTATE_MAGIC2)
except:
    pass

# /usr/include/bits/sigstack.h: 36
try:
    SS_ONSTACK = SS_ONSTACK
except:
    pass

# /usr/include/bits/sigstack.h: 38
try:
    SS_DISABLE = SS_DISABLE
except:
    pass

# /usr/include/bits/sigstack.h: 42
try:
    MINSIGSTKSZ = 2048
except:
    pass

# /usr/include/bits/sigstack.h: 45
try:
    SIGSTKSZ = 8192
except:
    pass

# /usr/include/sys/ucontext.h: 19
try:
    _SYS_UCONTEXT_H = 1
except:
    pass

# /usr/include/sys/ucontext.h: 34
try:
    NGREG = 23
except:
    pass

# /usr/include/bits/sigthread.h: 20
try:
    _BITS_SIGTHREAD_H = 1
except:
    pass

# /usr/include/fcntl.h: 23
try:
    _FCNTL_H = 1
except:
    pass

# /usr/include/bits/fcntl.h: 24
try:
    __O_LARGEFILE = 0
except:
    pass

# /usr/include/bits/fcntl.h: 29
try:
    F_GETLK64 = 5
except:
    pass

# /usr/include/bits/fcntl.h: 30
try:
    F_SETLK64 = 6
except:
    pass

# /usr/include/bits/fcntl.h: 31
try:
    F_SETLKW64 = 7
except:
    pass

# /usr/include/bits/fcntl-linux.h: 42
try:
    O_ACCMODE = 3
except:
    pass

# /usr/include/bits/fcntl-linux.h: 43
try:
    O_RDONLY = 0
except:
    pass

# /usr/include/bits/fcntl-linux.h: 44
try:
    O_WRONLY = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 45
try:
    O_RDWR = 2
except:
    pass

# /usr/include/bits/fcntl-linux.h: 47
try:
    O_CREAT = 100
except:
    pass

# /usr/include/bits/fcntl-linux.h: 50
try:
    O_EXCL = 200
except:
    pass

# /usr/include/bits/fcntl-linux.h: 53
try:
    O_NOCTTY = 400
except:
    pass

# /usr/include/bits/fcntl-linux.h: 56
try:
    O_TRUNC = 1000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 59
try:
    O_APPEND = 2000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 62
try:
    O_NONBLOCK = 4000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 65
try:
    O_NDELAY = O_NONBLOCK
except:
    pass

# /usr/include/bits/fcntl-linux.h: 68
try:
    O_SYNC = 4010000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 70
try:
    O_FSYNC = O_SYNC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 72
try:
    O_ASYNC = 20000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 79
try:
    __O_DIRECTORY = 200000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 82
try:
    __O_NOFOLLOW = 400000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 85
try:
    __O_CLOEXEC = 2000000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 88
try:
    __O_DIRECT = 40000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 91
try:
    __O_NOATIME = 1000000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 94
try:
    __O_PATH = 10000000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 97
try:
    __O_DSYNC = 10000
except:
    pass

# /usr/include/bits/fcntl-linux.h: 100
try:
    __O_TMPFILE = (20000000 | __O_DIRECTORY)
except:
    pass

# /usr/include/bits/fcntl-linux.h: 105
try:
    F_GETLK = 5
except:
    pass

# /usr/include/bits/fcntl-linux.h: 106
try:
    F_SETLK = 6
except:
    pass

# /usr/include/bits/fcntl-linux.h: 107
try:
    F_SETLKW = 7
except:
    pass

# /usr/include/bits/fcntl-linux.h: 144
try:
    O_DIRECTORY = __O_DIRECTORY
except:
    pass

# /usr/include/bits/fcntl-linux.h: 145
try:
    O_NOFOLLOW = __O_NOFOLLOW
except:
    pass

# /usr/include/bits/fcntl-linux.h: 146
try:
    O_CLOEXEC = __O_CLOEXEC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 160
try:
    O_DSYNC = __O_DSYNC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 164
try:
    O_RSYNC = O_SYNC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 169
try:
    F_DUPFD = 0
except:
    pass

# /usr/include/bits/fcntl-linux.h: 170
try:
    F_GETFD = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 171
try:
    F_SETFD = 2
except:
    pass

# /usr/include/bits/fcntl-linux.h: 172
try:
    F_GETFL = 3
except:
    pass

# /usr/include/bits/fcntl-linux.h: 173
try:
    F_SETFL = 4
except:
    pass

# /usr/include/bits/fcntl-linux.h: 176
try:
    __F_SETOWN = 8
except:
    pass

# /usr/include/bits/fcntl-linux.h: 177
try:
    __F_GETOWN = 9
except:
    pass

# /usr/include/bits/fcntl-linux.h: 181
try:
    F_SETOWN = __F_SETOWN
except:
    pass

# /usr/include/bits/fcntl-linux.h: 182
try:
    F_GETOWN = __F_GETOWN
except:
    pass

# /usr/include/bits/fcntl-linux.h: 186
try:
    __F_SETSIG = 10
except:
    pass

# /usr/include/bits/fcntl-linux.h: 187
try:
    __F_GETSIG = 11
except:
    pass

# /usr/include/bits/fcntl-linux.h: 190
try:
    __F_SETOWN_EX = 15
except:
    pass

# /usr/include/bits/fcntl-linux.h: 191
try:
    __F_GETOWN_EX = 16
except:
    pass

# /usr/include/bits/fcntl-linux.h: 209
try:
    F_DUPFD_CLOEXEC = 1030
except:
    pass

# /usr/include/bits/fcntl-linux.h: 214
try:
    FD_CLOEXEC = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 218
try:
    F_RDLCK = 0
except:
    pass

# /usr/include/bits/fcntl-linux.h: 219
try:
    F_WRLCK = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 220
try:
    F_UNLCK = 2
except:
    pass

# /usr/include/bits/fcntl-linux.h: 226
try:
    F_EXLCK = 4
except:
    pass

# /usr/include/bits/fcntl-linux.h: 227
try:
    F_SHLCK = 8
except:
    pass

# /usr/include/bits/fcntl-linux.h: 232
try:
    LOCK_SH = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 233
try:
    LOCK_EX = 2
except:
    pass

# /usr/include/bits/fcntl-linux.h: 234
try:
    LOCK_NB = 4
except:
    pass

# /usr/include/bits/fcntl-linux.h: 236
try:
    LOCK_UN = 8
except:
    pass

# /usr/include/bits/fcntl-linux.h: 279
try:
    FAPPEND = O_APPEND
except:
    pass

# /usr/include/bits/fcntl-linux.h: 280
try:
    FFSYNC = O_FSYNC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 281
try:
    FASYNC = O_ASYNC
except:
    pass

# /usr/include/bits/fcntl-linux.h: 282
try:
    FNONBLOCK = O_NONBLOCK
except:
    pass

# /usr/include/bits/fcntl-linux.h: 283
try:
    FNDELAY = O_NDELAY
except:
    pass

# /usr/include/bits/fcntl-linux.h: 287
try:
    __POSIX_FADV_DONTNEED = 4
except:
    pass

# /usr/include/bits/fcntl-linux.h: 288
try:
    __POSIX_FADV_NOREUSE = 5
except:
    pass

# /usr/include/bits/fcntl-linux.h: 292
try:
    POSIX_FADV_NORMAL = 0
except:
    pass

# /usr/include/bits/fcntl-linux.h: 293
try:
    POSIX_FADV_RANDOM = 1
except:
    pass

# /usr/include/bits/fcntl-linux.h: 294
try:
    POSIX_FADV_SEQUENTIAL = 2
except:
    pass

# /usr/include/bits/fcntl-linux.h: 295
try:
    POSIX_FADV_WILLNEED = 3
except:
    pass

# /usr/include/bits/fcntl-linux.h: 296
try:
    POSIX_FADV_DONTNEED = __POSIX_FADV_DONTNEED
except:
    pass

# /usr/include/bits/fcntl-linux.h: 297
try:
    POSIX_FADV_NOREUSE = __POSIX_FADV_NOREUSE
except:
    pass

# /usr/include/fcntl.h: 40
def __OPEN_NEEDS_MODE(oflag):
    return (((oflag & O_CREAT) != 0) or ((oflag & __O_TMPFILE) == __O_TMPFILE))

# /usr/include/bits/stat.h: 23
try:
    _BITS_STAT_H = 1
except:
    pass

# /usr/include/bits/stat.h: 37
try:
    _STAT_VER_KERNEL = 0
except:
    pass

# /usr/include/bits/stat.h: 38
try:
    _STAT_VER_LINUX = 1
except:
    pass

# /usr/include/bits/stat.h: 41
try:
    _MKNOD_VER_LINUX = 0
except:
    pass

# /usr/include/bits/stat.h: 44
try:
    _STAT_VER = _STAT_VER_LINUX
except:
    pass

# /usr/include/bits/stat.h: 179
try:
    __S_IFMT = 170000
except:
    pass

# /usr/include/bits/stat.h: 182
try:
    __S_IFDIR = 40000
except:
    pass

# /usr/include/bits/stat.h: 183
try:
    __S_IFCHR = 20000
except:
    pass

# /usr/include/bits/stat.h: 184
try:
    __S_IFBLK = 60000
except:
    pass

# /usr/include/bits/stat.h: 185
try:
    __S_IFREG = 100000
except:
    pass

# /usr/include/bits/stat.h: 186
try:
    __S_IFIFO = 10000
except:
    pass

# /usr/include/bits/stat.h: 187
try:
    __S_IFLNK = 120000
except:
    pass

# /usr/include/bits/stat.h: 188
try:
    __S_IFSOCK = 140000
except:
    pass

# /usr/include/bits/stat.h: 192
def __S_TYPEISMQ(buf):
    return (((buf.contents.st_mode).value) - ((buf.contents.st_mode).value))

# /usr/include/bits/stat.h: 193
def __S_TYPEISSEM(buf):
    return (((buf.contents.st_mode).value) - ((buf.contents.st_mode).value))

# /usr/include/bits/stat.h: 194
def __S_TYPEISSHM(buf):
    return (((buf.contents.st_mode).value) - ((buf.contents.st_mode).value))

# /usr/include/bits/stat.h: 198
try:
    __S_ISUID = 4000
except:
    pass

# /usr/include/bits/stat.h: 199
try:
    __S_ISGID = 2000
except:
    pass

# /usr/include/bits/stat.h: 200
try:
    __S_ISVTX = 1000
except:
    pass

# /usr/include/bits/stat.h: 201
try:
    __S_IREAD = 400
except:
    pass

# /usr/include/bits/stat.h: 202
try:
    __S_IWRITE = 200
except:
    pass

# /usr/include/bits/stat.h: 203
try:
    __S_IEXEC = 100
except:
    pass

# /usr/include/bits/stat.h: 206
try:
    UTIME_NOW = ((1.0 << 30) - 1.0)
except:
    pass

# /usr/include/bits/stat.h: 207
try:
    UTIME_OMIT = ((1.0 << 30) - 2.0)
except:
    pass

# /usr/include/fcntl.h: 79
try:
    S_IFMT = __S_IFMT
except:
    pass

# /usr/include/fcntl.h: 80
try:
    S_IFDIR = __S_IFDIR
except:
    pass

# /usr/include/fcntl.h: 81
try:
    S_IFCHR = __S_IFCHR
except:
    pass

# /usr/include/fcntl.h: 82
try:
    S_IFBLK = __S_IFBLK
except:
    pass

# /usr/include/fcntl.h: 83
try:
    S_IFREG = __S_IFREG
except:
    pass

# /usr/include/fcntl.h: 85
try:
    S_IFIFO = __S_IFIFO
except:
    pass

# /usr/include/fcntl.h: 88
try:
    S_IFLNK = __S_IFLNK
except:
    pass

# /usr/include/fcntl.h: 91
try:
    S_IFSOCK = __S_IFSOCK
except:
    pass

# /usr/include/fcntl.h: 96
try:
    S_ISUID = __S_ISUID
except:
    pass

# /usr/include/fcntl.h: 97
try:
    S_ISGID = __S_ISGID
except:
    pass

# /usr/include/fcntl.h: 101
try:
    S_ISVTX = __S_ISVTX
except:
    pass

# /usr/include/fcntl.h: 104
try:
    S_IRUSR = __S_IREAD
except:
    pass

# /usr/include/fcntl.h: 105
try:
    S_IWUSR = __S_IWRITE
except:
    pass

# /usr/include/fcntl.h: 106
try:
    S_IXUSR = __S_IEXEC
except:
    pass

# /usr/include/fcntl.h: 108
try:
    S_IRWXU = ((__S_IREAD | __S_IWRITE) | __S_IEXEC)
except:
    pass

# /usr/include/fcntl.h: 110
try:
    S_IRGRP = (S_IRUSR >> 3)
except:
    pass

# /usr/include/fcntl.h: 111
try:
    S_IWGRP = (S_IWUSR >> 3)
except:
    pass

# /usr/include/fcntl.h: 112
try:
    S_IXGRP = (S_IXUSR >> 3)
except:
    pass

# /usr/include/fcntl.h: 114
try:
    S_IRWXG = (S_IRWXU >> 3)
except:
    pass

# /usr/include/fcntl.h: 116
try:
    S_IROTH = (S_IRGRP >> 3)
except:
    pass

# /usr/include/fcntl.h: 117
try:
    S_IWOTH = (S_IWGRP >> 3)
except:
    pass

# /usr/include/fcntl.h: 118
try:
    S_IXOTH = (S_IXGRP >> 3)
except:
    pass

# /usr/include/fcntl.h: 120
try:
    S_IRWXO = (S_IRWXG >> 3)
except:
    pass

# /usr/include/fcntl.h: 136
try:
    SEEK_SET = 0
except:
    pass

# /usr/include/fcntl.h: 137
try:
    SEEK_CUR = 1
except:
    pass

# /usr/include/fcntl.h: 138
try:
    SEEK_END = 2
except:
    pass

# /usr/include/fcntl.h: 142
try:
    AT_FDCWD = (-100)
except:
    pass

# /usr/include/fcntl.h: 145
try:
    AT_SYMLINK_NOFOLLOW = 256
except:
    pass

# /usr/include/fcntl.h: 146
try:
    AT_REMOVEDIR = 512
except:
    pass

# /usr/include/fcntl.h: 148
try:
    AT_SYMLINK_FOLLOW = 1024
except:
    pass

# /usr/include/fcntl.h: 154
try:
    AT_EACCESS = 512
except:
    pass

# /usr/include/ctype.h: 24
try:
    _CTYPE_H = 1
except:
    pass

# /usr/include/ctype.h: 44
def _ISbit(bit):
    return (bit < 8) and ((1 << bit) << 8) or ((1 << bit) >> 8)

# /usr/include/ctype.h: 89
def __isctype(c, type):
    return ((((__ctype_b_loc ())[0]) [(c_int (ord_if_char(c))).value]) & (c_uint (ord_if_char(type))).value)

# /usr/include/ctype.h: 100
def __isascii(c):
    return ((c & (~127)) == 0)

# /usr/include/ctype.h: 101
def __toascii(c):
    return (c & 127)

# /usr/include/ctype.h: 198
def isalnum(c):
    return (__isctype (c, _ISalnum))

# /usr/include/ctype.h: 199
def isalpha(c):
    return (__isctype (c, _ISalpha))

# /usr/include/ctype.h: 200
def iscntrl(c):
    return (__isctype (c, _IScntrl))

# /usr/include/ctype.h: 201
def isdigit(c):
    return (__isctype (c, _ISdigit))

# /usr/include/ctype.h: 202
def islower(c):
    return (__isctype (c, _ISlower))

# /usr/include/ctype.h: 203
def isgraph(c):
    return (__isctype (c, _ISgraph))

# /usr/include/ctype.h: 204
def isprint(c):
    return (__isctype (c, _ISprint))

# /usr/include/ctype.h: 205
def ispunct(c):
    return (__isctype (c, _ISpunct))

# /usr/include/ctype.h: 206
def isspace(c):
    return (__isctype (c, _ISspace))

# /usr/include/ctype.h: 207
def isupper(c):
    return (__isctype (c, _ISupper))

# /usr/include/ctype.h: 208
def isxdigit(c):
    return (__isctype (c, _ISxdigit))

# /usr/include/ctype.h: 210
def isblank(c):
    return (__isctype (c, _ISblank))

# /usr/include/ctype.h: 234
def isascii(c):
    return (__isascii (c))

# /usr/include/ctype.h: 235
def toascii(c):
    return (__toascii (c))

# /usr/include/ctype.h: 237
def _tolower(c):
    return (c_int (ord_if_char((((__ctype_tolower_loc ())[0]) [(c_int (ord_if_char(c))).value])))).value

# /usr/include/ctype.h: 238
def _toupper(c):
    return (c_int (ord_if_char((((__ctype_toupper_loc ())[0]) [(c_int (ord_if_char(c))).value])))).value

# /usr/include/ctype.h: 262
def __isctype_l(c, type, locale):
    return ((((locale.contents.__ctype_b).value) [(c_int (ord_if_char(c))).value]) & (c_uint (ord_if_char(type))).value)

# /usr/include/ctype.h: 306
def __isalnum_l(c, l):
    return (__isctype_l (c, _ISalnum, l))

# /usr/include/ctype.h: 307
def __isalpha_l(c, l):
    return (__isctype_l (c, _ISalpha, l))

# /usr/include/ctype.h: 308
def __iscntrl_l(c, l):
    return (__isctype_l (c, _IScntrl, l))

# /usr/include/ctype.h: 309
def __isdigit_l(c, l):
    return (__isctype_l (c, _ISdigit, l))

# /usr/include/ctype.h: 310
def __islower_l(c, l):
    return (__isctype_l (c, _ISlower, l))

# /usr/include/ctype.h: 311
def __isgraph_l(c, l):
    return (__isctype_l (c, _ISgraph, l))

# /usr/include/ctype.h: 312
def __isprint_l(c, l):
    return (__isctype_l (c, _ISprint, l))

# /usr/include/ctype.h: 313
def __ispunct_l(c, l):
    return (__isctype_l (c, _ISpunct, l))

# /usr/include/ctype.h: 314
def __isspace_l(c, l):
    return (__isctype_l (c, _ISspace, l))

# /usr/include/ctype.h: 315
def __isupper_l(c, l):
    return (__isctype_l (c, _ISupper, l))

# /usr/include/ctype.h: 316
def __isxdigit_l(c, l):
    return (__isctype_l (c, _ISxdigit, l))

# /usr/include/ctype.h: 318
def __isblank_l(c, l):
    return (__isctype_l (c, _ISblank, l))

# /usr/include/ctype.h: 321
def __isascii_l(c, l):
    return l

# /usr/include/ctype.h: 322
def __toascii_l(c, l):
    return l

# /usr/include/ctype.h: 325
def isalnum_l(c, l):
    return (__isalnum_l (c, l))

# /usr/include/ctype.h: 326
def isalpha_l(c, l):
    return (__isalpha_l (c, l))

# /usr/include/ctype.h: 327
def iscntrl_l(c, l):
    return (__iscntrl_l (c, l))

# /usr/include/ctype.h: 328
def isdigit_l(c, l):
    return (__isdigit_l (c, l))

# /usr/include/ctype.h: 329
def islower_l(c, l):
    return (__islower_l (c, l))

# /usr/include/ctype.h: 330
def isgraph_l(c, l):
    return (__isgraph_l (c, l))

# /usr/include/ctype.h: 331
def isprint_l(c, l):
    return (__isprint_l (c, l))

# /usr/include/ctype.h: 332
def ispunct_l(c, l):
    return (__ispunct_l (c, l))

# /usr/include/ctype.h: 333
def isspace_l(c, l):
    return (__isspace_l (c, l))

# /usr/include/ctype.h: 334
def isupper_l(c, l):
    return (__isupper_l (c, l))

# /usr/include/ctype.h: 335
def isxdigit_l(c, l):
    return (__isxdigit_l (c, l))

# /usr/include/ctype.h: 337
def isblank_l(c, l):
    return (__isblank_l (c, l))

# /usr/include/ctype.h: 340
def isascii_l(c, l):
    return (__isascii_l (c, l))

# /usr/include/ctype.h: 341
def toascii_l(c, l):
    return (__toascii_l (c, l))

# /usr/include/dirent.h: 24
try:
    _DIRENT_H = 1
except:
    pass

# /usr/include/bits/dirent.h: 56
try:
    _DIRENT_MATCHES_DIRENT64 = 1
except:
    pass

# /usr/include/dirent.h: 86
def _D_EXACT_NAMLEN(d):
    return (strlen ((d.contents.d_name)))

# /usr/include/dirent.h: 88
def _D_ALLOC_NAMLEN(d):
    return (((String (ord_if_char(d))).value + ((d.contents.d_reclen).value)) - pointer((((d.contents.d_name).value) [0])))

# /usr/include/dirent.h: 101
try:
    DT_UNKNOWN = DT_UNKNOWN
except:
    pass

# /usr/include/dirent.h: 103
try:
    DT_FIFO = DT_FIFO
except:
    pass

# /usr/include/dirent.h: 105
try:
    DT_CHR = DT_CHR
except:
    pass

# /usr/include/dirent.h: 107
try:
    DT_DIR = DT_DIR
except:
    pass

# /usr/include/dirent.h: 109
try:
    DT_BLK = DT_BLK
except:
    pass

# /usr/include/dirent.h: 111
try:
    DT_REG = DT_REG
except:
    pass

# /usr/include/dirent.h: 113
try:
    DT_LNK = DT_LNK
except:
    pass

# /usr/include/dirent.h: 115
try:
    DT_SOCK = DT_SOCK
except:
    pass

# /usr/include/dirent.h: 117
try:
    DT_WHT = DT_WHT
except:
    pass

# /usr/include/dirent.h: 121
def IFTODT(mode):
    return ((mode & 170000) >> 12)

# /usr/include/dirent.h: 122
def DTTOIF(dirtype):
    return (dirtype << 12)

# /usr/include/dirent.h: 237
try:
    MAXNAMLEN = NAME_MAX
except:
    pass

# /usr/include/sys/time.h: 20
try:
    _SYS_TIME_H = 1
except:
    pass

# /usr/include/sys/time.h: 96
try:
    ITIMER_REAL = ITIMER_REAL
except:
    pass

# /usr/include/sys/time.h: 99
try:
    ITIMER_VIRTUAL = ITIMER_VIRTUAL
except:
    pass

# /usr/include/sys/time.h: 103
try:
    ITIMER_PROF = ITIMER_PROF
except:
    pass

# /usr/include/sys/time.h: 163
def timerisset(tvp):
    return ((tvp.contents.tv_sec) or (tvp.contents.tv_usec))

# /usr/include/sys/time.h: 164
def timerclear(tvp):
    return 0

# /usr/include/sys/timeb.h: 19
try:
    _SYS_TIMEB_H = 1
except:
    pass

# /usr/include/sys/stat.h: 24
try:
    _SYS_STAT_H = 1
except:
    pass

# /usr/include/sys/stat.h: 109
try:
    S_IFMT = __S_IFMT
except:
    pass

# /usr/include/sys/stat.h: 110
try:
    S_IFDIR = __S_IFDIR
except:
    pass

# /usr/include/sys/stat.h: 111
try:
    S_IFCHR = __S_IFCHR
except:
    pass

# /usr/include/sys/stat.h: 112
try:
    S_IFBLK = __S_IFBLK
except:
    pass

# /usr/include/sys/stat.h: 113
try:
    S_IFREG = __S_IFREG
except:
    pass

# /usr/include/sys/stat.h: 115
try:
    S_IFIFO = __S_IFIFO
except:
    pass

# /usr/include/sys/stat.h: 118
try:
    S_IFLNK = __S_IFLNK
except:
    pass

# /usr/include/sys/stat.h: 122
try:
    S_IFSOCK = __S_IFSOCK
except:
    pass

# /usr/include/sys/stat.h: 128
def __S_ISTYPE(mode, mask):
    return ((mode & __S_IFMT) == mask)

# /usr/include/sys/stat.h: 130
def S_ISDIR(mode):
    return (__S_ISTYPE (mode, __S_IFDIR))

# /usr/include/sys/stat.h: 131
def S_ISCHR(mode):
    return (__S_ISTYPE (mode, __S_IFCHR))

# /usr/include/sys/stat.h: 132
def S_ISBLK(mode):
    return (__S_ISTYPE (mode, __S_IFBLK))

# /usr/include/sys/stat.h: 133
def S_ISREG(mode):
    return (__S_ISTYPE (mode, __S_IFREG))

# /usr/include/sys/stat.h: 135
def S_ISFIFO(mode):
    return (__S_ISTYPE (mode, __S_IFIFO))

# /usr/include/sys/stat.h: 138
def S_ISLNK(mode):
    return (__S_ISTYPE (mode, __S_IFLNK))

# /usr/include/sys/stat.h: 147
def S_ISSOCK(mode):
    return (__S_ISTYPE (mode, __S_IFSOCK))

# /usr/include/sys/stat.h: 157
def S_TYPEISMQ(buf):
    return (__S_TYPEISMQ (buf))

# /usr/include/sys/stat.h: 158
def S_TYPEISSEM(buf):
    return (__S_TYPEISSEM (buf))

# /usr/include/sys/stat.h: 159
def S_TYPEISSHM(buf):
    return (__S_TYPEISSHM (buf))

# /usr/include/sys/stat.h: 165
try:
    S_ISUID = __S_ISUID
except:
    pass

# /usr/include/sys/stat.h: 166
try:
    S_ISGID = __S_ISGID
except:
    pass

# /usr/include/sys/stat.h: 170
try:
    S_ISVTX = __S_ISVTX
except:
    pass

# /usr/include/sys/stat.h: 173
try:
    S_IRUSR = __S_IREAD
except:
    pass

# /usr/include/sys/stat.h: 174
try:
    S_IWUSR = __S_IWRITE
except:
    pass

# /usr/include/sys/stat.h: 175
try:
    S_IXUSR = __S_IEXEC
except:
    pass

# /usr/include/sys/stat.h: 177
try:
    S_IRWXU = ((__S_IREAD | __S_IWRITE) | __S_IEXEC)
except:
    pass

# /usr/include/sys/stat.h: 180
try:
    S_IREAD = S_IRUSR
except:
    pass

# /usr/include/sys/stat.h: 181
try:
    S_IWRITE = S_IWUSR
except:
    pass

# /usr/include/sys/stat.h: 182
try:
    S_IEXEC = S_IXUSR
except:
    pass

# /usr/include/sys/stat.h: 185
try:
    S_IRGRP = (S_IRUSR >> 3)
except:
    pass

# /usr/include/sys/stat.h: 186
try:
    S_IWGRP = (S_IWUSR >> 3)
except:
    pass

# /usr/include/sys/stat.h: 187
try:
    S_IXGRP = (S_IXUSR >> 3)
except:
    pass

# /usr/include/sys/stat.h: 189
try:
    S_IRWXG = (S_IRWXU >> 3)
except:
    pass

# /usr/include/sys/stat.h: 191
try:
    S_IROTH = (S_IRGRP >> 3)
except:
    pass

# /usr/include/sys/stat.h: 192
try:
    S_IWOTH = (S_IWGRP >> 3)
except:
    pass

# /usr/include/sys/stat.h: 193
try:
    S_IXOTH = (S_IXGRP >> 3)
except:
    pass

# /usr/include/sys/stat.h: 195
try:
    S_IRWXO = (S_IRWXG >> 3)
except:
    pass

# /usr/include/sys/stat.h: 200
try:
    ACCESSPERMS = ((S_IRWXU | S_IRWXG) | S_IRWXO)
except:
    pass

# /usr/include/sys/stat.h: 201
try:
    ALLPERMS = (((((S_ISUID | S_ISGID) | S_ISVTX) | S_IRWXU) | S_IRWXG) | S_IRWXO)
except:
    pass

# /usr/include/sys/stat.h: 202
try:
    DEFFILEMODE = (((((S_IRUSR | S_IWUSR) | S_IRGRP) | S_IWGRP) | S_IROTH) | S_IWOTH)
except:
    pass

# /usr/include/sys/stat.h: 204
try:
    S_BLKSIZE = 512
except:
    pass

# /usr/include/sys/stat.h: 395
try:
    _MKNOD_VER = 0
except:
    pass

# /usr/include/errno.h: 27
try:
    _ERRNO_H = 1
except:
    pass

# /usr/include/asm-generic/errno-base.h: 4
try:
    EPERM = 1
except:
    pass

# /usr/include/asm-generic/errno-base.h: 5
try:
    ENOENT = 2
except:
    pass

# /usr/include/asm-generic/errno-base.h: 6
try:
    ESRCH = 3
except:
    pass

# /usr/include/asm-generic/errno-base.h: 7
try:
    EINTR = 4
except:
    pass

# /usr/include/asm-generic/errno-base.h: 8
try:
    EIO = 5
except:
    pass

# /usr/include/asm-generic/errno-base.h: 9
try:
    ENXIO = 6
except:
    pass

# /usr/include/asm-generic/errno-base.h: 10
try:
    E2BIG = 7
except:
    pass

# /usr/include/asm-generic/errno-base.h: 11
try:
    ENOEXEC = 8
except:
    pass

# /usr/include/asm-generic/errno-base.h: 12
try:
    EBADF = 9
except:
    pass

# /usr/include/asm-generic/errno-base.h: 13
try:
    ECHILD = 10
except:
    pass

# /usr/include/asm-generic/errno-base.h: 14
try:
    EAGAIN = 11
except:
    pass

# /usr/include/asm-generic/errno-base.h: 15
try:
    ENOMEM = 12
except:
    pass

# /usr/include/asm-generic/errno-base.h: 16
try:
    EACCES = 13
except:
    pass

# /usr/include/asm-generic/errno-base.h: 17
try:
    EFAULT = 14
except:
    pass

# /usr/include/asm-generic/errno-base.h: 18
try:
    ENOTBLK = 15
except:
    pass

# /usr/include/asm-generic/errno-base.h: 19
try:
    EBUSY = 16
except:
    pass

# /usr/include/asm-generic/errno-base.h: 20
try:
    EEXIST = 17
except:
    pass

# /usr/include/asm-generic/errno-base.h: 21
try:
    EXDEV = 18
except:
    pass

# /usr/include/asm-generic/errno-base.h: 22
try:
    ENODEV = 19
except:
    pass

# /usr/include/asm-generic/errno-base.h: 23
try:
    ENOTDIR = 20
except:
    pass

# /usr/include/asm-generic/errno-base.h: 24
try:
    EISDIR = 21
except:
    pass

# /usr/include/asm-generic/errno-base.h: 25
try:
    EINVAL = 22
except:
    pass

# /usr/include/asm-generic/errno-base.h: 26
try:
    ENFILE = 23
except:
    pass

# /usr/include/asm-generic/errno-base.h: 27
try:
    EMFILE = 24
except:
    pass

# /usr/include/asm-generic/errno-base.h: 28
try:
    ENOTTY = 25
except:
    pass

# /usr/include/asm-generic/errno-base.h: 29
try:
    ETXTBSY = 26
except:
    pass

# /usr/include/asm-generic/errno-base.h: 30
try:
    EFBIG = 27
except:
    pass

# /usr/include/asm-generic/errno-base.h: 31
try:
    ENOSPC = 28
except:
    pass

# /usr/include/asm-generic/errno-base.h: 32
try:
    ESPIPE = 29
except:
    pass

# /usr/include/asm-generic/errno-base.h: 33
try:
    EROFS = 30
except:
    pass

# /usr/include/asm-generic/errno-base.h: 34
try:
    EMLINK = 31
except:
    pass

# /usr/include/asm-generic/errno-base.h: 35
try:
    EPIPE = 32
except:
    pass

# /usr/include/asm-generic/errno-base.h: 36
try:
    EDOM = 33
except:
    pass

# /usr/include/asm-generic/errno-base.h: 37
try:
    ERANGE = 34
except:
    pass

# /usr/include/asm-generic/errno.h: 6
try:
    EDEADLK = 35
except:
    pass

# /usr/include/asm-generic/errno.h: 7
try:
    ENAMETOOLONG = 36
except:
    pass

# /usr/include/asm-generic/errno.h: 8
try:
    ENOLCK = 37
except:
    pass

# /usr/include/asm-generic/errno.h: 9
try:
    ENOSYS = 38
except:
    pass

# /usr/include/asm-generic/errno.h: 10
try:
    ENOTEMPTY = 39
except:
    pass

# /usr/include/asm-generic/errno.h: 11
try:
    ELOOP = 40
except:
    pass

# /usr/include/asm-generic/errno.h: 12
try:
    EWOULDBLOCK = EAGAIN
except:
    pass

# /usr/include/asm-generic/errno.h: 13
try:
    ENOMSG = 42
except:
    pass

# /usr/include/asm-generic/errno.h: 14
try:
    EIDRM = 43
except:
    pass

# /usr/include/asm-generic/errno.h: 15
try:
    ECHRNG = 44
except:
    pass

# /usr/include/asm-generic/errno.h: 16
try:
    EL2NSYNC = 45
except:
    pass

# /usr/include/asm-generic/errno.h: 17
try:
    EL3HLT = 46
except:
    pass

# /usr/include/asm-generic/errno.h: 18
try:
    EL3RST = 47
except:
    pass

# /usr/include/asm-generic/errno.h: 19
try:
    ELNRNG = 48
except:
    pass

# /usr/include/asm-generic/errno.h: 20
try:
    EUNATCH = 49
except:
    pass

# /usr/include/asm-generic/errno.h: 21
try:
    ENOCSI = 50
except:
    pass

# /usr/include/asm-generic/errno.h: 22
try:
    EL2HLT = 51
except:
    pass

# /usr/include/asm-generic/errno.h: 23
try:
    EBADE = 52
except:
    pass

# /usr/include/asm-generic/errno.h: 24
try:
    EBADR = 53
except:
    pass

# /usr/include/asm-generic/errno.h: 25
try:
    EXFULL = 54
except:
    pass

# /usr/include/asm-generic/errno.h: 26
try:
    ENOANO = 55
except:
    pass

# /usr/include/asm-generic/errno.h: 27
try:
    EBADRQC = 56
except:
    pass

# /usr/include/asm-generic/errno.h: 28
try:
    EBADSLT = 57
except:
    pass

# /usr/include/asm-generic/errno.h: 30
try:
    EDEADLOCK = EDEADLK
except:
    pass

# /usr/include/asm-generic/errno.h: 32
try:
    EBFONT = 59
except:
    pass

# /usr/include/asm-generic/errno.h: 33
try:
    ENOSTR = 60
except:
    pass

# /usr/include/asm-generic/errno.h: 34
try:
    ENODATA = 61
except:
    pass

# /usr/include/asm-generic/errno.h: 35
try:
    ETIME = 62
except:
    pass

# /usr/include/asm-generic/errno.h: 36
try:
    ENOSR = 63
except:
    pass

# /usr/include/asm-generic/errno.h: 37
try:
    ENONET = 64
except:
    pass

# /usr/include/asm-generic/errno.h: 38
try:
    ENOPKG = 65
except:
    pass

# /usr/include/asm-generic/errno.h: 39
try:
    EREMOTE = 66
except:
    pass

# /usr/include/asm-generic/errno.h: 40
try:
    ENOLINK = 67
except:
    pass

# /usr/include/asm-generic/errno.h: 41
try:
    EADV = 68
except:
    pass

# /usr/include/asm-generic/errno.h: 42
try:
    ESRMNT = 69
except:
    pass

# /usr/include/asm-generic/errno.h: 43
try:
    ECOMM = 70
except:
    pass

# /usr/include/asm-generic/errno.h: 44
try:
    EPROTO = 71
except:
    pass

# /usr/include/asm-generic/errno.h: 45
try:
    EMULTIHOP = 72
except:
    pass

# /usr/include/asm-generic/errno.h: 46
try:
    EDOTDOT = 73
except:
    pass

# /usr/include/asm-generic/errno.h: 47
try:
    EBADMSG = 74
except:
    pass

# /usr/include/asm-generic/errno.h: 48
try:
    EOVERFLOW = 75
except:
    pass

# /usr/include/asm-generic/errno.h: 49
try:
    ENOTUNIQ = 76
except:
    pass

# /usr/include/asm-generic/errno.h: 50
try:
    EBADFD = 77
except:
    pass

# /usr/include/asm-generic/errno.h: 51
try:
    EREMCHG = 78
except:
    pass

# /usr/include/asm-generic/errno.h: 52
try:
    ELIBACC = 79
except:
    pass

# /usr/include/asm-generic/errno.h: 53
try:
    ELIBBAD = 80
except:
    pass

# /usr/include/asm-generic/errno.h: 54
try:
    ELIBSCN = 81
except:
    pass

# /usr/include/asm-generic/errno.h: 55
try:
    ELIBMAX = 82
except:
    pass

# /usr/include/asm-generic/errno.h: 56
try:
    ELIBEXEC = 83
except:
    pass

# /usr/include/asm-generic/errno.h: 57
try:
    EILSEQ = 84
except:
    pass

# /usr/include/asm-generic/errno.h: 58
try:
    ERESTART = 85
except:
    pass

# /usr/include/asm-generic/errno.h: 59
try:
    ESTRPIPE = 86
except:
    pass

# /usr/include/asm-generic/errno.h: 60
try:
    EUSERS = 87
except:
    pass

# /usr/include/asm-generic/errno.h: 61
try:
    ENOTSOCK = 88
except:
    pass

# /usr/include/asm-generic/errno.h: 62
try:
    EDESTADDRREQ = 89
except:
    pass

# /usr/include/asm-generic/errno.h: 63
try:
    EMSGSIZE = 90
except:
    pass

# /usr/include/asm-generic/errno.h: 64
try:
    EPROTOTYPE = 91
except:
    pass

# /usr/include/asm-generic/errno.h: 65
try:
    ENOPROTOOPT = 92
except:
    pass

# /usr/include/asm-generic/errno.h: 66
try:
    EPROTONOSUPPORT = 93
except:
    pass

# /usr/include/asm-generic/errno.h: 67
try:
    ESOCKTNOSUPPORT = 94
except:
    pass

# /usr/include/asm-generic/errno.h: 68
try:
    EOPNOTSUPP = 95
except:
    pass

# /usr/include/asm-generic/errno.h: 69
try:
    EPFNOSUPPORT = 96
except:
    pass

# /usr/include/asm-generic/errno.h: 70
try:
    EAFNOSUPPORT = 97
except:
    pass

# /usr/include/asm-generic/errno.h: 71
try:
    EADDRINUSE = 98
except:
    pass

# /usr/include/asm-generic/errno.h: 72
try:
    EADDRNOTAVAIL = 99
except:
    pass

# /usr/include/asm-generic/errno.h: 73
try:
    ENETDOWN = 100
except:
    pass

# /usr/include/asm-generic/errno.h: 74
try:
    ENETUNREACH = 101
except:
    pass

# /usr/include/asm-generic/errno.h: 75
try:
    ENETRESET = 102
except:
    pass

# /usr/include/asm-generic/errno.h: 76
try:
    ECONNABORTED = 103
except:
    pass

# /usr/include/asm-generic/errno.h: 77
try:
    ECONNRESET = 104
except:
    pass

# /usr/include/asm-generic/errno.h: 78
try:
    ENOBUFS = 105
except:
    pass

# /usr/include/asm-generic/errno.h: 79
try:
    EISCONN = 106
except:
    pass

# /usr/include/asm-generic/errno.h: 80
try:
    ENOTCONN = 107
except:
    pass

# /usr/include/asm-generic/errno.h: 81
try:
    ESHUTDOWN = 108
except:
    pass

# /usr/include/asm-generic/errno.h: 82
try:
    ETOOMANYREFS = 109
except:
    pass

# /usr/include/asm-generic/errno.h: 83
try:
    ETIMEDOUT = 110
except:
    pass

# /usr/include/asm-generic/errno.h: 84
try:
    ECONNREFUSED = 111
except:
    pass

# /usr/include/asm-generic/errno.h: 85
try:
    EHOSTDOWN = 112
except:
    pass

# /usr/include/asm-generic/errno.h: 86
try:
    EHOSTUNREACH = 113
except:
    pass

# /usr/include/asm-generic/errno.h: 87
try:
    EALREADY = 114
except:
    pass

# /usr/include/asm-generic/errno.h: 88
try:
    EINPROGRESS = 115
except:
    pass

# /usr/include/asm-generic/errno.h: 89
try:
    ESTALE = 116
except:
    pass

# /usr/include/asm-generic/errno.h: 90
try:
    EUCLEAN = 117
except:
    pass

# /usr/include/asm-generic/errno.h: 91
try:
    ENOTNAM = 118
except:
    pass

# /usr/include/asm-generic/errno.h: 92
try:
    ENAVAIL = 119
except:
    pass

# /usr/include/asm-generic/errno.h: 93
try:
    EISNAM = 120
except:
    pass

# /usr/include/asm-generic/errno.h: 94
try:
    EREMOTEIO = 121
except:
    pass

# /usr/include/asm-generic/errno.h: 95
try:
    EDQUOT = 122
except:
    pass

# /usr/include/asm-generic/errno.h: 97
try:
    ENOMEDIUM = 123
except:
    pass

# /usr/include/asm-generic/errno.h: 98
try:
    EMEDIUMTYPE = 124
except:
    pass

# /usr/include/asm-generic/errno.h: 99
try:
    ECANCELED = 125
except:
    pass

# /usr/include/asm-generic/errno.h: 100
try:
    ENOKEY = 126
except:
    pass

# /usr/include/asm-generic/errno.h: 101
try:
    EKEYEXPIRED = 127
except:
    pass

# /usr/include/asm-generic/errno.h: 102
try:
    EKEYREVOKED = 128
except:
    pass

# /usr/include/asm-generic/errno.h: 103
try:
    EKEYREJECTED = 129
except:
    pass

# /usr/include/asm-generic/errno.h: 106
try:
    EOWNERDEAD = 130
except:
    pass

# /usr/include/asm-generic/errno.h: 107
try:
    ENOTRECOVERABLE = 131
except:
    pass

# /usr/include/asm-generic/errno.h: 109
try:
    ERFKILL = 132
except:
    pass

# /usr/include/asm-generic/errno.h: 111
try:
    EHWPOISON = 133
except:
    pass

# /usr/include/bits/errno.h: 27
try:
    ENOTSUP = EOPNOTSUPP
except:
    pass

# /usr/include/bits/errno.h: 54
try:
    errno = ((__errno_location ())[0])
except:
    pass

timespec = struct_timespec# /usr/include/time.h: 120

timeval = struct_timeval# /usr/include/bits/time.h: 30

pthread_attr_t = union_pthread_attr_t# /usr/include/bits/pthreadtypes.h: 63

__pthread_internal_list = struct___pthread_internal_list# /usr/include/bits/pthreadtypes.h: 75

__pthread_mutex_s = struct___pthread_mutex_s# /usr/include/bits/pthreadtypes.h: 92

sched_param = struct_sched_param# /usr/include/bits/sched.h: 73

__sched_param = struct___sched_param# /usr/include/bits/sched.h: 104

tm = struct_tm# /usr/include/time.h: 133

itimerspec = struct_itimerspec# /usr/include/time.h: 161

sigevent = struct_sigevent# /usr/include/bits/siginfo.h: 301

__locale_data = struct___locale_data# /usr/include/xlocale.h: 30

__locale_struct = struct___locale_struct# /usr/include/xlocale.h: 27

_pthread_cleanup_buffer = struct__pthread_cleanup_buffer# /usr/include/pthread.h: 192

__pthread_cleanup_frame = struct___pthread_cleanup_frame# /usr/include/pthread.h: 534

__jmp_buf_tag = struct___jmp_buf_tag# /usr/include/pthread.h: 736

CbfHEntry = struct_CbfHEntry# /virgoApp/Cfg/v9r0/src/CbfHash.h: 43

CbfH = struct_CbfH# /virgoApp/Cfg/v9r0/src/CbfHash.h: 53

CbfClean = struct_CbfClean# /virgoApp/Cfg/v9r0/src/CbfClean.h: 51

CbfCleanChain = struct_CbfCleanChain# /virgoApp/Cfg/v9r0/src/CbfClean.h: 42

CfgName = struct_CfgName# /virgoApp/Cfg/v9r0/src/CfgList.h: 70

CfgNameList = struct_CfgNameList# /virgoApp/Cfg/v9r0/src/CfgList.h: 77

CfgMsg = struct_CfgMsg# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 54

CfgMsgR = struct_CfgMsgR# /virgoApp/Cfg/v9r0/src/CfgMsg.h: 68

_CmMessageRec = struct__CmMessageRec# /virgoApp/Cm/v9r0/src/CmMessage.h: 38

_CmMessageIteratorRec = struct__CmMessageIteratorRec# /virgoApp/Cm/v9r0/src/CmMessage.h: 39

_GCReferenceRec = struct__GCReferenceRec# /virgoApp/Cm/v9r0/src/GC.h: 36

_GCClassRec = struct__GCClassRec# /virgoApp/Cm/v9r0/src/GC.h: 37

_GCObjectRec = struct__GCObjectRec# /virgoApp/Cm/v9r0/src/GC.h: 38

_CArrayRec = struct__CArrayRec# /virgoApp/Cm/v9r0/src/CSet.h: 38

_CStackRec = struct__CStackRec# /virgoApp/Cm/v9r0/src/CSet.h: 39

_CQueueRec = struct__CQueueRec# /virgoApp/Cm/v9r0/src/CSet.h: 40

_CLListRec = struct__CLListRec# /virgoApp/Cm/v9r0/src/CSet.h: 41

_CHasherRec = struct__CHasherRec# /virgoApp/Cm/v9r0/src/CSet.h: 42

_CIteratorRec = struct__CIteratorRec# /virgoApp/Cm/v9r0/src/CSet.h: 43

_CmConnectRec = struct__CmConnectRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 40

_CmConnectIteratorRec = struct__CmConnectIteratorRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 41

_CmNameServerInfosRec = struct__CmNameServerInfosRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 73

_CmConnectStatisticsRec = struct__CmConnectStatisticsRec# /virgoApp/Cm/v9r0/src/CmConnect.h: 84

_CvtRec = struct__CvtRec# /virgoApp/Cm/v9r0/src/Cvt.h: 38

_CmTransactionRec = struct__CmTransactionRec# /virgoApp/Cm/v9r0/src/CmTransaction.h: 4

CfgDouble = union_CfgDouble# /virgoApp/Cfg/v9r0/src/CfgParse.h: 69

CfgParse = struct_CfgParse# /virgoApp/Cfg/v9r0/src/CfgParse.h: 71

CfgDataType = struct_CfgDataType# /virgoApp/Cfg/v9r0/src/CfgParse.h: 72

_IO_FILE = struct__IO_FILE# /usr/include/libio.h: 246

_IO_jump_t = struct__IO_jump_t# /usr/include/libio.h: 145

_IO_marker = struct__IO_marker# /usr/include/libio.h: 161

_IO_FILE_plus = struct__IO_FILE_plus# /usr/include/libio.h: 319

CfgData = struct_CfgData# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 82

CfgPrinter = struct_CfgPrinter# /virgoApp/Cfg/v9r0/src/CfgCommon.h: 164

CfgRequest = struct_CfgRequest# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 42

CfgQueue = struct_CfgQueue# /virgoApp/Cfg/v9r0/src/CfgQueue.h: 57

wait = union_wait# /usr/include/bits/waitstatus.h: 66

random_data = struct_random_data# /usr/include/stdlib.h: 343

drand48_data = struct_drand48_data# /usr/include/stdlib.h: 412

FrIO = struct_FrIO# /virgoApp/Fr/v8r40p5/src/FrIO.h: 30

FrameH = struct_FrameH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 151

FrAdcData = struct_FrAdcData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 287

FrBasic = struct_FrBasic# /virgoApp/Fr/v8r40p5/src/FrameL.h: 390

FrDetector = struct_FrDetector# /virgoApp/Fr/v8r40p5/src/FrameL.h: 352

FrEndOfFrame = struct_FrEndOfFrame# /virgoApp/Fr/v8r40p5/src/FrameL.h: 400

FrEndOfFile = struct_FrEndOfFile# /virgoApp/Fr/v8r40p5/src/FrameL.h: 412

FrEvent = struct_FrEvent# /virgoApp/Fr/v8r40p5/src/FrameL.h: 426

FrMsg = struct_FrMsg# /virgoApp/Fr/v8r40p5/src/FrameL.h: 714

FrFile = struct_FrFile# /virgoApp/Fr/v8r40p5/src/FrameL.h: 505

FrFileH = struct_FrFileH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 675

FrHistory = struct_FrHistory# /virgoApp/Fr/v8r40p5/src/FrameL.h: 690

FrObject = struct_FrObject# /virgoApp/Fr/v8r40p5/src/FrameL.h: 739

FrRawData = struct_FrRawData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 795

FrProcData = struct_FrProcData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 746

FrSE = struct_FrSE# /virgoApp/Fr/v8r40p5/src/FrameL.h: 819

FrSH = struct_FrSH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 885

FrSimData = struct_FrSimData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 905

FrSegList = struct_FrSegList# /virgoApp/Fr/v8r40p5/src/FrameL.h: 832

FrSerData = struct_FrSerData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 857

FrStatData = struct_FrStatData# /virgoApp/Fr/v8r40p5/src/FrameL.h: 988

FrSummary = struct_FrSummary# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1031

FrSimEvent = struct_FrSimEvent# /virgoApp/Fr/v8r40p5/src/FrameL.h: 934

FrTable = struct_FrTable# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1055

FrTag = struct_FrTag# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1077

FrTOC = struct_FrTOC# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1091

FrTOCdet = struct_FrTOCdet# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1152

FrTOCevt = struct_FrTOCevt# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1163

FrTOCstat = struct_FrTOCstat# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1185

FrTOCts = struct_FrTOCts# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1198

FrTOCtsH = struct_FrTOCtsH# /virgoApp/Fr/v8r40p5/src/FrameL.h: 1213

FrVect = struct_FrVect# /virgoApp/Fr/v8r40p5/src/FrVect.h: 41

FrCList = struct_FrCList# /virgoApp/Fr/v8r40p5/src/FrameL.h: 336

FrFilter = struct_FrFilter# /virgoApp/Fr/v8r40p5/src/FrFilter.h: 20

FrvBuf = struct_FrvBuf# /virgoApp/Frv/v4r35p2/src/FrvBuf.h: 17

FrvBandRms = struct_FrvBandRms# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 21

FrvRFFT = struct_FrvRFFT# /virgoApp/Frv/v4r35p2/src/FrvFFT.h: 36

FrvFilter2 = struct_FrvFilter2# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 20

FrvFilterB = struct_FrvFilterB# /virgoApp/Frv/v4r35p2/src/FrvFilter.h: 68

FrvStat = struct_FrvStat# /virgoApp/Frv/v4r35p2/src/FrvMath.h: 21

FrvCoGap = struct_FrvCoGap# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 21

FrvTF = struct_FrvTF# /virgoApp/Frv/v4r35p2/src/FrvTF.h: 42

FrvCorr = struct_FrvCorr# /virgoApp/Frv/v4r35p2/src/FrvCorr.h: 19

FrvLinFilt = struct_FrvLinFilt# /virgoApp/Frv/v4r35p2/src/FrvLinFilt.h: 19

FrvSmartD = struct_FrvSmartD# /virgoApp/Frv/v4r35p2/src/FrvSmartDecimate.h: 32

FrvFDFilter = struct_FrvFDFilter# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 22

FrvFDFilterOut = struct_FrvFDFilterOut# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 47

FrvFDFHole = struct_FrvFDFHole# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 61

FrvFDFTFBin = struct_FrvFDFTFBin# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 69

FrvFDFilter2 = struct_FrvFDFilter2# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 83

FrvFDFPhaseBump = struct_FrvFDFPhaseBump# /virgoApp/Frv/v4r35p2/src/FrvFDFilter.h: 76

FrvCh = struct_FrvCh# /virgoApp/Frv/v4r35p2/src/FrvCh.h: 16

FdCList = struct_FdCList# /users/poulton/packages/Fd/v9r0/src/FdChList.h: 7

FdFrMrgr = struct_FdFrMrgr# /users/poulton/packages/Fd/v9r0/src/FdFrMrgr.h: 18

FdIO = struct_FdIO# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 82

exception = struct_exception# /usr/include/math.h: 313

sigval = union_sigval# /usr/include/bits/siginfo.h: 36

sigaction = struct_sigaction# /usr/include/bits/sigaction.h: 24

sigvec = struct_sigvec# /usr/include/signal.h: 315

_fpx_sw_bytes = struct__fpx_sw_bytes# /usr/include/bits/sigcontext.h: 29

_fpreg = struct__fpreg# /usr/include/bits/sigcontext.h: 38

_fpxreg = struct__fpxreg# /usr/include/bits/sigcontext.h: 44

_xmmreg = struct__xmmreg# /usr/include/bits/sigcontext.h: 51

_fpstate = struct__fpstate# /usr/include/bits/sigcontext.h: 121

sigcontext = struct_sigcontext# /usr/include/bits/sigcontext.h: 137

_xsave_hdr = struct__xsave_hdr# /usr/include/bits/sigcontext.h: 175

_ymmh_state = struct__ymmh_state# /usr/include/bits/sigcontext.h: 182

_xstate = struct__xstate# /usr/include/bits/sigcontext.h: 187

sigstack = struct_sigstack# /usr/include/bits/sigstack.h: 25

sigaltstack = struct_sigaltstack# /usr/include/bits/sigstack.h: 54

_libc_fpxreg = struct__libc_fpxreg# /usr/include/sys/ucontext.h: 92

_libc_xmmreg = struct__libc_xmmreg# /usr/include/sys/ucontext.h: 99

_libc_fpstate = struct__libc_fpstate# /usr/include/sys/ucontext.h: 104

ucontext = struct_ucontext# /usr/include/sys/ucontext.h: 133

flock = struct_flock# /usr/include/bits/fcntl.h: 35

stat = struct_stat# /usr/include/bits/stat.h: 46

dirent = struct_dirent# /usr/include/bits/dirent.h: 22

__dirstream = struct___dirstream# /usr/include/dirent.h: 128

timezone = struct_timezone# /usr/include/sys/time.h: 56

itimerval = struct_itimerval# /usr/include/sys/time.h: 108

timeb = struct_timeb# /usr/include/sys/timeb.h: 31

FrRandomG = struct_FrRandomG# /users/poulton/packages/Fd/v9r0/src/FdTools.h: 13

FdAction = struct_FdAction# /users/poulton/packages/Fd/v9r0/src/FdIO.h: 53

FdIDir = struct_FdIDir# /users/poulton/packages/Fd/v9r0/src/FdIDir.h: 14

# No inserted files

# No prefix-stripping

